#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3577
#define LARGE_STATE_COUNT 494
#define SYMBOL_COUNT 524
#define ALIAS_COUNT 1
#define TOKEN_COUNT 163
#define EXTERNAL_TOKEN_COUNT 7
#define FIELD_COUNT 20
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 98

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_POUND = 2,
  sym_decimal_integer_literal = 3,
  sym_hex_integer_literal = 4,
  sym_decimal_floating_point_literal = 5,
  anon_sym_true = 6,
  anon_sym_false = 7,
  anon_sym_DQUOTE = 8,
  anon_sym_SQUOTE = 9,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 10,
  anon_sym_SQUOTE_SQUOTE_SQUOTE = 11,
  anon_sym_r_DQUOTE = 12,
  anon_sym_DOLLAR = 13,
  anon_sym_r_SQUOTE = 14,
  anon_sym_r_DQUOTE_DQUOTE_DQUOTE = 15,
  anon_sym_r_SQUOTE_SQUOTE_SQUOTE = 16,
  anon_sym_LBRACE = 17,
  anon_sym_RBRACE = 18,
  aux_sym__sub_string_test_token1 = 19,
  sym__unused_escape_sequence = 20,
  anon_sym_LBRACK = 21,
  anon_sym_COMMA = 22,
  anon_sym_RBRACK = 23,
  anon_sym_COLON = 24,
  anon_sym_null = 25,
  anon_sym_LPAREN = 26,
  anon_sym_RPAREN = 27,
  anon_sym_throw = 28,
  anon_sym_EQ = 29,
  anon_sym_PLUS_EQ = 30,
  anon_sym_DASH_EQ = 31,
  anon_sym_STAR_EQ = 32,
  anon_sym_SLASH_EQ = 33,
  anon_sym_PERCENT_EQ = 34,
  anon_sym_TILDE_SLASH_EQ = 35,
  anon_sym_LT_LT_EQ = 36,
  anon_sym_GT_GT_EQ = 37,
  anon_sym_GT_GT_GT_EQ = 38,
  anon_sym_AMP_EQ = 39,
  anon_sym_CARET_EQ = 40,
  anon_sym_PIPE_EQ = 41,
  anon_sym_QMARK_QMARK_EQ = 42,
  anon_sym_QMARK_QMARK = 43,
  anon_sym_QMARK = 44,
  sym_equality_operator = 45,
  anon_sym_LT = 46,
  anon_sym_GT = 47,
  anon_sym_LT_EQ = 48,
  anon_sym_GT_EQ = 49,
  anon_sym_PIPE = 50,
  anon_sym_CARET = 51,
  anon_sym_AMP = 52,
  anon_sym_LT_LT = 53,
  anon_sym_GT_GT = 54,
  anon_sym_GT_GT_GT = 55,
  sym__additive_operator = 56,
  anon_sym_STAR = 57,
  anon_sym_SLASH = 58,
  anon_sym_PERCENT = 59,
  anon_sym_TILDE_SLASH = 60,
  sym_increment_operator = 61,
  anon_sym_DOT_DOT_DOT = 62,
  sym_minus_operator = 63,
  anon_sym_BANG = 64,
  anon_sym_TILDE = 65,
  anon_sym_await = 66,
  anon_sym_is = 67,
  anon_sym_as = 68,
  anon_sym_DOT = 69,
  anon_sym_QMARK_DOT = 70,
  anon_sym_DOT_DOT = 71,
  anon_sym_QMARK_DOT_DOT = 72,
  anon_sym_extends = 73,
  anon_sym_SEMI = 74,
  anon_sym_switch = 75,
  anon_sym_EQ_GT = 76,
  anon_sym_when = 77,
  anon_sym_default = 78,
  anon_sym_do = 79,
  anon_sym_while = 80,
  anon_sym_continue = 81,
  anon_sym_yield = 82,
  anon_sym_return = 83,
  anon_sym_on = 84,
  anon_sym_try = 85,
  anon_sym_catch = 86,
  anon_sym_finally = 87,
  anon_sym_if = 88,
  anon_sym_case = 89,
  anon_sym_else = 90,
  anon_sym_for = 91,
  anon_sym_in = 92,
  anon_sym_AT = 93,
  anon_sym_part = 94,
  anon_sym_EQ_EQ = 95,
  anon_sym_show = 96,
  anon_sym_hide = 97,
  anon_sym_enum = 98,
  anon_sym_final = 99,
  anon_sym_inline = 100,
  anon_sym_class = 101,
  anon_sym_extension = 102,
  anon_sym_with = 103,
  anon_sym_LBRACK_RBRACK = 104,
  anon_sym_LBRACK_RBRACK_EQ = 105,
  sym_floating_point_type = 106,
  anon_sym_bool = 107,
  sym_void_type = 108,
  anon_sym_var = 109,
  anon_sym_async = 110,
  anon_sym_async_STAR = 111,
  anon_sym_sync_STAR = 112,
  anon_sym_POUND_BANG = 113,
  aux_sym_script_tag_token1 = 114,
  anon_sym_LF = 115,
  anon_sym_library = 116,
  sym_break_builtin = 117,
  sym_assert_builtin = 118,
  sym_rethrow_builtin = 119,
  sym_part_of_builtin = 120,
  anon_sym_covariant = 121,
  anon_sym_deferred = 122,
  anon_sym_dynamic = 123,
  anon_sym_export = 124,
  anon_sym_factory = 125,
  anon_sym_Function = 126,
  anon_sym_get = 127,
  anon_sym_native = 128,
  anon_sym_implements = 129,
  anon_sym_import = 130,
  anon_sym_interface = 131,
  anon_sym_base = 132,
  anon_sym_abstract = 133,
  anon_sym_sealed = 134,
  anon_sym_operator = 135,
  anon_sym_mixin = 136,
  anon_sym_required = 137,
  anon_sym_set = 138,
  anon_sym_static = 139,
  anon_sym_typedef = 140,
  anon_sym_new = 141,
  anon_sym_AMP_AMP = 142,
  anon_sym_PIPE_PIPE = 143,
  sym_const_builtin = 144,
  anon_sym_late = 145,
  anon_sym_external = 146,
  anon_sym_this = 147,
  anon_sym_super = 148,
  sym_identifier_dollar_escaped = 149,
  anon_sym_SLASH_SLASH = 150,
  aux_sym_comment_token1 = 151,
  anon_sym_SLASH_STAR = 152,
  aux_sym_comment_token2 = 153,
  anon_sym_SLASH_SLASH_SLASH = 154,
  aux_sym_documentation_comment_token1 = 155,
  sym__template_chars_double = 156,
  sym__template_chars_single = 157,
  sym__template_chars_double_single = 158,
  sym__template_chars_single_single = 159,
  sym__template_chars_raw_slash = 160,
  sym__block_comment = 161,
  sym__documentation_block_comment = 162,
  sym_program = 163,
  sym__top_level_definition = 164,
  sym__bool_literal = 165,
  sym__numeric_literal = 166,
  sym__literal = 167,
  sym_symbol_literal = 168,
  sym_true = 169,
  sym_false = 170,
  sym_string_literal = 171,
  sym__string_literal_double_quotes = 172,
  sym__string_literal_single_quotes = 173,
  sym__string_literal_double_quotes_multiple = 174,
  sym__string_literal_single_quotes_multiple = 175,
  sym__raw_string_literal_double_quotes = 176,
  sym__raw_string_literal_single_quotes = 177,
  sym__raw_string_literal_double_quotes_multiple = 178,
  sym__raw_string_literal_single_quotes_multiple = 179,
  sym_template_substitution = 180,
  sym__sub_string_test = 181,
  sym_escape_sequence = 182,
  sym_list_literal = 183,
  sym_set_or_map_literal = 184,
  sym_pair = 185,
  sym__element = 186,
  sym_null_literal = 187,
  sym_record_literal = 188,
  sym__record_literal_no_const = 189,
  sym_record_field = 190,
  sym__expression = 191,
  sym__expression_without_cascade = 192,
  sym__real_expression = 193,
  sym_throw_expression = 194,
  sym_throw_expression_without_cascade = 195,
  sym_rethrow_expression = 196,
  sym_assignment_expression = 197,
  sym_assignment_expression_without_cascade = 198,
  sym_assignable_expression = 199,
  sym__assignable_selector_part = 200,
  sym__assignment_operator = 201,
  sym_lambda_expression = 202,
  sym_function_expression = 203,
  sym_if_null_expression = 204,
  aux_sym__if_null_expression = 205,
  sym_conditional_expression = 206,
  sym_logical_or_expression = 207,
  sym_logical_and_expression = 208,
  sym_equality_expression = 209,
  sym_type_cast_expression = 210,
  sym_type_test_expression = 211,
  sym_relational_expression = 212,
  sym_relational_operator = 213,
  sym_bitwise_or_expression = 214,
  sym_bitwise_xor_expression = 215,
  sym_bitwise_and_expression = 216,
  sym_shift_expression = 217,
  sym_additive_expression = 218,
  sym_multiplicative_expression = 219,
  sym_bitwise_operator = 220,
  sym__bitwise_operator = 221,
  sym_shift_operator = 222,
  sym__shift_operator = 223,
  sym_additive_operator = 224,
  sym_multiplicative_operator = 225,
  sym__multiplicative_operator = 226,
  sym__unary_expression = 227,
  sym_unary_expression = 228,
  sym__postfix_expression = 229,
  sym_postfix_expression = 230,
  sym_postfix_operator = 231,
  sym_spread_element = 232,
  sym_selector = 233,
  sym_prefix_operator = 234,
  sym_negation_operator = 235,
  sym__exclamation_operator = 236,
  sym_tilde_operator = 237,
  sym_await_expression = 238,
  sym_type_test = 239,
  sym_is_operator = 240,
  sym_type_cast = 241,
  sym_as_operator = 242,
  sym_new_expression = 243,
  sym__dot_identifier = 244,
  sym_const_object_expression = 245,
  sym__primary = 246,
  sym_parenthesized_expression = 247,
  sym_constructor_invocation = 248,
  sym_constructor_tearoff = 249,
  sym_arguments = 250,
  sym__argument_list = 251,
  sym__any_argument = 252,
  sym_argument = 253,
  sym_named_argument = 254,
  sym_cascade_section = 255,
  sym__cascade_subsection = 256,
  sym__cascade_assignment_section = 257,
  sym_index_selector = 258,
  sym_cascade_selector = 259,
  sym_argument_part = 260,
  sym_unconditional_assignable_selector = 261,
  sym_conditional_assignable_selector = 262,
  sym__assignable_selector = 263,
  sym_type_arguments = 264,
  sym__statement = 265,
  sym_local_function_declaration = 266,
  sym_block = 267,
  sym_expression_statement = 268,
  sym_assert_statement = 269,
  sym_assertion = 270,
  sym_assertion_arguments = 271,
  sym_switch_statement = 272,
  sym_switch_expression = 273,
  sym_switch_expression_case = 274,
  sym__guarded_pattern = 275,
  sym__pattern = 276,
  sym__logical_or_pattern = 277,
  sym__logical_and_pattern = 278,
  sym__relational_pattern = 279,
  sym__unary_pattern = 280,
  sym__primary_pattern = 281,
  sym_cast_pattern = 282,
  sym_null_check_pattern = 283,
  sym_null_assert_pattern = 284,
  sym_constant_pattern = 285,
  sym_variable_pattern = 286,
  sym__parenthesized_pattern = 287,
  sym_list_pattern = 288,
  sym__list_pattern_element = 289,
  sym_rest_pattern = 290,
  sym_map_pattern = 291,
  sym__map_pattern_entry = 292,
  sym_record_pattern = 293,
  sym__pattern_field = 294,
  sym_object_pattern = 295,
  sym_pattern_variable_declaration = 296,
  sym__outer_pattern = 297,
  sym_pattern_assignment = 298,
  sym_switch_block = 299,
  sym_switch_statement_case = 300,
  sym_switch_statement_default = 301,
  sym_do_statement = 302,
  sym_break_statement = 303,
  sym_continue_statement = 304,
  sym_yield_statement = 305,
  sym_yield_each_statement = 306,
  sym_return_statement = 307,
  sym_try_statement = 308,
  sym__on_part = 309,
  sym__try_head = 310,
  sym_catch_clause = 311,
  sym_catch_parameters = 312,
  sym_finally_clause = 313,
  sym_if_element = 314,
  sym_if_statement = 315,
  sym_while_statement = 316,
  sym_for_statement = 317,
  sym_for_loop_parts = 318,
  sym__for_loop_parts = 319,
  sym_for_element = 320,
  sym_annotation = 321,
  sym_import_or_export = 322,
  sym_library_import = 323,
  sym_library_export = 324,
  sym_import_specification = 325,
  sym_part_directive = 326,
  sym_part_of_directive = 327,
  sym_uri = 328,
  sym_configurable_uri = 329,
  sym_configuration_uri = 330,
  sym_configuration_uri_condition = 331,
  sym_uri_test = 332,
  sym_combinator = 333,
  sym__identifier_list = 334,
  sym_enum_declaration = 335,
  sym_enum_body = 336,
  sym_enum_constant = 337,
  sym_type_alias = 338,
  sym__class_modifiers = 339,
  sym__mixin_class_modifiers = 340,
  sym_class_definition = 341,
  sym_extension_declaration = 342,
  sym__metadata = 343,
  sym_type_parameters = 344,
  sym_type_parameter = 345,
  sym_type_bound = 346,
  sym_superclass = 347,
  sym_mixins = 348,
  sym_mixin_application_class = 349,
  sym_mixin_application = 350,
  sym_mixin_declaration = 351,
  sym_interfaces = 352,
  sym_class_body = 353,
  sym_extension_body = 354,
  sym_getter_signature = 355,
  sym_setter_signature = 356,
  sym_method_signature = 357,
  sym_declaration = 358,
  sym_identifier_list = 359,
  sym_initialized_identifier_list = 360,
  sym_initialized_identifier = 361,
  sym_static_final_declaration_list = 362,
  sym_binary_operator = 363,
  sym_operator_signature = 364,
  sym_static_final_declaration = 365,
  sym__external_and_static = 366,
  sym__final_or_const = 367,
  sym_initializers = 368,
  sym_initializer_list_entry = 369,
  sym_field_initializer = 370,
  sym_factory_constructor_signature = 371,
  sym_redirecting_factory_constructor_signature = 372,
  sym_redirection = 373,
  sym_constructor_signature = 374,
  sym_constant_constructor_signature = 375,
  sym_scoped_identifier = 376,
  sym_initialized_variable_definition = 377,
  sym__declared_identifier = 378,
  sym__final_const_var_or_type = 379,
  sym__type = 380,
  sym__type_not_function = 381,
  sym__type_not_void_not_function = 382,
  sym_function_type = 383,
  aux_sym__function_type_tails = 384,
  sym__function_type_tail = 385,
  sym_parameter_type_list = 386,
  sym_normal_parameter_type = 387,
  sym_optional_parameter_types = 388,
  sym_optional_positional_parameter_types = 389,
  sym_named_parameter_types = 390,
  sym__named_parameter_type = 391,
  sym__type_not_void = 392,
  sym_record_type = 393,
  sym_record_type_field = 394,
  sym_record_type_named_field = 395,
  sym__type_not_void_list = 396,
  sym__type_name = 397,
  sym__type_dot_identifier = 398,
  sym_typed_identifier = 399,
  sym_nullable_type = 400,
  sym_nullable_selector = 401,
  sym__var_or_type = 402,
  sym__final_var_or_type = 403,
  sym_inferred_type = 404,
  sym_function_body = 405,
  sym_function_expression_body = 406,
  sym_function_signature = 407,
  sym__formal_parameter_part = 408,
  sym_formal_parameter_list = 409,
  sym__strict_formal_parameter_list = 410,
  sym__normal_formal_parameters = 411,
  sym_optional_formal_parameters = 412,
  sym__optional_postional_formal_parameters = 413,
  sym__named_formal_parameters = 414,
  sym_formal_parameter = 415,
  sym__default_formal_parameter = 416,
  sym__default_named_parameter = 417,
  sym__normal_formal_parameter = 418,
  sym__function_formal_parameter = 419,
  sym__simple_formal_parameter = 420,
  sym_super_formal_parameter = 421,
  sym_constructor_param = 422,
  sym_local_variable_declaration = 423,
  sym_script_tag = 424,
  sym_library_name = 425,
  sym_dotted_identifier_list = 426,
  sym__identifier_or_new = 427,
  sym_qualified = 428,
  sym__as = 429,
  sym_case_builtin = 430,
  sym__covariant = 431,
  sym__deferred = 432,
  sym__export = 433,
  sym__external = 434,
  sym__factory = 435,
  sym__function_builtin_identifier = 436,
  sym__get = 437,
  sym__native = 438,
  sym__implements = 439,
  sym__import = 440,
  sym_interface = 441,
  sym_base = 442,
  sym_abstract = 443,
  sym_sealed = 444,
  sym__operator = 445,
  sym_mixin = 446,
  sym__required = 447,
  sym__set = 448,
  sym__static = 449,
  sym__typedef = 450,
  sym__new_builtin = 451,
  sym_logical_and_operator = 452,
  sym_logical_or_operator = 453,
  sym_final_builtin = 454,
  sym__late_builtin = 455,
  sym__external_builtin = 456,
  sym_this = 457,
  sym_super = 458,
  sym_label = 459,
  sym__semicolon = 460,
  sym_comment = 461,
  sym_documentation_comment = 462,
  aux_sym_program_repeat1 = 463,
  aux_sym_program_repeat2 = 464,
  aux_sym_program_repeat3 = 465,
  aux_sym_program_repeat4 = 466,
  aux_sym_string_literal_repeat1 = 467,
  aux_sym__string_literal_double_quotes_repeat1 = 468,
  aux_sym__string_literal_single_quotes_repeat1 = 469,
  aux_sym__string_literal_double_quotes_multiple_repeat1 = 470,
  aux_sym__string_literal_single_quotes_multiple_repeat1 = 471,
  aux_sym__raw_string_literal_double_quotes_repeat1 = 472,
  aux_sym__raw_string_literal_single_quotes_repeat1 = 473,
  aux_sym__raw_string_literal_double_quotes_multiple_repeat1 = 474,
  aux_sym__raw_string_literal_single_quotes_multiple_repeat1 = 475,
  aux_sym_list_literal_repeat1 = 476,
  aux_sym__record_literal_no_const_repeat1 = 477,
  aux_sym__expression_repeat1 = 478,
  aux_sym__assignable_selector_part_repeat1 = 479,
  aux_sym_inferred_parameters_repeat1 = 480,
  aux_sym_logical_or_expression_repeat1 = 481,
  aux_sym_logical_and_expression_repeat1 = 482,
  aux_sym_bitwise_or_expression_repeat1 = 483,
  aux_sym_bitwise_xor_expression_repeat1 = 484,
  aux_sym_bitwise_and_expression_repeat1 = 485,
  aux_sym_shift_expression_repeat1 = 486,
  aux_sym_additive_expression_repeat1 = 487,
  aux_sym_multiplicative_expression_repeat1 = 488,
  aux_sym__argument_list_repeat1 = 489,
  aux_sym_cascade_section_repeat1 = 490,
  aux_sym_cascade_section_repeat2 = 491,
  aux_sym_type_arguments_repeat1 = 492,
  aux_sym_block_repeat1 = 493,
  aux_sym_switch_expression_repeat1 = 494,
  aux_sym__logical_or_pattern_repeat1 = 495,
  aux_sym__logical_and_pattern_repeat1 = 496,
  aux_sym_list_pattern_repeat1 = 497,
  aux_sym_map_pattern_repeat1 = 498,
  aux_sym_record_pattern_repeat1 = 499,
  aux_sym_switch_block_repeat1 = 500,
  aux_sym_switch_statement_case_repeat1 = 501,
  aux_sym_try_statement_repeat1 = 502,
  aux_sym__for_loop_parts_repeat1 = 503,
  aux_sym__for_loop_parts_repeat2 = 504,
  aux_sym_library_export_repeat1 = 505,
  aux_sym_configurable_uri_repeat1 = 506,
  aux_sym_enum_body_repeat1 = 507,
  aux_sym_enum_body_repeat2 = 508,
  aux_sym__metadata_repeat1 = 509,
  aux_sym_type_parameters_repeat1 = 510,
  aux_sym_extension_body_repeat1 = 511,
  aux_sym_initialized_identifier_list_repeat1 = 512,
  aux_sym_static_final_declaration_list_repeat1 = 513,
  aux_sym_initializers_repeat1 = 514,
  aux_sym_factory_constructor_signature_repeat1 = 515,
  aux_sym_parameter_type_list_repeat1 = 516,
  aux_sym_named_parameter_types_repeat1 = 517,
  aux_sym_record_type_repeat1 = 518,
  aux_sym_record_type_repeat2 = 519,
  aux_sym__type_not_void_list_repeat1 = 520,
  aux_sym__normal_formal_parameters_repeat1 = 521,
  aux_sym_positional_parameters_repeat1 = 522,
  aux_sym__named_formal_parameters_repeat1 = 523,
  alias_sym_type_identifier = 524,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_POUND] = "#",
  [sym_decimal_integer_literal] = "decimal_integer_literal",
  [sym_hex_integer_literal] = "hex_integer_literal",
  [sym_decimal_floating_point_literal] = "decimal_floating_point_literal",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = "'''",
  [anon_sym_r_DQUOTE] = "r\"",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_r_SQUOTE] = "r'",
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = "r\"\"\"",
  [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = "r'''",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym__sub_string_test_token1] = "_sub_string_test_token1",
  [sym__unused_escape_sequence] = "_unused_escape_sequence",
  [anon_sym_LBRACK] = "[",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON] = ":",
  [anon_sym_null] = "null",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_throw] = "throw",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_TILDE_SLASH_EQ] = "~/=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_QMARK] = "\?",
  [sym_equality_operator] = "equality_operator",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [sym__additive_operator] = "_additive_operator",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_TILDE_SLASH] = "~/",
  [sym_increment_operator] = "increment_operator",
  [anon_sym_DOT_DOT_DOT] = "...",
  [sym_minus_operator] = "minus_operator",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_await] = "await",
  [anon_sym_is] = "is",
  [anon_sym_as] = "as",
  [anon_sym_DOT] = ".",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_QMARK_DOT_DOT] = "\?..",
  [anon_sym_extends] = "extends",
  [anon_sym_SEMI] = ";",
  [anon_sym_switch] = "switch",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_when] = "when",
  [anon_sym_default] = "default",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_continue] = "continue",
  [anon_sym_yield] = "yield",
  [anon_sym_return] = "return",
  [anon_sym_on] = "on",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_if] = "if",
  [anon_sym_case] = "case",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_AT] = "@",
  [anon_sym_part] = "part",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_show] = "show",
  [anon_sym_hide] = "hide",
  [anon_sym_enum] = "enum",
  [anon_sym_final] = "final",
  [anon_sym_inline] = "inline",
  [anon_sym_class] = "class",
  [anon_sym_extension] = "extension",
  [anon_sym_with] = "with",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [sym_floating_point_type] = "floating_point_type",
  [anon_sym_bool] = "bool",
  [sym_void_type] = "void_type",
  [anon_sym_var] = "var",
  [anon_sym_async] = "async",
  [anon_sym_async_STAR] = "async*",
  [anon_sym_sync_STAR] = "sync*",
  [anon_sym_POUND_BANG] = "#!",
  [aux_sym_script_tag_token1] = "script_tag_token1",
  [anon_sym_LF] = "\n",
  [anon_sym_library] = "library",
  [sym_break_builtin] = "break_builtin",
  [sym_assert_builtin] = "assert_builtin",
  [sym_rethrow_builtin] = "rethrow_builtin",
  [sym_part_of_builtin] = "part_of_builtin",
  [anon_sym_covariant] = "covariant",
  [anon_sym_deferred] = "deferred",
  [anon_sym_dynamic] = "dynamic",
  [anon_sym_export] = "export",
  [anon_sym_factory] = "factory",
  [anon_sym_Function] = "Function",
  [anon_sym_get] = "get",
  [anon_sym_native] = "native",
  [anon_sym_implements] = "implements",
  [anon_sym_import] = "import",
  [anon_sym_interface] = "interface",
  [anon_sym_base] = "base",
  [anon_sym_abstract] = "abstract",
  [anon_sym_sealed] = "sealed",
  [anon_sym_operator] = "operator",
  [anon_sym_mixin] = "mixin",
  [anon_sym_required] = "required",
  [anon_sym_set] = "set",
  [anon_sym_static] = "static",
  [anon_sym_typedef] = "typedef",
  [anon_sym_new] = "new",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [sym_const_builtin] = "const_builtin",
  [anon_sym_late] = "late",
  [anon_sym_external] = "external",
  [anon_sym_this] = "this",
  [anon_sym_super] = "super",
  [sym_identifier_dollar_escaped] = "identifier_dollar_escaped",
  [anon_sym_SLASH_SLASH] = "//",
  [aux_sym_comment_token1] = "comment_token1",
  [anon_sym_SLASH_STAR] = "/*",
  [aux_sym_comment_token2] = "comment_token2",
  [anon_sym_SLASH_SLASH_SLASH] = "///",
  [aux_sym_documentation_comment_token1] = "documentation_comment_token1",
  [sym__template_chars_double] = "_template_chars_double",
  [sym__template_chars_single] = "_template_chars_single",
  [sym__template_chars_double_single] = "_template_chars_double_single",
  [sym__template_chars_single_single] = "_template_chars_single_single",
  [sym__template_chars_raw_slash] = "_template_chars_raw_slash",
  [sym__block_comment] = "_block_comment",
  [sym__documentation_block_comment] = "_documentation_block_comment",
  [sym_program] = "program",
  [sym__top_level_definition] = "_top_level_definition",
  [sym__bool_literal] = "_bool_literal",
  [sym__numeric_literal] = "_numeric_literal",
  [sym__literal] = "_literal",
  [sym_symbol_literal] = "symbol_literal",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_string_literal] = "string_literal",
  [sym__string_literal_double_quotes] = "_string_literal_double_quotes",
  [sym__string_literal_single_quotes] = "_string_literal_single_quotes",
  [sym__string_literal_double_quotes_multiple] = "_string_literal_double_quotes_multiple",
  [sym__string_literal_single_quotes_multiple] = "_string_literal_single_quotes_multiple",
  [sym__raw_string_literal_double_quotes] = "_raw_string_literal_double_quotes",
  [sym__raw_string_literal_single_quotes] = "_raw_string_literal_single_quotes",
  [sym__raw_string_literal_double_quotes_multiple] = "_raw_string_literal_double_quotes_multiple",
  [sym__raw_string_literal_single_quotes_multiple] = "_raw_string_literal_single_quotes_multiple",
  [sym_template_substitution] = "template_substitution",
  [sym__sub_string_test] = "_sub_string_test",
  [sym_escape_sequence] = "escape_sequence",
  [sym_list_literal] = "list_literal",
  [sym_set_or_map_literal] = "set_or_map_literal",
  [sym_pair] = "pair",
  [sym__element] = "_element",
  [sym_null_literal] = "null_literal",
  [sym_record_literal] = "record_literal",
  [sym__record_literal_no_const] = "_record_literal_no_const",
  [sym_record_field] = "record_field",
  [sym__expression] = "_expression",
  [sym__expression_without_cascade] = "_expression_without_cascade",
  [sym__real_expression] = "_real_expression",
  [sym_throw_expression] = "throw_expression",
  [sym_throw_expression_without_cascade] = "throw_expression_without_cascade",
  [sym_rethrow_expression] = "rethrow_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_assignment_expression_without_cascade] = "assignment_expression_without_cascade",
  [sym_assignable_expression] = "assignable_expression",
  [sym__assignable_selector_part] = "_assignable_selector_part",
  [sym__assignment_operator] = "_assignment_operator",
  [sym_lambda_expression] = "lambda_expression",
  [sym_function_expression] = "function_expression",
  [sym_if_null_expression] = "if_null_expression",
  [aux_sym__if_null_expression] = "_if_null_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_logical_or_expression] = "logical_or_expression",
  [sym_logical_and_expression] = "logical_and_expression",
  [sym_equality_expression] = "equality_expression",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_type_test_expression] = "type_test_expression",
  [sym_relational_expression] = "relational_expression",
  [sym_relational_operator] = "relational_operator",
  [sym_bitwise_or_expression] = "bitwise_or_expression",
  [sym_bitwise_xor_expression] = "bitwise_xor_expression",
  [sym_bitwise_and_expression] = "bitwise_and_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_additive_expression] = "additive_expression",
  [sym_multiplicative_expression] = "multiplicative_expression",
  [sym_bitwise_operator] = "bitwise_operator",
  [sym__bitwise_operator] = "_bitwise_operator",
  [sym_shift_operator] = "shift_operator",
  [sym__shift_operator] = "_shift_operator",
  [sym_additive_operator] = "additive_operator",
  [sym_multiplicative_operator] = "multiplicative_operator",
  [sym__multiplicative_operator] = "_multiplicative_operator",
  [sym__unary_expression] = "_unary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym__postfix_expression] = "_postfix_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_postfix_operator] = "postfix_operator",
  [sym_spread_element] = "spread_element",
  [sym_selector] = "selector",
  [sym_prefix_operator] = "prefix_operator",
  [sym_negation_operator] = "negation_operator",
  [sym__exclamation_operator] = "_exclamation_operator",
  [sym_tilde_operator] = "tilde_operator",
  [sym_await_expression] = "await_expression",
  [sym_type_test] = "type_test",
  [sym_is_operator] = "is_operator",
  [sym_type_cast] = "type_cast",
  [sym_as_operator] = "as_operator",
  [sym_new_expression] = "new_expression",
  [sym__dot_identifier] = "_dot_identifier",
  [sym_const_object_expression] = "const_object_expression",
  [sym__primary] = "_primary",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_constructor_invocation] = "constructor_invocation",
  [sym_constructor_tearoff] = "constructor_tearoff",
  [sym_arguments] = "arguments",
  [sym__argument_list] = "_argument_list",
  [sym__any_argument] = "_any_argument",
  [sym_argument] = "argument",
  [sym_named_argument] = "named_argument",
  [sym_cascade_section] = "cascade_section",
  [sym__cascade_subsection] = "_cascade_subsection",
  [sym__cascade_assignment_section] = "_cascade_assignment_section",
  [sym_index_selector] = "index_selector",
  [sym_cascade_selector] = "cascade_selector",
  [sym_argument_part] = "argument_part",
  [sym_unconditional_assignable_selector] = "unconditional_assignable_selector",
  [sym_conditional_assignable_selector] = "conditional_assignable_selector",
  [sym__assignable_selector] = "_assignable_selector",
  [sym_type_arguments] = "type_arguments",
  [sym__statement] = "_statement",
  [sym_local_function_declaration] = "local_function_declaration",
  [sym_block] = "block",
  [sym_expression_statement] = "expression_statement",
  [sym_assert_statement] = "assert_statement",
  [sym_assertion] = "assertion",
  [sym_assertion_arguments] = "assertion_arguments",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_expression_case] = "switch_expression_case",
  [sym__guarded_pattern] = "_guarded_pattern",
  [sym__pattern] = "_pattern",
  [sym__logical_or_pattern] = "_logical_or_pattern",
  [sym__logical_and_pattern] = "_logical_and_pattern",
  [sym__relational_pattern] = "_relational_pattern",
  [sym__unary_pattern] = "_unary_pattern",
  [sym__primary_pattern] = "_primary_pattern",
  [sym_cast_pattern] = "cast_pattern",
  [sym_null_check_pattern] = "null_check_pattern",
  [sym_null_assert_pattern] = "null_assert_pattern",
  [sym_constant_pattern] = "constant_pattern",
  [sym_variable_pattern] = "variable_pattern",
  [sym__parenthesized_pattern] = "_parenthesized_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym__list_pattern_element] = "_list_pattern_element",
  [sym_rest_pattern] = "rest_pattern",
  [sym_map_pattern] = "map_pattern",
  [sym__map_pattern_entry] = "_map_pattern_entry",
  [sym_record_pattern] = "record_pattern",
  [sym__pattern_field] = "_pattern_field",
  [sym_object_pattern] = "object_pattern",
  [sym_pattern_variable_declaration] = "pattern_variable_declaration",
  [sym__outer_pattern] = "_outer_pattern",
  [sym_pattern_assignment] = "pattern_assignment",
  [sym_switch_block] = "switch_block",
  [sym_switch_statement_case] = "switch_statement_case",
  [sym_switch_statement_default] = "switch_statement_default",
  [sym_do_statement] = "do_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_yield_each_statement] = "yield_each_statement",
  [sym_return_statement] = "return_statement",
  [sym_try_statement] = "try_statement",
  [sym__on_part] = "_on_part",
  [sym__try_head] = "_try_head",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_parameters] = "catch_parameters",
  [sym_finally_clause] = "finally_clause",
  [sym_if_element] = "if_element",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_loop_parts] = "for_loop_parts",
  [sym__for_loop_parts] = "_for_loop_parts",
  [sym_for_element] = "for_element",
  [sym_annotation] = "annotation",
  [sym_import_or_export] = "import_or_export",
  [sym_library_import] = "library_import",
  [sym_library_export] = "library_export",
  [sym_import_specification] = "import_specification",
  [sym_part_directive] = "part_directive",
  [sym_part_of_directive] = "part_of_directive",
  [sym_uri] = "uri",
  [sym_configurable_uri] = "configurable_uri",
  [sym_configuration_uri] = "configuration_uri",
  [sym_configuration_uri_condition] = "configuration_uri_condition",
  [sym_uri_test] = "uri_test",
  [sym_combinator] = "combinator",
  [sym__identifier_list] = "_identifier_list",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_constant] = "enum_constant",
  [sym_type_alias] = "type_alias",
  [sym__class_modifiers] = "_class_modifiers",
  [sym__mixin_class_modifiers] = "_mixin_class_modifiers",
  [sym_class_definition] = "class_definition",
  [sym_extension_declaration] = "extension_declaration",
  [sym__metadata] = "_metadata",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_type_bound] = "type_bound",
  [sym_superclass] = "superclass",
  [sym_mixins] = "mixins",
  [sym_mixin_application_class] = "mixin_application_class",
  [sym_mixin_application] = "mixin_application",
  [sym_mixin_declaration] = "mixin_declaration",
  [sym_interfaces] = "interfaces",
  [sym_class_body] = "class_body",
  [sym_extension_body] = "extension_body",
  [sym_getter_signature] = "getter_signature",
  [sym_setter_signature] = "setter_signature",
  [sym_method_signature] = "method_signature",
  [sym_declaration] = "declaration",
  [sym_identifier_list] = "identifier_list",
  [sym_initialized_identifier_list] = "initialized_identifier_list",
  [sym_initialized_identifier] = "initialized_identifier",
  [sym_static_final_declaration_list] = "static_final_declaration_list",
  [sym_binary_operator] = "binary_operator",
  [sym_operator_signature] = "operator_signature",
  [sym_static_final_declaration] = "static_final_declaration",
  [sym__external_and_static] = "_external_and_static",
  [sym__final_or_const] = "_final_or_const",
  [sym_initializers] = "initializers",
  [sym_initializer_list_entry] = "initializer_list_entry",
  [sym_field_initializer] = "field_initializer",
  [sym_factory_constructor_signature] = "factory_constructor_signature",
  [sym_redirecting_factory_constructor_signature] = "redirecting_factory_constructor_signature",
  [sym_redirection] = "redirection",
  [sym_constructor_signature] = "constructor_signature",
  [sym_constant_constructor_signature] = "constant_constructor_signature",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_initialized_variable_definition] = "initialized_variable_definition",
  [sym__declared_identifier] = "_declared_identifier",
  [sym__final_const_var_or_type] = "_final_const_var_or_type",
  [sym__type] = "_type",
  [sym__type_not_function] = "_type_not_function",
  [sym__type_not_void_not_function] = "_type_not_void_not_function",
  [sym_function_type] = "function_type",
  [aux_sym__function_type_tails] = "_function_type_tails",
  [sym__function_type_tail] = "_function_type_tail",
  [sym_parameter_type_list] = "parameter_type_list",
  [sym_normal_parameter_type] = "normal_parameter_type",
  [sym_optional_parameter_types] = "optional_parameter_types",
  [sym_optional_positional_parameter_types] = "optional_positional_parameter_types",
  [sym_named_parameter_types] = "named_parameter_types",
  [sym__named_parameter_type] = "_named_parameter_type",
  [sym__type_not_void] = "_type_not_void",
  [sym_record_type] = "record_type",
  [sym_record_type_field] = "record_type_field",
  [sym_record_type_named_field] = "record_type_named_field",
  [sym__type_not_void_list] = "_type_not_void_list",
  [sym__type_name] = "_type_name",
  [sym__type_dot_identifier] = "_type_dot_identifier",
  [sym_typed_identifier] = "typed_identifier",
  [sym_nullable_type] = "nullable_type",
  [sym_nullable_selector] = "nullable_selector",
  [sym__var_or_type] = "_var_or_type",
  [sym__final_var_or_type] = "_final_var_or_type",
  [sym_inferred_type] = "inferred_type",
  [sym_function_body] = "function_body",
  [sym_function_expression_body] = "function_expression_body",
  [sym_function_signature] = "function_signature",
  [sym__formal_parameter_part] = "_formal_parameter_part",
  [sym_formal_parameter_list] = "formal_parameter_list",
  [sym__strict_formal_parameter_list] = "_strict_formal_parameter_list",
  [sym__normal_formal_parameters] = "_normal_formal_parameters",
  [sym_optional_formal_parameters] = "optional_formal_parameters",
  [sym__optional_postional_formal_parameters] = "_optional_postional_formal_parameters",
  [sym__named_formal_parameters] = "_named_formal_parameters",
  [sym_formal_parameter] = "formal_parameter",
  [sym__default_formal_parameter] = "_default_formal_parameter",
  [sym__default_named_parameter] = "_default_named_parameter",
  [sym__normal_formal_parameter] = "_normal_formal_parameter",
  [sym__function_formal_parameter] = "_function_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_super_formal_parameter] = "super_formal_parameter",
  [sym_constructor_param] = "constructor_param",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym_script_tag] = "script_tag",
  [sym_library_name] = "library_name",
  [sym_dotted_identifier_list] = "dotted_identifier_list",
  [sym__identifier_or_new] = "_identifier_or_new",
  [sym_qualified] = "qualified",
  [sym__as] = "_as",
  [sym_case_builtin] = "case_builtin",
  [sym__covariant] = "_covariant",
  [sym__deferred] = "_deferred",
  [sym__export] = "_export",
  [sym__external] = "_external",
  [sym__factory] = "_factory",
  [sym__function_builtin_identifier] = "_function_builtin_identifier",
  [sym__get] = "_get",
  [sym__native] = "_native",
  [sym__implements] = "_implements",
  [sym__import] = "_import",
  [sym_interface] = "interface",
  [sym_base] = "base",
  [sym_abstract] = "abstract",
  [sym_sealed] = "sealed",
  [sym__operator] = "_operator",
  [sym_mixin] = "mixin",
  [sym__required] = "_required",
  [sym__set] = "_set",
  [sym__static] = "_static",
  [sym__typedef] = "_typedef",
  [sym__new_builtin] = "_new_builtin",
  [sym_logical_and_operator] = "logical_and_operator",
  [sym_logical_or_operator] = "logical_or_operator",
  [sym_final_builtin] = "final_builtin",
  [sym__late_builtin] = "_late_builtin",
  [sym__external_builtin] = "_external_builtin",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_label] = "label",
  [sym__semicolon] = "_semicolon",
  [sym_comment] = "comment",
  [sym_documentation_comment] = "documentation_comment",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_program_repeat2] = "program_repeat2",
  [aux_sym_program_repeat3] = "program_repeat3",
  [aux_sym_program_repeat4] = "program_repeat4",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__string_literal_double_quotes_repeat1] = "_string_literal_double_quotes_repeat1",
  [aux_sym__string_literal_single_quotes_repeat1] = "_string_literal_single_quotes_repeat1",
  [aux_sym__string_literal_double_quotes_multiple_repeat1] = "_string_literal_double_quotes_multiple_repeat1",
  [aux_sym__string_literal_single_quotes_multiple_repeat1] = "_string_literal_single_quotes_multiple_repeat1",
  [aux_sym__raw_string_literal_double_quotes_repeat1] = "_raw_string_literal_double_quotes_repeat1",
  [aux_sym__raw_string_literal_single_quotes_repeat1] = "_raw_string_literal_single_quotes_repeat1",
  [aux_sym__raw_string_literal_double_quotes_multiple_repeat1] = "_raw_string_literal_double_quotes_multiple_repeat1",
  [aux_sym__raw_string_literal_single_quotes_multiple_repeat1] = "_raw_string_literal_single_quotes_multiple_repeat1",
  [aux_sym_list_literal_repeat1] = "list_literal_repeat1",
  [aux_sym__record_literal_no_const_repeat1] = "_record_literal_no_const_repeat1",
  [aux_sym__expression_repeat1] = "_expression_repeat1",
  [aux_sym__assignable_selector_part_repeat1] = "_assignable_selector_part_repeat1",
  [aux_sym_inferred_parameters_repeat1] = "inferred_parameters_repeat1",
  [aux_sym_logical_or_expression_repeat1] = "logical_or_expression_repeat1",
  [aux_sym_logical_and_expression_repeat1] = "logical_and_expression_repeat1",
  [aux_sym_bitwise_or_expression_repeat1] = "bitwise_or_expression_repeat1",
  [aux_sym_bitwise_xor_expression_repeat1] = "bitwise_xor_expression_repeat1",
  [aux_sym_bitwise_and_expression_repeat1] = "bitwise_and_expression_repeat1",
  [aux_sym_shift_expression_repeat1] = "shift_expression_repeat1",
  [aux_sym_additive_expression_repeat1] = "additive_expression_repeat1",
  [aux_sym_multiplicative_expression_repeat1] = "multiplicative_expression_repeat1",
  [aux_sym__argument_list_repeat1] = "_argument_list_repeat1",
  [aux_sym_cascade_section_repeat1] = "cascade_section_repeat1",
  [aux_sym_cascade_section_repeat2] = "cascade_section_repeat2",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_switch_expression_repeat1] = "switch_expression_repeat1",
  [aux_sym__logical_or_pattern_repeat1] = "_logical_or_pattern_repeat1",
  [aux_sym__logical_and_pattern_repeat1] = "_logical_and_pattern_repeat1",
  [aux_sym_list_pattern_repeat1] = "list_pattern_repeat1",
  [aux_sym_map_pattern_repeat1] = "map_pattern_repeat1",
  [aux_sym_record_pattern_repeat1] = "record_pattern_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_switch_statement_case_repeat1] = "switch_statement_case_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym__for_loop_parts_repeat1] = "_for_loop_parts_repeat1",
  [aux_sym__for_loop_parts_repeat2] = "_for_loop_parts_repeat2",
  [aux_sym_library_export_repeat1] = "library_export_repeat1",
  [aux_sym_configurable_uri_repeat1] = "configurable_uri_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_enum_body_repeat2] = "enum_body_repeat2",
  [aux_sym__metadata_repeat1] = "_metadata_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_extension_body_repeat1] = "extension_body_repeat1",
  [aux_sym_initialized_identifier_list_repeat1] = "initialized_identifier_list_repeat1",
  [aux_sym_static_final_declaration_list_repeat1] = "static_final_declaration_list_repeat1",
  [aux_sym_initializers_repeat1] = "initializers_repeat1",
  [aux_sym_factory_constructor_signature_repeat1] = "factory_constructor_signature_repeat1",
  [aux_sym_parameter_type_list_repeat1] = "parameter_type_list_repeat1",
  [aux_sym_named_parameter_types_repeat1] = "named_parameter_types_repeat1",
  [aux_sym_record_type_repeat1] = "record_type_repeat1",
  [aux_sym_record_type_repeat2] = "record_type_repeat2",
  [aux_sym__type_not_void_list_repeat1] = "_type_not_void_list_repeat1",
  [aux_sym__normal_formal_parameters_repeat1] = "_normal_formal_parameters_repeat1",
  [aux_sym_positional_parameters_repeat1] = "positional_parameters_repeat1",
  [aux_sym__named_formal_parameters_repeat1] = "_named_formal_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_POUND] = anon_sym_POUND,
  [sym_decimal_integer_literal] = sym_decimal_integer_literal,
  [sym_hex_integer_literal] = sym_hex_integer_literal,
  [sym_decimal_floating_point_literal] = sym_decimal_floating_point_literal,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE_SQUOTE,
  [anon_sym_r_DQUOTE] = anon_sym_r_DQUOTE,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_r_SQUOTE] = anon_sym_r_SQUOTE,
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym__sub_string_test_token1] = aux_sym__sub_string_test_token1,
  [sym__unused_escape_sequence] = sym__unused_escape_sequence,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_TILDE_SLASH_EQ] = anon_sym_TILDE_SLASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [sym_equality_operator] = sym_equality_operator,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [sym__additive_operator] = sym__additive_operator,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_TILDE_SLASH] = anon_sym_TILDE_SLASH,
  [sym_increment_operator] = sym_increment_operator,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [sym_minus_operator] = sym_minus_operator,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_QMARK_DOT_DOT] = anon_sym_QMARK_DOT_DOT,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_part] = anon_sym_part,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_show] = anon_sym_show,
  [anon_sym_hide] = anon_sym_hide,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extension] = anon_sym_extension,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK_RBRACK_EQ] = anon_sym_LBRACK_RBRACK_EQ,
  [sym_floating_point_type] = sym_floating_point_type,
  [anon_sym_bool] = anon_sym_bool,
  [sym_void_type] = sym_void_type,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_async_STAR] = anon_sym_async_STAR,
  [anon_sym_sync_STAR] = anon_sym_sync_STAR,
  [anon_sym_POUND_BANG] = anon_sym_POUND_BANG,
  [aux_sym_script_tag_token1] = aux_sym_script_tag_token1,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_library] = anon_sym_library,
  [sym_break_builtin] = sym_break_builtin,
  [sym_assert_builtin] = sym_assert_builtin,
  [sym_rethrow_builtin] = sym_rethrow_builtin,
  [sym_part_of_builtin] = sym_part_of_builtin,
  [anon_sym_covariant] = anon_sym_covariant,
  [anon_sym_deferred] = anon_sym_deferred,
  [anon_sym_dynamic] = anon_sym_dynamic,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_factory] = anon_sym_factory,
  [anon_sym_Function] = anon_sym_Function,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_base] = anon_sym_base,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_mixin] = anon_sym_mixin,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [sym_const_builtin] = sym_const_builtin,
  [anon_sym_late] = anon_sym_late,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_this] = anon_sym_this,
  [anon_sym_super] = anon_sym_super,
  [sym_identifier_dollar_escaped] = sym_identifier_dollar_escaped,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [anon_sym_SLASH_STAR] = anon_sym_SLASH_STAR,
  [aux_sym_comment_token2] = aux_sym_comment_token2,
  [anon_sym_SLASH_SLASH_SLASH] = anon_sym_SLASH_SLASH_SLASH,
  [aux_sym_documentation_comment_token1] = aux_sym_documentation_comment_token1,
  [sym__template_chars_double] = sym__template_chars_double,
  [sym__template_chars_single] = sym__template_chars_single,
  [sym__template_chars_double_single] = sym__template_chars_double_single,
  [sym__template_chars_single_single] = sym__template_chars_single_single,
  [sym__template_chars_raw_slash] = sym__template_chars_raw_slash,
  [sym__block_comment] = sym__block_comment,
  [sym__documentation_block_comment] = sym__documentation_block_comment,
  [sym_program] = sym_program,
  [sym__top_level_definition] = sym__top_level_definition,
  [sym__bool_literal] = sym__bool_literal,
  [sym__numeric_literal] = sym__numeric_literal,
  [sym__literal] = sym__literal,
  [sym_symbol_literal] = sym_symbol_literal,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_string_literal] = sym_string_literal,
  [sym__string_literal_double_quotes] = sym__string_literal_double_quotes,
  [sym__string_literal_single_quotes] = sym__string_literal_single_quotes,
  [sym__string_literal_double_quotes_multiple] = sym__string_literal_double_quotes_multiple,
  [sym__string_literal_single_quotes_multiple] = sym__string_literal_single_quotes_multiple,
  [sym__raw_string_literal_double_quotes] = sym__raw_string_literal_double_quotes,
  [sym__raw_string_literal_single_quotes] = sym__raw_string_literal_single_quotes,
  [sym__raw_string_literal_double_quotes_multiple] = sym__raw_string_literal_double_quotes_multiple,
  [sym__raw_string_literal_single_quotes_multiple] = sym__raw_string_literal_single_quotes_multiple,
  [sym_template_substitution] = sym_template_substitution,
  [sym__sub_string_test] = sym__sub_string_test,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_list_literal] = sym_list_literal,
  [sym_set_or_map_literal] = sym_set_or_map_literal,
  [sym_pair] = sym_pair,
  [sym__element] = sym__element,
  [sym_null_literal] = sym_null_literal,
  [sym_record_literal] = sym_record_literal,
  [sym__record_literal_no_const] = sym__record_literal_no_const,
  [sym_record_field] = sym_record_field,
  [sym__expression] = sym__expression,
  [sym__expression_without_cascade] = sym__expression_without_cascade,
  [sym__real_expression] = sym__real_expression,
  [sym_throw_expression] = sym_throw_expression,
  [sym_throw_expression_without_cascade] = sym_throw_expression_without_cascade,
  [sym_rethrow_expression] = sym_rethrow_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_assignment_expression_without_cascade] = sym_assignment_expression_without_cascade,
  [sym_assignable_expression] = sym_assignable_expression,
  [sym__assignable_selector_part] = sym__assignable_selector_part,
  [sym__assignment_operator] = sym__assignment_operator,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_function_expression] = sym_function_expression,
  [sym_if_null_expression] = sym_if_null_expression,
  [aux_sym__if_null_expression] = aux_sym__if_null_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_logical_or_expression] = sym_logical_or_expression,
  [sym_logical_and_expression] = sym_logical_and_expression,
  [sym_equality_expression] = sym_equality_expression,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_type_test_expression] = sym_type_test_expression,
  [sym_relational_expression] = sym_relational_expression,
  [sym_relational_operator] = sym_relational_operator,
  [sym_bitwise_or_expression] = sym_bitwise_or_expression,
  [sym_bitwise_xor_expression] = sym_bitwise_xor_expression,
  [sym_bitwise_and_expression] = sym_bitwise_and_expression,
  [sym_shift_expression] = sym_shift_expression,
  [sym_additive_expression] = sym_additive_expression,
  [sym_multiplicative_expression] = sym_multiplicative_expression,
  [sym_bitwise_operator] = sym_bitwise_operator,
  [sym__bitwise_operator] = sym__bitwise_operator,
  [sym_shift_operator] = sym_shift_operator,
  [sym__shift_operator] = sym__shift_operator,
  [sym_additive_operator] = sym_additive_operator,
  [sym_multiplicative_operator] = sym_multiplicative_operator,
  [sym__multiplicative_operator] = sym__multiplicative_operator,
  [sym__unary_expression] = sym__unary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym__postfix_expression] = sym__postfix_expression,
  [sym_postfix_expression] = sym_postfix_expression,
  [sym_postfix_operator] = sym_postfix_operator,
  [sym_spread_element] = sym_spread_element,
  [sym_selector] = sym_selector,
  [sym_prefix_operator] = sym_prefix_operator,
  [sym_negation_operator] = sym_negation_operator,
  [sym__exclamation_operator] = sym__exclamation_operator,
  [sym_tilde_operator] = sym_tilde_operator,
  [sym_await_expression] = sym_await_expression,
  [sym_type_test] = sym_type_test,
  [sym_is_operator] = sym_is_operator,
  [sym_type_cast] = sym_type_cast,
  [sym_as_operator] = sym_as_operator,
  [sym_new_expression] = sym_new_expression,
  [sym__dot_identifier] = sym__dot_identifier,
  [sym_const_object_expression] = sym_const_object_expression,
  [sym__primary] = sym__primary,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_constructor_invocation] = sym_constructor_invocation,
  [sym_constructor_tearoff] = sym_constructor_tearoff,
  [sym_arguments] = sym_arguments,
  [sym__argument_list] = sym__argument_list,
  [sym__any_argument] = sym__any_argument,
  [sym_argument] = sym_argument,
  [sym_named_argument] = sym_named_argument,
  [sym_cascade_section] = sym_cascade_section,
  [sym__cascade_subsection] = sym__cascade_subsection,
  [sym__cascade_assignment_section] = sym__cascade_assignment_section,
  [sym_index_selector] = sym_index_selector,
  [sym_cascade_selector] = sym_cascade_selector,
  [sym_argument_part] = sym_argument_part,
  [sym_unconditional_assignable_selector] = sym_unconditional_assignable_selector,
  [sym_conditional_assignable_selector] = sym_conditional_assignable_selector,
  [sym__assignable_selector] = sym__assignable_selector,
  [sym_type_arguments] = sym_type_arguments,
  [sym__statement] = sym__statement,
  [sym_local_function_declaration] = sym_local_function_declaration,
  [sym_block] = sym_block,
  [sym_expression_statement] = sym_expression_statement,
  [sym_assert_statement] = sym_assert_statement,
  [sym_assertion] = sym_assertion,
  [sym_assertion_arguments] = sym_assertion_arguments,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_expression_case] = sym_switch_expression_case,
  [sym__guarded_pattern] = sym__guarded_pattern,
  [sym__pattern] = sym__pattern,
  [sym__logical_or_pattern] = sym__logical_or_pattern,
  [sym__logical_and_pattern] = sym__logical_and_pattern,
  [sym__relational_pattern] = sym__relational_pattern,
  [sym__unary_pattern] = sym__unary_pattern,
  [sym__primary_pattern] = sym__primary_pattern,
  [sym_cast_pattern] = sym_cast_pattern,
  [sym_null_check_pattern] = sym_null_check_pattern,
  [sym_null_assert_pattern] = sym_null_assert_pattern,
  [sym_constant_pattern] = sym_constant_pattern,
  [sym_variable_pattern] = sym_variable_pattern,
  [sym__parenthesized_pattern] = sym__parenthesized_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym__list_pattern_element] = sym__list_pattern_element,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_map_pattern] = sym_map_pattern,
  [sym__map_pattern_entry] = sym__map_pattern_entry,
  [sym_record_pattern] = sym_record_pattern,
  [sym__pattern_field] = sym__pattern_field,
  [sym_object_pattern] = sym_object_pattern,
  [sym_pattern_variable_declaration] = sym_pattern_variable_declaration,
  [sym__outer_pattern] = sym__outer_pattern,
  [sym_pattern_assignment] = sym_pattern_assignment,
  [sym_switch_block] = sym_switch_block,
  [sym_switch_statement_case] = sym_switch_statement_case,
  [sym_switch_statement_default] = sym_switch_statement_default,
  [sym_do_statement] = sym_do_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_yield_each_statement] = sym_yield_each_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_try_statement] = sym_try_statement,
  [sym__on_part] = sym__on_part,
  [sym__try_head] = sym__try_head,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_parameters] = sym_catch_parameters,
  [sym_finally_clause] = sym_finally_clause,
  [sym_if_element] = sym_if_element,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_loop_parts] = sym_for_loop_parts,
  [sym__for_loop_parts] = sym__for_loop_parts,
  [sym_for_element] = sym_for_element,
  [sym_annotation] = sym_annotation,
  [sym_import_or_export] = sym_import_or_export,
  [sym_library_import] = sym_library_import,
  [sym_library_export] = sym_library_export,
  [sym_import_specification] = sym_import_specification,
  [sym_part_directive] = sym_part_directive,
  [sym_part_of_directive] = sym_part_of_directive,
  [sym_uri] = sym_uri,
  [sym_configurable_uri] = sym_configurable_uri,
  [sym_configuration_uri] = sym_configuration_uri,
  [sym_configuration_uri_condition] = sym_configuration_uri_condition,
  [sym_uri_test] = sym_uri_test,
  [sym_combinator] = sym_combinator,
  [sym__identifier_list] = sym__identifier_list,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_constant] = sym_enum_constant,
  [sym_type_alias] = sym_type_alias,
  [sym__class_modifiers] = sym__class_modifiers,
  [sym__mixin_class_modifiers] = sym__mixin_class_modifiers,
  [sym_class_definition] = sym_class_definition,
  [sym_extension_declaration] = sym_extension_declaration,
  [sym__metadata] = sym__metadata,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_type_bound] = sym_type_bound,
  [sym_superclass] = sym_superclass,
  [sym_mixins] = sym_mixins,
  [sym_mixin_application_class] = sym_mixin_application_class,
  [sym_mixin_application] = sym_mixin_application,
  [sym_mixin_declaration] = sym_mixin_declaration,
  [sym_interfaces] = sym_interfaces,
  [sym_class_body] = sym_class_body,
  [sym_extension_body] = sym_extension_body,
  [sym_getter_signature] = sym_getter_signature,
  [sym_setter_signature] = sym_setter_signature,
  [sym_method_signature] = sym_method_signature,
  [sym_declaration] = sym_declaration,
  [sym_identifier_list] = sym_identifier_list,
  [sym_initialized_identifier_list] = sym_initialized_identifier_list,
  [sym_initialized_identifier] = sym_initialized_identifier,
  [sym_static_final_declaration_list] = sym_static_final_declaration_list,
  [sym_binary_operator] = sym_binary_operator,
  [sym_operator_signature] = sym_operator_signature,
  [sym_static_final_declaration] = sym_static_final_declaration,
  [sym__external_and_static] = sym__external_and_static,
  [sym__final_or_const] = sym__final_or_const,
  [sym_initializers] = sym_initializers,
  [sym_initializer_list_entry] = sym_initializer_list_entry,
  [sym_field_initializer] = sym_field_initializer,
  [sym_factory_constructor_signature] = sym_factory_constructor_signature,
  [sym_redirecting_factory_constructor_signature] = sym_redirecting_factory_constructor_signature,
  [sym_redirection] = sym_redirection,
  [sym_constructor_signature] = sym_constructor_signature,
  [sym_constant_constructor_signature] = sym_constant_constructor_signature,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_initialized_variable_definition] = sym_initialized_variable_definition,
  [sym__declared_identifier] = sym__declared_identifier,
  [sym__final_const_var_or_type] = sym__final_const_var_or_type,
  [sym__type] = sym__type,
  [sym__type_not_function] = sym__type_not_function,
  [sym__type_not_void_not_function] = sym__type_not_void_not_function,
  [sym_function_type] = sym_function_type,
  [aux_sym__function_type_tails] = aux_sym__function_type_tails,
  [sym__function_type_tail] = sym__function_type_tail,
  [sym_parameter_type_list] = sym_parameter_type_list,
  [sym_normal_parameter_type] = sym_normal_parameter_type,
  [sym_optional_parameter_types] = sym_optional_parameter_types,
  [sym_optional_positional_parameter_types] = sym_optional_positional_parameter_types,
  [sym_named_parameter_types] = sym_named_parameter_types,
  [sym__named_parameter_type] = sym__named_parameter_type,
  [sym__type_not_void] = sym__type_not_void,
  [sym_record_type] = sym_record_type,
  [sym_record_type_field] = sym_record_type_field,
  [sym_record_type_named_field] = sym_record_type_named_field,
  [sym__type_not_void_list] = sym__type_not_void_list,
  [sym__type_name] = sym__type_name,
  [sym__type_dot_identifier] = sym__type_dot_identifier,
  [sym_typed_identifier] = sym_typed_identifier,
  [sym_nullable_type] = sym_nullable_type,
  [sym_nullable_selector] = sym_nullable_selector,
  [sym__var_or_type] = sym__var_or_type,
  [sym__final_var_or_type] = sym__final_var_or_type,
  [sym_inferred_type] = sym_inferred_type,
  [sym_function_body] = sym_function_body,
  [sym_function_expression_body] = sym_function_expression_body,
  [sym_function_signature] = sym_function_signature,
  [sym__formal_parameter_part] = sym__formal_parameter_part,
  [sym_formal_parameter_list] = sym_formal_parameter_list,
  [sym__strict_formal_parameter_list] = sym__strict_formal_parameter_list,
  [sym__normal_formal_parameters] = sym__normal_formal_parameters,
  [sym_optional_formal_parameters] = sym_optional_formal_parameters,
  [sym__optional_postional_formal_parameters] = sym__optional_postional_formal_parameters,
  [sym__named_formal_parameters] = sym__named_formal_parameters,
  [sym_formal_parameter] = sym_formal_parameter,
  [sym__default_formal_parameter] = sym__default_formal_parameter,
  [sym__default_named_parameter] = sym__default_named_parameter,
  [sym__normal_formal_parameter] = sym__normal_formal_parameter,
  [sym__function_formal_parameter] = sym__function_formal_parameter,
  [sym__simple_formal_parameter] = sym__simple_formal_parameter,
  [sym_super_formal_parameter] = sym_super_formal_parameter,
  [sym_constructor_param] = sym_constructor_param,
  [sym_local_variable_declaration] = sym_local_variable_declaration,
  [sym_script_tag] = sym_script_tag,
  [sym_library_name] = sym_library_name,
  [sym_dotted_identifier_list] = sym_dotted_identifier_list,
  [sym__identifier_or_new] = sym__identifier_or_new,
  [sym_qualified] = sym_qualified,
  [sym__as] = sym__as,
  [sym_case_builtin] = sym_case_builtin,
  [sym__covariant] = sym__covariant,
  [sym__deferred] = sym__deferred,
  [sym__export] = sym__export,
  [sym__external] = sym__external,
  [sym__factory] = sym__factory,
  [sym__function_builtin_identifier] = sym__function_builtin_identifier,
  [sym__get] = sym__get,
  [sym__native] = sym__native,
  [sym__implements] = sym__implements,
  [sym__import] = sym__import,
  [sym_interface] = sym_interface,
  [sym_base] = sym_base,
  [sym_abstract] = sym_abstract,
  [sym_sealed] = sym_sealed,
  [sym__operator] = sym__operator,
  [sym_mixin] = sym_mixin,
  [sym__required] = sym__required,
  [sym__set] = sym__set,
  [sym__static] = sym__static,
  [sym__typedef] = sym__typedef,
  [sym__new_builtin] = sym__new_builtin,
  [sym_logical_and_operator] = sym_logical_and_operator,
  [sym_logical_or_operator] = sym_logical_or_operator,
  [sym_final_builtin] = sym_final_builtin,
  [sym__late_builtin] = sym__late_builtin,
  [sym__external_builtin] = sym__external_builtin,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_label] = sym_label,
  [sym__semicolon] = sym__semicolon,
  [sym_comment] = sym_comment,
  [sym_documentation_comment] = sym_documentation_comment,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_program_repeat2] = aux_sym_program_repeat2,
  [aux_sym_program_repeat3] = aux_sym_program_repeat3,
  [aux_sym_program_repeat4] = aux_sym_program_repeat4,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__string_literal_double_quotes_repeat1] = aux_sym__string_literal_double_quotes_repeat1,
  [aux_sym__string_literal_single_quotes_repeat1] = aux_sym__string_literal_single_quotes_repeat1,
  [aux_sym__string_literal_double_quotes_multiple_repeat1] = aux_sym__string_literal_double_quotes_multiple_repeat1,
  [aux_sym__string_literal_single_quotes_multiple_repeat1] = aux_sym__string_literal_single_quotes_multiple_repeat1,
  [aux_sym__raw_string_literal_double_quotes_repeat1] = aux_sym__raw_string_literal_double_quotes_repeat1,
  [aux_sym__raw_string_literal_single_quotes_repeat1] = aux_sym__raw_string_literal_single_quotes_repeat1,
  [aux_sym__raw_string_literal_double_quotes_multiple_repeat1] = aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
  [aux_sym__raw_string_literal_single_quotes_multiple_repeat1] = aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
  [aux_sym_list_literal_repeat1] = aux_sym_list_literal_repeat1,
  [aux_sym__record_literal_no_const_repeat1] = aux_sym__record_literal_no_const_repeat1,
  [aux_sym__expression_repeat1] = aux_sym__expression_repeat1,
  [aux_sym__assignable_selector_part_repeat1] = aux_sym__assignable_selector_part_repeat1,
  [aux_sym_inferred_parameters_repeat1] = aux_sym_inferred_parameters_repeat1,
  [aux_sym_logical_or_expression_repeat1] = aux_sym_logical_or_expression_repeat1,
  [aux_sym_logical_and_expression_repeat1] = aux_sym_logical_and_expression_repeat1,
  [aux_sym_bitwise_or_expression_repeat1] = aux_sym_bitwise_or_expression_repeat1,
  [aux_sym_bitwise_xor_expression_repeat1] = aux_sym_bitwise_xor_expression_repeat1,
  [aux_sym_bitwise_and_expression_repeat1] = aux_sym_bitwise_and_expression_repeat1,
  [aux_sym_shift_expression_repeat1] = aux_sym_shift_expression_repeat1,
  [aux_sym_additive_expression_repeat1] = aux_sym_additive_expression_repeat1,
  [aux_sym_multiplicative_expression_repeat1] = aux_sym_multiplicative_expression_repeat1,
  [aux_sym__argument_list_repeat1] = aux_sym__argument_list_repeat1,
  [aux_sym_cascade_section_repeat1] = aux_sym_cascade_section_repeat1,
  [aux_sym_cascade_section_repeat2] = aux_sym_cascade_section_repeat2,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_switch_expression_repeat1] = aux_sym_switch_expression_repeat1,
  [aux_sym__logical_or_pattern_repeat1] = aux_sym__logical_or_pattern_repeat1,
  [aux_sym__logical_and_pattern_repeat1] = aux_sym__logical_and_pattern_repeat1,
  [aux_sym_list_pattern_repeat1] = aux_sym_list_pattern_repeat1,
  [aux_sym_map_pattern_repeat1] = aux_sym_map_pattern_repeat1,
  [aux_sym_record_pattern_repeat1] = aux_sym_record_pattern_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_switch_statement_case_repeat1] = aux_sym_switch_statement_case_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym__for_loop_parts_repeat1] = aux_sym__for_loop_parts_repeat1,
  [aux_sym__for_loop_parts_repeat2] = aux_sym__for_loop_parts_repeat2,
  [aux_sym_library_export_repeat1] = aux_sym_library_export_repeat1,
  [aux_sym_configurable_uri_repeat1] = aux_sym_configurable_uri_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_enum_body_repeat2] = aux_sym_enum_body_repeat2,
  [aux_sym__metadata_repeat1] = aux_sym__metadata_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_extension_body_repeat1] = aux_sym_extension_body_repeat1,
  [aux_sym_initialized_identifier_list_repeat1] = aux_sym_initialized_identifier_list_repeat1,
  [aux_sym_static_final_declaration_list_repeat1] = aux_sym_static_final_declaration_list_repeat1,
  [aux_sym_initializers_repeat1] = aux_sym_initializers_repeat1,
  [aux_sym_factory_constructor_signature_repeat1] = aux_sym_factory_constructor_signature_repeat1,
  [aux_sym_parameter_type_list_repeat1] = aux_sym_parameter_type_list_repeat1,
  [aux_sym_named_parameter_types_repeat1] = aux_sym_named_parameter_types_repeat1,
  [aux_sym_record_type_repeat1] = aux_sym_record_type_repeat1,
  [aux_sym_record_type_repeat2] = aux_sym_record_type_repeat2,
  [aux_sym__type_not_void_list_repeat1] = aux_sym__type_not_void_list_repeat1,
  [aux_sym__normal_formal_parameters_repeat1] = aux_sym__normal_formal_parameters_repeat1,
  [aux_sym_positional_parameters_repeat1] = aux_sym_positional_parameters_repeat1,
  [aux_sym__named_formal_parameters_repeat1] = aux_sym__named_formal_parameters_repeat1,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [sym_decimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__sub_string_test_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__unused_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [sym_equality_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__additive_operator] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_increment_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_minus_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_part] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_show] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hide] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extension] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_floating_point_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [sym_void_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sync_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_BANG] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_script_tag_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_library] = {
    .visible = true,
    .named = false,
  },
  [sym_break_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_rethrow_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_part_of_builtin] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_covariant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_deferred] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_factory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mixin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_const_builtin] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_late] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_super] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier_dollar_escaped] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SLASH_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_documentation_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__template_chars_double] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_single] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_double_single] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_single_single] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars_raw_slash] = {
    .visible = false,
    .named = true,
  },
  [sym__block_comment] = {
    .visible = false,
    .named = true,
  },
  [sym__documentation_block_comment] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_definition] = {
    .visible = false,
    .named = true,
  },
  [sym__bool_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__numeric_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_symbol_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal_double_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__string_literal_single_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__string_literal_double_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym__string_literal_single_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_double_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_single_quotes] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_double_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal_single_quotes_multiple] = {
    .visible = false,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym__sub_string_test] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_set_or_map_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__element] = {
    .visible = false,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_record_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__record_literal_no_const] = {
    .visible = false,
    .named = true,
  },
  [sym_record_field] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__expression_without_cascade] = {
    .visible = false,
    .named = true,
  },
  [sym__real_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression_without_cascade] = {
    .visible = true,
    .named = true,
  },
  [sym_rethrow_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression_without_cascade] = {
    .visible = true,
    .named = true,
  },
  [sym_assignable_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__assignable_selector_part] = {
    .visible = false,
    .named = true,
  },
  [sym__assignment_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_null_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__if_null_expression] = {
    .visible = false,
    .named = false,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_or_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_and_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equality_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_test_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_or_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_xor_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_and_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_additive_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_multiplicative_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_bitwise_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__bitwise_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_shift_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__shift_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_additive_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_multiplicative_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__multiplicative_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__postfix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_negation_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__exclamation_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_tilde_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_test] = {
    .visible = true,
    .named = true,
  },
  [sym_is_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_as_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__dot_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_const_object_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_tearoff] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym__any_argument] = {
    .visible = false,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_named_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_cascade_section] = {
    .visible = true,
    .named = true,
  },
  [sym__cascade_subsection] = {
    .visible = false,
    .named = true,
  },
  [sym__cascade_assignment_section] = {
    .visible = false,
    .named = true,
  },
  [sym_index_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_cascade_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_part] = {
    .visible = true,
    .named = true,
  },
  [sym_unconditional_assignable_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_assignable_selector] = {
    .visible = true,
    .named = true,
  },
  [sym__assignable_selector] = {
    .visible = false,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_local_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_assertion_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression_case] = {
    .visible = true,
    .named = true,
  },
  [sym__guarded_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__logical_or_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__logical_and_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__relational_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_cast_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_null_check_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_null_assert_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__parenthesized_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__list_pattern_element] = {
    .visible = false,
    .named = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_map_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__map_pattern_entry] = {
    .visible = false,
    .named = true,
  },
  [sym_record_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_field] = {
    .visible = false,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__outer_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_pattern_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement_default] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_each_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__on_part] = {
    .visible = false,
    .named = true,
  },
  [sym__try_head] = {
    .visible = false,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_element] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_loop_parts] = {
    .visible = true,
    .named = true,
  },
  [sym__for_loop_parts] = {
    .visible = false,
    .named = true,
  },
  [sym_for_element] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_import_or_export] = {
    .visible = true,
    .named = true,
  },
  [sym_library_import] = {
    .visible = true,
    .named = true,
  },
  [sym_library_export] = {
    .visible = true,
    .named = true,
  },
  [sym_import_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_part_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_part_of_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_configurable_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_configuration_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_configuration_uri_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_uri_test] = {
    .visible = true,
    .named = true,
  },
  [sym_combinator] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_list] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym__class_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__mixin_class_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__metadata] = {
    .visible = false,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_mixins] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_application_class] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_application] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_body] = {
    .visible = true,
    .named = true,
  },
  [sym_getter_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_setter_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initialized_identifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initialized_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_static_final_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_static_final_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__external_and_static] = {
    .visible = false,
    .named = true,
  },
  [sym__final_or_const] = {
    .visible = false,
    .named = true,
  },
  [sym_initializers] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list_entry] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_factory_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_redirecting_factory_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_redirection] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_constructor_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_initialized_variable_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__declared_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__final_const_var_or_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_not_function] = {
    .visible = false,
    .named = true,
  },
  [sym__type_not_void_not_function] = {
    .visible = false,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__function_type_tails] = {
    .visible = false,
    .named = false,
  },
  [sym__function_type_tail] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_normal_parameter_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_positional_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym_named_parameter_types] = {
    .visible = true,
    .named = true,
  },
  [sym__named_parameter_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_not_void] = {
    .visible = false,
    .named = true,
  },
  [sym_record_type] = {
    .visible = true,
    .named = true,
  },
  [sym_record_type_field] = {
    .visible = true,
    .named = true,
  },
  [sym_record_type_named_field] = {
    .visible = true,
    .named = true,
  },
  [sym__type_not_void_list] = {
    .visible = false,
    .named = true,
  },
  [sym__type_name] = {
    .visible = false,
    .named = true,
  },
  [sym__type_dot_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_typed_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_nullable_type] = {
    .visible = true,
    .named = true,
  },
  [sym_nullable_selector] = {
    .visible = true,
    .named = true,
  },
  [sym__var_or_type] = {
    .visible = false,
    .named = true,
  },
  [sym__final_var_or_type] = {
    .visible = false,
    .named = true,
  },
  [sym_inferred_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression_body] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter_part] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__strict_formal_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__normal_formal_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__optional_postional_formal_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__named_formal_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__default_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__default_named_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__normal_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__function_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_super_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_param] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_script_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_library_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_identifier_list] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_or_new] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified] = {
    .visible = true,
    .named = true,
  },
  [sym__as] = {
    .visible = false,
    .named = true,
  },
  [sym_case_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym__covariant] = {
    .visible = false,
    .named = true,
  },
  [sym__deferred] = {
    .visible = false,
    .named = true,
  },
  [sym__export] = {
    .visible = false,
    .named = true,
  },
  [sym__external] = {
    .visible = false,
    .named = true,
  },
  [sym__factory] = {
    .visible = false,
    .named = true,
  },
  [sym__function_builtin_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__get] = {
    .visible = false,
    .named = true,
  },
  [sym__native] = {
    .visible = false,
    .named = true,
  },
  [sym__implements] = {
    .visible = false,
    .named = true,
  },
  [sym__import] = {
    .visible = false,
    .named = true,
  },
  [sym_interface] = {
    .visible = true,
    .named = true,
  },
  [sym_base] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract] = {
    .visible = true,
    .named = true,
  },
  [sym_sealed] = {
    .visible = true,
    .named = true,
  },
  [sym__operator] = {
    .visible = false,
    .named = true,
  },
  [sym_mixin] = {
    .visible = true,
    .named = true,
  },
  [sym__required] = {
    .visible = false,
    .named = true,
  },
  [sym__set] = {
    .visible = false,
    .named = true,
  },
  [sym__static] = {
    .visible = false,
    .named = true,
  },
  [sym__typedef] = {
    .visible = false,
    .named = true,
  },
  [sym__new_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym_logical_and_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_or_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_final_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym__late_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym__external_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_documentation_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_program_repeat4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_double_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_single_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_double_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_single_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_double_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_single_quotes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_double_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_single_quotes_multiple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__record_literal_no_const_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__assignable_selector_part_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inferred_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_logical_or_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_logical_and_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bitwise_or_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bitwise_xor_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bitwise_and_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_shift_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_additive_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multiplicative_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cascade_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cascade_section_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__logical_or_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__logical_and_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_map_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_statement_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__for_loop_parts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__for_loop_parts_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_library_export_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_configurable_uri_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__metadata_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initialized_identifier_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_static_final_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_factory_constructor_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_parameter_types_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_type_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_not_void_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__normal_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_positional_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__named_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_body = 2,
  field_class = 3,
  field_condition = 4,
  field_consequence = 5,
  field_first = 6,
  field_init = 7,
  field_interfaces = 8,
  field_key = 9,
  field_left = 10,
  field_name = 11,
  field_operator = 12,
  field_parameters = 13,
  field_right = 14,
  field_scope = 15,
  field_second = 16,
  field_superclass = 17,
  field_type_parameters = 18,
  field_update = 19,
  field_value = 20,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_body] = "body",
  [field_class] = "class",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_first] = "first",
  [field_init] = "init",
  [field_interfaces] = "interfaces",
  [field_key] = "key",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_second] = "second",
  [field_superclass] = "superclass",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 2},
  [6] = {.index = 4, .length = 1},
  [8] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 0, .length = 1},
  [11] = {.index = 7, .length = 2},
  [12] = {.index = 9, .length = 2},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 13, .length = 1},
  [15] = {.index = 14, .length = 3},
  [16] = {.index = 17, .length = 3},
  [17] = {.index = 20, .length = 3},
  [18] = {.index = 23, .length = 2},
  [19] = {.index = 25, .length = 1},
  [20] = {.index = 26, .length = 2},
  [21] = {.index = 28, .length = 2},
  [22] = {.index = 30, .length = 2},
  [23] = {.index = 32, .length = 3},
  [24] = {.index = 35, .length = 3},
  [25] = {.index = 38, .length = 2},
  [26] = {.index = 40, .length = 4},
  [27] = {.index = 44, .length = 4},
  [28] = {.index = 48, .length = 4},
  [29] = {.index = 52, .length = 2},
  [30] = {.index = 54, .length = 2},
  [31] = {.index = 56, .length = 3},
  [32] = {.index = 59, .length = 3},
  [33] = {.index = 62, .length = 3},
  [34] = {.index = 65, .length = 2},
  [35] = {.index = 67, .length = 1},
  [36] = {.index = 68, .length = 1},
  [37] = {.index = 69, .length = 2},
  [38] = {.index = 71, .length = 3},
  [39] = {.index = 74, .length = 2},
  [40] = {.index = 76, .length = 2},
  [41] = {.index = 78, .length = 4},
  [42] = {.index = 82, .length = 1},
  [43] = {.index = 83, .length = 5},
  [44] = {.index = 88, .length = 2},
  [45] = {.index = 90, .length = 3},
  [46] = {.index = 93, .length = 3},
  [47] = {.index = 96, .length = 4},
  [48] = {.index = 100, .length = 4},
  [49] = {.index = 104, .length = 4},
  [50] = {.index = 108, .length = 2},
  [51] = {.index = 110, .length = 1},
  [52] = {.index = 111, .length = 1},
  [53] = {.index = 112, .length = 5},
  [54] = {.index = 117, .length = 1},
  [55] = {.index = 118, .length = 1},
  [56] = {.index = 119, .length = 4},
  [57] = {.index = 123, .length = 2},
  [58] = {.index = 125, .length = 4},
  [59] = {.index = 129, .length = 5},
  [60] = {.index = 134, .length = 4},
  [61] = {.index = 138, .length = 2},
  [62] = {.index = 140, .length = 1},
  [63] = {.index = 141, .length = 1},
  [64] = {.index = 142, .length = 1},
  [65] = {.index = 143, .length = 2},
  [66] = {.index = 145, .length = 2},
  [67] = {.index = 147, .length = 2},
  [68] = {.index = 149, .length = 2},
  [69] = {.index = 151, .length = 1},
  [70] = {.index = 152, .length = 2},
  [71] = {.index = 154, .length = 1},
  [72] = {.index = 155, .length = 2},
  [73] = {.index = 157, .length = 5},
  [74] = {.index = 162, .length = 2},
  [75] = {.index = 164, .length = 3},
  [76] = {.index = 167, .length = 2},
  [77] = {.index = 169, .length = 2},
  [78] = {.index = 171, .length = 1},
  [79] = {.index = 172, .length = 3},
  [80] = {.index = 175, .length = 3},
  [81] = {.index = 178, .length = 2},
  [82] = {.index = 180, .length = 2},
  [83] = {.index = 182, .length = 2},
  [84] = {.index = 184, .length = 6},
  [85] = {.index = 190, .length = 2},
  [86] = {.index = 192, .length = 1},
  [87] = {.index = 193, .length = 3},
  [88] = {.index = 196, .length = 3},
  [89] = {.index = 199, .length = 3},
  [90] = {.index = 202, .length = 3},
  [91] = {.index = 205, .length = 4},
  [92] = {.index = 209, .length = 3},
  [93] = {.index = 212, .length = 4},
  [94] = {.index = 216, .length = 4},
  [95] = {.index = 220, .length = 4},
  [96] = {.index = 224, .length = 2},
  [97] = {.index = 226, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_name, 0},
  [2] =
    {field_body, 2},
    {field_name, 1},
  [4] =
    {field_name, 0, .inherited = true},
  [5] =
    {field_body, 0, .inherited = true},
  [6] =
    {field_name, 2},
  [7] =
    {field_name, 2},
    {field_scope, 0},
  [9] =
    {field_body, 3},
    {field_name, 1},
  [11] =
    {field_body, 3},
    {field_class, 2},
  [13] =
    {field_name, 1, .inherited = true},
  [14] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [17] =
    {field_body, 3},
    {field_name, 1},
    {field_superclass, 2},
  [20] =
    {field_body, 3},
    {field_interfaces, 2},
    {field_name, 1},
  [23] =
    {field_body, 3},
    {field_name, 2},
  [25] =
    {field_body, 1},
  [26] =
    {field_first, 0},
    {field_second, 1, .inherited = true},
  [28] =
    {field_body, 1},
    {field_parameters, 0},
  [30] =
    {field_body, 4},
    {field_name, 1},
  [32] =
    {field_body, 4},
    {field_class, 3},
    {field_name, 1},
  [35] =
    {field_body, 4},
    {field_class, 3},
    {field_type_parameters, 1},
  [38] =
    {field_name, 0},
    {field_parameters, 1},
  [40] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [44] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [48] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_superclass, 2},
  [52] =
    {field_body, 4},
    {field_name, 2},
  [54] =
    {field_body, 4},
    {field_class, 3},
  [56] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [59] =
    {field_body, 4},
    {field_name, 2},
    {field_superclass, 3},
  [62] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 2},
  [65] =
    {field_body, 2},
    {field_condition, 1},
  [67] =
    {field_body, 2},
  [68] =
    {field_second, 1},
  [69] =
    {field_second, 0, .inherited = true},
    {field_second, 1, .inherited = true},
  [71] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [74] =
    {field_name, 0, .inherited = true},
    {field_value, 2},
  [76] =
    {field_body, 5},
    {field_name, 1},
  [78] =
    {field_body, 5},
    {field_class, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [82] =
    {field_name, 3},
  [83] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [88] =
    {field_body, 5},
    {field_name, 2},
  [90] =
    {field_body, 5},
    {field_class, 4},
    {field_name, 2},
  [93] =
    {field_body, 5},
    {field_class, 4},
    {field_type_parameters, 2},
  [96] =
    {field_body, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [100] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [104] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_superclass, 3},
  [108] =
    {field_key, 0},
    {field_value, 2},
  [110] =
    {field_body, 3},
  [111] =
    {field_condition, 0},
  [112] =
    {field_condition, 1, .inherited = true},
    {field_init, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_update, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [117] =
    {field_init, 0},
  [118] =
    {field_update, 1},
  [119] =
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
    {field_parameters, 3},
  [123] =
    {field_body, 6},
    {field_name, 2},
  [125] =
    {field_body, 6},
    {field_class, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [129] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [134] =
    {field_body, 2},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [138] =
    {field_body, 1},
    {field_condition, 3},
  [140] =
    {field_consequence, 4},
  [141] =
    {field_value, 2},
  [142] =
    {field_init, 1},
  [143] =
    {field_condition, 0},
    {field_update, 2},
  [145] =
    {field_init, 0, .inherited = true},
    {field_init, 1, .inherited = true},
  [147] =
    {field_condition, 1},
    {field_init, 0},
  [149] =
    {field_init, 0},
    {field_update, 2},
  [151] =
    {field_condition, 1},
  [152] =
    {field_update, 1},
    {field_update, 2, .inherited = true},
  [154] =
    {field_update, 2},
  [155] =
    {field_alternative, 4},
    {field_consequence, 2},
  [157] =
    {field_body, 2},
    {field_body, 3},
    {field_body, 4},
    {field_body, 5},
    {field_condition, 1},
  [162] =
    {field_condition, 2},
    {field_init, 0},
  [164] =
    {field_condition, 0},
    {field_update, 2},
    {field_update, 3, .inherited = true},
  [167] =
    {field_init, 0},
    {field_update, 3},
  [169] =
    {field_init, 0},
    {field_init, 1, .inherited = true},
  [171] =
    {field_value, 3},
  [172] =
    {field_condition, 1},
    {field_init, 0},
    {field_update, 3},
  [175] =
    {field_init, 0},
    {field_update, 2},
    {field_update, 3, .inherited = true},
  [178] =
    {field_condition, 1},
    {field_update, 3},
  [180] =
    {field_update, 0, .inherited = true},
    {field_update, 1, .inherited = true},
  [182] =
    {field_update, 2},
    {field_update, 3, .inherited = true},
  [184] =
    {field_body, 2},
    {field_body, 3},
    {field_body, 4},
    {field_body, 5},
    {field_body, 6},
    {field_condition, 1},
  [190] =
    {field_alternative, 6},
    {field_consequence, 4},
  [192] =
    {field_consequence, 6},
  [193] =
    {field_condition, 2},
    {field_init, 0},
    {field_update, 4},
  [196] =
    {field_init, 0},
    {field_update, 3},
    {field_update, 4, .inherited = true},
  [199] =
    {field_condition, 3},
    {field_init, 0},
    {field_init, 1, .inherited = true},
  [202] =
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 4},
  [205] =
    {field_condition, 1},
    {field_init, 0},
    {field_update, 3},
    {field_update, 4, .inherited = true},
  [209] =
    {field_condition, 1},
    {field_update, 3},
    {field_update, 4, .inherited = true},
  [212] =
    {field_condition, 2},
    {field_init, 0},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [216] =
    {field_condition, 3},
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 5},
  [220] =
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [224] =
    {field_alternative, 8},
    {field_consequence, 6},
  [226] =
    {field_condition, 3},
    {field_init, 0},
    {field_init, 1, .inherited = true},
    {field_update, 5},
    {field_update, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [4] = {
    [0] = sym_identifier,
  },
  [7] = {
    [1] = alias_sym_type_identifier,
  },
  [10] = {
    [1] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__get, 2,
    sym__get,
    sym_identifier,
  sym__set, 2,
    sym__set,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 14,
  [16] = 16,
  [17] = 17,
  [18] = 14,
  [19] = 19,
  [20] = 14,
  [21] = 14,
  [22] = 22,
  [23] = 16,
  [24] = 16,
  [25] = 16,
  [26] = 26,
  [27] = 16,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 29,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 33,
  [37] = 37,
  [38] = 35,
  [39] = 30,
  [40] = 32,
  [41] = 28,
  [42] = 34,
  [43] = 43,
  [44] = 43,
  [45] = 45,
  [46] = 46,
  [47] = 46,
  [48] = 48,
  [49] = 49,
  [50] = 49,
  [51] = 51,
  [52] = 52,
  [53] = 51,
  [54] = 52,
  [55] = 51,
  [56] = 52,
  [57] = 57,
  [58] = 57,
  [59] = 57,
  [60] = 57,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 66,
  [68] = 66,
  [69] = 66,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 72,
  [75] = 73,
  [76] = 73,
  [77] = 72,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 78,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 86,
  [92] = 85,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 95,
  [101] = 94,
  [102] = 102,
  [103] = 82,
  [104] = 104,
  [105] = 80,
  [106] = 78,
  [107] = 82,
  [108] = 108,
  [109] = 102,
  [110] = 102,
  [111] = 83,
  [112] = 84,
  [113] = 85,
  [114] = 86,
  [115] = 104,
  [116] = 80,
  [117] = 94,
  [118] = 118,
  [119] = 104,
  [120] = 93,
  [121] = 97,
  [122] = 98,
  [123] = 86,
  [124] = 124,
  [125] = 85,
  [126] = 126,
  [127] = 97,
  [128] = 97,
  [129] = 98,
  [130] = 102,
  [131] = 98,
  [132] = 93,
  [133] = 95,
  [134] = 95,
  [135] = 93,
  [136] = 104,
  [137] = 137,
  [138] = 138,
  [139] = 94,
  [140] = 80,
  [141] = 83,
  [142] = 78,
  [143] = 82,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 83,
  [148] = 84,
  [149] = 84,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 161,
  [163] = 161,
  [164] = 161,
  [165] = 161,
  [166] = 161,
  [167] = 161,
  [168] = 161,
  [169] = 161,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 177,
  [179] = 179,
  [180] = 177,
  [181] = 181,
  [182] = 177,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 201,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 207,
  [211] = 202,
  [212] = 202,
  [213] = 213,
  [214] = 205,
  [215] = 202,
  [216] = 202,
  [217] = 202,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 202,
  [222] = 222,
  [223] = 223,
  [224] = 206,
  [225] = 225,
  [226] = 202,
  [227] = 202,
  [228] = 228,
  [229] = 202,
  [230] = 207,
  [231] = 231,
  [232] = 202,
  [233] = 205,
  [234] = 234,
  [235] = 235,
  [236] = 220,
  [237] = 201,
  [238] = 213,
  [239] = 239,
  [240] = 208,
  [241] = 203,
  [242] = 242,
  [243] = 243,
  [244] = 202,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 205,
  [251] = 207,
  [252] = 252,
  [253] = 253,
  [254] = 208,
  [255] = 202,
  [256] = 256,
  [257] = 213,
  [258] = 213,
  [259] = 208,
  [260] = 260,
  [261] = 239,
  [262] = 262,
  [263] = 263,
  [264] = 239,
  [265] = 203,
  [266] = 266,
  [267] = 203,
  [268] = 201,
  [269] = 205,
  [270] = 207,
  [271] = 239,
  [272] = 272,
  [273] = 239,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 274,
  [278] = 276,
  [279] = 276,
  [280] = 274,
  [281] = 281,
  [282] = 282,
  [283] = 276,
  [284] = 275,
  [285] = 274,
  [286] = 281,
  [287] = 274,
  [288] = 282,
  [289] = 276,
  [290] = 282,
  [291] = 281,
  [292] = 274,
  [293] = 275,
  [294] = 276,
  [295] = 281,
  [296] = 275,
  [297] = 274,
  [298] = 275,
  [299] = 274,
  [300] = 281,
  [301] = 282,
  [302] = 282,
  [303] = 282,
  [304] = 281,
  [305] = 282,
  [306] = 282,
  [307] = 282,
  [308] = 274,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 312,
  [316] = 316,
  [317] = 317,
  [318] = 314,
  [319] = 319,
  [320] = 317,
  [321] = 321,
  [322] = 322,
  [323] = 313,
  [324] = 309,
  [325] = 311,
  [326] = 316,
  [327] = 319,
  [328] = 321,
  [329] = 317,
  [330] = 309,
  [331] = 313,
  [332] = 322,
  [333] = 311,
  [334] = 309,
  [335] = 321,
  [336] = 322,
  [337] = 313,
  [338] = 311,
  [339] = 319,
  [340] = 311,
  [341] = 314,
  [342] = 316,
  [343] = 319,
  [344] = 313,
  [345] = 345,
  [346] = 312,
  [347] = 316,
  [348] = 314,
  [349] = 317,
  [350] = 316,
  [351] = 317,
  [352] = 322,
  [353] = 353,
  [354] = 309,
  [355] = 321,
  [356] = 319,
  [357] = 314,
  [358] = 312,
  [359] = 314,
  [360] = 316,
  [361] = 321,
  [362] = 310,
  [363] = 317,
  [364] = 312,
  [365] = 322,
  [366] = 309,
  [367] = 319,
  [368] = 321,
  [369] = 322,
  [370] = 353,
  [371] = 311,
  [372] = 313,
  [373] = 312,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 378,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 386,
  [388] = 388,
  [389] = 389,
  [390] = 385,
  [391] = 391,
  [392] = 386,
  [393] = 386,
  [394] = 394,
  [395] = 385,
  [396] = 396,
  [397] = 385,
  [398] = 398,
  [399] = 399,
  [400] = 399,
  [401] = 399,
  [402] = 402,
  [403] = 403,
  [404] = 399,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 411,
  [414] = 414,
  [415] = 408,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 417,
  [422] = 422,
  [423] = 423,
  [424] = 420,
  [425] = 420,
  [426] = 419,
  [427] = 420,
  [428] = 417,
  [429] = 419,
  [430] = 420,
  [431] = 417,
  [432] = 417,
  [433] = 419,
  [434] = 419,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 456,
  [458] = 456,
  [459] = 456,
  [460] = 456,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 455,
  [467] = 453,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 444,
  [486] = 486,
  [487] = 472,
  [488] = 488,
  [489] = 489,
  [490] = 471,
  [491] = 443,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 481,
  [509] = 483,
  [510] = 481,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 513,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 521,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 495,
  [554] = 503,
  [555] = 501,
  [556] = 556,
  [557] = 504,
  [558] = 505,
  [559] = 507,
  [560] = 560,
  [561] = 499,
  [562] = 500,
  [563] = 563,
  [564] = 498,
  [565] = 565,
  [566] = 496,
  [567] = 567,
  [568] = 568,
  [569] = 502,
  [570] = 570,
  [571] = 571,
  [572] = 506,
  [573] = 497,
  [574] = 494,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 575,
  [579] = 579,
  [580] = 580,
  [581] = 552,
  [582] = 582,
  [583] = 583,
  [584] = 563,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 565,
  [592] = 473,
  [593] = 593,
  [594] = 594,
  [595] = 474,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 567,
  [603] = 603,
  [604] = 521,
  [605] = 521,
  [606] = 606,
  [607] = 552,
  [608] = 608,
  [609] = 474,
  [610] = 473,
  [611] = 575,
  [612] = 565,
  [613] = 613,
  [614] = 563,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 568,
  [621] = 576,
  [622] = 567,
  [623] = 570,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 618,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 582,
  [638] = 563,
  [639] = 587,
  [640] = 521,
  [641] = 567,
  [642] = 642,
  [643] = 643,
  [644] = 594,
  [645] = 642,
  [646] = 565,
  [647] = 585,
  [648] = 648,
  [649] = 552,
  [650] = 579,
  [651] = 575,
  [652] = 580,
  [653] = 583,
  [654] = 643,
  [655] = 655,
  [656] = 618,
  [657] = 600,
  [658] = 521,
  [659] = 648,
  [660] = 481,
  [661] = 567,
  [662] = 568,
  [663] = 663,
  [664] = 664,
  [665] = 565,
  [666] = 563,
  [667] = 667,
  [668] = 648,
  [669] = 669,
  [670] = 669,
  [671] = 575,
  [672] = 664,
  [673] = 576,
  [674] = 648,
  [675] = 570,
  [676] = 552,
  [677] = 677,
  [678] = 521,
  [679] = 664,
  [680] = 680,
  [681] = 642,
  [682] = 664,
  [683] = 503,
  [684] = 648,
  [685] = 685,
  [686] = 502,
  [687] = 687,
  [688] = 500,
  [689] = 498,
  [690] = 648,
  [691] = 643,
  [692] = 494,
  [693] = 693,
  [694] = 495,
  [695] = 504,
  [696] = 696,
  [697] = 506,
  [698] = 505,
  [699] = 643,
  [700] = 507,
  [701] = 648,
  [702] = 702,
  [703] = 648,
  [704] = 501,
  [705] = 664,
  [706] = 669,
  [707] = 669,
  [708] = 664,
  [709] = 709,
  [710] = 663,
  [711] = 664,
  [712] = 664,
  [713] = 502,
  [714] = 506,
  [715] = 495,
  [716] = 648,
  [717] = 643,
  [718] = 505,
  [719] = 648,
  [720] = 494,
  [721] = 501,
  [722] = 481,
  [723] = 504,
  [724] = 503,
  [725] = 500,
  [726] = 498,
  [727] = 507,
  [728] = 643,
  [729] = 627,
  [730] = 635,
  [731] = 625,
  [732] = 608,
  [733] = 628,
  [734] = 615,
  [735] = 616,
  [736] = 626,
  [737] = 617,
  [738] = 631,
  [739] = 619,
  [740] = 613,
  [741] = 664,
  [742] = 669,
  [743] = 636,
  [744] = 663,
  [745] = 632,
  [746] = 633,
  [747] = 624,
  [748] = 664,
  [749] = 669,
  [750] = 634,
  [751] = 751,
  [752] = 752,
  [753] = 495,
  [754] = 503,
  [755] = 506,
  [756] = 501,
  [757] = 503,
  [758] = 758,
  [759] = 455,
  [760] = 502,
  [761] = 498,
  [762] = 762,
  [763] = 494,
  [764] = 764,
  [765] = 500,
  [766] = 766,
  [767] = 505,
  [768] = 500,
  [769] = 505,
  [770] = 507,
  [771] = 504,
  [772] = 502,
  [773] = 501,
  [774] = 774,
  [775] = 498,
  [776] = 507,
  [777] = 777,
  [778] = 494,
  [779] = 506,
  [780] = 495,
  [781] = 453,
  [782] = 504,
  [783] = 783,
  [784] = 784,
  [785] = 702,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 693,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 635,
  [795] = 795,
  [796] = 625,
  [797] = 797,
  [798] = 628,
  [799] = 627,
  [800] = 800,
  [801] = 801,
  [802] = 615,
  [803] = 631,
  [804] = 616,
  [805] = 805,
  [806] = 617,
  [807] = 619,
  [808] = 624,
  [809] = 632,
  [810] = 634,
  [811] = 613,
  [812] = 608,
  [813] = 636,
  [814] = 626,
  [815] = 633,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 453,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 455,
  [831] = 831,
  [832] = 521,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 552,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 752,
  [844] = 844,
  [845] = 845,
  [846] = 774,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 575,
  [851] = 777,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 567,
  [859] = 570,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 758,
  [868] = 868,
  [869] = 869,
  [870] = 571,
  [871] = 568,
  [872] = 872,
  [873] = 576,
  [874] = 496,
  [875] = 565,
  [876] = 563,
  [877] = 877,
  [878] = 766,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 882,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 521,
  [896] = 896,
  [897] = 897,
  [898] = 898,
  [899] = 899,
  [900] = 900,
  [901] = 901,
  [902] = 787,
  [903] = 903,
  [904] = 576,
  [905] = 905,
  [906] = 552,
  [907] = 567,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 911,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 600,
  [919] = 919,
  [920] = 568,
  [921] = 921,
  [922] = 570,
  [923] = 443,
  [924] = 924,
  [925] = 925,
  [926] = 926,
  [927] = 927,
  [928] = 789,
  [929] = 801,
  [930] = 791,
  [931] = 931,
  [932] = 521,
  [933] = 797,
  [934] = 934,
  [935] = 935,
  [936] = 795,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 941,
  [942] = 942,
  [943] = 585,
  [944] = 944,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 953,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 784,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 483,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 563,
  [971] = 565,
  [972] = 793,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 444,
  [978] = 805,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 497,
  [984] = 594,
  [985] = 985,
  [986] = 986,
  [987] = 792,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 991,
  [992] = 583,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 499,
  [998] = 575,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 521,
  [1005] = 833,
  [1006] = 821,
  [1007] = 819,
  [1008] = 835,
  [1009] = 576,
  [1010] = 834,
  [1011] = 828,
  [1012] = 819,
  [1013] = 817,
  [1014] = 827,
  [1015] = 816,
  [1016] = 824,
  [1017] = 829,
  [1018] = 568,
  [1019] = 820,
  [1020] = 570,
  [1021] = 822,
  [1022] = 818,
  [1023] = 838,
  [1024] = 853,
  [1025] = 886,
  [1026] = 897,
  [1027] = 576,
  [1028] = 568,
  [1029] = 889,
  [1030] = 570,
  [1031] = 881,
  [1032] = 898,
  [1033] = 887,
  [1034] = 552,
  [1035] = 857,
  [1036] = 567,
  [1037] = 888,
  [1038] = 842,
  [1039] = 880,
  [1040] = 892,
  [1041] = 865,
  [1042] = 891,
  [1043] = 883,
  [1044] = 521,
  [1045] = 849,
  [1046] = 852,
  [1047] = 899,
  [1048] = 879,
  [1049] = 855,
  [1050] = 1050,
  [1051] = 848,
  [1052] = 563,
  [1053] = 882,
  [1054] = 884,
  [1055] = 872,
  [1056] = 862,
  [1057] = 565,
  [1058] = 893,
  [1059] = 1059,
  [1060] = 521,
  [1061] = 844,
  [1062] = 885,
  [1063] = 840,
  [1064] = 1064,
  [1065] = 863,
  [1066] = 845,
  [1067] = 847,
  [1068] = 575,
  [1069] = 471,
  [1070] = 866,
  [1071] = 868,
  [1072] = 839,
  [1073] = 894,
  [1074] = 472,
  [1075] = 877,
  [1076] = 896,
  [1077] = 1077,
  [1078] = 869,
  [1079] = 854,
  [1080] = 861,
  [1081] = 860,
  [1082] = 856,
  [1083] = 864,
  [1084] = 841,
  [1085] = 966,
  [1086] = 521,
  [1087] = 1003,
  [1088] = 579,
  [1089] = 979,
  [1090] = 552,
  [1091] = 935,
  [1092] = 594,
  [1093] = 991,
  [1094] = 942,
  [1095] = 944,
  [1096] = 567,
  [1097] = 1000,
  [1098] = 993,
  [1099] = 570,
  [1100] = 568,
  [1101] = 568,
  [1102] = 582,
  [1103] = 946,
  [1104] = 964,
  [1105] = 995,
  [1106] = 950,
  [1107] = 570,
  [1108] = 594,
  [1109] = 583,
  [1110] = 575,
  [1111] = 939,
  [1112] = 563,
  [1113] = 565,
  [1114] = 994,
  [1115] = 989,
  [1116] = 576,
  [1117] = 996,
  [1118] = 956,
  [1119] = 974,
  [1120] = 1001,
  [1121] = 787,
  [1122] = 565,
  [1123] = 980,
  [1124] = 563,
  [1125] = 915,
  [1126] = 587,
  [1127] = 909,
  [1128] = 571,
  [1129] = 938,
  [1130] = 940,
  [1131] = 951,
  [1132] = 952,
  [1133] = 914,
  [1134] = 600,
  [1135] = 962,
  [1136] = 585,
  [1137] = 959,
  [1138] = 567,
  [1139] = 941,
  [1140] = 576,
  [1141] = 580,
  [1142] = 921,
  [1143] = 957,
  [1144] = 911,
  [1145] = 552,
  [1146] = 990,
  [1147] = 793,
  [1148] = 973,
  [1149] = 903,
  [1150] = 948,
  [1151] = 443,
  [1152] = 585,
  [1153] = 968,
  [1154] = 969,
  [1155] = 575,
  [1156] = 955,
  [1157] = 954,
  [1158] = 583,
  [1159] = 905,
  [1160] = 594,
  [1161] = 945,
  [1162] = 927,
  [1163] = 999,
  [1164] = 925,
  [1165] = 900,
  [1166] = 960,
  [1167] = 953,
  [1168] = 976,
  [1169] = 988,
  [1170] = 947,
  [1171] = 975,
  [1172] = 949,
  [1173] = 934,
  [1174] = 916,
  [1175] = 917,
  [1176] = 1002,
  [1177] = 791,
  [1178] = 600,
  [1179] = 958,
  [1180] = 967,
  [1181] = 937,
  [1182] = 963,
  [1183] = 901,
  [1184] = 913,
  [1185] = 600,
  [1186] = 908,
  [1187] = 924,
  [1188] = 986,
  [1189] = 912,
  [1190] = 926,
  [1191] = 946,
  [1192] = 981,
  [1193] = 982,
  [1194] = 985,
  [1195] = 444,
  [1196] = 565,
  [1197] = 563,
  [1198] = 472,
  [1199] = 471,
  [1200] = 883,
  [1201] = 862,
  [1202] = 869,
  [1203] = 1203,
  [1204] = 453,
  [1205] = 568,
  [1206] = 1206,
  [1207] = 521,
  [1208] = 576,
  [1209] = 570,
  [1210] = 567,
  [1211] = 552,
  [1212] = 849,
  [1213] = 852,
  [1214] = 860,
  [1215] = 455,
  [1216] = 575,
  [1217] = 967,
  [1218] = 444,
  [1219] = 976,
  [1220] = 1000,
  [1221] = 948,
  [1222] = 903,
  [1223] = 973,
  [1224] = 911,
  [1225] = 921,
  [1226] = 941,
  [1227] = 575,
  [1228] = 585,
  [1229] = 565,
  [1230] = 563,
  [1231] = 567,
  [1232] = 552,
  [1233] = 1233,
  [1234] = 881,
  [1235] = 793,
  [1236] = 951,
  [1237] = 940,
  [1238] = 1238,
  [1239] = 938,
  [1240] = 600,
  [1241] = 1241,
  [1242] = 865,
  [1243] = 571,
  [1244] = 443,
  [1245] = 1245,
  [1246] = 909,
  [1247] = 915,
  [1248] = 966,
  [1249] = 1249,
  [1250] = 974,
  [1251] = 791,
  [1252] = 594,
  [1253] = 583,
  [1254] = 1254,
  [1255] = 995,
  [1256] = 964,
  [1257] = 855,
  [1258] = 570,
  [1259] = 568,
  [1260] = 787,
  [1261] = 979,
  [1262] = 1003,
  [1263] = 963,
  [1264] = 901,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 908,
  [1268] = 924,
  [1269] = 576,
  [1270] = 937,
  [1271] = 958,
  [1272] = 1002,
  [1273] = 917,
  [1274] = 916,
  [1275] = 900,
  [1276] = 934,
  [1277] = 947,
  [1278] = 962,
  [1279] = 989,
  [1280] = 953,
  [1281] = 1001,
  [1282] = 988,
  [1283] = 1283,
  [1284] = 752,
  [1285] = 967,
  [1286] = 960,
  [1287] = 955,
  [1288] = 986,
  [1289] = 925,
  [1290] = 985,
  [1291] = 927,
  [1292] = 945,
  [1293] = 777,
  [1294] = 982,
  [1295] = 981,
  [1296] = 952,
  [1297] = 1297,
  [1298] = 954,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 993,
  [1302] = 991,
  [1303] = 994,
  [1304] = 378,
  [1305] = 795,
  [1306] = 758,
  [1307] = 975,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 766,
  [1311] = 797,
  [1312] = 774,
  [1313] = 926,
  [1314] = 1314,
  [1315] = 969,
  [1316] = 968,
  [1317] = 942,
  [1318] = 944,
  [1319] = 801,
  [1320] = 789,
  [1321] = 793,
  [1322] = 1322,
  [1323] = 787,
  [1324] = 1324,
  [1325] = 805,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1324,
  [1329] = 787,
  [1330] = 784,
  [1331] = 752,
  [1332] = 791,
  [1333] = 791,
  [1334] = 792,
  [1335] = 1322,
  [1336] = 777,
  [1337] = 1322,
  [1338] = 1322,
  [1339] = 1322,
  [1340] = 1322,
  [1341] = 828,
  [1342] = 1322,
  [1343] = 1322,
  [1344] = 1322,
  [1345] = 1322,
  [1346] = 1322,
  [1347] = 1322,
  [1348] = 1324,
  [1349] = 817,
  [1350] = 946,
  [1351] = 789,
  [1352] = 801,
  [1353] = 797,
  [1354] = 795,
  [1355] = 471,
  [1356] = 879,
  [1357] = 1357,
  [1358] = 816,
  [1359] = 1357,
  [1360] = 863,
  [1361] = 1361,
  [1362] = 774,
  [1363] = 766,
  [1364] = 882,
  [1365] = 472,
  [1366] = 758,
  [1367] = 844,
  [1368] = 821,
  [1369] = 827,
  [1370] = 1370,
  [1371] = 1206,
  [1372] = 1372,
  [1373] = 926,
  [1374] = 594,
  [1375] = 818,
  [1376] = 600,
  [1377] = 824,
  [1378] = 942,
  [1379] = 944,
  [1380] = 975,
  [1381] = 968,
  [1382] = 969,
  [1383] = 822,
  [1384] = 820,
  [1385] = 1357,
  [1386] = 833,
  [1387] = 1357,
  [1388] = 1388,
  [1389] = 991,
  [1390] = 993,
  [1391] = 994,
  [1392] = 835,
  [1393] = 834,
  [1394] = 1357,
  [1395] = 1395,
  [1396] = 855,
  [1397] = 1397,
  [1398] = 884,
  [1399] = 1399,
  [1400] = 881,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 845,
  [1404] = 1399,
  [1405] = 839,
  [1406] = 847,
  [1407] = 865,
  [1408] = 840,
  [1409] = 841,
  [1410] = 899,
  [1411] = 848,
  [1412] = 1412,
  [1413] = 887,
  [1414] = 853,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 886,
  [1418] = 792,
  [1419] = 854,
  [1420] = 1420,
  [1421] = 885,
  [1422] = 777,
  [1423] = 888,
  [1424] = 891,
  [1425] = 1425,
  [1426] = 752,
  [1427] = 892,
  [1428] = 893,
  [1429] = 856,
  [1430] = 897,
  [1431] = 784,
  [1432] = 898,
  [1433] = 861,
  [1434] = 1434,
  [1435] = 864,
  [1436] = 889,
  [1437] = 877,
  [1438] = 828,
  [1439] = 894,
  [1440] = 896,
  [1441] = 872,
  [1442] = 842,
  [1443] = 805,
  [1444] = 1395,
  [1445] = 857,
  [1446] = 866,
  [1447] = 838,
  [1448] = 880,
  [1449] = 868,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 946,
  [1453] = 956,
  [1454] = 1308,
  [1455] = 758,
  [1456] = 834,
  [1457] = 835,
  [1458] = 882,
  [1459] = 821,
  [1460] = 766,
  [1461] = 833,
  [1462] = 774,
  [1463] = 752,
  [1464] = 820,
  [1465] = 822,
  [1466] = 824,
  [1467] = 789,
  [1468] = 801,
  [1469] = 957,
  [1470] = 473,
  [1471] = 797,
  [1472] = 795,
  [1473] = 1314,
  [1474] = 1474,
  [1475] = 474,
  [1476] = 816,
  [1477] = 996,
  [1478] = 483,
  [1479] = 1309,
  [1480] = 994,
  [1481] = 993,
  [1482] = 926,
  [1483] = 991,
  [1484] = 950,
  [1485] = 949,
  [1486] = 879,
  [1487] = 969,
  [1488] = 968,
  [1489] = 863,
  [1490] = 844,
  [1491] = 817,
  [1492] = 818,
  [1493] = 935,
  [1494] = 827,
  [1495] = 944,
  [1496] = 942,
  [1497] = 905,
  [1498] = 777,
  [1499] = 975,
  [1500] = 959,
  [1501] = 913,
  [1502] = 912,
  [1503] = 866,
  [1504] = 882,
  [1505] = 848,
  [1506] = 853,
  [1507] = 847,
  [1508] = 864,
  [1509] = 1509,
  [1510] = 891,
  [1511] = 805,
  [1512] = 856,
  [1513] = 839,
  [1514] = 840,
  [1515] = 879,
  [1516] = 841,
  [1517] = 792,
  [1518] = 888,
  [1519] = 889,
  [1520] = 899,
  [1521] = 845,
  [1522] = 1522,
  [1523] = 854,
  [1524] = 880,
  [1525] = 887,
  [1526] = 886,
  [1527] = 885,
  [1528] = 894,
  [1529] = 884,
  [1530] = 805,
  [1531] = 896,
  [1532] = 892,
  [1533] = 857,
  [1534] = 877,
  [1535] = 792,
  [1536] = 828,
  [1537] = 1509,
  [1538] = 1538,
  [1539] = 872,
  [1540] = 893,
  [1541] = 897,
  [1542] = 1542,
  [1543] = 898,
  [1544] = 861,
  [1545] = 842,
  [1546] = 784,
  [1547] = 881,
  [1548] = 855,
  [1549] = 838,
  [1550] = 865,
  [1551] = 868,
  [1552] = 1542,
  [1553] = 784,
  [1554] = 835,
  [1555] = 1555,
  [1556] = 863,
  [1557] = 795,
  [1558] = 1558,
  [1559] = 789,
  [1560] = 957,
  [1561] = 820,
  [1562] = 822,
  [1563] = 956,
  [1564] = 1564,
  [1565] = 774,
  [1566] = 844,
  [1567] = 1567,
  [1568] = 822,
  [1569] = 1569,
  [1570] = 834,
  [1571] = 1361,
  [1572] = 1572,
  [1573] = 905,
  [1574] = 835,
  [1575] = 824,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 949,
  [1579] = 1579,
  [1580] = 824,
  [1581] = 1581,
  [1582] = 833,
  [1583] = 959,
  [1584] = 1584,
  [1585] = 1370,
  [1586] = 766,
  [1587] = 797,
  [1588] = 844,
  [1589] = 818,
  [1590] = 816,
  [1591] = 935,
  [1592] = 834,
  [1593] = 499,
  [1594] = 912,
  [1595] = 913,
  [1596] = 950,
  [1597] = 497,
  [1598] = 1598,
  [1599] = 821,
  [1600] = 817,
  [1601] = 882,
  [1602] = 879,
  [1603] = 827,
  [1604] = 1604,
  [1605] = 758,
  [1606] = 833,
  [1607] = 801,
  [1608] = 820,
  [1609] = 996,
  [1610] = 445,
  [1611] = 1372,
  [1612] = 842,
  [1613] = 1613,
  [1614] = 828,
  [1615] = 868,
  [1616] = 818,
  [1617] = 841,
  [1618] = 892,
  [1619] = 866,
  [1620] = 893,
  [1621] = 896,
  [1622] = 865,
  [1623] = 877,
  [1624] = 864,
  [1625] = 863,
  [1626] = 840,
  [1627] = 857,
  [1628] = 872,
  [1629] = 861,
  [1630] = 899,
  [1631] = 888,
  [1632] = 889,
  [1633] = 856,
  [1634] = 881,
  [1635] = 894,
  [1636] = 865,
  [1637] = 854,
  [1638] = 853,
  [1639] = 821,
  [1640] = 855,
  [1641] = 891,
  [1642] = 855,
  [1643] = 848,
  [1644] = 847,
  [1645] = 842,
  [1646] = 881,
  [1647] = 897,
  [1648] = 880,
  [1649] = 898,
  [1650] = 891,
  [1651] = 845,
  [1652] = 838,
  [1653] = 885,
  [1654] = 886,
  [1655] = 887,
  [1656] = 885,
  [1657] = 886,
  [1658] = 887,
  [1659] = 899,
  [1660] = 839,
  [1661] = 884,
  [1662] = 884,
  [1663] = 839,
  [1664] = 817,
  [1665] = 840,
  [1666] = 841,
  [1667] = 827,
  [1668] = 1668,
  [1669] = 956,
  [1670] = 861,
  [1671] = 1671,
  [1672] = 889,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 950,
  [1676] = 893,
  [1677] = 912,
  [1678] = 898,
  [1679] = 996,
  [1680] = 894,
  [1681] = 896,
  [1682] = 949,
  [1683] = 853,
  [1684] = 897,
  [1685] = 854,
  [1686] = 1686,
  [1687] = 877,
  [1688] = 1688,
  [1689] = 1686,
  [1690] = 1688,
  [1691] = 1688,
  [1692] = 838,
  [1693] = 1686,
  [1694] = 864,
  [1695] = 1673,
  [1696] = 935,
  [1697] = 856,
  [1698] = 1686,
  [1699] = 1686,
  [1700] = 848,
  [1701] = 1673,
  [1702] = 866,
  [1703] = 847,
  [1704] = 868,
  [1705] = 1688,
  [1706] = 845,
  [1707] = 1688,
  [1708] = 913,
  [1709] = 957,
  [1710] = 905,
  [1711] = 959,
  [1712] = 1686,
  [1713] = 1713,
  [1714] = 1673,
  [1715] = 1688,
  [1716] = 1673,
  [1717] = 1673,
  [1718] = 872,
  [1719] = 473,
  [1720] = 474,
  [1721] = 892,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1772,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 624,
  [1812] = 634,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1813,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 633,
  [1823] = 1820,
  [1824] = 1821,
  [1825] = 613,
  [1826] = 635,
  [1827] = 636,
  [1828] = 632,
  [1829] = 631,
  [1830] = 1820,
  [1831] = 628,
  [1832] = 625,
  [1833] = 1815,
  [1834] = 1834,
  [1835] = 1813,
  [1836] = 1815,
  [1837] = 1821,
  [1838] = 1838,
  [1839] = 1815,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1838,
  [1843] = 1834,
  [1844] = 1816,
  [1845] = 1841,
  [1846] = 1821,
  [1847] = 1841,
  [1848] = 1848,
  [1849] = 1820,
  [1850] = 615,
  [1851] = 1821,
  [1852] = 1820,
  [1853] = 616,
  [1854] = 627,
  [1855] = 1816,
  [1856] = 1815,
  [1857] = 1834,
  [1858] = 1813,
  [1859] = 1838,
  [1860] = 617,
  [1861] = 1813,
  [1862] = 1821,
  [1863] = 1815,
  [1864] = 1838,
  [1865] = 1816,
  [1866] = 1866,
  [1867] = 1834,
  [1868] = 619,
  [1869] = 1869,
  [1870] = 1841,
  [1871] = 1841,
  [1872] = 1816,
  [1873] = 1838,
  [1874] = 1834,
  [1875] = 1834,
  [1876] = 1813,
  [1877] = 1838,
  [1878] = 1841,
  [1879] = 608,
  [1880] = 1880,
  [1881] = 1820,
  [1882] = 1816,
  [1883] = 626,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1884,
  [1889] = 1889,
  [1890] = 1889,
  [1891] = 1889,
  [1892] = 1886,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 1889,
  [1896] = 1896,
  [1897] = 1886,
  [1898] = 1898,
  [1899] = 1884,
  [1900] = 1889,
  [1901] = 1901,
  [1902] = 1886,
  [1903] = 1886,
  [1904] = 1904,
  [1905] = 1905,
  [1906] = 1884,
  [1907] = 1884,
  [1908] = 1726,
  [1909] = 1909,
  [1910] = 1884,
  [1911] = 1911,
  [1912] = 1889,
  [1913] = 1886,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1916,
  [1918] = 1918,
  [1919] = 1919,
  [1920] = 1918,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1916,
  [1925] = 1918,
  [1926] = 1918,
  [1927] = 1916,
  [1928] = 1928,
  [1929] = 1918,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1933,
  [1934] = 1934,
  [1935] = 1935,
  [1936] = 1931,
  [1937] = 1937,
  [1938] = 1931,
  [1939] = 1931,
  [1940] = 1932,
  [1941] = 1937,
  [1942] = 1937,
  [1943] = 1931,
  [1944] = 1937,
  [1945] = 663,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 1931,
  [1949] = 1931,
  [1950] = 1950,
  [1951] = 1931,
  [1952] = 1932,
  [1953] = 1953,
  [1954] = 1954,
  [1955] = 1932,
  [1956] = 1932,
  [1957] = 1957,
  [1958] = 1937,
  [1959] = 1959,
  [1960] = 1931,
  [1961] = 1961,
  [1962] = 914,
  [1963] = 939,
  [1964] = 905,
  [1965] = 980,
  [1966] = 990,
  [1967] = 935,
  [1968] = 950,
  [1969] = 1969,
  [1970] = 999,
  [1971] = 1971,
  [1972] = 1972,
  [1973] = 626,
  [1974] = 608,
  [1975] = 634,
  [1976] = 1976,
  [1977] = 632,
  [1978] = 631,
  [1979] = 628,
  [1980] = 625,
  [1981] = 1981,
  [1982] = 613,
  [1983] = 1983,
  [1984] = 1984,
  [1985] = 816,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1988,
  [1989] = 1989,
  [1990] = 975,
  [1991] = 615,
  [1992] = 1992,
  [1993] = 1993,
  [1994] = 627,
  [1995] = 1995,
  [1996] = 616,
  [1997] = 635,
  [1998] = 617,
  [1999] = 619,
  [2000] = 1904,
  [2001] = 633,
  [2002] = 624,
  [2003] = 636,
  [2004] = 2004,
  [2005] = 2005,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2010,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 2010,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2034,
  [2035] = 2010,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 2032,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2010,
  [2043] = 2043,
  [2044] = 2010,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2047,
  [2048] = 2010,
  [2049] = 2049,
  [2050] = 2050,
  [2051] = 2051,
  [2052] = 2052,
  [2053] = 2010,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2060,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 2060,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2058,
  [2067] = 888,
  [2068] = 2068,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 2076,
  [2077] = 2064,
  [2078] = 2078,
  [2079] = 2074,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2064,
  [2087] = 2058,
  [2088] = 2088,
  [2089] = 2058,
  [2090] = 2064,
  [2091] = 2074,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 2094,
  [2095] = 819,
  [2096] = 2064,
  [2097] = 2058,
  [2098] = 2074,
  [2099] = 857,
  [2100] = 2100,
  [2101] = 829,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 1000,
  [2105] = 2105,
  [2106] = 901,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 600,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 963,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 900,
  [2121] = 594,
  [2122] = 953,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 986,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 985,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 982,
  [2134] = 981,
  [2135] = 819,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 829,
  [2141] = 777,
  [2142] = 829,
  [2143] = 2143,
  [2144] = 752,
  [2145] = 880,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2153,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2157,
  [2158] = 2158,
  [2159] = 2159,
  [2160] = 2153,
  [2161] = 758,
  [2162] = 2157,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2165,
  [2166] = 2153,
  [2167] = 828,
  [2168] = 2168,
  [2169] = 953,
  [2170] = 2157,
  [2171] = 2171,
  [2172] = 2165,
  [2173] = 2150,
  [2174] = 766,
  [2175] = 774,
  [2176] = 2176,
  [2177] = 2165,
  [2178] = 2153,
  [2179] = 2165,
  [2180] = 2165,
  [2181] = 2157,
  [2182] = 2150,
  [2183] = 2157,
  [2184] = 2150,
  [2185] = 2150,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2196,
  [2197] = 2197,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2201,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 959,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2192,
  [2211] = 2211,
  [2212] = 2191,
  [2213] = 2213,
  [2214] = 2211,
  [2215] = 2213,
  [2216] = 789,
  [2217] = 2217,
  [2218] = 2191,
  [2219] = 801,
  [2220] = 2192,
  [2221] = 2188,
  [2222] = 2209,
  [2223] = 2208,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2198,
  [2227] = 2196,
  [2228] = 2228,
  [2229] = 2209,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2192,
  [2233] = 2191,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2209,
  [2237] = 2237,
  [2238] = 2208,
  [2239] = 2196,
  [2240] = 2198,
  [2241] = 2208,
  [2242] = 2209,
  [2243] = 2213,
  [2244] = 2211,
  [2245] = 2192,
  [2246] = 2191,
  [2247] = 2247,
  [2248] = 2211,
  [2249] = 2213,
  [2250] = 2211,
  [2251] = 2198,
  [2252] = 2194,
  [2253] = 2196,
  [2254] = 2213,
  [2255] = 2198,
  [2256] = 2196,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 797,
  [2260] = 2260,
  [2261] = 2208,
  [2262] = 795,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2265,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2267,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2267,
  [2273] = 869,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2267,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2267,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2263,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2267,
  [2298] = 2263,
  [2299] = 2299,
  [2300] = 2295,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2301,
  [2305] = 2305,
  [2306] = 2294,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2263,
  [2314] = 2295,
  [2315] = 862,
  [2316] = 2263,
  [2317] = 2295,
  [2318] = 2294,
  [2319] = 2301,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2294,
  [2323] = 2323,
  [2324] = 2294,
  [2325] = 2325,
  [2326] = 2295,
  [2327] = 2327,
  [2328] = 2301,
  [2329] = 2329,
  [2330] = 2301,
  [2331] = 2331,
  [2332] = 921,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 952,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 964,
  [2339] = 2339,
  [2340] = 915,
  [2341] = 909,
  [2342] = 2339,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 916,
  [2346] = 917,
  [2347] = 2347,
  [2348] = 981,
  [2349] = 2349,
  [2350] = 982,
  [2351] = 985,
  [2352] = 2352,
  [2353] = 1002,
  [2354] = 2354,
  [2355] = 958,
  [2356] = 963,
  [2357] = 2357,
  [2358] = 2339,
  [2359] = 986,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 1001,
  [2364] = 989,
  [2365] = 951,
  [2366] = 937,
  [2367] = 979,
  [2368] = 2368,
  [2369] = 962,
  [2370] = 2370,
  [2371] = 900,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 585,
  [2375] = 2375,
  [2376] = 940,
  [2377] = 2343,
  [2378] = 2378,
  [2379] = 947,
  [2380] = 988,
  [2381] = 865,
  [2382] = 941,
  [2383] = 976,
  [2384] = 974,
  [2385] = 995,
  [2386] = 855,
  [2387] = 901,
  [2388] = 924,
  [2389] = 960,
  [2390] = 934,
  [2391] = 925,
  [2392] = 2392,
  [2393] = 908,
  [2394] = 881,
  [2395] = 2378,
  [2396] = 575,
  [2397] = 911,
  [2398] = 2398,
  [2399] = 1003,
  [2400] = 2372,
  [2401] = 583,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 973,
  [2405] = 903,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2362,
  [2409] = 552,
  [2410] = 2410,
  [2411] = 2344,
  [2412] = 948,
  [2413] = 927,
  [2414] = 567,
  [2415] = 945,
  [2416] = 1000,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 563,
  [2424] = 1796,
  [2425] = 2425,
  [2426] = 2339,
  [2427] = 966,
  [2428] = 954,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 938,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 955,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 565,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2441,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 2452,
  [2453] = 2453,
  [2454] = 2454,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2460,
  [2461] = 2461,
  [2462] = 2462,
  [2463] = 2463,
  [2464] = 2464,
  [2465] = 2465,
  [2466] = 2466,
  [2467] = 2453,
  [2468] = 2468,
  [2469] = 2461,
  [2470] = 2470,
  [2471] = 2442,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2473,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2450,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2450,
  [2487] = 2441,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2462,
  [2495] = 2495,
  [2496] = 2137,
  [2497] = 2362,
  [2498] = 2362,
  [2499] = 2499,
  [2500] = 2463,
  [2501] = 2450,
  [2502] = 2138,
  [2503] = 2503,
  [2504] = 2504,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2450,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 2516,
  [2517] = 2362,
  [2518] = 2499,
  [2519] = 2362,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 2524,
  [2525] = 2525,
  [2526] = 2526,
  [2527] = 2527,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 2362,
  [2532] = 2532,
  [2533] = 2499,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 2441,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2547,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2553,
  [2554] = 2554,
  [2555] = 2555,
  [2556] = 2556,
  [2557] = 2557,
  [2558] = 2453,
  [2559] = 2559,
  [2560] = 2560,
  [2561] = 2561,
  [2562] = 2562,
  [2563] = 2563,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2499,
  [2570] = 2362,
  [2571] = 2571,
  [2572] = 2572,
  [2573] = 2441,
  [2574] = 2574,
  [2575] = 2575,
  [2576] = 2576,
  [2577] = 2577,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 2580,
  [2581] = 2581,
  [2582] = 2582,
  [2583] = 2583,
  [2584] = 2584,
  [2585] = 2453,
  [2586] = 2586,
  [2587] = 2587,
  [2588] = 2588,
  [2589] = 2589,
  [2590] = 2590,
  [2591] = 2591,
  [2592] = 2592,
  [2593] = 2593,
  [2594] = 2594,
  [2595] = 2595,
  [2596] = 2596,
  [2597] = 2597,
  [2598] = 2598,
  [2599] = 2599,
  [2600] = 2600,
  [2601] = 2601,
  [2602] = 2602,
  [2603] = 2603,
  [2604] = 2604,
  [2605] = 2605,
  [2606] = 2606,
  [2607] = 2595,
  [2608] = 2596,
  [2609] = 2594,
  [2610] = 2610,
  [2611] = 2592,
  [2612] = 2612,
  [2613] = 2595,
  [2614] = 2596,
  [2615] = 2615,
  [2616] = 2616,
  [2617] = 2617,
  [2618] = 2618,
  [2619] = 2619,
  [2620] = 2620,
  [2621] = 2621,
  [2622] = 2622,
  [2623] = 2592,
  [2624] = 2624,
  [2625] = 2625,
  [2626] = 2594,
  [2627] = 2627,
  [2628] = 2628,
  [2629] = 2629,
  [2630] = 2630,
  [2631] = 2631,
  [2632] = 2632,
  [2633] = 2596,
  [2634] = 2634,
  [2635] = 2594,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2596,
  [2639] = 2639,
  [2640] = 2640,
  [2641] = 2641,
  [2642] = 2594,
  [2643] = 2643,
  [2644] = 2644,
  [2645] = 2645,
  [2646] = 2644,
  [2647] = 2647,
  [2648] = 2594,
  [2649] = 2596,
  [2650] = 2592,
  [2651] = 2651,
  [2652] = 2652,
  [2653] = 2653,
  [2654] = 2654,
  [2655] = 2655,
  [2656] = 2594,
  [2657] = 2592,
  [2658] = 2658,
  [2659] = 2659,
  [2660] = 2660,
  [2661] = 2661,
  [2662] = 2662,
  [2663] = 2661,
  [2664] = 2596,
  [2665] = 2665,
  [2666] = 2666,
  [2667] = 2667,
  [2668] = 2594,
  [2669] = 2595,
  [2670] = 2670,
  [2671] = 2289,
  [2672] = 2672,
  [2673] = 2673,
  [2674] = 2674,
  [2675] = 2311,
  [2676] = 2329,
  [2677] = 2677,
  [2678] = 2678,
  [2679] = 2679,
  [2680] = 2276,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2684,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 2688,
  [2689] = 2683,
  [2690] = 2690,
  [2691] = 2691,
  [2692] = 2685,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2695,
  [2696] = 2696,
  [2697] = 2683,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 2700,
  [2701] = 2701,
  [2702] = 2685,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 2705,
  [2706] = 2706,
  [2707] = 2707,
  [2708] = 2670,
  [2709] = 2683,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 2712,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2695,
  [2716] = 2716,
  [2717] = 2717,
  [2718] = 2718,
  [2719] = 2719,
  [2720] = 2720,
  [2721] = 2683,
  [2722] = 2722,
  [2723] = 2685,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 2303,
  [2727] = 2727,
  [2728] = 2695,
  [2729] = 2700,
  [2730] = 2701,
  [2731] = 2731,
  [2732] = 2685,
  [2733] = 2733,
  [2734] = 2734,
  [2735] = 2718,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2705,
  [2739] = 2739,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2706,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2701,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 2672,
  [2763] = 2763,
  [2764] = 2764,
  [2765] = 2765,
  [2766] = 2766,
  [2767] = 2767,
  [2768] = 2678,
  [2769] = 2769,
  [2770] = 2770,
  [2771] = 2771,
  [2772] = 2772,
  [2773] = 2773,
  [2774] = 2674,
  [2775] = 2775,
  [2776] = 2776,
  [2777] = 2777,
  [2778] = 2705,
  [2779] = 2779,
  [2780] = 2780,
  [2781] = 2781,
  [2782] = 2782,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2766,
  [2786] = 2786,
  [2787] = 2757,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2784,
  [2791] = 2791,
  [2792] = 2681,
  [2793] = 2793,
  [2794] = 2670,
  [2795] = 2782,
  [2796] = 2796,
  [2797] = 2797,
  [2798] = 2798,
  [2799] = 2799,
  [2800] = 2718,
  [2801] = 2801,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2672,
  [2805] = 2805,
  [2806] = 2806,
  [2807] = 2720,
  [2808] = 2808,
  [2809] = 2809,
  [2810] = 2706,
  [2811] = 2780,
  [2812] = 2695,
  [2813] = 2683,
  [2814] = 2814,
  [2815] = 2724,
  [2816] = 2725,
  [2817] = 2817,
  [2818] = 2769,
  [2819] = 2819,
  [2820] = 2820,
  [2821] = 2739,
  [2822] = 2822,
  [2823] = 2705,
  [2824] = 2824,
  [2825] = 2672,
  [2826] = 2699,
  [2827] = 2670,
  [2828] = 2786,
  [2829] = 2678,
  [2830] = 2817,
  [2831] = 2700,
  [2832] = 2701,
  [2833] = 2685,
  [2834] = 2834,
  [2835] = 2835,
  [2836] = 2836,
  [2837] = 2837,
  [2838] = 2838,
  [2839] = 2775,
  [2840] = 2302,
  [2841] = 2305,
  [2842] = 2685,
  [2843] = 2701,
  [2844] = 2718,
  [2845] = 2325,
  [2846] = 2809,
  [2847] = 2847,
  [2848] = 2848,
  [2849] = 2705,
  [2850] = 2724,
  [2851] = 2700,
  [2852] = 2817,
  [2853] = 2786,
  [2854] = 2854,
  [2855] = 2855,
  [2856] = 2725,
  [2857] = 2857,
  [2858] = 2858,
  [2859] = 2699,
  [2860] = 2860,
  [2861] = 2861,
  [2862] = 2806,
  [2863] = 2863,
  [2864] = 2814,
  [2865] = 2739,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2869,
  [2870] = 2706,
  [2871] = 2805,
  [2872] = 2672,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2678,
  [2876] = 2814,
  [2877] = 2877,
  [2878] = 2670,
  [2879] = 2879,
  [2880] = 2880,
  [2881] = 2769,
  [2882] = 2674,
  [2883] = 2678,
  [2884] = 2331,
  [2885] = 2683,
  [2886] = 2886,
  [2887] = 2695,
  [2888] = 2775,
  [2889] = 2889,
  [2890] = 2890,
  [2891] = 2809,
  [2892] = 2780,
  [2893] = 2806,
  [2894] = 2805,
  [2895] = 2895,
  [2896] = 2782,
  [2897] = 2784,
  [2898] = 2898,
  [2899] = 2766,
  [2900] = 2706,
  [2901] = 2803,
  [2902] = 2802,
  [2903] = 2757,
  [2904] = 2681,
  [2905] = 2718,
  [2906] = 2906,
  [2907] = 2724,
  [2908] = 2908,
  [2909] = 2802,
  [2910] = 2910,
  [2911] = 2803,
  [2912] = 2725,
  [2913] = 2805,
  [2914] = 2906,
  [2915] = 2806,
  [2916] = 2916,
  [2917] = 2809,
  [2918] = 2918,
  [2919] = 2695,
  [2920] = 2920,
  [2921] = 2285,
  [2922] = 2922,
  [2923] = 2683,
  [2924] = 2739,
  [2925] = 2681,
  [2926] = 2769,
  [2927] = 2757,
  [2928] = 2766,
  [2929] = 2784,
  [2930] = 2782,
  [2931] = 2931,
  [2932] = 2932,
  [2933] = 2672,
  [2934] = 2934,
  [2935] = 2935,
  [2936] = 2731,
  [2937] = 2678,
  [2938] = 2718,
  [2939] = 2264,
  [2940] = 2265,
  [2941] = 2920,
  [2942] = 2780,
  [2943] = 2943,
  [2944] = 2906,
  [2945] = 2775,
  [2946] = 2674,
  [2947] = 2947,
  [2948] = 2724,
  [2949] = 2699,
  [2950] = 2291,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 2803,
  [2954] = 2802,
  [2955] = 2786,
  [2956] = 2817,
  [2957] = 2957,
  [2958] = 2700,
  [2959] = 2701,
  [2960] = 2685,
  [2961] = 2725,
  [2962] = 2962,
  [2963] = 2963,
  [2964] = 2964,
  [2965] = 2965,
  [2966] = 2705,
  [2967] = 2739,
  [2968] = 2744,
  [2969] = 2724,
  [2970] = 2970,
  [2971] = 2971,
  [2972] = 2972,
  [2973] = 2973,
  [2974] = 2725,
  [2975] = 2975,
  [2976] = 2976,
  [2977] = 2706,
  [2978] = 2978,
  [2979] = 2979,
  [2980] = 2980,
  [2981] = 2906,
  [2982] = 2982,
  [2983] = 2983,
  [2984] = 2984,
  [2985] = 2670,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 2814,
  [2989] = 2989,
  [2990] = 2990,
  [2991] = 2991,
  [2992] = 2992,
  [2993] = 2700,
  [2994] = 2947,
  [2995] = 2995,
  [2996] = 2996,
  [2997] = 2997,
  [2998] = 2998,
  [2999] = 2999,
  [3000] = 2739,
  [3001] = 3001,
  [3002] = 3002,
  [3003] = 3003,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 3006,
  [3007] = 3007,
  [3008] = 3008,
  [3009] = 3009,
  [3010] = 3010,
  [3011] = 3010,
  [3012] = 3010,
  [3013] = 3013,
  [3014] = 3014,
  [3015] = 3015,
  [3016] = 3016,
  [3017] = 3017,
  [3018] = 3018,
  [3019] = 3019,
  [3020] = 3020,
  [3021] = 3021,
  [3022] = 3022,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 3025,
  [3026] = 3026,
  [3027] = 3027,
  [3028] = 3028,
  [3029] = 3029,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3007,
  [3046] = 3046,
  [3047] = 3047,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 3053,
  [3054] = 3054,
  [3055] = 3055,
  [3056] = 3056,
  [3057] = 3057,
  [3058] = 3058,
  [3059] = 3059,
  [3060] = 3060,
  [3061] = 3017,
  [3062] = 3062,
  [3063] = 3063,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 3069,
  [3070] = 3070,
  [3071] = 3071,
  [3072] = 3072,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 3076,
  [3077] = 3077,
  [3078] = 3078,
  [3079] = 3079,
  [3080] = 3060,
  [3081] = 3081,
  [3082] = 3019,
  [3083] = 3052,
  [3084] = 3084,
  [3085] = 3085,
  [3086] = 3086,
  [3087] = 3087,
  [3088] = 3088,
  [3089] = 3089,
  [3090] = 3090,
  [3091] = 3091,
  [3092] = 3092,
  [3093] = 3093,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 3096,
  [3097] = 3079,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3081,
  [3101] = 3101,
  [3102] = 3009,
  [3103] = 3103,
  [3104] = 3104,
  [3105] = 3085,
  [3106] = 3050,
  [3107] = 3107,
  [3108] = 3085,
  [3109] = 3109,
  [3110] = 3009,
  [3111] = 3064,
  [3112] = 3112,
  [3113] = 3017,
  [3114] = 3114,
  [3115] = 3081,
  [3116] = 531,
  [3117] = 3117,
  [3118] = 3050,
  [3119] = 3119,
  [3120] = 3098,
  [3121] = 547,
  [3122] = 3070,
  [3123] = 3123,
  [3124] = 3098,
  [3125] = 3125,
  [3126] = 3052,
  [3127] = 3060,
  [3128] = 3128,
  [3129] = 3129,
  [3130] = 3130,
  [3131] = 3131,
  [3132] = 3132,
  [3133] = 3133,
  [3134] = 3134,
  [3135] = 3079,
  [3136] = 3136,
  [3137] = 3137,
  [3138] = 3138,
  [3139] = 3139,
  [3140] = 3077,
  [3141] = 3079,
  [3142] = 3084,
  [3143] = 3019,
  [3144] = 3119,
  [3145] = 3145,
  [3146] = 3081,
  [3147] = 3147,
  [3148] = 3148,
  [3149] = 3010,
  [3150] = 3085,
  [3151] = 3151,
  [3152] = 3152,
  [3153] = 3153,
  [3154] = 3154,
  [3155] = 3155,
  [3156] = 3156,
  [3157] = 3157,
  [3158] = 3077,
  [3159] = 3159,
  [3160] = 3160,
  [3161] = 3109,
  [3162] = 3070,
  [3163] = 3163,
  [3164] = 3164,
  [3165] = 3165,
  [3166] = 3166,
  [3167] = 3167,
  [3168] = 3168,
  [3169] = 3064,
  [3170] = 3019,
  [3171] = 3171,
  [3172] = 3172,
  [3173] = 3173,
  [3174] = 3077,
  [3175] = 3077,
  [3176] = 3176,
  [3177] = 3177,
  [3178] = 3178,
  [3179] = 3077,
  [3180] = 3180,
  [3181] = 3077,
  [3182] = 3182,
  [3183] = 3077,
  [3184] = 3184,
  [3185] = 3185,
  [3186] = 3186,
  [3187] = 3187,
  [3188] = 3064,
  [3189] = 3068,
  [3190] = 3190,
  [3191] = 3191,
  [3192] = 3192,
  [3193] = 3193,
  [3194] = 3070,
  [3195] = 3195,
  [3196] = 3077,
  [3197] = 3197,
  [3198] = 3198,
  [3199] = 3199,
  [3200] = 3109,
  [3201] = 3077,
  [3202] = 3084,
  [3203] = 3203,
  [3204] = 3204,
  [3205] = 3084,
  [3206] = 3077,
  [3207] = 3132,
  [3208] = 3208,
  [3209] = 3145,
  [3210] = 3164,
  [3211] = 3137,
  [3212] = 3212,
  [3213] = 3213,
  [3214] = 3167,
  [3215] = 3077,
  [3216] = 3216,
  [3217] = 3217,
  [3218] = 3098,
  [3219] = 3219,
  [3220] = 3220,
  [3221] = 3221,
  [3222] = 3222,
  [3223] = 3223,
  [3224] = 3224,
  [3225] = 3225,
  [3226] = 3050,
  [3227] = 3227,
  [3228] = 3228,
  [3229] = 3229,
  [3230] = 3230,
  [3231] = 3017,
  [3232] = 3232,
  [3233] = 3233,
  [3234] = 3234,
  [3235] = 3235,
  [3236] = 3066,
  [3237] = 3237,
  [3238] = 3050,
  [3239] = 3239,
  [3240] = 3240,
  [3241] = 3241,
  [3242] = 3242,
  [3243] = 3243,
  [3244] = 3060,
  [3245] = 3245,
  [3246] = 3077,
  [3247] = 3247,
  [3248] = 3248,
  [3249] = 3070,
  [3250] = 3250,
  [3251] = 3251,
  [3252] = 3252,
  [3253] = 3253,
  [3254] = 3254,
  [3255] = 3255,
  [3256] = 3256,
  [3257] = 3257,
  [3258] = 3258,
  [3259] = 3259,
  [3260] = 3260,
  [3261] = 3261,
  [3262] = 3262,
  [3263] = 3263,
  [3264] = 3264,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 3267,
  [3268] = 3268,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 3271,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 3275,
  [3276] = 3276,
  [3277] = 3277,
  [3278] = 3278,
  [3279] = 3273,
  [3280] = 3280,
  [3281] = 3281,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 3285,
  [3286] = 3286,
  [3287] = 3287,
  [3288] = 3288,
  [3289] = 3289,
  [3290] = 3290,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 3294,
  [3295] = 3295,
  [3296] = 3296,
  [3297] = 3297,
  [3298] = 3298,
  [3299] = 3299,
  [3300] = 3300,
  [3301] = 3301,
  [3302] = 3302,
  [3303] = 3303,
  [3304] = 3273,
  [3305] = 3305,
  [3306] = 3306,
  [3307] = 3307,
  [3308] = 3308,
  [3309] = 3291,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 3307,
  [3321] = 3306,
  [3322] = 3297,
  [3323] = 3289,
  [3324] = 3324,
  [3325] = 3318,
  [3326] = 3275,
  [3327] = 3327,
  [3328] = 3316,
  [3329] = 3315,
  [3330] = 3313,
  [3331] = 3331,
  [3332] = 3332,
  [3333] = 3333,
  [3334] = 3334,
  [3335] = 3284,
  [3336] = 3292,
  [3337] = 3293,
  [3338] = 3275,
  [3339] = 3295,
  [3340] = 3340,
  [3341] = 3341,
  [3342] = 3342,
  [3343] = 3273,
  [3344] = 3305,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3347,
  [3348] = 3291,
  [3349] = 3313,
  [3350] = 3297,
  [3351] = 3315,
  [3352] = 3316,
  [3353] = 3353,
  [3354] = 3318,
  [3355] = 3307,
  [3356] = 3306,
  [3357] = 3297,
  [3358] = 3289,
  [3359] = 3359,
  [3360] = 3360,
  [3361] = 3361,
  [3362] = 3281,
  [3363] = 3295,
  [3364] = 3291,
  [3365] = 3365,
  [3366] = 3273,
  [3367] = 3305,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 3315,
  [3371] = 3371,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3305,
  [3375] = 3295,
  [3376] = 3273,
  [3377] = 3289,
  [3378] = 3273,
  [3379] = 3305,
  [3380] = 3380,
  [3381] = 3315,
  [3382] = 3382,
  [3383] = 3284,
  [3384] = 3295,
  [3385] = 3295,
  [3386] = 3273,
  [3387] = 3305,
  [3388] = 3315,
  [3389] = 3389,
  [3390] = 3293,
  [3391] = 3273,
  [3392] = 3305,
  [3393] = 3315,
  [3394] = 3292,
  [3395] = 3287,
  [3396] = 3273,
  [3397] = 3305,
  [3398] = 3315,
  [3399] = 3399,
  [3400] = 3292,
  [3401] = 3273,
  [3402] = 3305,
  [3403] = 3315,
  [3404] = 3293,
  [3405] = 3273,
  [3406] = 3305,
  [3407] = 3315,
  [3408] = 3408,
  [3409] = 3287,
  [3410] = 3287,
  [3411] = 3411,
  [3412] = 3412,
  [3413] = 3413,
  [3414] = 3295,
  [3415] = 3415,
  [3416] = 3284,
  [3417] = 3417,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3275,
  [3426] = 3305,
  [3427] = 3422,
  [3428] = 3428,
  [3429] = 3429,
  [3430] = 3430,
  [3431] = 3305,
  [3432] = 3432,
  [3433] = 3433,
  [3434] = 3341,
  [3435] = 3435,
  [3436] = 3436,
  [3437] = 3289,
  [3438] = 3306,
  [3439] = 3439,
  [3440] = 3297,
  [3441] = 3291,
  [3442] = 3281,
  [3443] = 3443,
  [3444] = 3361,
  [3445] = 3445,
  [3446] = 3446,
  [3447] = 3341,
  [3448] = 3448,
  [3449] = 3315,
  [3450] = 3450,
  [3451] = 3451,
  [3452] = 3307,
  [3453] = 3453,
  [3454] = 3340,
  [3455] = 3334,
  [3456] = 3451,
  [3457] = 3448,
  [3458] = 3319,
  [3459] = 3459,
  [3460] = 3318,
  [3461] = 3461,
  [3462] = 3462,
  [3463] = 3463,
  [3464] = 3464,
  [3465] = 3316,
  [3466] = 3315,
  [3467] = 3467,
  [3468] = 3313,
  [3469] = 3469,
  [3470] = 3292,
  [3471] = 3313,
  [3472] = 3472,
  [3473] = 3340,
  [3474] = 3474,
  [3475] = 3334,
  [3476] = 3340,
  [3477] = 3315,
  [3478] = 3448,
  [3479] = 3479,
  [3480] = 3341,
  [3481] = 3481,
  [3482] = 3482,
  [3483] = 3483,
  [3484] = 3316,
  [3485] = 3485,
  [3486] = 3486,
  [3487] = 3278,
  [3488] = 3488,
  [3489] = 3318,
  [3490] = 3490,
  [3491] = 3491,
  [3492] = 3281,
  [3493] = 3493,
  [3494] = 3291,
  [3495] = 3495,
  [3496] = 3496,
  [3497] = 3347,
  [3498] = 3498,
  [3499] = 3275,
  [3500] = 3305,
  [3501] = 3273,
  [3502] = 3502,
  [3503] = 3503,
  [3504] = 3504,
  [3505] = 3505,
  [3506] = 3307,
  [3507] = 3306,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 3510,
  [3511] = 3511,
  [3512] = 3297,
  [3513] = 3491,
  [3514] = 3514,
  [3515] = 3515,
  [3516] = 3293,
  [3517] = 3289,
  [3518] = 3295,
  [3519] = 3519,
  [3520] = 3520,
  [3521] = 3293,
  [3522] = 3292,
  [3523] = 3523,
  [3524] = 3382,
  [3525] = 3525,
  [3526] = 3295,
  [3527] = 3527,
  [3528] = 3528,
  [3529] = 3529,
  [3530] = 3530,
  [3531] = 3531,
  [3532] = 3532,
  [3533] = 3287,
  [3534] = 3534,
  [3535] = 3535,
  [3536] = 3536,
  [3537] = 3537,
  [3538] = 3538,
  [3539] = 3539,
  [3540] = 3540,
  [3541] = 3541,
  [3542] = 3542,
  [3543] = 3543,
  [3544] = 3313,
  [3545] = 3545,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3548,
  [3549] = 3284,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3334,
  [3553] = 3553,
  [3554] = 3368,
  [3555] = 3555,
  [3556] = 3556,
  [3557] = 3275,
  [3558] = 3558,
  [3559] = 3559,
  [3560] = 3560,
  [3561] = 3368,
  [3562] = 3318,
  [3563] = 3316,
  [3564] = 3564,
  [3565] = 3368,
  [3566] = 3566,
  [3567] = 3567,
  [3568] = 3306,
  [3569] = 3307,
  [3570] = 3570,
  [3571] = 3571,
  [3572] = 3572,
  [3573] = 3573,
  [3574] = 3574,
  [3575] = 3575,
  [3576] = 3576,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(103);
      ADVANCE_MAP(
        '!', 217,
        '"', 112,
        '#', 105,
        '$', 119,
        '%', 208,
        '&', 189,
        '\'', 114,
        '(', 140,
        ')', 141,
        '*', 204,
        '+', 198,
        ',', 137,
        '-', 215,
        '.', 225,
        '/', 206,
        '0', 106,
        ':', 139,
        ';', 234,
        '<', 174,
        '=', 145,
        '>', 180,
        '?', 164,
        '@', 236,
        '[', 136,
        '\\', 85,
        ']', 138,
        '^', 187,
        'a', 261,
        'p', 255,
        'r', 253,
        's', 265,
        '{', 123,
        '|', 184,
        '}', 124,
        '~', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(99);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(107);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(248);
      if (lookahead == '/') ADVANCE(42);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(2);
      if (lookahead == '/') ADVANCE(245);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(246);
      if (lookahead != 0) ADVANCE(247);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 217,
        '"', 112,
        '#', 104,
        '%', 207,
        '&', 188,
        '\'', 114,
        '(', 140,
        '*', 203,
        '+', 197,
        ',', 137,
        '-', 214,
        '.', 227,
        '/', 205,
        '0', 106,
        ':', 139,
        ';', 234,
        '<', 175,
        '=', 143,
        '>', 181,
        '?', 165,
        '@', 236,
        '[', 136,
        '^', 186,
        'a', 262,
        'r', 253,
        '{', 123,
        '|', 185,
        '}', 124,
        '~', 220,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(107);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 217,
        '"', 112,
        '#', 104,
        '\'', 114,
        '(', 140,
        ')', 141,
        '+', 48,
        ',', 137,
        '-', 214,
        '.', 51,
        '/', 42,
        '0', 106,
        ':', 139,
        '<', 177,
        '=', 56,
        '>', 179,
        '?', 162,
        '@', 236,
        '[', 136,
        ']', 138,
        'r', 253,
        '{', 123,
        '~', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(107);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 217,
        '"', 112,
        '%', 207,
        '&', 188,
        '\'', 114,
        '(', 140,
        ')', 141,
        '*', 203,
        ',', 137,
        '.', 224,
        '/', 205,
        ':', 139,
        '<', 175,
        '=', 57,
        '>', 181,
        '?', 169,
        '[', 136,
        ']', 138,
        '^', 186,
        'a', 262,
        'r', 253,
        '|', 185,
        '}', 124,
        '~', 53,
        '+', 196,
        '-', 196,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 217,
        '"', 112,
        '%', 207,
        '&', 188,
        '\'', 114,
        '(', 140,
        ')', 141,
        '*', 203,
        ',', 137,
        '.', 226,
        '/', 205,
        ':', 139,
        ';', 234,
        '<', 175,
        '=', 144,
        '>', 181,
        '?', 165,
        '[', 136,
        ']', 138,
        '^', 186,
        'a', 262,
        'r', 253,
        '{', 123,
        '|', 185,
        '}', 124,
        '~', 53,
        '+', 196,
        '-', 196,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 217,
        '"', 112,
        '%', 207,
        '&', 188,
        '\'', 114,
        '(', 140,
        '*', 203,
        ',', 137,
        '.', 226,
        '/', 205,
        ';', 234,
        '<', 175,
        '=', 144,
        '>', 181,
        '?', 165,
        '[', 136,
        '^', 186,
        'a', 261,
        'r', 253,
        's', 265,
        '{', 123,
        '|', 185,
        '~', 53,
        '+', 196,
        '-', 196,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 217,
        '%', 208,
        '&', 189,
        '(', 140,
        ')', 141,
        '*', 204,
        '+', 198,
        ',', 137,
        '-', 200,
        '.', 224,
        '/', 206,
        ':', 139,
        '<', 174,
        '=', 144,
        '>', 180,
        '?', 168,
        '[', 136,
        ']', 138,
        '^', 187,
        'a', 262,
        '|', 184,
        '}', 124,
        '~', 52,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 217,
        '%', 208,
        '&', 189,
        '(', 140,
        ')', 141,
        '*', 204,
        '+', 198,
        ',', 137,
        '-', 200,
        '.', 226,
        '/', 206,
        ':', 139,
        ';', 234,
        '<', 174,
        '=', 144,
        '>', 180,
        '?', 164,
        '[', 136,
        ']', 138,
        '^', 187,
        'a', 262,
        '|', 184,
        '}', 124,
        '~', 52,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 217,
        '%', 208,
        '&', 189,
        '(', 140,
        ')', 141,
        '*', 204,
        '+', 201,
        ',', 137,
        '-', 202,
        '.', 226,
        '/', 206,
        ':', 139,
        ';', 234,
        '<', 174,
        '=', 144,
        '>', 180,
        '?', 164,
        '[', 136,
        ']', 138,
        '^', 187,
        'a', 262,
        '|', 184,
        '}', 124,
        '~', 52,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 217,
        '%', 208,
        '&', 189,
        '(', 140,
        '*', 204,
        '+', 198,
        ',', 137,
        '-', 200,
        '.', 226,
        '/', 206,
        ';', 234,
        '<', 174,
        '=', 144,
        '>', 180,
        '?', 164,
        '[', 136,
        '^', 187,
        'a', 261,
        's', 265,
        '{', 123,
        '|', 184,
        '~', 52,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 217,
        '%', 208,
        '&', 189,
        '(', 140,
        '*', 204,
        '+', 201,
        ',', 137,
        '-', 202,
        '.', 226,
        '/', 206,
        ';', 234,
        '<', 174,
        '=', 144,
        '>', 180,
        '?', 164,
        '[', 136,
        '^', 187,
        'a', 261,
        's', 265,
        '{', 123,
        '|', 184,
        '~', 52,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 217,
        '%', 207,
        '&', 188,
        '(', 140,
        ')', 141,
        '*', 203,
        '+', 197,
        ',', 137,
        '-', 199,
        '.', 224,
        '/', 205,
        ':', 139,
        '<', 175,
        '=', 57,
        '>', 181,
        '?', 169,
        '[', 136,
        ']', 138,
        '^', 186,
        'a', 262,
        '|', 185,
        '}', 124,
        '~', 53,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 217,
        '%', 207,
        '&', 188,
        '(', 140,
        ')', 141,
        '*', 203,
        '+', 197,
        ',', 137,
        '-', 199,
        '.', 226,
        '/', 205,
        ':', 139,
        ';', 234,
        '<', 175,
        '=', 57,
        '>', 181,
        '?', 165,
        '[', 136,
        ']', 138,
        '^', 186,
        'a', 262,
        '|', 185,
        '}', 124,
        '~', 53,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 217,
        '%', 207,
        '&', 188,
        '(', 140,
        '*', 203,
        '+', 197,
        ',', 137,
        '-', 199,
        '.', 226,
        '/', 205,
        ';', 234,
        '<', 175,
        '=', 57,
        '>', 181,
        '?', 165,
        '[', 136,
        '^', 186,
        'a', 261,
        's', 265,
        '{', 123,
        '|', 185,
        '~', 53,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(244);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 216,
        '"', 112,
        '$', 118,
        '&', 37,
        '\'', 113,
        ')', 141,
        ',', 137,
        '/', 42,
        '=', 142,
        '?', 162,
        '\\', 85,
        ']', 138,
        'a', 83,
        '|', 89,
        '}', 124,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 216,
        '"', 112,
        '$', 118,
        '&', 37,
        '\'', 113,
        ')', 141,
        ',', 137,
        '/', 42,
        '=', 142,
        '?', 162,
        ']', 138,
        'a', 83,
        '|', 89,
        '}', 124,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 216,
        '"', 112,
        '%', 207,
        '&', 188,
        '\'', 114,
        '(', 140,
        ')', 141,
        '*', 203,
        ',', 137,
        '.', 224,
        '/', 205,
        ':', 139,
        '<', 175,
        '=', 63,
        '>', 181,
        '?', 162,
        '[', 73,
        ']', 138,
        '^', 186,
        'a', 262,
        'r', 253,
        '|', 185,
        '}', 124,
        '~', 220,
        '+', 196,
        '-', 196,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 216,
        '"', 111,
        '$', 118,
        '\'', 114,
        '(', 140,
        ',', 137,
        '.', 226,
        '/', 42,
        ';', 234,
        '<', 173,
        '=', 71,
        '?', 163,
        '[', 136,
        '\\', 85,
        'a', 84,
        's', 86,
        '{', 123,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '!', 216,
        '"', 111,
        '$', 118,
        '\'', 114,
        '(', 140,
        ',', 137,
        '.', 226,
        '/', 42,
        ';', 234,
        '<', 173,
        '=', 71,
        '?', 163,
        '[', 136,
        'a', 84,
        's', 86,
        '{', 123,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 216,
        '%', 58,
        '&', 59,
        '(', 140,
        ')', 141,
        '*', 60,
        '+', 61,
        ',', 137,
        '-', 62,
        '.', 226,
        '/', 43,
        ':', 139,
        ';', 234,
        '<', 176,
        '=', 146,
        '>', 72,
        '?', 166,
        '[', 136,
        ']', 138,
        '^', 64,
        'a', 263,
        's', 265,
        '{', 123,
        '|', 65,
        '}', 124,
        '~', 55,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 216,
        '%', 58,
        '&', 59,
        '(', 140,
        ')', 141,
        '*', 60,
        '+', 61,
        ',', 137,
        '-', 62,
        '.', 226,
        '/', 43,
        ':', 139,
        ';', 234,
        '<', 176,
        '=', 146,
        '>', 72,
        '?', 166,
        '[', 136,
        ']', 138,
        '^', 64,
        '|', 65,
        '}', 124,
        '~', 55,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 216,
        '&', 37,
        '(', 140,
        ')', 141,
        ',', 137,
        '.', 224,
        '/', 42,
        ':', 139,
        '<', 173,
        '=', 146,
        '?', 162,
        ']', 138,
        'a', 262,
        '|', 89,
        '}', 124,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(24);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '!', 56,
        '"', 112,
        '#', 104,
        '\'', 114,
        '(', 140,
        ')', 141,
        ',', 137,
        '-', 213,
        '.', 51,
        '/', 42,
        '0', 106,
        ':', 139,
        '<', 177,
        '=', 56,
        '>', 179,
        '@', 236,
        '[', 136,
        ']', 138,
        'r', 253,
        '{', 123,
        '}', 124,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(107);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '!', 56,
        '%', 207,
        '&', 188,
        '(', 140,
        ')', 141,
        '*', 203,
        ',', 137,
        '.', 224,
        '/', 205,
        ':', 139,
        '<', 175,
        '=', 57,
        '>', 181,
        '?', 171,
        ']', 138,
        '^', 186,
        'a', 262,
        '|', 185,
        '}', 124,
        '~', 53,
        '+', 196,
        '-', 196,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '!', 56,
        '%', 207,
        '&', 188,
        '(', 140,
        ')', 141,
        '*', 203,
        ',', 137,
        '.', 226,
        '/', 205,
        ':', 139,
        ';', 234,
        '<', 175,
        '=', 57,
        '>', 181,
        '?', 170,
        '[', 136,
        ']', 138,
        '^', 186,
        'a', 262,
        '|', 185,
        '}', 124,
        '~', 53,
        '+', 196,
        '-', 196,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '!', 56,
        '%', 207,
        '&', 188,
        '(', 140,
        '*', 203,
        ',', 137,
        '.', 226,
        '/', 205,
        ';', 234,
        '<', 175,
        '=', 57,
        '>', 181,
        '?', 170,
        '^', 186,
        'a', 261,
        's', 265,
        '{', 123,
        '|', 185,
        '~', 53,
        '+', 196,
        '-', 196,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 29:
      if (lookahead == '"') ADVANCE(112);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(132);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(126);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(125);
      END_STATE();
    case 30:
      if (lookahead == '"') ADVANCE(115);
      END_STATE();
    case 31:
      if (lookahead == '"') ADVANCE(121);
      END_STATE();
    case 32:
      if (lookahead == '"') ADVANCE(111);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(114);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(132);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(127);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(125);
      END_STATE();
    case 33:
      if (lookahead == '"') ADVANCE(111);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '/') ADVANCE(42);
      if (lookahead == '\\') ADVANCE(85);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      END_STATE();
    case 34:
      if (lookahead == '"') ADVANCE(111);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '/') ADVANCE(42);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      END_STATE();
    case 35:
      if (lookahead == '"') ADVANCE(111);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(132);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(128);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(125);
      END_STATE();
    case 36:
      if (lookahead == '$') ADVANCE(268);
      END_STATE();
    case 37:
      if (lookahead == '&') ADVANCE(250);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '&', 37,
        '(', 140,
        ')', 141,
        ',', 137,
        '.', 224,
        '/', 42,
        ':', 139,
        ';', 234,
        '<', 173,
        '=', 146,
        '>', 178,
        '?', 162,
        '@', 236,
        '[', 136,
        ']', 138,
        '{', 123,
        '|', 89,
        '}', 124,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 39:
      if (lookahead == '\'') ADVANCE(116);
      END_STATE();
    case 40:
      if (lookahead == '\'') ADVANCE(122);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        ')', 141,
        ',', 137,
        '/', 42,
        ':', 139,
        ';', 234,
        '=', 146,
        '?', 162,
        ']', 138,
        'a', 263,
        's', 265,
        '{', 123,
        '}', 124,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 42:
      if (lookahead == '*') ADVANCE(278);
      if (lookahead == '/') ADVANCE(270);
      END_STATE();
    case 43:
      if (lookahead == '*') ADVANCE(278);
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 44:
      if (lookahead == '*') ADVANCE(243);
      END_STATE();
    case 45:
      if (lookahead == '*') ADVANCE(283);
      if (lookahead == '/') ADVANCE(47);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(45);
      if (lookahead != 0) ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == '*') ADVANCE(283);
      if (lookahead != 0) ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '*') ADVANCE(279);
      if (lookahead == '/') ADVANCE(269);
      if (lookahead != 0) ADVANCE(46);
      END_STATE();
    case 48:
      if (lookahead == '+') ADVANCE(211);
      END_STATE();
    case 49:
      if (lookahead == '.') ADVANCE(212);
      END_STATE();
    case 50:
      if (lookahead == '.') ADVANCE(233);
      END_STATE();
    case 51:
      if (lookahead == '.') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 52:
      if (lookahead == '/') ADVANCE(210);
      END_STATE();
    case 53:
      if (lookahead == '/') ADVANCE(209);
      END_STATE();
    case 54:
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead == '{') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(131);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(268);
      if (lookahead != 0) ADVANCE(125);
      END_STATE();
    case 55:
      if (lookahead == '/') ADVANCE(69);
      END_STATE();
    case 56:
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 57:
      if (lookahead == '=') ADVANCE(172);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 58:
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 59:
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 60:
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 61:
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 62:
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 63:
      if (lookahead == '=') ADVANCE(237);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 64:
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 65:
      if (lookahead == '=') ADVANCE(158);
      END_STATE();
    case 66:
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 67:
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '>') ADVANCE(70);
      END_STATE();
    case 68:
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 69:
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 70:
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 71:
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 72:
      if (lookahead == '>') ADVANCE(67);
      END_STATE();
    case 73:
      if (lookahead == ']') ADVANCE(238);
      END_STATE();
    case 74:
      if (lookahead == '_') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 75:
      if (lookahead == '_') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 76:
      if (lookahead == '_') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(110);
      END_STATE();
    case 77:
      if (lookahead == 'c') ADVANCE(44);
      END_STATE();
    case 78:
      if (lookahead == 'c') ADVANCE(240);
      END_STATE();
    case 79:
      if (lookahead == 'f') ADVANCE(249);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(77);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(78);
      END_STATE();
    case 82:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 83:
      if (lookahead == 's') ADVANCE(221);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 85:
      if (lookahead == 'u') ADVANCE(88);
      if (lookahead == 'x') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(135);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 86:
      if (lookahead == 'y') ADVANCE(80);
      END_STATE();
    case 87:
      if (lookahead == 'y') ADVANCE(81);
      END_STATE();
    case 88:
      if (lookahead == '{') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(97);
      END_STATE();
    case 89:
      if (lookahead == '|') ADVANCE(251);
      END_STATE();
    case 90:
      if (lookahead == '}') ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 91:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(110);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(110);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(133);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(98);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(94);
      END_STATE();
    case 99:
      if (eof) ADVANCE(103);
      ADVANCE_MAP(
        '!', 217,
        '"', 112,
        '#', 105,
        '$', 119,
        '%', 208,
        '&', 189,
        '\'', 114,
        '(', 140,
        ')', 141,
        '*', 204,
        '+', 198,
        ',', 137,
        '-', 215,
        '.', 225,
        '/', 206,
        '0', 106,
        ':', 139,
        ';', 234,
        '<', 174,
        '=', 145,
        '>', 180,
        '?', 164,
        '@', 236,
        '[', 136,
        ']', 138,
        '^', 187,
        'a', 261,
        'p', 255,
        'r', 253,
        's', 265,
        '{', 123,
        '|', 184,
        '}', 124,
        '~', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(99);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(107);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 100:
      if (eof) ADVANCE(103);
      ADVANCE_MAP(
        '!', 216,
        '"', 112,
        '#', 16,
        '\'', 114,
        '(', 140,
        ')', 141,
        ',', 137,
        '.', 224,
        '/', 42,
        ':', 139,
        ';', 234,
        '<', 173,
        '=', 142,
        '>', 178,
        '?', 167,
        '@', 236,
        '[', 136,
        ']', 138,
        'p', 255,
        'r', 253,
        '}', 124,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(100);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 101:
      if (eof) ADVANCE(103);
      ADVANCE_MAP(
        '!', 216,
        '"', 112,
        '#', 104,
        '&', 37,
        '\'', 114,
        '(', 140,
        ')', 141,
        '*', 203,
        '+', 48,
        ',', 137,
        '-', 214,
        '.', 51,
        '/', 42,
        '0', 106,
        ':', 139,
        ';', 234,
        '<', 173,
        '=', 146,
        '>', 178,
        '?', 162,
        '@', 236,
        '[', 136,
        ']', 138,
        'r', 253,
        '{', 123,
        '|', 89,
        '}', 124,
        '~', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(101);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(107);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 102:
      if (eof) ADVANCE(103);
      ADVANCE_MAP(
        '!', 216,
        '"', 112,
        '#', 104,
        '&', 37,
        '\'', 114,
        '(', 140,
        ')', 141,
        '+', 48,
        ',', 137,
        '-', 214,
        '.', 228,
        '/', 42,
        '0', 106,
        ':', 139,
        ';', 234,
        '<', 173,
        '=', 63,
        '>', 178,
        '?', 167,
        '@', 236,
        '[', 136,
        ']', 138,
        'r', 253,
        '{', 123,
        '|', 89,
        '}', 124,
        '~', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(102);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(107);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '!') ADVANCE(244);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(91);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '_') ADVANCE(74);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '_') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(110);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(30);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(39);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE);
      if (lookahead == '"') ADVANCE(31);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_r_SQUOTE);
      if (lookahead == '\'') ADVANCE(40);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_r_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '"') ADVANCE(112);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '/') ADVANCE(130);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(126);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(125);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '"') ADVANCE(111);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(114);
      if (lookahead == '/') ADVANCE(130);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(127);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(125);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '"') ADVANCE(111);
      if (lookahead == '$') ADVANCE(118);
      if (lookahead == '\'') ADVANCE(113);
      if (lookahead == '/') ADVANCE(130);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(128);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(125);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '$') ADVANCE(268);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '*') ADVANCE(278);
      if (lookahead == '/') ADVANCE(270);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(129);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(131);
      if (lookahead != 0 &&
          (lookahead < 'A' || 'Z' < lookahead) &&
          lookahead != '_' &&
          (lookahead < 'a' || '{' < lookahead)) ADVANCE(125);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym__sub_string_test_token1);
      if (lookahead == 'u') ADVANCE(88);
      if (lookahead == 'x') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(135);
      if (lookahead != 0) ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym__unused_escape_sequence);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym__unused_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(133);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym__unused_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(134);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(172);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(237);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(235);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_TILDE_SLASH_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(159);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(230);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(230);
      if (lookahead == '?') ADVANCE(161);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(230);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(230);
      if (lookahead == '?') ADVANCE(68);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(229);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(229);
      if (lookahead == '?') ADVANCE(161);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(229);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(50);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_equality_operator);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(191);
      if (lookahead == '=') ADVANCE(182);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(190);
      if (lookahead == '=') ADVANCE(182);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(66);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(182);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(183);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(183);
      if (lookahead == '>') ADVANCE(192);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(183);
      if (lookahead == '>') ADVANCE(193);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '|') ADVANCE(251);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(251);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(157);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(250);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(250);
      if (lookahead == '=') ADVANCE(156);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(154);
      if (lookahead == '>') ADVANCE(195);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(155);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym__additive_operator);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '+') ADVANCE(211);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '+') ADVANCE(211);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '-') ADVANCE(211);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym__additive_operator);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(278);
      if (lookahead == '/') ADVANCE(270);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(278);
      if (lookahead == '/') ADVANCE(270);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(151);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_TILDE_SLASH);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_TILDE_SLASH);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_increment_operator);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_minus_operator);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_minus_operator);
      if (lookahead == '-') ADVANCE(211);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_minus_operator);
      if (lookahead == '-') ADVANCE(211);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(172);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '/') ADVANCE(210);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '/') ADVANCE(209);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(259);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(232);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(231);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(109);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      if (lookahead == '.') ADVANCE(233);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(212);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT_DOT);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=') ADVANCE(239);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '*') ADVANCE(242);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == '*') ADVANCE(242);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_async_STAR);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_sync_STAR);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_POUND_BANG);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead == '*') ADVANCE(280);
      if (lookahead == '/') ADVANCE(271);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(247);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead == '/') ADVANCE(245);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(246);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(247);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(aux_sym_script_tag_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(247);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(248);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_part_of_builtin);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == ' ') ADVANCE(82);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(120);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(260);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(254);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(241);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(256);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(257);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(264);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(222);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(223);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(266);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(252);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(258);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(259);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_identifier_dollar_escaped);
      if (lookahead == '\\') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '*') ADVANCE(283);
      if (lookahead == '/') ADVANCE(285);
      if (lookahead != 0) ADVANCE(46);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(284);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(286);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(247);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(287);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(291);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '/') ADVANCE(288);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(277);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '*') ADVANCE(282);
      if (lookahead == '/') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(277);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '/') ADVANCE(274);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(275);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(277);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(275);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '/') ADVANCE(277);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(277);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead == '*') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '/') ADVANCE(46);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(247);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(291);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(277);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_comment_token2);
      if (lookahead == '*') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '/') ADVANCE(46);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      if (lookahead == '*') ADVANCE(283);
      if (lookahead != 0) ADVANCE(46);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(247);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(291);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(277);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_documentation_comment_token1);
      if (lookahead == '*') ADVANCE(281);
      if (lookahead == '/') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(291);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_documentation_comment_token1);
      if (lookahead == '/') ADVANCE(289);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(290);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(291);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_documentation_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(291);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'F', 1,
        'a', 2,
        'b', 3,
        'c', 4,
        'd', 5,
        'e', 6,
        'f', 7,
        'g', 8,
        'h', 9,
        'i', 10,
        'l', 11,
        'm', 12,
        'n', 13,
        'o', 14,
        'p', 15,
        'r', 16,
        's', 17,
        't', 18,
        'v', 19,
        'w', 20,
        'y', 21,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'u') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'b') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      if (lookahead == 'r') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'l') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      if (lookahead == 'y') ADVANCE(34);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'n') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(42);
      END_STATE();
    case 10:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      END_STATE();
    case 12:
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 14:
      if (lookahead == 'n') ADVANCE(53);
      if (lookahead == 'p') ADVANCE(54);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(55);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 'h') ADVANCE(58);
      if (lookahead == 't') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(60);
      if (lookahead == 'w') ADVANCE(61);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 'y') ADVANCE(64);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(67);
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(71);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 27:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(77);
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(80);
      if (lookahead == 'v') ADVANCE(81);
      END_STATE();
    case 32:
      if (lookahead == 'f') ADVANCE(82);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(83);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 35:
      if (lookahead == 's') ADVANCE(85);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 37:
      if (lookahead == 'p') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 38:
      if (lookahead == 'c') ADVANCE(89);
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 42:
      if (lookahead == 'd') ADVANCE(94);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(95);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'l') ADVANCE(96);
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'b') ADVANCE(99);
      END_STATE();
    case 49:
      if (lookahead == 'x') ADVANCE(100);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(102);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(103);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(105);
      END_STATE();
    case 56:
      if (lookahead == 'q') ADVANCE(106);
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(108);
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 58:
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(111);
      END_STATE();
    case 60:
      if (lookahead == 'p') ADVANCE(112);
      END_STATE();
    case 61:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(116);
      if (lookahead == 'y') ADVANCE(117);
      END_STATE();
    case 64:
      if (lookahead == 'p') ADVANCE(118);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(121);
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 70:
      if (lookahead == 'c') ADVANCE(125);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(129);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 78:
      if (lookahead == 'c') ADVANCE(133);
      END_STATE();
    case 79:
      if (lookahead == 's') ADVANCE(134);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(135);
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(137);
      END_STATE();
    case 82:
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 83:
      if (lookahead == 'b') ADVANCE(140);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 86:
      if (lookahead == 'm') ADVANCE(143);
      END_STATE();
    case 87:
      if (lookahead == 'o') ADVANCE(144);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 89:
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(147);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(150);
      if (lookahead == 'o') ADVANCE(151);
      END_STATE();
    case 96:
      if (lookahead == 'i') ADVANCE(152);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 99:
      if (lookahead == 'r') ADVANCE(155);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(156);
      END_STATE();
    case 101:
      if (lookahead == 'i') ADVANCE(157);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(158);
      END_STATE();
    case 104:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 106:
      if (lookahead == 'u') ADVANCE(161);
      END_STATE();
    case 107:
      if (lookahead == 'h') ADVANCE(162);
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 110:
      if (lookahead == 'w') ADVANCE(165);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 113:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 114:
      if (lookahead == 's') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 120:
      if (lookahead == 'd') ADVANCE(173);
      END_STATE();
    case 121:
      if (lookahead == 'n') ADVANCE(174);
      END_STATE();
    case 122:
      if (lookahead == 'l') ADVANCE(175);
      END_STATE();
    case 123:
      if (lookahead == 'h') ADVANCE(176);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 126:
      if (lookahead == 'r') ADVANCE(179);
      END_STATE();
    case 127:
      if (lookahead == 'r') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_base);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 131:
      if (lookahead == 'k') ADVANCE(182);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 133:
      if (lookahead == 'h') ADVANCE(183);
      END_STATE();
    case 134:
      if (lookahead == 's') ADVANCE(184);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 136:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 137:
      if (lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 138:
      if (lookahead == 'u') ADVANCE(188);
      END_STATE();
    case 139:
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 140:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 141:
      if (lookahead == 'm') ADVANCE(191);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 144:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 145:
      if (lookahead == 'n') ADVANCE(193);
      if (lookahead == 'r') ADVANCE(194);
      END_STATE();
    case 146:
      if (lookahead == 'o') ADVANCE(195);
      END_STATE();
    case 147:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 148:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_hide);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 151:
      if (lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 152:
      if (lookahead == 'n') ADVANCE(200);
      END_STATE();
    case 153:
      if (lookahead == 'r') ADVANCE(201);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_late);
      END_STATE();
    case 155:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 156:
      if (lookahead == 'n') ADVANCE(203);
      END_STATE();
    case 157:
      if (lookahead == 'v') ADVANCE(204);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_part);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(206);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(207);
      END_STATE();
    case 163:
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_show);
      END_STATE();
    case 166:
      if (lookahead == 'i') ADVANCE(210);
      END_STATE();
    case 167:
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 168:
      if (lookahead == 'c') ADVANCE(212);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 170:
      if (lookahead == 'w') ADVANCE(213);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 172:
      if (lookahead == 'd') ADVANCE(214);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_void_type);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 177:
      if (lookahead == 'd') ADVANCE(216);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 179:
      if (lookahead == 'a') ADVANCE(218);
      END_STATE();
    case 180:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_break_builtin);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_const_builtin);
      END_STATE();
    case 186:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 187:
      if (lookahead == 'i') ADVANCE(221);
      END_STATE();
    case 188:
      if (lookahead == 'l') ADVANCE(222);
      END_STATE();
    case 189:
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 190:
      if (lookahead == 'e') ADVANCE(224);
      END_STATE();
    case 191:
      if (lookahead == 'i') ADVANCE(225);
      END_STATE();
    case 192:
      if (lookahead == 't') ADVANCE(226);
      END_STATE();
    case 193:
      if (lookahead == 'd') ADVANCE(227);
      if (lookahead == 's') ADVANCE(228);
      END_STATE();
    case 194:
      if (lookahead == 'n') ADVANCE(229);
      END_STATE();
    case 195:
      if (lookahead == 'r') ADVANCE(230);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 198:
      if (lookahead == 'm') ADVANCE(232);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 200:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 201:
      if (lookahead == 'f') ADVANCE(235);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(236);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_mixin);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(238);
      END_STATE();
    case 206:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 207:
      if (lookahead == 'o') ADVANCE(240);
      END_STATE();
    case 208:
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 209:
      if (lookahead == 'd') ADVANCE(242);
      END_STATE();
    case 210:
      if (lookahead == 'c') ADVANCE(243);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_super);
      END_STATE();
    case 212:
      if (lookahead == 'h') ADVANCE(244);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 217:
      if (lookahead == 'o') ADVANCE(246);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(247);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_assert_builtin);
      END_STATE();
    case 220:
      if (lookahead == 'u') ADVANCE(248);
      END_STATE();
    case 221:
      if (lookahead == 'a') ADVANCE(249);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_floating_point_type);
      END_STATE();
    case 225:
      if (lookahead == 'c') ADVANCE(252);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 227:
      if (lookahead == 's') ADVANCE(253);
      END_STATE();
    case 228:
      if (lookahead == 'i') ADVANCE(254);
      END_STATE();
    case 229:
      if (lookahead == 'a') ADVANCE(255);
      END_STATE();
    case 230:
      if (lookahead == 'y') ADVANCE(256);
      END_STATE();
    case 231:
      if (lookahead == 'y') ADVANCE(257);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(258);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 235:
      if (lookahead == 'a') ADVANCE(259);
      END_STATE();
    case 236:
      if (lookahead == 'y') ADVANCE(260);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(261);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 240:
      if (lookahead == 'w') ADVANCE(263);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 245:
      if (lookahead == 'f') ADVANCE(264);
      END_STATE();
    case 246:
      if (lookahead == 'n') ADVANCE(265);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(266);
      END_STATE();
    case 248:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 249:
      if (lookahead == 'n') ADVANCE(268);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 251:
      if (lookahead == 'd') ADVANCE(269);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_dynamic);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 254:
      if (lookahead == 'o') ADVANCE(270);
      END_STATE();
    case 255:
      if (lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_factory);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 258:
      if (lookahead == 'n') ADVANCE(272);
      END_STATE();
    case 259:
      if (lookahead == 'c') ADVANCE(273);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_library);
      END_STATE();
    case 261:
      if (lookahead == 'r') ADVANCE(274);
      END_STATE();
    case 262:
      if (lookahead == 'd') ADVANCE(275);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_rethrow_builtin);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_Function);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 268:
      if (lookahead == 't') ADVANCE(276);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_deferred);
      END_STATE();
    case 270:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 272:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_covariant);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_extension);
      END_STATE();
    case 278:
      if (lookahead == 's') ADVANCE(280);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 100, .external_lex_state = 2},
  [2] = {.lex_state = 101, .external_lex_state = 2},
  [3] = {.lex_state = 101, .external_lex_state = 2},
  [4] = {.lex_state = 101, .external_lex_state = 2},
  [5] = {.lex_state = 101, .external_lex_state = 2},
  [6] = {.lex_state = 101, .external_lex_state = 2},
  [7] = {.lex_state = 101, .external_lex_state = 2},
  [8] = {.lex_state = 101, .external_lex_state = 2},
  [9] = {.lex_state = 101, .external_lex_state = 2},
  [10] = {.lex_state = 101, .external_lex_state = 2},
  [11] = {.lex_state = 101, .external_lex_state = 2},
  [12] = {.lex_state = 101, .external_lex_state = 2},
  [13] = {.lex_state = 101, .external_lex_state = 2},
  [14] = {.lex_state = 101, .external_lex_state = 2},
  [15] = {.lex_state = 101, .external_lex_state = 2},
  [16] = {.lex_state = 101, .external_lex_state = 2},
  [17] = {.lex_state = 101, .external_lex_state = 2},
  [18] = {.lex_state = 101, .external_lex_state = 2},
  [19] = {.lex_state = 101, .external_lex_state = 2},
  [20] = {.lex_state = 101, .external_lex_state = 2},
  [21] = {.lex_state = 101, .external_lex_state = 2},
  [22] = {.lex_state = 101, .external_lex_state = 2},
  [23] = {.lex_state = 101, .external_lex_state = 2},
  [24] = {.lex_state = 101, .external_lex_state = 2},
  [25] = {.lex_state = 101, .external_lex_state = 2},
  [26] = {.lex_state = 101, .external_lex_state = 2},
  [27] = {.lex_state = 101, .external_lex_state = 2},
  [28] = {.lex_state = 101, .external_lex_state = 2},
  [29] = {.lex_state = 101, .external_lex_state = 2},
  [30] = {.lex_state = 101, .external_lex_state = 2},
  [31] = {.lex_state = 101, .external_lex_state = 2},
  [32] = {.lex_state = 101, .external_lex_state = 2},
  [33] = {.lex_state = 101, .external_lex_state = 2},
  [34] = {.lex_state = 101, .external_lex_state = 2},
  [35] = {.lex_state = 101, .external_lex_state = 2},
  [36] = {.lex_state = 101, .external_lex_state = 2},
  [37] = {.lex_state = 101, .external_lex_state = 2},
  [38] = {.lex_state = 101, .external_lex_state = 2},
  [39] = {.lex_state = 101, .external_lex_state = 2},
  [40] = {.lex_state = 101, .external_lex_state = 2},
  [41] = {.lex_state = 101, .external_lex_state = 2},
  [42] = {.lex_state = 101, .external_lex_state = 2},
  [43] = {.lex_state = 4, .external_lex_state = 2},
  [44] = {.lex_state = 4, .external_lex_state = 2},
  [45] = {.lex_state = 4, .external_lex_state = 2},
  [46] = {.lex_state = 4, .external_lex_state = 2},
  [47] = {.lex_state = 4, .external_lex_state = 2},
  [48] = {.lex_state = 101, .external_lex_state = 2},
  [49] = {.lex_state = 101, .external_lex_state = 2},
  [50] = {.lex_state = 101, .external_lex_state = 2},
  [51] = {.lex_state = 4, .external_lex_state = 2},
  [52] = {.lex_state = 4, .external_lex_state = 2},
  [53] = {.lex_state = 4, .external_lex_state = 2},
  [54] = {.lex_state = 4, .external_lex_state = 2},
  [55] = {.lex_state = 4, .external_lex_state = 2},
  [56] = {.lex_state = 4, .external_lex_state = 2},
  [57] = {.lex_state = 101, .external_lex_state = 2},
  [58] = {.lex_state = 101, .external_lex_state = 2},
  [59] = {.lex_state = 101, .external_lex_state = 2},
  [60] = {.lex_state = 101, .external_lex_state = 2},
  [61] = {.lex_state = 4, .external_lex_state = 2},
  [62] = {.lex_state = 4, .external_lex_state = 2},
  [63] = {.lex_state = 101, .external_lex_state = 2},
  [64] = {.lex_state = 101, .external_lex_state = 2},
  [65] = {.lex_state = 101, .external_lex_state = 2},
  [66] = {.lex_state = 101, .external_lex_state = 2},
  [67] = {.lex_state = 101, .external_lex_state = 2},
  [68] = {.lex_state = 101, .external_lex_state = 2},
  [69] = {.lex_state = 101, .external_lex_state = 2},
  [70] = {.lex_state = 101, .external_lex_state = 2},
  [71] = {.lex_state = 101, .external_lex_state = 2},
  [72] = {.lex_state = 101, .external_lex_state = 2},
  [73] = {.lex_state = 101, .external_lex_state = 2},
  [74] = {.lex_state = 101, .external_lex_state = 2},
  [75] = {.lex_state = 101, .external_lex_state = 2},
  [76] = {.lex_state = 101, .external_lex_state = 2},
  [77] = {.lex_state = 101, .external_lex_state = 2},
  [78] = {.lex_state = 101, .external_lex_state = 2},
  [79] = {.lex_state = 101, .external_lex_state = 2},
  [80] = {.lex_state = 101, .external_lex_state = 2},
  [81] = {.lex_state = 101, .external_lex_state = 2},
  [82] = {.lex_state = 101, .external_lex_state = 2},
  [83] = {.lex_state = 101, .external_lex_state = 2},
  [84] = {.lex_state = 101, .external_lex_state = 2},
  [85] = {.lex_state = 101, .external_lex_state = 2},
  [86] = {.lex_state = 101, .external_lex_state = 2},
  [87] = {.lex_state = 101, .external_lex_state = 2},
  [88] = {.lex_state = 101, .external_lex_state = 2},
  [89] = {.lex_state = 101, .external_lex_state = 2},
  [90] = {.lex_state = 101, .external_lex_state = 2},
  [91] = {.lex_state = 101, .external_lex_state = 2},
  [92] = {.lex_state = 101, .external_lex_state = 2},
  [93] = {.lex_state = 101, .external_lex_state = 2},
  [94] = {.lex_state = 101, .external_lex_state = 2},
  [95] = {.lex_state = 101, .external_lex_state = 2},
  [96] = {.lex_state = 101, .external_lex_state = 2},
  [97] = {.lex_state = 101, .external_lex_state = 2},
  [98] = {.lex_state = 101, .external_lex_state = 2},
  [99] = {.lex_state = 101, .external_lex_state = 2},
  [100] = {.lex_state = 101, .external_lex_state = 2},
  [101] = {.lex_state = 101, .external_lex_state = 2},
  [102] = {.lex_state = 101, .external_lex_state = 2},
  [103] = {.lex_state = 101, .external_lex_state = 2},
  [104] = {.lex_state = 101, .external_lex_state = 2},
  [105] = {.lex_state = 101, .external_lex_state = 2},
  [106] = {.lex_state = 101, .external_lex_state = 2},
  [107] = {.lex_state = 101, .external_lex_state = 2},
  [108] = {.lex_state = 101, .external_lex_state = 2},
  [109] = {.lex_state = 101, .external_lex_state = 2},
  [110] = {.lex_state = 101, .external_lex_state = 2},
  [111] = {.lex_state = 101, .external_lex_state = 2},
  [112] = {.lex_state = 101, .external_lex_state = 2},
  [113] = {.lex_state = 101, .external_lex_state = 2},
  [114] = {.lex_state = 101, .external_lex_state = 2},
  [115] = {.lex_state = 101, .external_lex_state = 2},
  [116] = {.lex_state = 101, .external_lex_state = 2},
  [117] = {.lex_state = 101, .external_lex_state = 2},
  [118] = {.lex_state = 101, .external_lex_state = 2},
  [119] = {.lex_state = 101, .external_lex_state = 2},
  [120] = {.lex_state = 101, .external_lex_state = 2},
  [121] = {.lex_state = 101, .external_lex_state = 2},
  [122] = {.lex_state = 101, .external_lex_state = 2},
  [123] = {.lex_state = 101, .external_lex_state = 2},
  [124] = {.lex_state = 101, .external_lex_state = 2},
  [125] = {.lex_state = 101, .external_lex_state = 2},
  [126] = {.lex_state = 101, .external_lex_state = 2},
  [127] = {.lex_state = 101, .external_lex_state = 2},
  [128] = {.lex_state = 101, .external_lex_state = 2},
  [129] = {.lex_state = 101, .external_lex_state = 2},
  [130] = {.lex_state = 101, .external_lex_state = 2},
  [131] = {.lex_state = 101, .external_lex_state = 2},
  [132] = {.lex_state = 101, .external_lex_state = 2},
  [133] = {.lex_state = 101, .external_lex_state = 2},
  [134] = {.lex_state = 101, .external_lex_state = 2},
  [135] = {.lex_state = 101, .external_lex_state = 2},
  [136] = {.lex_state = 101, .external_lex_state = 2},
  [137] = {.lex_state = 101, .external_lex_state = 2},
  [138] = {.lex_state = 101, .external_lex_state = 2},
  [139] = {.lex_state = 101, .external_lex_state = 2},
  [140] = {.lex_state = 101, .external_lex_state = 2},
  [141] = {.lex_state = 101, .external_lex_state = 2},
  [142] = {.lex_state = 101, .external_lex_state = 2},
  [143] = {.lex_state = 101, .external_lex_state = 2},
  [144] = {.lex_state = 101, .external_lex_state = 2},
  [145] = {.lex_state = 101, .external_lex_state = 2},
  [146] = {.lex_state = 101, .external_lex_state = 2},
  [147] = {.lex_state = 101, .external_lex_state = 2},
  [148] = {.lex_state = 101, .external_lex_state = 2},
  [149] = {.lex_state = 101, .external_lex_state = 2},
  [150] = {.lex_state = 101, .external_lex_state = 2},
  [151] = {.lex_state = 101, .external_lex_state = 2},
  [152] = {.lex_state = 101, .external_lex_state = 2},
  [153] = {.lex_state = 101, .external_lex_state = 2},
  [154] = {.lex_state = 101, .external_lex_state = 2},
  [155] = {.lex_state = 101, .external_lex_state = 2},
  [156] = {.lex_state = 101, .external_lex_state = 2},
  [157] = {.lex_state = 101, .external_lex_state = 2},
  [158] = {.lex_state = 101, .external_lex_state = 2},
  [159] = {.lex_state = 101, .external_lex_state = 2},
  [160] = {.lex_state = 101, .external_lex_state = 2},
  [161] = {.lex_state = 101, .external_lex_state = 2},
  [162] = {.lex_state = 101, .external_lex_state = 2},
  [163] = {.lex_state = 101, .external_lex_state = 2},
  [164] = {.lex_state = 101, .external_lex_state = 2},
  [165] = {.lex_state = 101, .external_lex_state = 2},
  [166] = {.lex_state = 101, .external_lex_state = 2},
  [167] = {.lex_state = 101, .external_lex_state = 2},
  [168] = {.lex_state = 101, .external_lex_state = 2},
  [169] = {.lex_state = 101, .external_lex_state = 2},
  [170] = {.lex_state = 101, .external_lex_state = 2},
  [171] = {.lex_state = 101, .external_lex_state = 2},
  [172] = {.lex_state = 101, .external_lex_state = 2},
  [173] = {.lex_state = 101, .external_lex_state = 2},
  [174] = {.lex_state = 101, .external_lex_state = 2},
  [175] = {.lex_state = 101, .external_lex_state = 2},
  [176] = {.lex_state = 101, .external_lex_state = 2},
  [177] = {.lex_state = 101, .external_lex_state = 2},
  [178] = {.lex_state = 101, .external_lex_state = 2},
  [179] = {.lex_state = 101, .external_lex_state = 2},
  [180] = {.lex_state = 101, .external_lex_state = 2},
  [181] = {.lex_state = 101, .external_lex_state = 2},
  [182] = {.lex_state = 101, .external_lex_state = 2},
  [183] = {.lex_state = 101, .external_lex_state = 2},
  [184] = {.lex_state = 101, .external_lex_state = 2},
  [185] = {.lex_state = 101, .external_lex_state = 2},
  [186] = {.lex_state = 101, .external_lex_state = 2},
  [187] = {.lex_state = 101, .external_lex_state = 2},
  [188] = {.lex_state = 101, .external_lex_state = 2},
  [189] = {.lex_state = 101, .external_lex_state = 2},
  [190] = {.lex_state = 101, .external_lex_state = 2},
  [191] = {.lex_state = 101, .external_lex_state = 2},
  [192] = {.lex_state = 101, .external_lex_state = 2},
  [193] = {.lex_state = 101, .external_lex_state = 2},
  [194] = {.lex_state = 101, .external_lex_state = 2},
  [195] = {.lex_state = 101, .external_lex_state = 2},
  [196] = {.lex_state = 101, .external_lex_state = 2},
  [197] = {.lex_state = 101, .external_lex_state = 2},
  [198] = {.lex_state = 101, .external_lex_state = 2},
  [199] = {.lex_state = 101, .external_lex_state = 2},
  [200] = {.lex_state = 101, .external_lex_state = 2},
  [201] = {.lex_state = 101, .external_lex_state = 2},
  [202] = {.lex_state = 101, .external_lex_state = 2},
  [203] = {.lex_state = 101, .external_lex_state = 2},
  [204] = {.lex_state = 101, .external_lex_state = 2},
  [205] = {.lex_state = 101, .external_lex_state = 2},
  [206] = {.lex_state = 101, .external_lex_state = 2},
  [207] = {.lex_state = 101, .external_lex_state = 2},
  [208] = {.lex_state = 101, .external_lex_state = 2},
  [209] = {.lex_state = 101, .external_lex_state = 2},
  [210] = {.lex_state = 101, .external_lex_state = 2},
  [211] = {.lex_state = 101, .external_lex_state = 2},
  [212] = {.lex_state = 101, .external_lex_state = 2},
  [213] = {.lex_state = 101, .external_lex_state = 2},
  [214] = {.lex_state = 101, .external_lex_state = 2},
  [215] = {.lex_state = 101, .external_lex_state = 2},
  [216] = {.lex_state = 101, .external_lex_state = 2},
  [217] = {.lex_state = 101, .external_lex_state = 2},
  [218] = {.lex_state = 101, .external_lex_state = 2},
  [219] = {.lex_state = 101, .external_lex_state = 2},
  [220] = {.lex_state = 101, .external_lex_state = 2},
  [221] = {.lex_state = 101, .external_lex_state = 2},
  [222] = {.lex_state = 101, .external_lex_state = 2},
  [223] = {.lex_state = 101, .external_lex_state = 2},
  [224] = {.lex_state = 101, .external_lex_state = 2},
  [225] = {.lex_state = 101, .external_lex_state = 2},
  [226] = {.lex_state = 101, .external_lex_state = 2},
  [227] = {.lex_state = 101, .external_lex_state = 2},
  [228] = {.lex_state = 101, .external_lex_state = 2},
  [229] = {.lex_state = 101, .external_lex_state = 2},
  [230] = {.lex_state = 101, .external_lex_state = 2},
  [231] = {.lex_state = 101, .external_lex_state = 2},
  [232] = {.lex_state = 101, .external_lex_state = 2},
  [233] = {.lex_state = 101, .external_lex_state = 2},
  [234] = {.lex_state = 101, .external_lex_state = 2},
  [235] = {.lex_state = 101, .external_lex_state = 2},
  [236] = {.lex_state = 101, .external_lex_state = 2},
  [237] = {.lex_state = 101, .external_lex_state = 2},
  [238] = {.lex_state = 101, .external_lex_state = 2},
  [239] = {.lex_state = 101, .external_lex_state = 2},
  [240] = {.lex_state = 101, .external_lex_state = 2},
  [241] = {.lex_state = 101, .external_lex_state = 2},
  [242] = {.lex_state = 101, .external_lex_state = 2},
  [243] = {.lex_state = 101, .external_lex_state = 2},
  [244] = {.lex_state = 101, .external_lex_state = 2},
  [245] = {.lex_state = 101, .external_lex_state = 2},
  [246] = {.lex_state = 101, .external_lex_state = 2},
  [247] = {.lex_state = 101, .external_lex_state = 2},
  [248] = {.lex_state = 101, .external_lex_state = 2},
  [249] = {.lex_state = 101, .external_lex_state = 2},
  [250] = {.lex_state = 101, .external_lex_state = 2},
  [251] = {.lex_state = 101, .external_lex_state = 2},
  [252] = {.lex_state = 101, .external_lex_state = 2},
  [253] = {.lex_state = 101, .external_lex_state = 2},
  [254] = {.lex_state = 101, .external_lex_state = 2},
  [255] = {.lex_state = 101, .external_lex_state = 2},
  [256] = {.lex_state = 101, .external_lex_state = 2},
  [257] = {.lex_state = 101, .external_lex_state = 2},
  [258] = {.lex_state = 101, .external_lex_state = 2},
  [259] = {.lex_state = 101, .external_lex_state = 2},
  [260] = {.lex_state = 101, .external_lex_state = 2},
  [261] = {.lex_state = 101, .external_lex_state = 2},
  [262] = {.lex_state = 101, .external_lex_state = 2},
  [263] = {.lex_state = 101, .external_lex_state = 2},
  [264] = {.lex_state = 101, .external_lex_state = 2},
  [265] = {.lex_state = 101, .external_lex_state = 2},
  [266] = {.lex_state = 101, .external_lex_state = 2},
  [267] = {.lex_state = 101, .external_lex_state = 2},
  [268] = {.lex_state = 101, .external_lex_state = 2},
  [269] = {.lex_state = 101, .external_lex_state = 2},
  [270] = {.lex_state = 101, .external_lex_state = 2},
  [271] = {.lex_state = 101, .external_lex_state = 2},
  [272] = {.lex_state = 101, .external_lex_state = 2},
  [273] = {.lex_state = 101, .external_lex_state = 2},
  [274] = {.lex_state = 101, .external_lex_state = 2},
  [275] = {.lex_state = 101, .external_lex_state = 2},
  [276] = {.lex_state = 101, .external_lex_state = 2},
  [277] = {.lex_state = 101, .external_lex_state = 2},
  [278] = {.lex_state = 101, .external_lex_state = 2},
  [279] = {.lex_state = 101, .external_lex_state = 2},
  [280] = {.lex_state = 101, .external_lex_state = 2},
  [281] = {.lex_state = 101, .external_lex_state = 2},
  [282] = {.lex_state = 101, .external_lex_state = 2},
  [283] = {.lex_state = 101, .external_lex_state = 2},
  [284] = {.lex_state = 101, .external_lex_state = 2},
  [285] = {.lex_state = 101, .external_lex_state = 2},
  [286] = {.lex_state = 101, .external_lex_state = 2},
  [287] = {.lex_state = 101, .external_lex_state = 2},
  [288] = {.lex_state = 101, .external_lex_state = 2},
  [289] = {.lex_state = 101, .external_lex_state = 2},
  [290] = {.lex_state = 101, .external_lex_state = 2},
  [291] = {.lex_state = 101, .external_lex_state = 2},
  [292] = {.lex_state = 101, .external_lex_state = 2},
  [293] = {.lex_state = 101, .external_lex_state = 2},
  [294] = {.lex_state = 101, .external_lex_state = 2},
  [295] = {.lex_state = 101, .external_lex_state = 2},
  [296] = {.lex_state = 101, .external_lex_state = 2},
  [297] = {.lex_state = 101, .external_lex_state = 2},
  [298] = {.lex_state = 101, .external_lex_state = 2},
  [299] = {.lex_state = 101, .external_lex_state = 2},
  [300] = {.lex_state = 101, .external_lex_state = 2},
  [301] = {.lex_state = 101, .external_lex_state = 2},
  [302] = {.lex_state = 101, .external_lex_state = 2},
  [303] = {.lex_state = 101, .external_lex_state = 2},
  [304] = {.lex_state = 101, .external_lex_state = 2},
  [305] = {.lex_state = 101, .external_lex_state = 2},
  [306] = {.lex_state = 101, .external_lex_state = 2},
  [307] = {.lex_state = 101, .external_lex_state = 2},
  [308] = {.lex_state = 101, .external_lex_state = 2},
  [309] = {.lex_state = 101, .external_lex_state = 2},
  [310] = {.lex_state = 101, .external_lex_state = 2},
  [311] = {.lex_state = 101, .external_lex_state = 2},
  [312] = {.lex_state = 101, .external_lex_state = 2},
  [313] = {.lex_state = 101, .external_lex_state = 2},
  [314] = {.lex_state = 101, .external_lex_state = 2},
  [315] = {.lex_state = 101, .external_lex_state = 2},
  [316] = {.lex_state = 101, .external_lex_state = 2},
  [317] = {.lex_state = 101, .external_lex_state = 2},
  [318] = {.lex_state = 101, .external_lex_state = 2},
  [319] = {.lex_state = 101, .external_lex_state = 2},
  [320] = {.lex_state = 101, .external_lex_state = 2},
  [321] = {.lex_state = 101, .external_lex_state = 2},
  [322] = {.lex_state = 101, .external_lex_state = 2},
  [323] = {.lex_state = 101, .external_lex_state = 2},
  [324] = {.lex_state = 101, .external_lex_state = 2},
  [325] = {.lex_state = 101, .external_lex_state = 2},
  [326] = {.lex_state = 101, .external_lex_state = 2},
  [327] = {.lex_state = 101, .external_lex_state = 2},
  [328] = {.lex_state = 101, .external_lex_state = 2},
  [329] = {.lex_state = 101, .external_lex_state = 2},
  [330] = {.lex_state = 101, .external_lex_state = 2},
  [331] = {.lex_state = 101, .external_lex_state = 2},
  [332] = {.lex_state = 101, .external_lex_state = 2},
  [333] = {.lex_state = 101, .external_lex_state = 2},
  [334] = {.lex_state = 101, .external_lex_state = 2},
  [335] = {.lex_state = 101, .external_lex_state = 2},
  [336] = {.lex_state = 101, .external_lex_state = 2},
  [337] = {.lex_state = 101, .external_lex_state = 2},
  [338] = {.lex_state = 101, .external_lex_state = 2},
  [339] = {.lex_state = 101, .external_lex_state = 2},
  [340] = {.lex_state = 101, .external_lex_state = 2},
  [341] = {.lex_state = 101, .external_lex_state = 2},
  [342] = {.lex_state = 101, .external_lex_state = 2},
  [343] = {.lex_state = 101, .external_lex_state = 2},
  [344] = {.lex_state = 101, .external_lex_state = 2},
  [345] = {.lex_state = 101, .external_lex_state = 2},
  [346] = {.lex_state = 101, .external_lex_state = 2},
  [347] = {.lex_state = 101, .external_lex_state = 2},
  [348] = {.lex_state = 101, .external_lex_state = 2},
  [349] = {.lex_state = 101, .external_lex_state = 2},
  [350] = {.lex_state = 101, .external_lex_state = 2},
  [351] = {.lex_state = 101, .external_lex_state = 2},
  [352] = {.lex_state = 101, .external_lex_state = 2},
  [353] = {.lex_state = 101, .external_lex_state = 2},
  [354] = {.lex_state = 101, .external_lex_state = 2},
  [355] = {.lex_state = 101, .external_lex_state = 2},
  [356] = {.lex_state = 101, .external_lex_state = 2},
  [357] = {.lex_state = 101, .external_lex_state = 2},
  [358] = {.lex_state = 101, .external_lex_state = 2},
  [359] = {.lex_state = 101, .external_lex_state = 2},
  [360] = {.lex_state = 101, .external_lex_state = 2},
  [361] = {.lex_state = 101, .external_lex_state = 2},
  [362] = {.lex_state = 101, .external_lex_state = 2},
  [363] = {.lex_state = 101, .external_lex_state = 2},
  [364] = {.lex_state = 101, .external_lex_state = 2},
  [365] = {.lex_state = 101, .external_lex_state = 2},
  [366] = {.lex_state = 101, .external_lex_state = 2},
  [367] = {.lex_state = 101, .external_lex_state = 2},
  [368] = {.lex_state = 101, .external_lex_state = 2},
  [369] = {.lex_state = 101, .external_lex_state = 2},
  [370] = {.lex_state = 101, .external_lex_state = 2},
  [371] = {.lex_state = 101, .external_lex_state = 2},
  [372] = {.lex_state = 101, .external_lex_state = 2},
  [373] = {.lex_state = 101, .external_lex_state = 2},
  [374] = {.lex_state = 25, .external_lex_state = 2},
  [375] = {.lex_state = 4, .external_lex_state = 2},
  [376] = {.lex_state = 25, .external_lex_state = 2},
  [377] = {.lex_state = 25, .external_lex_state = 2},
  [378] = {.lex_state = 3, .external_lex_state = 2},
  [379] = {.lex_state = 25, .external_lex_state = 2},
  [380] = {.lex_state = 25, .external_lex_state = 2},
  [381] = {.lex_state = 25, .external_lex_state = 2},
  [382] = {.lex_state = 3, .external_lex_state = 2},
  [383] = {.lex_state = 25, .external_lex_state = 2},
  [384] = {.lex_state = 25, .external_lex_state = 2},
  [385] = {.lex_state = 25, .external_lex_state = 2},
  [386] = {.lex_state = 25, .external_lex_state = 2},
  [387] = {.lex_state = 25, .external_lex_state = 2},
  [388] = {.lex_state = 25, .external_lex_state = 2},
  [389] = {.lex_state = 25, .external_lex_state = 2},
  [390] = {.lex_state = 25, .external_lex_state = 2},
  [391] = {.lex_state = 25, .external_lex_state = 2},
  [392] = {.lex_state = 25, .external_lex_state = 2},
  [393] = {.lex_state = 25, .external_lex_state = 2},
  [394] = {.lex_state = 25, .external_lex_state = 2},
  [395] = {.lex_state = 25, .external_lex_state = 2},
  [396] = {.lex_state = 25, .external_lex_state = 2},
  [397] = {.lex_state = 25, .external_lex_state = 2},
  [398] = {.lex_state = 25, .external_lex_state = 2},
  [399] = {.lex_state = 25, .external_lex_state = 2},
  [400] = {.lex_state = 25, .external_lex_state = 2},
  [401] = {.lex_state = 25, .external_lex_state = 2},
  [402] = {.lex_state = 25, .external_lex_state = 2},
  [403] = {.lex_state = 25, .external_lex_state = 2},
  [404] = {.lex_state = 25, .external_lex_state = 2},
  [405] = {.lex_state = 25, .external_lex_state = 2},
  [406] = {.lex_state = 25, .external_lex_state = 2},
  [407] = {.lex_state = 25, .external_lex_state = 2},
  [408] = {.lex_state = 25, .external_lex_state = 2},
  [409] = {.lex_state = 25, .external_lex_state = 2},
  [410] = {.lex_state = 101, .external_lex_state = 2},
  [411] = {.lex_state = 101, .external_lex_state = 2},
  [412] = {.lex_state = 25, .external_lex_state = 2},
  [413] = {.lex_state = 101, .external_lex_state = 2},
  [414] = {.lex_state = 101, .external_lex_state = 2},
  [415] = {.lex_state = 25, .external_lex_state = 2},
  [416] = {.lex_state = 25, .external_lex_state = 2},
  [417] = {.lex_state = 101, .external_lex_state = 2},
  [418] = {.lex_state = 25, .external_lex_state = 2},
  [419] = {.lex_state = 101, .external_lex_state = 2},
  [420] = {.lex_state = 101, .external_lex_state = 2},
  [421] = {.lex_state = 101, .external_lex_state = 2},
  [422] = {.lex_state = 25, .external_lex_state = 2},
  [423] = {.lex_state = 25, .external_lex_state = 2},
  [424] = {.lex_state = 101, .external_lex_state = 2},
  [425] = {.lex_state = 101, .external_lex_state = 2},
  [426] = {.lex_state = 101, .external_lex_state = 2},
  [427] = {.lex_state = 101, .external_lex_state = 2},
  [428] = {.lex_state = 101, .external_lex_state = 2},
  [429] = {.lex_state = 101, .external_lex_state = 2},
  [430] = {.lex_state = 101, .external_lex_state = 2},
  [431] = {.lex_state = 101, .external_lex_state = 2},
  [432] = {.lex_state = 101, .external_lex_state = 2},
  [433] = {.lex_state = 101, .external_lex_state = 2},
  [434] = {.lex_state = 101, .external_lex_state = 2},
  [435] = {.lex_state = 100, .external_lex_state = 2},
  [436] = {.lex_state = 25, .external_lex_state = 2},
  [437] = {.lex_state = 25, .external_lex_state = 2},
  [438] = {.lex_state = 100, .external_lex_state = 2},
  [439] = {.lex_state = 100, .external_lex_state = 2},
  [440] = {.lex_state = 100, .external_lex_state = 2},
  [441] = {.lex_state = 100, .external_lex_state = 2},
  [442] = {.lex_state = 100, .external_lex_state = 2},
  [443] = {.lex_state = 102, .external_lex_state = 2},
  [444] = {.lex_state = 102, .external_lex_state = 2},
  [445] = {.lex_state = 101, .external_lex_state = 2},
  [446] = {.lex_state = 101, .external_lex_state = 2},
  [447] = {.lex_state = 101, .external_lex_state = 2},
  [448] = {.lex_state = 101, .external_lex_state = 2},
  [449] = {.lex_state = 101, .external_lex_state = 2},
  [450] = {.lex_state = 100, .external_lex_state = 2},
  [451] = {.lex_state = 100, .external_lex_state = 2},
  [452] = {.lex_state = 100, .external_lex_state = 2},
  [453] = {.lex_state = 10, .external_lex_state = 2},
  [454] = {.lex_state = 100, .external_lex_state = 2},
  [455] = {.lex_state = 10, .external_lex_state = 2},
  [456] = {.lex_state = 101, .external_lex_state = 2},
  [457] = {.lex_state = 101, .external_lex_state = 2},
  [458] = {.lex_state = 101, .external_lex_state = 2},
  [459] = {.lex_state = 101, .external_lex_state = 2},
  [460] = {.lex_state = 101, .external_lex_state = 2},
  [461] = {.lex_state = 101, .external_lex_state = 2},
  [462] = {.lex_state = 100, .external_lex_state = 2},
  [463] = {.lex_state = 100, .external_lex_state = 2},
  [464] = {.lex_state = 101, .external_lex_state = 2},
  [465] = {.lex_state = 100, .external_lex_state = 2},
  [466] = {.lex_state = 12, .external_lex_state = 2},
  [467] = {.lex_state = 12, .external_lex_state = 2},
  [468] = {.lex_state = 100, .external_lex_state = 2},
  [469] = {.lex_state = 100, .external_lex_state = 2},
  [470] = {.lex_state = 101, .external_lex_state = 2},
  [471] = {.lex_state = 10, .external_lex_state = 2},
  [472] = {.lex_state = 10, .external_lex_state = 2},
  [473] = {.lex_state = 6, .external_lex_state = 2},
  [474] = {.lex_state = 6, .external_lex_state = 2},
  [475] = {.lex_state = 101, .external_lex_state = 2},
  [476] = {.lex_state = 101, .external_lex_state = 2},
  [477] = {.lex_state = 101, .external_lex_state = 2},
  [478] = {.lex_state = 101, .external_lex_state = 2},
  [479] = {.lex_state = 101, .external_lex_state = 2},
  [480] = {.lex_state = 101, .external_lex_state = 2},
  [481] = {.lex_state = 6, .external_lex_state = 2},
  [482] = {.lex_state = 101, .external_lex_state = 2},
  [483] = {.lex_state = 10, .external_lex_state = 2},
  [484] = {.lex_state = 101, .external_lex_state = 2},
  [485] = {.lex_state = 101, .external_lex_state = 2},
  [486] = {.lex_state = 101, .external_lex_state = 2},
  [487] = {.lex_state = 12, .external_lex_state = 2},
  [488] = {.lex_state = 101, .external_lex_state = 2},
  [489] = {.lex_state = 9, .external_lex_state = 2},
  [490] = {.lex_state = 12, .external_lex_state = 2},
  [491] = {.lex_state = 101, .external_lex_state = 2},
  [492] = {.lex_state = 101, .external_lex_state = 2},
  [493] = {.lex_state = 101, .external_lex_state = 2},
  [494] = {.lex_state = 6, .external_lex_state = 2},
  [495] = {.lex_state = 6, .external_lex_state = 2},
  [496] = {.lex_state = 10, .external_lex_state = 2},
  [497] = {.lex_state = 10, .external_lex_state = 2},
  [498] = {.lex_state = 6, .external_lex_state = 2},
  [499] = {.lex_state = 10, .external_lex_state = 2},
  [500] = {.lex_state = 6, .external_lex_state = 2},
  [501] = {.lex_state = 6, .external_lex_state = 2},
  [502] = {.lex_state = 6, .external_lex_state = 2},
  [503] = {.lex_state = 6, .external_lex_state = 2},
  [504] = {.lex_state = 6, .external_lex_state = 2},
  [505] = {.lex_state = 6, .external_lex_state = 2},
  [506] = {.lex_state = 6, .external_lex_state = 2},
  [507] = {.lex_state = 6, .external_lex_state = 2},
  [508] = {.lex_state = 7, .external_lex_state = 2},
  [509] = {.lex_state = 12, .external_lex_state = 2},
  [510] = {.lex_state = 6, .external_lex_state = 2},
  [511] = {.lex_state = 101, .external_lex_state = 2},
  [512] = {.lex_state = 101, .external_lex_state = 2},
  [513] = {.lex_state = 9, .external_lex_state = 2},
  [514] = {.lex_state = 9, .external_lex_state = 2},
  [515] = {.lex_state = 9, .external_lex_state = 2},
  [516] = {.lex_state = 9, .external_lex_state = 2},
  [517] = {.lex_state = 9, .external_lex_state = 2},
  [518] = {.lex_state = 101, .external_lex_state = 2},
  [519] = {.lex_state = 101, .external_lex_state = 2},
  [520] = {.lex_state = 101, .external_lex_state = 2},
  [521] = {.lex_state = 9, .external_lex_state = 2},
  [522] = {.lex_state = 101, .external_lex_state = 2},
  [523] = {.lex_state = 101, .external_lex_state = 2},
  [524] = {.lex_state = 101, .external_lex_state = 2},
  [525] = {.lex_state = 101, .external_lex_state = 2},
  [526] = {.lex_state = 101, .external_lex_state = 2},
  [527] = {.lex_state = 101, .external_lex_state = 2},
  [528] = {.lex_state = 101, .external_lex_state = 2},
  [529] = {.lex_state = 101, .external_lex_state = 2},
  [530] = {.lex_state = 101, .external_lex_state = 2},
  [531] = {.lex_state = 101, .external_lex_state = 2},
  [532] = {.lex_state = 9, .external_lex_state = 2},
  [533] = {.lex_state = 101, .external_lex_state = 2},
  [534] = {.lex_state = 101, .external_lex_state = 2},
  [535] = {.lex_state = 101, .external_lex_state = 2},
  [536] = {.lex_state = 101, .external_lex_state = 2},
  [537] = {.lex_state = 101, .external_lex_state = 2},
  [538] = {.lex_state = 101, .external_lex_state = 2},
  [539] = {.lex_state = 101, .external_lex_state = 2},
  [540] = {.lex_state = 101, .external_lex_state = 2},
  [541] = {.lex_state = 101, .external_lex_state = 2},
  [542] = {.lex_state = 101, .external_lex_state = 2},
  [543] = {.lex_state = 101, .external_lex_state = 2},
  [544] = {.lex_state = 101, .external_lex_state = 2},
  [545] = {.lex_state = 101, .external_lex_state = 2},
  [546] = {.lex_state = 101, .external_lex_state = 2},
  [547] = {.lex_state = 101, .external_lex_state = 2},
  [548] = {.lex_state = 101, .external_lex_state = 2},
  [549] = {.lex_state = 101, .external_lex_state = 2},
  [550] = {.lex_state = 100, .external_lex_state = 2},
  [551] = {.lex_state = 101, .external_lex_state = 2},
  [552] = {.lex_state = 9, .external_lex_state = 2},
  [553] = {.lex_state = 7, .external_lex_state = 2},
  [554] = {.lex_state = 7, .external_lex_state = 2},
  [555] = {.lex_state = 7, .external_lex_state = 2},
  [556] = {.lex_state = 101, .external_lex_state = 2},
  [557] = {.lex_state = 7, .external_lex_state = 2},
  [558] = {.lex_state = 7, .external_lex_state = 2},
  [559] = {.lex_state = 7, .external_lex_state = 2},
  [560] = {.lex_state = 100, .external_lex_state = 2},
  [561] = {.lex_state = 12, .external_lex_state = 2},
  [562] = {.lex_state = 7, .external_lex_state = 2},
  [563] = {.lex_state = 9, .external_lex_state = 2},
  [564] = {.lex_state = 7, .external_lex_state = 2},
  [565] = {.lex_state = 9, .external_lex_state = 2},
  [566] = {.lex_state = 12, .external_lex_state = 2},
  [567] = {.lex_state = 9, .external_lex_state = 2},
  [568] = {.lex_state = 9, .external_lex_state = 2},
  [569] = {.lex_state = 7, .external_lex_state = 2},
  [570] = {.lex_state = 9, .external_lex_state = 2},
  [571] = {.lex_state = 102, .external_lex_state = 2},
  [572] = {.lex_state = 7, .external_lex_state = 2},
  [573] = {.lex_state = 12, .external_lex_state = 2},
  [574] = {.lex_state = 7, .external_lex_state = 2},
  [575] = {.lex_state = 9, .external_lex_state = 2},
  [576] = {.lex_state = 9, .external_lex_state = 2},
  [577] = {.lex_state = 101, .external_lex_state = 2},
  [578] = {.lex_state = 10, .external_lex_state = 2},
  [579] = {.lex_state = 10, .external_lex_state = 2},
  [580] = {.lex_state = 10, .external_lex_state = 2},
  [581] = {.lex_state = 10, .external_lex_state = 2},
  [582] = {.lex_state = 10, .external_lex_state = 2},
  [583] = {.lex_state = 10, .external_lex_state = 2},
  [584] = {.lex_state = 10, .external_lex_state = 2},
  [585] = {.lex_state = 10, .external_lex_state = 2},
  [586] = {.lex_state = 101, .external_lex_state = 2},
  [587] = {.lex_state = 10, .external_lex_state = 2},
  [588] = {.lex_state = 101, .external_lex_state = 2},
  [589] = {.lex_state = 101, .external_lex_state = 2},
  [590] = {.lex_state = 101, .external_lex_state = 2},
  [591] = {.lex_state = 10, .external_lex_state = 2},
  [592] = {.lex_state = 7, .external_lex_state = 2},
  [593] = {.lex_state = 101, .external_lex_state = 2},
  [594] = {.lex_state = 10, .external_lex_state = 2},
  [595] = {.lex_state = 7, .external_lex_state = 2},
  [596] = {.lex_state = 101, .external_lex_state = 2},
  [597] = {.lex_state = 101, .external_lex_state = 2},
  [598] = {.lex_state = 101, .external_lex_state = 2},
  [599] = {.lex_state = 101, .external_lex_state = 2},
  [600] = {.lex_state = 10, .external_lex_state = 2},
  [601] = {.lex_state = 101, .external_lex_state = 2},
  [602] = {.lex_state = 10, .external_lex_state = 2},
  [603] = {.lex_state = 101, .external_lex_state = 2},
  [604] = {.lex_state = 11, .external_lex_state = 2},
  [605] = {.lex_state = 11, .external_lex_state = 2},
  [606] = {.lex_state = 101, .external_lex_state = 2},
  [607] = {.lex_state = 11, .external_lex_state = 2},
  [608] = {.lex_state = 6, .external_lex_state = 2},
  [609] = {.lex_state = 5, .external_lex_state = 2},
  [610] = {.lex_state = 5, .external_lex_state = 2},
  [611] = {.lex_state = 11, .external_lex_state = 2},
  [612] = {.lex_state = 11, .external_lex_state = 2},
  [613] = {.lex_state = 6, .external_lex_state = 2},
  [614] = {.lex_state = 11, .external_lex_state = 2},
  [615] = {.lex_state = 6, .external_lex_state = 2},
  [616] = {.lex_state = 6, .external_lex_state = 2},
  [617] = {.lex_state = 6, .external_lex_state = 2},
  [618] = {.lex_state = 9, .external_lex_state = 2},
  [619] = {.lex_state = 6, .external_lex_state = 2},
  [620] = {.lex_state = 11, .external_lex_state = 2},
  [621] = {.lex_state = 11, .external_lex_state = 2},
  [622] = {.lex_state = 11, .external_lex_state = 2},
  [623] = {.lex_state = 11, .external_lex_state = 2},
  [624] = {.lex_state = 6, .external_lex_state = 2},
  [625] = {.lex_state = 6, .external_lex_state = 2},
  [626] = {.lex_state = 6, .external_lex_state = 2},
  [627] = {.lex_state = 6, .external_lex_state = 2},
  [628] = {.lex_state = 6, .external_lex_state = 2},
  [629] = {.lex_state = 9, .external_lex_state = 2},
  [630] = {.lex_state = 9, .external_lex_state = 2},
  [631] = {.lex_state = 6, .external_lex_state = 2},
  [632] = {.lex_state = 6, .external_lex_state = 2},
  [633] = {.lex_state = 6, .external_lex_state = 2},
  [634] = {.lex_state = 6, .external_lex_state = 2},
  [635] = {.lex_state = 6, .external_lex_state = 2},
  [636] = {.lex_state = 6, .external_lex_state = 2},
  [637] = {.lex_state = 12, .external_lex_state = 2},
  [638] = {.lex_state = 12, .external_lex_state = 2},
  [639] = {.lex_state = 12, .external_lex_state = 2},
  [640] = {.lex_state = 8, .external_lex_state = 2},
  [641] = {.lex_state = 12, .external_lex_state = 2},
  [642] = {.lex_state = 9, .external_lex_state = 2},
  [643] = {.lex_state = 6, .external_lex_state = 2},
  [644] = {.lex_state = 12, .external_lex_state = 2},
  [645] = {.lex_state = 9, .external_lex_state = 2},
  [646] = {.lex_state = 12, .external_lex_state = 2},
  [647] = {.lex_state = 12, .external_lex_state = 2},
  [648] = {.lex_state = 6, .external_lex_state = 2},
  [649] = {.lex_state = 12, .external_lex_state = 2},
  [650] = {.lex_state = 12, .external_lex_state = 2},
  [651] = {.lex_state = 12, .external_lex_state = 2},
  [652] = {.lex_state = 12, .external_lex_state = 2},
  [653] = {.lex_state = 12, .external_lex_state = 2},
  [654] = {.lex_state = 6, .external_lex_state = 2},
  [655] = {.lex_state = 9, .external_lex_state = 2},
  [656] = {.lex_state = 9, .external_lex_state = 2},
  [657] = {.lex_state = 12, .external_lex_state = 2},
  [658] = {.lex_state = 9, .external_lex_state = 2},
  [659] = {.lex_state = 6, .external_lex_state = 2},
  [660] = {.lex_state = 27, .external_lex_state = 2},
  [661] = {.lex_state = 8, .external_lex_state = 2},
  [662] = {.lex_state = 8, .external_lex_state = 2},
  [663] = {.lex_state = 6, .external_lex_state = 2},
  [664] = {.lex_state = 6, .external_lex_state = 2},
  [665] = {.lex_state = 8, .external_lex_state = 2},
  [666] = {.lex_state = 8, .external_lex_state = 2},
  [667] = {.lex_state = 100, .external_lex_state = 2},
  [668] = {.lex_state = 6, .external_lex_state = 2},
  [669] = {.lex_state = 6, .external_lex_state = 2},
  [670] = {.lex_state = 6, .external_lex_state = 2},
  [671] = {.lex_state = 8, .external_lex_state = 2},
  [672] = {.lex_state = 6, .external_lex_state = 2},
  [673] = {.lex_state = 8, .external_lex_state = 2},
  [674] = {.lex_state = 6, .external_lex_state = 2},
  [675] = {.lex_state = 8, .external_lex_state = 2},
  [676] = {.lex_state = 8, .external_lex_state = 2},
  [677] = {.lex_state = 101, .external_lex_state = 2},
  [678] = {.lex_state = 9, .external_lex_state = 2},
  [679] = {.lex_state = 6, .external_lex_state = 2},
  [680] = {.lex_state = 100, .external_lex_state = 2},
  [681] = {.lex_state = 9, .external_lex_state = 2},
  [682] = {.lex_state = 6, .external_lex_state = 2},
  [683] = {.lex_state = 27, .external_lex_state = 2},
  [684] = {.lex_state = 7, .external_lex_state = 2},
  [685] = {.lex_state = 101, .external_lex_state = 2},
  [686] = {.lex_state = 27, .external_lex_state = 2},
  [687] = {.lex_state = 101, .external_lex_state = 2},
  [688] = {.lex_state = 27, .external_lex_state = 2},
  [689] = {.lex_state = 27, .external_lex_state = 2},
  [690] = {.lex_state = 7, .external_lex_state = 2},
  [691] = {.lex_state = 7, .external_lex_state = 2},
  [692] = {.lex_state = 27, .external_lex_state = 2},
  [693] = {.lex_state = 28, .external_lex_state = 2},
  [694] = {.lex_state = 27, .external_lex_state = 2},
  [695] = {.lex_state = 27, .external_lex_state = 2},
  [696] = {.lex_state = 101, .external_lex_state = 2},
  [697] = {.lex_state = 27, .external_lex_state = 2},
  [698] = {.lex_state = 27, .external_lex_state = 2},
  [699] = {.lex_state = 7, .external_lex_state = 2},
  [700] = {.lex_state = 27, .external_lex_state = 2},
  [701] = {.lex_state = 7, .external_lex_state = 2},
  [702] = {.lex_state = 28, .external_lex_state = 2},
  [703] = {.lex_state = 7, .external_lex_state = 2},
  [704] = {.lex_state = 27, .external_lex_state = 2},
  [705] = {.lex_state = 7, .external_lex_state = 2},
  [706] = {.lex_state = 7, .external_lex_state = 2},
  [707] = {.lex_state = 7, .external_lex_state = 2},
  [708] = {.lex_state = 7, .external_lex_state = 2},
  [709] = {.lex_state = 101, .external_lex_state = 2},
  [710] = {.lex_state = 7, .external_lex_state = 2},
  [711] = {.lex_state = 7, .external_lex_state = 2},
  [712] = {.lex_state = 7, .external_lex_state = 2},
  [713] = {.lex_state = 28, .external_lex_state = 2},
  [714] = {.lex_state = 28, .external_lex_state = 2},
  [715] = {.lex_state = 28, .external_lex_state = 2},
  [716] = {.lex_state = 5, .external_lex_state = 2},
  [717] = {.lex_state = 5, .external_lex_state = 2},
  [718] = {.lex_state = 28, .external_lex_state = 2},
  [719] = {.lex_state = 5, .external_lex_state = 2},
  [720] = {.lex_state = 28, .external_lex_state = 2},
  [721] = {.lex_state = 28, .external_lex_state = 2},
  [722] = {.lex_state = 6, .external_lex_state = 2},
  [723] = {.lex_state = 28, .external_lex_state = 2},
  [724] = {.lex_state = 28, .external_lex_state = 2},
  [725] = {.lex_state = 28, .external_lex_state = 2},
  [726] = {.lex_state = 28, .external_lex_state = 2},
  [727] = {.lex_state = 28, .external_lex_state = 2},
  [728] = {.lex_state = 5, .external_lex_state = 2},
  [729] = {.lex_state = 7, .external_lex_state = 2},
  [730] = {.lex_state = 7, .external_lex_state = 2},
  [731] = {.lex_state = 7, .external_lex_state = 2},
  [732] = {.lex_state = 7, .external_lex_state = 2},
  [733] = {.lex_state = 7, .external_lex_state = 2},
  [734] = {.lex_state = 7, .external_lex_state = 2},
  [735] = {.lex_state = 7, .external_lex_state = 2},
  [736] = {.lex_state = 7, .external_lex_state = 2},
  [737] = {.lex_state = 7, .external_lex_state = 2},
  [738] = {.lex_state = 7, .external_lex_state = 2},
  [739] = {.lex_state = 7, .external_lex_state = 2},
  [740] = {.lex_state = 7, .external_lex_state = 2},
  [741] = {.lex_state = 5, .external_lex_state = 2},
  [742] = {.lex_state = 5, .external_lex_state = 2},
  [743] = {.lex_state = 7, .external_lex_state = 2},
  [744] = {.lex_state = 5, .external_lex_state = 2},
  [745] = {.lex_state = 7, .external_lex_state = 2},
  [746] = {.lex_state = 7, .external_lex_state = 2},
  [747] = {.lex_state = 7, .external_lex_state = 2},
  [748] = {.lex_state = 5, .external_lex_state = 2},
  [749] = {.lex_state = 5, .external_lex_state = 2},
  [750] = {.lex_state = 7, .external_lex_state = 2},
  [751] = {.lex_state = 101, .external_lex_state = 2},
  [752] = {.lex_state = 6, .external_lex_state = 2},
  [753] = {.lex_state = 26, .external_lex_state = 2},
  [754] = {.lex_state = 26, .external_lex_state = 2},
  [755] = {.lex_state = 26, .external_lex_state = 2},
  [756] = {.lex_state = 6, .external_lex_state = 2},
  [757] = {.lex_state = 6, .external_lex_state = 2},
  [758] = {.lex_state = 6, .external_lex_state = 2},
  [759] = {.lex_state = 23, .external_lex_state = 2},
  [760] = {.lex_state = 26, .external_lex_state = 2},
  [761] = {.lex_state = 6, .external_lex_state = 2},
  [762] = {.lex_state = 26, .external_lex_state = 2},
  [763] = {.lex_state = 26, .external_lex_state = 2},
  [764] = {.lex_state = 101, .external_lex_state = 2},
  [765] = {.lex_state = 26, .external_lex_state = 2},
  [766] = {.lex_state = 6, .external_lex_state = 2},
  [767] = {.lex_state = 6, .external_lex_state = 2},
  [768] = {.lex_state = 6, .external_lex_state = 2},
  [769] = {.lex_state = 26, .external_lex_state = 2},
  [770] = {.lex_state = 26, .external_lex_state = 2},
  [771] = {.lex_state = 26, .external_lex_state = 2},
  [772] = {.lex_state = 6, .external_lex_state = 2},
  [773] = {.lex_state = 26, .external_lex_state = 2},
  [774] = {.lex_state = 6, .external_lex_state = 2},
  [775] = {.lex_state = 26, .external_lex_state = 2},
  [776] = {.lex_state = 6, .external_lex_state = 2},
  [777] = {.lex_state = 6, .external_lex_state = 2},
  [778] = {.lex_state = 6, .external_lex_state = 2},
  [779] = {.lex_state = 6, .external_lex_state = 2},
  [780] = {.lex_state = 6, .external_lex_state = 2},
  [781] = {.lex_state = 23, .external_lex_state = 2},
  [782] = {.lex_state = 6, .external_lex_state = 2},
  [783] = {.lex_state = 101, .external_lex_state = 2},
  [784] = {.lex_state = 6, .external_lex_state = 2},
  [785] = {.lex_state = 27, .external_lex_state = 2},
  [786] = {.lex_state = 101, .external_lex_state = 2},
  [787] = {.lex_state = 6, .external_lex_state = 2},
  [788] = {.lex_state = 101, .external_lex_state = 2},
  [789] = {.lex_state = 6, .external_lex_state = 2},
  [790] = {.lex_state = 27, .external_lex_state = 2},
  [791] = {.lex_state = 6, .external_lex_state = 2},
  [792] = {.lex_state = 6, .external_lex_state = 2},
  [793] = {.lex_state = 6, .external_lex_state = 2},
  [794] = {.lex_state = 5, .external_lex_state = 2},
  [795] = {.lex_state = 6, .external_lex_state = 2},
  [796] = {.lex_state = 5, .external_lex_state = 2},
  [797] = {.lex_state = 6, .external_lex_state = 2},
  [798] = {.lex_state = 5, .external_lex_state = 2},
  [799] = {.lex_state = 5, .external_lex_state = 2},
  [800] = {.lex_state = 101, .external_lex_state = 2},
  [801] = {.lex_state = 6, .external_lex_state = 2},
  [802] = {.lex_state = 5, .external_lex_state = 2},
  [803] = {.lex_state = 5, .external_lex_state = 2},
  [804] = {.lex_state = 5, .external_lex_state = 2},
  [805] = {.lex_state = 6, .external_lex_state = 2},
  [806] = {.lex_state = 5, .external_lex_state = 2},
  [807] = {.lex_state = 5, .external_lex_state = 2},
  [808] = {.lex_state = 5, .external_lex_state = 2},
  [809] = {.lex_state = 5, .external_lex_state = 2},
  [810] = {.lex_state = 5, .external_lex_state = 2},
  [811] = {.lex_state = 5, .external_lex_state = 2},
  [812] = {.lex_state = 5, .external_lex_state = 2},
  [813] = {.lex_state = 5, .external_lex_state = 2},
  [814] = {.lex_state = 5, .external_lex_state = 2},
  [815] = {.lex_state = 5, .external_lex_state = 2},
  [816] = {.lex_state = 6, .external_lex_state = 2},
  [817] = {.lex_state = 6, .external_lex_state = 2},
  [818] = {.lex_state = 6, .external_lex_state = 2},
  [819] = {.lex_state = 6, .external_lex_state = 2},
  [820] = {.lex_state = 6, .external_lex_state = 2},
  [821] = {.lex_state = 6, .external_lex_state = 2},
  [822] = {.lex_state = 6, .external_lex_state = 2},
  [823] = {.lex_state = 22, .external_lex_state = 2},
  [824] = {.lex_state = 6, .external_lex_state = 2},
  [825] = {.lex_state = 101, .external_lex_state = 2},
  [826] = {.lex_state = 101, .external_lex_state = 2},
  [827] = {.lex_state = 6, .external_lex_state = 2},
  [828] = {.lex_state = 6, .external_lex_state = 2},
  [829] = {.lex_state = 6, .external_lex_state = 2},
  [830] = {.lex_state = 22, .external_lex_state = 2},
  [831] = {.lex_state = 101, .external_lex_state = 2},
  [832] = {.lex_state = 14, .external_lex_state = 2},
  [833] = {.lex_state = 6, .external_lex_state = 2},
  [834] = {.lex_state = 6, .external_lex_state = 2},
  [835] = {.lex_state = 6, .external_lex_state = 2},
  [836] = {.lex_state = 14, .external_lex_state = 2},
  [837] = {.lex_state = 101, .external_lex_state = 2},
  [838] = {.lex_state = 6, .external_lex_state = 2},
  [839] = {.lex_state = 6, .external_lex_state = 2},
  [840] = {.lex_state = 6, .external_lex_state = 2},
  [841] = {.lex_state = 6, .external_lex_state = 2},
  [842] = {.lex_state = 6, .external_lex_state = 2},
  [843] = {.lex_state = 7, .external_lex_state = 2},
  [844] = {.lex_state = 6, .external_lex_state = 2},
  [845] = {.lex_state = 6, .external_lex_state = 2},
  [846] = {.lex_state = 7, .external_lex_state = 2},
  [847] = {.lex_state = 6, .external_lex_state = 2},
  [848] = {.lex_state = 6, .external_lex_state = 2},
  [849] = {.lex_state = 6, .external_lex_state = 2},
  [850] = {.lex_state = 14, .external_lex_state = 2},
  [851] = {.lex_state = 7, .external_lex_state = 2},
  [852] = {.lex_state = 6, .external_lex_state = 2},
  [853] = {.lex_state = 6, .external_lex_state = 2},
  [854] = {.lex_state = 6, .external_lex_state = 2},
  [855] = {.lex_state = 6, .external_lex_state = 2},
  [856] = {.lex_state = 6, .external_lex_state = 2},
  [857] = {.lex_state = 6, .external_lex_state = 2},
  [858] = {.lex_state = 14, .external_lex_state = 2},
  [859] = {.lex_state = 14, .external_lex_state = 2},
  [860] = {.lex_state = 6, .external_lex_state = 2},
  [861] = {.lex_state = 6, .external_lex_state = 2},
  [862] = {.lex_state = 6, .external_lex_state = 2},
  [863] = {.lex_state = 6, .external_lex_state = 2},
  [864] = {.lex_state = 6, .external_lex_state = 2},
  [865] = {.lex_state = 6, .external_lex_state = 2},
  [866] = {.lex_state = 6, .external_lex_state = 2},
  [867] = {.lex_state = 7, .external_lex_state = 2},
  [868] = {.lex_state = 6, .external_lex_state = 2},
  [869] = {.lex_state = 6, .external_lex_state = 2},
  [870] = {.lex_state = 6, .external_lex_state = 2},
  [871] = {.lex_state = 14, .external_lex_state = 2},
  [872] = {.lex_state = 6, .external_lex_state = 2},
  [873] = {.lex_state = 14, .external_lex_state = 2},
  [874] = {.lex_state = 22, .external_lex_state = 2},
  [875] = {.lex_state = 14, .external_lex_state = 2},
  [876] = {.lex_state = 14, .external_lex_state = 2},
  [877] = {.lex_state = 6, .external_lex_state = 2},
  [878] = {.lex_state = 7, .external_lex_state = 2},
  [879] = {.lex_state = 6, .external_lex_state = 2},
  [880] = {.lex_state = 6, .external_lex_state = 2},
  [881] = {.lex_state = 6, .external_lex_state = 2},
  [882] = {.lex_state = 6, .external_lex_state = 2},
  [883] = {.lex_state = 6, .external_lex_state = 2},
  [884] = {.lex_state = 6, .external_lex_state = 2},
  [885] = {.lex_state = 6, .external_lex_state = 2},
  [886] = {.lex_state = 6, .external_lex_state = 2},
  [887] = {.lex_state = 6, .external_lex_state = 2},
  [888] = {.lex_state = 6, .external_lex_state = 2},
  [889] = {.lex_state = 6, .external_lex_state = 2},
  [890] = {.lex_state = 101, .external_lex_state = 2},
  [891] = {.lex_state = 6, .external_lex_state = 2},
  [892] = {.lex_state = 6, .external_lex_state = 2},
  [893] = {.lex_state = 6, .external_lex_state = 2},
  [894] = {.lex_state = 6, .external_lex_state = 2},
  [895] = {.lex_state = 6, .external_lex_state = 2},
  [896] = {.lex_state = 6, .external_lex_state = 2},
  [897] = {.lex_state = 6, .external_lex_state = 2},
  [898] = {.lex_state = 6, .external_lex_state = 2},
  [899] = {.lex_state = 6, .external_lex_state = 2},
  [900] = {.lex_state = 6, .external_lex_state = 2},
  [901] = {.lex_state = 6, .external_lex_state = 2},
  [902] = {.lex_state = 7, .external_lex_state = 2},
  [903] = {.lex_state = 6, .external_lex_state = 2},
  [904] = {.lex_state = 6, .external_lex_state = 2},
  [905] = {.lex_state = 6, .external_lex_state = 2},
  [906] = {.lex_state = 6, .external_lex_state = 2},
  [907] = {.lex_state = 6, .external_lex_state = 2},
  [908] = {.lex_state = 6, .external_lex_state = 2},
  [909] = {.lex_state = 6, .external_lex_state = 2},
  [910] = {.lex_state = 101, .external_lex_state = 2},
  [911] = {.lex_state = 6, .external_lex_state = 2},
  [912] = {.lex_state = 6, .external_lex_state = 2},
  [913] = {.lex_state = 6, .external_lex_state = 2},
  [914] = {.lex_state = 6, .external_lex_state = 2},
  [915] = {.lex_state = 6, .external_lex_state = 2},
  [916] = {.lex_state = 6, .external_lex_state = 2},
  [917] = {.lex_state = 6, .external_lex_state = 2},
  [918] = {.lex_state = 6, .external_lex_state = 2},
  [919] = {.lex_state = 101, .external_lex_state = 2},
  [920] = {.lex_state = 6, .external_lex_state = 2},
  [921] = {.lex_state = 6, .external_lex_state = 2},
  [922] = {.lex_state = 6, .external_lex_state = 2},
  [923] = {.lex_state = 6, .external_lex_state = 2},
  [924] = {.lex_state = 6, .external_lex_state = 2},
  [925] = {.lex_state = 6, .external_lex_state = 2},
  [926] = {.lex_state = 6, .external_lex_state = 2},
  [927] = {.lex_state = 6, .external_lex_state = 2},
  [928] = {.lex_state = 7, .external_lex_state = 2},
  [929] = {.lex_state = 7, .external_lex_state = 2},
  [930] = {.lex_state = 7, .external_lex_state = 2},
  [931] = {.lex_state = 101, .external_lex_state = 2},
  [932] = {.lex_state = 6, .external_lex_state = 2},
  [933] = {.lex_state = 7, .external_lex_state = 2},
  [934] = {.lex_state = 6, .external_lex_state = 2},
  [935] = {.lex_state = 6, .external_lex_state = 2},
  [936] = {.lex_state = 7, .external_lex_state = 2},
  [937] = {.lex_state = 6, .external_lex_state = 2},
  [938] = {.lex_state = 6, .external_lex_state = 2},
  [939] = {.lex_state = 6, .external_lex_state = 2},
  [940] = {.lex_state = 6, .external_lex_state = 2},
  [941] = {.lex_state = 6, .external_lex_state = 2},
  [942] = {.lex_state = 6, .external_lex_state = 2},
  [943] = {.lex_state = 6, .external_lex_state = 2},
  [944] = {.lex_state = 6, .external_lex_state = 2},
  [945] = {.lex_state = 6, .external_lex_state = 2},
  [946] = {.lex_state = 6, .external_lex_state = 2},
  [947] = {.lex_state = 6, .external_lex_state = 2},
  [948] = {.lex_state = 6, .external_lex_state = 2},
  [949] = {.lex_state = 6, .external_lex_state = 2},
  [950] = {.lex_state = 6, .external_lex_state = 2},
  [951] = {.lex_state = 6, .external_lex_state = 2},
  [952] = {.lex_state = 6, .external_lex_state = 2},
  [953] = {.lex_state = 6, .external_lex_state = 2},
  [954] = {.lex_state = 6, .external_lex_state = 2},
  [955] = {.lex_state = 6, .external_lex_state = 2},
  [956] = {.lex_state = 6, .external_lex_state = 2},
  [957] = {.lex_state = 6, .external_lex_state = 2},
  [958] = {.lex_state = 6, .external_lex_state = 2},
  [959] = {.lex_state = 6, .external_lex_state = 2},
  [960] = {.lex_state = 6, .external_lex_state = 2},
  [961] = {.lex_state = 7, .external_lex_state = 2},
  [962] = {.lex_state = 6, .external_lex_state = 2},
  [963] = {.lex_state = 6, .external_lex_state = 2},
  [964] = {.lex_state = 6, .external_lex_state = 2},
  [965] = {.lex_state = 22, .external_lex_state = 2},
  [966] = {.lex_state = 6, .external_lex_state = 2},
  [967] = {.lex_state = 6, .external_lex_state = 2},
  [968] = {.lex_state = 6, .external_lex_state = 2},
  [969] = {.lex_state = 6, .external_lex_state = 2},
  [970] = {.lex_state = 6, .external_lex_state = 2},
  [971] = {.lex_state = 6, .external_lex_state = 2},
  [972] = {.lex_state = 7, .external_lex_state = 2},
  [973] = {.lex_state = 6, .external_lex_state = 2},
  [974] = {.lex_state = 6, .external_lex_state = 2},
  [975] = {.lex_state = 6, .external_lex_state = 2},
  [976] = {.lex_state = 6, .external_lex_state = 2},
  [977] = {.lex_state = 6, .external_lex_state = 2},
  [978] = {.lex_state = 7, .external_lex_state = 2},
  [979] = {.lex_state = 6, .external_lex_state = 2},
  [980] = {.lex_state = 6, .external_lex_state = 2},
  [981] = {.lex_state = 6, .external_lex_state = 2},
  [982] = {.lex_state = 6, .external_lex_state = 2},
  [983] = {.lex_state = 22, .external_lex_state = 2},
  [984] = {.lex_state = 6, .external_lex_state = 2},
  [985] = {.lex_state = 6, .external_lex_state = 2},
  [986] = {.lex_state = 6, .external_lex_state = 2},
  [987] = {.lex_state = 7, .external_lex_state = 2},
  [988] = {.lex_state = 6, .external_lex_state = 2},
  [989] = {.lex_state = 6, .external_lex_state = 2},
  [990] = {.lex_state = 6, .external_lex_state = 2},
  [991] = {.lex_state = 6, .external_lex_state = 2},
  [992] = {.lex_state = 6, .external_lex_state = 2},
  [993] = {.lex_state = 6, .external_lex_state = 2},
  [994] = {.lex_state = 6, .external_lex_state = 2},
  [995] = {.lex_state = 6, .external_lex_state = 2},
  [996] = {.lex_state = 6, .external_lex_state = 2},
  [997] = {.lex_state = 22, .external_lex_state = 2},
  [998] = {.lex_state = 6, .external_lex_state = 2},
  [999] = {.lex_state = 6, .external_lex_state = 2},
  [1000] = {.lex_state = 6, .external_lex_state = 2},
  [1001] = {.lex_state = 6, .external_lex_state = 2},
  [1002] = {.lex_state = 6, .external_lex_state = 2},
  [1003] = {.lex_state = 6, .external_lex_state = 2},
  [1004] = {.lex_state = 15, .external_lex_state = 2},
  [1005] = {.lex_state = 7, .external_lex_state = 2},
  [1006] = {.lex_state = 7, .external_lex_state = 2},
  [1007] = {.lex_state = 6, .external_lex_state = 2},
  [1008] = {.lex_state = 7, .external_lex_state = 2},
  [1009] = {.lex_state = 6, .external_lex_state = 2},
  [1010] = {.lex_state = 7, .external_lex_state = 2},
  [1011] = {.lex_state = 7, .external_lex_state = 2},
  [1012] = {.lex_state = 7, .external_lex_state = 2},
  [1013] = {.lex_state = 7, .external_lex_state = 2},
  [1014] = {.lex_state = 7, .external_lex_state = 2},
  [1015] = {.lex_state = 7, .external_lex_state = 2},
  [1016] = {.lex_state = 7, .external_lex_state = 2},
  [1017] = {.lex_state = 7, .external_lex_state = 2},
  [1018] = {.lex_state = 6, .external_lex_state = 2},
  [1019] = {.lex_state = 7, .external_lex_state = 2},
  [1020] = {.lex_state = 6, .external_lex_state = 2},
  [1021] = {.lex_state = 7, .external_lex_state = 2},
  [1022] = {.lex_state = 7, .external_lex_state = 2},
  [1023] = {.lex_state = 7, .external_lex_state = 2},
  [1024] = {.lex_state = 7, .external_lex_state = 2},
  [1025] = {.lex_state = 7, .external_lex_state = 2},
  [1026] = {.lex_state = 7, .external_lex_state = 2},
  [1027] = {.lex_state = 15, .external_lex_state = 2},
  [1028] = {.lex_state = 15, .external_lex_state = 2},
  [1029] = {.lex_state = 7, .external_lex_state = 2},
  [1030] = {.lex_state = 15, .external_lex_state = 2},
  [1031] = {.lex_state = 7, .external_lex_state = 2},
  [1032] = {.lex_state = 7, .external_lex_state = 2},
  [1033] = {.lex_state = 7, .external_lex_state = 2},
  [1034] = {.lex_state = 15, .external_lex_state = 2},
  [1035] = {.lex_state = 7, .external_lex_state = 2},
  [1036] = {.lex_state = 15, .external_lex_state = 2},
  [1037] = {.lex_state = 7, .external_lex_state = 2},
  [1038] = {.lex_state = 7, .external_lex_state = 2},
  [1039] = {.lex_state = 7, .external_lex_state = 2},
  [1040] = {.lex_state = 7, .external_lex_state = 2},
  [1041] = {.lex_state = 7, .external_lex_state = 2},
  [1042] = {.lex_state = 7, .external_lex_state = 2},
  [1043] = {.lex_state = 7, .external_lex_state = 2},
  [1044] = {.lex_state = 7, .external_lex_state = 2},
  [1045] = {.lex_state = 7, .external_lex_state = 2},
  [1046] = {.lex_state = 7, .external_lex_state = 2},
  [1047] = {.lex_state = 7, .external_lex_state = 2},
  [1048] = {.lex_state = 7, .external_lex_state = 2},
  [1049] = {.lex_state = 7, .external_lex_state = 2},
  [1050] = {.lex_state = 100, .external_lex_state = 2},
  [1051] = {.lex_state = 7, .external_lex_state = 2},
  [1052] = {.lex_state = 15, .external_lex_state = 2},
  [1053] = {.lex_state = 7, .external_lex_state = 2},
  [1054] = {.lex_state = 7, .external_lex_state = 2},
  [1055] = {.lex_state = 7, .external_lex_state = 2},
  [1056] = {.lex_state = 7, .external_lex_state = 2},
  [1057] = {.lex_state = 15, .external_lex_state = 2},
  [1058] = {.lex_state = 7, .external_lex_state = 2},
  [1059] = {.lex_state = 101, .external_lex_state = 2},
  [1060] = {.lex_state = 7, .external_lex_state = 2},
  [1061] = {.lex_state = 7, .external_lex_state = 2},
  [1062] = {.lex_state = 7, .external_lex_state = 2},
  [1063] = {.lex_state = 7, .external_lex_state = 2},
  [1064] = {.lex_state = 101, .external_lex_state = 2},
  [1065] = {.lex_state = 7, .external_lex_state = 2},
  [1066] = {.lex_state = 7, .external_lex_state = 2},
  [1067] = {.lex_state = 7, .external_lex_state = 2},
  [1068] = {.lex_state = 15, .external_lex_state = 2},
  [1069] = {.lex_state = 23, .external_lex_state = 2},
  [1070] = {.lex_state = 7, .external_lex_state = 2},
  [1071] = {.lex_state = 7, .external_lex_state = 2},
  [1072] = {.lex_state = 7, .external_lex_state = 2},
  [1073] = {.lex_state = 7, .external_lex_state = 2},
  [1074] = {.lex_state = 23, .external_lex_state = 2},
  [1075] = {.lex_state = 7, .external_lex_state = 2},
  [1076] = {.lex_state = 7, .external_lex_state = 2},
  [1077] = {.lex_state = 101, .external_lex_state = 2},
  [1078] = {.lex_state = 7, .external_lex_state = 2},
  [1079] = {.lex_state = 7, .external_lex_state = 2},
  [1080] = {.lex_state = 7, .external_lex_state = 2},
  [1081] = {.lex_state = 7, .external_lex_state = 2},
  [1082] = {.lex_state = 7, .external_lex_state = 2},
  [1083] = {.lex_state = 7, .external_lex_state = 2},
  [1084] = {.lex_state = 7, .external_lex_state = 2},
  [1085] = {.lex_state = 7, .external_lex_state = 2},
  [1086] = {.lex_state = 13, .external_lex_state = 2},
  [1087] = {.lex_state = 7, .external_lex_state = 2},
  [1088] = {.lex_state = 22, .external_lex_state = 2},
  [1089] = {.lex_state = 7, .external_lex_state = 2},
  [1090] = {.lex_state = 7, .external_lex_state = 2},
  [1091] = {.lex_state = 7, .external_lex_state = 2},
  [1092] = {.lex_state = 100, .external_lex_state = 2},
  [1093] = {.lex_state = 7, .external_lex_state = 2},
  [1094] = {.lex_state = 7, .external_lex_state = 2},
  [1095] = {.lex_state = 7, .external_lex_state = 2},
  [1096] = {.lex_state = 7, .external_lex_state = 2},
  [1097] = {.lex_state = 7, .external_lex_state = 2},
  [1098] = {.lex_state = 7, .external_lex_state = 2},
  [1099] = {.lex_state = 7, .external_lex_state = 2},
  [1100] = {.lex_state = 7, .external_lex_state = 2},
  [1101] = {.lex_state = 7, .external_lex_state = 2},
  [1102] = {.lex_state = 22, .external_lex_state = 2},
  [1103] = {.lex_state = 27, .external_lex_state = 2},
  [1104] = {.lex_state = 7, .external_lex_state = 2},
  [1105] = {.lex_state = 7, .external_lex_state = 2},
  [1106] = {.lex_state = 7, .external_lex_state = 2},
  [1107] = {.lex_state = 7, .external_lex_state = 2},
  [1108] = {.lex_state = 7, .external_lex_state = 2},
  [1109] = {.lex_state = 22, .external_lex_state = 2},
  [1110] = {.lex_state = 7, .external_lex_state = 2},
  [1111] = {.lex_state = 7, .external_lex_state = 2},
  [1112] = {.lex_state = 7, .external_lex_state = 2},
  [1113] = {.lex_state = 7, .external_lex_state = 2},
  [1114] = {.lex_state = 7, .external_lex_state = 2},
  [1115] = {.lex_state = 7, .external_lex_state = 2},
  [1116] = {.lex_state = 7, .external_lex_state = 2},
  [1117] = {.lex_state = 7, .external_lex_state = 2},
  [1118] = {.lex_state = 7, .external_lex_state = 2},
  [1119] = {.lex_state = 7, .external_lex_state = 2},
  [1120] = {.lex_state = 7, .external_lex_state = 2},
  [1121] = {.lex_state = 27, .external_lex_state = 2},
  [1122] = {.lex_state = 22, .external_lex_state = 2},
  [1123] = {.lex_state = 7, .external_lex_state = 2},
  [1124] = {.lex_state = 22, .external_lex_state = 2},
  [1125] = {.lex_state = 7, .external_lex_state = 2},
  [1126] = {.lex_state = 22, .external_lex_state = 2},
  [1127] = {.lex_state = 7, .external_lex_state = 2},
  [1128] = {.lex_state = 7, .external_lex_state = 2},
  [1129] = {.lex_state = 7, .external_lex_state = 2},
  [1130] = {.lex_state = 7, .external_lex_state = 2},
  [1131] = {.lex_state = 7, .external_lex_state = 2},
  [1132] = {.lex_state = 7, .external_lex_state = 2},
  [1133] = {.lex_state = 7, .external_lex_state = 2},
  [1134] = {.lex_state = 22, .external_lex_state = 2},
  [1135] = {.lex_state = 7, .external_lex_state = 2},
  [1136] = {.lex_state = 22, .external_lex_state = 2},
  [1137] = {.lex_state = 7, .external_lex_state = 2},
  [1138] = {.lex_state = 22, .external_lex_state = 2},
  [1139] = {.lex_state = 7, .external_lex_state = 2},
  [1140] = {.lex_state = 7, .external_lex_state = 2},
  [1141] = {.lex_state = 22, .external_lex_state = 2},
  [1142] = {.lex_state = 7, .external_lex_state = 2},
  [1143] = {.lex_state = 7, .external_lex_state = 2},
  [1144] = {.lex_state = 7, .external_lex_state = 2},
  [1145] = {.lex_state = 22, .external_lex_state = 2},
  [1146] = {.lex_state = 7, .external_lex_state = 2},
  [1147] = {.lex_state = 27, .external_lex_state = 2},
  [1148] = {.lex_state = 7, .external_lex_state = 2},
  [1149] = {.lex_state = 7, .external_lex_state = 2},
  [1150] = {.lex_state = 7, .external_lex_state = 2},
  [1151] = {.lex_state = 7, .external_lex_state = 2},
  [1152] = {.lex_state = 7, .external_lex_state = 2},
  [1153] = {.lex_state = 7, .external_lex_state = 2},
  [1154] = {.lex_state = 7, .external_lex_state = 2},
  [1155] = {.lex_state = 22, .external_lex_state = 2},
  [1156] = {.lex_state = 7, .external_lex_state = 2},
  [1157] = {.lex_state = 7, .external_lex_state = 2},
  [1158] = {.lex_state = 7, .external_lex_state = 2},
  [1159] = {.lex_state = 7, .external_lex_state = 2},
  [1160] = {.lex_state = 22, .external_lex_state = 2},
  [1161] = {.lex_state = 7, .external_lex_state = 2},
  [1162] = {.lex_state = 7, .external_lex_state = 2},
  [1163] = {.lex_state = 7, .external_lex_state = 2},
  [1164] = {.lex_state = 7, .external_lex_state = 2},
  [1165] = {.lex_state = 7, .external_lex_state = 2},
  [1166] = {.lex_state = 7, .external_lex_state = 2},
  [1167] = {.lex_state = 7, .external_lex_state = 2},
  [1168] = {.lex_state = 7, .external_lex_state = 2},
  [1169] = {.lex_state = 7, .external_lex_state = 2},
  [1170] = {.lex_state = 7, .external_lex_state = 2},
  [1171] = {.lex_state = 7, .external_lex_state = 2},
  [1172] = {.lex_state = 7, .external_lex_state = 2},
  [1173] = {.lex_state = 7, .external_lex_state = 2},
  [1174] = {.lex_state = 7, .external_lex_state = 2},
  [1175] = {.lex_state = 7, .external_lex_state = 2},
  [1176] = {.lex_state = 7, .external_lex_state = 2},
  [1177] = {.lex_state = 27, .external_lex_state = 2},
  [1178] = {.lex_state = 7, .external_lex_state = 2},
  [1179] = {.lex_state = 7, .external_lex_state = 2},
  [1180] = {.lex_state = 7, .external_lex_state = 2},
  [1181] = {.lex_state = 7, .external_lex_state = 2},
  [1182] = {.lex_state = 7, .external_lex_state = 2},
  [1183] = {.lex_state = 7, .external_lex_state = 2},
  [1184] = {.lex_state = 7, .external_lex_state = 2},
  [1185] = {.lex_state = 100, .external_lex_state = 2},
  [1186] = {.lex_state = 7, .external_lex_state = 2},
  [1187] = {.lex_state = 7, .external_lex_state = 2},
  [1188] = {.lex_state = 7, .external_lex_state = 2},
  [1189] = {.lex_state = 7, .external_lex_state = 2},
  [1190] = {.lex_state = 7, .external_lex_state = 2},
  [1191] = {.lex_state = 7, .external_lex_state = 2},
  [1192] = {.lex_state = 7, .external_lex_state = 2},
  [1193] = {.lex_state = 7, .external_lex_state = 2},
  [1194] = {.lex_state = 7, .external_lex_state = 2},
  [1195] = {.lex_state = 7, .external_lex_state = 2},
  [1196] = {.lex_state = 13, .external_lex_state = 2},
  [1197] = {.lex_state = 13, .external_lex_state = 2},
  [1198] = {.lex_state = 22, .external_lex_state = 2},
  [1199] = {.lex_state = 22, .external_lex_state = 2},
  [1200] = {.lex_state = 6, .external_lex_state = 2},
  [1201] = {.lex_state = 5, .external_lex_state = 2},
  [1202] = {.lex_state = 5, .external_lex_state = 2},
  [1203] = {.lex_state = 6, .external_lex_state = 2},
  [1204] = {.lex_state = 23, .external_lex_state = 2},
  [1205] = {.lex_state = 13, .external_lex_state = 2},
  [1206] = {.lex_state = 38, .external_lex_state = 2},
  [1207] = {.lex_state = 5, .external_lex_state = 2},
  [1208] = {.lex_state = 13, .external_lex_state = 2},
  [1209] = {.lex_state = 13, .external_lex_state = 2},
  [1210] = {.lex_state = 13, .external_lex_state = 2},
  [1211] = {.lex_state = 13, .external_lex_state = 2},
  [1212] = {.lex_state = 6, .external_lex_state = 2},
  [1213] = {.lex_state = 6, .external_lex_state = 2},
  [1214] = {.lex_state = 6, .external_lex_state = 2},
  [1215] = {.lex_state = 23, .external_lex_state = 2},
  [1216] = {.lex_state = 13, .external_lex_state = 2},
  [1217] = {.lex_state = 102, .external_lex_state = 2},
  [1218] = {.lex_state = 5, .external_lex_state = 2},
  [1219] = {.lex_state = 5, .external_lex_state = 2},
  [1220] = {.lex_state = 5, .external_lex_state = 2},
  [1221] = {.lex_state = 5, .external_lex_state = 2},
  [1222] = {.lex_state = 5, .external_lex_state = 2},
  [1223] = {.lex_state = 5, .external_lex_state = 2},
  [1224] = {.lex_state = 5, .external_lex_state = 2},
  [1225] = {.lex_state = 5, .external_lex_state = 2},
  [1226] = {.lex_state = 5, .external_lex_state = 2},
  [1227] = {.lex_state = 5, .external_lex_state = 2},
  [1228] = {.lex_state = 5, .external_lex_state = 2},
  [1229] = {.lex_state = 5, .external_lex_state = 2},
  [1230] = {.lex_state = 5, .external_lex_state = 2},
  [1231] = {.lex_state = 5, .external_lex_state = 2},
  [1232] = {.lex_state = 5, .external_lex_state = 2},
  [1233] = {.lex_state = 101, .external_lex_state = 2},
  [1234] = {.lex_state = 5, .external_lex_state = 2},
  [1235] = {.lex_state = 28, .external_lex_state = 2},
  [1236] = {.lex_state = 5, .external_lex_state = 2},
  [1237] = {.lex_state = 5, .external_lex_state = 2},
  [1238] = {.lex_state = 6, .external_lex_state = 2},
  [1239] = {.lex_state = 5, .external_lex_state = 2},
  [1240] = {.lex_state = 5, .external_lex_state = 2},
  [1241] = {.lex_state = 6, .external_lex_state = 2},
  [1242] = {.lex_state = 5, .external_lex_state = 2},
  [1243] = {.lex_state = 5, .external_lex_state = 2},
  [1244] = {.lex_state = 5, .external_lex_state = 2},
  [1245] = {.lex_state = 6, .external_lex_state = 2},
  [1246] = {.lex_state = 5, .external_lex_state = 2},
  [1247] = {.lex_state = 5, .external_lex_state = 2},
  [1248] = {.lex_state = 5, .external_lex_state = 2},
  [1249] = {.lex_state = 6, .external_lex_state = 2},
  [1250] = {.lex_state = 5, .external_lex_state = 2},
  [1251] = {.lex_state = 28, .external_lex_state = 2},
  [1252] = {.lex_state = 5, .external_lex_state = 2},
  [1253] = {.lex_state = 5, .external_lex_state = 2},
  [1254] = {.lex_state = 6, .external_lex_state = 2},
  [1255] = {.lex_state = 5, .external_lex_state = 2},
  [1256] = {.lex_state = 5, .external_lex_state = 2},
  [1257] = {.lex_state = 5, .external_lex_state = 2},
  [1258] = {.lex_state = 5, .external_lex_state = 2},
  [1259] = {.lex_state = 5, .external_lex_state = 2},
  [1260] = {.lex_state = 28, .external_lex_state = 2},
  [1261] = {.lex_state = 5, .external_lex_state = 2},
  [1262] = {.lex_state = 5, .external_lex_state = 2},
  [1263] = {.lex_state = 5, .external_lex_state = 2},
  [1264] = {.lex_state = 5, .external_lex_state = 2},
  [1265] = {.lex_state = 6, .external_lex_state = 2},
  [1266] = {.lex_state = 6, .external_lex_state = 2},
  [1267] = {.lex_state = 5, .external_lex_state = 2},
  [1268] = {.lex_state = 5, .external_lex_state = 2},
  [1269] = {.lex_state = 5, .external_lex_state = 2},
  [1270] = {.lex_state = 5, .external_lex_state = 2},
  [1271] = {.lex_state = 5, .external_lex_state = 2},
  [1272] = {.lex_state = 5, .external_lex_state = 2},
  [1273] = {.lex_state = 5, .external_lex_state = 2},
  [1274] = {.lex_state = 5, .external_lex_state = 2},
  [1275] = {.lex_state = 5, .external_lex_state = 2},
  [1276] = {.lex_state = 5, .external_lex_state = 2},
  [1277] = {.lex_state = 5, .external_lex_state = 2},
  [1278] = {.lex_state = 5, .external_lex_state = 2},
  [1279] = {.lex_state = 5, .external_lex_state = 2},
  [1280] = {.lex_state = 5, .external_lex_state = 2},
  [1281] = {.lex_state = 5, .external_lex_state = 2},
  [1282] = {.lex_state = 5, .external_lex_state = 2},
  [1283] = {.lex_state = 6, .external_lex_state = 2},
  [1284] = {.lex_state = 27, .external_lex_state = 2},
  [1285] = {.lex_state = 5, .external_lex_state = 2},
  [1286] = {.lex_state = 5, .external_lex_state = 2},
  [1287] = {.lex_state = 5, .external_lex_state = 2},
  [1288] = {.lex_state = 5, .external_lex_state = 2},
  [1289] = {.lex_state = 5, .external_lex_state = 2},
  [1290] = {.lex_state = 5, .external_lex_state = 2},
  [1291] = {.lex_state = 5, .external_lex_state = 2},
  [1292] = {.lex_state = 5, .external_lex_state = 2},
  [1293] = {.lex_state = 27, .external_lex_state = 2},
  [1294] = {.lex_state = 5, .external_lex_state = 2},
  [1295] = {.lex_state = 5, .external_lex_state = 2},
  [1296] = {.lex_state = 5, .external_lex_state = 2},
  [1297] = {.lex_state = 6, .external_lex_state = 2},
  [1298] = {.lex_state = 5, .external_lex_state = 2},
  [1299] = {.lex_state = 6, .external_lex_state = 2},
  [1300] = {.lex_state = 6, .external_lex_state = 2},
  [1301] = {.lex_state = 27, .external_lex_state = 2},
  [1302] = {.lex_state = 27, .external_lex_state = 2},
  [1303] = {.lex_state = 27, .external_lex_state = 2},
  [1304] = {.lex_state = 6, .external_lex_state = 2},
  [1305] = {.lex_state = 27, .external_lex_state = 2},
  [1306] = {.lex_state = 27, .external_lex_state = 2},
  [1307] = {.lex_state = 27, .external_lex_state = 2},
  [1308] = {.lex_state = 101, .external_lex_state = 2},
  [1309] = {.lex_state = 38, .external_lex_state = 2},
  [1310] = {.lex_state = 27, .external_lex_state = 2},
  [1311] = {.lex_state = 27, .external_lex_state = 2},
  [1312] = {.lex_state = 27, .external_lex_state = 2},
  [1313] = {.lex_state = 27, .external_lex_state = 2},
  [1314] = {.lex_state = 101, .external_lex_state = 2},
  [1315] = {.lex_state = 27, .external_lex_state = 2},
  [1316] = {.lex_state = 27, .external_lex_state = 2},
  [1317] = {.lex_state = 27, .external_lex_state = 2},
  [1318] = {.lex_state = 27, .external_lex_state = 2},
  [1319] = {.lex_state = 27, .external_lex_state = 2},
  [1320] = {.lex_state = 27, .external_lex_state = 2},
  [1321] = {.lex_state = 26, .external_lex_state = 2},
  [1322] = {.lex_state = 6, .external_lex_state = 2},
  [1323] = {.lex_state = 6, .external_lex_state = 2},
  [1324] = {.lex_state = 6, .external_lex_state = 2},
  [1325] = {.lex_state = 27, .external_lex_state = 2},
  [1326] = {.lex_state = 101, .external_lex_state = 2},
  [1327] = {.lex_state = 101, .external_lex_state = 2},
  [1328] = {.lex_state = 6, .external_lex_state = 2},
  [1329] = {.lex_state = 26, .external_lex_state = 2},
  [1330] = {.lex_state = 27, .external_lex_state = 2},
  [1331] = {.lex_state = 28, .external_lex_state = 2},
  [1332] = {.lex_state = 26, .external_lex_state = 2},
  [1333] = {.lex_state = 6, .external_lex_state = 2},
  [1334] = {.lex_state = 27, .external_lex_state = 2},
  [1335] = {.lex_state = 6, .external_lex_state = 2},
  [1336] = {.lex_state = 28, .external_lex_state = 2},
  [1337] = {.lex_state = 6, .external_lex_state = 2},
  [1338] = {.lex_state = 6, .external_lex_state = 2},
  [1339] = {.lex_state = 6, .external_lex_state = 2},
  [1340] = {.lex_state = 6, .external_lex_state = 2},
  [1341] = {.lex_state = 27, .external_lex_state = 2},
  [1342] = {.lex_state = 6, .external_lex_state = 2},
  [1343] = {.lex_state = 6, .external_lex_state = 2},
  [1344] = {.lex_state = 6, .external_lex_state = 2},
  [1345] = {.lex_state = 6, .external_lex_state = 2},
  [1346] = {.lex_state = 6, .external_lex_state = 2},
  [1347] = {.lex_state = 6, .external_lex_state = 2},
  [1348] = {.lex_state = 6, .external_lex_state = 2},
  [1349] = {.lex_state = 27, .external_lex_state = 2},
  [1350] = {.lex_state = 28, .external_lex_state = 2},
  [1351] = {.lex_state = 28, .external_lex_state = 2},
  [1352] = {.lex_state = 28, .external_lex_state = 2},
  [1353] = {.lex_state = 28, .external_lex_state = 2},
  [1354] = {.lex_state = 28, .external_lex_state = 2},
  [1355] = {.lex_state = 23, .external_lex_state = 2},
  [1356] = {.lex_state = 27, .external_lex_state = 2},
  [1357] = {.lex_state = 101, .external_lex_state = 2},
  [1358] = {.lex_state = 27, .external_lex_state = 2},
  [1359] = {.lex_state = 101, .external_lex_state = 2},
  [1360] = {.lex_state = 27, .external_lex_state = 2},
  [1361] = {.lex_state = 101, .external_lex_state = 2},
  [1362] = {.lex_state = 28, .external_lex_state = 2},
  [1363] = {.lex_state = 28, .external_lex_state = 2},
  [1364] = {.lex_state = 27, .external_lex_state = 2},
  [1365] = {.lex_state = 23, .external_lex_state = 2},
  [1366] = {.lex_state = 28, .external_lex_state = 2},
  [1367] = {.lex_state = 27, .external_lex_state = 2},
  [1368] = {.lex_state = 27, .external_lex_state = 2},
  [1369] = {.lex_state = 27, .external_lex_state = 2},
  [1370] = {.lex_state = 101, .external_lex_state = 2},
  [1371] = {.lex_state = 100, .external_lex_state = 2},
  [1372] = {.lex_state = 101, .external_lex_state = 2},
  [1373] = {.lex_state = 28, .external_lex_state = 2},
  [1374] = {.lex_state = 101, .external_lex_state = 2},
  [1375] = {.lex_state = 27, .external_lex_state = 2},
  [1376] = {.lex_state = 101, .external_lex_state = 2},
  [1377] = {.lex_state = 27, .external_lex_state = 2},
  [1378] = {.lex_state = 28, .external_lex_state = 2},
  [1379] = {.lex_state = 28, .external_lex_state = 2},
  [1380] = {.lex_state = 28, .external_lex_state = 2},
  [1381] = {.lex_state = 28, .external_lex_state = 2},
  [1382] = {.lex_state = 28, .external_lex_state = 2},
  [1383] = {.lex_state = 27, .external_lex_state = 2},
  [1384] = {.lex_state = 27, .external_lex_state = 2},
  [1385] = {.lex_state = 101, .external_lex_state = 2},
  [1386] = {.lex_state = 27, .external_lex_state = 2},
  [1387] = {.lex_state = 101, .external_lex_state = 2},
  [1388] = {.lex_state = 101, .external_lex_state = 2},
  [1389] = {.lex_state = 28, .external_lex_state = 2},
  [1390] = {.lex_state = 28, .external_lex_state = 2},
  [1391] = {.lex_state = 28, .external_lex_state = 2},
  [1392] = {.lex_state = 27, .external_lex_state = 2},
  [1393] = {.lex_state = 27, .external_lex_state = 2},
  [1394] = {.lex_state = 101, .external_lex_state = 2},
  [1395] = {.lex_state = 101, .external_lex_state = 2},
  [1396] = {.lex_state = 27, .external_lex_state = 2},
  [1397] = {.lex_state = 101, .external_lex_state = 2},
  [1398] = {.lex_state = 27, .external_lex_state = 2},
  [1399] = {.lex_state = 101, .external_lex_state = 2},
  [1400] = {.lex_state = 27, .external_lex_state = 2},
  [1401] = {.lex_state = 101, .external_lex_state = 2},
  [1402] = {.lex_state = 101, .external_lex_state = 2},
  [1403] = {.lex_state = 27, .external_lex_state = 2},
  [1404] = {.lex_state = 25, .external_lex_state = 2},
  [1405] = {.lex_state = 27, .external_lex_state = 2},
  [1406] = {.lex_state = 27, .external_lex_state = 2},
  [1407] = {.lex_state = 27, .external_lex_state = 2},
  [1408] = {.lex_state = 27, .external_lex_state = 2},
  [1409] = {.lex_state = 27, .external_lex_state = 2},
  [1410] = {.lex_state = 27, .external_lex_state = 2},
  [1411] = {.lex_state = 27, .external_lex_state = 2},
  [1412] = {.lex_state = 101, .external_lex_state = 2},
  [1413] = {.lex_state = 27, .external_lex_state = 2},
  [1414] = {.lex_state = 27, .external_lex_state = 2},
  [1415] = {.lex_state = 101, .external_lex_state = 2},
  [1416] = {.lex_state = 101, .external_lex_state = 2},
  [1417] = {.lex_state = 27, .external_lex_state = 2},
  [1418] = {.lex_state = 28, .external_lex_state = 2},
  [1419] = {.lex_state = 27, .external_lex_state = 2},
  [1420] = {.lex_state = 100, .external_lex_state = 2},
  [1421] = {.lex_state = 27, .external_lex_state = 2},
  [1422] = {.lex_state = 26, .external_lex_state = 2},
  [1423] = {.lex_state = 27, .external_lex_state = 2},
  [1424] = {.lex_state = 27, .external_lex_state = 2},
  [1425] = {.lex_state = 101, .external_lex_state = 2},
  [1426] = {.lex_state = 26, .external_lex_state = 2},
  [1427] = {.lex_state = 27, .external_lex_state = 2},
  [1428] = {.lex_state = 27, .external_lex_state = 2},
  [1429] = {.lex_state = 27, .external_lex_state = 2},
  [1430] = {.lex_state = 27, .external_lex_state = 2},
  [1431] = {.lex_state = 28, .external_lex_state = 2},
  [1432] = {.lex_state = 27, .external_lex_state = 2},
  [1433] = {.lex_state = 27, .external_lex_state = 2},
  [1434] = {.lex_state = 25, .external_lex_state = 2},
  [1435] = {.lex_state = 27, .external_lex_state = 2},
  [1436] = {.lex_state = 27, .external_lex_state = 2},
  [1437] = {.lex_state = 27, .external_lex_state = 2},
  [1438] = {.lex_state = 28, .external_lex_state = 2},
  [1439] = {.lex_state = 27, .external_lex_state = 2},
  [1440] = {.lex_state = 27, .external_lex_state = 2},
  [1441] = {.lex_state = 27, .external_lex_state = 2},
  [1442] = {.lex_state = 27, .external_lex_state = 2},
  [1443] = {.lex_state = 28, .external_lex_state = 2},
  [1444] = {.lex_state = 25, .external_lex_state = 2},
  [1445] = {.lex_state = 27, .external_lex_state = 2},
  [1446] = {.lex_state = 27, .external_lex_state = 2},
  [1447] = {.lex_state = 27, .external_lex_state = 2},
  [1448] = {.lex_state = 27, .external_lex_state = 2},
  [1449] = {.lex_state = 27, .external_lex_state = 2},
  [1450] = {.lex_state = 101, .external_lex_state = 2},
  [1451] = {.lex_state = 101, .external_lex_state = 2},
  [1452] = {.lex_state = 26, .external_lex_state = 2},
  [1453] = {.lex_state = 27, .external_lex_state = 2},
  [1454] = {.lex_state = 100, .external_lex_state = 2},
  [1455] = {.lex_state = 26, .external_lex_state = 2},
  [1456] = {.lex_state = 28, .external_lex_state = 2},
  [1457] = {.lex_state = 28, .external_lex_state = 2},
  [1458] = {.lex_state = 28, .external_lex_state = 2},
  [1459] = {.lex_state = 28, .external_lex_state = 2},
  [1460] = {.lex_state = 26, .external_lex_state = 2},
  [1461] = {.lex_state = 28, .external_lex_state = 2},
  [1462] = {.lex_state = 26, .external_lex_state = 2},
  [1463] = {.lex_state = 38, .external_lex_state = 2},
  [1464] = {.lex_state = 28, .external_lex_state = 2},
  [1465] = {.lex_state = 28, .external_lex_state = 2},
  [1466] = {.lex_state = 28, .external_lex_state = 2},
  [1467] = {.lex_state = 26, .external_lex_state = 2},
  [1468] = {.lex_state = 26, .external_lex_state = 2},
  [1469] = {.lex_state = 27, .external_lex_state = 2},
  [1470] = {.lex_state = 19, .external_lex_state = 2},
  [1471] = {.lex_state = 26, .external_lex_state = 2},
  [1472] = {.lex_state = 26, .external_lex_state = 2},
  [1473] = {.lex_state = 100, .external_lex_state = 2},
  [1474] = {.lex_state = 100, .external_lex_state = 2},
  [1475] = {.lex_state = 19, .external_lex_state = 2},
  [1476] = {.lex_state = 28, .external_lex_state = 2},
  [1477] = {.lex_state = 27, .external_lex_state = 2},
  [1478] = {.lex_state = 23, .external_lex_state = 2},
  [1479] = {.lex_state = 100, .external_lex_state = 2},
  [1480] = {.lex_state = 26, .external_lex_state = 2},
  [1481] = {.lex_state = 26, .external_lex_state = 2},
  [1482] = {.lex_state = 26, .external_lex_state = 2},
  [1483] = {.lex_state = 26, .external_lex_state = 2},
  [1484] = {.lex_state = 27, .external_lex_state = 2},
  [1485] = {.lex_state = 27, .external_lex_state = 2},
  [1486] = {.lex_state = 28, .external_lex_state = 2},
  [1487] = {.lex_state = 26, .external_lex_state = 2},
  [1488] = {.lex_state = 26, .external_lex_state = 2},
  [1489] = {.lex_state = 28, .external_lex_state = 2},
  [1490] = {.lex_state = 28, .external_lex_state = 2},
  [1491] = {.lex_state = 28, .external_lex_state = 2},
  [1492] = {.lex_state = 28, .external_lex_state = 2},
  [1493] = {.lex_state = 27, .external_lex_state = 2},
  [1494] = {.lex_state = 28, .external_lex_state = 2},
  [1495] = {.lex_state = 26, .external_lex_state = 2},
  [1496] = {.lex_state = 26, .external_lex_state = 2},
  [1497] = {.lex_state = 27, .external_lex_state = 2},
  [1498] = {.lex_state = 38, .external_lex_state = 2},
  [1499] = {.lex_state = 26, .external_lex_state = 2},
  [1500] = {.lex_state = 27, .external_lex_state = 2},
  [1501] = {.lex_state = 27, .external_lex_state = 2},
  [1502] = {.lex_state = 27, .external_lex_state = 2},
  [1503] = {.lex_state = 28, .external_lex_state = 2},
  [1504] = {.lex_state = 38, .external_lex_state = 2},
  [1505] = {.lex_state = 28, .external_lex_state = 2},
  [1506] = {.lex_state = 28, .external_lex_state = 2},
  [1507] = {.lex_state = 28, .external_lex_state = 2},
  [1508] = {.lex_state = 28, .external_lex_state = 2},
  [1509] = {.lex_state = 19, .external_lex_state = 2},
  [1510] = {.lex_state = 28, .external_lex_state = 2},
  [1511] = {.lex_state = 26, .external_lex_state = 2},
  [1512] = {.lex_state = 28, .external_lex_state = 2},
  [1513] = {.lex_state = 28, .external_lex_state = 2},
  [1514] = {.lex_state = 28, .external_lex_state = 2},
  [1515] = {.lex_state = 38, .external_lex_state = 2},
  [1516] = {.lex_state = 28, .external_lex_state = 2},
  [1517] = {.lex_state = 6, .external_lex_state = 2},
  [1518] = {.lex_state = 28, .external_lex_state = 2},
  [1519] = {.lex_state = 28, .external_lex_state = 2},
  [1520] = {.lex_state = 28, .external_lex_state = 2},
  [1521] = {.lex_state = 28, .external_lex_state = 2},
  [1522] = {.lex_state = 100, .external_lex_state = 2},
  [1523] = {.lex_state = 28, .external_lex_state = 2},
  [1524] = {.lex_state = 28, .external_lex_state = 2},
  [1525] = {.lex_state = 28, .external_lex_state = 2},
  [1526] = {.lex_state = 28, .external_lex_state = 2},
  [1527] = {.lex_state = 28, .external_lex_state = 2},
  [1528] = {.lex_state = 28, .external_lex_state = 2},
  [1529] = {.lex_state = 28, .external_lex_state = 2},
  [1530] = {.lex_state = 38, .external_lex_state = 2},
  [1531] = {.lex_state = 28, .external_lex_state = 2},
  [1532] = {.lex_state = 28, .external_lex_state = 2},
  [1533] = {.lex_state = 28, .external_lex_state = 2},
  [1534] = {.lex_state = 28, .external_lex_state = 2},
  [1535] = {.lex_state = 26, .external_lex_state = 2},
  [1536] = {.lex_state = 26, .external_lex_state = 2},
  [1537] = {.lex_state = 19, .external_lex_state = 2},
  [1538] = {.lex_state = 101, .external_lex_state = 2},
  [1539] = {.lex_state = 28, .external_lex_state = 2},
  [1540] = {.lex_state = 28, .external_lex_state = 2},
  [1541] = {.lex_state = 28, .external_lex_state = 2},
  [1542] = {.lex_state = 19, .external_lex_state = 2},
  [1543] = {.lex_state = 28, .external_lex_state = 2},
  [1544] = {.lex_state = 28, .external_lex_state = 2},
  [1545] = {.lex_state = 28, .external_lex_state = 2},
  [1546] = {.lex_state = 6, .external_lex_state = 2},
  [1547] = {.lex_state = 28, .external_lex_state = 2},
  [1548] = {.lex_state = 28, .external_lex_state = 2},
  [1549] = {.lex_state = 28, .external_lex_state = 2},
  [1550] = {.lex_state = 28, .external_lex_state = 2},
  [1551] = {.lex_state = 28, .external_lex_state = 2},
  [1552] = {.lex_state = 19, .external_lex_state = 2},
  [1553] = {.lex_state = 26, .external_lex_state = 2},
  [1554] = {.lex_state = 26, .external_lex_state = 2},
  [1555] = {.lex_state = 100, .external_lex_state = 2},
  [1556] = {.lex_state = 26, .external_lex_state = 2},
  [1557] = {.lex_state = 38, .external_lex_state = 2},
  [1558] = {.lex_state = 100, .external_lex_state = 2},
  [1559] = {.lex_state = 38, .external_lex_state = 2},
  [1560] = {.lex_state = 28, .external_lex_state = 2},
  [1561] = {.lex_state = 6, .external_lex_state = 2},
  [1562] = {.lex_state = 6, .external_lex_state = 2},
  [1563] = {.lex_state = 28, .external_lex_state = 2},
  [1564] = {.lex_state = 100, .external_lex_state = 2},
  [1565] = {.lex_state = 38, .external_lex_state = 2},
  [1566] = {.lex_state = 38, .external_lex_state = 2},
  [1567] = {.lex_state = 100, .external_lex_state = 2},
  [1568] = {.lex_state = 26, .external_lex_state = 2},
  [1569] = {.lex_state = 100, .external_lex_state = 2},
  [1570] = {.lex_state = 6, .external_lex_state = 2},
  [1571] = {.lex_state = 100, .external_lex_state = 2},
  [1572] = {.lex_state = 100, .external_lex_state = 2},
  [1573] = {.lex_state = 28, .external_lex_state = 2},
  [1574] = {.lex_state = 6, .external_lex_state = 2},
  [1575] = {.lex_state = 6, .external_lex_state = 2},
  [1576] = {.lex_state = 100, .external_lex_state = 2},
  [1577] = {.lex_state = 100, .external_lex_state = 2},
  [1578] = {.lex_state = 28, .external_lex_state = 2},
  [1579] = {.lex_state = 100, .external_lex_state = 2},
  [1580] = {.lex_state = 26, .external_lex_state = 2},
  [1581] = {.lex_state = 100, .external_lex_state = 2},
  [1582] = {.lex_state = 6, .external_lex_state = 2},
  [1583] = {.lex_state = 28, .external_lex_state = 2},
  [1584] = {.lex_state = 100, .external_lex_state = 2},
  [1585] = {.lex_state = 100, .external_lex_state = 2},
  [1586] = {.lex_state = 38, .external_lex_state = 2},
  [1587] = {.lex_state = 38, .external_lex_state = 2},
  [1588] = {.lex_state = 26, .external_lex_state = 2},
  [1589] = {.lex_state = 26, .external_lex_state = 2},
  [1590] = {.lex_state = 26, .external_lex_state = 2},
  [1591] = {.lex_state = 28, .external_lex_state = 2},
  [1592] = {.lex_state = 26, .external_lex_state = 2},
  [1593] = {.lex_state = 23, .external_lex_state = 2},
  [1594] = {.lex_state = 28, .external_lex_state = 2},
  [1595] = {.lex_state = 28, .external_lex_state = 2},
  [1596] = {.lex_state = 28, .external_lex_state = 2},
  [1597] = {.lex_state = 23, .external_lex_state = 2},
  [1598] = {.lex_state = 100, .external_lex_state = 2},
  [1599] = {.lex_state = 26, .external_lex_state = 2},
  [1600] = {.lex_state = 26, .external_lex_state = 2},
  [1601] = {.lex_state = 26, .external_lex_state = 2},
  [1602] = {.lex_state = 26, .external_lex_state = 2},
  [1603] = {.lex_state = 26, .external_lex_state = 2},
  [1604] = {.lex_state = 100, .external_lex_state = 2},
  [1605] = {.lex_state = 38, .external_lex_state = 2},
  [1606] = {.lex_state = 26, .external_lex_state = 2},
  [1607] = {.lex_state = 38, .external_lex_state = 2},
  [1608] = {.lex_state = 26, .external_lex_state = 2},
  [1609] = {.lex_state = 28, .external_lex_state = 2},
  [1610] = {.lex_state = 100, .external_lex_state = 2},
  [1611] = {.lex_state = 100, .external_lex_state = 2},
  [1612] = {.lex_state = 38, .external_lex_state = 2},
  [1613] = {.lex_state = 100, .external_lex_state = 2},
  [1614] = {.lex_state = 38, .external_lex_state = 2},
  [1615] = {.lex_state = 26, .external_lex_state = 2},
  [1616] = {.lex_state = 38, .external_lex_state = 2},
  [1617] = {.lex_state = 26, .external_lex_state = 2},
  [1618] = {.lex_state = 26, .external_lex_state = 2},
  [1619] = {.lex_state = 26, .external_lex_state = 2},
  [1620] = {.lex_state = 26, .external_lex_state = 2},
  [1621] = {.lex_state = 26, .external_lex_state = 2},
  [1622] = {.lex_state = 26, .external_lex_state = 2},
  [1623] = {.lex_state = 26, .external_lex_state = 2},
  [1624] = {.lex_state = 26, .external_lex_state = 2},
  [1625] = {.lex_state = 38, .external_lex_state = 2},
  [1626] = {.lex_state = 26, .external_lex_state = 2},
  [1627] = {.lex_state = 26, .external_lex_state = 2},
  [1628] = {.lex_state = 26, .external_lex_state = 2},
  [1629] = {.lex_state = 26, .external_lex_state = 2},
  [1630] = {.lex_state = 6, .external_lex_state = 2},
  [1631] = {.lex_state = 26, .external_lex_state = 2},
  [1632] = {.lex_state = 26, .external_lex_state = 2},
  [1633] = {.lex_state = 26, .external_lex_state = 2},
  [1634] = {.lex_state = 26, .external_lex_state = 2},
  [1635] = {.lex_state = 26, .external_lex_state = 2},
  [1636] = {.lex_state = 38, .external_lex_state = 2},
  [1637] = {.lex_state = 26, .external_lex_state = 2},
  [1638] = {.lex_state = 26, .external_lex_state = 2},
  [1639] = {.lex_state = 38, .external_lex_state = 2},
  [1640] = {.lex_state = 26, .external_lex_state = 2},
  [1641] = {.lex_state = 26, .external_lex_state = 2},
  [1642] = {.lex_state = 38, .external_lex_state = 2},
  [1643] = {.lex_state = 26, .external_lex_state = 2},
  [1644] = {.lex_state = 26, .external_lex_state = 2},
  [1645] = {.lex_state = 26, .external_lex_state = 2},
  [1646] = {.lex_state = 38, .external_lex_state = 2},
  [1647] = {.lex_state = 26, .external_lex_state = 2},
  [1648] = {.lex_state = 26, .external_lex_state = 2},
  [1649] = {.lex_state = 26, .external_lex_state = 2},
  [1650] = {.lex_state = 38, .external_lex_state = 2},
  [1651] = {.lex_state = 26, .external_lex_state = 2},
  [1652] = {.lex_state = 26, .external_lex_state = 2},
  [1653] = {.lex_state = 26, .external_lex_state = 2},
  [1654] = {.lex_state = 26, .external_lex_state = 2},
  [1655] = {.lex_state = 26, .external_lex_state = 2},
  [1656] = {.lex_state = 6, .external_lex_state = 2},
  [1657] = {.lex_state = 6, .external_lex_state = 2},
  [1658] = {.lex_state = 6, .external_lex_state = 2},
  [1659] = {.lex_state = 26, .external_lex_state = 2},
  [1660] = {.lex_state = 26, .external_lex_state = 2},
  [1661] = {.lex_state = 26, .external_lex_state = 2},
  [1662] = {.lex_state = 6, .external_lex_state = 2},
  [1663] = {.lex_state = 6, .external_lex_state = 2},
  [1664] = {.lex_state = 38, .external_lex_state = 2},
  [1665] = {.lex_state = 6, .external_lex_state = 2},
  [1666] = {.lex_state = 6, .external_lex_state = 2},
  [1667] = {.lex_state = 38, .external_lex_state = 2},
  [1668] = {.lex_state = 101, .external_lex_state = 2},
  [1669] = {.lex_state = 26, .external_lex_state = 2},
  [1670] = {.lex_state = 38, .external_lex_state = 2},
  [1671] = {.lex_state = 100, .external_lex_state = 2},
  [1672] = {.lex_state = 38, .external_lex_state = 2},
  [1673] = {.lex_state = 101, .external_lex_state = 2},
  [1674] = {.lex_state = 100, .external_lex_state = 2},
  [1675] = {.lex_state = 26, .external_lex_state = 2},
  [1676] = {.lex_state = 38, .external_lex_state = 2},
  [1677] = {.lex_state = 26, .external_lex_state = 2},
  [1678] = {.lex_state = 38, .external_lex_state = 2},
  [1679] = {.lex_state = 26, .external_lex_state = 2},
  [1680] = {.lex_state = 38, .external_lex_state = 2},
  [1681] = {.lex_state = 38, .external_lex_state = 2},
  [1682] = {.lex_state = 26, .external_lex_state = 2},
  [1683] = {.lex_state = 38, .external_lex_state = 2},
  [1684] = {.lex_state = 38, .external_lex_state = 2},
  [1685] = {.lex_state = 38, .external_lex_state = 2},
  [1686] = {.lex_state = 101, .external_lex_state = 2},
  [1687] = {.lex_state = 38, .external_lex_state = 2},
  [1688] = {.lex_state = 101, .external_lex_state = 2},
  [1689] = {.lex_state = 101, .external_lex_state = 2},
  [1690] = {.lex_state = 101, .external_lex_state = 2},
  [1691] = {.lex_state = 101, .external_lex_state = 2},
  [1692] = {.lex_state = 38, .external_lex_state = 2},
  [1693] = {.lex_state = 101, .external_lex_state = 2},
  [1694] = {.lex_state = 38, .external_lex_state = 2},
  [1695] = {.lex_state = 101, .external_lex_state = 2},
  [1696] = {.lex_state = 26, .external_lex_state = 2},
  [1697] = {.lex_state = 38, .external_lex_state = 2},
  [1698] = {.lex_state = 101, .external_lex_state = 2},
  [1699] = {.lex_state = 101, .external_lex_state = 2},
  [1700] = {.lex_state = 38, .external_lex_state = 2},
  [1701] = {.lex_state = 101, .external_lex_state = 2},
  [1702] = {.lex_state = 38, .external_lex_state = 2},
  [1703] = {.lex_state = 38, .external_lex_state = 2},
  [1704] = {.lex_state = 38, .external_lex_state = 2},
  [1705] = {.lex_state = 101, .external_lex_state = 2},
  [1706] = {.lex_state = 38, .external_lex_state = 2},
  [1707] = {.lex_state = 101, .external_lex_state = 2},
  [1708] = {.lex_state = 26, .external_lex_state = 2},
  [1709] = {.lex_state = 26, .external_lex_state = 2},
  [1710] = {.lex_state = 26, .external_lex_state = 2},
  [1711] = {.lex_state = 26, .external_lex_state = 2},
  [1712] = {.lex_state = 101, .external_lex_state = 2},
  [1713] = {.lex_state = 100, .external_lex_state = 2},
  [1714] = {.lex_state = 101, .external_lex_state = 2},
  [1715] = {.lex_state = 101, .external_lex_state = 2},
  [1716] = {.lex_state = 101, .external_lex_state = 2},
  [1717] = {.lex_state = 101, .external_lex_state = 2},
  [1718] = {.lex_state = 102, .external_lex_state = 2},
  [1719] = {.lex_state = 100, .external_lex_state = 2},
  [1720] = {.lex_state = 100, .external_lex_state = 2},
  [1721] = {.lex_state = 102, .external_lex_state = 2},
  [1722] = {.lex_state = 101, .external_lex_state = 2},
  [1723] = {.lex_state = 100, .external_lex_state = 2},
  [1724] = {.lex_state = 100, .external_lex_state = 2},
  [1725] = {.lex_state = 100, .external_lex_state = 2},
  [1726] = {.lex_state = 0, .external_lex_state = 2},
  [1727] = {.lex_state = 101, .external_lex_state = 2},
  [1728] = {.lex_state = 101, .external_lex_state = 2},
  [1729] = {.lex_state = 101, .external_lex_state = 2},
  [1730] = {.lex_state = 101, .external_lex_state = 2},
  [1731] = {.lex_state = 101, .external_lex_state = 2},
  [1732] = {.lex_state = 101, .external_lex_state = 2},
  [1733] = {.lex_state = 101, .external_lex_state = 2},
  [1734] = {.lex_state = 101, .external_lex_state = 2},
  [1735] = {.lex_state = 101, .external_lex_state = 2},
  [1736] = {.lex_state = 101, .external_lex_state = 2},
  [1737] = {.lex_state = 101, .external_lex_state = 2},
  [1738] = {.lex_state = 101, .external_lex_state = 2},
  [1739] = {.lex_state = 101, .external_lex_state = 2},
  [1740] = {.lex_state = 101, .external_lex_state = 2},
  [1741] = {.lex_state = 101, .external_lex_state = 2},
  [1742] = {.lex_state = 101, .external_lex_state = 2},
  [1743] = {.lex_state = 101, .external_lex_state = 2},
  [1744] = {.lex_state = 101, .external_lex_state = 2},
  [1745] = {.lex_state = 101, .external_lex_state = 2},
  [1746] = {.lex_state = 101, .external_lex_state = 2},
  [1747] = {.lex_state = 101, .external_lex_state = 2},
  [1748] = {.lex_state = 101, .external_lex_state = 2},
  [1749] = {.lex_state = 101, .external_lex_state = 2},
  [1750] = {.lex_state = 101, .external_lex_state = 2},
  [1751] = {.lex_state = 101, .external_lex_state = 2},
  [1752] = {.lex_state = 101, .external_lex_state = 2},
  [1753] = {.lex_state = 101, .external_lex_state = 2},
  [1754] = {.lex_state = 101, .external_lex_state = 2},
  [1755] = {.lex_state = 101, .external_lex_state = 2},
  [1756] = {.lex_state = 101, .external_lex_state = 2},
  [1757] = {.lex_state = 101, .external_lex_state = 2},
  [1758] = {.lex_state = 101, .external_lex_state = 2},
  [1759] = {.lex_state = 101, .external_lex_state = 2},
  [1760] = {.lex_state = 101, .external_lex_state = 2},
  [1761] = {.lex_state = 101, .external_lex_state = 2},
  [1762] = {.lex_state = 101, .external_lex_state = 2},
  [1763] = {.lex_state = 101, .external_lex_state = 2},
  [1764] = {.lex_state = 101, .external_lex_state = 2},
  [1765] = {.lex_state = 101, .external_lex_state = 2},
  [1766] = {.lex_state = 101, .external_lex_state = 2},
  [1767] = {.lex_state = 101, .external_lex_state = 2},
  [1768] = {.lex_state = 101, .external_lex_state = 2},
  [1769] = {.lex_state = 101, .external_lex_state = 2},
  [1770] = {.lex_state = 101, .external_lex_state = 2},
  [1771] = {.lex_state = 101, .external_lex_state = 2},
  [1772] = {.lex_state = 101, .external_lex_state = 2},
  [1773] = {.lex_state = 101, .external_lex_state = 2},
  [1774] = {.lex_state = 101, .external_lex_state = 2},
  [1775] = {.lex_state = 101, .external_lex_state = 2},
  [1776] = {.lex_state = 101, .external_lex_state = 2},
  [1777] = {.lex_state = 101, .external_lex_state = 2},
  [1778] = {.lex_state = 101, .external_lex_state = 2},
  [1779] = {.lex_state = 101, .external_lex_state = 2},
  [1780] = {.lex_state = 101, .external_lex_state = 2},
  [1781] = {.lex_state = 101, .external_lex_state = 2},
  [1782] = {.lex_state = 101, .external_lex_state = 2},
  [1783] = {.lex_state = 101, .external_lex_state = 2},
  [1784] = {.lex_state = 101, .external_lex_state = 2},
  [1785] = {.lex_state = 101, .external_lex_state = 2},
  [1786] = {.lex_state = 101, .external_lex_state = 2},
  [1787] = {.lex_state = 101, .external_lex_state = 2},
  [1788] = {.lex_state = 101, .external_lex_state = 2},
  [1789] = {.lex_state = 101, .external_lex_state = 2},
  [1790] = {.lex_state = 101, .external_lex_state = 2},
  [1791] = {.lex_state = 101, .external_lex_state = 2},
  [1792] = {.lex_state = 101, .external_lex_state = 2},
  [1793] = {.lex_state = 101, .external_lex_state = 2},
  [1794] = {.lex_state = 101, .external_lex_state = 2},
  [1795] = {.lex_state = 101, .external_lex_state = 2},
  [1796] = {.lex_state = 101, .external_lex_state = 2},
  [1797] = {.lex_state = 101, .external_lex_state = 2},
  [1798] = {.lex_state = 101, .external_lex_state = 2},
  [1799] = {.lex_state = 101, .external_lex_state = 2},
  [1800] = {.lex_state = 101, .external_lex_state = 2},
  [1801] = {.lex_state = 101, .external_lex_state = 2},
  [1802] = {.lex_state = 101, .external_lex_state = 2},
  [1803] = {.lex_state = 101, .external_lex_state = 2},
  [1804] = {.lex_state = 101, .external_lex_state = 2},
  [1805] = {.lex_state = 101, .external_lex_state = 2},
  [1806] = {.lex_state = 101, .external_lex_state = 2},
  [1807] = {.lex_state = 101, .external_lex_state = 2},
  [1808] = {.lex_state = 101, .external_lex_state = 2},
  [1809] = {.lex_state = 101, .external_lex_state = 2},
  [1810] = {.lex_state = 101, .external_lex_state = 2},
  [1811] = {.lex_state = 19, .external_lex_state = 2},
  [1812] = {.lex_state = 19, .external_lex_state = 2},
  [1813] = {.lex_state = 101, .external_lex_state = 2},
  [1814] = {.lex_state = 101, .external_lex_state = 2},
  [1815] = {.lex_state = 101, .external_lex_state = 2},
  [1816] = {.lex_state = 101, .external_lex_state = 2},
  [1817] = {.lex_state = 0, .external_lex_state = 2},
  [1818] = {.lex_state = 101, .external_lex_state = 2},
  [1819] = {.lex_state = 101, .external_lex_state = 2},
  [1820] = {.lex_state = 101, .external_lex_state = 2},
  [1821] = {.lex_state = 101, .external_lex_state = 2},
  [1822] = {.lex_state = 19, .external_lex_state = 2},
  [1823] = {.lex_state = 101, .external_lex_state = 2},
  [1824] = {.lex_state = 101, .external_lex_state = 2},
  [1825] = {.lex_state = 19, .external_lex_state = 2},
  [1826] = {.lex_state = 19, .external_lex_state = 2},
  [1827] = {.lex_state = 19, .external_lex_state = 2},
  [1828] = {.lex_state = 19, .external_lex_state = 2},
  [1829] = {.lex_state = 19, .external_lex_state = 2},
  [1830] = {.lex_state = 101, .external_lex_state = 2},
  [1831] = {.lex_state = 19, .external_lex_state = 2},
  [1832] = {.lex_state = 19, .external_lex_state = 2},
  [1833] = {.lex_state = 101, .external_lex_state = 2},
  [1834] = {.lex_state = 101, .external_lex_state = 2},
  [1835] = {.lex_state = 101, .external_lex_state = 2},
  [1836] = {.lex_state = 101, .external_lex_state = 2},
  [1837] = {.lex_state = 101, .external_lex_state = 2},
  [1838] = {.lex_state = 101, .external_lex_state = 2},
  [1839] = {.lex_state = 101, .external_lex_state = 2},
  [1840] = {.lex_state = 0, .external_lex_state = 2},
  [1841] = {.lex_state = 101, .external_lex_state = 2},
  [1842] = {.lex_state = 101, .external_lex_state = 2},
  [1843] = {.lex_state = 101, .external_lex_state = 2},
  [1844] = {.lex_state = 101, .external_lex_state = 2},
  [1845] = {.lex_state = 101, .external_lex_state = 2},
  [1846] = {.lex_state = 101, .external_lex_state = 2},
  [1847] = {.lex_state = 101, .external_lex_state = 2},
  [1848] = {.lex_state = 101, .external_lex_state = 2},
  [1849] = {.lex_state = 101, .external_lex_state = 2},
  [1850] = {.lex_state = 19, .external_lex_state = 2},
  [1851] = {.lex_state = 101, .external_lex_state = 2},
  [1852] = {.lex_state = 101, .external_lex_state = 2},
  [1853] = {.lex_state = 19, .external_lex_state = 2},
  [1854] = {.lex_state = 19, .external_lex_state = 2},
  [1855] = {.lex_state = 101, .external_lex_state = 2},
  [1856] = {.lex_state = 101, .external_lex_state = 2},
  [1857] = {.lex_state = 101, .external_lex_state = 2},
  [1858] = {.lex_state = 101, .external_lex_state = 2},
  [1859] = {.lex_state = 101, .external_lex_state = 2},
  [1860] = {.lex_state = 19, .external_lex_state = 2},
  [1861] = {.lex_state = 101, .external_lex_state = 2},
  [1862] = {.lex_state = 101, .external_lex_state = 2},
  [1863] = {.lex_state = 101, .external_lex_state = 2},
  [1864] = {.lex_state = 101, .external_lex_state = 2},
  [1865] = {.lex_state = 101, .external_lex_state = 2},
  [1866] = {.lex_state = 101, .external_lex_state = 2},
  [1867] = {.lex_state = 101, .external_lex_state = 2},
  [1868] = {.lex_state = 19, .external_lex_state = 2},
  [1869] = {.lex_state = 0, .external_lex_state = 2},
  [1870] = {.lex_state = 101, .external_lex_state = 2},
  [1871] = {.lex_state = 101, .external_lex_state = 2},
  [1872] = {.lex_state = 101, .external_lex_state = 2},
  [1873] = {.lex_state = 101, .external_lex_state = 2},
  [1874] = {.lex_state = 101, .external_lex_state = 2},
  [1875] = {.lex_state = 101, .external_lex_state = 2},
  [1876] = {.lex_state = 101, .external_lex_state = 2},
  [1877] = {.lex_state = 101, .external_lex_state = 2},
  [1878] = {.lex_state = 101, .external_lex_state = 2},
  [1879] = {.lex_state = 19, .external_lex_state = 2},
  [1880] = {.lex_state = 101, .external_lex_state = 2},
  [1881] = {.lex_state = 101, .external_lex_state = 2},
  [1882] = {.lex_state = 101, .external_lex_state = 2},
  [1883] = {.lex_state = 19, .external_lex_state = 2},
  [1884] = {.lex_state = 101, .external_lex_state = 2},
  [1885] = {.lex_state = 0, .external_lex_state = 2},
  [1886] = {.lex_state = 101, .external_lex_state = 2},
  [1887] = {.lex_state = 101, .external_lex_state = 2},
  [1888] = {.lex_state = 101, .external_lex_state = 2},
  [1889] = {.lex_state = 101, .external_lex_state = 2},
  [1890] = {.lex_state = 101, .external_lex_state = 2},
  [1891] = {.lex_state = 101, .external_lex_state = 2},
  [1892] = {.lex_state = 101, .external_lex_state = 2},
  [1893] = {.lex_state = 0, .external_lex_state = 2},
  [1894] = {.lex_state = 101, .external_lex_state = 2},
  [1895] = {.lex_state = 101, .external_lex_state = 2},
  [1896] = {.lex_state = 101, .external_lex_state = 2},
  [1897] = {.lex_state = 101, .external_lex_state = 2},
  [1898] = {.lex_state = 101, .external_lex_state = 2},
  [1899] = {.lex_state = 101, .external_lex_state = 2},
  [1900] = {.lex_state = 101, .external_lex_state = 2},
  [1901] = {.lex_state = 101, .external_lex_state = 2},
  [1902] = {.lex_state = 101, .external_lex_state = 2},
  [1903] = {.lex_state = 101, .external_lex_state = 2},
  [1904] = {.lex_state = 38, .external_lex_state = 2},
  [1905] = {.lex_state = 101, .external_lex_state = 2},
  [1906] = {.lex_state = 101, .external_lex_state = 2},
  [1907] = {.lex_state = 101, .external_lex_state = 2},
  [1908] = {.lex_state = 0, .external_lex_state = 2},
  [1909] = {.lex_state = 0, .external_lex_state = 2},
  [1910] = {.lex_state = 101, .external_lex_state = 2},
  [1911] = {.lex_state = 19, .external_lex_state = 2},
  [1912] = {.lex_state = 101, .external_lex_state = 2},
  [1913] = {.lex_state = 101, .external_lex_state = 2},
  [1914] = {.lex_state = 101, .external_lex_state = 2},
  [1915] = {.lex_state = 101, .external_lex_state = 2},
  [1916] = {.lex_state = 101, .external_lex_state = 2},
  [1917] = {.lex_state = 101, .external_lex_state = 2},
  [1918] = {.lex_state = 100, .external_lex_state = 2},
  [1919] = {.lex_state = 101, .external_lex_state = 2},
  [1920] = {.lex_state = 100, .external_lex_state = 2},
  [1921] = {.lex_state = 24, .external_lex_state = 2},
  [1922] = {.lex_state = 0, .external_lex_state = 2},
  [1923] = {.lex_state = 101, .external_lex_state = 2},
  [1924] = {.lex_state = 101, .external_lex_state = 2},
  [1925] = {.lex_state = 100, .external_lex_state = 2},
  [1926] = {.lex_state = 100, .external_lex_state = 2},
  [1927] = {.lex_state = 101, .external_lex_state = 2},
  [1928] = {.lex_state = 101, .external_lex_state = 2},
  [1929] = {.lex_state = 100, .external_lex_state = 2},
  [1930] = {.lex_state = 101, .external_lex_state = 2},
  [1931] = {.lex_state = 9, .external_lex_state = 2},
  [1932] = {.lex_state = 9, .external_lex_state = 2},
  [1933] = {.lex_state = 38, .external_lex_state = 2},
  [1934] = {.lex_state = 101, .external_lex_state = 2},
  [1935] = {.lex_state = 101, .external_lex_state = 2},
  [1936] = {.lex_state = 9, .external_lex_state = 2},
  [1937] = {.lex_state = 100, .external_lex_state = 2},
  [1938] = {.lex_state = 9, .external_lex_state = 2},
  [1939] = {.lex_state = 9, .external_lex_state = 2},
  [1940] = {.lex_state = 9, .external_lex_state = 2},
  [1941] = {.lex_state = 100, .external_lex_state = 2},
  [1942] = {.lex_state = 100, .external_lex_state = 2},
  [1943] = {.lex_state = 9, .external_lex_state = 2},
  [1944] = {.lex_state = 100, .external_lex_state = 2},
  [1945] = {.lex_state = 100, .external_lex_state = 2},
  [1946] = {.lex_state = 101, .external_lex_state = 2},
  [1947] = {.lex_state = 101, .external_lex_state = 2},
  [1948] = {.lex_state = 9, .external_lex_state = 2},
  [1949] = {.lex_state = 9, .external_lex_state = 2},
  [1950] = {.lex_state = 101, .external_lex_state = 2},
  [1951] = {.lex_state = 9, .external_lex_state = 2},
  [1952] = {.lex_state = 9, .external_lex_state = 2},
  [1953] = {.lex_state = 101, .external_lex_state = 2},
  [1954] = {.lex_state = 101, .external_lex_state = 2},
  [1955] = {.lex_state = 9, .external_lex_state = 2},
  [1956] = {.lex_state = 9, .external_lex_state = 2},
  [1957] = {.lex_state = 101, .external_lex_state = 2},
  [1958] = {.lex_state = 100, .external_lex_state = 2},
  [1959] = {.lex_state = 101, .external_lex_state = 2},
  [1960] = {.lex_state = 9, .external_lex_state = 2},
  [1961] = {.lex_state = 101, .external_lex_state = 2},
  [1962] = {.lex_state = 20, .external_lex_state = 2},
  [1963] = {.lex_state = 20, .external_lex_state = 2},
  [1964] = {.lex_state = 20, .external_lex_state = 2},
  [1965] = {.lex_state = 20, .external_lex_state = 2},
  [1966] = {.lex_state = 20, .external_lex_state = 2},
  [1967] = {.lex_state = 20, .external_lex_state = 2},
  [1968] = {.lex_state = 20, .external_lex_state = 2},
  [1969] = {.lex_state = 101, .external_lex_state = 2},
  [1970] = {.lex_state = 20, .external_lex_state = 2},
  [1971] = {.lex_state = 101, .external_lex_state = 2},
  [1972] = {.lex_state = 101, .external_lex_state = 2},
  [1973] = {.lex_state = 100, .external_lex_state = 2},
  [1974] = {.lex_state = 100, .external_lex_state = 2},
  [1975] = {.lex_state = 100, .external_lex_state = 2},
  [1976] = {.lex_state = 101, .external_lex_state = 2},
  [1977] = {.lex_state = 100, .external_lex_state = 2},
  [1978] = {.lex_state = 100, .external_lex_state = 2},
  [1979] = {.lex_state = 100, .external_lex_state = 2},
  [1980] = {.lex_state = 100, .external_lex_state = 2},
  [1981] = {.lex_state = 101, .external_lex_state = 2},
  [1982] = {.lex_state = 100, .external_lex_state = 2},
  [1983] = {.lex_state = 101, .external_lex_state = 2},
  [1984] = {.lex_state = 101, .external_lex_state = 2},
  [1985] = {.lex_state = 38, .external_lex_state = 2},
  [1986] = {.lex_state = 101, .external_lex_state = 2},
  [1987] = {.lex_state = 101, .external_lex_state = 2},
  [1988] = {.lex_state = 101, .external_lex_state = 2},
  [1989] = {.lex_state = 101, .external_lex_state = 2},
  [1990] = {.lex_state = 9, .external_lex_state = 2},
  [1991] = {.lex_state = 100, .external_lex_state = 2},
  [1992] = {.lex_state = 101, .external_lex_state = 2},
  [1993] = {.lex_state = 101, .external_lex_state = 2},
  [1994] = {.lex_state = 100, .external_lex_state = 2},
  [1995] = {.lex_state = 101, .external_lex_state = 2},
  [1996] = {.lex_state = 100, .external_lex_state = 2},
  [1997] = {.lex_state = 100, .external_lex_state = 2},
  [1998] = {.lex_state = 100, .external_lex_state = 2},
  [1999] = {.lex_state = 100, .external_lex_state = 2},
  [2000] = {.lex_state = 38, .external_lex_state = 2},
  [2001] = {.lex_state = 100, .external_lex_state = 2},
  [2002] = {.lex_state = 100, .external_lex_state = 2},
  [2003] = {.lex_state = 100, .external_lex_state = 2},
  [2004] = {.lex_state = 38, .external_lex_state = 2},
  [2005] = {.lex_state = 101, .external_lex_state = 2},
  [2006] = {.lex_state = 101, .external_lex_state = 2},
  [2007] = {.lex_state = 101, .external_lex_state = 2},
  [2008] = {.lex_state = 41, .external_lex_state = 2},
  [2009] = {.lex_state = 41, .external_lex_state = 2},
  [2010] = {.lex_state = 101, .external_lex_state = 2},
  [2011] = {.lex_state = 41, .external_lex_state = 2},
  [2012] = {.lex_state = 24, .external_lex_state = 2},
  [2013] = {.lex_state = 101, .external_lex_state = 2},
  [2014] = {.lex_state = 24, .external_lex_state = 2},
  [2015] = {.lex_state = 24, .external_lex_state = 2},
  [2016] = {.lex_state = 41, .external_lex_state = 2},
  [2017] = {.lex_state = 24, .external_lex_state = 2},
  [2018] = {.lex_state = 19, .external_lex_state = 2},
  [2019] = {.lex_state = 101, .external_lex_state = 2},
  [2020] = {.lex_state = 41, .external_lex_state = 2},
  [2021] = {.lex_state = 101, .external_lex_state = 2},
  [2022] = {.lex_state = 24, .external_lex_state = 2},
  [2023] = {.lex_state = 101, .external_lex_state = 2},
  [2024] = {.lex_state = 41, .external_lex_state = 2},
  [2025] = {.lex_state = 24, .external_lex_state = 2},
  [2026] = {.lex_state = 24, .external_lex_state = 2},
  [2027] = {.lex_state = 101, .external_lex_state = 2},
  [2028] = {.lex_state = 24, .external_lex_state = 2},
  [2029] = {.lex_state = 24, .external_lex_state = 2},
  [2030] = {.lex_state = 101, .external_lex_state = 2},
  [2031] = {.lex_state = 41, .external_lex_state = 2},
  [2032] = {.lex_state = 24, .external_lex_state = 2},
  [2033] = {.lex_state = 101, .external_lex_state = 2},
  [2034] = {.lex_state = 24, .external_lex_state = 2},
  [2035] = {.lex_state = 101, .external_lex_state = 2},
  [2036] = {.lex_state = 101, .external_lex_state = 2},
  [2037] = {.lex_state = 41, .external_lex_state = 2},
  [2038] = {.lex_state = 38, .external_lex_state = 2},
  [2039] = {.lex_state = 24, .external_lex_state = 2},
  [2040] = {.lex_state = 101, .external_lex_state = 2},
  [2041] = {.lex_state = 24, .external_lex_state = 2},
  [2042] = {.lex_state = 101, .external_lex_state = 2},
  [2043] = {.lex_state = 101, .external_lex_state = 2},
  [2044] = {.lex_state = 101, .external_lex_state = 2},
  [2045] = {.lex_state = 24, .external_lex_state = 2},
  [2046] = {.lex_state = 24, .external_lex_state = 2},
  [2047] = {.lex_state = 24, .external_lex_state = 2},
  [2048] = {.lex_state = 101, .external_lex_state = 2},
  [2049] = {.lex_state = 24, .external_lex_state = 2},
  [2050] = {.lex_state = 24, .external_lex_state = 2},
  [2051] = {.lex_state = 101, .external_lex_state = 2},
  [2052] = {.lex_state = 24, .external_lex_state = 2},
  [2053] = {.lex_state = 101, .external_lex_state = 2},
  [2054] = {.lex_state = 101, .external_lex_state = 2},
  [2055] = {.lex_state = 24, .external_lex_state = 2},
  [2056] = {.lex_state = 24, .external_lex_state = 2},
  [2057] = {.lex_state = 101, .external_lex_state = 2},
  [2058] = {.lex_state = 101, .external_lex_state = 2},
  [2059] = {.lex_state = 101, .external_lex_state = 2},
  [2060] = {.lex_state = 38, .external_lex_state = 2},
  [2061] = {.lex_state = 101, .external_lex_state = 2},
  [2062] = {.lex_state = 101, .external_lex_state = 2},
  [2063] = {.lex_state = 38, .external_lex_state = 2},
  [2064] = {.lex_state = 101, .external_lex_state = 2},
  [2065] = {.lex_state = 101, .external_lex_state = 2},
  [2066] = {.lex_state = 101, .external_lex_state = 2},
  [2067] = {.lex_state = 102, .external_lex_state = 2},
  [2068] = {.lex_state = 101, .external_lex_state = 2},
  [2069] = {.lex_state = 101, .external_lex_state = 2},
  [2070] = {.lex_state = 101, .external_lex_state = 2},
  [2071] = {.lex_state = 101, .external_lex_state = 2},
  [2072] = {.lex_state = 101, .external_lex_state = 2},
  [2073] = {.lex_state = 101, .external_lex_state = 2},
  [2074] = {.lex_state = 101, .external_lex_state = 2},
  [2075] = {.lex_state = 101, .external_lex_state = 2},
  [2076] = {.lex_state = 101, .external_lex_state = 2},
  [2077] = {.lex_state = 101, .external_lex_state = 2},
  [2078] = {.lex_state = 19, .external_lex_state = 2},
  [2079] = {.lex_state = 101, .external_lex_state = 2},
  [2080] = {.lex_state = 101, .external_lex_state = 2},
  [2081] = {.lex_state = 101, .external_lex_state = 2},
  [2082] = {.lex_state = 101, .external_lex_state = 2},
  [2083] = {.lex_state = 101, .external_lex_state = 2},
  [2084] = {.lex_state = 101, .external_lex_state = 2},
  [2085] = {.lex_state = 101, .external_lex_state = 2},
  [2086] = {.lex_state = 101, .external_lex_state = 2},
  [2087] = {.lex_state = 101, .external_lex_state = 2},
  [2088] = {.lex_state = 101, .external_lex_state = 2},
  [2089] = {.lex_state = 101, .external_lex_state = 2},
  [2090] = {.lex_state = 101, .external_lex_state = 2},
  [2091] = {.lex_state = 101, .external_lex_state = 2},
  [2092] = {.lex_state = 101, .external_lex_state = 2},
  [2093] = {.lex_state = 101, .external_lex_state = 2},
  [2094] = {.lex_state = 101, .external_lex_state = 2},
  [2095] = {.lex_state = 23, .external_lex_state = 2},
  [2096] = {.lex_state = 101, .external_lex_state = 2},
  [2097] = {.lex_state = 101, .external_lex_state = 2},
  [2098] = {.lex_state = 101, .external_lex_state = 2},
  [2099] = {.lex_state = 102, .external_lex_state = 2},
  [2100] = {.lex_state = 101, .external_lex_state = 2},
  [2101] = {.lex_state = 23, .external_lex_state = 2},
  [2102] = {.lex_state = 19, .external_lex_state = 2},
  [2103] = {.lex_state = 101, .external_lex_state = 2},
  [2104] = {.lex_state = 19, .external_lex_state = 2},
  [2105] = {.lex_state = 19, .external_lex_state = 2},
  [2106] = {.lex_state = 19, .external_lex_state = 2},
  [2107] = {.lex_state = 101, .external_lex_state = 2},
  [2108] = {.lex_state = 19, .external_lex_state = 2},
  [2109] = {.lex_state = 19, .external_lex_state = 2},
  [2110] = {.lex_state = 19, .external_lex_state = 2},
  [2111] = {.lex_state = 101, .external_lex_state = 2},
  [2112] = {.lex_state = 100, .external_lex_state = 2},
  [2113] = {.lex_state = 101, .external_lex_state = 2},
  [2114] = {.lex_state = 19, .external_lex_state = 2},
  [2115] = {.lex_state = 19, .external_lex_state = 2},
  [2116] = {.lex_state = 100, .external_lex_state = 2},
  [2117] = {.lex_state = 38, .external_lex_state = 2},
  [2118] = {.lex_state = 101, .external_lex_state = 2},
  [2119] = {.lex_state = 19, .external_lex_state = 2},
  [2120] = {.lex_state = 19, .external_lex_state = 2},
  [2121] = {.lex_state = 19, .external_lex_state = 2},
  [2122] = {.lex_state = 19, .external_lex_state = 2},
  [2123] = {.lex_state = 19, .external_lex_state = 2},
  [2124] = {.lex_state = 19, .external_lex_state = 2},
  [2125] = {.lex_state = 19, .external_lex_state = 2},
  [2126] = {.lex_state = 38, .external_lex_state = 2},
  [2127] = {.lex_state = 19, .external_lex_state = 2},
  [2128] = {.lex_state = 19, .external_lex_state = 2},
  [2129] = {.lex_state = 19, .external_lex_state = 2},
  [2130] = {.lex_state = 19, .external_lex_state = 2},
  [2131] = {.lex_state = 100, .external_lex_state = 2},
  [2132] = {.lex_state = 100, .external_lex_state = 2},
  [2133] = {.lex_state = 19, .external_lex_state = 2},
  [2134] = {.lex_state = 19, .external_lex_state = 2},
  [2135] = {.lex_state = 20, .external_lex_state = 2},
  [2136] = {.lex_state = 101, .external_lex_state = 2},
  [2137] = {.lex_state = 12, .external_lex_state = 2},
  [2138] = {.lex_state = 12, .external_lex_state = 2},
  [2139] = {.lex_state = 101, .external_lex_state = 2},
  [2140] = {.lex_state = 20, .external_lex_state = 2},
  [2141] = {.lex_state = 38, .external_lex_state = 2},
  [2142] = {.lex_state = 12, .external_lex_state = 2},
  [2143] = {.lex_state = 101, .external_lex_state = 2},
  [2144] = {.lex_state = 38, .external_lex_state = 2},
  [2145] = {.lex_state = 38, .external_lex_state = 2},
  [2146] = {.lex_state = 101, .external_lex_state = 2},
  [2147] = {.lex_state = 101, .external_lex_state = 2},
  [2148] = {.lex_state = 101, .external_lex_state = 2},
  [2149] = {.lex_state = 101, .external_lex_state = 2},
  [2150] = {.lex_state = 20, .external_lex_state = 3},
  [2151] = {.lex_state = 17, .external_lex_state = 4},
  [2152] = {.lex_state = 101, .external_lex_state = 2},
  [2153] = {.lex_state = 17, .external_lex_state = 4},
  [2154] = {.lex_state = 17, .external_lex_state = 4},
  [2155] = {.lex_state = 101, .external_lex_state = 2},
  [2156] = {.lex_state = 38, .external_lex_state = 2},
  [2157] = {.lex_state = 20, .external_lex_state = 3},
  [2158] = {.lex_state = 17, .external_lex_state = 2},
  [2159] = {.lex_state = 101, .external_lex_state = 2},
  [2160] = {.lex_state = 17, .external_lex_state = 4},
  [2161] = {.lex_state = 38, .external_lex_state = 2},
  [2162] = {.lex_state = 20, .external_lex_state = 3},
  [2163] = {.lex_state = 101, .external_lex_state = 2},
  [2164] = {.lex_state = 38, .external_lex_state = 2},
  [2165] = {.lex_state = 17, .external_lex_state = 4},
  [2166] = {.lex_state = 17, .external_lex_state = 4},
  [2167] = {.lex_state = 38, .external_lex_state = 2},
  [2168] = {.lex_state = 101, .external_lex_state = 2},
  [2169] = {.lex_state = 102, .external_lex_state = 2},
  [2170] = {.lex_state = 20, .external_lex_state = 3},
  [2171] = {.lex_state = 101, .external_lex_state = 2},
  [2172] = {.lex_state = 17, .external_lex_state = 4},
  [2173] = {.lex_state = 20, .external_lex_state = 3},
  [2174] = {.lex_state = 38, .external_lex_state = 2},
  [2175] = {.lex_state = 38, .external_lex_state = 2},
  [2176] = {.lex_state = 20, .external_lex_state = 3},
  [2177] = {.lex_state = 17, .external_lex_state = 4},
  [2178] = {.lex_state = 17, .external_lex_state = 4},
  [2179] = {.lex_state = 17, .external_lex_state = 4},
  [2180] = {.lex_state = 17, .external_lex_state = 4},
  [2181] = {.lex_state = 20, .external_lex_state = 3},
  [2182] = {.lex_state = 20, .external_lex_state = 3},
  [2183] = {.lex_state = 20, .external_lex_state = 3},
  [2184] = {.lex_state = 20, .external_lex_state = 3},
  [2185] = {.lex_state = 20, .external_lex_state = 3},
  [2186] = {.lex_state = 101, .external_lex_state = 2},
  [2187] = {.lex_state = 0, .external_lex_state = 2},
  [2188] = {.lex_state = 101, .external_lex_state = 2},
  [2189] = {.lex_state = 38, .external_lex_state = 2},
  [2190] = {.lex_state = 101, .external_lex_state = 2},
  [2191] = {.lex_state = 33, .external_lex_state = 5},
  [2192] = {.lex_state = 33, .external_lex_state = 6},
  [2193] = {.lex_state = 101, .external_lex_state = 2},
  [2194] = {.lex_state = 101, .external_lex_state = 2},
  [2195] = {.lex_state = 0, .external_lex_state = 2},
  [2196] = {.lex_state = 33, .external_lex_state = 5},
  [2197] = {.lex_state = 101, .external_lex_state = 2},
  [2198] = {.lex_state = 33, .external_lex_state = 6},
  [2199] = {.lex_state = 101, .external_lex_state = 2},
  [2200] = {.lex_state = 100, .external_lex_state = 2},
  [2201] = {.lex_state = 20, .external_lex_state = 7},
  [2202] = {.lex_state = 17, .external_lex_state = 8},
  [2203] = {.lex_state = 33, .external_lex_state = 6},
  [2204] = {.lex_state = 102, .external_lex_state = 2},
  [2205] = {.lex_state = 100, .external_lex_state = 2},
  [2206] = {.lex_state = 33, .external_lex_state = 5},
  [2207] = {.lex_state = 0, .external_lex_state = 2},
  [2208] = {.lex_state = 20, .external_lex_state = 7},
  [2209] = {.lex_state = 17, .external_lex_state = 8},
  [2210] = {.lex_state = 33, .external_lex_state = 6},
  [2211] = {.lex_state = 17, .external_lex_state = 8},
  [2212] = {.lex_state = 33, .external_lex_state = 5},
  [2213] = {.lex_state = 20, .external_lex_state = 7},
  [2214] = {.lex_state = 17, .external_lex_state = 8},
  [2215] = {.lex_state = 20, .external_lex_state = 7},
  [2216] = {.lex_state = 38, .external_lex_state = 2},
  [2217] = {.lex_state = 101, .external_lex_state = 2},
  [2218] = {.lex_state = 33, .external_lex_state = 5},
  [2219] = {.lex_state = 38, .external_lex_state = 2},
  [2220] = {.lex_state = 33, .external_lex_state = 6},
  [2221] = {.lex_state = 101, .external_lex_state = 2},
  [2222] = {.lex_state = 17, .external_lex_state = 8},
  [2223] = {.lex_state = 20, .external_lex_state = 7},
  [2224] = {.lex_state = 101, .external_lex_state = 2},
  [2225] = {.lex_state = 38, .external_lex_state = 2},
  [2226] = {.lex_state = 33, .external_lex_state = 6},
  [2227] = {.lex_state = 33, .external_lex_state = 5},
  [2228] = {.lex_state = 101, .external_lex_state = 2},
  [2229] = {.lex_state = 17, .external_lex_state = 8},
  [2230] = {.lex_state = 101, .external_lex_state = 2},
  [2231] = {.lex_state = 101, .external_lex_state = 2},
  [2232] = {.lex_state = 33, .external_lex_state = 6},
  [2233] = {.lex_state = 33, .external_lex_state = 5},
  [2234] = {.lex_state = 101, .external_lex_state = 2},
  [2235] = {.lex_state = 101, .external_lex_state = 2},
  [2236] = {.lex_state = 17, .external_lex_state = 8},
  [2237] = {.lex_state = 3, .external_lex_state = 2},
  [2238] = {.lex_state = 20, .external_lex_state = 7},
  [2239] = {.lex_state = 33, .external_lex_state = 5},
  [2240] = {.lex_state = 33, .external_lex_state = 6},
  [2241] = {.lex_state = 20, .external_lex_state = 7},
  [2242] = {.lex_state = 17, .external_lex_state = 8},
  [2243] = {.lex_state = 20, .external_lex_state = 7},
  [2244] = {.lex_state = 17, .external_lex_state = 8},
  [2245] = {.lex_state = 33, .external_lex_state = 6},
  [2246] = {.lex_state = 33, .external_lex_state = 5},
  [2247] = {.lex_state = 38, .external_lex_state = 2},
  [2248] = {.lex_state = 17, .external_lex_state = 8},
  [2249] = {.lex_state = 20, .external_lex_state = 7},
  [2250] = {.lex_state = 17, .external_lex_state = 8},
  [2251] = {.lex_state = 33, .external_lex_state = 6},
  [2252] = {.lex_state = 101, .external_lex_state = 2},
  [2253] = {.lex_state = 33, .external_lex_state = 5},
  [2254] = {.lex_state = 20, .external_lex_state = 7},
  [2255] = {.lex_state = 33, .external_lex_state = 6},
  [2256] = {.lex_state = 33, .external_lex_state = 5},
  [2257] = {.lex_state = 101, .external_lex_state = 2},
  [2258] = {.lex_state = 101, .external_lex_state = 2},
  [2259] = {.lex_state = 38, .external_lex_state = 2},
  [2260] = {.lex_state = 100, .external_lex_state = 2},
  [2261] = {.lex_state = 20, .external_lex_state = 7},
  [2262] = {.lex_state = 38, .external_lex_state = 2},
  [2263] = {.lex_state = 33, .external_lex_state = 9},
  [2264] = {.lex_state = 0, .external_lex_state = 2},
  [2265] = {.lex_state = 22, .external_lex_state = 2},
  [2266] = {.lex_state = 101, .external_lex_state = 2},
  [2267] = {.lex_state = 101, .external_lex_state = 2},
  [2268] = {.lex_state = 0, .external_lex_state = 2},
  [2269] = {.lex_state = 101, .external_lex_state = 2},
  [2270] = {.lex_state = 101, .external_lex_state = 2},
  [2271] = {.lex_state = 0, .external_lex_state = 2},
  [2272] = {.lex_state = 101, .external_lex_state = 2},
  [2273] = {.lex_state = 100, .external_lex_state = 2},
  [2274] = {.lex_state = 0, .external_lex_state = 2},
  [2275] = {.lex_state = 101, .external_lex_state = 2},
  [2276] = {.lex_state = 22, .external_lex_state = 2},
  [2277] = {.lex_state = 101, .external_lex_state = 2},
  [2278] = {.lex_state = 101, .external_lex_state = 2},
  [2279] = {.lex_state = 100, .external_lex_state = 2},
  [2280] = {.lex_state = 33, .external_lex_state = 10},
  [2281] = {.lex_state = 33, .external_lex_state = 9},
  [2282] = {.lex_state = 101, .external_lex_state = 2},
  [2283] = {.lex_state = 101, .external_lex_state = 2},
  [2284] = {.lex_state = 100, .external_lex_state = 2},
  [2285] = {.lex_state = 22, .external_lex_state = 2},
  [2286] = {.lex_state = 101, .external_lex_state = 2},
  [2287] = {.lex_state = 101, .external_lex_state = 2},
  [2288] = {.lex_state = 101, .external_lex_state = 2},
  [2289] = {.lex_state = 22, .external_lex_state = 2},
  [2290] = {.lex_state = 33, .external_lex_state = 9},
  [2291] = {.lex_state = 0, .external_lex_state = 2},
  [2292] = {.lex_state = 101, .external_lex_state = 2},
  [2293] = {.lex_state = 101, .external_lex_state = 2},
  [2294] = {.lex_state = 33, .external_lex_state = 9},
  [2295] = {.lex_state = 33, .external_lex_state = 10},
  [2296] = {.lex_state = 22, .external_lex_state = 2},
  [2297] = {.lex_state = 101, .external_lex_state = 2},
  [2298] = {.lex_state = 33, .external_lex_state = 9},
  [2299] = {.lex_state = 100, .external_lex_state = 2},
  [2300] = {.lex_state = 33, .external_lex_state = 10},
  [2301] = {.lex_state = 33, .external_lex_state = 10},
  [2302] = {.lex_state = 22, .external_lex_state = 2},
  [2303] = {.lex_state = 0, .external_lex_state = 2},
  [2304] = {.lex_state = 33, .external_lex_state = 10},
  [2305] = {.lex_state = 22, .external_lex_state = 2},
  [2306] = {.lex_state = 33, .external_lex_state = 9},
  [2307] = {.lex_state = 29, .external_lex_state = 8},
  [2308] = {.lex_state = 101, .external_lex_state = 2},
  [2309] = {.lex_state = 101, .external_lex_state = 2},
  [2310] = {.lex_state = 101, .external_lex_state = 2},
  [2311] = {.lex_state = 22, .external_lex_state = 2},
  [2312] = {.lex_state = 101, .external_lex_state = 2},
  [2313] = {.lex_state = 33, .external_lex_state = 9},
  [2314] = {.lex_state = 33, .external_lex_state = 10},
  [2315] = {.lex_state = 100, .external_lex_state = 2},
  [2316] = {.lex_state = 33, .external_lex_state = 9},
  [2317] = {.lex_state = 33, .external_lex_state = 10},
  [2318] = {.lex_state = 33, .external_lex_state = 9},
  [2319] = {.lex_state = 33, .external_lex_state = 10},
  [2320] = {.lex_state = 3, .external_lex_state = 2},
  [2321] = {.lex_state = 101, .external_lex_state = 2},
  [2322] = {.lex_state = 33, .external_lex_state = 9},
  [2323] = {.lex_state = 32, .external_lex_state = 7},
  [2324] = {.lex_state = 33, .external_lex_state = 9},
  [2325] = {.lex_state = 22, .external_lex_state = 2},
  [2326] = {.lex_state = 33, .external_lex_state = 10},
  [2327] = {.lex_state = 101, .external_lex_state = 2},
  [2328] = {.lex_state = 33, .external_lex_state = 10},
  [2329] = {.lex_state = 22, .external_lex_state = 2},
  [2330] = {.lex_state = 33, .external_lex_state = 10},
  [2331] = {.lex_state = 22, .external_lex_state = 2},
  [2332] = {.lex_state = 100, .external_lex_state = 2},
  [2333] = {.lex_state = 0, .external_lex_state = 2},
  [2334] = {.lex_state = 100, .external_lex_state = 2},
  [2335] = {.lex_state = 100, .external_lex_state = 2},
  [2336] = {.lex_state = 3, .external_lex_state = 2},
  [2337] = {.lex_state = 0, .external_lex_state = 2},
  [2338] = {.lex_state = 100, .external_lex_state = 2},
  [2339] = {.lex_state = 0, .external_lex_state = 2},
  [2340] = {.lex_state = 100, .external_lex_state = 2},
  [2341] = {.lex_state = 100, .external_lex_state = 2},
  [2342] = {.lex_state = 0, .external_lex_state = 2},
  [2343] = {.lex_state = 101, .external_lex_state = 2},
  [2344] = {.lex_state = 101, .external_lex_state = 2},
  [2345] = {.lex_state = 100, .external_lex_state = 2},
  [2346] = {.lex_state = 100, .external_lex_state = 2},
  [2347] = {.lex_state = 0, .external_lex_state = 2},
  [2348] = {.lex_state = 100, .external_lex_state = 2},
  [2349] = {.lex_state = 0, .external_lex_state = 2},
  [2350] = {.lex_state = 100, .external_lex_state = 2},
  [2351] = {.lex_state = 100, .external_lex_state = 2},
  [2352] = {.lex_state = 22, .external_lex_state = 2},
  [2353] = {.lex_state = 100, .external_lex_state = 2},
  [2354] = {.lex_state = 0, .external_lex_state = 2},
  [2355] = {.lex_state = 100, .external_lex_state = 2},
  [2356] = {.lex_state = 100, .external_lex_state = 2},
  [2357] = {.lex_state = 101, .external_lex_state = 2},
  [2358] = {.lex_state = 0, .external_lex_state = 2},
  [2359] = {.lex_state = 100, .external_lex_state = 2},
  [2360] = {.lex_state = 0, .external_lex_state = 2},
  [2361] = {.lex_state = 3, .external_lex_state = 2},
  [2362] = {.lex_state = 17, .external_lex_state = 8},
  [2363] = {.lex_state = 100, .external_lex_state = 2},
  [2364] = {.lex_state = 100, .external_lex_state = 2},
  [2365] = {.lex_state = 100, .external_lex_state = 2},
  [2366] = {.lex_state = 100, .external_lex_state = 2},
  [2367] = {.lex_state = 100, .external_lex_state = 2},
  [2368] = {.lex_state = 0, .external_lex_state = 2},
  [2369] = {.lex_state = 100, .external_lex_state = 2},
  [2370] = {.lex_state = 0, .external_lex_state = 2},
  [2371] = {.lex_state = 100, .external_lex_state = 2},
  [2372] = {.lex_state = 101, .external_lex_state = 2},
  [2373] = {.lex_state = 101, .external_lex_state = 2},
  [2374] = {.lex_state = 100, .external_lex_state = 2},
  [2375] = {.lex_state = 0, .external_lex_state = 2},
  [2376] = {.lex_state = 100, .external_lex_state = 2},
  [2377] = {.lex_state = 101, .external_lex_state = 2},
  [2378] = {.lex_state = 101, .external_lex_state = 2},
  [2379] = {.lex_state = 100, .external_lex_state = 2},
  [2380] = {.lex_state = 100, .external_lex_state = 2},
  [2381] = {.lex_state = 100, .external_lex_state = 2},
  [2382] = {.lex_state = 100, .external_lex_state = 2},
  [2383] = {.lex_state = 100, .external_lex_state = 2},
  [2384] = {.lex_state = 100, .external_lex_state = 2},
  [2385] = {.lex_state = 100, .external_lex_state = 2},
  [2386] = {.lex_state = 100, .external_lex_state = 2},
  [2387] = {.lex_state = 100, .external_lex_state = 2},
  [2388] = {.lex_state = 100, .external_lex_state = 2},
  [2389] = {.lex_state = 100, .external_lex_state = 2},
  [2390] = {.lex_state = 100, .external_lex_state = 2},
  [2391] = {.lex_state = 100, .external_lex_state = 2},
  [2392] = {.lex_state = 0, .external_lex_state = 2},
  [2393] = {.lex_state = 100, .external_lex_state = 2},
  [2394] = {.lex_state = 100, .external_lex_state = 2},
  [2395] = {.lex_state = 101, .external_lex_state = 2},
  [2396] = {.lex_state = 100, .external_lex_state = 2},
  [2397] = {.lex_state = 100, .external_lex_state = 2},
  [2398] = {.lex_state = 20, .external_lex_state = 7},
  [2399] = {.lex_state = 100, .external_lex_state = 2},
  [2400] = {.lex_state = 101, .external_lex_state = 2},
  [2401] = {.lex_state = 100, .external_lex_state = 2},
  [2402] = {.lex_state = 17, .external_lex_state = 8},
  [2403] = {.lex_state = 0, .external_lex_state = 2},
  [2404] = {.lex_state = 100, .external_lex_state = 2},
  [2405] = {.lex_state = 100, .external_lex_state = 2},
  [2406] = {.lex_state = 22, .external_lex_state = 2},
  [2407] = {.lex_state = 38, .external_lex_state = 2},
  [2408] = {.lex_state = 20, .external_lex_state = 7},
  [2409] = {.lex_state = 100, .external_lex_state = 2},
  [2410] = {.lex_state = 101, .external_lex_state = 2},
  [2411] = {.lex_state = 101, .external_lex_state = 2},
  [2412] = {.lex_state = 100, .external_lex_state = 2},
  [2413] = {.lex_state = 100, .external_lex_state = 2},
  [2414] = {.lex_state = 100, .external_lex_state = 2},
  [2415] = {.lex_state = 100, .external_lex_state = 2},
  [2416] = {.lex_state = 100, .external_lex_state = 2},
  [2417] = {.lex_state = 0, .external_lex_state = 2},
  [2418] = {.lex_state = 22, .external_lex_state = 2},
  [2419] = {.lex_state = 101, .external_lex_state = 2},
  [2420] = {.lex_state = 38, .external_lex_state = 2},
  [2421] = {.lex_state = 101, .external_lex_state = 2},
  [2422] = {.lex_state = 0, .external_lex_state = 2},
  [2423] = {.lex_state = 100, .external_lex_state = 2},
  [2424] = {.lex_state = 101, .external_lex_state = 2},
  [2425] = {.lex_state = 35, .external_lex_state = 10},
  [2426] = {.lex_state = 0, .external_lex_state = 2},
  [2427] = {.lex_state = 100, .external_lex_state = 2},
  [2428] = {.lex_state = 100, .external_lex_state = 2},
  [2429] = {.lex_state = 0, .external_lex_state = 2},
  [2430] = {.lex_state = 0, .external_lex_state = 2},
  [2431] = {.lex_state = 101, .external_lex_state = 2},
  [2432] = {.lex_state = 100, .external_lex_state = 2},
  [2433] = {.lex_state = 101, .external_lex_state = 2},
  [2434] = {.lex_state = 35, .external_lex_state = 9},
  [2435] = {.lex_state = 100, .external_lex_state = 2},
  [2436] = {.lex_state = 101, .external_lex_state = 2},
  [2437] = {.lex_state = 101, .external_lex_state = 2},
  [2438] = {.lex_state = 100, .external_lex_state = 2},
  [2439] = {.lex_state = 33, .external_lex_state = 10},
  [2440] = {.lex_state = 101, .external_lex_state = 2},
  [2441] = {.lex_state = 20, .external_lex_state = 3},
  [2442] = {.lex_state = 100, .external_lex_state = 2},
  [2443] = {.lex_state = 101, .external_lex_state = 2},
  [2444] = {.lex_state = 101, .external_lex_state = 2},
  [2445] = {.lex_state = 100, .external_lex_state = 2},
  [2446] = {.lex_state = 0, .external_lex_state = 2},
  [2447] = {.lex_state = 100, .external_lex_state = 2},
  [2448] = {.lex_state = 33, .external_lex_state = 9},
  [2449] = {.lex_state = 20, .external_lex_state = 3},
  [2450] = {.lex_state = 101, .external_lex_state = 2},
  [2451] = {.lex_state = 0, .external_lex_state = 2},
  [2452] = {.lex_state = 101, .external_lex_state = 2},
  [2453] = {.lex_state = 17, .external_lex_state = 4},
  [2454] = {.lex_state = 100, .external_lex_state = 2},
  [2455] = {.lex_state = 101, .external_lex_state = 2},
  [2456] = {.lex_state = 101, .external_lex_state = 2},
  [2457] = {.lex_state = 3, .external_lex_state = 2},
  [2458] = {.lex_state = 0, .external_lex_state = 2},
  [2459] = {.lex_state = 0, .external_lex_state = 2},
  [2460] = {.lex_state = 0, .external_lex_state = 2},
  [2461] = {.lex_state = 100, .external_lex_state = 2},
  [2462] = {.lex_state = 100, .external_lex_state = 2},
  [2463] = {.lex_state = 100, .external_lex_state = 2},
  [2464] = {.lex_state = 100, .external_lex_state = 2},
  [2465] = {.lex_state = 100, .external_lex_state = 2},
  [2466] = {.lex_state = 100, .external_lex_state = 2},
  [2467] = {.lex_state = 20, .external_lex_state = 3},
  [2468] = {.lex_state = 100, .external_lex_state = 2},
  [2469] = {.lex_state = 100, .external_lex_state = 2},
  [2470] = {.lex_state = 0, .external_lex_state = 2},
  [2471] = {.lex_state = 100, .external_lex_state = 2},
  [2472] = {.lex_state = 100, .external_lex_state = 2},
  [2473] = {.lex_state = 100, .external_lex_state = 2},
  [2474] = {.lex_state = 100, .external_lex_state = 2},
  [2475] = {.lex_state = 100, .external_lex_state = 2},
  [2476] = {.lex_state = 101, .external_lex_state = 2},
  [2477] = {.lex_state = 101, .external_lex_state = 2},
  [2478] = {.lex_state = 100, .external_lex_state = 2},
  [2479] = {.lex_state = 101, .external_lex_state = 2},
  [2480] = {.lex_state = 100, .external_lex_state = 2},
  [2481] = {.lex_state = 101, .external_lex_state = 2},
  [2482] = {.lex_state = 101, .external_lex_state = 2},
  [2483] = {.lex_state = 100, .external_lex_state = 2},
  [2484] = {.lex_state = 101, .external_lex_state = 2},
  [2485] = {.lex_state = 100, .external_lex_state = 2},
  [2486] = {.lex_state = 101, .external_lex_state = 2},
  [2487] = {.lex_state = 17, .external_lex_state = 4},
  [2488] = {.lex_state = 101, .external_lex_state = 2},
  [2489] = {.lex_state = 101, .external_lex_state = 2},
  [2490] = {.lex_state = 101, .external_lex_state = 2},
  [2491] = {.lex_state = 101, .external_lex_state = 2},
  [2492] = {.lex_state = 0, .external_lex_state = 2},
  [2493] = {.lex_state = 0, .external_lex_state = 2},
  [2494] = {.lex_state = 100, .external_lex_state = 2},
  [2495] = {.lex_state = 17, .external_lex_state = 4},
  [2496] = {.lex_state = 3, .external_lex_state = 2},
  [2497] = {.lex_state = 33, .external_lex_state = 10},
  [2498] = {.lex_state = 17, .external_lex_state = 4},
  [2499] = {.lex_state = 17, .external_lex_state = 4},
  [2500] = {.lex_state = 100, .external_lex_state = 2},
  [2501] = {.lex_state = 101, .external_lex_state = 2},
  [2502] = {.lex_state = 3, .external_lex_state = 2},
  [2503] = {.lex_state = 101, .external_lex_state = 2},
  [2504] = {.lex_state = 102, .external_lex_state = 2},
  [2505] = {.lex_state = 101, .external_lex_state = 2},
  [2506] = {.lex_state = 0, .external_lex_state = 2},
  [2507] = {.lex_state = 101, .external_lex_state = 2},
  [2508] = {.lex_state = 0, .external_lex_state = 2},
  [2509] = {.lex_state = 101, .external_lex_state = 2},
  [2510] = {.lex_state = 101, .external_lex_state = 2},
  [2511] = {.lex_state = 101, .external_lex_state = 2},
  [2512] = {.lex_state = 101, .external_lex_state = 2},
  [2513] = {.lex_state = 100, .external_lex_state = 2},
  [2514] = {.lex_state = 101, .external_lex_state = 2},
  [2515] = {.lex_state = 101, .external_lex_state = 2},
  [2516] = {.lex_state = 0, .external_lex_state = 2},
  [2517] = {.lex_state = 33, .external_lex_state = 9},
  [2518] = {.lex_state = 20, .external_lex_state = 3},
  [2519] = {.lex_state = 20, .external_lex_state = 3},
  [2520] = {.lex_state = 0, .external_lex_state = 2},
  [2521] = {.lex_state = 0, .external_lex_state = 2},
  [2522] = {.lex_state = 101, .external_lex_state = 2},
  [2523] = {.lex_state = 100, .external_lex_state = 2},
  [2524] = {.lex_state = 100, .external_lex_state = 2},
  [2525] = {.lex_state = 100, .external_lex_state = 2},
  [2526] = {.lex_state = 0, .external_lex_state = 2},
  [2527] = {.lex_state = 101, .external_lex_state = 2},
  [2528] = {.lex_state = 102, .external_lex_state = 2},
  [2529] = {.lex_state = 101, .external_lex_state = 2},
  [2530] = {.lex_state = 101, .external_lex_state = 2},
  [2531] = {.lex_state = 33, .external_lex_state = 6},
  [2532] = {.lex_state = 101, .external_lex_state = 2},
  [2533] = {.lex_state = 33, .external_lex_state = 6},
  [2534] = {.lex_state = 101, .external_lex_state = 2},
  [2535] = {.lex_state = 101, .external_lex_state = 2},
  [2536] = {.lex_state = 0, .external_lex_state = 2},
  [2537] = {.lex_state = 3, .external_lex_state = 2},
  [2538] = {.lex_state = 33, .external_lex_state = 5},
  [2539] = {.lex_state = 100, .external_lex_state = 2},
  [2540] = {.lex_state = 101, .external_lex_state = 2},
  [2541] = {.lex_state = 101, .external_lex_state = 2},
  [2542] = {.lex_state = 100, .external_lex_state = 2},
  [2543] = {.lex_state = 3, .external_lex_state = 2},
  [2544] = {.lex_state = 101, .external_lex_state = 2},
  [2545] = {.lex_state = 101, .external_lex_state = 2},
  [2546] = {.lex_state = 100, .external_lex_state = 2},
  [2547] = {.lex_state = 101, .external_lex_state = 2},
  [2548] = {.lex_state = 101, .external_lex_state = 2},
  [2549] = {.lex_state = 0, .external_lex_state = 2},
  [2550] = {.lex_state = 101, .external_lex_state = 2},
  [2551] = {.lex_state = 101, .external_lex_state = 2},
  [2552] = {.lex_state = 100, .external_lex_state = 2},
  [2553] = {.lex_state = 101, .external_lex_state = 2},
  [2554] = {.lex_state = 101, .external_lex_state = 2},
  [2555] = {.lex_state = 101, .external_lex_state = 2},
  [2556] = {.lex_state = 102, .external_lex_state = 2},
  [2557] = {.lex_state = 101, .external_lex_state = 2},
  [2558] = {.lex_state = 33, .external_lex_state = 6},
  [2559] = {.lex_state = 101, .external_lex_state = 2},
  [2560] = {.lex_state = 102, .external_lex_state = 2},
  [2561] = {.lex_state = 101, .external_lex_state = 2},
  [2562] = {.lex_state = 101, .external_lex_state = 2},
  [2563] = {.lex_state = 101, .external_lex_state = 2},
  [2564] = {.lex_state = 101, .external_lex_state = 2},
  [2565] = {.lex_state = 0, .external_lex_state = 2},
  [2566] = {.lex_state = 101, .external_lex_state = 2},
  [2567] = {.lex_state = 101, .external_lex_state = 2},
  [2568] = {.lex_state = 0, .external_lex_state = 2},
  [2569] = {.lex_state = 33, .external_lex_state = 5},
  [2570] = {.lex_state = 33, .external_lex_state = 5},
  [2571] = {.lex_state = 101, .external_lex_state = 2},
  [2572] = {.lex_state = 101, .external_lex_state = 2},
  [2573] = {.lex_state = 33, .external_lex_state = 6},
  [2574] = {.lex_state = 101, .external_lex_state = 2},
  [2575] = {.lex_state = 101, .external_lex_state = 2},
  [2576] = {.lex_state = 100, .external_lex_state = 2},
  [2577] = {.lex_state = 100, .external_lex_state = 2},
  [2578] = {.lex_state = 101, .external_lex_state = 2},
  [2579] = {.lex_state = 101, .external_lex_state = 2},
  [2580] = {.lex_state = 102, .external_lex_state = 2},
  [2581] = {.lex_state = 101, .external_lex_state = 2},
  [2582] = {.lex_state = 101, .external_lex_state = 2},
  [2583] = {.lex_state = 33, .external_lex_state = 5},
  [2584] = {.lex_state = 33, .external_lex_state = 6},
  [2585] = {.lex_state = 33, .external_lex_state = 5},
  [2586] = {.lex_state = 101, .external_lex_state = 2},
  [2587] = {.lex_state = 101, .external_lex_state = 2},
  [2588] = {.lex_state = 101, .external_lex_state = 2},
  [2589] = {.lex_state = 101, .external_lex_state = 2},
  [2590] = {.lex_state = 0, .external_lex_state = 2},
  [2591] = {.lex_state = 0, .external_lex_state = 2},
  [2592] = {.lex_state = 100, .external_lex_state = 2},
  [2593] = {.lex_state = 101, .external_lex_state = 2},
  [2594] = {.lex_state = 100, .external_lex_state = 2},
  [2595] = {.lex_state = 100, .external_lex_state = 2},
  [2596] = {.lex_state = 101, .external_lex_state = 2},
  [2597] = {.lex_state = 101, .external_lex_state = 2},
  [2598] = {.lex_state = 101, .external_lex_state = 2},
  [2599] = {.lex_state = 101, .external_lex_state = 2},
  [2600] = {.lex_state = 101, .external_lex_state = 2},
  [2601] = {.lex_state = 101, .external_lex_state = 2},
  [2602] = {.lex_state = 100, .external_lex_state = 2},
  [2603] = {.lex_state = 101, .external_lex_state = 2},
  [2604] = {.lex_state = 100, .external_lex_state = 2},
  [2605] = {.lex_state = 0, .external_lex_state = 2},
  [2606] = {.lex_state = 101, .external_lex_state = 2},
  [2607] = {.lex_state = 100, .external_lex_state = 2},
  [2608] = {.lex_state = 101, .external_lex_state = 2},
  [2609] = {.lex_state = 100, .external_lex_state = 2},
  [2610] = {.lex_state = 0, .external_lex_state = 2},
  [2611] = {.lex_state = 100, .external_lex_state = 2},
  [2612] = {.lex_state = 101, .external_lex_state = 2},
  [2613] = {.lex_state = 100, .external_lex_state = 2},
  [2614] = {.lex_state = 101, .external_lex_state = 2},
  [2615] = {.lex_state = 101, .external_lex_state = 2},
  [2616] = {.lex_state = 101, .external_lex_state = 2},
  [2617] = {.lex_state = 101, .external_lex_state = 2},
  [2618] = {.lex_state = 101, .external_lex_state = 2},
  [2619] = {.lex_state = 101, .external_lex_state = 2},
  [2620] = {.lex_state = 101, .external_lex_state = 2},
  [2621] = {.lex_state = 100, .external_lex_state = 2},
  [2622] = {.lex_state = 101, .external_lex_state = 2},
  [2623] = {.lex_state = 100, .external_lex_state = 2},
  [2624] = {.lex_state = 0, .external_lex_state = 2},
  [2625] = {.lex_state = 100, .external_lex_state = 2},
  [2626] = {.lex_state = 100, .external_lex_state = 2},
  [2627] = {.lex_state = 100, .external_lex_state = 2},
  [2628] = {.lex_state = 100, .external_lex_state = 2},
  [2629] = {.lex_state = 101, .external_lex_state = 2},
  [2630] = {.lex_state = 0, .external_lex_state = 2},
  [2631] = {.lex_state = 0, .external_lex_state = 2},
  [2632] = {.lex_state = 101, .external_lex_state = 2},
  [2633] = {.lex_state = 101, .external_lex_state = 2},
  [2634] = {.lex_state = 101, .external_lex_state = 2},
  [2635] = {.lex_state = 100, .external_lex_state = 2},
  [2636] = {.lex_state = 101, .external_lex_state = 2},
  [2637] = {.lex_state = 101, .external_lex_state = 2},
  [2638] = {.lex_state = 101, .external_lex_state = 2},
  [2639] = {.lex_state = 101, .external_lex_state = 2},
  [2640] = {.lex_state = 101, .external_lex_state = 2},
  [2641] = {.lex_state = 0, .external_lex_state = 2},
  [2642] = {.lex_state = 100, .external_lex_state = 2},
  [2643] = {.lex_state = 101, .external_lex_state = 2},
  [2644] = {.lex_state = 101, .external_lex_state = 2},
  [2645] = {.lex_state = 101, .external_lex_state = 2},
  [2646] = {.lex_state = 101, .external_lex_state = 2},
  [2647] = {.lex_state = 101, .external_lex_state = 2},
  [2648] = {.lex_state = 100, .external_lex_state = 2},
  [2649] = {.lex_state = 101, .external_lex_state = 2},
  [2650] = {.lex_state = 100, .external_lex_state = 2},
  [2651] = {.lex_state = 101, .external_lex_state = 2},
  [2652] = {.lex_state = 101, .external_lex_state = 2},
  [2653] = {.lex_state = 101, .external_lex_state = 2},
  [2654] = {.lex_state = 100, .external_lex_state = 2},
  [2655] = {.lex_state = 0, .external_lex_state = 2},
  [2656] = {.lex_state = 100, .external_lex_state = 2},
  [2657] = {.lex_state = 100, .external_lex_state = 2},
  [2658] = {.lex_state = 0, .external_lex_state = 2},
  [2659] = {.lex_state = 101, .external_lex_state = 2},
  [2660] = {.lex_state = 101, .external_lex_state = 2},
  [2661] = {.lex_state = 100, .external_lex_state = 2},
  [2662] = {.lex_state = 100, .external_lex_state = 2},
  [2663] = {.lex_state = 100, .external_lex_state = 2},
  [2664] = {.lex_state = 101, .external_lex_state = 2},
  [2665] = {.lex_state = 101, .external_lex_state = 2},
  [2666] = {.lex_state = 101, .external_lex_state = 2},
  [2667] = {.lex_state = 100, .external_lex_state = 2},
  [2668] = {.lex_state = 100, .external_lex_state = 2},
  [2669] = {.lex_state = 100, .external_lex_state = 2},
  [2670] = {.lex_state = 0, .external_lex_state = 2},
  [2671] = {.lex_state = 101, .external_lex_state = 2},
  [2672] = {.lex_state = 0, .external_lex_state = 2},
  [2673] = {.lex_state = 0, .external_lex_state = 2},
  [2674] = {.lex_state = 0, .external_lex_state = 2},
  [2675] = {.lex_state = 101, .external_lex_state = 2},
  [2676] = {.lex_state = 101, .external_lex_state = 2},
  [2677] = {.lex_state = 0, .external_lex_state = 2},
  [2678] = {.lex_state = 0, .external_lex_state = 2},
  [2679] = {.lex_state = 0, .external_lex_state = 2},
  [2680] = {.lex_state = 101, .external_lex_state = 2},
  [2681] = {.lex_state = 0, .external_lex_state = 2},
  [2682] = {.lex_state = 0, .external_lex_state = 2},
  [2683] = {.lex_state = 100, .external_lex_state = 2},
  [2684] = {.lex_state = 0, .external_lex_state = 2},
  [2685] = {.lex_state = 100, .external_lex_state = 2},
  [2686] = {.lex_state = 0, .external_lex_state = 2},
  [2687] = {.lex_state = 0, .external_lex_state = 2},
  [2688] = {.lex_state = 0, .external_lex_state = 2},
  [2689] = {.lex_state = 100, .external_lex_state = 2},
  [2690] = {.lex_state = 101, .external_lex_state = 2},
  [2691] = {.lex_state = 101, .external_lex_state = 2},
  [2692] = {.lex_state = 100, .external_lex_state = 2},
  [2693] = {.lex_state = 101, .external_lex_state = 2},
  [2694] = {.lex_state = 0, .external_lex_state = 2},
  [2695] = {.lex_state = 0, .external_lex_state = 2},
  [2696] = {.lex_state = 0, .external_lex_state = 2},
  [2697] = {.lex_state = 100, .external_lex_state = 2},
  [2698] = {.lex_state = 101, .external_lex_state = 2},
  [2699] = {.lex_state = 100, .external_lex_state = 2},
  [2700] = {.lex_state = 100, .external_lex_state = 2},
  [2701] = {.lex_state = 0, .external_lex_state = 2},
  [2702] = {.lex_state = 100, .external_lex_state = 2},
  [2703] = {.lex_state = 0, .external_lex_state = 2},
  [2704] = {.lex_state = 101, .external_lex_state = 2},
  [2705] = {.lex_state = 100, .external_lex_state = 2},
  [2706] = {.lex_state = 0, .external_lex_state = 2},
  [2707] = {.lex_state = 0, .external_lex_state = 2},
  [2708] = {.lex_state = 0, .external_lex_state = 2},
  [2709] = {.lex_state = 100, .external_lex_state = 2},
  [2710] = {.lex_state = 101, .external_lex_state = 2},
  [2711] = {.lex_state = 0, .external_lex_state = 2},
  [2712] = {.lex_state = 101, .external_lex_state = 2},
  [2713] = {.lex_state = 101, .external_lex_state = 2},
  [2714] = {.lex_state = 0, .external_lex_state = 2},
  [2715] = {.lex_state = 0, .external_lex_state = 2},
  [2716] = {.lex_state = 0, .external_lex_state = 2},
  [2717] = {.lex_state = 101, .external_lex_state = 2},
  [2718] = {.lex_state = 0, .external_lex_state = 2},
  [2719] = {.lex_state = 0, .external_lex_state = 2},
  [2720] = {.lex_state = 0, .external_lex_state = 2},
  [2721] = {.lex_state = 100, .external_lex_state = 2},
  [2722] = {.lex_state = 0, .external_lex_state = 2},
  [2723] = {.lex_state = 100, .external_lex_state = 2},
  [2724] = {.lex_state = 0, .external_lex_state = 2},
  [2725] = {.lex_state = 0, .external_lex_state = 2},
  [2726] = {.lex_state = 0, .external_lex_state = 2},
  [2727] = {.lex_state = 0, .external_lex_state = 2},
  [2728] = {.lex_state = 0, .external_lex_state = 2},
  [2729] = {.lex_state = 100, .external_lex_state = 2},
  [2730] = {.lex_state = 0, .external_lex_state = 2},
  [2731] = {.lex_state = 0, .external_lex_state = 2},
  [2732] = {.lex_state = 100, .external_lex_state = 2},
  [2733] = {.lex_state = 101, .external_lex_state = 2},
  [2734] = {.lex_state = 0, .external_lex_state = 2},
  [2735] = {.lex_state = 0, .external_lex_state = 2},
  [2736] = {.lex_state = 0, .external_lex_state = 2},
  [2737] = {.lex_state = 101, .external_lex_state = 2},
  [2738] = {.lex_state = 100, .external_lex_state = 2},
  [2739] = {.lex_state = 0, .external_lex_state = 2},
  [2740] = {.lex_state = 0, .external_lex_state = 2},
  [2741] = {.lex_state = 101, .external_lex_state = 2},
  [2742] = {.lex_state = 0, .external_lex_state = 2},
  [2743] = {.lex_state = 100, .external_lex_state = 2},
  [2744] = {.lex_state = 101, .external_lex_state = 2},
  [2745] = {.lex_state = 0, .external_lex_state = 2},
  [2746] = {.lex_state = 0, .external_lex_state = 2},
  [2747] = {.lex_state = 0, .external_lex_state = 2},
  [2748] = {.lex_state = 0, .external_lex_state = 2},
  [2749] = {.lex_state = 0, .external_lex_state = 2},
  [2750] = {.lex_state = 0, .external_lex_state = 2},
  [2751] = {.lex_state = 0, .external_lex_state = 2},
  [2752] = {.lex_state = 0, .external_lex_state = 2},
  [2753] = {.lex_state = 0, .external_lex_state = 2},
  [2754] = {.lex_state = 0, .external_lex_state = 2},
  [2755] = {.lex_state = 101, .external_lex_state = 2},
  [2756] = {.lex_state = 101, .external_lex_state = 2},
  [2757] = {.lex_state = 0, .external_lex_state = 2},
  [2758] = {.lex_state = 0, .external_lex_state = 2},
  [2759] = {.lex_state = 0, .external_lex_state = 2},
  [2760] = {.lex_state = 0, .external_lex_state = 2},
  [2761] = {.lex_state = 100, .external_lex_state = 2},
  [2762] = {.lex_state = 0, .external_lex_state = 2},
  [2763] = {.lex_state = 0, .external_lex_state = 2},
  [2764] = {.lex_state = 0, .external_lex_state = 2},
  [2765] = {.lex_state = 0, .external_lex_state = 2},
  [2766] = {.lex_state = 0, .external_lex_state = 2},
  [2767] = {.lex_state = 101, .external_lex_state = 2},
  [2768] = {.lex_state = 0, .external_lex_state = 2},
  [2769] = {.lex_state = 0, .external_lex_state = 2},
  [2770] = {.lex_state = 0, .external_lex_state = 2},
  [2771] = {.lex_state = 0, .external_lex_state = 2},
  [2772] = {.lex_state = 0, .external_lex_state = 2},
  [2773] = {.lex_state = 0, .external_lex_state = 2},
  [2774] = {.lex_state = 0, .external_lex_state = 2},
  [2775] = {.lex_state = 0, .external_lex_state = 2},
  [2776] = {.lex_state = 0, .external_lex_state = 2},
  [2777] = {.lex_state = 0, .external_lex_state = 2},
  [2778] = {.lex_state = 100, .external_lex_state = 2},
  [2779] = {.lex_state = 101, .external_lex_state = 2},
  [2780] = {.lex_state = 0, .external_lex_state = 2},
  [2781] = {.lex_state = 0, .external_lex_state = 2},
  [2782] = {.lex_state = 0, .external_lex_state = 2},
  [2783] = {.lex_state = 101, .external_lex_state = 2},
  [2784] = {.lex_state = 0, .external_lex_state = 2},
  [2785] = {.lex_state = 0, .external_lex_state = 2},
  [2786] = {.lex_state = 0, .external_lex_state = 2},
  [2787] = {.lex_state = 0, .external_lex_state = 2},
  [2788] = {.lex_state = 0, .external_lex_state = 2},
  [2789] = {.lex_state = 101, .external_lex_state = 2},
  [2790] = {.lex_state = 0, .external_lex_state = 2},
  [2791] = {.lex_state = 0, .external_lex_state = 2},
  [2792] = {.lex_state = 0, .external_lex_state = 2},
  [2793] = {.lex_state = 0, .external_lex_state = 2},
  [2794] = {.lex_state = 0, .external_lex_state = 2},
  [2795] = {.lex_state = 0, .external_lex_state = 2},
  [2796] = {.lex_state = 0, .external_lex_state = 2},
  [2797] = {.lex_state = 0, .external_lex_state = 2},
  [2798] = {.lex_state = 0, .external_lex_state = 2},
  [2799] = {.lex_state = 101, .external_lex_state = 2},
  [2800] = {.lex_state = 0, .external_lex_state = 2},
  [2801] = {.lex_state = 0, .external_lex_state = 2},
  [2802] = {.lex_state = 0, .external_lex_state = 2},
  [2803] = {.lex_state = 0, .external_lex_state = 2},
  [2804] = {.lex_state = 0, .external_lex_state = 2},
  [2805] = {.lex_state = 0, .external_lex_state = 2},
  [2806] = {.lex_state = 0, .external_lex_state = 2},
  [2807] = {.lex_state = 0, .external_lex_state = 2},
  [2808] = {.lex_state = 0, .external_lex_state = 2},
  [2809] = {.lex_state = 0, .external_lex_state = 2},
  [2810] = {.lex_state = 0, .external_lex_state = 2},
  [2811] = {.lex_state = 0, .external_lex_state = 2},
  [2812] = {.lex_state = 0, .external_lex_state = 2},
  [2813] = {.lex_state = 100, .external_lex_state = 2},
  [2814] = {.lex_state = 54, .external_lex_state = 2},
  [2815] = {.lex_state = 0, .external_lex_state = 2},
  [2816] = {.lex_state = 0, .external_lex_state = 2},
  [2817] = {.lex_state = 0, .external_lex_state = 2},
  [2818] = {.lex_state = 0, .external_lex_state = 2},
  [2819] = {.lex_state = 0, .external_lex_state = 2},
  [2820] = {.lex_state = 0, .external_lex_state = 2},
  [2821] = {.lex_state = 0, .external_lex_state = 2},
  [2822] = {.lex_state = 101, .external_lex_state = 2},
  [2823] = {.lex_state = 100, .external_lex_state = 2},
  [2824] = {.lex_state = 0, .external_lex_state = 2},
  [2825] = {.lex_state = 0, .external_lex_state = 2},
  [2826] = {.lex_state = 100, .external_lex_state = 2},
  [2827] = {.lex_state = 0, .external_lex_state = 2},
  [2828] = {.lex_state = 0, .external_lex_state = 2},
  [2829] = {.lex_state = 0, .external_lex_state = 2},
  [2830] = {.lex_state = 0, .external_lex_state = 2},
  [2831] = {.lex_state = 100, .external_lex_state = 2},
  [2832] = {.lex_state = 0, .external_lex_state = 2},
  [2833] = {.lex_state = 100, .external_lex_state = 2},
  [2834] = {.lex_state = 101, .external_lex_state = 2},
  [2835] = {.lex_state = 0, .external_lex_state = 2},
  [2836] = {.lex_state = 101, .external_lex_state = 2},
  [2837] = {.lex_state = 0, .external_lex_state = 2},
  [2838] = {.lex_state = 0, .external_lex_state = 2},
  [2839] = {.lex_state = 0, .external_lex_state = 2},
  [2840] = {.lex_state = 101, .external_lex_state = 2},
  [2841] = {.lex_state = 101, .external_lex_state = 2},
  [2842] = {.lex_state = 100, .external_lex_state = 2},
  [2843] = {.lex_state = 0, .external_lex_state = 2},
  [2844] = {.lex_state = 0, .external_lex_state = 2},
  [2845] = {.lex_state = 101, .external_lex_state = 2},
  [2846] = {.lex_state = 0, .external_lex_state = 2},
  [2847] = {.lex_state = 0, .external_lex_state = 2},
  [2848] = {.lex_state = 0, .external_lex_state = 2},
  [2849] = {.lex_state = 100, .external_lex_state = 2},
  [2850] = {.lex_state = 0, .external_lex_state = 2},
  [2851] = {.lex_state = 100, .external_lex_state = 2},
  [2852] = {.lex_state = 0, .external_lex_state = 2},
  [2853] = {.lex_state = 0, .external_lex_state = 2},
  [2854] = {.lex_state = 0, .external_lex_state = 2},
  [2855] = {.lex_state = 0, .external_lex_state = 2},
  [2856] = {.lex_state = 0, .external_lex_state = 2},
  [2857] = {.lex_state = 0, .external_lex_state = 2},
  [2858] = {.lex_state = 0, .external_lex_state = 2},
  [2859] = {.lex_state = 100, .external_lex_state = 2},
  [2860] = {.lex_state = 0, .external_lex_state = 2},
  [2861] = {.lex_state = 0, .external_lex_state = 2},
  [2862] = {.lex_state = 0, .external_lex_state = 2},
  [2863] = {.lex_state = 0, .external_lex_state = 2},
  [2864] = {.lex_state = 54, .external_lex_state = 2},
  [2865] = {.lex_state = 0, .external_lex_state = 2},
  [2866] = {.lex_state = 0, .external_lex_state = 2},
  [2867] = {.lex_state = 0, .external_lex_state = 2},
  [2868] = {.lex_state = 101, .external_lex_state = 2},
  [2869] = {.lex_state = 0, .external_lex_state = 2},
  [2870] = {.lex_state = 0, .external_lex_state = 2},
  [2871] = {.lex_state = 0, .external_lex_state = 2},
  [2872] = {.lex_state = 0, .external_lex_state = 2},
  [2873] = {.lex_state = 0, .external_lex_state = 2},
  [2874] = {.lex_state = 0, .external_lex_state = 2},
  [2875] = {.lex_state = 0, .external_lex_state = 2},
  [2876] = {.lex_state = 54, .external_lex_state = 2},
  [2877] = {.lex_state = 0, .external_lex_state = 2},
  [2878] = {.lex_state = 0, .external_lex_state = 2},
  [2879] = {.lex_state = 0, .external_lex_state = 2},
  [2880] = {.lex_state = 0, .external_lex_state = 2},
  [2881] = {.lex_state = 0, .external_lex_state = 2},
  [2882] = {.lex_state = 0, .external_lex_state = 2},
  [2883] = {.lex_state = 0, .external_lex_state = 2},
  [2884] = {.lex_state = 101, .external_lex_state = 2},
  [2885] = {.lex_state = 100, .external_lex_state = 2},
  [2886] = {.lex_state = 0, .external_lex_state = 2},
  [2887] = {.lex_state = 0, .external_lex_state = 2},
  [2888] = {.lex_state = 0, .external_lex_state = 2},
  [2889] = {.lex_state = 0, .external_lex_state = 2},
  [2890] = {.lex_state = 0, .external_lex_state = 2},
  [2891] = {.lex_state = 0, .external_lex_state = 2},
  [2892] = {.lex_state = 0, .external_lex_state = 2},
  [2893] = {.lex_state = 0, .external_lex_state = 2},
  [2894] = {.lex_state = 0, .external_lex_state = 2},
  [2895] = {.lex_state = 101, .external_lex_state = 2},
  [2896] = {.lex_state = 0, .external_lex_state = 2},
  [2897] = {.lex_state = 0, .external_lex_state = 2},
  [2898] = {.lex_state = 101, .external_lex_state = 2},
  [2899] = {.lex_state = 0, .external_lex_state = 2},
  [2900] = {.lex_state = 0, .external_lex_state = 2},
  [2901] = {.lex_state = 0, .external_lex_state = 2},
  [2902] = {.lex_state = 0, .external_lex_state = 2},
  [2903] = {.lex_state = 0, .external_lex_state = 2},
  [2904] = {.lex_state = 0, .external_lex_state = 2},
  [2905] = {.lex_state = 0, .external_lex_state = 2},
  [2906] = {.lex_state = 101, .external_lex_state = 2},
  [2907] = {.lex_state = 0, .external_lex_state = 2},
  [2908] = {.lex_state = 101, .external_lex_state = 2},
  [2909] = {.lex_state = 0, .external_lex_state = 2},
  [2910] = {.lex_state = 101, .external_lex_state = 2},
  [2911] = {.lex_state = 0, .external_lex_state = 2},
  [2912] = {.lex_state = 0, .external_lex_state = 2},
  [2913] = {.lex_state = 0, .external_lex_state = 2},
  [2914] = {.lex_state = 101, .external_lex_state = 2},
  [2915] = {.lex_state = 0, .external_lex_state = 2},
  [2916] = {.lex_state = 0, .external_lex_state = 2},
  [2917] = {.lex_state = 0, .external_lex_state = 2},
  [2918] = {.lex_state = 101, .external_lex_state = 2},
  [2919] = {.lex_state = 0, .external_lex_state = 2},
  [2920] = {.lex_state = 100, .external_lex_state = 2},
  [2921] = {.lex_state = 101, .external_lex_state = 2},
  [2922] = {.lex_state = 0, .external_lex_state = 2},
  [2923] = {.lex_state = 100, .external_lex_state = 2},
  [2924] = {.lex_state = 0, .external_lex_state = 2},
  [2925] = {.lex_state = 0, .external_lex_state = 2},
  [2926] = {.lex_state = 0, .external_lex_state = 2},
  [2927] = {.lex_state = 0, .external_lex_state = 2},
  [2928] = {.lex_state = 0, .external_lex_state = 2},
  [2929] = {.lex_state = 0, .external_lex_state = 2},
  [2930] = {.lex_state = 0, .external_lex_state = 2},
  [2931] = {.lex_state = 0, .external_lex_state = 2},
  [2932] = {.lex_state = 0, .external_lex_state = 2},
  [2933] = {.lex_state = 0, .external_lex_state = 2},
  [2934] = {.lex_state = 101, .external_lex_state = 2},
  [2935] = {.lex_state = 101, .external_lex_state = 2},
  [2936] = {.lex_state = 0, .external_lex_state = 2},
  [2937] = {.lex_state = 0, .external_lex_state = 2},
  [2938] = {.lex_state = 0, .external_lex_state = 2},
  [2939] = {.lex_state = 0, .external_lex_state = 2},
  [2940] = {.lex_state = 101, .external_lex_state = 2},
  [2941] = {.lex_state = 100, .external_lex_state = 2},
  [2942] = {.lex_state = 0, .external_lex_state = 2},
  [2943] = {.lex_state = 101, .external_lex_state = 2},
  [2944] = {.lex_state = 101, .external_lex_state = 2},
  [2945] = {.lex_state = 0, .external_lex_state = 2},
  [2946] = {.lex_state = 0, .external_lex_state = 2},
  [2947] = {.lex_state = 100, .external_lex_state = 2},
  [2948] = {.lex_state = 0, .external_lex_state = 2},
  [2949] = {.lex_state = 100, .external_lex_state = 2},
  [2950] = {.lex_state = 0, .external_lex_state = 2},
  [2951] = {.lex_state = 0, .external_lex_state = 2},
  [2952] = {.lex_state = 0, .external_lex_state = 2},
  [2953] = {.lex_state = 0, .external_lex_state = 2},
  [2954] = {.lex_state = 0, .external_lex_state = 2},
  [2955] = {.lex_state = 0, .external_lex_state = 2},
  [2956] = {.lex_state = 0, .external_lex_state = 2},
  [2957] = {.lex_state = 101, .external_lex_state = 2},
  [2958] = {.lex_state = 100, .external_lex_state = 2},
  [2959] = {.lex_state = 0, .external_lex_state = 2},
  [2960] = {.lex_state = 100, .external_lex_state = 2},
  [2961] = {.lex_state = 0, .external_lex_state = 2},
  [2962] = {.lex_state = 101, .external_lex_state = 2},
  [2963] = {.lex_state = 0, .external_lex_state = 2},
  [2964] = {.lex_state = 0, .external_lex_state = 2},
  [2965] = {.lex_state = 101, .external_lex_state = 2},
  [2966] = {.lex_state = 100, .external_lex_state = 2},
  [2967] = {.lex_state = 0, .external_lex_state = 2},
  [2968] = {.lex_state = 101, .external_lex_state = 2},
  [2969] = {.lex_state = 0, .external_lex_state = 2},
  [2970] = {.lex_state = 101, .external_lex_state = 2},
  [2971] = {.lex_state = 101, .external_lex_state = 2},
  [2972] = {.lex_state = 0, .external_lex_state = 2},
  [2973] = {.lex_state = 0, .external_lex_state = 2},
  [2974] = {.lex_state = 0, .external_lex_state = 2},
  [2975] = {.lex_state = 100, .external_lex_state = 2},
  [2976] = {.lex_state = 0, .external_lex_state = 2},
  [2977] = {.lex_state = 0, .external_lex_state = 2},
  [2978] = {.lex_state = 0, .external_lex_state = 2},
  [2979] = {.lex_state = 0, .external_lex_state = 2},
  [2980] = {.lex_state = 0, .external_lex_state = 2},
  [2981] = {.lex_state = 101, .external_lex_state = 2},
  [2982] = {.lex_state = 100, .external_lex_state = 2},
  [2983] = {.lex_state = 0, .external_lex_state = 2},
  [2984] = {.lex_state = 101, .external_lex_state = 2},
  [2985] = {.lex_state = 0, .external_lex_state = 2},
  [2986] = {.lex_state = 0, .external_lex_state = 2},
  [2987] = {.lex_state = 101, .external_lex_state = 2},
  [2988] = {.lex_state = 54, .external_lex_state = 2},
  [2989] = {.lex_state = 100, .external_lex_state = 2},
  [2990] = {.lex_state = 101, .external_lex_state = 2},
  [2991] = {.lex_state = 0, .external_lex_state = 2},
  [2992] = {.lex_state = 0, .external_lex_state = 2},
  [2993] = {.lex_state = 100, .external_lex_state = 2},
  [2994] = {.lex_state = 100, .external_lex_state = 2},
  [2995] = {.lex_state = 0, .external_lex_state = 2},
  [2996] = {.lex_state = 101, .external_lex_state = 2},
  [2997] = {.lex_state = 0, .external_lex_state = 2},
  [2998] = {.lex_state = 0, .external_lex_state = 2},
  [2999] = {.lex_state = 101, .external_lex_state = 2},
  [3000] = {.lex_state = 0, .external_lex_state = 2},
  [3001] = {.lex_state = 101, .external_lex_state = 2},
  [3002] = {.lex_state = 0, .external_lex_state = 2},
  [3003] = {.lex_state = 0, .external_lex_state = 2},
  [3004] = {.lex_state = 0, .external_lex_state = 2},
  [3005] = {.lex_state = 0, .external_lex_state = 2},
  [3006] = {.lex_state = 100, .external_lex_state = 2},
  [3007] = {.lex_state = 101, .external_lex_state = 2},
  [3008] = {.lex_state = 100, .external_lex_state = 2},
  [3009] = {.lex_state = 0, .external_lex_state = 2},
  [3010] = {.lex_state = 0, .external_lex_state = 2},
  [3011] = {.lex_state = 0, .external_lex_state = 2},
  [3012] = {.lex_state = 0, .external_lex_state = 2},
  [3013] = {.lex_state = 0, .external_lex_state = 2},
  [3014] = {.lex_state = 0, .external_lex_state = 2},
  [3015] = {.lex_state = 0, .external_lex_state = 2},
  [3016] = {.lex_state = 0, .external_lex_state = 2},
  [3017] = {.lex_state = 0, .external_lex_state = 2},
  [3018] = {.lex_state = 100, .external_lex_state = 2},
  [3019] = {.lex_state = 101, .external_lex_state = 2},
  [3020] = {.lex_state = 0, .external_lex_state = 2},
  [3021] = {.lex_state = 102, .external_lex_state = 2},
  [3022] = {.lex_state = 0, .external_lex_state = 2},
  [3023] = {.lex_state = 0, .external_lex_state = 2},
  [3024] = {.lex_state = 0, .external_lex_state = 2},
  [3025] = {.lex_state = 0, .external_lex_state = 2},
  [3026] = {.lex_state = 101, .external_lex_state = 2},
  [3027] = {.lex_state = 0, .external_lex_state = 2},
  [3028] = {.lex_state = 100, .external_lex_state = 2},
  [3029] = {.lex_state = 0, .external_lex_state = 2},
  [3030] = {.lex_state = 0, .external_lex_state = 2},
  [3031] = {.lex_state = 0, .external_lex_state = 2},
  [3032] = {.lex_state = 101, .external_lex_state = 2},
  [3033] = {.lex_state = 0, .external_lex_state = 2},
  [3034] = {.lex_state = 0, .external_lex_state = 2},
  [3035] = {.lex_state = 100, .external_lex_state = 2},
  [3036] = {.lex_state = 100, .external_lex_state = 2},
  [3037] = {.lex_state = 0, .external_lex_state = 2},
  [3038] = {.lex_state = 0, .external_lex_state = 2},
  [3039] = {.lex_state = 101, .external_lex_state = 2},
  [3040] = {.lex_state = 0, .external_lex_state = 2},
  [3041] = {.lex_state = 0, .external_lex_state = 2},
  [3042] = {.lex_state = 0, .external_lex_state = 2},
  [3043] = {.lex_state = 101, .external_lex_state = 2},
  [3044] = {.lex_state = 101, .external_lex_state = 2},
  [3045] = {.lex_state = 101, .external_lex_state = 2},
  [3046] = {.lex_state = 0, .external_lex_state = 2},
  [3047] = {.lex_state = 0, .external_lex_state = 2},
  [3048] = {.lex_state = 0, .external_lex_state = 2},
  [3049] = {.lex_state = 0, .external_lex_state = 2},
  [3050] = {.lex_state = 0, .external_lex_state = 2},
  [3051] = {.lex_state = 0, .external_lex_state = 2},
  [3052] = {.lex_state = 0, .external_lex_state = 2},
  [3053] = {.lex_state = 101, .external_lex_state = 2},
  [3054] = {.lex_state = 0, .external_lex_state = 2},
  [3055] = {.lex_state = 0, .external_lex_state = 2},
  [3056] = {.lex_state = 0, .external_lex_state = 2},
  [3057] = {.lex_state = 0, .external_lex_state = 2},
  [3058] = {.lex_state = 101, .external_lex_state = 2},
  [3059] = {.lex_state = 0, .external_lex_state = 2},
  [3060] = {.lex_state = 0, .external_lex_state = 2},
  [3061] = {.lex_state = 0, .external_lex_state = 2},
  [3062] = {.lex_state = 0, .external_lex_state = 2},
  [3063] = {.lex_state = 0, .external_lex_state = 2},
  [3064] = {.lex_state = 0, .external_lex_state = 2},
  [3065] = {.lex_state = 0, .external_lex_state = 2},
  [3066] = {.lex_state = 0, .external_lex_state = 2},
  [3067] = {.lex_state = 0, .external_lex_state = 2},
  [3068] = {.lex_state = 100, .external_lex_state = 2},
  [3069] = {.lex_state = 0, .external_lex_state = 2},
  [3070] = {.lex_state = 0, .external_lex_state = 2},
  [3071] = {.lex_state = 0, .external_lex_state = 2},
  [3072] = {.lex_state = 101, .external_lex_state = 2},
  [3073] = {.lex_state = 0, .external_lex_state = 2},
  [3074] = {.lex_state = 0, .external_lex_state = 2},
  [3075] = {.lex_state = 0, .external_lex_state = 2},
  [3076] = {.lex_state = 101, .external_lex_state = 2},
  [3077] = {.lex_state = 0, .external_lex_state = 2},
  [3078] = {.lex_state = 0, .external_lex_state = 2},
  [3079] = {.lex_state = 0, .external_lex_state = 2},
  [3080] = {.lex_state = 0, .external_lex_state = 2},
  [3081] = {.lex_state = 0, .external_lex_state = 2},
  [3082] = {.lex_state = 101, .external_lex_state = 2},
  [3083] = {.lex_state = 0, .external_lex_state = 2},
  [3084] = {.lex_state = 0, .external_lex_state = 2},
  [3085] = {.lex_state = 0, .external_lex_state = 2},
  [3086] = {.lex_state = 0, .external_lex_state = 2},
  [3087] = {.lex_state = 0, .external_lex_state = 2},
  [3088] = {.lex_state = 0, .external_lex_state = 2},
  [3089] = {.lex_state = 0, .external_lex_state = 2},
  [3090] = {.lex_state = 0, .external_lex_state = 2},
  [3091] = {.lex_state = 0, .external_lex_state = 2},
  [3092] = {.lex_state = 0, .external_lex_state = 2},
  [3093] = {.lex_state = 17, .external_lex_state = 2},
  [3094] = {.lex_state = 0, .external_lex_state = 2},
  [3095] = {.lex_state = 0, .external_lex_state = 2},
  [3096] = {.lex_state = 101, .external_lex_state = 2},
  [3097] = {.lex_state = 0, .external_lex_state = 2},
  [3098] = {.lex_state = 0, .external_lex_state = 2},
  [3099] = {.lex_state = 0, .external_lex_state = 2},
  [3100] = {.lex_state = 0, .external_lex_state = 2},
  [3101] = {.lex_state = 0, .external_lex_state = 2},
  [3102] = {.lex_state = 0, .external_lex_state = 2},
  [3103] = {.lex_state = 101, .external_lex_state = 2},
  [3104] = {.lex_state = 0, .external_lex_state = 2},
  [3105] = {.lex_state = 0, .external_lex_state = 2},
  [3106] = {.lex_state = 0, .external_lex_state = 2},
  [3107] = {.lex_state = 0, .external_lex_state = 2},
  [3108] = {.lex_state = 0, .external_lex_state = 2},
  [3109] = {.lex_state = 0, .external_lex_state = 2},
  [3110] = {.lex_state = 0, .external_lex_state = 2},
  [3111] = {.lex_state = 0, .external_lex_state = 2},
  [3112] = {.lex_state = 0, .external_lex_state = 2},
  [3113] = {.lex_state = 0, .external_lex_state = 2},
  [3114] = {.lex_state = 0, .external_lex_state = 2},
  [3115] = {.lex_state = 0, .external_lex_state = 2},
  [3116] = {.lex_state = 101, .external_lex_state = 2},
  [3117] = {.lex_state = 0, .external_lex_state = 2},
  [3118] = {.lex_state = 0, .external_lex_state = 2},
  [3119] = {.lex_state = 0, .external_lex_state = 2},
  [3120] = {.lex_state = 0, .external_lex_state = 2},
  [3121] = {.lex_state = 101, .external_lex_state = 2},
  [3122] = {.lex_state = 0, .external_lex_state = 2},
  [3123] = {.lex_state = 0, .external_lex_state = 2},
  [3124] = {.lex_state = 0, .external_lex_state = 2},
  [3125] = {.lex_state = 101, .external_lex_state = 2},
  [3126] = {.lex_state = 0, .external_lex_state = 2},
  [3127] = {.lex_state = 0, .external_lex_state = 2},
  [3128] = {.lex_state = 0, .external_lex_state = 2},
  [3129] = {.lex_state = 0, .external_lex_state = 2},
  [3130] = {.lex_state = 0, .external_lex_state = 2},
  [3131] = {.lex_state = 100, .external_lex_state = 2},
  [3132] = {.lex_state = 101, .external_lex_state = 2},
  [3133] = {.lex_state = 0, .external_lex_state = 2},
  [3134] = {.lex_state = 0, .external_lex_state = 2},
  [3135] = {.lex_state = 0, .external_lex_state = 2},
  [3136] = {.lex_state = 101, .external_lex_state = 2},
  [3137] = {.lex_state = 100, .external_lex_state = 2},
  [3138] = {.lex_state = 0, .external_lex_state = 2},
  [3139] = {.lex_state = 0, .external_lex_state = 2},
  [3140] = {.lex_state = 0, .external_lex_state = 2},
  [3141] = {.lex_state = 0, .external_lex_state = 2},
  [3142] = {.lex_state = 0, .external_lex_state = 2},
  [3143] = {.lex_state = 101, .external_lex_state = 2},
  [3144] = {.lex_state = 0, .external_lex_state = 2},
  [3145] = {.lex_state = 0, .external_lex_state = 2},
  [3146] = {.lex_state = 0, .external_lex_state = 2},
  [3147] = {.lex_state = 0, .external_lex_state = 2},
  [3148] = {.lex_state = 0, .external_lex_state = 2},
  [3149] = {.lex_state = 0, .external_lex_state = 2},
  [3150] = {.lex_state = 0, .external_lex_state = 2},
  [3151] = {.lex_state = 0, .external_lex_state = 2},
  [3152] = {.lex_state = 0, .external_lex_state = 2},
  [3153] = {.lex_state = 0, .external_lex_state = 2},
  [3154] = {.lex_state = 100, .external_lex_state = 2},
  [3155] = {.lex_state = 0, .external_lex_state = 2},
  [3156] = {.lex_state = 0, .external_lex_state = 2},
  [3157] = {.lex_state = 0, .external_lex_state = 2},
  [3158] = {.lex_state = 0, .external_lex_state = 2},
  [3159] = {.lex_state = 0, .external_lex_state = 2},
  [3160] = {.lex_state = 0, .external_lex_state = 2},
  [3161] = {.lex_state = 0, .external_lex_state = 2},
  [3162] = {.lex_state = 0, .external_lex_state = 2},
  [3163] = {.lex_state = 0, .external_lex_state = 2},
  [3164] = {.lex_state = 0, .external_lex_state = 2},
  [3165] = {.lex_state = 0, .external_lex_state = 2},
  [3166] = {.lex_state = 0, .external_lex_state = 2},
  [3167] = {.lex_state = 0, .external_lex_state = 2},
  [3168] = {.lex_state = 0, .external_lex_state = 2},
  [3169] = {.lex_state = 0, .external_lex_state = 2},
  [3170] = {.lex_state = 101, .external_lex_state = 2},
  [3171] = {.lex_state = 0, .external_lex_state = 2},
  [3172] = {.lex_state = 0, .external_lex_state = 2},
  [3173] = {.lex_state = 101, .external_lex_state = 2},
  [3174] = {.lex_state = 0, .external_lex_state = 2},
  [3175] = {.lex_state = 0, .external_lex_state = 2},
  [3176] = {.lex_state = 0, .external_lex_state = 2},
  [3177] = {.lex_state = 0, .external_lex_state = 2},
  [3178] = {.lex_state = 0, .external_lex_state = 2},
  [3179] = {.lex_state = 0, .external_lex_state = 2},
  [3180] = {.lex_state = 0, .external_lex_state = 2},
  [3181] = {.lex_state = 0, .external_lex_state = 2},
  [3182] = {.lex_state = 101, .external_lex_state = 2},
  [3183] = {.lex_state = 0, .external_lex_state = 2},
  [3184] = {.lex_state = 0, .external_lex_state = 2},
  [3185] = {.lex_state = 0, .external_lex_state = 2},
  [3186] = {.lex_state = 0, .external_lex_state = 2},
  [3187] = {.lex_state = 0, .external_lex_state = 2},
  [3188] = {.lex_state = 0, .external_lex_state = 2},
  [3189] = {.lex_state = 100, .external_lex_state = 2},
  [3190] = {.lex_state = 0, .external_lex_state = 2},
  [3191] = {.lex_state = 0, .external_lex_state = 2},
  [3192] = {.lex_state = 0, .external_lex_state = 2},
  [3193] = {.lex_state = 0, .external_lex_state = 2},
  [3194] = {.lex_state = 0, .external_lex_state = 2},
  [3195] = {.lex_state = 101, .external_lex_state = 2},
  [3196] = {.lex_state = 0, .external_lex_state = 2},
  [3197] = {.lex_state = 0, .external_lex_state = 2},
  [3198] = {.lex_state = 100, .external_lex_state = 2},
  [3199] = {.lex_state = 0, .external_lex_state = 2},
  [3200] = {.lex_state = 0, .external_lex_state = 2},
  [3201] = {.lex_state = 0, .external_lex_state = 2},
  [3202] = {.lex_state = 0, .external_lex_state = 2},
  [3203] = {.lex_state = 0, .external_lex_state = 2},
  [3204] = {.lex_state = 101, .external_lex_state = 2},
  [3205] = {.lex_state = 0, .external_lex_state = 2},
  [3206] = {.lex_state = 0, .external_lex_state = 2},
  [3207] = {.lex_state = 101, .external_lex_state = 2},
  [3208] = {.lex_state = 0, .external_lex_state = 2},
  [3209] = {.lex_state = 0, .external_lex_state = 2},
  [3210] = {.lex_state = 0, .external_lex_state = 2},
  [3211] = {.lex_state = 100, .external_lex_state = 2},
  [3212] = {.lex_state = 0, .external_lex_state = 2},
  [3213] = {.lex_state = 0, .external_lex_state = 2},
  [3214] = {.lex_state = 0, .external_lex_state = 2},
  [3215] = {.lex_state = 0, .external_lex_state = 2},
  [3216] = {.lex_state = 0, .external_lex_state = 2},
  [3217] = {.lex_state = 0, .external_lex_state = 2},
  [3218] = {.lex_state = 0, .external_lex_state = 2},
  [3219] = {.lex_state = 101, .external_lex_state = 2},
  [3220] = {.lex_state = 0, .external_lex_state = 2},
  [3221] = {.lex_state = 101, .external_lex_state = 2},
  [3222] = {.lex_state = 0, .external_lex_state = 2},
  [3223] = {.lex_state = 0, .external_lex_state = 2},
  [3224] = {.lex_state = 101, .external_lex_state = 2},
  [3225] = {.lex_state = 0, .external_lex_state = 2},
  [3226] = {.lex_state = 0, .external_lex_state = 2},
  [3227] = {.lex_state = 101, .external_lex_state = 2},
  [3228] = {.lex_state = 0, .external_lex_state = 2},
  [3229] = {.lex_state = 101, .external_lex_state = 2},
  [3230] = {.lex_state = 0, .external_lex_state = 2},
  [3231] = {.lex_state = 0, .external_lex_state = 2},
  [3232] = {.lex_state = 101, .external_lex_state = 2},
  [3233] = {.lex_state = 101, .external_lex_state = 2},
  [3234] = {.lex_state = 0, .external_lex_state = 2},
  [3235] = {.lex_state = 0, .external_lex_state = 2},
  [3236] = {.lex_state = 0, .external_lex_state = 2},
  [3237] = {.lex_state = 0, .external_lex_state = 2},
  [3238] = {.lex_state = 0, .external_lex_state = 2},
  [3239] = {.lex_state = 101, .external_lex_state = 2},
  [3240] = {.lex_state = 0, .external_lex_state = 2},
  [3241] = {.lex_state = 0, .external_lex_state = 2},
  [3242] = {.lex_state = 0, .external_lex_state = 2},
  [3243] = {.lex_state = 0, .external_lex_state = 2},
  [3244] = {.lex_state = 0, .external_lex_state = 2},
  [3245] = {.lex_state = 0, .external_lex_state = 2},
  [3246] = {.lex_state = 0, .external_lex_state = 2},
  [3247] = {.lex_state = 0, .external_lex_state = 2},
  [3248] = {.lex_state = 101, .external_lex_state = 2},
  [3249] = {.lex_state = 0, .external_lex_state = 2},
  [3250] = {.lex_state = 101, .external_lex_state = 2},
  [3251] = {.lex_state = 0, .external_lex_state = 2},
  [3252] = {.lex_state = 100, .external_lex_state = 2},
  [3253] = {.lex_state = 0, .external_lex_state = 2},
  [3254] = {.lex_state = 0, .external_lex_state = 2},
  [3255] = {.lex_state = 0, .external_lex_state = 2},
  [3256] = {.lex_state = 0, .external_lex_state = 2},
  [3257] = {.lex_state = 0, .external_lex_state = 2},
  [3258] = {.lex_state = 0, .external_lex_state = 2},
  [3259] = {.lex_state = 0, .external_lex_state = 2},
  [3260] = {.lex_state = 0, .external_lex_state = 2},
  [3261] = {.lex_state = 101, .external_lex_state = 2},
  [3262] = {.lex_state = 0, .external_lex_state = 2},
  [3263] = {.lex_state = 100, .external_lex_state = 2},
  [3264] = {.lex_state = 0, .external_lex_state = 2},
  [3265] = {.lex_state = 0, .external_lex_state = 2},
  [3266] = {.lex_state = 0, .external_lex_state = 2},
  [3267] = {.lex_state = 100, .external_lex_state = 2},
  [3268] = {.lex_state = 0, .external_lex_state = 2},
  [3269] = {.lex_state = 0, .external_lex_state = 2},
  [3270] = {.lex_state = 100, .external_lex_state = 2},
  [3271] = {.lex_state = 0, .external_lex_state = 2},
  [3272] = {.lex_state = 100, .external_lex_state = 2},
  [3273] = {.lex_state = 101, .external_lex_state = 2},
  [3274] = {.lex_state = 101, .external_lex_state = 2},
  [3275] = {.lex_state = 101, .external_lex_state = 2},
  [3276] = {.lex_state = 100, .external_lex_state = 2},
  [3277] = {.lex_state = 0, .external_lex_state = 2},
  [3278] = {.lex_state = 0, .external_lex_state = 2},
  [3279] = {.lex_state = 101, .external_lex_state = 2},
  [3280] = {.lex_state = 0, .external_lex_state = 2},
  [3281] = {.lex_state = 0, .external_lex_state = 2},
  [3282] = {.lex_state = 100, .external_lex_state = 2},
  [3283] = {.lex_state = 100, .external_lex_state = 2},
  [3284] = {.lex_state = 101, .external_lex_state = 2},
  [3285] = {.lex_state = 0, .external_lex_state = 2},
  [3286] = {.lex_state = 0, .external_lex_state = 2},
  [3287] = {.lex_state = 100, .external_lex_state = 2},
  [3288] = {.lex_state = 100, .external_lex_state = 2},
  [3289] = {.lex_state = 0, .external_lex_state = 2},
  [3290] = {.lex_state = 0, .external_lex_state = 2},
  [3291] = {.lex_state = 0, .external_lex_state = 2},
  [3292] = {.lex_state = 0, .external_lex_state = 2},
  [3293] = {.lex_state = 0, .external_lex_state = 2},
  [3294] = {.lex_state = 101, .external_lex_state = 2},
  [3295] = {.lex_state = 0, .external_lex_state = 2},
  [3296] = {.lex_state = 101, .external_lex_state = 2},
  [3297] = {.lex_state = 0, .external_lex_state = 2},
  [3298] = {.lex_state = 101, .external_lex_state = 2},
  [3299] = {.lex_state = 0, .external_lex_state = 2},
  [3300] = {.lex_state = 101, .external_lex_state = 2},
  [3301] = {.lex_state = 0, .external_lex_state = 2},
  [3302] = {.lex_state = 0, .external_lex_state = 2},
  [3303] = {.lex_state = 101, .external_lex_state = 2},
  [3304] = {.lex_state = 101, .external_lex_state = 2},
  [3305] = {.lex_state = 101, .external_lex_state = 2},
  [3306] = {.lex_state = 0, .external_lex_state = 2},
  [3307] = {.lex_state = 0, .external_lex_state = 2},
  [3308] = {.lex_state = 101, .external_lex_state = 2},
  [3309] = {.lex_state = 0, .external_lex_state = 2},
  [3310] = {.lex_state = 101, .external_lex_state = 2},
  [3311] = {.lex_state = 0, .external_lex_state = 2},
  [3312] = {.lex_state = 101, .external_lex_state = 2},
  [3313] = {.lex_state = 0, .external_lex_state = 2},
  [3314] = {.lex_state = 0, .external_lex_state = 2},
  [3315] = {.lex_state = 0, .external_lex_state = 2},
  [3316] = {.lex_state = 0, .external_lex_state = 2},
  [3317] = {.lex_state = 0, .external_lex_state = 2},
  [3318] = {.lex_state = 0, .external_lex_state = 2},
  [3319] = {.lex_state = 100, .external_lex_state = 2},
  [3320] = {.lex_state = 0, .external_lex_state = 2},
  [3321] = {.lex_state = 0, .external_lex_state = 2},
  [3322] = {.lex_state = 0, .external_lex_state = 2},
  [3323] = {.lex_state = 0, .external_lex_state = 2},
  [3324] = {.lex_state = 101, .external_lex_state = 2},
  [3325] = {.lex_state = 0, .external_lex_state = 2},
  [3326] = {.lex_state = 101, .external_lex_state = 2},
  [3327] = {.lex_state = 0, .external_lex_state = 2},
  [3328] = {.lex_state = 0, .external_lex_state = 2},
  [3329] = {.lex_state = 0, .external_lex_state = 2},
  [3330] = {.lex_state = 0, .external_lex_state = 2},
  [3331] = {.lex_state = 0, .external_lex_state = 2},
  [3332] = {.lex_state = 101, .external_lex_state = 2},
  [3333] = {.lex_state = 101, .external_lex_state = 2},
  [3334] = {.lex_state = 0, .external_lex_state = 2},
  [3335] = {.lex_state = 101, .external_lex_state = 2},
  [3336] = {.lex_state = 0, .external_lex_state = 2},
  [3337] = {.lex_state = 0, .external_lex_state = 2},
  [3338] = {.lex_state = 101, .external_lex_state = 2},
  [3339] = {.lex_state = 0, .external_lex_state = 2},
  [3340] = {.lex_state = 100, .external_lex_state = 2},
  [3341] = {.lex_state = 0, .external_lex_state = 2},
  [3342] = {.lex_state = 0, .external_lex_state = 2},
  [3343] = {.lex_state = 101, .external_lex_state = 2},
  [3344] = {.lex_state = 101, .external_lex_state = 2},
  [3345] = {.lex_state = 0, .external_lex_state = 2},
  [3346] = {.lex_state = 0, .external_lex_state = 2},
  [3347] = {.lex_state = 0, .external_lex_state = 2},
  [3348] = {.lex_state = 0, .external_lex_state = 2},
  [3349] = {.lex_state = 0, .external_lex_state = 2},
  [3350] = {.lex_state = 0, .external_lex_state = 2},
  [3351] = {.lex_state = 0, .external_lex_state = 2},
  [3352] = {.lex_state = 0, .external_lex_state = 2},
  [3353] = {.lex_state = 0, .external_lex_state = 2},
  [3354] = {.lex_state = 0, .external_lex_state = 2},
  [3355] = {.lex_state = 0, .external_lex_state = 2},
  [3356] = {.lex_state = 0, .external_lex_state = 2},
  [3357] = {.lex_state = 0, .external_lex_state = 2},
  [3358] = {.lex_state = 0, .external_lex_state = 2},
  [3359] = {.lex_state = 0, .external_lex_state = 2},
  [3360] = {.lex_state = 0, .external_lex_state = 2},
  [3361] = {.lex_state = 101, .external_lex_state = 2},
  [3362] = {.lex_state = 0, .external_lex_state = 2},
  [3363] = {.lex_state = 0, .external_lex_state = 2},
  [3364] = {.lex_state = 0, .external_lex_state = 2},
  [3365] = {.lex_state = 0, .external_lex_state = 2},
  [3366] = {.lex_state = 101, .external_lex_state = 2},
  [3367] = {.lex_state = 101, .external_lex_state = 2},
  [3368] = {.lex_state = 0, .external_lex_state = 2},
  [3369] = {.lex_state = 101, .external_lex_state = 2},
  [3370] = {.lex_state = 0, .external_lex_state = 2},
  [3371] = {.lex_state = 0, .external_lex_state = 2},
  [3372] = {.lex_state = 101, .external_lex_state = 2},
  [3373] = {.lex_state = 101, .external_lex_state = 2},
  [3374] = {.lex_state = 101, .external_lex_state = 2},
  [3375] = {.lex_state = 0, .external_lex_state = 2},
  [3376] = {.lex_state = 101, .external_lex_state = 2},
  [3377] = {.lex_state = 0, .external_lex_state = 2},
  [3378] = {.lex_state = 101, .external_lex_state = 2},
  [3379] = {.lex_state = 101, .external_lex_state = 2},
  [3380] = {.lex_state = 0, .external_lex_state = 2},
  [3381] = {.lex_state = 0, .external_lex_state = 2},
  [3382] = {.lex_state = 101, .external_lex_state = 2},
  [3383] = {.lex_state = 101, .external_lex_state = 2},
  [3384] = {.lex_state = 0, .external_lex_state = 2},
  [3385] = {.lex_state = 0, .external_lex_state = 2},
  [3386] = {.lex_state = 101, .external_lex_state = 2},
  [3387] = {.lex_state = 101, .external_lex_state = 2},
  [3388] = {.lex_state = 0, .external_lex_state = 2},
  [3389] = {.lex_state = 101, .external_lex_state = 2},
  [3390] = {.lex_state = 0, .external_lex_state = 2},
  [3391] = {.lex_state = 101, .external_lex_state = 2},
  [3392] = {.lex_state = 101, .external_lex_state = 2},
  [3393] = {.lex_state = 0, .external_lex_state = 2},
  [3394] = {.lex_state = 0, .external_lex_state = 2},
  [3395] = {.lex_state = 100, .external_lex_state = 2},
  [3396] = {.lex_state = 101, .external_lex_state = 2},
  [3397] = {.lex_state = 101, .external_lex_state = 2},
  [3398] = {.lex_state = 0, .external_lex_state = 2},
  [3399] = {.lex_state = 0, .external_lex_state = 2},
  [3400] = {.lex_state = 0, .external_lex_state = 2},
  [3401] = {.lex_state = 101, .external_lex_state = 2},
  [3402] = {.lex_state = 101, .external_lex_state = 2},
  [3403] = {.lex_state = 0, .external_lex_state = 2},
  [3404] = {.lex_state = 0, .external_lex_state = 2},
  [3405] = {.lex_state = 101, .external_lex_state = 2},
  [3406] = {.lex_state = 101, .external_lex_state = 2},
  [3407] = {.lex_state = 0, .external_lex_state = 2},
  [3408] = {.lex_state = 0, .external_lex_state = 2},
  [3409] = {.lex_state = 100, .external_lex_state = 2},
  [3410] = {.lex_state = 100, .external_lex_state = 2},
  [3411] = {.lex_state = 101, .external_lex_state = 2},
  [3412] = {.lex_state = 101, .external_lex_state = 2},
  [3413] = {.lex_state = 100, .external_lex_state = 2},
  [3414] = {.lex_state = 0, .external_lex_state = 2},
  [3415] = {.lex_state = 0, .external_lex_state = 2},
  [3416] = {.lex_state = 101, .external_lex_state = 2},
  [3417] = {.lex_state = 0, .external_lex_state = 2},
  [3418] = {.lex_state = 0, .external_lex_state = 2},
  [3419] = {.lex_state = 101, .external_lex_state = 2},
  [3420] = {.lex_state = 0, .external_lex_state = 2},
  [3421] = {.lex_state = 101, .external_lex_state = 2},
  [3422] = {.lex_state = 100, .external_lex_state = 2},
  [3423] = {.lex_state = 0, .external_lex_state = 2},
  [3424] = {.lex_state = 0, .external_lex_state = 2},
  [3425] = {.lex_state = 101, .external_lex_state = 2},
  [3426] = {.lex_state = 101, .external_lex_state = 2},
  [3427] = {.lex_state = 100, .external_lex_state = 2},
  [3428] = {.lex_state = 0, .external_lex_state = 2},
  [3429] = {.lex_state = 0, .external_lex_state = 2},
  [3430] = {.lex_state = 0, .external_lex_state = 2},
  [3431] = {.lex_state = 101, .external_lex_state = 2},
  [3432] = {.lex_state = 0, .external_lex_state = 2},
  [3433] = {.lex_state = 0, .external_lex_state = 2},
  [3434] = {.lex_state = 0, .external_lex_state = 2},
  [3435] = {.lex_state = 0, .external_lex_state = 2},
  [3436] = {.lex_state = 0, .external_lex_state = 2},
  [3437] = {.lex_state = 0, .external_lex_state = 2},
  [3438] = {.lex_state = 0, .external_lex_state = 2},
  [3439] = {.lex_state = 101, .external_lex_state = 2},
  [3440] = {.lex_state = 0, .external_lex_state = 2},
  [3441] = {.lex_state = 0, .external_lex_state = 2},
  [3442] = {.lex_state = 0, .external_lex_state = 2},
  [3443] = {.lex_state = 101, .external_lex_state = 2},
  [3444] = {.lex_state = 101, .external_lex_state = 2},
  [3445] = {.lex_state = 0, .external_lex_state = 2},
  [3446] = {.lex_state = 0, .external_lex_state = 2},
  [3447] = {.lex_state = 0, .external_lex_state = 2},
  [3448] = {.lex_state = 101, .external_lex_state = 2},
  [3449] = {.lex_state = 0, .external_lex_state = 2},
  [3450] = {.lex_state = 101, .external_lex_state = 2},
  [3451] = {.lex_state = 0, .external_lex_state = 2},
  [3452] = {.lex_state = 0, .external_lex_state = 2},
  [3453] = {.lex_state = 101, .external_lex_state = 2},
  [3454] = {.lex_state = 100, .external_lex_state = 2},
  [3455] = {.lex_state = 0, .external_lex_state = 2},
  [3456] = {.lex_state = 0, .external_lex_state = 2},
  [3457] = {.lex_state = 101, .external_lex_state = 2},
  [3458] = {.lex_state = 100, .external_lex_state = 2},
  [3459] = {.lex_state = 1, .external_lex_state = 2},
  [3460] = {.lex_state = 0, .external_lex_state = 2},
  [3461] = {.lex_state = 0, .external_lex_state = 2},
  [3462] = {.lex_state = 0, .external_lex_state = 2},
  [3463] = {.lex_state = 0, .external_lex_state = 2},
  [3464] = {.lex_state = 0, .external_lex_state = 2},
  [3465] = {.lex_state = 0, .external_lex_state = 2},
  [3466] = {.lex_state = 0, .external_lex_state = 2},
  [3467] = {.lex_state = 0, .external_lex_state = 2},
  [3468] = {.lex_state = 0, .external_lex_state = 2},
  [3469] = {.lex_state = 101, .external_lex_state = 2},
  [3470] = {.lex_state = 0, .external_lex_state = 2},
  [3471] = {.lex_state = 0, .external_lex_state = 2},
  [3472] = {.lex_state = 0, .external_lex_state = 2},
  [3473] = {.lex_state = 100, .external_lex_state = 2},
  [3474] = {.lex_state = 101, .external_lex_state = 2},
  [3475] = {.lex_state = 0, .external_lex_state = 2},
  [3476] = {.lex_state = 100, .external_lex_state = 2},
  [3477] = {.lex_state = 0, .external_lex_state = 2},
  [3478] = {.lex_state = 101, .external_lex_state = 2},
  [3479] = {.lex_state = 101, .external_lex_state = 2},
  [3480] = {.lex_state = 0, .external_lex_state = 2},
  [3481] = {.lex_state = 0, .external_lex_state = 2},
  [3482] = {.lex_state = 17, .external_lex_state = 2},
  [3483] = {.lex_state = 0, .external_lex_state = 2},
  [3484] = {.lex_state = 0, .external_lex_state = 2},
  [3485] = {.lex_state = 101, .external_lex_state = 2},
  [3486] = {.lex_state = 101, .external_lex_state = 2},
  [3487] = {.lex_state = 0, .external_lex_state = 2},
  [3488] = {.lex_state = 101, .external_lex_state = 2},
  [3489] = {.lex_state = 0, .external_lex_state = 2},
  [3490] = {.lex_state = 101, .external_lex_state = 2},
  [3491] = {.lex_state = 100, .external_lex_state = 2},
  [3492] = {.lex_state = 0, .external_lex_state = 2},
  [3493] = {.lex_state = 101, .external_lex_state = 2},
  [3494] = {.lex_state = 0, .external_lex_state = 2},
  [3495] = {.lex_state = 101, .external_lex_state = 2},
  [3496] = {.lex_state = 0, .external_lex_state = 2},
  [3497] = {.lex_state = 0, .external_lex_state = 2},
  [3498] = {.lex_state = 0, .external_lex_state = 2},
  [3499] = {.lex_state = 101, .external_lex_state = 2},
  [3500] = {.lex_state = 101, .external_lex_state = 2},
  [3501] = {.lex_state = 101, .external_lex_state = 2},
  [3502] = {.lex_state = 0, .external_lex_state = 2},
  [3503] = {.lex_state = 0, .external_lex_state = 2},
  [3504] = {.lex_state = 2, .external_lex_state = 2},
  [3505] = {.lex_state = 0, .external_lex_state = 2},
  [3506] = {.lex_state = 0, .external_lex_state = 2},
  [3507] = {.lex_state = 0, .external_lex_state = 2},
  [3508] = {.lex_state = 101, .external_lex_state = 2},
  [3509] = {.lex_state = 0, .external_lex_state = 2},
  [3510] = {.lex_state = 0, .external_lex_state = 2},
  [3511] = {.lex_state = 101, .external_lex_state = 2},
  [3512] = {.lex_state = 0, .external_lex_state = 2},
  [3513] = {.lex_state = 100, .external_lex_state = 2},
  [3514] = {.lex_state = 101, .external_lex_state = 2},
  [3515] = {.lex_state = 101, .external_lex_state = 2},
  [3516] = {.lex_state = 0, .external_lex_state = 2},
  [3517] = {.lex_state = 0, .external_lex_state = 2},
  [3518] = {.lex_state = 0, .external_lex_state = 2},
  [3519] = {.lex_state = 0, .external_lex_state = 2},
  [3520] = {.lex_state = 0, .external_lex_state = 2},
  [3521] = {.lex_state = 0, .external_lex_state = 2},
  [3522] = {.lex_state = 0, .external_lex_state = 2},
  [3523] = {.lex_state = 101, .external_lex_state = 2},
  [3524] = {.lex_state = 101, .external_lex_state = 2},
  [3525] = {.lex_state = 101, .external_lex_state = 2},
  [3526] = {.lex_state = 0, .external_lex_state = 2},
  [3527] = {.lex_state = 101, .external_lex_state = 2},
  [3528] = {.lex_state = 0, .external_lex_state = 2},
  [3529] = {.lex_state = 101, .external_lex_state = 2},
  [3530] = {.lex_state = 101, .external_lex_state = 2},
  [3531] = {.lex_state = 101, .external_lex_state = 2},
  [3532] = {.lex_state = 101, .external_lex_state = 2},
  [3533] = {.lex_state = 100, .external_lex_state = 2},
  [3534] = {.lex_state = 101, .external_lex_state = 2},
  [3535] = {.lex_state = 101, .external_lex_state = 2},
  [3536] = {.lex_state = 101, .external_lex_state = 2},
  [3537] = {.lex_state = 101, .external_lex_state = 2},
  [3538] = {.lex_state = 100, .external_lex_state = 2},
  [3539] = {.lex_state = 101, .external_lex_state = 2},
  [3540] = {.lex_state = 0, .external_lex_state = 2},
  [3541] = {.lex_state = 101, .external_lex_state = 2},
  [3542] = {.lex_state = 0, .external_lex_state = 2},
  [3543] = {.lex_state = 101, .external_lex_state = 2},
  [3544] = {.lex_state = 0, .external_lex_state = 2},
  [3545] = {.lex_state = 290, .external_lex_state = 2},
  [3546] = {.lex_state = 0, .external_lex_state = 2},
  [3547] = {.lex_state = 101, .external_lex_state = 2},
  [3548] = {.lex_state = 0, .external_lex_state = 2},
  [3549] = {.lex_state = 101, .external_lex_state = 2},
  [3550] = {.lex_state = 45, .external_lex_state = 2},
  [3551] = {.lex_state = 100, .external_lex_state = 2},
  [3552] = {.lex_state = 0, .external_lex_state = 2},
  [3553] = {.lex_state = 276, .external_lex_state = 2},
  [3554] = {.lex_state = 0, .external_lex_state = 2},
  [3555] = {.lex_state = 0, .external_lex_state = 2},
  [3556] = {.lex_state = 0, .external_lex_state = 2},
  [3557] = {.lex_state = 101, .external_lex_state = 2},
  [3558] = {.lex_state = 0, .external_lex_state = 2},
  [3559] = {.lex_state = 0, .external_lex_state = 2},
  [3560] = {.lex_state = 101, .external_lex_state = 2},
  [3561] = {.lex_state = 0, .external_lex_state = 2},
  [3562] = {.lex_state = 0, .external_lex_state = 2},
  [3563] = {.lex_state = 0, .external_lex_state = 2},
  [3564] = {.lex_state = 0, .external_lex_state = 2},
  [3565] = {.lex_state = 0, .external_lex_state = 2},
  [3566] = {.lex_state = 0, .external_lex_state = 2},
  [3567] = {.lex_state = 101, .external_lex_state = 2},
  [3568] = {.lex_state = 0, .external_lex_state = 2},
  [3569] = {.lex_state = 0, .external_lex_state = 2},
  [3570] = {.lex_state = 0, .external_lex_state = 2},
  [3571] = {.lex_state = 0, .external_lex_state = 2},
  [3572] = {(TSStateId)(-1)},
  [3573] = {(TSStateId)(-1)},
  [3574] = {(TSStateId)(-1)},
  [3575] = {(TSStateId)(-1)},
  [3576] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [sym_documentation_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [sym_decimal_integer_literal] = ACTIONS(1),
    [sym_hex_integer_literal] = ACTIONS(1),
    [sym_decimal_floating_point_literal] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_r_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_r_SQUOTE] = ACTIONS(1),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym__unused_escape_sequence] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [sym_equality_operator] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [sym__additive_operator] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_TILDE_SLASH] = ACTIONS(1),
    [sym_increment_operator] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [sym_minus_operator] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_part] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_show] = ACTIONS(1),
    [anon_sym_hide] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extension] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [sym_floating_point_type] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [sym_void_type] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_async_STAR] = ACTIONS(1),
    [anon_sym_sync_STAR] = ACTIONS(1),
    [anon_sym_POUND_BANG] = ACTIONS(1),
    [anon_sym_library] = ACTIONS(1),
    [sym_break_builtin] = ACTIONS(1),
    [sym_assert_builtin] = ACTIONS(1),
    [sym_rethrow_builtin] = ACTIONS(1),
    [sym_part_of_builtin] = ACTIONS(1),
    [anon_sym_covariant] = ACTIONS(1),
    [anon_sym_deferred] = ACTIONS(1),
    [anon_sym_dynamic] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_factory] = ACTIONS(1),
    [anon_sym_Function] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_base] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_mixin] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [sym_const_builtin] = ACTIONS(1),
    [anon_sym_late] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_super] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__template_chars_double] = ACTIONS(1),
    [sym__template_chars_single] = ACTIONS(1),
    [sym__template_chars_double_single] = ACTIONS(1),
    [sym__template_chars_single_single] = ACTIONS(1),
    [sym__template_chars_raw_slash] = ACTIONS(1),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [1] = {
    [sym_program] = STATE(3430),
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_import_or_export] = STATE(1572),
    [sym_library_import] = STATE(1577),
    [sym_library_export] = STATE(1577),
    [sym_import_specification] = STATE(1581),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(550),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym_script_tag] = STATE(435),
    [sym_library_name] = STATE(442),
    [sym__export] = STATE(1869),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym__import] = STATE(1817),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(1),
    [sym_documentation_comment] = STATE(1),
    [aux_sym_program_repeat1] = STATE(438),
    [aux_sym_program_repeat2] = STATE(454),
    [aux_sym_program_repeat3] = STATE(469),
    [aux_sym_program_repeat4] = STATE(475),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(13),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_POUND_BANG] = ACTIONS(37),
    [anon_sym_library] = ACTIONS(39),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_export] = ACTIONS(43),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [2] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2565),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_element] = STATE(2660),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(2),
    [sym_documentation_comment] = STATE(2),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(24),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [3] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2565),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_element] = STATE(2660),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(3),
    [sym_documentation_comment] = STATE(3),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(24),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [4] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2565),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_element] = STATE(2660),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(4),
    [sym_documentation_comment] = STATE(4),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(24),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_RBRACE] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [5] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2645),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2503),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(547),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_element] = STATE(2660),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(5),
    [sym_documentation_comment] = STATE(5),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [6] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2600),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2503),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(539),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_element] = STATE(2660),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(6),
    [sym_documentation_comment] = STATE(6),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [7] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2589),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2503),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(531),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_element] = STATE(2660),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(7),
    [sym_documentation_comment] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [8] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2615),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2503),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(537),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_element] = STATE(2660),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(8),
    [sym_documentation_comment] = STATE(8),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(139),
    [anon_sym_for] = ACTIONS(141),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [9] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(9),
    [sym_documentation_comment] = STATE(9),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(169),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(174),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_default] = ACTIONS(178),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_case] = ACTIONS(178),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [10] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(10),
    [sym_documentation_comment] = STATE(10),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(12),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(184),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(187),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_default] = ACTIONS(189),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_case] = ACTIONS(189),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [11] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(11),
    [sym_documentation_comment] = STATE(11),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(9),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(191),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_default] = ACTIONS(196),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [12] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(12),
    [sym_documentation_comment] = STATE(12),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(191),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(194),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_default] = ACTIONS(196),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [13] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(13),
    [sym_documentation_comment] = STATE(13),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(198),
    [anon_sym_POUND] = ACTIONS(201),
    [sym_decimal_integer_literal] = ACTIONS(204),
    [sym_hex_integer_literal] = ACTIONS(207),
    [sym_decimal_floating_point_literal] = ACTIONS(204),
    [anon_sym_true] = ACTIONS(210),
    [anon_sym_false] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(216),
    [anon_sym_SQUOTE] = ACTIONS(219),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(222),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(225),
    [anon_sym_r_DQUOTE] = ACTIONS(228),
    [anon_sym_r_SQUOTE] = ACTIONS(231),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(234),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(237),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_LBRACK] = ACTIONS(245),
    [anon_sym_null] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_throw] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(257),
    [sym_increment_operator] = ACTIONS(260),
    [sym_minus_operator] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(266),
    [anon_sym_TILDE] = ACTIONS(269),
    [anon_sym_await] = ACTIONS(272),
    [anon_sym_switch] = ACTIONS(275),
    [anon_sym_default] = ACTIONS(278),
    [anon_sym_do] = ACTIONS(280),
    [anon_sym_while] = ACTIONS(283),
    [anon_sym_continue] = ACTIONS(286),
    [anon_sym_yield] = ACTIONS(289),
    [anon_sym_return] = ACTIONS(292),
    [anon_sym_try] = ACTIONS(295),
    [anon_sym_if] = ACTIONS(298),
    [anon_sym_case] = ACTIONS(278),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(304),
    [anon_sym_final] = ACTIONS(307),
    [sym_void_type] = ACTIONS(310),
    [anon_sym_var] = ACTIONS(313),
    [sym_break_builtin] = ACTIONS(316),
    [sym_assert_builtin] = ACTIONS(319),
    [sym_rethrow_builtin] = ACTIONS(322),
    [anon_sym_covariant] = ACTIONS(325),
    [anon_sym_Function] = ACTIONS(328),
    [anon_sym_get] = ACTIONS(331),
    [anon_sym_set] = ACTIONS(334),
    [anon_sym_new] = ACTIONS(337),
    [sym_const_builtin] = ACTIONS(340),
    [anon_sym_late] = ACTIONS(343),
    [anon_sym_this] = ACTIONS(346),
    [anon_sym_super] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [14] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(14),
    [sym_documentation_comment] = STATE(14),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(23),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(352),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [15] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(15),
    [sym_documentation_comment] = STATE(15),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(27),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [16] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(16),
    [sym_documentation_comment] = STATE(16),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(356),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [17] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(17),
    [sym_documentation_comment] = STATE(17),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(358),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [18] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(18),
    [sym_documentation_comment] = STATE(18),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(24),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(360),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [19] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(19),
    [sym_documentation_comment] = STATE(19),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(17),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [20] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(20),
    [sym_documentation_comment] = STATE(20),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(25),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [21] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(21),
    [sym_documentation_comment] = STATE(21),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(16),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [22] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(22),
    [sym_documentation_comment] = STATE(22),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(26),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(358),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [23] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(23),
    [sym_documentation_comment] = STATE(23),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [24] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(24),
    [sym_documentation_comment] = STATE(24),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [25] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(25),
    [sym_documentation_comment] = STATE(25),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [26] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(26),
    [sym_documentation_comment] = STATE(26),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [27] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(556),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(27),
    [sym_documentation_comment] = STATE(27),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym_block_repeat1] = STATE(13),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_RBRACE] = ACTIONS(376),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [28] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(3116),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(28),
    [sym_documentation_comment] = STATE(28),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [29] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(520),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(29),
    [sym_documentation_comment] = STATE(29),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [30] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(523),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(30),
    [sym_documentation_comment] = STATE(30),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [31] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(520),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(31),
    [sym_documentation_comment] = STATE(31),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [32] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(547),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(32),
    [sym_documentation_comment] = STATE(32),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [33] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(539),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(33),
    [sym_documentation_comment] = STATE(33),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [34] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(545),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(34),
    [sym_documentation_comment] = STATE(34),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [35] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(537),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(35),
    [sym_documentation_comment] = STATE(35),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [36] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(539),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(36),
    [sym_documentation_comment] = STATE(36),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [37] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(3450),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(37),
    [sym_documentation_comment] = STATE(37),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [38] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(537),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(38),
    [sym_documentation_comment] = STATE(38),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [39] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(523),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(39),
    [sym_documentation_comment] = STATE(39),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [40] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(3121),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(40),
    [sym_documentation_comment] = STATE(40),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(380),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [41] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(531),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(41),
    [sym_documentation_comment] = STATE(41),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [42] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3203),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_lambda_expression] = STATE(534),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym__statement] = STATE(545),
    [sym_local_function_declaration] = STATE(533),
    [sym_block] = STATE(527),
    [sym_expression_statement] = STATE(527),
    [sym_assert_statement] = STATE(527),
    [sym_assertion] = STATE(3380),
    [sym_switch_statement] = STATE(527),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_do_statement] = STATE(527),
    [sym_break_statement] = STATE(527),
    [sym_continue_statement] = STATE(527),
    [sym_yield_statement] = STATE(527),
    [sym_yield_each_statement] = STATE(527),
    [sym_return_statement] = STATE(527),
    [sym_try_statement] = STATE(527),
    [sym__try_head] = STATE(464),
    [sym_if_statement] = STATE(527),
    [sym_while_statement] = STATE(527),
    [sym_for_statement] = STATE(527),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1059),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2667),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2530),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1771),
    [sym_function_signature] = STATE(2368),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(542),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2500),
    [sym__set] = STATE(2500),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1764),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(42),
    [sym_documentation_comment] = STATE(42),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(176),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_do] = ACTIONS(127),
    [anon_sym_while] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_yield] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(180),
    [anon_sym_for] = ACTIONS(182),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_break_builtin] = ACTIONS(147),
    [sym_assert_builtin] = ACTIONS(149),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [43] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2786),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2771),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2690),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__var_or_type] = STATE(2755),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(1995),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_formal_parameter] = STATE(2982),
    [sym__default_formal_parameter] = STATE(2791),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym_qualified] = STATE(2124),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1992),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1324),
    [sym_comment] = STATE(43),
    [sym_documentation_comment] = STATE(43),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(388),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(418),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [44] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2786),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2771),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2690),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__var_or_type] = STATE(2755),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(1995),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_formal_parameter] = STATE(2982),
    [sym__default_formal_parameter] = STATE(2791),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym_qualified] = STATE(2124),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1992),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1324),
    [sym_comment] = STATE(44),
    [sym_documentation_comment] = STATE(44),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(388),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(420),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(418),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [45] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3108),
    [sym__expression] = STATE(3111),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3114),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym__pattern_field] = STATE(2754),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1064),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2553),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2126),
    [sym__var_or_type] = STATE(2755),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(1995),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__normal_formal_parameters] = STATE(3271),
    [sym_optional_formal_parameters] = STATE(3277),
    [sym__optional_postional_formal_parameters] = STATE(3424),
    [sym__named_formal_parameters] = STATE(3424),
    [sym_formal_parameter] = STATE(2750),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym_qualified] = STATE(2124),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1992),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1328),
    [sym_label] = STATE(213),
    [sym_comment] = STATE(45),
    [sym_documentation_comment] = STATE(45),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(422),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(430),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(418),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [46] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3108),
    [sym__expression] = STATE(3111),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3114),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym__pattern_field] = STATE(2754),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2690),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__var_or_type] = STATE(2755),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(1995),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__normal_formal_parameters] = STATE(3271),
    [sym_optional_formal_parameters] = STATE(3277),
    [sym__optional_postional_formal_parameters] = STATE(3424),
    [sym__named_formal_parameters] = STATE(3424),
    [sym_formal_parameter] = STATE(2750),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym_qualified] = STATE(2124),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1992),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1328),
    [sym_label] = STATE(213),
    [sym_comment] = STATE(46),
    [sym_documentation_comment] = STATE(46),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(434),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(418),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [47] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3085),
    [sym__expression] = STATE(3188),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3114),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym__pattern_field] = STATE(2754),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2690),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__var_or_type] = STATE(2755),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(1995),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__normal_formal_parameters] = STATE(3271),
    [sym_optional_formal_parameters] = STATE(3277),
    [sym__optional_postional_formal_parameters] = STATE(3424),
    [sym__named_formal_parameters] = STATE(3424),
    [sym_formal_parameter] = STATE(2750),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym_qualified] = STATE(2124),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1992),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1328),
    [sym_label] = STATE(238),
    [sym_comment] = STATE(47),
    [sym_documentation_comment] = STATE(47),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(434),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(436),
    [anon_sym_LBRACK] = ACTIONS(426),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(418),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [48] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(788),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2868),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_named_field] = STATE(2804),
    [sym__type_name] = STATE(2004),
    [sym_typed_identifier] = STATE(3101),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1976),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_formal_parameter] = STATE(2654),
    [sym__default_named_parameter] = STATE(2997),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__required] = STATE(910),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1984),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1348),
    [sym_comment] = STATE(48),
    [sym_documentation_comment] = STATE(48),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(440),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_required] = ACTIONS(446),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [49] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(825),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2756),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1976),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_formal_parameter] = STATE(2654),
    [sym__default_named_parameter] = STATE(2997),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__required] = STATE(910),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1984),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1348),
    [sym_comment] = STATE(49),
    [sym_documentation_comment] = STATE(49),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(440),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_required] = ACTIONS(446),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [50] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(825),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2756),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1976),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_formal_parameter] = STATE(2654),
    [sym__default_named_parameter] = STATE(2997),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__required] = STATE(910),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1984),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1348),
    [sym_comment] = STATE(50),
    [sym_documentation_comment] = STATE(50),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(440),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_required] = ACTIONS(446),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [51] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2828),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2771),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(51),
    [sym_documentation_comment] = STATE(51),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(452),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [52] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2954),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2972),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(52),
    [sym_documentation_comment] = STATE(52),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(456),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [53] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2786),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2771),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(53),
    [sym_documentation_comment] = STATE(53),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(420),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [54] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2954),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2972),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(54),
    [sym_documentation_comment] = STATE(54),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(458),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [55] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2786),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2771),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(55),
    [sym_documentation_comment] = STATE(55),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [56] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2802),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym__list_pattern_element] = STATE(2972),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(56),
    [sym_documentation_comment] = STATE(56),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(460),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(404),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [57] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3105),
    [sym__expression] = STATE(3064),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2756),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1976),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__normal_formal_parameters] = STATE(3271),
    [sym_optional_formal_parameters] = STATE(3277),
    [sym__optional_postional_formal_parameters] = STATE(3424),
    [sym__named_formal_parameters] = STATE(3424),
    [sym_formal_parameter] = STATE(2750),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1984),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1328),
    [sym_label] = STATE(257),
    [sym_comment] = STATE(57),
    [sym_documentation_comment] = STATE(57),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(462),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(466),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [58] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3108),
    [sym__expression] = STATE(3111),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2756),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1976),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__normal_formal_parameters] = STATE(3271),
    [sym_optional_formal_parameters] = STATE(3277),
    [sym__optional_postional_formal_parameters] = STATE(3424),
    [sym__named_formal_parameters] = STATE(3424),
    [sym_formal_parameter] = STATE(2750),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1984),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1328),
    [sym_label] = STATE(213),
    [sym_comment] = STATE(58),
    [sym_documentation_comment] = STATE(58),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(462),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(466),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [59] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3150),
    [sym__expression] = STATE(3169),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2756),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1976),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__normal_formal_parameters] = STATE(3271),
    [sym_optional_formal_parameters] = STATE(3277),
    [sym__optional_postional_formal_parameters] = STATE(3424),
    [sym__named_formal_parameters] = STATE(3424),
    [sym_formal_parameter] = STATE(2750),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1984),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1328),
    [sym_label] = STATE(258),
    [sym_comment] = STATE(59),
    [sym_documentation_comment] = STATE(59),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(462),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(466),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [60] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3085),
    [sym__expression] = STATE(3188),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1077),
    [sym_type_parameters] = STATE(2932),
    [sym__declared_identifier] = STATE(2468),
    [sym__final_const_var_or_type] = STATE(2557),
    [sym__type] = STATE(2756),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1976),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__normal_formal_parameters] = STATE(3271),
    [sym_optional_formal_parameters] = STATE(3277),
    [sym__optional_postional_formal_parameters] = STATE(3424),
    [sym__named_formal_parameters] = STATE(3424),
    [sym_formal_parameter] = STATE(2750),
    [sym__normal_formal_parameter] = STATE(2466),
    [sym__function_formal_parameter] = STATE(2465),
    [sym__simple_formal_parameter] = STATE(2464),
    [sym_super_formal_parameter] = STATE(2465),
    [sym_constructor_param] = STATE(2465),
    [sym__covariant] = STATE(1794),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1984),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(1254),
    [sym_super] = STATE(1328),
    [sym_label] = STATE(238),
    [sym_comment] = STATE(60),
    [sym_documentation_comment] = STATE(60),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(462),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(464),
    [anon_sym_LBRACK] = ACTIONS(466),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [61] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2601),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3168),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(61),
    [sym_documentation_comment] = STATE(61),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(470),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [62] = {
    [sym__bool_literal] = STATE(1245),
    [sym__numeric_literal] = STATE(1245),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(1245),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(1245),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(1245),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2606),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_relational_operator] = STATE(345),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(1249),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3161),
    [sym_switch_expression] = STATE(962),
    [sym__pattern] = STATE(3191),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2158),
    [sym_list_pattern] = STATE(2158),
    [sym_map_pattern] = STATE(2158),
    [sym_record_pattern] = STATE(2158),
    [sym_object_pattern] = STATE(2158),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2126),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(2100),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(62),
    [sym_documentation_comment] = STATE(62),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(450),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(398),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(454),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [63] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2624),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym_pattern_variable_declaration] = STATE(3176),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym__for_loop_parts] = STATE(3510),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(1388),
    [sym_type_parameters] = STATE(2932),
    [sym_initialized_variable_definition] = STATE(3176),
    [sym__declared_identifier] = STATE(2561),
    [sym__final_const_var_or_type] = STATE(3411),
    [sym__type] = STATE(2943),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2004),
    [sym__var_or_type] = STATE(2755),
    [sym_inferred_type] = STATE(1727),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_local_variable_declaration] = STATE(187),
    [sym__covariant] = STATE(1795),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_final_builtin] = STATE(1759),
    [sym__late_builtin] = STATE(1915),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym__semicolon] = STATE(181),
    [sym_comment] = STATE(63),
    [sym_documentation_comment] = STATE(63),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(472),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_covariant] = ACTIONS(153),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(157),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [64] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2043),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3495),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_named_field] = STATE(2804),
    [sym__type_name] = STATE(2004),
    [sym_typed_identifier] = STATE(3101),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(64),
    [sym_documentation_comment] = STATE(64),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [65] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3558),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2043),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(3495),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_named_field] = STATE(2804),
    [sym__type_name] = STATE(2004),
    [sym_typed_identifier] = STATE(3101),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(65),
    [sym_documentation_comment] = STATE(65),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(482),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [66] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3150),
    [sym__expression] = STATE(3455),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2088),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(2822),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2004),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(258),
    [sym_comment] = STATE(66),
    [sym_documentation_comment] = STATE(66),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(484),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [67] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3108),
    [sym__expression] = STATE(3552),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2088),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(2822),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2004),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(213),
    [sym_comment] = STATE(67),
    [sym_documentation_comment] = STATE(67),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(484),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [68] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3085),
    [sym__expression] = STATE(3334),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2088),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(2822),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2004),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(238),
    [sym_comment] = STATE(68),
    [sym_documentation_comment] = STATE(68),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(484),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [69] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3105),
    [sym__expression] = STATE(3475),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2088),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(2822),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2004),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(257),
    [sym_comment] = STATE(69),
    [sym_documentation_comment] = STATE(69),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(484),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [70] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3108),
    [sym__expression] = STATE(3258),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2088),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(2822),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2004),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(213),
    [sym_comment] = STATE(70),
    [sym_documentation_comment] = STATE(70),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(490),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [71] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3496),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2088),
    [sym_type_parameters] = STATE(2932),
    [sym__type] = STATE(2822),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2004),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(71),
    [sym_documentation_comment] = STATE(71),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(492),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(488),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(143),
    [sym_void_type] = ACTIONS(33),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [72] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2953),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2986),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(72),
    [sym_documentation_comment] = STATE(72),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [73] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2830),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(73),
    [sym_documentation_comment] = STATE(73),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [74] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2803),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2986),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(74),
    [sym_documentation_comment] = STATE(74),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [75] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(75),
    [sym_documentation_comment] = STATE(75),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [76] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(76),
    [sym_documentation_comment] = STATE(76),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [77] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2953),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2688),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2986),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(77),
    [sym_documentation_comment] = STATE(77),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(115),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [78] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(78),
    [sym_documentation_comment] = STATE(78),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [79] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(79),
    [sym_documentation_comment] = STATE(79),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [80] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2784),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(80),
    [sym_documentation_comment] = STATE(80),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [81] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(81),
    [sym_documentation_comment] = STATE(81),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(512),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [82] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(82),
    [sym_documentation_comment] = STATE(82),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [83] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2802),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(83),
    [sym_documentation_comment] = STATE(83),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(514),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [84] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2803),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(84),
    [sym_documentation_comment] = STATE(84),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [85] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2828),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(85),
    [sym_documentation_comment] = STATE(85),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(518),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [86] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2830),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(86),
    [sym_documentation_comment] = STATE(86),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [87] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(87),
    [sym_documentation_comment] = STATE(87),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [88] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(88),
    [sym_documentation_comment] = STATE(88),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(524),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [89] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2797),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(89),
    [sym_documentation_comment] = STATE(89),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(526),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [90] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2801),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(90),
    [sym_documentation_comment] = STATE(90),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [91] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2852),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(91),
    [sym_documentation_comment] = STATE(91),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [92] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2853),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(92),
    [sym_documentation_comment] = STATE(92),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(532),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [93] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(93),
    [sym_documentation_comment] = STATE(93),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(534),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [94] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(94),
    [sym_documentation_comment] = STATE(94),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(536),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [95] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(95),
    [sym_documentation_comment] = STATE(95),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [96] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(96),
    [sym_documentation_comment] = STATE(96),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(540),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [97] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(97),
    [sym_documentation_comment] = STATE(97),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(542),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [98] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(98),
    [sym_documentation_comment] = STATE(98),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [99] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(99),
    [sym_documentation_comment] = STATE(99),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [100] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(100),
    [sym_documentation_comment] = STATE(100),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [101] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(101),
    [sym_documentation_comment] = STATE(101),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(548),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [102] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(102),
    [sym_documentation_comment] = STATE(102),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [103] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(103),
    [sym_documentation_comment] = STATE(103),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [104] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2896),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(104),
    [sym_documentation_comment] = STATE(104),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(506),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [105] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2897),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(105),
    [sym_documentation_comment] = STATE(105),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [106] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(106),
    [sym_documentation_comment] = STATE(106),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [107] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(107),
    [sym_documentation_comment] = STATE(107),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [108] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(108),
    [sym_documentation_comment] = STATE(108),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [109] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(109),
    [sym_documentation_comment] = STATE(109),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [110] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(110),
    [sym_documentation_comment] = STATE(110),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [111] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2909),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(111),
    [sym_documentation_comment] = STATE(111),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(564),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [112] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2911),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(112),
    [sym_documentation_comment] = STATE(112),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [113] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2955),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(113),
    [sym_documentation_comment] = STATE(113),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(568),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [114] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2956),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(114),
    [sym_documentation_comment] = STATE(114),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [115] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2795),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(115),
    [sym_documentation_comment] = STATE(115),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [116] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2790),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(116),
    [sym_documentation_comment] = STATE(116),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [117] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(117),
    [sym_documentation_comment] = STATE(117),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(572),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [118] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(118),
    [sym_documentation_comment] = STATE(118),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(508),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [119] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2782),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(119),
    [sym_documentation_comment] = STATE(119),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(512),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [120] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(120),
    [sym_documentation_comment] = STATE(120),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(574),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [121] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(121),
    [sym_documentation_comment] = STATE(121),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(576),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [122] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(122),
    [sym_documentation_comment] = STATE(122),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [123] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2817),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(123),
    [sym_documentation_comment] = STATE(123),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [124] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(124),
    [sym_documentation_comment] = STATE(124),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(582),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [125] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2786),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(125),
    [sym_documentation_comment] = STATE(125),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(584),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [126] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(126),
    [sym_documentation_comment] = STATE(126),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(586),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [127] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(127),
    [sym_documentation_comment] = STATE(127),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(588),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [128] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(128),
    [sym_documentation_comment] = STATE(128),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(590),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [129] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(129),
    [sym_documentation_comment] = STATE(129),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(592),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [130] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(130),
    [sym_documentation_comment] = STATE(130),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [131] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(131),
    [sym_documentation_comment] = STATE(131),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(596),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [132] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(132),
    [sym_documentation_comment] = STATE(132),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(598),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [133] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(133),
    [sym_documentation_comment] = STATE(133),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [134] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(134),
    [sym_documentation_comment] = STATE(134),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [135] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(135),
    [sym_documentation_comment] = STATE(135),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(604),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [136] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2930),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(136),
    [sym_documentation_comment] = STATE(136),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(606),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [137] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2867),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(137),
    [sym_documentation_comment] = STATE(137),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [138] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2860),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(138),
    [sym_documentation_comment] = STATE(138),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [139] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(139),
    [sym_documentation_comment] = STATE(139),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(608),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [140] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2929),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(140),
    [sym_documentation_comment] = STATE(140),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [141] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2954),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(141),
    [sym_documentation_comment] = STATE(141),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(526),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [142] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(142),
    [sym_documentation_comment] = STATE(142),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(606),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [143] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(143),
    [sym_documentation_comment] = STATE(143),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [144] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(144),
    [sym_documentation_comment] = STATE(144),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [145] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(145),
    [sym_documentation_comment] = STATE(145),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [146] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(146),
    [sym_documentation_comment] = STATE(146),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(614),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [147] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2902),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(147),
    [sym_documentation_comment] = STATE(147),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_RBRACK] = ACTIONS(616),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [148] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2901),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(148),
    [sym_documentation_comment] = STATE(148),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [149] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2953),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(149),
    [sym_documentation_comment] = STATE(149),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [150] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2615),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(150),
    [sym_documentation_comment] = STATE(150),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [151] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2588),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(151),
    [sym_documentation_comment] = STATE(151),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [152] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2589),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(152),
    [sym_documentation_comment] = STATE(152),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [153] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2835),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(153),
    [sym_documentation_comment] = STATE(153),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [154] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2645),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(154),
    [sym_documentation_comment] = STATE(154),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [155] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2752),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(155),
    [sym_documentation_comment] = STATE(155),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [156] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2837),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(156),
    [sym_documentation_comment] = STATE(156),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [157] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2749),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(157),
    [sym_documentation_comment] = STATE(157),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [158] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2598),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(158),
    [sym_documentation_comment] = STATE(158),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [159] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2838),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(159),
    [sym_documentation_comment] = STATE(159),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [160] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_pair] = STATE(2660),
    [sym__element] = STATE(2600),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2562),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_spread_element] = STATE(2660),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_if_element] = STATE(2660),
    [sym_for_element] = STATE(2660),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(160),
    [sym_documentation_comment] = STATE(160),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(167),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(410),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(416),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [161] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3339),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(161),
    [sym_documentation_comment] = STATE(161),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [162] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3414),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(162),
    [sym_documentation_comment] = STATE(162),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(624),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [163] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3384),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(163),
    [sym_documentation_comment] = STATE(163),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(626),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [164] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3375),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(164),
    [sym_documentation_comment] = STATE(164),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(628),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [165] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3526),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(165),
    [sym_documentation_comment] = STATE(165),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [166] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3363),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(166),
    [sym_documentation_comment] = STATE(166),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(632),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [167] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3518),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(167),
    [sym_documentation_comment] = STATE(167),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(634),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [168] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3295),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(168),
    [sym_documentation_comment] = STATE(168),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(636),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [169] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__argument_list] = STATE(3385),
    [sym__any_argument] = STATE(2931),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(169),
    [sym_documentation_comment] = STATE(169),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [170] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__any_argument] = STATE(3030),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(170),
    [sym_documentation_comment] = STATE(170),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(640),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [171] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__any_argument] = STATE(3030),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(171),
    [sym_documentation_comment] = STATE(171),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(642),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [172] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3055),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym__any_argument] = STATE(3030),
    [sym_argument] = STATE(3051),
    [sym_named_argument] = STATE(3051),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(209),
    [sym_comment] = STATE(172),
    [sym_documentation_comment] = STATE(172),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [173] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3558),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(3212),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(173),
    [sym_documentation_comment] = STATE(173),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(482),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [174] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3558),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2798),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(174),
    [sym_documentation_comment] = STATE(174),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(482),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [175] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3558),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(3212),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(175),
    [sym_documentation_comment] = STATE(175),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(482),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [176] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2601),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(176),
    [sym_documentation_comment] = STATE(176),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [177] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3234),
    [sym__expression] = STATE(3220),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(235),
    [sym_comment] = STATE(177),
    [sym_documentation_comment] = STATE(177),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [178] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3234),
    [sym__expression] = STATE(3220),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(235),
    [sym_comment] = STATE(178),
    [sym_documentation_comment] = STATE(178),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(652),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [179] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3558),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(2986),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(179),
    [sym_documentation_comment] = STATE(179),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(654),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(482),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [180] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3234),
    [sym__expression] = STATE(3220),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(235),
    [sym_comment] = STATE(180),
    [sym_documentation_comment] = STATE(180),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(656),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [181] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2549),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym__semicolon] = STATE(195),
    [sym_comment] = STATE(181),
    [sym_documentation_comment] = STATE(181),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [182] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3234),
    [sym__expression] = STATE(3220),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(235),
    [sym_comment] = STATE(182),
    [sym_documentation_comment] = STATE(182),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(660),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [183] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3558),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(3212),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(183),
    [sym_documentation_comment] = STATE(183),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(482),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [184] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2536),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym__semicolon] = STATE(199),
    [sym_comment] = STATE(184),
    [sym_documentation_comment] = STATE(184),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(664),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [185] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3558),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym__map_pattern_entry] = STATE(3212),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(185),
    [sym_documentation_comment] = STATE(185),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(482),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [186] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_record_field] = STATE(3234),
    [sym__expression] = STATE(3220),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_label] = STATE(235),
    [sym_comment] = STATE(186),
    [sym_documentation_comment] = STATE(186),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [187] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3134),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym__semicolon] = STATE(194),
    [sym_comment] = STATE(187),
    [sym_documentation_comment] = STATE(187),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [188] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3260),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym__semicolon] = STATE(198),
    [sym_comment] = STATE(188),
    [sym_documentation_comment] = STATE(188),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [189] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3138),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym__semicolon] = STATE(536),
    [sym_comment] = STATE(189),
    [sym_documentation_comment] = STATE(189),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [190] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2879),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(190),
    [sym_documentation_comment] = STATE(190),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [191] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3130),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(191),
    [sym_documentation_comment] = STATE(191),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(668),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [192] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2601),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(192),
    [sym_documentation_comment] = STATE(192),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [193] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3155),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(193),
    [sym_documentation_comment] = STATE(193),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(670),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [194] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2687),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(194),
    [sym_documentation_comment] = STATE(194),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(672),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [195] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2679),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(195),
    [sym_documentation_comment] = STATE(195),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(674),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [196] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2781),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(196),
    [sym_documentation_comment] = STATE(196),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [197] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2952),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(197),
    [sym_documentation_comment] = STATE(197),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(678),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [198] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2858),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(198),
    [sym_documentation_comment] = STATE(198),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [199] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2764),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(199),
    [sym_documentation_comment] = STATE(199),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(682),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [200] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2772),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(200),
    [sym_documentation_comment] = STATE(200),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [201] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(1225),
    [sym__real_expression] = STATE(510),
    [sym_throw_expression] = STATE(1267),
    [sym_rethrow_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1267),
    [sym_assignable_expression] = STATE(1956),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3409),
    [sym_pattern_assignment] = STATE(1267),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(201),
    [sym_documentation_comment] = STATE(201),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [202] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3449),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(202),
    [sym_documentation_comment] = STATE(202),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [203] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression] = STATE(1161),
    [sym__real_expression] = STATE(508),
    [sym_throw_expression] = STATE(1186),
    [sym_rethrow_expression] = STATE(1186),
    [sym_assignment_expression] = STATE(1186),
    [sym_assignable_expression] = STATE(1932),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3109),
    [sym_switch_expression] = STATE(1135),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3287),
    [sym_pattern_assignment] = STATE(1186),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2663),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(203),
    [sym_documentation_comment] = STATE(203),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(726),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_throw] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [sym_rethrow_builtin] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [204] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression] = STATE(1142),
    [sym__real_expression] = STATE(508),
    [sym_throw_expression] = STATE(1186),
    [sym_rethrow_expression] = STATE(1186),
    [sym_assignment_expression] = STATE(1186),
    [sym_assignable_expression] = STATE(1932),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3109),
    [sym_switch_expression] = STATE(1135),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3287),
    [sym_pattern_assignment] = STATE(1186),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2663),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(204),
    [sym_documentation_comment] = STATE(204),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(726),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_throw] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [sym_rethrow_builtin] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [205] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(1226),
    [sym__real_expression] = STATE(510),
    [sym_throw_expression] = STATE(1267),
    [sym_rethrow_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1267),
    [sym_assignable_expression] = STATE(1956),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3409),
    [sym_pattern_assignment] = STATE(1267),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(205),
    [sym_documentation_comment] = STATE(205),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [206] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3132),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(206),
    [sym_documentation_comment] = STATE(206),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [207] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(1236),
    [sym__real_expression] = STATE(510),
    [sym_throw_expression] = STATE(1267),
    [sym_rethrow_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1267),
    [sym_assignable_expression] = STATE(1956),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3409),
    [sym_pattern_assignment] = STATE(1267),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(207),
    [sym_documentation_comment] = STATE(207),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [208] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3281),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(208),
    [sym_documentation_comment] = STATE(208),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [209] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3256),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(209),
    [sym_documentation_comment] = STATE(209),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [210] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression] = STATE(1131),
    [sym__real_expression] = STATE(508),
    [sym_throw_expression] = STATE(1186),
    [sym_rethrow_expression] = STATE(1186),
    [sym_assignment_expression] = STATE(1186),
    [sym_assignable_expression] = STATE(1932),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3109),
    [sym_switch_expression] = STATE(1135),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3287),
    [sym_pattern_assignment] = STATE(1186),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2663),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(210),
    [sym_documentation_comment] = STATE(210),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(726),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_throw] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [sym_rethrow_builtin] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [211] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3407),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(211),
    [sym_documentation_comment] = STATE(211),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [212] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3403),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(212),
    [sym_documentation_comment] = STATE(212),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [213] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3120),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(213),
    [sym_documentation_comment] = STATE(213),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [214] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression] = STATE(1139),
    [sym__real_expression] = STATE(508),
    [sym_throw_expression] = STATE(1186),
    [sym_rethrow_expression] = STATE(1186),
    [sym_assignment_expression] = STATE(1186),
    [sym_assignable_expression] = STATE(1932),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3109),
    [sym_switch_expression] = STATE(1135),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3287),
    [sym_pattern_assignment] = STATE(1186),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2663),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(214),
    [sym_documentation_comment] = STATE(214),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(726),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_throw] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [sym_rethrow_builtin] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [215] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3398),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(215),
    [sym_documentation_comment] = STATE(215),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [216] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3393),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(216),
    [sym_documentation_comment] = STATE(216),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [217] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3388),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(217),
    [sym_documentation_comment] = STATE(217),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [218] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3180),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(218),
    [sym_documentation_comment] = STATE(218),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [219] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3446),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(219),
    [sym_documentation_comment] = STATE(219),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [220] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3487),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(220),
    [sym_documentation_comment] = STATE(220),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [221] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3381),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(221),
    [sym_documentation_comment] = STATE(221),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [222] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3086),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(222),
    [sym_documentation_comment] = STATE(222),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [223] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3290),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(223),
    [sym_documentation_comment] = STATE(223),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [224] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3207),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(224),
    [sym_documentation_comment] = STATE(224),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [225] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3247),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(225),
    [sym_documentation_comment] = STATE(225),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [226] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3370),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(226),
    [sym_documentation_comment] = STATE(226),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [227] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3351),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(227),
    [sym_documentation_comment] = STATE(227),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [228] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3071),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(228),
    [sym_documentation_comment] = STATE(228),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [229] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3315),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(229),
    [sym_documentation_comment] = STATE(229),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [230] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(951),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(230),
    [sym_documentation_comment] = STATE(230),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [231] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3436),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(231),
    [sym_documentation_comment] = STATE(231),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [232] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3329),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(232),
    [sym_documentation_comment] = STATE(232),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [233] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(941),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(233),
    [sym_documentation_comment] = STATE(233),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [234] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2978),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(234),
    [sym_documentation_comment] = STATE(234),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [235] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3091),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(235),
    [sym_documentation_comment] = STATE(235),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [236] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3278),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(236),
    [sym_documentation_comment] = STATE(236),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [237] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(921),
    [sym__real_expression] = STATE(481),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1955),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3395),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(237),
    [sym_documentation_comment] = STATE(237),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [238] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3218),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(238),
    [sym_documentation_comment] = STATE(238),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [239] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(1003),
    [sym__real_expression] = STATE(481),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1955),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3395),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(239),
    [sym_documentation_comment] = STATE(239),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [240] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3362),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(240),
    [sym_documentation_comment] = STATE(240),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [241] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(1292),
    [sym__real_expression] = STATE(510),
    [sym_throw_expression] = STATE(1267),
    [sym_rethrow_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1267),
    [sym_assignable_expression] = STATE(1956),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3409),
    [sym_pattern_assignment] = STATE(1267),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(241),
    [sym_documentation_comment] = STATE(241),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [242] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3222),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(242),
    [sym_documentation_comment] = STATE(242),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [243] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3217),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(243),
    [sym_documentation_comment] = STATE(243),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [244] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3466),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(244),
    [sym_documentation_comment] = STATE(244),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [245] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3038),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(245),
    [sym_documentation_comment] = STATE(245),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [246] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2760),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(246),
    [sym_documentation_comment] = STATE(246),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [247] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3046),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(247),
    [sym_documentation_comment] = STATE(247),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [248] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3041),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(248),
    [sym_documentation_comment] = STATE(248),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [249] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3266),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(249),
    [sym_documentation_comment] = STATE(249),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [250] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2382),
    [sym__real_expression] = STATE(722),
    [sym_throw_expression] = STATE(2393),
    [sym_rethrow_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_assignable_expression] = STATE(1952),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3533),
    [sym_pattern_assignment] = STATE(2393),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(250),
    [sym_documentation_comment] = STATE(250),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [251] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2365),
    [sym__real_expression] = STATE(722),
    [sym_throw_expression] = STATE(2393),
    [sym_rethrow_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_assignable_expression] = STATE(1952),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3533),
    [sym_pattern_assignment] = STATE(2393),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(251),
    [sym_documentation_comment] = STATE(251),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [252] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2597),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(252),
    [sym_documentation_comment] = STATE(252),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [253] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3173),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(253),
    [sym_documentation_comment] = STATE(253),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [254] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3492),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(254),
    [sym_documentation_comment] = STATE(254),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [255] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3477),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(255),
    [sym_documentation_comment] = STATE(255),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [256] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3219),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(256),
    [sym_documentation_comment] = STATE(256),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [257] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3098),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(257),
    [sym_documentation_comment] = STATE(257),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [258] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3124),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(258),
    [sym_documentation_comment] = STATE(258),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [259] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3442),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(259),
    [sym_documentation_comment] = STATE(259),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [260] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3228),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(260),
    [sym_documentation_comment] = STATE(260),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [261] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2399),
    [sym__real_expression] = STATE(722),
    [sym_throw_expression] = STATE(2393),
    [sym_rethrow_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_assignable_expression] = STATE(1952),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3533),
    [sym_pattern_assignment] = STATE(2393),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(261),
    [sym_documentation_comment] = STATE(261),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [262] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3034),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(262),
    [sym_documentation_comment] = STATE(262),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [263] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2606),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(263),
    [sym_documentation_comment] = STATE(263),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [264] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(1003),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(264),
    [sym_documentation_comment] = STATE(264),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [265] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2415),
    [sym__real_expression] = STATE(722),
    [sym_throw_expression] = STATE(2393),
    [sym_rethrow_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_assignable_expression] = STATE(1952),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3533),
    [sym_pattern_assignment] = STATE(2393),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(265),
    [sym_documentation_comment] = STATE(265),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [266] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3519),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(266),
    [sym_documentation_comment] = STATE(266),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [267] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(945),
    [sym__real_expression] = STATE(481),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1955),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3395),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(267),
    [sym_documentation_comment] = STATE(267),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [268] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(2332),
    [sym__real_expression] = STATE(722),
    [sym_throw_expression] = STATE(2393),
    [sym_rethrow_expression] = STATE(2393),
    [sym_assignment_expression] = STATE(2393),
    [sym_assignable_expression] = STATE(1952),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3533),
    [sym_pattern_assignment] = STATE(2393),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(268),
    [sym_documentation_comment] = STATE(268),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(750),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(752),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [269] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(941),
    [sym__real_expression] = STATE(481),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1955),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3395),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(269),
    [sym_documentation_comment] = STATE(269),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [270] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(951),
    [sym__real_expression] = STATE(481),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1955),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3395),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(270),
    [sym_documentation_comment] = STATE(270),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(748),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [271] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(1262),
    [sym__real_expression] = STATE(510),
    [sym_throw_expression] = STATE(1267),
    [sym_rethrow_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1267),
    [sym_assignable_expression] = STATE(1956),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3409),
    [sym_pattern_assignment] = STATE(1267),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(271),
    [sym_documentation_comment] = STATE(271),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [272] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression] = STATE(3029),
    [sym__real_expression] = STATE(660),
    [sym_throw_expression] = STATE(908),
    [sym_rethrow_expression] = STATE(908),
    [sym_assignment_expression] = STATE(908),
    [sym_assignable_expression] = STATE(1940),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3200),
    [sym_switch_expression] = STATE(962),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3410),
    [sym_pattern_assignment] = STATE(908),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2661),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(272),
    [sym_documentation_comment] = STATE(272),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [sym_rethrow_builtin] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [273] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression] = STATE(1087),
    [sym__real_expression] = STATE(508),
    [sym_throw_expression] = STATE(1186),
    [sym_rethrow_expression] = STATE(1186),
    [sym_assignment_expression] = STATE(1186),
    [sym_assignable_expression] = STATE(1932),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3109),
    [sym_switch_expression] = STATE(1135),
    [sym__parenthesized_pattern] = STATE(3182),
    [sym_list_pattern] = STATE(3182),
    [sym_map_pattern] = STATE(3182),
    [sym_record_pattern] = STATE(3182),
    [sym_object_pattern] = STATE(3182),
    [sym__outer_pattern] = STATE(3287),
    [sym_pattern_assignment] = STATE(1186),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2663),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(273),
    [sym_documentation_comment] = STATE(273),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(724),
    [anon_sym_LBRACK] = ACTIONS(726),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(730),
    [anon_sym_throw] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [sym_rethrow_builtin] = ACTIONS(742),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [274] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1106),
    [sym__real_expression] = STATE(554),
    [sym_throw_expression_without_cascade] = STATE(1159),
    [sym_assignment_expression_without_cascade] = STATE(1159),
    [sym_assignable_expression] = STATE(1960),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(274),
    [sym_documentation_comment] = STATE(274),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [275] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(1966),
    [sym__real_expression] = STATE(757),
    [sym_throw_expression_without_cascade] = STATE(1964),
    [sym_assignment_expression_without_cascade] = STATE(1964),
    [sym_assignable_expression] = STATE(1938),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(275),
    [sym_documentation_comment] = STATE(275),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [276] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(3349),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(276),
    [sym_documentation_comment] = STATE(276),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [277] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(1675),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1710),
    [sym_assignment_expression_without_cascade] = STATE(1710),
    [sym_assignable_expression] = STATE(1951),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(277),
    [sym_documentation_comment] = STATE(277),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(824),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [278] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(3313),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(278),
    [sym_documentation_comment] = STATE(278),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [279] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(3544),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(279),
    [sym_documentation_comment] = STATE(279),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [280] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(1968),
    [sym__real_expression] = STATE(757),
    [sym_throw_expression_without_cascade] = STATE(1964),
    [sym_assignment_expression_without_cascade] = STATE(1964),
    [sym_assignable_expression] = STATE(1938),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(280),
    [sym_documentation_comment] = STATE(280),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [281] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1172),
    [sym__real_expression] = STATE(554),
    [sym_throw_expression_without_cascade] = STATE(1159),
    [sym_assignment_expression_without_cascade] = STATE(1159),
    [sym_assignable_expression] = STATE(1960),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(281),
    [sym_documentation_comment] = STATE(281),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [282] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(1696),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1710),
    [sym_assignment_expression_without_cascade] = STATE(1710),
    [sym_assignable_expression] = STATE(1951),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(282),
    [sym_documentation_comment] = STATE(282),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(824),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [283] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(3330),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(283),
    [sym_documentation_comment] = STATE(283),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [284] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1966),
    [sym__real_expression] = STATE(724),
    [sym_throw_expression_without_cascade] = STATE(1964),
    [sym_assignment_expression_without_cascade] = STATE(1964),
    [sym_assignable_expression] = STATE(1948),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(703),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1345),
    [sym_comment] = STATE(284),
    [sym_documentation_comment] = STATE(284),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [285] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(950),
    [sym__real_expression] = STATE(503),
    [sym_throw_expression_without_cascade] = STATE(905),
    [sym_assignment_expression_without_cascade] = STATE(905),
    [sym_assignable_expression] = STATE(1943),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(285),
    [sym_documentation_comment] = STATE(285),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(834),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [286] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(949),
    [sym__real_expression] = STATE(503),
    [sym_throw_expression_without_cascade] = STATE(905),
    [sym_assignment_expression_without_cascade] = STATE(905),
    [sym_assignable_expression] = STATE(1943),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(286),
    [sym_documentation_comment] = STATE(286),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(834),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [287] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(950),
    [sym__real_expression] = STATE(757),
    [sym_throw_expression_without_cascade] = STATE(905),
    [sym_assignment_expression_without_cascade] = STATE(905),
    [sym_assignable_expression] = STATE(1949),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(287),
    [sym_documentation_comment] = STATE(287),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [288] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(935),
    [sym__real_expression] = STATE(757),
    [sym_throw_expression_without_cascade] = STATE(905),
    [sym_assignment_expression_without_cascade] = STATE(905),
    [sym_assignable_expression] = STATE(1949),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(288),
    [sym_documentation_comment] = STATE(288),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [289] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(3471),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(289),
    [sym_documentation_comment] = STATE(289),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [290] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(935),
    [sym__real_expression] = STATE(503),
    [sym_throw_expression_without_cascade] = STATE(905),
    [sym_assignment_expression_without_cascade] = STATE(905),
    [sym_assignable_expression] = STATE(1943),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(290),
    [sym_documentation_comment] = STATE(290),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(834),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [291] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(1485),
    [sym__real_expression] = STATE(683),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1936),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(291),
    [sym_documentation_comment] = STATE(291),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [292] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(1484),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(292),
    [sym_documentation_comment] = STATE(292),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [293] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(990),
    [sym__real_expression] = STATE(683),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1936),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(293),
    [sym_documentation_comment] = STATE(293),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [294] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(3468),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(294),
    [sym_documentation_comment] = STATE(294),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [295] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(949),
    [sym__real_expression] = STATE(757),
    [sym_throw_expression_without_cascade] = STATE(905),
    [sym_assignment_expression_without_cascade] = STATE(905),
    [sym_assignable_expression] = STATE(1949),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(295),
    [sym_documentation_comment] = STATE(295),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [296] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1146),
    [sym__real_expression] = STATE(554),
    [sym_throw_expression_without_cascade] = STATE(1159),
    [sym_assignment_expression_without_cascade] = STATE(1159),
    [sym_assignable_expression] = STATE(1960),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(296),
    [sym_documentation_comment] = STATE(296),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [297] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1968),
    [sym__real_expression] = STATE(724),
    [sym_throw_expression_without_cascade] = STATE(1964),
    [sym_assignment_expression_without_cascade] = STATE(1964),
    [sym_assignable_expression] = STATE(1948),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(703),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1345),
    [sym_comment] = STATE(297),
    [sym_documentation_comment] = STATE(297),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [298] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(990),
    [sym__real_expression] = STATE(503),
    [sym_throw_expression_without_cascade] = STATE(905),
    [sym_assignment_expression_without_cascade] = STATE(905),
    [sym_assignable_expression] = STATE(1943),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1338),
    [sym_comment] = STATE(298),
    [sym_documentation_comment] = STATE(298),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(834),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [299] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1596),
    [sym__real_expression] = STATE(724),
    [sym_throw_expression_without_cascade] = STATE(1573),
    [sym_assignment_expression_without_cascade] = STATE(1573),
    [sym_assignable_expression] = STATE(1939),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(703),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1345),
    [sym_comment] = STATE(299),
    [sym_documentation_comment] = STATE(299),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [300] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1578),
    [sym__real_expression] = STATE(724),
    [sym_throw_expression_without_cascade] = STATE(1573),
    [sym_assignment_expression_without_cascade] = STATE(1573),
    [sym_assignable_expression] = STATE(1939),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(703),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1345),
    [sym_comment] = STATE(300),
    [sym_documentation_comment] = STATE(300),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [301] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(1967),
    [sym__real_expression] = STATE(757),
    [sym_throw_expression_without_cascade] = STATE(1964),
    [sym_assignment_expression_without_cascade] = STATE(1964),
    [sym_assignable_expression] = STATE(1938),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(648),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1339),
    [sym_comment] = STATE(301),
    [sym_documentation_comment] = STATE(301),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(772),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [302] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1591),
    [sym__real_expression] = STATE(724),
    [sym_throw_expression_without_cascade] = STATE(1573),
    [sym_assignment_expression_without_cascade] = STATE(1573),
    [sym_assignable_expression] = STATE(1939),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(703),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1345),
    [sym_comment] = STATE(302),
    [sym_documentation_comment] = STATE(302),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [303] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(1493),
    [sym__real_expression] = STATE(683),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1936),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(303),
    [sym_documentation_comment] = STATE(303),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [304] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(1682),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1710),
    [sym_assignment_expression_without_cascade] = STATE(1710),
    [sym_assignable_expression] = STATE(1951),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(304),
    [sym_documentation_comment] = STATE(304),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(824),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [305] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__expression_without_cascade] = STATE(1493),
    [sym__real_expression] = STATE(754),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1931),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(716),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(717),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1335),
    [sym_comment] = STATE(305),
    [sym_documentation_comment] = STATE(305),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_throw] = ACTIONS(810),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [306] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1091),
    [sym__real_expression] = STATE(554),
    [sym_throw_expression_without_cascade] = STATE(1159),
    [sym_assignment_expression_without_cascade] = STATE(1159),
    [sym_assignable_expression] = STATE(1960),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(690),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1344),
    [sym_comment] = STATE(306),
    [sym_documentation_comment] = STATE(306),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [307] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__expression_without_cascade] = STATE(1967),
    [sym__real_expression] = STATE(724),
    [sym_throw_expression_without_cascade] = STATE(1964),
    [sym_assignment_expression_without_cascade] = STATE(1964),
    [sym_assignable_expression] = STATE(1948),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(703),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(699),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1345),
    [sym_comment] = STATE(307),
    [sym_documentation_comment] = STATE(307),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_throw] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [308] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__expression_without_cascade] = STATE(1484),
    [sym__real_expression] = STATE(683),
    [sym_throw_expression_without_cascade] = STATE(1497),
    [sym_assignment_expression_without_cascade] = STATE(1497),
    [sym_assignable_expression] = STATE(1936),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(668),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(643),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1337),
    [sym_comment] = STATE(308),
    [sym_documentation_comment] = STATE(308),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(764),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [309] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(770),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(309),
    [sym_documentation_comment] = STATE(309),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [310] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(785),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(310),
    [sym_documentation_comment] = STATE(310),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [311] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(689),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(311),
    [sym_documentation_comment] = STATE(311),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [312] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(718),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(312),
    [sym_documentation_comment] = STATE(312),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [313] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(704),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(313),
    [sym_documentation_comment] = STATE(313),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [314] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(569),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(314),
    [sym_documentation_comment] = STATE(314),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [315] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(698),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(315),
    [sym_documentation_comment] = STATE(315),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [316] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(688),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(316),
    [sym_documentation_comment] = STATE(316),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [317] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(572),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(317),
    [sym_documentation_comment] = STATE(317),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [318] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(686),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(318),
    [sym_documentation_comment] = STATE(318),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [319] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(553),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(319),
    [sym_documentation_comment] = STATE(319),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [320] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(697),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(320),
    [sym_documentation_comment] = STATE(320),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [321] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(574),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(321),
    [sym_documentation_comment] = STATE(321),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [322] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(782),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(322),
    [sym_documentation_comment] = STATE(322),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [323] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(721),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(323),
    [sym_documentation_comment] = STATE(323),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [324] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(776),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(324),
    [sym_documentation_comment] = STATE(324),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [325] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(726),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(325),
    [sym_documentation_comment] = STATE(325),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [326] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(725),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(326),
    [sym_documentation_comment] = STATE(326),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [327] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(694),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(327),
    [sym_documentation_comment] = STATE(327),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [328] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(692),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(328),
    [sym_documentation_comment] = STATE(328),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [329] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(506),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(329),
    [sym_documentation_comment] = STATE(329),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [330] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(700),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(330),
    [sym_documentation_comment] = STATE(330),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [331] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(756),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(331),
    [sym_documentation_comment] = STATE(331),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [332] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(695),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(332),
    [sym_documentation_comment] = STATE(332),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [333] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(564),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(333),
    [sym_documentation_comment] = STATE(333),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [334] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(559),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(334),
    [sym_documentation_comment] = STATE(334),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [335] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(778),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(335),
    [sym_documentation_comment] = STATE(335),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [336] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(557),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(336),
    [sym_documentation_comment] = STATE(336),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [337] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(555),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(337),
    [sym_documentation_comment] = STATE(337),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [338] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(775),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(338),
    [sym_documentation_comment] = STATE(338),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [339] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(780),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(339),
    [sym_documentation_comment] = STATE(339),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [340] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(761),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(340),
    [sym_documentation_comment] = STATE(340),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [341] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(502),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(341),
    [sym_documentation_comment] = STATE(341),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [342] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(562),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(342),
    [sym_documentation_comment] = STATE(342),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [343] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(495),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(343),
    [sym_documentation_comment] = STATE(343),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [344] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(773),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(344),
    [sym_documentation_comment] = STATE(344),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [345] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(762),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(345),
    [sym_documentation_comment] = STATE(345),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [346] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(769),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(346),
    [sym_documentation_comment] = STATE(346),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [347] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(765),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(347),
    [sym_documentation_comment] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [348] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(760),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(348),
    [sym_documentation_comment] = STATE(348),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [349] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(755),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(349),
    [sym_documentation_comment] = STATE(349),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [350] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(500),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(350),
    [sym_documentation_comment] = STATE(350),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [351] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(779),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(351),
    [sym_documentation_comment] = STATE(351),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [352] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(723),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(352),
    [sym_documentation_comment] = STATE(352),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [353] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(790),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(1477),
    [sym_conditional_expression] = STATE(1477),
    [sym_logical_or_expression] = STATE(1477),
    [sym_logical_and_expression] = STATE(1477),
    [sym_equality_expression] = STATE(1477),
    [sym_type_cast_expression] = STATE(1477),
    [sym_type_test_expression] = STATE(1477),
    [sym_relational_expression] = STATE(1477),
    [sym_bitwise_or_expression] = STATE(1477),
    [sym_bitwise_xor_expression] = STATE(1477),
    [sym_bitwise_and_expression] = STATE(1477),
    [sym_shift_expression] = STATE(1477),
    [sym_additive_expression] = STATE(1477),
    [sym_multiplicative_expression] = STATE(1477),
    [sym__unary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1322),
    [sym_comment] = STATE(353),
    [sym_documentation_comment] = STATE(353),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [354] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(727),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(354),
    [sym_documentation_comment] = STATE(354),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [355] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(720),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(355),
    [sym_documentation_comment] = STATE(355),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [356] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(753),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(356),
    [sym_documentation_comment] = STATE(356),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [357] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(713),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(357),
    [sym_documentation_comment] = STATE(357),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [358] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(767),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(358),
    [sym_documentation_comment] = STATE(358),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [359] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(772),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(359),
    [sym_documentation_comment] = STATE(359),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [360] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(768),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1343),
    [sym_comment] = STATE(360),
    [sym_documentation_comment] = STATE(360),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [361] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(763),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(361),
    [sym_documentation_comment] = STATE(361),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [362] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(702),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(362),
    [sym_documentation_comment] = STATE(362),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [363] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(714),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(363),
    [sym_documentation_comment] = STATE(363),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [364] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(558),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1117),
    [sym_conditional_expression] = STATE(1117),
    [sym_logical_or_expression] = STATE(1117),
    [sym_logical_and_expression] = STATE(1117),
    [sym_equality_expression] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_type_test_expression] = STATE(1117),
    [sym_relational_expression] = STATE(1117),
    [sym_bitwise_or_expression] = STATE(1117),
    [sym_bitwise_xor_expression] = STATE(1117),
    [sym_bitwise_and_expression] = STATE(1117),
    [sym_shift_expression] = STATE(1117),
    [sym_additive_expression] = STATE(1117),
    [sym_multiplicative_expression] = STATE(1117),
    [sym__unary_expression] = STATE(902),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1346),
    [sym_comment] = STATE(364),
    [sym_documentation_comment] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [365] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(504),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(365),
    [sym_documentation_comment] = STATE(365),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [366] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(507),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(366),
    [sym_documentation_comment] = STATE(366),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [367] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(715),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(367),
    [sym_documentation_comment] = STATE(367),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [368] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(494),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(368),
    [sym_documentation_comment] = STATE(368),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [369] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym__real_expression] = STATE(771),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym_if_null_expression] = STATE(1679),
    [sym_conditional_expression] = STATE(1679),
    [sym_logical_or_expression] = STATE(1679),
    [sym_logical_and_expression] = STATE(1679),
    [sym_equality_expression] = STATE(1679),
    [sym_type_cast_expression] = STATE(1679),
    [sym_type_test_expression] = STATE(1679),
    [sym_relational_expression] = STATE(1679),
    [sym_bitwise_or_expression] = STATE(1679),
    [sym_bitwise_xor_expression] = STATE(1679),
    [sym_bitwise_and_expression] = STATE(1679),
    [sym_shift_expression] = STATE(1679),
    [sym_additive_expression] = STATE(1679),
    [sym_multiplicative_expression] = STATE(1679),
    [sym__unary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(1347),
    [sym_comment] = STATE(369),
    [sym_documentation_comment] = STATE(369),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [370] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym__real_expression] = STATE(693),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym_if_null_expression] = STATE(1609),
    [sym_conditional_expression] = STATE(1609),
    [sym_logical_or_expression] = STATE(1609),
    [sym_logical_and_expression] = STATE(1609),
    [sym_equality_expression] = STATE(1609),
    [sym_type_cast_expression] = STATE(1609),
    [sym_type_test_expression] = STATE(1609),
    [sym_relational_expression] = STATE(1609),
    [sym_bitwise_or_expression] = STATE(1609),
    [sym_bitwise_xor_expression] = STATE(1609),
    [sym_bitwise_and_expression] = STATE(1609),
    [sym_shift_expression] = STATE(1609),
    [sym_additive_expression] = STATE(1609),
    [sym_multiplicative_expression] = STATE(1609),
    [sym__unary_expression] = STATE(1260),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(1342),
    [sym_comment] = STATE(370),
    [sym_documentation_comment] = STATE(370),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [371] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(498),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(371),
    [sym_documentation_comment] = STATE(371),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [372] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(501),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(372),
    [sym_documentation_comment] = STATE(372),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [373] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym__real_expression] = STATE(505),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym_if_null_expression] = STATE(996),
    [sym_conditional_expression] = STATE(996),
    [sym_logical_or_expression] = STATE(996),
    [sym_logical_and_expression] = STATE(996),
    [sym_equality_expression] = STATE(996),
    [sym_type_cast_expression] = STATE(996),
    [sym_type_test_expression] = STATE(996),
    [sym_relational_expression] = STATE(996),
    [sym_bitwise_or_expression] = STATE(996),
    [sym_bitwise_xor_expression] = STATE(996),
    [sym_bitwise_and_expression] = STATE(996),
    [sym_shift_expression] = STATE(996),
    [sym_additive_expression] = STATE(996),
    [sym_multiplicative_expression] = STATE(996),
    [sym__unary_expression] = STATE(787),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(1340),
    [sym_comment] = STATE(373),
    [sym_documentation_comment] = STATE(373),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [374] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(2681),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym_switch_statement_case] = STATE(2665),
    [sym_switch_statement_default] = STATE(3420),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym_case_builtin] = STATE(409),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_label] = STATE(2691),
    [sym_comment] = STATE(374),
    [sym_documentation_comment] = STATE(374),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [aux_sym_switch_block_repeat1] = STATE(2168),
    [aux_sym_switch_statement_case_repeat1] = STATE(2476),
    [sym_identifier] = ACTIONS(848),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(878),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_default] = ACTIONS(890),
    [anon_sym_case] = ACTIONS(892),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [375] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3257),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(375),
    [sym_documentation_comment] = STATE(375),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_POUND] = ACTIONS(899),
    [sym_decimal_integer_literal] = ACTIONS(902),
    [sym_hex_integer_literal] = ACTIONS(905),
    [sym_decimal_floating_point_literal] = ACTIONS(902),
    [anon_sym_true] = ACTIONS(908),
    [anon_sym_false] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(914),
    [anon_sym_SQUOTE] = ACTIONS(917),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(920),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(923),
    [anon_sym_r_DQUOTE] = ACTIONS(926),
    [anon_sym_r_SQUOTE] = ACTIONS(929),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(932),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_LBRACK] = ACTIONS(941),
    [anon_sym_null] = ACTIONS(944),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_throw] = ACTIONS(950),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_increment_operator] = ACTIONS(955),
    [sym_minus_operator] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(950),
    [anon_sym_TILDE] = ACTIONS(955),
    [anon_sym_await] = ACTIONS(950),
    [anon_sym_switch] = ACTIONS(950),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_rethrow_builtin] = ACTIONS(950),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_new] = ACTIONS(950),
    [sym_const_builtin] = ACTIONS(960),
    [anon_sym_this] = ACTIONS(950),
    [anon_sym_super] = ACTIONS(950),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [376] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3114),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(2754),
    [sym_object_pattern] = STATE(2102),
    [sym_annotation] = STATE(1361),
    [sym__metadata] = STATE(2088),
    [sym__type] = STATE(2984),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym_record_type_field] = STATE(2827),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(376),
    [sym_documentation_comment] = STATE(376),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [sym_identifier] = ACTIONS(963),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_RPAREN] = ACTIONS(488),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [377] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym__list_pattern_element] = STATE(3268),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(377),
    [sym_documentation_comment] = STATE(377),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_RBRACK] = ACTIONS(969),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [378] = {
    [sym_comment] = STATE(378),
    [sym_documentation_comment] = STATE(378),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_POUND] = ACTIONS(975),
    [sym_decimal_integer_literal] = ACTIONS(973),
    [sym_hex_integer_literal] = ACTIONS(975),
    [sym_decimal_floating_point_literal] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(973),
    [anon_sym_false] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_r_DQUOTE] = ACTIONS(973),
    [anon_sym_r_SQUOTE] = ACTIONS(973),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(980),
    [anon_sym_COLON] = ACTIONS(980),
    [anon_sym_null] = ACTIONS(973),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_EQ] = ACTIONS(982),
    [anon_sym_QMARK_QMARK] = ACTIONS(980),
    [anon_sym_QMARK] = ACTIONS(984),
    [sym_equality_operator] = ACTIONS(980),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_LT_EQ] = ACTIONS(980),
    [anon_sym_GT_EQ] = ACTIONS(980),
    [anon_sym_PIPE] = ACTIONS(984),
    [anon_sym_CARET] = ACTIONS(980),
    [anon_sym_AMP] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(980),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_GT_GT_GT] = ACTIONS(980),
    [sym__additive_operator] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_SLASH] = ACTIONS(984),
    [anon_sym_PERCENT] = ACTIONS(980),
    [anon_sym_TILDE_SLASH] = ACTIONS(980),
    [sym_increment_operator] = ACTIONS(975),
    [sym_minus_operator] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(973),
    [anon_sym_is] = ACTIONS(984),
    [anon_sym_as] = ACTIONS(984),
    [anon_sym_DOT] = ACTIONS(984),
    [anon_sym_QMARK_DOT] = ACTIONS(984),
    [anon_sym_DOT_DOT] = ACTIONS(980),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(980),
    [anon_sym_SEMI] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(973),
    [anon_sym_do] = ACTIONS(973),
    [anon_sym_while] = ACTIONS(973),
    [anon_sym_continue] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(973),
    [anon_sym_return] = ACTIONS(973),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(986),
    [anon_sym_for] = ACTIONS(973),
    [anon_sym_AT] = ACTIONS(975),
    [anon_sym_final] = ACTIONS(973),
    [sym_void_type] = ACTIONS(973),
    [anon_sym_var] = ACTIONS(973),
    [sym_break_builtin] = ACTIONS(973),
    [sym_assert_builtin] = ACTIONS(973),
    [sym_rethrow_builtin] = ACTIONS(973),
    [anon_sym_covariant] = ACTIONS(973),
    [anon_sym_Function] = ACTIONS(973),
    [anon_sym_get] = ACTIONS(973),
    [anon_sym_set] = ACTIONS(973),
    [anon_sym_new] = ACTIONS(973),
    [anon_sym_AMP_AMP] = ACTIONS(980),
    [anon_sym_PIPE_PIPE] = ACTIONS(980),
    [sym_const_builtin] = ACTIONS(973),
    [anon_sym_late] = ACTIONS(973),
    [anon_sym_this] = ACTIONS(973),
    [anon_sym_super] = ACTIONS(973),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [379] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym__list_pattern_element] = STATE(2972),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(379),
    [sym_documentation_comment] = STATE(379),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_RBRACK] = ACTIONS(989),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [380] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym__list_pattern_element] = STATE(3268),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(380),
    [sym_documentation_comment] = STATE(380),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_RBRACK] = ACTIONS(991),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [381] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym__list_pattern_element] = STATE(3268),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(381),
    [sym_documentation_comment] = STATE(381),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_RBRACK] = ACTIONS(993),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [382] = {
    [sym_comment] = STATE(382),
    [sym_documentation_comment] = STATE(382),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_POUND] = ACTIONS(975),
    [sym_decimal_integer_literal] = ACTIONS(973),
    [sym_hex_integer_literal] = ACTIONS(975),
    [sym_decimal_floating_point_literal] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(973),
    [anon_sym_false] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_r_DQUOTE] = ACTIONS(973),
    [anon_sym_r_SQUOTE] = ACTIONS(973),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(977),
    [anon_sym_null] = ACTIONS(973),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_EQ] = ACTIONS(982),
    [anon_sym_QMARK_QMARK] = ACTIONS(980),
    [anon_sym_QMARK] = ACTIONS(984),
    [sym_equality_operator] = ACTIONS(980),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_LT_EQ] = ACTIONS(980),
    [anon_sym_GT_EQ] = ACTIONS(980),
    [anon_sym_PIPE] = ACTIONS(984),
    [anon_sym_CARET] = ACTIONS(980),
    [anon_sym_AMP] = ACTIONS(984),
    [anon_sym_LT_LT] = ACTIONS(980),
    [anon_sym_GT_GT] = ACTIONS(984),
    [anon_sym_GT_GT_GT] = ACTIONS(980),
    [sym__additive_operator] = ACTIONS(984),
    [anon_sym_STAR] = ACTIONS(980),
    [anon_sym_SLASH] = ACTIONS(984),
    [anon_sym_PERCENT] = ACTIONS(980),
    [anon_sym_TILDE_SLASH] = ACTIONS(980),
    [sym_increment_operator] = ACTIONS(975),
    [sym_minus_operator] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(986),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(973),
    [anon_sym_is] = ACTIONS(984),
    [anon_sym_as] = ACTIONS(984),
    [anon_sym_DOT] = ACTIONS(984),
    [anon_sym_QMARK_DOT] = ACTIONS(984),
    [anon_sym_DOT_DOT] = ACTIONS(980),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(980),
    [anon_sym_SEMI] = ACTIONS(980),
    [anon_sym_switch] = ACTIONS(973),
    [anon_sym_default] = ACTIONS(973),
    [anon_sym_do] = ACTIONS(973),
    [anon_sym_while] = ACTIONS(973),
    [anon_sym_continue] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(973),
    [anon_sym_return] = ACTIONS(973),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(973),
    [anon_sym_AT] = ACTIONS(975),
    [anon_sym_final] = ACTIONS(973),
    [sym_void_type] = ACTIONS(973),
    [anon_sym_var] = ACTIONS(973),
    [sym_break_builtin] = ACTIONS(973),
    [sym_assert_builtin] = ACTIONS(973),
    [sym_rethrow_builtin] = ACTIONS(973),
    [anon_sym_covariant] = ACTIONS(973),
    [anon_sym_Function] = ACTIONS(973),
    [anon_sym_get] = ACTIONS(973),
    [anon_sym_set] = ACTIONS(973),
    [anon_sym_new] = ACTIONS(973),
    [anon_sym_AMP_AMP] = ACTIONS(980),
    [anon_sym_PIPE_PIPE] = ACTIONS(980),
    [sym_const_builtin] = ACTIONS(973),
    [anon_sym_late] = ACTIONS(973),
    [anon_sym_this] = ACTIONS(973),
    [anon_sym_super] = ACTIONS(973),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [383] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym__list_pattern_element] = STATE(2771),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(383),
    [sym_documentation_comment] = STATE(383),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_RBRACK] = ACTIONS(995),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [384] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(3184),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(384),
    [sym_documentation_comment] = STATE(384),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_RPAREN] = ACTIONS(999),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [385] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(385),
    [sym_documentation_comment] = STATE(385),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [386] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(386),
    [sym_documentation_comment] = STATE(386),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [387] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(387),
    [sym_documentation_comment] = STATE(387),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [388] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(3184),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(388),
    [sym_documentation_comment] = STATE(388),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_RPAREN] = ACTIONS(1007),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [389] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(3184),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(389),
    [sym_documentation_comment] = STATE(389),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [390] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(390),
    [sym_documentation_comment] = STATE(390),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [391] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(3184),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(391),
    [sym_documentation_comment] = STATE(391),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_RPAREN] = ACTIONS(1013),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [392] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(392),
    [sym_documentation_comment] = STATE(392),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [393] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(393),
    [sym_documentation_comment] = STATE(393),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [394] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3099),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym__list_pattern_element] = STATE(3268),
    [sym_rest_pattern] = STATE(3099),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(394),
    [sym_documentation_comment] = STATE(394),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(971),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [395] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(395),
    [sym_documentation_comment] = STATE(395),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [396] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(3184),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(396),
    [sym_documentation_comment] = STATE(396),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [397] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(397),
    [sym_documentation_comment] = STATE(397),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [398] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(2877),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(398),
    [sym_documentation_comment] = STATE(398),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [399] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(2925),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(399),
    [sym_documentation_comment] = STATE(399),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [400] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(2904),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(400),
    [sym_documentation_comment] = STATE(400),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [401] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(2681),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(401),
    [sym_documentation_comment] = STATE(401),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [402] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(2980),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(402),
    [sym_documentation_comment] = STATE(402),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [403] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3168),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(403),
    [sym_documentation_comment] = STATE(403),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [404] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(2792),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(404),
    [sym_documentation_comment] = STATE(404),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [405] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3014),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym__pattern_field] = STATE(3184),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(405),
    [sym_documentation_comment] = STATE(405),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [406] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym_switch_expression_case] = STATE(3269),
    [sym__guarded_pattern] = STATE(3408),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(406),
    [sym_documentation_comment] = STATE(406),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [407] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__guarded_pattern] = STATE(3286),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(407),
    [sym_documentation_comment] = STATE(407),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [408] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__guarded_pattern] = STATE(3451),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(408),
    [sym_documentation_comment] = STATE(408),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [409] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__guarded_pattern] = STATE(3467),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(409),
    [sym_documentation_comment] = STATE(409),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [410] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(410),
    [sym_documentation_comment] = STATE(410),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [411] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(411),
    [sym_documentation_comment] = STATE(411),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [412] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__guarded_pattern] = STATE(3285),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(412),
    [sym_documentation_comment] = STATE(412),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [413] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(413),
    [sym_documentation_comment] = STATE(413),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [414] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(414),
    [sym_documentation_comment] = STATE(414),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [415] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__guarded_pattern] = STATE(3456),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(415),
    [sym_documentation_comment] = STATE(415),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [416] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__guarded_pattern] = STATE(3280),
    [sym__pattern] = STATE(2666),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(416),
    [sym_documentation_comment] = STATE(416),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [417] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym__unary_expression] = STATE(1154),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(2635),
    [sym_comment] = STATE(417),
    [sym_documentation_comment] = STATE(417),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [418] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3159),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(418),
    [sym_documentation_comment] = STATE(418),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [419] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(419),
    [sym_documentation_comment] = STATE(419),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [420] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym__unary_expression] = STATE(1482),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(2609),
    [sym_comment] = STATE(420),
    [sym_documentation_comment] = STATE(420),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [421] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(969),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(421),
    [sym_documentation_comment] = STATE(421),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [422] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3191),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(422),
    [sym_documentation_comment] = STATE(422),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [423] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__pattern] = STATE(3257),
    [sym__logical_or_pattern] = STATE(2373),
    [sym__logical_and_pattern] = STATE(2152),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(423),
    [sym_documentation_comment] = STATE(423),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [424] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(1313),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(424),
    [sym_documentation_comment] = STATE(424),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [425] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym__unary_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(2635),
    [sym_comment] = STATE(425),
    [sym_documentation_comment] = STATE(425),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [426] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym__unary_expression] = STATE(1488),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(2609),
    [sym_comment] = STATE(426),
    [sym_documentation_comment] = STATE(426),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [427] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(926),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(427),
    [sym_documentation_comment] = STATE(427),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [428] = {
    [sym__bool_literal] = STATE(1279),
    [sym__numeric_literal] = STATE(1279),
    [sym__literal] = STATE(1278),
    [sym_symbol_literal] = STATE(1279),
    [sym_true] = STATE(1275),
    [sym_false] = STATE(1275),
    [sym_string_literal] = STATE(1279),
    [sym__string_literal_double_quotes] = STATE(799),
    [sym__string_literal_single_quotes] = STATE(799),
    [sym__string_literal_double_quotes_multiple] = STATE(799),
    [sym__string_literal_single_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_double_quotes] = STATE(799),
    [sym__raw_string_literal_single_quotes] = STATE(799),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(799),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(799),
    [sym_list_literal] = STATE(1279),
    [sym_set_or_map_literal] = STATE(1279),
    [sym_null_literal] = STATE(1279),
    [sym_record_literal] = STATE(1279),
    [sym__record_literal_no_const] = STATE(1268),
    [sym_assignable_expression] = STATE(3162),
    [sym_function_expression] = STATE(1278),
    [sym__unary_expression] = STATE(1487),
    [sym_unary_expression] = STATE(1480),
    [sym__postfix_expression] = STATE(1480),
    [sym_postfix_expression] = STATE(1481),
    [sym_prefix_operator] = STATE(428),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1387),
    [sym_await_expression] = STATE(1483),
    [sym_new_expression] = STATE(1278),
    [sym_const_object_expression] = STATE(1278),
    [sym__primary] = STATE(719),
    [sym_parenthesized_expression] = STATE(1278),
    [sym_constructor_invocation] = STATE(728),
    [sym_constructor_tearoff] = STATE(1278),
    [sym_type_arguments] = STATE(3100),
    [sym_switch_expression] = STATE(1278),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2949),
    [sym__formal_parameter_part] = STATE(2342),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2091),
    [sym_this] = STATE(1278),
    [sym_super] = STATE(2609),
    [sym_comment] = STATE(428),
    [sym_documentation_comment] = STATE(428),
    [aux_sym_string_literal_repeat1] = STATE(609),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_POUND] = ACTIONS(776),
    [sym_decimal_integer_literal] = ACTIONS(778),
    [sym_hex_integer_literal] = ACTIONS(780),
    [sym_decimal_floating_point_literal] = ACTIONS(778),
    [anon_sym_true] = ACTIONS(782),
    [anon_sym_false] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(786),
    [anon_sym_SQUOTE] = ACTIONS(788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(790),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(792),
    [anon_sym_r_DQUOTE] = ACTIONS(794),
    [anon_sym_r_SQUOTE] = ACTIONS(796),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(798),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_null] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(808),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(812),
    [sym_minus_operator] = ACTIONS(814),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(816),
    [anon_sym_switch] = ACTIONS(818),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(820),
    [anon_sym_this] = ACTIONS(822),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [429] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3070),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(968),
    [sym_unary_expression] = STATE(994),
    [sym__postfix_expression] = STATE(994),
    [sym_postfix_expression] = STATE(993),
    [sym_prefix_operator] = STATE(421),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1357),
    [sym_await_expression] = STATE(991),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(659),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(429),
    [sym_documentation_comment] = STATE(429),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(688),
    [sym_minus_operator] = ACTIONS(690),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [430] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym__unary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(2635),
    [sym_comment] = STATE(430),
    [sym_documentation_comment] = STATE(430),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [431] = {
    [sym__bool_literal] = STATE(989),
    [sym__numeric_literal] = STATE(989),
    [sym__literal] = STATE(962),
    [sym_symbol_literal] = STATE(989),
    [sym_true] = STATE(900),
    [sym_false] = STATE(900),
    [sym_string_literal] = STATE(989),
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_list_literal] = STATE(989),
    [sym_set_or_map_literal] = STATE(989),
    [sym_null_literal] = STATE(989),
    [sym_record_literal] = STATE(989),
    [sym__record_literal_no_const] = STATE(924),
    [sym_assignable_expression] = STATE(3122),
    [sym_function_expression] = STATE(962),
    [sym__unary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1303),
    [sym__postfix_expression] = STATE(1303),
    [sym_postfix_expression] = STATE(1301),
    [sym_prefix_operator] = STATE(431),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1385),
    [sym_await_expression] = STATE(1302),
    [sym_new_expression] = STATE(962),
    [sym_const_object_expression] = STATE(962),
    [sym__primary] = STATE(674),
    [sym_parenthesized_expression] = STATE(962),
    [sym_constructor_invocation] = STATE(654),
    [sym_constructor_tearoff] = STATE(962),
    [sym_type_arguments] = STATE(3146),
    [sym_switch_expression] = STATE(962),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2859),
    [sym__formal_parameter_part] = STATE(2339),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2079),
    [sym_this] = STATE(962),
    [sym_super] = STATE(2594),
    [sym_comment] = STATE(431),
    [sym_documentation_comment] = STATE(431),
    [aux_sym_string_literal_repeat1] = STATE(474),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_POUND] = ACTIONS(73),
    [sym_decimal_integer_literal] = ACTIONS(75),
    [sym_hex_integer_literal] = ACTIONS(77),
    [sym_decimal_floating_point_literal] = ACTIONS(75),
    [anon_sym_true] = ACTIONS(79),
    [anon_sym_false] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(768),
    [anon_sym_null] = ACTIONS(105),
    [anon_sym_LPAREN] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(113),
    [sym_minus_operator] = ACTIONS(117),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(432),
    [anon_sym_switch] = ACTIONS(412),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(478),
    [anon_sym_this] = ACTIONS(159),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [432] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym__unary_expression] = STATE(1382),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(2635),
    [sym_comment] = STATE(432),
    [sym_documentation_comment] = STATE(432),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [433] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym_assignable_expression] = STATE(3194),
    [sym_function_expression] = STATE(1135),
    [sym__unary_expression] = STATE(1381),
    [sym_unary_expression] = STATE(1391),
    [sym__postfix_expression] = STATE(1391),
    [sym_postfix_expression] = STATE(1390),
    [sym_prefix_operator] = STATE(432),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1394),
    [sym_await_expression] = STATE(1389),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(684),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(2635),
    [sym_comment] = STATE(433),
    [sym_documentation_comment] = STATE(433),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(828),
    [sym_minus_operator] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [434] = {
    [sym__bool_literal] = STATE(1115),
    [sym__numeric_literal] = STATE(1115),
    [sym__literal] = STATE(1135),
    [sym_symbol_literal] = STATE(1115),
    [sym_true] = STATE(1165),
    [sym_false] = STATE(1165),
    [sym_string_literal] = STATE(1115),
    [sym__string_literal_double_quotes] = STATE(729),
    [sym__string_literal_single_quotes] = STATE(729),
    [sym__string_literal_double_quotes_multiple] = STATE(729),
    [sym__string_literal_single_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_double_quotes] = STATE(729),
    [sym__raw_string_literal_single_quotes] = STATE(729),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(729),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(729),
    [sym_list_literal] = STATE(1115),
    [sym_set_or_map_literal] = STATE(1115),
    [sym_null_literal] = STATE(1115),
    [sym_record_literal] = STATE(1115),
    [sym__record_literal_no_const] = STATE(1187),
    [sym_assignable_expression] = STATE(3249),
    [sym_function_expression] = STATE(1135),
    [sym__unary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1114),
    [sym__postfix_expression] = STATE(1114),
    [sym_postfix_expression] = STATE(1098),
    [sym_prefix_operator] = STATE(417),
    [sym_negation_operator] = STATE(1450),
    [sym__exclamation_operator] = STATE(1451),
    [sym_tilde_operator] = STATE(1359),
    [sym_await_expression] = STATE(1093),
    [sym_new_expression] = STATE(1135),
    [sym_const_object_expression] = STATE(1135),
    [sym__primary] = STATE(701),
    [sym_parenthesized_expression] = STATE(1135),
    [sym_constructor_invocation] = STATE(691),
    [sym_constructor_tearoff] = STATE(1135),
    [sym_type_arguments] = STATE(3081),
    [sym_switch_expression] = STATE(1135),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2826),
    [sym__formal_parameter_part] = STATE(2358),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2074),
    [sym_this] = STATE(1135),
    [sym_super] = STATE(2635),
    [sym_comment] = STATE(434),
    [sym_documentation_comment] = STATE(434),
    [aux_sym_string_literal_repeat1] = STATE(595),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_POUND] = ACTIONS(698),
    [sym_decimal_integer_literal] = ACTIONS(700),
    [sym_hex_integer_literal] = ACTIONS(702),
    [sym_decimal_floating_point_literal] = ACTIONS(700),
    [anon_sym_true] = ACTIONS(704),
    [anon_sym_false] = ACTIONS(706),
    [anon_sym_DQUOTE] = ACTIONS(708),
    [anon_sym_SQUOTE] = ACTIONS(710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(712),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(714),
    [anon_sym_r_DQUOTE] = ACTIONS(716),
    [anon_sym_r_SQUOTE] = ACTIONS(718),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(720),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(722),
    [anon_sym_LBRACE] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_null] = ACTIONS(728),
    [anon_sym_LPAREN] = ACTIONS(760),
    [anon_sym_LT] = ACTIONS(111),
    [sym_increment_operator] = ACTIONS(734),
    [sym_minus_operator] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(119),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_await] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(740),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(744),
    [anon_sym_this] = ACTIONS(746),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [435] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_import_or_export] = STATE(1572),
    [sym_library_import] = STATE(1577),
    [sym_library_export] = STATE(1577),
    [sym_import_specification] = STATE(1581),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(550),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym_library_name] = STATE(441),
    [sym__export] = STATE(1869),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym__import] = STATE(1817),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(435),
    [sym_documentation_comment] = STATE(435),
    [aux_sym_program_repeat1] = STATE(440),
    [aux_sym_program_repeat2] = STATE(452),
    [aux_sym_program_repeat3] = STATE(462),
    [aux_sym_program_repeat4] = STATE(476),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_library] = ACTIONS(39),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_export] = ACTIONS(43),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [436] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__logical_and_pattern] = STATE(2308),
    [sym__relational_pattern] = STATE(2147),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(436),
    [sym_documentation_comment] = STATE(436),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [437] = {
    [sym__bool_literal] = STATE(2124),
    [sym__numeric_literal] = STATE(2124),
    [sym_symbol_literal] = STATE(2124),
    [sym_true] = STATE(2120),
    [sym_false] = STATE(2120),
    [sym_string_literal] = STATE(2124),
    [sym__string_literal_double_quotes] = STATE(1854),
    [sym__string_literal_single_quotes] = STATE(1854),
    [sym__string_literal_double_quotes_multiple] = STATE(1854),
    [sym__string_literal_single_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_double_quotes] = STATE(1854),
    [sym__raw_string_literal_single_quotes] = STATE(1854),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1854),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1854),
    [sym_null_literal] = STATE(2124),
    [sym_relational_operator] = STATE(345),
    [sym_const_object_expression] = STATE(2124),
    [sym_type_arguments] = STATE(3171),
    [sym__relational_pattern] = STATE(2186),
    [sym__unary_pattern] = STATE(2230),
    [sym__primary_pattern] = STATE(2129),
    [sym_cast_pattern] = STATE(2231),
    [sym_null_check_pattern] = STATE(2231),
    [sym_null_assert_pattern] = STATE(2231),
    [sym_constant_pattern] = STATE(2102),
    [sym_variable_pattern] = STATE(2102),
    [sym__parenthesized_pattern] = STATE(2102),
    [sym_list_pattern] = STATE(2102),
    [sym_map_pattern] = STATE(2102),
    [sym_record_pattern] = STATE(2102),
    [sym_object_pattern] = STATE(2102),
    [sym__type] = STATE(3547),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(2156),
    [sym__final_var_or_type] = STATE(3469),
    [sym_inferred_type] = STATE(3547),
    [sym_qualified] = STATE(2124),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym_final_builtin] = STATE(2100),
    [sym_comment] = STATE(437),
    [sym_documentation_comment] = STATE(437),
    [aux_sym_string_literal_repeat1] = STATE(1475),
    [sym_identifier] = ACTIONS(967),
    [anon_sym_POUND] = ACTIONS(850),
    [sym_decimal_integer_literal] = ACTIONS(852),
    [sym_hex_integer_literal] = ACTIONS(854),
    [sym_decimal_floating_point_literal] = ACTIONS(852),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(858),
    [anon_sym_DQUOTE] = ACTIONS(860),
    [anon_sym_SQUOTE] = ACTIONS(862),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(864),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(866),
    [anon_sym_r_DQUOTE] = ACTIONS(868),
    [anon_sym_r_SQUOTE] = ACTIONS(870),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(872),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(880),
    [anon_sym_null] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(884),
    [sym_equality_operator] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(886),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [sym_minus_operator] = ACTIONS(888),
    [anon_sym_final] = ACTIONS(145),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [sym_const_builtin] = ACTIONS(894),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [438] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_import_or_export] = STATE(1572),
    [sym_library_import] = STATE(1577),
    [sym_library_export] = STATE(1577),
    [sym_import_specification] = STATE(1581),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(560),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__export] = STATE(1869),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym__import] = STATE(1817),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(438),
    [sym_documentation_comment] = STATE(438),
    [aux_sym_program_repeat1] = STATE(1050),
    [aux_sym_program_repeat2] = STATE(452),
    [aux_sym_program_repeat3] = STATE(462),
    [aux_sym_program_repeat4] = STATE(476),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_export] = ACTIONS(43),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [439] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_import_or_export] = STATE(1572),
    [sym_library_import] = STATE(1577),
    [sym_library_export] = STATE(1577),
    [sym_import_specification] = STATE(1581),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(560),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__export] = STATE(1869),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym__import] = STATE(1817),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(439),
    [sym_documentation_comment] = STATE(439),
    [aux_sym_program_repeat1] = STATE(1050),
    [aux_sym_program_repeat2] = STATE(450),
    [aux_sym_program_repeat3] = STATE(468),
    [aux_sym_program_repeat4] = STATE(477),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1035),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_export] = ACTIONS(43),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [440] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_import_or_export] = STATE(1572),
    [sym_library_import] = STATE(1577),
    [sym_library_export] = STATE(1577),
    [sym_import_specification] = STATE(1581),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(560),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__export] = STATE(1869),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym__import] = STATE(1817),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(440),
    [sym_documentation_comment] = STATE(440),
    [aux_sym_program_repeat1] = STATE(1050),
    [aux_sym_program_repeat2] = STATE(451),
    [aux_sym_program_repeat3] = STATE(463),
    [aux_sym_program_repeat4] = STATE(478),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_export] = ACTIONS(43),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [441] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_import_or_export] = STATE(1572),
    [sym_library_import] = STATE(1577),
    [sym_library_export] = STATE(1577),
    [sym_import_specification] = STATE(1581),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(560),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__export] = STATE(1869),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym__import] = STATE(1817),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(441),
    [sym_documentation_comment] = STATE(441),
    [aux_sym_program_repeat1] = STATE(439),
    [aux_sym_program_repeat2] = STATE(451),
    [aux_sym_program_repeat3] = STATE(463),
    [aux_sym_program_repeat4] = STATE(478),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_export] = ACTIONS(43),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [442] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_import_or_export] = STATE(1572),
    [sym_library_import] = STATE(1577),
    [sym_library_export] = STATE(1577),
    [sym_import_specification] = STATE(1581),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(560),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__export] = STATE(1869),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym__import] = STATE(1817),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(442),
    [sym_documentation_comment] = STATE(442),
    [aux_sym_program_repeat1] = STATE(440),
    [aux_sym_program_repeat2] = STATE(452),
    [aux_sym_program_repeat3] = STATE(462),
    [aux_sym_program_repeat4] = STATE(476),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_export] = ACTIONS(43),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [443] = {
    [sym_comment] = STATE(443),
    [sym_documentation_comment] = STATE(443),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_POUND] = ACTIONS(1039),
    [sym_decimal_integer_literal] = ACTIONS(1041),
    [sym_hex_integer_literal] = ACTIONS(1039),
    [sym_decimal_floating_point_literal] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1041),
    [anon_sym_SQUOTE] = ACTIONS(1041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1039),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1039),
    [anon_sym_r_DQUOTE] = ACTIONS(1041),
    [anon_sym_r_SQUOTE] = ACTIONS(1041),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1039),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_QMARK] = ACTIONS(1041),
    [anon_sym_LT] = ACTIONS(1039),
    [sym_increment_operator] = ACTIONS(1039),
    [sym_minus_operator] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_QMARK_DOT] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_do] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_final] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_extension] = ACTIONS(1041),
    [sym_void_type] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [sym_break_builtin] = ACTIONS(1041),
    [sym_assert_builtin] = ACTIONS(1041),
    [sym_rethrow_builtin] = ACTIONS(1041),
    [anon_sym_covariant] = ACTIONS(1041),
    [anon_sym_factory] = ACTIONS(1041),
    [anon_sym_Function] = ACTIONS(1041),
    [anon_sym_get] = ACTIONS(1041),
    [anon_sym_interface] = ACTIONS(1041),
    [anon_sym_base] = ACTIONS(1041),
    [anon_sym_abstract] = ACTIONS(1041),
    [anon_sym_sealed] = ACTIONS(1041),
    [anon_sym_operator] = ACTIONS(1041),
    [anon_sym_mixin] = ACTIONS(1041),
    [anon_sym_set] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_typedef] = ACTIONS(1041),
    [anon_sym_new] = ACTIONS(1041),
    [sym_const_builtin] = ACTIONS(1041),
    [anon_sym_late] = ACTIONS(1041),
    [anon_sym_external] = ACTIONS(1041),
    [anon_sym_this] = ACTIONS(1041),
    [anon_sym_super] = ACTIONS(1041),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [444] = {
    [sym_comment] = STATE(444),
    [sym_documentation_comment] = STATE(444),
    [ts_builtin_sym_end] = ACTIONS(975),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_POUND] = ACTIONS(975),
    [sym_decimal_integer_literal] = ACTIONS(973),
    [sym_hex_integer_literal] = ACTIONS(975),
    [sym_decimal_floating_point_literal] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(973),
    [anon_sym_false] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_r_DQUOTE] = ACTIONS(973),
    [anon_sym_r_SQUOTE] = ACTIONS(973),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_null] = ACTIONS(973),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(975),
    [sym_increment_operator] = ACTIONS(975),
    [sym_minus_operator] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_await] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(973),
    [anon_sym_QMARK_DOT] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(973),
    [anon_sym_default] = ACTIONS(973),
    [anon_sym_do] = ACTIONS(973),
    [anon_sym_while] = ACTIONS(973),
    [anon_sym_continue] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(973),
    [anon_sym_return] = ACTIONS(973),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(973),
    [anon_sym_AT] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(973),
    [anon_sym_final] = ACTIONS(973),
    [anon_sym_inline] = ACTIONS(973),
    [anon_sym_class] = ACTIONS(973),
    [anon_sym_extension] = ACTIONS(973),
    [sym_void_type] = ACTIONS(973),
    [anon_sym_var] = ACTIONS(973),
    [sym_break_builtin] = ACTIONS(973),
    [sym_assert_builtin] = ACTIONS(973),
    [sym_rethrow_builtin] = ACTIONS(973),
    [anon_sym_covariant] = ACTIONS(973),
    [anon_sym_factory] = ACTIONS(973),
    [anon_sym_Function] = ACTIONS(973),
    [anon_sym_get] = ACTIONS(973),
    [anon_sym_interface] = ACTIONS(973),
    [anon_sym_base] = ACTIONS(973),
    [anon_sym_abstract] = ACTIONS(973),
    [anon_sym_sealed] = ACTIONS(973),
    [anon_sym_operator] = ACTIONS(973),
    [anon_sym_mixin] = ACTIONS(973),
    [anon_sym_set] = ACTIONS(973),
    [anon_sym_static] = ACTIONS(973),
    [anon_sym_typedef] = ACTIONS(973),
    [anon_sym_new] = ACTIONS(973),
    [sym_const_builtin] = ACTIONS(973),
    [anon_sym_late] = ACTIONS(973),
    [anon_sym_external] = ACTIONS(973),
    [anon_sym_this] = ACTIONS(973),
    [anon_sym_super] = ACTIONS(973),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [445] = {
    [sym_comment] = STATE(445),
    [sym_documentation_comment] = STATE(445),
    [ts_builtin_sym_end] = ACTIONS(1043),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_POUND] = ACTIONS(1043),
    [sym_decimal_integer_literal] = ACTIONS(1045),
    [sym_hex_integer_literal] = ACTIONS(1043),
    [sym_decimal_floating_point_literal] = ACTIONS(1045),
    [anon_sym_true] = ACTIONS(1045),
    [anon_sym_false] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1045),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1043),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1043),
    [anon_sym_r_DQUOTE] = ACTIONS(1045),
    [anon_sym_r_SQUOTE] = ACTIONS(1045),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1043),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1043),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1043),
    [anon_sym_null] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_throw] = ACTIONS(1045),
    [anon_sym_LT] = ACTIONS(1043),
    [sym_increment_operator] = ACTIONS(1043),
    [sym_minus_operator] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_await] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(1045),
    [anon_sym_default] = ACTIONS(1045),
    [anon_sym_do] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1045),
    [anon_sym_continue] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_try] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1045),
    [anon_sym_case] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1045),
    [anon_sym_final] = ACTIONS(1045),
    [anon_sym_inline] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_extension] = ACTIONS(1045),
    [sym_void_type] = ACTIONS(1045),
    [anon_sym_var] = ACTIONS(1045),
    [sym_break_builtin] = ACTIONS(1045),
    [sym_assert_builtin] = ACTIONS(1045),
    [sym_rethrow_builtin] = ACTIONS(1045),
    [anon_sym_covariant] = ACTIONS(1045),
    [anon_sym_factory] = ACTIONS(1045),
    [anon_sym_Function] = ACTIONS(1045),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_interface] = ACTIONS(1045),
    [anon_sym_base] = ACTIONS(1045),
    [anon_sym_abstract] = ACTIONS(1045),
    [anon_sym_sealed] = ACTIONS(1045),
    [anon_sym_operator] = ACTIONS(1045),
    [anon_sym_mixin] = ACTIONS(1045),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_typedef] = ACTIONS(1045),
    [anon_sym_new] = ACTIONS(1045),
    [sym_const_builtin] = ACTIONS(1045),
    [anon_sym_late] = ACTIONS(1045),
    [anon_sym_external] = ACTIONS(1045),
    [anon_sym_this] = ACTIONS(1045),
    [anon_sym_super] = ACTIONS(1045),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [446] = {
    [sym_comment] = STATE(446),
    [sym_documentation_comment] = STATE(446),
    [ts_builtin_sym_end] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_POUND] = ACTIONS(1047),
    [sym_decimal_integer_literal] = ACTIONS(1049),
    [sym_hex_integer_literal] = ACTIONS(1047),
    [sym_decimal_floating_point_literal] = ACTIONS(1049),
    [anon_sym_true] = ACTIONS(1049),
    [anon_sym_false] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1047),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1047),
    [anon_sym_r_DQUOTE] = ACTIONS(1049),
    [anon_sym_r_SQUOTE] = ACTIONS(1049),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1047),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_null] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_throw] = ACTIONS(1049),
    [anon_sym_LT] = ACTIONS(1047),
    [sym_increment_operator] = ACTIONS(1047),
    [sym_minus_operator] = ACTIONS(1049),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_TILDE] = ACTIONS(1047),
    [anon_sym_await] = ACTIONS(1049),
    [anon_sym_switch] = ACTIONS(1049),
    [anon_sym_default] = ACTIONS(1049),
    [anon_sym_do] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [anon_sym_continue] = ACTIONS(1049),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_return] = ACTIONS(1049),
    [anon_sym_try] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_case] = ACTIONS(1049),
    [anon_sym_else] = ACTIONS(1049),
    [anon_sym_for] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1047),
    [anon_sym_enum] = ACTIONS(1049),
    [anon_sym_final] = ACTIONS(1049),
    [anon_sym_inline] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(1049),
    [anon_sym_extension] = ACTIONS(1049),
    [sym_void_type] = ACTIONS(1049),
    [anon_sym_var] = ACTIONS(1049),
    [sym_break_builtin] = ACTIONS(1049),
    [sym_assert_builtin] = ACTIONS(1049),
    [sym_rethrow_builtin] = ACTIONS(1049),
    [anon_sym_covariant] = ACTIONS(1049),
    [anon_sym_factory] = ACTIONS(1049),
    [anon_sym_Function] = ACTIONS(1049),
    [anon_sym_get] = ACTIONS(1049),
    [anon_sym_interface] = ACTIONS(1049),
    [anon_sym_base] = ACTIONS(1049),
    [anon_sym_abstract] = ACTIONS(1049),
    [anon_sym_sealed] = ACTIONS(1049),
    [anon_sym_operator] = ACTIONS(1049),
    [anon_sym_mixin] = ACTIONS(1049),
    [anon_sym_set] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(1049),
    [anon_sym_typedef] = ACTIONS(1049),
    [anon_sym_new] = ACTIONS(1049),
    [sym_const_builtin] = ACTIONS(1049),
    [anon_sym_late] = ACTIONS(1049),
    [anon_sym_external] = ACTIONS(1049),
    [anon_sym_this] = ACTIONS(1049),
    [anon_sym_super] = ACTIONS(1049),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [447] = {
    [sym_comment] = STATE(447),
    [sym_documentation_comment] = STATE(447),
    [ts_builtin_sym_end] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_POUND] = ACTIONS(1051),
    [sym_decimal_integer_literal] = ACTIONS(1053),
    [sym_hex_integer_literal] = ACTIONS(1051),
    [sym_decimal_floating_point_literal] = ACTIONS(1053),
    [anon_sym_true] = ACTIONS(1053),
    [anon_sym_false] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1053),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1051),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1051),
    [anon_sym_r_DQUOTE] = ACTIONS(1053),
    [anon_sym_r_SQUOTE] = ACTIONS(1053),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1051),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_null] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_throw] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1051),
    [sym_increment_operator] = ACTIONS(1051),
    [sym_minus_operator] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_await] = ACTIONS(1053),
    [anon_sym_switch] = ACTIONS(1053),
    [anon_sym_default] = ACTIONS(1053),
    [anon_sym_do] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_case] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1053),
    [anon_sym_final] = ACTIONS(1053),
    [anon_sym_inline] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_extension] = ACTIONS(1053),
    [sym_void_type] = ACTIONS(1053),
    [anon_sym_var] = ACTIONS(1053),
    [sym_break_builtin] = ACTIONS(1053),
    [sym_assert_builtin] = ACTIONS(1053),
    [sym_rethrow_builtin] = ACTIONS(1053),
    [anon_sym_covariant] = ACTIONS(1053),
    [anon_sym_factory] = ACTIONS(1053),
    [anon_sym_Function] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_interface] = ACTIONS(1053),
    [anon_sym_base] = ACTIONS(1053),
    [anon_sym_abstract] = ACTIONS(1053),
    [anon_sym_sealed] = ACTIONS(1053),
    [anon_sym_operator] = ACTIONS(1053),
    [anon_sym_mixin] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_typedef] = ACTIONS(1053),
    [anon_sym_new] = ACTIONS(1053),
    [sym_const_builtin] = ACTIONS(1053),
    [anon_sym_late] = ACTIONS(1053),
    [anon_sym_external] = ACTIONS(1053),
    [anon_sym_this] = ACTIONS(1053),
    [anon_sym_super] = ACTIONS(1053),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [448] = {
    [sym_comment] = STATE(448),
    [sym_documentation_comment] = STATE(448),
    [ts_builtin_sym_end] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_POUND] = ACTIONS(1055),
    [sym_decimal_integer_literal] = ACTIONS(1057),
    [sym_hex_integer_literal] = ACTIONS(1055),
    [sym_decimal_floating_point_literal] = ACTIONS(1057),
    [anon_sym_true] = ACTIONS(1057),
    [anon_sym_false] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_SQUOTE] = ACTIONS(1057),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1055),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1055),
    [anon_sym_r_DQUOTE] = ACTIONS(1057),
    [anon_sym_r_SQUOTE] = ACTIONS(1057),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1055),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_null] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_throw] = ACTIONS(1057),
    [anon_sym_LT] = ACTIONS(1055),
    [sym_increment_operator] = ACTIONS(1055),
    [sym_minus_operator] = ACTIONS(1057),
    [anon_sym_BANG] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1055),
    [anon_sym_await] = ACTIONS(1057),
    [anon_sym_switch] = ACTIONS(1057),
    [anon_sym_default] = ACTIONS(1057),
    [anon_sym_do] = ACTIONS(1057),
    [anon_sym_while] = ACTIONS(1057),
    [anon_sym_continue] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1057),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_try] = ACTIONS(1057),
    [anon_sym_if] = ACTIONS(1057),
    [anon_sym_case] = ACTIONS(1057),
    [anon_sym_else] = ACTIONS(1057),
    [anon_sym_for] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1055),
    [anon_sym_enum] = ACTIONS(1057),
    [anon_sym_final] = ACTIONS(1057),
    [anon_sym_inline] = ACTIONS(1057),
    [anon_sym_class] = ACTIONS(1057),
    [anon_sym_extension] = ACTIONS(1057),
    [sym_void_type] = ACTIONS(1057),
    [anon_sym_var] = ACTIONS(1057),
    [sym_break_builtin] = ACTIONS(1057),
    [sym_assert_builtin] = ACTIONS(1057),
    [sym_rethrow_builtin] = ACTIONS(1057),
    [anon_sym_covariant] = ACTIONS(1057),
    [anon_sym_factory] = ACTIONS(1057),
    [anon_sym_Function] = ACTIONS(1057),
    [anon_sym_get] = ACTIONS(1057),
    [anon_sym_interface] = ACTIONS(1057),
    [anon_sym_base] = ACTIONS(1057),
    [anon_sym_abstract] = ACTIONS(1057),
    [anon_sym_sealed] = ACTIONS(1057),
    [anon_sym_operator] = ACTIONS(1057),
    [anon_sym_mixin] = ACTIONS(1057),
    [anon_sym_set] = ACTIONS(1057),
    [anon_sym_static] = ACTIONS(1057),
    [anon_sym_typedef] = ACTIONS(1057),
    [anon_sym_new] = ACTIONS(1057),
    [sym_const_builtin] = ACTIONS(1057),
    [anon_sym_late] = ACTIONS(1057),
    [anon_sym_external] = ACTIONS(1057),
    [anon_sym_this] = ACTIONS(1057),
    [anon_sym_super] = ACTIONS(1057),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [449] = {
    [sym_comment] = STATE(449),
    [sym_documentation_comment] = STATE(449),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_POUND] = ACTIONS(1059),
    [sym_decimal_integer_literal] = ACTIONS(1061),
    [sym_hex_integer_literal] = ACTIONS(1059),
    [sym_decimal_floating_point_literal] = ACTIONS(1061),
    [anon_sym_true] = ACTIONS(1061),
    [anon_sym_false] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1059),
    [anon_sym_r_DQUOTE] = ACTIONS(1061),
    [anon_sym_r_SQUOTE] = ACTIONS(1061),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1059),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_null] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1059),
    [sym_increment_operator] = ACTIONS(1059),
    [sym_minus_operator] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_enum] = ACTIONS(1061),
    [anon_sym_final] = ACTIONS(1061),
    [anon_sym_inline] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_extension] = ACTIONS(1061),
    [sym_void_type] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [sym_break_builtin] = ACTIONS(1061),
    [sym_assert_builtin] = ACTIONS(1061),
    [sym_rethrow_builtin] = ACTIONS(1061),
    [anon_sym_covariant] = ACTIONS(1061),
    [anon_sym_factory] = ACTIONS(1061),
    [anon_sym_Function] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_base] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_sealed] = ACTIONS(1061),
    [anon_sym_operator] = ACTIONS(1061),
    [anon_sym_mixin] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_typedef] = ACTIONS(1061),
    [anon_sym_new] = ACTIONS(1061),
    [sym_const_builtin] = ACTIONS(1061),
    [anon_sym_late] = ACTIONS(1061),
    [anon_sym_external] = ACTIONS(1061),
    [anon_sym_this] = ACTIONS(1061),
    [anon_sym_super] = ACTIONS(1061),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [450] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(667),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(450),
    [sym_documentation_comment] = STATE(450),
    [aux_sym_program_repeat2] = STATE(1420),
    [aux_sym_program_repeat3] = STATE(465),
    [aux_sym_program_repeat4] = STATE(480),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [451] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(667),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(451),
    [sym_documentation_comment] = STATE(451),
    [aux_sym_program_repeat2] = STATE(1420),
    [aux_sym_program_repeat3] = STATE(468),
    [aux_sym_program_repeat4] = STATE(477),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1035),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [452] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(667),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(452),
    [sym_documentation_comment] = STATE(452),
    [aux_sym_program_repeat2] = STATE(1420),
    [aux_sym_program_repeat3] = STATE(463),
    [aux_sym_program_repeat4] = STATE(478),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [453] = {
    [sym__assignment_operator] = STATE(298),
    [sym_arguments] = STATE(583),
    [sym__cascade_subsection] = STATE(580),
    [sym__cascade_assignment_section] = STATE(980),
    [sym_index_selector] = STATE(581),
    [sym_argument_part] = STATE(579),
    [sym_unconditional_assignable_selector] = STATE(602),
    [sym_conditional_assignable_selector] = STATE(602),
    [sym__assignable_selector] = STATE(499),
    [sym_type_arguments] = STATE(3083),
    [sym_comment] = STATE(453),
    [sym_documentation_comment] = STATE(453),
    [aux_sym_cascade_section_repeat1] = STATE(496),
    [aux_sym_cascade_section_repeat2] = STATE(472),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_RBRACK] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [sym_equality_operator] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [sym__additive_operator] = ACTIONS(1071),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_TILDE_SLASH] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_is] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_QMARK_DOT] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1065),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ_GT] = ACTIONS(1065),
    [anon_sym_when] = ACTIONS(1065),
    [anon_sym_case] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [454] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_directive] = STATE(1671),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(667),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(454),
    [sym_documentation_comment] = STATE(454),
    [aux_sym_program_repeat2] = STATE(1420),
    [aux_sym_program_repeat3] = STATE(462),
    [aux_sym_program_repeat4] = STATE(476),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_part] = ACTIONS(21),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [455] = {
    [sym__assignment_operator] = STATE(298),
    [sym_arguments] = STATE(583),
    [sym__cascade_subsection] = STATE(580),
    [sym__cascade_assignment_section] = STATE(999),
    [sym_index_selector] = STATE(581),
    [sym_argument_part] = STATE(579),
    [sym_unconditional_assignable_selector] = STATE(602),
    [sym_conditional_assignable_selector] = STATE(602),
    [sym__assignable_selector] = STATE(499),
    [sym_type_arguments] = STATE(3083),
    [sym_comment] = STATE(455),
    [sym_documentation_comment] = STATE(455),
    [aux_sym_cascade_section_repeat1] = STATE(453),
    [aux_sym_cascade_section_repeat2] = STATE(471),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_RBRACK] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1075),
    [sym_equality_operator] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1075),
    [anon_sym_GT_GT_GT] = ACTIONS(1075),
    [sym__additive_operator] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [anon_sym_PERCENT] = ACTIONS(1075),
    [anon_sym_TILDE_SLASH] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_is] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1075),
    [anon_sym_QMARK_DOT] = ACTIONS(1075),
    [anon_sym_DOT_DOT] = ACTIONS(1073),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_EQ_GT] = ACTIONS(1073),
    [anon_sym_when] = ACTIONS(1073),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [456] = {
    [sym__bool_literal] = STATE(2364),
    [sym__numeric_literal] = STATE(2364),
    [sym__literal] = STATE(2369),
    [sym_symbol_literal] = STATE(2364),
    [sym_true] = STATE(2371),
    [sym_false] = STATE(2371),
    [sym_string_literal] = STATE(2364),
    [sym__string_literal_double_quotes] = STATE(1994),
    [sym__string_literal_single_quotes] = STATE(1994),
    [sym__string_literal_double_quotes_multiple] = STATE(1994),
    [sym__string_literal_single_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_double_quotes] = STATE(1994),
    [sym__raw_string_literal_single_quotes] = STATE(1994),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1994),
    [sym_list_literal] = STATE(2364),
    [sym_set_or_map_literal] = STATE(2364),
    [sym_null_literal] = STATE(2364),
    [sym_record_literal] = STATE(2364),
    [sym__record_literal_no_const] = STATE(2388),
    [sym_assignable_expression] = STATE(1315),
    [sym_function_expression] = STATE(2369),
    [sym_new_expression] = STATE(2369),
    [sym_const_object_expression] = STATE(2369),
    [sym__primary] = STATE(1920),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_constructor_invocation] = STATE(1920),
    [sym_constructor_tearoff] = STATE(2369),
    [sym_type_arguments] = STATE(3115),
    [sym_switch_expression] = STATE(2369),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2699),
    [sym__formal_parameter_part] = STATE(2426),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2098),
    [sym_this] = STATE(2369),
    [sym_super] = STATE(2642),
    [sym_comment] = STATE(456),
    [sym_documentation_comment] = STATE(456),
    [aux_sym_string_literal_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(1077),
    [anon_sym_POUND] = ACTIONS(1079),
    [sym_decimal_integer_literal] = ACTIONS(1081),
    [sym_hex_integer_literal] = ACTIONS(1083),
    [sym_decimal_floating_point_literal] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(1085),
    [anon_sym_false] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1095),
    [anon_sym_r_DQUOTE] = ACTIONS(1097),
    [anon_sym_r_SQUOTE] = ACTIONS(1099),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1101),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_null] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1117),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [457] = {
    [sym__bool_literal] = STATE(2364),
    [sym__numeric_literal] = STATE(2364),
    [sym__literal] = STATE(2369),
    [sym_symbol_literal] = STATE(2364),
    [sym_true] = STATE(2371),
    [sym_false] = STATE(2371),
    [sym_string_literal] = STATE(2364),
    [sym__string_literal_double_quotes] = STATE(1994),
    [sym__string_literal_single_quotes] = STATE(1994),
    [sym__string_literal_double_quotes_multiple] = STATE(1994),
    [sym__string_literal_single_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_double_quotes] = STATE(1994),
    [sym__raw_string_literal_single_quotes] = STATE(1994),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1994),
    [sym_list_literal] = STATE(2364),
    [sym_set_or_map_literal] = STATE(2364),
    [sym_null_literal] = STATE(2364),
    [sym_record_literal] = STATE(2364),
    [sym__record_literal_no_const] = STATE(2388),
    [sym_assignable_expression] = STATE(1487),
    [sym_function_expression] = STATE(2369),
    [sym_new_expression] = STATE(2369),
    [sym_const_object_expression] = STATE(2369),
    [sym__primary] = STATE(1925),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_constructor_invocation] = STATE(1925),
    [sym_constructor_tearoff] = STATE(2369),
    [sym_type_arguments] = STATE(3115),
    [sym_switch_expression] = STATE(2369),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2699),
    [sym__formal_parameter_part] = STATE(2426),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2098),
    [sym_this] = STATE(2369),
    [sym_super] = STATE(2626),
    [sym_comment] = STATE(457),
    [sym_documentation_comment] = STATE(457),
    [aux_sym_string_literal_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_POUND] = ACTIONS(1079),
    [sym_decimal_integer_literal] = ACTIONS(1081),
    [sym_hex_integer_literal] = ACTIONS(1083),
    [sym_decimal_floating_point_literal] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(1085),
    [anon_sym_false] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1095),
    [anon_sym_r_DQUOTE] = ACTIONS(1097),
    [anon_sym_r_SQUOTE] = ACTIONS(1099),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1101),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_null] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1117),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [458] = {
    [sym__bool_literal] = STATE(2364),
    [sym__numeric_literal] = STATE(2364),
    [sym__literal] = STATE(2369),
    [sym_symbol_literal] = STATE(2364),
    [sym_true] = STATE(2371),
    [sym_false] = STATE(2371),
    [sym_string_literal] = STATE(2364),
    [sym__string_literal_double_quotes] = STATE(1994),
    [sym__string_literal_single_quotes] = STATE(1994),
    [sym__string_literal_double_quotes_multiple] = STATE(1994),
    [sym__string_literal_single_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_double_quotes] = STATE(1994),
    [sym__raw_string_literal_single_quotes] = STATE(1994),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1994),
    [sym_list_literal] = STATE(2364),
    [sym_set_or_map_literal] = STATE(2364),
    [sym_null_literal] = STATE(2364),
    [sym_record_literal] = STATE(2364),
    [sym__record_literal_no_const] = STATE(2388),
    [sym_assignable_expression] = STATE(969),
    [sym_function_expression] = STATE(2369),
    [sym_new_expression] = STATE(2369),
    [sym_const_object_expression] = STATE(2369),
    [sym__primary] = STATE(1918),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_constructor_invocation] = STATE(1918),
    [sym_constructor_tearoff] = STATE(2369),
    [sym_type_arguments] = STATE(3115),
    [sym_switch_expression] = STATE(2369),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2699),
    [sym__formal_parameter_part] = STATE(2426),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2098),
    [sym_this] = STATE(2369),
    [sym_super] = STATE(2648),
    [sym_comment] = STATE(458),
    [sym_documentation_comment] = STATE(458),
    [aux_sym_string_literal_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(1121),
    [anon_sym_POUND] = ACTIONS(1079),
    [sym_decimal_integer_literal] = ACTIONS(1081),
    [sym_hex_integer_literal] = ACTIONS(1083),
    [sym_decimal_floating_point_literal] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(1085),
    [anon_sym_false] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1095),
    [anon_sym_r_DQUOTE] = ACTIONS(1097),
    [anon_sym_r_SQUOTE] = ACTIONS(1099),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1101),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_null] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1117),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [459] = {
    [sym__bool_literal] = STATE(2364),
    [sym__numeric_literal] = STATE(2364),
    [sym__literal] = STATE(2369),
    [sym_symbol_literal] = STATE(2364),
    [sym_true] = STATE(2371),
    [sym_false] = STATE(2371),
    [sym_string_literal] = STATE(2364),
    [sym__string_literal_double_quotes] = STATE(1994),
    [sym__string_literal_single_quotes] = STATE(1994),
    [sym__string_literal_double_quotes_multiple] = STATE(1994),
    [sym__string_literal_single_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_double_quotes] = STATE(1994),
    [sym__raw_string_literal_single_quotes] = STATE(1994),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1994),
    [sym_list_literal] = STATE(2364),
    [sym_set_or_map_literal] = STATE(2364),
    [sym_null_literal] = STATE(2364),
    [sym_record_literal] = STATE(2364),
    [sym__record_literal_no_const] = STATE(2388),
    [sym_assignable_expression] = STATE(1154),
    [sym_function_expression] = STATE(2369),
    [sym_new_expression] = STATE(2369),
    [sym_const_object_expression] = STATE(2369),
    [sym__primary] = STATE(1926),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_constructor_invocation] = STATE(1926),
    [sym_constructor_tearoff] = STATE(2369),
    [sym_type_arguments] = STATE(3115),
    [sym_switch_expression] = STATE(2369),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2699),
    [sym__formal_parameter_part] = STATE(2426),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2098),
    [sym_this] = STATE(2369),
    [sym_super] = STATE(2668),
    [sym_comment] = STATE(459),
    [sym_documentation_comment] = STATE(459),
    [aux_sym_string_literal_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(1123),
    [anon_sym_POUND] = ACTIONS(1079),
    [sym_decimal_integer_literal] = ACTIONS(1081),
    [sym_hex_integer_literal] = ACTIONS(1083),
    [sym_decimal_floating_point_literal] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(1085),
    [anon_sym_false] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1095),
    [anon_sym_r_DQUOTE] = ACTIONS(1097),
    [anon_sym_r_SQUOTE] = ACTIONS(1099),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1101),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_null] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1117),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [460] = {
    [sym__bool_literal] = STATE(2364),
    [sym__numeric_literal] = STATE(2364),
    [sym__literal] = STATE(2369),
    [sym_symbol_literal] = STATE(2364),
    [sym_true] = STATE(2371),
    [sym_false] = STATE(2371),
    [sym_string_literal] = STATE(2364),
    [sym__string_literal_double_quotes] = STATE(1994),
    [sym__string_literal_single_quotes] = STATE(1994),
    [sym__string_literal_double_quotes_multiple] = STATE(1994),
    [sym__string_literal_single_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_double_quotes] = STATE(1994),
    [sym__raw_string_literal_single_quotes] = STATE(1994),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(1994),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(1994),
    [sym_list_literal] = STATE(2364),
    [sym_set_or_map_literal] = STATE(2364),
    [sym_null_literal] = STATE(2364),
    [sym_record_literal] = STATE(2364),
    [sym__record_literal_no_const] = STATE(2388),
    [sym_assignable_expression] = STATE(1382),
    [sym_function_expression] = STATE(2369),
    [sym_new_expression] = STATE(2369),
    [sym_const_object_expression] = STATE(2369),
    [sym__primary] = STATE(1929),
    [sym_parenthesized_expression] = STATE(2369),
    [sym_constructor_invocation] = STATE(1929),
    [sym_constructor_tearoff] = STATE(2369),
    [sym_type_arguments] = STATE(3115),
    [sym_switch_expression] = STATE(2369),
    [sym_type_parameters] = STATE(2932),
    [sym__type_name] = STATE(2699),
    [sym__formal_parameter_part] = STATE(2426),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym__new_builtin] = STATE(2098),
    [sym_this] = STATE(2369),
    [sym_super] = STATE(2656),
    [sym_comment] = STATE(460),
    [sym_documentation_comment] = STATE(460),
    [aux_sym_string_literal_repeat1] = STATE(1720),
    [sym_identifier] = ACTIONS(1125),
    [anon_sym_POUND] = ACTIONS(1079),
    [sym_decimal_integer_literal] = ACTIONS(1081),
    [sym_hex_integer_literal] = ACTIONS(1083),
    [sym_decimal_floating_point_literal] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(1085),
    [anon_sym_false] = ACTIONS(1087),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1093),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1095),
    [anon_sym_r_DQUOTE] = ACTIONS(1097),
    [anon_sym_r_SQUOTE] = ACTIONS(1099),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1101),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_null] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_new] = ACTIONS(155),
    [sym_const_builtin] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1117),
    [anon_sym_super] = ACTIONS(161),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [461] = {
    [sym__on_part] = STATE(493),
    [sym_catch_clause] = STATE(3156),
    [sym_finally_clause] = STATE(529),
    [sym_comment] = STATE(461),
    [sym_documentation_comment] = STATE(461),
    [aux_sym_try_statement_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_POUND] = ACTIONS(1129),
    [sym_decimal_integer_literal] = ACTIONS(1127),
    [sym_hex_integer_literal] = ACTIONS(1129),
    [sym_decimal_floating_point_literal] = ACTIONS(1127),
    [anon_sym_true] = ACTIONS(1127),
    [anon_sym_false] = ACTIONS(1127),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(1127),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1129),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1129),
    [anon_sym_r_DQUOTE] = ACTIONS(1127),
    [anon_sym_r_SQUOTE] = ACTIONS(1127),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1129),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [anon_sym_RBRACE] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_null] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(1129),
    [sym_increment_operator] = ACTIONS(1129),
    [sym_minus_operator] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_TILDE] = ACTIONS(1129),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_do] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_catch] = ACTIONS(1133),
    [anon_sym_finally] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_case] = ACTIONS(1127),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1129),
    [anon_sym_final] = ACTIONS(1127),
    [sym_void_type] = ACTIONS(1127),
    [anon_sym_var] = ACTIONS(1127),
    [sym_break_builtin] = ACTIONS(1127),
    [sym_assert_builtin] = ACTIONS(1127),
    [sym_rethrow_builtin] = ACTIONS(1127),
    [anon_sym_covariant] = ACTIONS(1127),
    [anon_sym_Function] = ACTIONS(1127),
    [anon_sym_get] = ACTIONS(1127),
    [anon_sym_set] = ACTIONS(1127),
    [anon_sym_new] = ACTIONS(1127),
    [sym_const_builtin] = ACTIONS(1127),
    [anon_sym_late] = ACTIONS(1127),
    [anon_sym_this] = ACTIONS(1127),
    [anon_sym_super] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [462] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(680),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(462),
    [sym_documentation_comment] = STATE(462),
    [aux_sym_program_repeat3] = STATE(1474),
    [aux_sym_program_repeat4] = STATE(478),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [463] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(680),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(463),
    [sym_documentation_comment] = STATE(463),
    [aux_sym_program_repeat3] = STATE(1474),
    [aux_sym_program_repeat4] = STATE(477),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1035),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [464] = {
    [sym__on_part] = STATE(493),
    [sym_catch_clause] = STATE(3156),
    [sym_finally_clause] = STATE(548),
    [sym_comment] = STATE(464),
    [sym_documentation_comment] = STATE(464),
    [aux_sym_try_statement_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_POUND] = ACTIONS(1139),
    [sym_decimal_integer_literal] = ACTIONS(1137),
    [sym_hex_integer_literal] = ACTIONS(1139),
    [sym_decimal_floating_point_literal] = ACTIONS(1137),
    [anon_sym_true] = ACTIONS(1137),
    [anon_sym_false] = ACTIONS(1137),
    [anon_sym_DQUOTE] = ACTIONS(1137),
    [anon_sym_SQUOTE] = ACTIONS(1137),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1139),
    [anon_sym_r_DQUOTE] = ACTIONS(1137),
    [anon_sym_r_SQUOTE] = ACTIONS(1137),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1139),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1139),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_null] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1139),
    [sym_increment_operator] = ACTIONS(1139),
    [sym_minus_operator] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_on] = ACTIONS(1131),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_catch] = ACTIONS(1133),
    [anon_sym_finally] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1139),
    [anon_sym_final] = ACTIONS(1137),
    [sym_void_type] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [sym_break_builtin] = ACTIONS(1137),
    [sym_assert_builtin] = ACTIONS(1137),
    [sym_rethrow_builtin] = ACTIONS(1137),
    [anon_sym_covariant] = ACTIONS(1137),
    [anon_sym_Function] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [sym_const_builtin] = ACTIONS(1137),
    [anon_sym_late] = ACTIONS(1137),
    [anon_sym_this] = ACTIONS(1137),
    [anon_sym_super] = ACTIONS(1137),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [465] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(680),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(465),
    [sym_documentation_comment] = STATE(465),
    [aux_sym_program_repeat3] = STATE(1474),
    [aux_sym_program_repeat4] = STATE(482),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1141),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [466] = {
    [sym__assignment_operator] = STATE(296),
    [sym_arguments] = STATE(653),
    [sym__cascade_subsection] = STATE(652),
    [sym__cascade_assignment_section] = STATE(1163),
    [sym_index_selector] = STATE(649),
    [sym_argument_part] = STATE(650),
    [sym_unconditional_assignable_selector] = STATE(641),
    [sym_conditional_assignable_selector] = STATE(641),
    [sym__assignable_selector] = STATE(561),
    [sym_type_arguments] = STATE(3126),
    [sym_comment] = STATE(466),
    [sym_documentation_comment] = STATE(466),
    [aux_sym_cascade_section_repeat1] = STATE(467),
    [aux_sym_cascade_section_repeat2] = STATE(490),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1075),
    [sym_equality_operator] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_LT_LT] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1075),
    [anon_sym_GT_GT_GT] = ACTIONS(1075),
    [sym__additive_operator] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [anon_sym_PERCENT] = ACTIONS(1075),
    [anon_sym_TILDE_SLASH] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_is] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1075),
    [anon_sym_DOT] = ACTIONS(1075),
    [anon_sym_QMARK_DOT] = ACTIONS(1075),
    [anon_sym_DOT_DOT] = ACTIONS(1073),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_EQ_GT] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_async_STAR] = ACTIONS(1073),
    [anon_sym_sync_STAR] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [467] = {
    [sym__assignment_operator] = STATE(296),
    [sym_arguments] = STATE(653),
    [sym__cascade_subsection] = STATE(652),
    [sym__cascade_assignment_section] = STATE(1123),
    [sym_index_selector] = STATE(649),
    [sym_argument_part] = STATE(650),
    [sym_unconditional_assignable_selector] = STATE(641),
    [sym_conditional_assignable_selector] = STATE(641),
    [sym__assignable_selector] = STATE(561),
    [sym_type_arguments] = STATE(3126),
    [sym_comment] = STATE(467),
    [sym_documentation_comment] = STATE(467),
    [aux_sym_cascade_section_repeat1] = STATE(566),
    [aux_sym_cascade_section_repeat2] = STATE(487),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [sym_equality_operator] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [sym__additive_operator] = ACTIONS(1071),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_TILDE_SLASH] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_is] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_QMARK_DOT] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1065),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ_GT] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1071),
    [anon_sym_async_STAR] = ACTIONS(1065),
    [anon_sym_sync_STAR] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [468] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(680),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(468),
    [sym_documentation_comment] = STATE(468),
    [aux_sym_program_repeat3] = STATE(1474),
    [aux_sym_program_repeat4] = STATE(480),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [469] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1571),
    [sym_part_of_directive] = STATE(1725),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(680),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(469),
    [sym_documentation_comment] = STATE(469),
    [aux_sym_program_repeat3] = STATE(1474),
    [aux_sym_program_repeat4] = STATE(476),
    [aux_sym__metadata_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [sym_part_of_builtin] = ACTIONS(41),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [470] = {
    [sym__on_part] = STATE(493),
    [sym_catch_clause] = STATE(3156),
    [sym_comment] = STATE(470),
    [sym_documentation_comment] = STATE(470),
    [aux_sym_try_statement_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(1143),
    [anon_sym_POUND] = ACTIONS(1145),
    [sym_decimal_integer_literal] = ACTIONS(1143),
    [sym_hex_integer_literal] = ACTIONS(1145),
    [sym_decimal_floating_point_literal] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(1143),
    [anon_sym_false] = ACTIONS(1143),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1145),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1145),
    [anon_sym_r_DQUOTE] = ACTIONS(1143),
    [anon_sym_r_SQUOTE] = ACTIONS(1143),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1145),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_null] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_throw] = ACTIONS(1143),
    [anon_sym_LT] = ACTIONS(1145),
    [sym_increment_operator] = ACTIONS(1145),
    [sym_minus_operator] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_TILDE] = ACTIONS(1145),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_switch] = ACTIONS(1143),
    [anon_sym_default] = ACTIONS(1143),
    [anon_sym_do] = ACTIONS(1143),
    [anon_sym_while] = ACTIONS(1143),
    [anon_sym_continue] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1143),
    [anon_sym_on] = ACTIONS(1147),
    [anon_sym_try] = ACTIONS(1143),
    [anon_sym_catch] = ACTIONS(1150),
    [anon_sym_finally] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(1143),
    [anon_sym_case] = ACTIONS(1143),
    [anon_sym_else] = ACTIONS(1143),
    [anon_sym_for] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_final] = ACTIONS(1143),
    [sym_void_type] = ACTIONS(1143),
    [anon_sym_var] = ACTIONS(1143),
    [sym_break_builtin] = ACTIONS(1143),
    [sym_assert_builtin] = ACTIONS(1143),
    [sym_rethrow_builtin] = ACTIONS(1143),
    [anon_sym_covariant] = ACTIONS(1143),
    [anon_sym_Function] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(1143),
    [anon_sym_set] = ACTIONS(1143),
    [anon_sym_new] = ACTIONS(1143),
    [sym_const_builtin] = ACTIONS(1143),
    [anon_sym_late] = ACTIONS(1143),
    [anon_sym_this] = ACTIONS(1143),
    [anon_sym_super] = ACTIONS(1143),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [471] = {
    [sym__assignment_operator] = STATE(298),
    [sym__cascade_subsection] = STATE(580),
    [sym__cascade_assignment_section] = STATE(980),
    [sym_index_selector] = STATE(581),
    [sym_unconditional_assignable_selector] = STATE(602),
    [sym_conditional_assignable_selector] = STATE(602),
    [sym__assignable_selector] = STATE(499),
    [sym_comment] = STATE(471),
    [sym_documentation_comment] = STATE(471),
    [aux_sym_cascade_section_repeat2] = STATE(483),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_RBRACK] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [sym_equality_operator] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [sym__additive_operator] = ACTIONS(1071),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_TILDE_SLASH] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_is] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_QMARK_DOT] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1065),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ_GT] = ACTIONS(1065),
    [anon_sym_when] = ACTIONS(1065),
    [anon_sym_case] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [472] = {
    [sym__assignment_operator] = STATE(298),
    [sym__cascade_subsection] = STATE(580),
    [sym__cascade_assignment_section] = STATE(939),
    [sym_index_selector] = STATE(581),
    [sym_unconditional_assignable_selector] = STATE(602),
    [sym_conditional_assignable_selector] = STATE(602),
    [sym__assignable_selector] = STATE(499),
    [sym_comment] = STATE(472),
    [sym_documentation_comment] = STATE(472),
    [aux_sym_cascade_section_repeat2] = STATE(483),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_RBRACK] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_QMARK] = ACTIONS(1155),
    [sym_equality_operator] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [sym__additive_operator] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_TILDE_SLASH] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_is] = ACTIONS(1153),
    [anon_sym_as] = ACTIONS(1153),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_QMARK_DOT] = ACTIONS(1155),
    [anon_sym_DOT_DOT] = ACTIONS(1153),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1153),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_EQ_GT] = ACTIONS(1153),
    [anon_sym_when] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [473] = {
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_comment] = STATE(473),
    [sym_documentation_comment] = STATE(473),
    [aux_sym_string_literal_repeat1] = STATE(473),
    [anon_sym_DQUOTE] = ACTIONS(1157),
    [anon_sym_SQUOTE] = ACTIONS(1160),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1166),
    [anon_sym_r_DQUOTE] = ACTIONS(1169),
    [anon_sym_r_SQUOTE] = ACTIONS(1172),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1175),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1178),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_COLON] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_RPAREN] = ACTIONS(1181),
    [anon_sym_QMARK_QMARK] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1183),
    [sym_equality_operator] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [sym__additive_operator] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_TILDE_SLASH] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_is] = ACTIONS(1181),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_QMARK_DOT] = ACTIONS(1183),
    [anon_sym_DOT_DOT] = ACTIONS(1181),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1181),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_EQ_GT] = ACTIONS(1181),
    [anon_sym_when] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_show] = ACTIONS(1181),
    [anon_sym_hide] = ACTIONS(1181),
    [anon_sym_deferred] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [474] = {
    [sym__string_literal_double_quotes] = STATE(627),
    [sym__string_literal_single_quotes] = STATE(627),
    [sym__string_literal_double_quotes_multiple] = STATE(627),
    [sym__string_literal_single_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_double_quotes] = STATE(627),
    [sym__raw_string_literal_single_quotes] = STATE(627),
    [sym__raw_string_literal_double_quotes_multiple] = STATE(627),
    [sym__raw_string_literal_single_quotes_multiple] = STATE(627),
    [sym_comment] = STATE(474),
    [sym_documentation_comment] = STATE(474),
    [aux_sym_string_literal_repeat1] = STATE(473),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(89),
    [anon_sym_r_DQUOTE] = ACTIONS(91),
    [anon_sym_r_SQUOTE] = ACTIONS(93),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(95),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(97),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACK] = ACTIONS(1185),
    [anon_sym_COLON] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_RPAREN] = ACTIONS(1185),
    [anon_sym_QMARK_QMARK] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1187),
    [sym_equality_operator] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [sym__additive_operator] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_TILDE_SLASH] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_is] = ACTIONS(1185),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_QMARK_DOT] = ACTIONS(1187),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_EQ_GT] = ACTIONS(1185),
    [anon_sym_when] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1185),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_show] = ACTIONS(1185),
    [anon_sym_hide] = ACTIONS(1185),
    [anon_sym_deferred] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [475] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1361),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(687),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(475),
    [sym_documentation_comment] = STATE(475),
    [aux_sym_program_repeat4] = STATE(479),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [476] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1361),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(687),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(476),
    [sym_documentation_comment] = STATE(476),
    [aux_sym_program_repeat4] = STATE(479),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [477] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1361),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(687),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(477),
    [sym_documentation_comment] = STATE(477),
    [aux_sym_program_repeat4] = STATE(479),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [478] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1361),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(687),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(478),
    [sym_documentation_comment] = STATE(478),
    [aux_sym_program_repeat4] = STATE(479),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(1035),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [479] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1361),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(687),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(479),
    [sym_documentation_comment] = STATE(479),
    [aux_sym_program_repeat4] = STATE(479),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1200),
    [anon_sym_final] = ACTIONS(1203),
    [anon_sym_inline] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(1209),
    [anon_sym_extension] = ACTIONS(1212),
    [sym_void_type] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1218),
    [anon_sym_Function] = ACTIONS(1221),
    [anon_sym_get] = ACTIONS(1224),
    [anon_sym_interface] = ACTIONS(1227),
    [anon_sym_base] = ACTIONS(1230),
    [anon_sym_abstract] = ACTIONS(1233),
    [anon_sym_sealed] = ACTIONS(1236),
    [anon_sym_mixin] = ACTIONS(1239),
    [anon_sym_set] = ACTIONS(1242),
    [anon_sym_typedef] = ACTIONS(1245),
    [sym_const_builtin] = ACTIONS(1248),
    [anon_sym_late] = ACTIONS(1251),
    [anon_sym_external] = ACTIONS(1254),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [480] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1361),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(687),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(480),
    [sym_documentation_comment] = STATE(480),
    [aux_sym_program_repeat4] = STATE(479),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(1141),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [481] = {
    [aux_sym__if_null_expression] = STATE(884),
    [sym_relational_operator] = STATE(329),
    [sym_shift_operator] = STATE(343),
    [sym__shift_operator] = STATE(1397),
    [sym_additive_operator] = STATE(368),
    [sym_type_test] = STATE(957),
    [sym_is_operator] = STATE(2089),
    [sym_type_cast] = STATE(956),
    [sym_as_operator] = STATE(2090),
    [sym_cascade_section] = STATE(914),
    [sym_logical_and_operator] = STATE(366),
    [sym_logical_or_operator] = STATE(365),
    [sym_comment] = STATE(481),
    [sym_documentation_comment] = STATE(481),
    [aux_sym__expression_repeat1] = STATE(819),
    [aux_sym_logical_or_expression_repeat1] = STATE(834),
    [aux_sym_logical_and_expression_repeat1] = STATE(835),
    [aux_sym_bitwise_or_expression_repeat1] = STATE(839),
    [aux_sym_bitwise_xor_expression_repeat1] = STATE(840),
    [aux_sym_bitwise_and_expression_repeat1] = STATE(841),
    [aux_sym_shift_expression_repeat1] = STATE(792),
    [aux_sym_additive_expression_repeat1] = STATE(833),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_QMARK_QMARK] = ACTIONS(1259),
    [anon_sym_QMARK] = ACTIONS(1261),
    [sym_equality_operator] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(400),
    [anon_sym_GT] = ACTIONS(400),
    [anon_sym_LT_EQ] = ACTIONS(402),
    [anon_sym_GT_EQ] = ACTIONS(402),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_GT_GT_GT] = ACTIONS(1271),
    [sym__additive_operator] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1277),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_TILDE_SLASH] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_is] = ACTIONS(1279),
    [anon_sym_as] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_QMARK_DOT] = ACTIONS(1277),
    [anon_sym_DOT_DOT] = ACTIONS(1283),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1283),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_EQ_GT] = ACTIONS(1257),
    [anon_sym_when] = ACTIONS(1257),
    [anon_sym_case] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1286),
    [anon_sym_PIPE_PIPE] = ACTIONS(1288),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [482] = {
    [sym__top_level_definition] = STATE(1774),
    [sym_annotation] = STATE(1361),
    [sym_enum_declaration] = STATE(1769),
    [sym_type_alias] = STATE(1769),
    [sym__class_modifiers] = STATE(3195),
    [sym__mixin_class_modifiers] = STATE(3373),
    [sym_class_definition] = STATE(1769),
    [sym_extension_declaration] = STATE(1769),
    [sym__metadata] = STATE(687),
    [sym_mixin_declaration] = STATE(1769),
    [sym_getter_signature] = STATE(2207),
    [sym_setter_signature] = STATE(2207),
    [sym__type] = STATE(2433),
    [sym__type_not_function] = STATE(1796),
    [sym__type_not_void_not_function] = STATE(1896),
    [sym_function_type] = STATE(1848),
    [aux_sym__function_type_tails] = STATE(1605),
    [sym__function_type_tail] = STATE(1704),
    [sym_record_type] = STATE(1805),
    [sym__type_name] = STATE(1530),
    [sym_inferred_type] = STATE(2737),
    [sym_function_signature] = STATE(2207),
    [sym__function_builtin_identifier] = STATE(1463),
    [sym__get] = STATE(2411),
    [sym_interface] = STATE(3539),
    [sym_base] = STATE(2767),
    [sym_abstract] = STATE(2228),
    [sym_sealed] = STATE(3539),
    [sym_mixin] = STATE(3250),
    [sym__set] = STATE(2377),
    [sym__typedef] = STATE(2082),
    [sym_final_builtin] = STATE(1989),
    [sym__late_builtin] = STATE(1957),
    [sym__external_builtin] = STATE(1818),
    [sym_comment] = STATE(482),
    [sym_documentation_comment] = STATE(482),
    [aux_sym_program_repeat4] = STATE(479),
    [aux_sym__metadata_repeat1] = STATE(1308),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_enum] = ACTIONS(23),
    [anon_sym_final] = ACTIONS(25),
    [anon_sym_inline] = ACTIONS(27),
    [anon_sym_class] = ACTIONS(29),
    [anon_sym_extension] = ACTIONS(31),
    [sym_void_type] = ACTIONS(33),
    [anon_sym_var] = ACTIONS(35),
    [anon_sym_Function] = ACTIONS(45),
    [anon_sym_get] = ACTIONS(47),
    [anon_sym_interface] = ACTIONS(51),
    [anon_sym_base] = ACTIONS(53),
    [anon_sym_abstract] = ACTIONS(55),
    [anon_sym_sealed] = ACTIONS(57),
    [anon_sym_mixin] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_typedef] = ACTIONS(63),
    [sym_const_builtin] = ACTIONS(65),
    [anon_sym_late] = ACTIONS(67),
    [anon_sym_external] = ACTIONS(69),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [483] = {
    [sym__cascade_subsection] = STATE(580),
    [sym_index_selector] = STATE(581),
    [sym_unconditional_assignable_selector] = STATE(602),
    [sym_conditional_assignable_selector] = STATE(602),
    [sym__assignable_selector] = STATE(499),
    [sym_comment] = STATE(483),
    [sym_documentation_comment] = STATE(483),
    [aux_sym_cascade_section_repeat2] = STATE(483),
    [anon_sym_RBRACE] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1294),
    [anon_sym_COMMA] = ACTIONS(1292),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_COLON] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_EQ] = ACTIONS(1297),
    [anon_sym_PLUS_EQ] = ACTIONS(1292),
    [anon_sym_DASH_EQ] = ACTIONS(1292),
    [anon_sym_STAR_EQ] = ACTIONS(1292),
    [anon_sym_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_PERCENT_EQ] = ACTIONS(1292),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1292),
    [anon_sym_LT_LT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1292),
    [anon_sym_AMP_EQ] = ACTIONS(1292),
    [anon_sym_CARET_EQ] = ACTIONS(1292),
    [anon_sym_PIPE_EQ] = ACTIONS(1292),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1292),
    [anon_sym_QMARK_QMARK] = ACTIONS(1297),
    [anon_sym_QMARK] = ACTIONS(1299),
    [sym_equality_operator] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1297),
    [anon_sym_GT] = ACTIONS(1297),
    [anon_sym_LT_EQ] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1297),
    [anon_sym_CARET] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1297),
    [anon_sym_LT_LT] = ACTIONS(1297),
    [anon_sym_GT_GT] = ACTIONS(1297),
    [anon_sym_GT_GT_GT] = ACTIONS(1297),
    [sym__additive_operator] = ACTIONS(1297),
    [anon_sym_STAR] = ACTIONS(1297),
    [anon_sym_SLASH] = ACTIONS(1297),
    [anon_sym_PERCENT] = ACTIONS(1297),
    [anon_sym_TILDE_SLASH] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1297),
    [anon_sym_is] = ACTIONS(1292),
    [anon_sym_as] = ACTIONS(1292),
    [anon_sym_DOT] = ACTIONS(1302),
    [anon_sym_QMARK_DOT] = ACTIONS(1305),
    [anon_sym_DOT_DOT] = ACTIONS(1292),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(1292),
    [anon_sym_when] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_AMP_AMP] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1292),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [484] = {
    [sym_comment] = STATE(484),
    [sym_documentation_comment] = STATE(484),
    [sym_identifier] = ACTIONS(1308),
    [anon_sym_POUND] = ACTIONS(1310),
    [sym_decimal_integer_literal] = ACTIONS(1308),
    [sym_hex_integer_literal] = ACTIONS(1310),
    [sym_decimal_floating_point_literal] = ACTIONS(1308),
    [anon_sym_true] = ACTIONS(1308),
    [anon_sym_false] = ACTIONS(1308),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1310),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1310),
    [anon_sym_r_DQUOTE] = ACTIONS(1308),
    [anon_sym_r_SQUOTE] = ACTIONS(1308),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1310),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1310),
    [anon_sym_null] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1310),
    [anon_sym_throw] = ACTIONS(1308),
    [anon_sym_LT] = ACTIONS(1310),
    [sym_increment_operator] = ACTIONS(1310),
    [sym_minus_operator] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1310),
    [anon_sym_await] = ACTIONS(1308),
    [anon_sym_switch] = ACTIONS(1308),
    [anon_sym_default] = ACTIONS(1308),
    [anon_sym_do] = ACTIONS(1308),
    [anon_sym_while] = ACTIONS(1308),
    [anon_sym_continue] = ACTIONS(1308),
    [anon_sym_yield] = ACTIONS(1308),
    [anon_sym_return] = ACTIONS(1308),
    [anon_sym_on] = ACTIONS(1308),
    [anon_sym_try] = ACTIONS(1308),
    [anon_sym_catch] = ACTIONS(1308),
    [anon_sym_finally] = ACTIONS(1308),
    [anon_sym_if] = ACTIONS(1308),
    [anon_sym_case] = ACTIONS(1308),
    [anon_sym_else] = ACTIONS(1308),
    [anon_sym_for] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(1310),
    [anon_sym_final] = ACTIONS(1308),
    [sym_void_type] = ACTIONS(1308),
    [anon_sym_var] = ACTIONS(1308),
    [sym_break_builtin] = ACTIONS(1308),
    [sym_assert_builtin] = ACTIONS(1308),
    [sym_rethrow_builtin] = ACTIONS(1308),
    [anon_sym_covariant] = ACTIONS(1308),
    [anon_sym_Function] = ACTIONS(1308),
    [anon_sym_get] = ACTIONS(1308),
    [anon_sym_set] = ACTIONS(1308),
    [anon_sym_new] = ACTIONS(1308),
    [sym_const_builtin] = ACTIONS(1308),
    [anon_sym_late] = ACTIONS(1308),
    [anon_sym_this] = ACTIONS(1308),
    [anon_sym_super] = ACTIONS(1308),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [485] = {
    [sym_comment] = STATE(485),
    [sym_documentation_comment] = STATE(485),
    [sym_identifier] = ACTIONS(973),
    [anon_sym_POUND] = ACTIONS(975),
    [sym_decimal_integer_literal] = ACTIONS(973),
    [sym_hex_integer_literal] = ACTIONS(975),
    [sym_decimal_floating_point_literal] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(973),
    [anon_sym_false] = ACTIONS(973),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_r_DQUOTE] = ACTIONS(973),
    [anon_sym_r_SQUOTE] = ACTIONS(973),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(975),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_null] = ACTIONS(973),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(975),
    [sym_increment_operator] = ACTIONS(975),
    [sym_minus_operator] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(975),
    [anon_sym_await] = ACTIONS(973),
    [anon_sym_switch] = ACTIONS(973),
    [anon_sym_default] = ACTIONS(973),
    [anon_sym_do] = ACTIONS(973),
    [anon_sym_while] = ACTIONS(973),
    [anon_sym_continue] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(973),
    [anon_sym_return] = ACTIONS(973),
    [anon_sym_on] = ACTIONS(973),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_catch] = ACTIONS(973),
    [anon_sym_finally] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(973),
    [anon_sym_AT] = ACTIONS(975),
    [anon_sym_final] = ACTIONS(973),
    [sym_void_type] = ACTIONS(973),
    [anon_sym_var] = ACTIONS(973),
    [sym_break_builtin] = ACTIONS(973),
    [sym_assert_builtin] = ACTIONS(973),
    [sym_rethrow_builtin] = ACTIONS(973),
    [anon_sym_covariant] = ACTIONS(973),
    [anon_sym_Function] = ACTIONS(973),
    [anon_sym_get] = ACTIONS(973),
    [anon_sym_set] = ACTIONS(973),
    [anon_sym_new] = ACTIONS(973),
    [sym_const_builtin] = ACTIONS(973),
    [anon_sym_late] = ACTIONS(973),
    [anon_sym_this] = ACTIONS(973),
    [anon_sym_super] = ACTIONS(973),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [486] = {
    [sym_comment] = STATE(486),
    [sym_documentation_comment] = STATE(486),
    [sym_identifier] = ACTIONS(1312),
    [anon_sym_POUND] = ACTIONS(1314),
    [sym_decimal_integer_literal] = ACTIONS(1312),
    [sym_hex_integer_literal] = ACTIONS(1314),
    [sym_decimal_floating_point_literal] = ACTIONS(1312),
    [anon_sym_true] = ACTIONS(1312),
    [anon_sym_false] = ACTIONS(1312),
    [anon_sym_DQUOTE] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1312),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1314),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1314),
    [anon_sym_r_DQUOTE] = ACTIONS(1312),
    [anon_sym_r_SQUOTE] = ACTIONS(1312),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1314),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_null] = ACTIONS(1312),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_throw] = ACTIONS(1312),
    [anon_sym_LT] = ACTIONS(1314),
    [sym_increment_operator] = ACTIONS(1314),
    [sym_minus_operator] = ACTIONS(1312),
    [anon_sym_BANG] = ACTIONS(1314),
    [anon_sym_TILDE] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1312),
    [anon_sym_switch] = ACTIONS(1312),
    [anon_sym_default] = ACTIONS(1312),
    [anon_sym_do] = ACTIONS(1312),
    [anon_sym_while] = ACTIONS(1312),
    [anon_sym_continue] = ACTIONS(1312),
    [anon_sym_yield] = ACTIONS(1312),
    [anon_sym_return] = ACTIONS(1312),
    [anon_sym_on] = ACTIONS(1312),
    [anon_sym_try] = ACTIONS(1312),
    [anon_sym_catch] = ACTIONS(1312),
    [anon_sym_finally] = ACTIONS(1312),
    [anon_sym_if] = ACTIONS(1312),
    [anon_sym_case] = ACTIONS(1312),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_for] = ACTIONS(1312),
    [anon_sym_AT] = ACTIONS(1314),
    [anon_sym_final] = ACTIONS(1312),
    [sym_void_type] = ACTIONS(1312),
    [anon_sym_var] = ACTIONS(1312),
    [sym_break_builtin] = ACTIONS(1312),
    [sym_assert_builtin] = ACTIONS(1312),
    [sym_rethrow_builtin] = ACTIONS(1312),
    [anon_sym_covariant] = ACTIONS(1312),
    [anon_sym_Function] = ACTIONS(1312),
    [anon_sym_get] = ACTIONS(1312),
    [anon_sym_set] = ACTIONS(1312),
    [anon_sym_new] = ACTIONS(1312),
    [sym_const_builtin] = ACTIONS(1312),
    [anon_sym_late] = ACTIONS(1312),
    [anon_sym_this] = ACTIONS(1312),
    [anon_sym_super] = ACTIONS(1312),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [487] = {
    [sym__assignment_operator] = STATE(296),
    [sym__cascade_subsection] = STATE(652),
    [sym__cascade_assignment_section] = STATE(1111),
    [sym_index_selector] = STATE(649),
    [sym_unconditional_assignable_selector] = STATE(641),
    [sym_conditional_assignable_selector] = STATE(641),
    [sym__assignable_selector] = STATE(561),
    [sym_comment] = STATE(487),
    [sym_documentation_comment] = STATE(487),
    [aux_sym_cascade_section_repeat2] = STATE(509),
    [anon_sym_LBRACE] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_QMARK] = ACTIONS(1155),
    [sym_equality_operator] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1155),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [sym__additive_operator] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_TILDE_SLASH] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_is] = ACTIONS(1153),
    [anon_sym_as] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_QMARK_DOT] = ACTIONS(1155),
    [anon_sym_DOT_DOT] = ACTIONS(1153),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1153),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_EQ_GT] = ACTIONS(1153),
    [anon_sym_async] = ACTIONS(1155),
    [anon_sym_async_STAR] = ACTIONS(1153),
    [anon_sym_sync_STAR] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [488] = {
    [sym_comment] = STATE(488),
    [sym_documentation_comment] = STATE(488),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_POUND] = ACTIONS(1318),
    [sym_decimal_integer_literal] = ACTIONS(1316),
    [sym_hex_integer_literal] = ACTIONS(1318),
    [sym_decimal_floating_point_literal] = ACTIONS(1316),
    [anon_sym_true] = ACTIONS(1316),
    [anon_sym_false] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1316),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1318),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1318),
    [anon_sym_r_DQUOTE] = ACTIONS(1316),
    [anon_sym_r_SQUOTE] = ACTIONS(1316),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1318),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1318),
    [anon_sym_LBRACE] = ACTIONS(1318),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1318),
    [anon_sym_null] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1318),
    [anon_sym_throw] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(1318),
    [sym_increment_operator] = ACTIONS(1318),
    [sym_minus_operator] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1318),
    [anon_sym_await] = ACTIONS(1316),
    [anon_sym_switch] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1316),
    [anon_sym_do] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1316),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_yield] = ACTIONS(1316),
    [anon_sym_return] = ACTIONS(1316),
    [anon_sym_on] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(1316),
    [anon_sym_catch] = ACTIONS(1316),
    [anon_sym_finally] = ACTIONS(1316),
    [anon_sym_if] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1316),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_for] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1318),
    [anon_sym_final] = ACTIONS(1316),
    [sym_void_type] = ACTIONS(1316),
    [anon_sym_var] = ACTIONS(1316),
    [sym_break_builtin] = ACTIONS(1316),
    [sym_assert_builtin] = ACTIONS(1316),
    [sym_rethrow_builtin] = ACTIONS(1316),
    [anon_sym_covariant] = ACTIONS(1316),
    [anon_sym_Function] = ACTIONS(1316),
    [anon_sym_get] = ACTIONS(1316),
    [anon_sym_set] = ACTIONS(1316),
    [anon_sym_new] = ACTIONS(1316),
    [sym_const_builtin] = ACTIONS(1316),
    [anon_sym_late] = ACTIONS(1316),
    [anon_sym_this] = ACTIONS(1316),
    [anon_sym_super] = ACTIONS(1316),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [489] = {
    [sym_type_parameters] = STATE(2932),
    [sym__type_dot_identifier] = STATE(1612),
    [sym__formal_parameter_part] = STATE(2276),
    [sym_formal_parameter_list] = STATE(2020),
    [sym__strict_formal_parameter_list] = STATE(2016),
    [sym_comment] = STATE(489),
    [sym_documentation_comment] = STATE(489),
    [sym_identifier] = ACTIONS(1320),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(1322),
    [anon_sym_COMMA] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_EQ] = ACTIONS(1328),
    [anon_sym_PLUS_EQ] = ACTIONS(1330),
    [anon_sym_DASH_EQ] = ACTIONS(1330),
    [anon_sym_STAR_EQ] = ACTIONS(1330),
    [anon_sym_SLASH_EQ] = ACTIONS(1330),
    [anon_sym_PERCENT_EQ] = ACTIONS(1330),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1330),
    [anon_sym_LT_LT_EQ] = ACTIONS(1330),
    [anon_sym_GT_GT_EQ] = ACTIONS(1330),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1330),
    [anon_sym_AMP_EQ] = ACTIONS(1330),
    [anon_sym_CARET_EQ] = ACTIONS(1330),
    [anon_sym_PIPE_EQ] = ACTIONS(1330),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1330),
    [anon_sym_QMARK_QMARK] = ACTIONS(1332),
    [anon_sym_QMARK] = ACTIONS(1334),
    [sym_equality_operator] = ACTIONS(1322),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1332),
    [anon_sym_LT_EQ] = ACTIONS(1322),
    [anon_sym_GT_EQ] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1332),
    [anon_sym_CARET] = ACTIONS(1332),
    [anon_sym_AMP] = ACTIONS(1332),
    [anon_sym_LT_LT] = ACTIONS(1332),
    [anon_sym_GT_GT] = ACTIONS(1332),
    [anon_sym_GT_GT_GT] = ACTIONS(1332),
    [sym__additive_operator] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(1332),
    [anon_sym_SLASH] = ACTIONS(1332),
    [anon_sym_PERCENT] = ACTIONS(1332),
    [anon_sym_TILDE_SLASH] = ACTIONS(1332),
    [sym_increment_operator] = ACTIONS(1330),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_is] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(1332),
    [anon_sym_DOT] = ACTIONS(1341),
    [anon_sym_QMARK_DOT] = ACTIONS(1332),
    [anon_sym_DOT_DOT] = ACTIONS(1322),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1322),
    [anon_sym_SEMI] = ACTIONS(1322),
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_Function] = ACTIONS(1320),
    [anon_sym_get] = ACTIONS(1320),
    [anon_sym_set] = ACTIONS(1320),
    [anon_sym_AMP_AMP] = ACTIONS(1322),
    [anon_sym_PIPE_PIPE] = ACTIONS(1322),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [490] = {
    [sym__assignment_operator] = STATE(296),
    [sym__cascade_subsection] = STATE(652),
    [sym__cascade_assignment_section] = STATE(1123),
    [sym_index_selector] = STATE(649),
    [sym_unconditional_assignable_selector] = STATE(641),
    [sym_conditional_assignable_selector] = STATE(641),
    [sym__assignable_selector] = STATE(561),
    [sym_comment] = STATE(490),
    [sym_documentation_comment] = STATE(490),
    [aux_sym_cascade_section_repeat2] = STATE(509),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_PLUS_EQ] = ACTIONS(1069),
    [anon_sym_DASH_EQ] = ACTIONS(1069),
    [anon_sym_STAR_EQ] = ACTIONS(1069),
    [anon_sym_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT_EQ] = ACTIONS(1069),
    [anon_sym_TILDE_SLASH_EQ] = ACTIONS(1069),
    [anon_sym_LT_LT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1069),
    [anon_sym_AMP_EQ] = ACTIONS(1069),
    [anon_sym_CARET_EQ] = ACTIONS(1069),
    [anon_sym_PIPE_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1069),
    [anon_sym_QMARK_QMARK] = ACTIONS(1071),
    [anon_sym_QMARK] = ACTIONS(1071),
    [sym_equality_operator] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1071),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_LT_LT] = ACTIONS(1071),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1071),
    [sym__additive_operator] = ACTIONS(1071),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1071),
    [anon_sym_TILDE_SLASH] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_is] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_QMARK_DOT] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1065),
    [anon_sym_QMARK_DOT_DOT] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ_GT] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1071),
    [anon_sym_async_STAR] = ACTIONS(1065),
    [anon_sym_sync_STAR] = ACTIONS(1065),
    [anon_sym_AMP_AMP] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [491] = {
    [sym_comment] = STATE(491),
    [sym_documentation_comment] = STATE(491),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_POUND] = ACTIONS(1039),
    [sym_decimal_integer_literal] = ACTIONS(1041),
    [sym_hex_integer_literal] = ACTIONS(1039),
    [sym_decimal_floating_point_literal] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1041),
    [anon_sym_SQUOTE] = ACTIONS(1041),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1039),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1039),
    [anon_sym_r_DQUOTE] = ACTIONS(1041),
    [anon_sym_r_SQUOTE] = ACTIONS(1041),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1039),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1039),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_LT] = ACTIONS(1039),
    [sym_increment_operator] = ACTIONS(1039),
    [sym_minus_operator] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1041),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_default] = ACTIONS(1041),
    [anon_sym_do] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_on] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_finally] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_case] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
    [anon_sym_final] = ACTIONS(1041),
    [sym_void_type] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [sym_break_builtin] = ACTIONS(1041),
    [sym_assert_builtin] = ACTIONS(1041),
    [sym_rethrow_builtin] = ACTIONS(1041),
    [anon_sym_covariant] = ACTIONS(1041),
    [anon_sym_Function] = ACTIONS(1041),
    [anon_sym_get] = ACTIONS(1041),
    [anon_sym_set] = ACTIONS(1041),
    [anon_sym_new] = ACTIONS(1041),
    [sym_const_builtin] = ACTIONS(1041),
    [anon_sym_late] = ACTIONS(1041),
    [anon_sym_this] = ACTIONS(1041),
    [anon_sym_super] = ACTIONS(1041),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [492] = {
    [sym_comment] = STATE(492),
    [sym_documentation_comment] = STATE(492),
    [sym_identifier] = ACTIONS(1345),
    [anon_sym_POUND] = ACTIONS(1347),
    [sym_decimal_integer_literal] = ACTIONS(1345),
    [sym_hex_integer_literal] = ACTIONS(1347),
    [sym_decimal_floating_point_literal] = ACTIONS(1345),
    [anon_sym_true] = ACTIONS(1345),
    [anon_sym_false] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_SQUOTE] = ACTIONS(1345),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1347),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1347),
    [anon_sym_r_DQUOTE] = ACTIONS(1345),
    [anon_sym_r_SQUOTE] = ACTIONS(1345),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1347),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(1347),
    [anon_sym_RBRACE] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1347),
    [anon_sym_null] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1347),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1347),
    [sym_increment_operator] = ACTIONS(1347),
    [sym_minus_operator] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_TILDE] = ACTIONS(1347),
    [anon_sym_await] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1345),
    [anon_sym_default] = ACTIONS(1345),
    [anon_sym_do] = ACTIONS(1345),
    [anon_sym_while] = ACTIONS(1345),
    [anon_sym_continue] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(1345),
    [anon_sym_return] = ACTIONS(1345),
    [anon_sym_on] = ACTIONS(1345),
    [anon_sym_try] = ACTIONS(1345),
    [anon_sym_catch] = ACTIONS(1345),
    [anon_sym_finally] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_case] = ACTIONS(1345),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_for] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_final] = ACTIONS(1345),
    [sym_void_type] = ACTIONS(1345),
    [anon_sym_var] = ACTIONS(1345),
    [sym_break_builtin] = ACTIONS(1345),
    [sym_assert_builtin] = ACTIONS(1345),
    [sym_rethrow_builtin] = ACTIONS(1345),
    [anon_sym_covariant] = ACTIONS(1345),
    [anon_sym_Function] = ACTIONS(1345),
    [anon_sym_get] = ACTIONS(1345),
    [anon_sym_set] = ACTIONS(1345),
    [anon_sym_new] = ACTIONS(1345),
    [sym_const_builtin] = ACTIONS(1345),
    [anon_sym_late] = ACTIONS(1345),
    [anon_sym_this] = ACTIONS(1345),
    [anon_sym_super] = ACTIONS(1345),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
  [493] = {
    [sym_comment] = STATE(493),
    [sym_documentation_comment] = STATE(493),
    [sym_identifier] = ACTIONS(1349),
    [anon_sym_POUND] = ACTIONS(1351),
    [sym_decimal_integer_literal] = ACTIONS(1349),
    [sym_hex_integer_literal] = ACTIONS(1351),
    [sym_decimal_floating_point_literal] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1349),
    [anon_sym_false] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1351),
    [anon_sym_r_DQUOTE] = ACTIONS(1349),
    [anon_sym_r_SQUOTE] = ACTIONS(1349),
    [anon_sym_r_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_r_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_RBRACE] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_null] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_throw] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [sym_increment_operator] = ACTIONS(1351),
    [sym_minus_operator] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_TILDE] = ACTIONS(1351),
    [anon_sym_await] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1349),
    [anon_sym_do] = ACTIONS(1349),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_yield] = ACTIONS(1349),
    [anon_sym_return] = ACTIONS(1349),
    [anon_sym_on] = ACTIONS(1349),
    [anon_sym_try] = ACTIONS(1349),
    [anon_sym_catch] = ACTIONS(1349),
    [anon_sym_finally] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1349),
    [anon_sym_case] = ACTIONS(1349),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_for] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_final] = ACTIONS(1349),
    [sym_void_type] = ACTIONS(1349),
    [anon_sym_var] = ACTIONS(1349),
    [sym_break_builtin] = ACTIONS(1349),
    [sym_assert_builtin] = ACTIONS(1349),
    [sym_rethrow_builtin] = ACTIONS(1349),
    [anon_sym_covariant] = ACTIONS(1349),
    [anon_sym_Function] = ACTIONS(1349),
    [anon_sym_get] = ACTIONS(1349),
    [anon_sym_set] = ACTIONS(1349),
    [anon_sym_new] = ACTIONS(1349),
    [sym_const_builtin] = ACTIONS(1349),
    [anon_sym_late] = ACTIONS(1349),
    [anon_sym_this] = ACTIONS(1349),
    [anon_sym_super] = ACTIONS(1349),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_SLASH_STAR] = ACTIONS(5),
    [anon_sym_SLASH_SLASH_SLASH] = ACTIONS(7),
    [sym__block_comment] = ACTIONS(9),
    [sym__documentation_block_comment] = ACTIONS(11),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(494), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1355), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1353), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [147] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(495), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1359), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1357), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [294] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    ACTIONS(1368), 1,
      anon_sym_LT,
    STATE(579), 1,
      sym_argument_part,
    STATE(583), 1,
      sym_arguments,
    STATE(3083), 1,
      sym_type_arguments,
    STATE(496), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_cascade_section_repeat1,
    ACTIONS(1366), 18,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1361), 33,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [385] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1373), 1,
      anon_sym_LPAREN,
    ACTIONS(1378), 1,
      anon_sym_LT,
    STATE(496), 1,
      aux_sym_cascade_section_repeat1,
    STATE(579), 1,
      sym_argument_part,
    STATE(583), 1,
      sym_arguments,
    STATE(3083), 1,
      sym_type_arguments,
    STATE(497), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1376), 18,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1371), 33,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [478] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(498), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1383), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1381), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [625] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1387), 1,
      anon_sym_LPAREN,
    ACTIONS(1392), 1,
      anon_sym_LT,
    STATE(497), 1,
      aux_sym_cascade_section_repeat1,
    STATE(579), 1,
      sym_argument_part,
    STATE(583), 1,
      sym_arguments,
    STATE(3083), 1,
      sym_type_arguments,
    STATE(499), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1390), 18,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1385), 33,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [718] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(500), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1397), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1395), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [865] = 37,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1403), 1,
      sym_equality_operator,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(501), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1401), 5,
      anon_sym_QMARK,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1399), 20,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [1004] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(502), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1408), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1406), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [1151] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(503), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1410), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [1298] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(504), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1416), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1414), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [1445] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(505), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1420), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1418), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [1592] = 36,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(506), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1424), 5,
      anon_sym_QMARK,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1422), 21,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [1729] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(507), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
  [1876] = 44,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1012), 1,
      aux_sym__expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1133), 1,
      sym_cascade_section,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1450), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(508), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1277), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1257), 11,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [2028] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1453), 1,
      anon_sym_LBRACK,
    ACTIONS(1456), 1,
      anon_sym_QMARK,
    ACTIONS(1459), 1,
      anon_sym_DOT,
    ACTIONS(1462), 1,
      anon_sym_QMARK_DOT,
    STATE(561), 1,
      sym__assignable_selector,
    STATE(649), 1,
      sym_index_selector,
    STATE(652), 1,
      sym__cascade_subsection,
    STATE(641), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(509), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_cascade_section_repeat2,
    ACTIONS(1297), 18,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1292), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [2124] = 44,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1259), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1261), 1,
      anon_sym_QMARK,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1265), 1,
      anon_sym_PIPE,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1269), 1,
      anon_sym_AMP,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(834), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(835), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(884), 1,
      aux_sym__if_null_expression,
    STATE(914), 1,
      sym_cascade_section,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1007), 1,
      aux_sym__expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1465), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(510), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1277), 4,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1257), 12,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_EQ_GT,
      anon_sym_when,
  [2276] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(511), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1469), 16,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1467), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [2356] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(512), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1473), 16,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1471), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [2436] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1324), 1,
      anon_sym_LPAREN,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1337), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1480), 1,
      anon_sym_COLON,
    ACTIONS(1482), 1,
      anon_sym_QMARK,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2275), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(1475), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1486), 2,
      anon_sym_BANG,
      anon_sym_as,
    ACTIONS(1489), 2,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(513), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(1322), 6,
      anon_sym_LBRACK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 15,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
  [2548] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1324), 1,
      anon_sym_LPAREN,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1337), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1480), 1,
      anon_sym_COLON,
    ACTIONS(1482), 1,
      anon_sym_QMARK,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2275), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(1486), 2,
      anon_sym_BANG,
      anon_sym_as,
    ACTIONS(1489), 2,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1492), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(514), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(1322), 6,
      anon_sym_LBRACK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 15,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
  [2660] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1324), 1,
      anon_sym_LPAREN,
    ACTIONS(1337), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1482), 1,
      anon_sym_QMARK,
    ACTIONS(1496), 1,
      anon_sym_EQ,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2275), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(1486), 2,
      anon_sym_BANG,
      anon_sym_as,
    ACTIONS(1489), 2,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(515), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(1322), 7,
      anon_sym_LBRACK,
      anon_sym_COLON,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 15,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
  [2770] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1324), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_QMARK,
    ACTIONS(1337), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_EQ,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2275), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(516), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1499), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(1322), 8,
      anon_sym_LBRACK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [2876] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1324), 1,
      anon_sym_LPAREN,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_QMARK,
    ACTIONS(1337), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1502), 1,
      anon_sym_COLON,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2275), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(1499), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(517), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(1322), 8,
      anon_sym_LBRACK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [2984] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(518), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1506), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1504), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3063] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(519), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1510), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1508), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3142] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(520), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1514), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1512), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3221] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(521), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 16,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    ACTIONS(1322), 20,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [3312] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(522), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1521), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1519), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3391] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(523), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1525), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1523), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3470] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(524), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1529), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1527), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3549] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(525), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1533), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1531), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3628] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(526), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1537), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1535), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3707] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(527), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1541), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1539), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3786] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(528), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1545), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1543), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3865] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(529), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1549), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1547), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [3944] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(530), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1553), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1551), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4023] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1559), 1,
      anon_sym_else,
    STATE(531), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1557), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1555), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4104] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(532), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 16,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    ACTIONS(1322), 21,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [4193] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(533), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1563), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1561), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4272] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(534), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1567), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1565), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4351] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(535), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1571), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1569), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4430] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(536), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1575), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1573), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4509] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(537), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1579), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1577), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4588] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(538), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1583), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1581), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4667] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(539), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1587), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1585), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4746] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(540), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1591), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1589), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4825] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(541), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1595), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1593), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4904] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(542), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1599), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1597), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [4983] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(543), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1603), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1601), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5062] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(544), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1607), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1605), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5141] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(545), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1611), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1609), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5220] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(546), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1615), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1613), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5299] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1621), 1,
      anon_sym_else,
    STATE(547), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1619), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1617), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5380] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(548), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1129), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1127), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5459] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(549), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1625), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1623), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5538] = 58,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_final,
    ACTIONS(27), 1,
      anon_sym_inline,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(43), 1,
      anon_sym_export,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(49), 1,
      anon_sym_import,
    ACTIONS(51), 1,
      anon_sym_interface,
    ACTIONS(53), 1,
      anon_sym_base,
    ACTIONS(55), 1,
      anon_sym_abstract,
    ACTIONS(57), 1,
      anon_sym_sealed,
    ACTIONS(59), 1,
      anon_sym_mixin,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(63), 1,
      anon_sym_typedef,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(1627), 1,
      anon_sym_part,
    ACTIONS(1629), 1,
      anon_sym_enum,
    ACTIONS(1631), 1,
      anon_sym_extension,
    ACTIONS(1633), 1,
      anon_sym_library,
    ACTIONS(1635), 1,
      sym_part_of_builtin,
    ACTIONS(1637), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1576), 1,
      sym_import_specification,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1817), 1,
      sym__import,
    STATE(1840), 1,
      sym__export,
    STATE(1848), 1,
      sym_function_type,
    STATE(1880), 1,
      sym__external_builtin,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1934), 1,
      sym__late_builtin,
    STATE(1971), 1,
      sym_final_builtin,
    STATE(2073), 1,
      sym__typedef,
    STATE(2228), 1,
      sym_abstract,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2419), 1,
      sym__type,
    STATE(2970), 1,
      sym_inferred_type,
    STATE(3001), 1,
      sym_base,
    STATE(3026), 1,
      sym_mixin,
    STATE(3032), 1,
      sym__class_modifiers,
    STATE(3560), 1,
      sym__mixin_class_modifiers,
    STATE(550), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3539), 2,
      sym_interface,
      sym_sealed,
    STATE(2195), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [5717] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(551), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1641), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1639), 40,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [5796] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(552), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1643), 35,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [5874] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(553), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1359), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1357), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [6018] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(554), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1410), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [6162] = 37,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(1647), 1,
      sym_equality_operator,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(555), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1401), 6,
      anon_sym_QMARK,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1399), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [6298] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(556), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1652), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1650), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_case,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [6376] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(557), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1416), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1414), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [6520] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(558), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1420), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1418), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [6664] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(559), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1432), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [6808] = 57,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_final,
    ACTIONS(27), 1,
      anon_sym_inline,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(43), 1,
      anon_sym_export,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(49), 1,
      anon_sym_import,
    ACTIONS(51), 1,
      anon_sym_interface,
    ACTIONS(53), 1,
      anon_sym_base,
    ACTIONS(55), 1,
      anon_sym_abstract,
    ACTIONS(57), 1,
      anon_sym_sealed,
    ACTIONS(59), 1,
      anon_sym_mixin,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(63), 1,
      anon_sym_typedef,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(1627), 1,
      anon_sym_part,
    ACTIONS(1629), 1,
      anon_sym_enum,
    ACTIONS(1631), 1,
      anon_sym_extension,
    ACTIONS(1635), 1,
      sym_part_of_builtin,
    ACTIONS(1637), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1576), 1,
      sym_import_specification,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1817), 1,
      sym__import,
    STATE(1840), 1,
      sym__export,
    STATE(1848), 1,
      sym_function_type,
    STATE(1880), 1,
      sym__external_builtin,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1934), 1,
      sym__late_builtin,
    STATE(1971), 1,
      sym_final_builtin,
    STATE(2073), 1,
      sym__typedef,
    STATE(2228), 1,
      sym_abstract,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2419), 1,
      sym__type,
    STATE(2970), 1,
      sym_inferred_type,
    STATE(3001), 1,
      sym_base,
    STATE(3026), 1,
      sym_mixin,
    STATE(3032), 1,
      sym__class_modifiers,
    STATE(3560), 1,
      sym__mixin_class_modifiers,
    STATE(560), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3539), 2,
      sym_interface,
      sym_sealed,
    STATE(2195), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [6984] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1392), 1,
      anon_sym_LT,
    ACTIONS(1654), 1,
      anon_sym_LPAREN,
    STATE(573), 1,
      aux_sym_cascade_section_repeat1,
    STATE(650), 1,
      sym_argument_part,
    STATE(653), 1,
      sym_arguments,
    STATE(3126), 1,
      sym_type_arguments,
    STATE(561), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1390), 20,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1385), 28,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7074] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(562), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1397), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1395), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [7218] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(563), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1657), 35,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7296] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(564), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1383), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1381), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [7440] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(565), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 35,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7518] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1368), 1,
      anon_sym_LT,
    ACTIONS(1665), 1,
      anon_sym_LPAREN,
    STATE(650), 1,
      sym_argument_part,
    STATE(653), 1,
      sym_arguments,
    STATE(3126), 1,
      sym_type_arguments,
    STATE(566), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_cascade_section_repeat1,
    ACTIONS(1366), 20,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1361), 28,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7606] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(567), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1668), 35,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7684] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(568), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1676), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1678), 18,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1672), 21,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7766] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(569), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1408), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1406), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [7910] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1682), 1,
      anon_sym_EQ,
    STATE(570), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1684), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1686), 18,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1680), 21,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7992] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(571), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1690), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_QMARK_DOT,
      anon_sym_AT,
    ACTIONS(1688), 39,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      anon_sym_QMARK,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_DOT,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [8070] = 36,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(572), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1424), 6,
      anon_sym_QMARK,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1422), 17,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8204] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1378), 1,
      anon_sym_LT,
    ACTIONS(1692), 1,
      anon_sym_LPAREN,
    STATE(566), 1,
      aux_sym_cascade_section_repeat1,
    STATE(650), 1,
      sym_argument_part,
    STATE(653), 1,
      sym_arguments,
    STATE(3126), 1,
      sym_type_arguments,
    STATE(573), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1376), 20,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1371), 28,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8294] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1438), 1,
      anon_sym_QMARK,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1442), 1,
      anon_sym_PIPE,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(1446), 1,
      anon_sym_AMP,
    ACTIONS(1448), 1,
      anon_sym_as,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1008), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1010), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1054), 1,
      aux_sym__if_null_expression,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1118), 1,
      sym_type_cast,
    STATE(1143), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(2064), 1,
      sym_as_operator,
    STATE(2066), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(574), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1355), 5,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1353), 13,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [8438] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(575), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1695), 35,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8516] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1699), 1,
      anon_sym_EQ,
    STATE(576), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1686), 18,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1680), 21,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8598] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1705), 1,
      anon_sym_RBRACE,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    STATE(596), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(577), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [8771] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(578), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1695), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8848] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(579), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1717), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1715), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8925] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(580), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1721), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1719), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [9002] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(581), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1643), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [9079] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(582), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1725), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1723), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [9156] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(583), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1729), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1727), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [9233] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(584), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1657), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [9310] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(585), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1733), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1731), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [9387] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1735), 1,
      anon_sym_RBRACE,
    STATE(597), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(586), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [9560] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(587), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1739), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1737), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [9637] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1741), 1,
      anon_sym_RBRACE,
    STATE(597), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(588), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [9810] = 55,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1743), 1,
      sym_identifier,
    ACTIONS(1746), 1,
      anon_sym_RBRACE,
    ACTIONS(1748), 1,
      anon_sym_LPAREN,
    ACTIONS(1751), 1,
      anon_sym_AT,
    ACTIONS(1754), 1,
      anon_sym_final,
    ACTIONS(1757), 1,
      sym_void_type,
    ACTIONS(1760), 1,
      anon_sym_var,
    ACTIONS(1763), 1,
      anon_sym_covariant,
    ACTIONS(1766), 1,
      anon_sym_factory,
    ACTIONS(1769), 1,
      anon_sym_Function,
    ACTIONS(1772), 1,
      anon_sym_get,
    ACTIONS(1775), 1,
      anon_sym_operator,
    ACTIONS(1778), 1,
      anon_sym_set,
    ACTIONS(1781), 1,
      anon_sym_static,
    ACTIONS(1784), 1,
      sym_const_builtin,
    ACTIONS(1787), 1,
      anon_sym_late,
    ACTIONS(1790), 1,
      anon_sym_external,
    STATE(685), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2370), 1,
      sym_method_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3265), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(589), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_extension_body_repeat1,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [9981] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1741), 1,
      anon_sym_RBRACE,
    STATE(599), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(590), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [10154] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(591), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [10231] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1793), 1,
      anon_sym_DQUOTE,
    ACTIONS(1796), 1,
      anon_sym_SQUOTE,
    ACTIONS(1799), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1802), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1805), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1808), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1811), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1814), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(592), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_string_literal_repeat1,
    STATE(729), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
    ACTIONS(1183), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1181), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [10326] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1817), 1,
      anon_sym_RBRACE,
    STATE(598), 1,
      aux_sym_extension_body_repeat1,
    STATE(685), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2370), 1,
      sym_method_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3265), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(593), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [10499] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(594), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1821), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1819), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [10576] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(708), 1,
      anon_sym_DQUOTE,
    ACTIONS(710), 1,
      anon_sym_SQUOTE,
    ACTIONS(712), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(714), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(716), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(718), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(720), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(722), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(592), 1,
      aux_sym_string_literal_repeat1,
    STATE(595), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(729), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
    ACTIONS(1187), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1185), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [10673] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1823), 1,
      anon_sym_RBRACE,
    STATE(597), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(596), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [10846] = 55,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1825), 1,
      sym_identifier,
    ACTIONS(1828), 1,
      anon_sym_RBRACE,
    ACTIONS(1830), 1,
      anon_sym_LPAREN,
    ACTIONS(1833), 1,
      anon_sym_AT,
    ACTIONS(1836), 1,
      anon_sym_final,
    ACTIONS(1839), 1,
      sym_void_type,
    ACTIONS(1842), 1,
      anon_sym_var,
    ACTIONS(1845), 1,
      anon_sym_covariant,
    ACTIONS(1848), 1,
      anon_sym_factory,
    ACTIONS(1851), 1,
      anon_sym_Function,
    ACTIONS(1854), 1,
      anon_sym_get,
    ACTIONS(1857), 1,
      anon_sym_operator,
    ACTIONS(1860), 1,
      anon_sym_set,
    ACTIONS(1863), 1,
      anon_sym_static,
    ACTIONS(1866), 1,
      sym_const_builtin,
    ACTIONS(1869), 1,
      anon_sym_late,
    ACTIONS(1872), 1,
      anon_sym_external,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(597), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_enum_body_repeat2,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [11017] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1875), 1,
      anon_sym_RBRACE,
    STATE(589), 1,
      aux_sym_extension_body_repeat1,
    STATE(685), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2370), 1,
      sym_method_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3265), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(598), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [11190] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1877), 1,
      anon_sym_RBRACE,
    STATE(597), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(599), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [11363] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(600), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1881), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1879), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [11440] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1883), 1,
      anon_sym_RBRACE,
    STATE(588), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(601), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [11613] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(602), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 19,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1668), 34,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [11690] = 56,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    ACTIONS(1877), 1,
      anon_sym_RBRACE,
    STATE(586), 1,
      aux_sym_enum_body_repeat2,
    STATE(696), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2417), 1,
      sym_method_signature,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3049), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(603), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [11863] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(604), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1322), 15,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1332), 18,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_async,
  [11951] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(605), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1322), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1332), 18,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_async,
  [12037] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(606), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1887), 15,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_DOT_DOT_DOT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_AT,
    ACTIONS(1885), 37,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_do,
      anon_sym_while,
      anon_sym_continue,
      anon_sym_yield,
      anon_sym_return,
      anon_sym_try,
      anon_sym_if,
      anon_sym_for,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      sym_break_builtin,
      sym_assert_builtin,
      sym_rethrow_builtin,
      anon_sym_covariant,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [12113] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(607), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1643), 30,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12188] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(608), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1889), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1891), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12263] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(786), 1,
      anon_sym_DQUOTE,
    ACTIONS(788), 1,
      anon_sym_SQUOTE,
    ACTIONS(790), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(792), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(794), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(796), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(798), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(800), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(610), 1,
      aux_sym_string_literal_repeat1,
    STATE(609), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1187), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    STATE(799), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
    ACTIONS(1185), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12358] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1893), 1,
      anon_sym_DQUOTE,
    ACTIONS(1896), 1,
      anon_sym_SQUOTE,
    ACTIONS(1899), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1902), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1905), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1908), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1911), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1914), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(610), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_string_literal_repeat1,
    ACTIONS(1183), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    STATE(799), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
    ACTIONS(1181), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12451] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(611), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1695), 30,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12526] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(612), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1661), 30,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12601] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(613), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1917), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1919), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12676] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(614), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1657), 30,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12751] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(615), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1921), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1923), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12826] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(616), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1925), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1927), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12901] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(617), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1929), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1931), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12976] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    ACTIONS(1939), 1,
      anon_sym_EQ,
    ACTIONS(1942), 1,
      anon_sym_LT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2447), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(1933), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(618), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 25,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13067] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(619), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1945), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1947), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13142] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(620), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1676), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1672), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1678), 20,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
  [13221] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1699), 1,
      anon_sym_EQ,
    STATE(621), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1680), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1686), 20,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
  [13300] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(622), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1668), 30,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13375] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1682), 1,
      anon_sym_EQ,
    STATE(623), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1684), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1680), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1686), 20,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
  [13454] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(624), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1949), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1951), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13529] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(625), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1953), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1955), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13604] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(626), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1957), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1959), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13679] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(627), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1961), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1963), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13754] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(628), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1965), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1967), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13829] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    ACTIONS(1939), 1,
      anon_sym_EQ,
    ACTIONS(1942), 1,
      anon_sym_LT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2447), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(629), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1933), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1663), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 24,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13920] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1482), 1,
      anon_sym_QMARK,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(1486), 2,
      anon_sym_BANG,
      anon_sym_as,
    STATE(630), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1489), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1322), 7,
      anon_sym_LBRACK,
      anon_sym_COLON,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 15,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_QMARK_DOT,
  [14015] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(631), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1969), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1971), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14090] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(632), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1973), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1975), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14165] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(633), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1977), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1979), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14240] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(634), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1981), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1983), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14315] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(635), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1985), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1987), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14390] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(636), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1989), 14,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1991), 37,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_if,
      anon_sym_case,
      anon_sym_else,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14465] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(637), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1725), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1723), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14539] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(638), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1657), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14613] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(639), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1739), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1737), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14687] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1993), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(640), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 15,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1322), 17,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14771] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(641), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1668), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14845] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1502), 1,
      anon_sym_COLON,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(1334), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(642), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1516), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(1322), 8,
      anon_sym_LBRACK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [14935] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2003), 1,
      anon_sym_QMARK,
    ACTIONS(2005), 1,
      anon_sym_LT,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2011), 1,
      anon_sym_DOT,
    ACTIONS(2013), 1,
      anon_sym_QMARK_DOT,
    STATE(552), 1,
      sym_index_selector,
    STATE(570), 1,
      sym__assignable_selector,
    STATE(670), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(567), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(643), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2007), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1997), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15041] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(644), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1821), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1819), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15115] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1502), 1,
      anon_sym_COLON,
    ACTIONS(2015), 1,
      anon_sym_RPAREN,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(1334), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1516), 2,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    STATE(645), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 8,
      anon_sym_LBRACK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [15207] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(646), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1661), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15281] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(647), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1733), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1731), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15355] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2019), 1,
      anon_sym_LBRACK,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2025), 1,
      anon_sym_QMARK,
    ACTIONS(2028), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_BANG,
    ACTIONS(2036), 1,
      anon_sym_DOT,
    ACTIONS(2039), 1,
      anon_sym_QMARK_DOT,
    STATE(552), 1,
      sym_index_selector,
    STATE(570), 1,
      sym__assignable_selector,
    STATE(672), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(567), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(648), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15461] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(649), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1643), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15535] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(650), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1717), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1715), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15609] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(651), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1695), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15683] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(652), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1721), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1719), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15757] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(653), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1729), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1727), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15831] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_LT,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2044), 1,
      anon_sym_QMARK,
    ACTIONS(2046), 1,
      anon_sym_DOT,
    ACTIONS(2048), 1,
      anon_sym_QMARK_DOT,
    STATE(669), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(836), 1,
      sym_index_selector,
    STATE(859), 1,
      sym__assignable_selector,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(654), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(858), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2007), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1997), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15937] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    ACTIONS(2050), 1,
      anon_sym_in,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(1334), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(655), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 10,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [16027] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    ACTIONS(1942), 1,
      anon_sym_LT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2447), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(1933), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(656), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 18,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 24,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16115] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(657), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1881), 21,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1879), 29,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16189] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(1334), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(658), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 11,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [16277] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2022), 1,
      anon_sym_LPAREN,
    ACTIONS(2028), 1,
      anon_sym_LT,
    ACTIONS(2033), 1,
      anon_sym_BANG,
    ACTIONS(2052), 1,
      anon_sym_LBRACK,
    ACTIONS(2055), 1,
      anon_sym_QMARK,
    ACTIONS(2058), 1,
      anon_sym_DOT,
    ACTIONS(2061), 1,
      anon_sym_QMARK_DOT,
    STATE(664), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(836), 1,
      sym_index_selector,
    STATE(859), 1,
      sym__assignable_selector,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(659), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(858), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16383] = 43,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(914), 1,
      sym_cascade_section,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2095), 1,
      aux_sym__expression_repeat1,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2076), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(660), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1257), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [16526] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(661), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 17,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1668), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16599] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1674), 1,
      anon_sym_EQ,
    STATE(662), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1676), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1678), 16,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1672), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16676] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2080), 1,
      anon_sym_LBRACK,
    ACTIONS(2083), 1,
      anon_sym_LPAREN,
    ACTIONS(2086), 1,
      anon_sym_QMARK,
    ACTIONS(2089), 1,
      anon_sym_LT,
    ACTIONS(2094), 1,
      anon_sym_BANG,
    ACTIONS(2097), 1,
      anon_sym_DOT,
    ACTIONS(2100), 1,
      anon_sym_QMARK_DOT,
    STATE(869), 1,
      sym_type_arguments,
    STATE(906), 1,
      sym_index_selector,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(907), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(663), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__assignable_selector_part_repeat1,
    STATE(995), 3,
      sym__exclamation_operator,
      sym_argument_part,
      sym__assignable_selector,
    ACTIONS(2092), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2078), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16775] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2105), 1,
      anon_sym_LBRACK,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2111), 1,
      anon_sym_QMARK,
    ACTIONS(2114), 1,
      anon_sym_LT,
    ACTIONS(2119), 1,
      anon_sym_BANG,
    ACTIONS(2122), 1,
      anon_sym_DOT,
    ACTIONS(2125), 1,
      anon_sym_QMARK_DOT,
    STATE(663), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(836), 1,
      sym_index_selector,
    STATE(869), 1,
      sym_type_arguments,
    STATE(873), 1,
      sym__assignable_selector,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(664), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(858), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2103), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16878] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(665), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 17,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1661), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16951] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(666), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 17,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1657), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17024] = 52,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_final,
    ACTIONS(27), 1,
      anon_sym_inline,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(51), 1,
      anon_sym_interface,
    ACTIONS(53), 1,
      anon_sym_base,
    ACTIONS(55), 1,
      anon_sym_abstract,
    ACTIONS(57), 1,
      anon_sym_sealed,
    ACTIONS(59), 1,
      anon_sym_mixin,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(63), 1,
      anon_sym_typedef,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(1627), 1,
      anon_sym_part,
    ACTIONS(1629), 1,
      anon_sym_enum,
    ACTIONS(1631), 1,
      anon_sym_extension,
    ACTIONS(1635), 1,
      sym_part_of_builtin,
    ACTIONS(1637), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1880), 1,
      sym__external_builtin,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1934), 1,
      sym__late_builtin,
    STATE(1971), 1,
      sym_final_builtin,
    STATE(2073), 1,
      sym__typedef,
    STATE(2228), 1,
      sym_abstract,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2419), 1,
      sym__type,
    STATE(2970), 1,
      sym_inferred_type,
    STATE(3001), 1,
      sym_base,
    STATE(3026), 1,
      sym_mixin,
    STATE(3032), 1,
      sym__class_modifiers,
    STATE(3560), 1,
      sym__mixin_class_modifiers,
    STATE(667), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3539), 2,
      sym_interface,
      sym_sealed,
    STATE(2195), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [17185] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2011), 1,
      anon_sym_DOT,
    ACTIONS(2013), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2025), 1,
      anon_sym_QMARK,
    ACTIONS(2028), 1,
      anon_sym_LT,
    STATE(552), 1,
      sym_index_selector,
    STATE(570), 1,
      sym__assignable_selector,
    STATE(682), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(567), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(668), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17290] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2005), 1,
      anon_sym_LT,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2044), 1,
      anon_sym_QMARK,
    ACTIONS(2046), 1,
      anon_sym_DOT,
    ACTIONS(2048), 1,
      anon_sym_QMARK_DOT,
    STATE(663), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(836), 1,
      sym_index_selector,
    STATE(869), 1,
      sym_type_arguments,
    STATE(873), 1,
      sym__assignable_selector,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(669), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(858), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2130), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2128), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17393] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2003), 1,
      anon_sym_QMARK,
    ACTIONS(2005), 1,
      anon_sym_LT,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2011), 1,
      anon_sym_DOT,
    ACTIONS(2013), 1,
      anon_sym_QMARK_DOT,
    STATE(552), 1,
      sym_index_selector,
    STATE(576), 1,
      sym__assignable_selector,
    STATE(663), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(567), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(670), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2130), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2128), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17496] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(671), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 17,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1695), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17569] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2108), 1,
      anon_sym_LPAREN,
    ACTIONS(2114), 1,
      anon_sym_LT,
    ACTIONS(2119), 1,
      anon_sym_BANG,
    ACTIONS(2132), 1,
      anon_sym_LBRACK,
    ACTIONS(2135), 1,
      anon_sym_QMARK,
    ACTIONS(2138), 1,
      anon_sym_DOT,
    ACTIONS(2141), 1,
      anon_sym_QMARK_DOT,
    STATE(552), 1,
      sym_index_selector,
    STATE(576), 1,
      sym__assignable_selector,
    STATE(663), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(567), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(672), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2103), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17672] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1699), 1,
      anon_sym_EQ,
    STATE(673), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1701), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1686), 16,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1680), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17749] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2028), 1,
      anon_sym_LT,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2046), 1,
      anon_sym_DOT,
    ACTIONS(2048), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2055), 1,
      anon_sym_QMARK,
    STATE(679), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(836), 1,
      sym_index_selector,
    STATE(859), 1,
      sym__assignable_selector,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(674), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(858), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17854] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1682), 1,
      anon_sym_EQ,
    STATE(675), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1684), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1686), 16,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1680), 18,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17931] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(676), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 17,
      anon_sym_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
    ACTIONS(1643), 32,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18004] = 29,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2144), 1,
      sym_identifier,
    ACTIONS(2151), 1,
      anon_sym_LPAREN,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_GT,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2723), 1,
      sym__type,
    STATE(2778), 1,
      sym_type_parameter,
    STATE(2779), 1,
      sym__metadata,
    STATE(677), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2147), 12,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2149), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
  [18119] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(2015), 1,
      anon_sym_COMMA,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(1334), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(1516), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    STATE(678), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 8,
      anon_sym_LBRACK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 17,
      anon_sym_QMARK_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
  [18208] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2046), 1,
      anon_sym_DOT,
    ACTIONS(2048), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2111), 1,
      anon_sym_QMARK,
    ACTIONS(2114), 1,
      anon_sym_LT,
    STATE(663), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(836), 1,
      sym_index_selector,
    STATE(869), 1,
      sym_type_arguments,
    STATE(873), 1,
      sym__assignable_selector,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(679), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(858), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2103), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18310] = 51,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_final,
    ACTIONS(27), 1,
      anon_sym_inline,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(51), 1,
      anon_sym_interface,
    ACTIONS(53), 1,
      anon_sym_base,
    ACTIONS(55), 1,
      anon_sym_abstract,
    ACTIONS(57), 1,
      anon_sym_sealed,
    ACTIONS(59), 1,
      anon_sym_mixin,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(63), 1,
      anon_sym_typedef,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(1629), 1,
      anon_sym_enum,
    ACTIONS(1631), 1,
      anon_sym_extension,
    ACTIONS(1635), 1,
      sym_part_of_builtin,
    ACTIONS(1637), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1880), 1,
      sym__external_builtin,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1934), 1,
      sym__late_builtin,
    STATE(1971), 1,
      sym_final_builtin,
    STATE(2073), 1,
      sym__typedef,
    STATE(2228), 1,
      sym_abstract,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2419), 1,
      sym__type,
    STATE(2970), 1,
      sym_inferred_type,
    STATE(3001), 1,
      sym_base,
    STATE(3026), 1,
      sym_mixin,
    STATE(3032), 1,
      sym__class_modifiers,
    STATE(3560), 1,
      sym__mixin_class_modifiers,
    STATE(680), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3539), 2,
      sym_interface,
      sym_sealed,
    STATE(2195), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [18468] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1328), 1,
      anon_sym_EQ,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(1502), 1,
      anon_sym_COLON,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(681), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 12,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1330), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
    ACTIONS(1332), 16,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
  [18554] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(2009), 1,
      anon_sym_BANG,
    ACTIONS(2011), 1,
      anon_sym_DOT,
    ACTIONS(2013), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2114), 1,
      anon_sym_LT,
    ACTIONS(2135), 1,
      anon_sym_QMARK,
    STATE(552), 1,
      sym_index_selector,
    STATE(576), 1,
      sym__assignable_selector,
    STATE(663), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(869), 1,
      sym_type_arguments,
    STATE(964), 1,
      sym_selector,
    STATE(992), 1,
      sym_arguments,
    STATE(567), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(682), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(995), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2103), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18656] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(683), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1410), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [18791] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2162), 1,
      anon_sym_QMARK,
    ACTIONS(2165), 1,
      anon_sym_LT,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2170), 1,
      anon_sym_DOT,
    ACTIONS(2172), 1,
      anon_sym_QMARK_DOT,
    STATE(708), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1030), 1,
      sym__assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(684), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1036), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2017), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18894] = 50,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2403), 1,
      sym_method_signature,
    STATE(2411), 1,
      sym__get,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3037), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(685), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [19049] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(686), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1406), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [19184] = 50,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_final,
    ACTIONS(27), 1,
      anon_sym_inline,
    ACTIONS(29), 1,
      anon_sym_class,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(51), 1,
      anon_sym_interface,
    ACTIONS(53), 1,
      anon_sym_base,
    ACTIONS(55), 1,
      anon_sym_abstract,
    ACTIONS(57), 1,
      anon_sym_sealed,
    ACTIONS(59), 1,
      anon_sym_mixin,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(63), 1,
      anon_sym_typedef,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(1629), 1,
      anon_sym_enum,
    ACTIONS(1631), 1,
      anon_sym_extension,
    ACTIONS(1637), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1880), 1,
      sym__external_builtin,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1934), 1,
      sym__late_builtin,
    STATE(1971), 1,
      sym_final_builtin,
    STATE(2073), 1,
      sym__typedef,
    STATE(2228), 1,
      sym_abstract,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2419), 1,
      sym__type,
    STATE(2970), 1,
      sym_inferred_type,
    STATE(3001), 1,
      sym_base,
    STATE(3026), 1,
      sym_mixin,
    STATE(3032), 1,
      sym__class_modifiers,
    STATE(3560), 1,
      sym__mixin_class_modifiers,
    STATE(687), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3539), 2,
      sym_interface,
      sym_sealed,
    STATE(2195), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [19339] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(688), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1395), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [19474] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(689), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1381), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [19609] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2165), 1,
      anon_sym_LT,
    ACTIONS(2174), 1,
      anon_sym_LBRACK,
    ACTIONS(2177), 1,
      anon_sym_LPAREN,
    ACTIONS(2180), 1,
      anon_sym_QMARK,
    ACTIONS(2183), 1,
      anon_sym_BANG,
    ACTIONS(2186), 1,
      anon_sym_DOT,
    ACTIONS(2189), 1,
      anon_sym_QMARK_DOT,
    STATE(607), 1,
      sym_index_selector,
    STATE(623), 1,
      sym__assignable_selector,
    STATE(705), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(622), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(690), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2017), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [19712] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2170), 1,
      anon_sym_DOT,
    ACTIONS(2172), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2192), 1,
      anon_sym_QMARK,
    ACTIONS(2194), 1,
      anon_sym_LT,
    STATE(707), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1030), 1,
      sym__assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(691), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1036), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2007), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1997), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [19815] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(692), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1353), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [19950] = 44,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    ACTIONS(2212), 1,
      anon_sym_async,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(1962), 1,
      sym_cascade_section,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    STATE(2138), 1,
      aux_sym__expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2210), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(693), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2196), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [20093] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(694), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1357), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [20228] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(695), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1414), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [20363] = 50,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(69), 1,
      anon_sym_external,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(1703), 1,
      sym_identifier,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(1713), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1538), 1,
      sym__static,
    STATE(1542), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1668), 1,
      sym__external,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1797), 1,
      sym__external_builtin,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1894), 1,
      sym__external_and_static,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1914), 1,
      sym__late_builtin,
    STATE(1946), 1,
      sym__covariant,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1983), 1,
      sym_final_builtin,
    STATE(2187), 1,
      sym_constructor_signature,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2418), 1,
      sym_factory_constructor_signature,
    STATE(2422), 1,
      sym_method_signature,
    STATE(2437), 1,
      sym__type,
    STATE(2610), 1,
      sym_constant_constructor_signature,
    STATE(2934), 1,
      sym__var_or_type,
    STATE(3237), 1,
      sym_declaration,
    STATE(3523), 1,
      sym__factory,
    STATE(3528), 1,
      sym_redirecting_factory_constructor_signature,
    STATE(696), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2451), 4,
      sym_getter_signature,
      sym_setter_signature,
      sym_operator_signature,
      sym_function_signature,
  [20518] = 36,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1424), 1,
      anon_sym_QMARK,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(697), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1422), 15,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [20645] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(698), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1418), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [20780] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2194), 1,
      anon_sym_LT,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_QMARK,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_QMARK_DOT,
    STATE(607), 1,
      sym_index_selector,
    STATE(623), 1,
      sym__assignable_selector,
    STATE(706), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(622), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(699), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2007), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1997), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [20883] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(700), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1432), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [21018] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2162), 1,
      anon_sym_QMARK,
    ACTIONS(2165), 1,
      anon_sym_LT,
    ACTIONS(2177), 1,
      anon_sym_LPAREN,
    ACTIONS(2183), 1,
      anon_sym_BANG,
    ACTIONS(2222), 1,
      anon_sym_LBRACK,
    ACTIONS(2225), 1,
      anon_sym_DOT,
    ACTIONS(2228), 1,
      anon_sym_QMARK_DOT,
    STATE(711), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1030), 1,
      sym__assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(701), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1036), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2017), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21121] = 44,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    ACTIONS(2233), 1,
      anon_sym_async,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(1962), 1,
      sym_cascade_section,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    STATE(2137), 1,
      aux_sym__expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2210), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(702), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2231), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [21264] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2165), 1,
      anon_sym_LT,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2180), 1,
      anon_sym_QMARK,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_QMARK_DOT,
    STATE(607), 1,
      sym_index_selector,
    STATE(623), 1,
      sym__assignable_selector,
    STATE(712), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(622), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(703), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2017), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21367] = 37,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1401), 1,
      anon_sym_QMARK,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    ACTIONS(2235), 1,
      sym_equality_operator,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(704), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1399), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21496] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2238), 1,
      anon_sym_LBRACK,
    ACTIONS(2241), 1,
      anon_sym_LPAREN,
    ACTIONS(2244), 1,
      anon_sym_QMARK,
    ACTIONS(2247), 1,
      anon_sym_LT,
    ACTIONS(2250), 1,
      anon_sym_BANG,
    ACTIONS(2253), 1,
      anon_sym_DOT,
    ACTIONS(2256), 1,
      anon_sym_QMARK_DOT,
    STATE(607), 1,
      sym_index_selector,
    STATE(621), 1,
      sym__assignable_selector,
    STATE(710), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(622), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(705), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2103), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21596] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2194), 1,
      anon_sym_LT,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2216), 1,
      anon_sym_QMARK,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_QMARK_DOT,
    STATE(607), 1,
      sym_index_selector,
    STATE(621), 1,
      sym__assignable_selector,
    STATE(710), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(622), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(706), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2130), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2128), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21696] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2170), 1,
      anon_sym_DOT,
    ACTIONS(2172), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2192), 1,
      anon_sym_QMARK,
    ACTIONS(2194), 1,
      anon_sym_LT,
    STATE(710), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1027), 1,
      sym__assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(707), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1036), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2130), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2128), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21796] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2170), 1,
      anon_sym_DOT,
    ACTIONS(2172), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2247), 1,
      anon_sym_LT,
    ACTIONS(2259), 1,
      anon_sym_QMARK,
    STATE(710), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1027), 1,
      sym__assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(708), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1036), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2103), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21896] = 49,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(438), 1,
      anon_sym_RPAREN,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2264), 1,
      anon_sym_LBRACE,
    ACTIONS(2266), 1,
      anon_sym_LBRACK,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2750), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3271), 1,
      sym__normal_formal_parameters,
    STATE(3277), 1,
      sym_optional_formal_parameters,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(709), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3424), 2,
      sym__optional_postional_formal_parameters,
      sym__named_formal_parameters,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [22048] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2270), 1,
      anon_sym_LBRACK,
    ACTIONS(2273), 1,
      anon_sym_LPAREN,
    ACTIONS(2276), 1,
      anon_sym_QMARK,
    ACTIONS(2279), 1,
      anon_sym_LT,
    ACTIONS(2282), 1,
      anon_sym_BANG,
    ACTIONS(2285), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      anon_sym_QMARK_DOT,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1090), 1,
      sym_index_selector,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(1096), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(710), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1105), 3,
      sym__exclamation_operator,
      sym_argument_part,
      sym__assignable_selector,
    ACTIONS(2092), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2078), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22144] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2241), 1,
      anon_sym_LPAREN,
    ACTIONS(2247), 1,
      anon_sym_LT,
    ACTIONS(2250), 1,
      anon_sym_BANG,
    ACTIONS(2259), 1,
      anon_sym_QMARK,
    ACTIONS(2291), 1,
      anon_sym_LBRACK,
    ACTIONS(2294), 1,
      anon_sym_DOT,
    ACTIONS(2297), 1,
      anon_sym_QMARK_DOT,
    STATE(710), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1027), 1,
      sym__assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(711), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1036), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2103), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22244] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_BANG,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2218), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2244), 1,
      anon_sym_QMARK,
    ACTIONS(2247), 1,
      anon_sym_LT,
    STATE(607), 1,
      sym_index_selector,
    STATE(621), 1,
      sym__assignable_selector,
    STATE(710), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1078), 1,
      sym_type_arguments,
    STATE(1104), 1,
      sym_selector,
    STATE(1158), 1,
      sym_arguments,
    STATE(622), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(712), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1105), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2103), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22344] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1408), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(713), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1406), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [22479] = 36,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1424), 2,
      anon_sym_QMARK,
      anon_sym_async,
    ACTIONS(1426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(714), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1422), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22604] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1359), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(715), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1357), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [22739] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2300), 1,
      anon_sym_LBRACK,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2304), 1,
      anon_sym_QMARK,
    ACTIONS(2307), 1,
      anon_sym_LT,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2312), 1,
      anon_sym_DOT,
    ACTIONS(2314), 1,
      anon_sym_QMARK_DOT,
    STATE(675), 1,
      sym__assignable_selector,
    STATE(676), 1,
      sym_index_selector,
    STATE(748), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(661), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(716), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22840] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2300), 1,
      anon_sym_LBRACK,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2312), 1,
      anon_sym_DOT,
    ACTIONS(2314), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2316), 1,
      anon_sym_QMARK,
    ACTIONS(2318), 1,
      anon_sym_LT,
    STATE(675), 1,
      sym__assignable_selector,
    STATE(676), 1,
      sym_index_selector,
    STATE(749), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(661), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(717), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2007), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1997), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22941] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1420), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(718), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1418), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [23076] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2307), 1,
      anon_sym_LT,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2320), 1,
      anon_sym_LBRACK,
    ACTIONS(2322), 1,
      anon_sym_QMARK,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK_DOT,
    STATE(741), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1209), 1,
      sym__assignable_selector,
    STATE(1211), 1,
      sym_index_selector,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(719), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1210), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2031), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23177] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1355), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(720), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1353), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [23312] = 37,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    ACTIONS(2329), 1,
      sym_equality_operator,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1401), 2,
      anon_sym_QMARK,
      anon_sym_async,
    STATE(721), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1399), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23439] = 44,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1962), 1,
      sym_cascade_section,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    STATE(2135), 1,
      aux_sym__expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1257), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2344), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(722), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1277), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [23580] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1416), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(723), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1414), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [23715] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1412), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(724), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1410), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [23850] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1397), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(725), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1395), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [23985] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1383), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(726), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1381), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [24120] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1434), 1,
      anon_sym_async,
    ACTIONS(1448), 1,
      anon_sym_as,
    ACTIONS(2198), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2200), 1,
      anon_sym_QMARK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2204), 1,
      anon_sym_PIPE,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2208), 1,
      anon_sym_AMP,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1456), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1457), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1529), 1,
      aux_sym__if_null_expression,
    STATE(1560), 1,
      sym_type_test,
    STATE(1563), 1,
      sym_type_cast,
    STATE(2086), 1,
      sym_as_operator,
    STATE(2087), 1,
      sym_is_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(727), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1432), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [24255] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2318), 1,
      anon_sym_LT,
    ACTIONS(2320), 1,
      anon_sym_LBRACK,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    STATE(742), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1209), 1,
      sym__assignable_selector,
    STATE(1211), 1,
      sym_index_selector,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(1990), 1,
      sym__assignable_selector_part,
    STATE(728), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1210), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2007), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1997), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24356] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(729), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1961), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1963), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24424] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(730), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1985), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1987), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24492] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(731), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1953), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1955), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24560] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(732), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1889), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1891), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24628] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(733), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1965), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1967), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24696] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(734), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1921), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1923), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24764] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(735), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1925), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1927), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24832] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(736), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1957), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1959), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24900] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(737), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1929), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1931), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24968] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(738), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1969), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1971), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25036] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(739), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1945), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1947), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25104] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(740), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1917), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1919), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25172] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2320), 1,
      anon_sym_LBRACK,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2348), 1,
      anon_sym_QMARK,
    ACTIONS(2351), 1,
      anon_sym_LT,
    STATE(744), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1208), 1,
      sym__assignable_selector,
    STATE(1211), 1,
      sym_index_selector,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(741), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1210), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2103), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25270] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2318), 1,
      anon_sym_LT,
    ACTIONS(2320), 1,
      anon_sym_LBRACK,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2327), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2346), 1,
      anon_sym_QMARK,
    STATE(744), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1208), 1,
      sym__assignable_selector,
    STATE(1211), 1,
      sym_index_selector,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(742), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1210), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2130), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2128), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25368] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(743), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1989), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1991), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25436] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2354), 1,
      anon_sym_LBRACK,
    ACTIONS(2357), 1,
      anon_sym_LPAREN,
    ACTIONS(2360), 1,
      anon_sym_QMARK,
    ACTIONS(2363), 1,
      anon_sym_LT,
    ACTIONS(2366), 1,
      anon_sym_BANG,
    ACTIONS(2369), 1,
      anon_sym_DOT,
    ACTIONS(2372), 1,
      anon_sym_QMARK_DOT,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1232), 1,
      sym_index_selector,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(1231), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(744), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1255), 3,
      sym__exclamation_operator,
      sym_argument_part,
      sym__assignable_selector,
    ACTIONS(2092), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2078), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25530] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(745), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1973), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1975), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25598] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(746), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1977), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1979), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25666] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(747), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1949), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1951), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25734] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2300), 1,
      anon_sym_LBRACK,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2312), 1,
      anon_sym_DOT,
    ACTIONS(2314), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2351), 1,
      anon_sym_LT,
    ACTIONS(2375), 1,
      anon_sym_QMARK,
    STATE(673), 1,
      sym__assignable_selector,
    STATE(676), 1,
      sym_index_selector,
    STATE(744), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(661), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(748), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2117), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2103), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25832] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2300), 1,
      anon_sym_LBRACK,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      anon_sym_BANG,
    ACTIONS(2312), 1,
      anon_sym_DOT,
    ACTIONS(2314), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(2316), 1,
      anon_sym_QMARK,
    ACTIONS(2318), 1,
      anon_sym_LT,
    STATE(673), 1,
      sym__assignable_selector,
    STATE(676), 1,
      sym_index_selector,
    STATE(744), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(1202), 1,
      sym_type_arguments,
    STATE(1253), 1,
      sym_arguments,
    STATE(1256), 1,
      sym_selector,
    STATE(661), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(749), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1255), 2,
      sym__exclamation_operator,
      sym_argument_part,
    ACTIONS(2130), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2128), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25930] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(750), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1981), 16,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1983), 28,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25998] = 47,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(2378), 1,
      anon_sym_RBRACE,
    STATE(825), 1,
      sym__metadata,
    STATE(910), 1,
      sym__required,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2654), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3040), 1,
      sym__default_named_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(751), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [26143] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2383), 1,
      anon_sym_LPAREN,
    ACTIONS(2387), 1,
      anon_sym_QMARK,
    ACTIONS(2391), 1,
      anon_sym_LT,
    STATE(795), 1,
      sym_type_parameters,
    STATE(797), 1,
      sym_nullable_type,
    STATE(827), 1,
      sym_parameter_type_list,
    STATE(752), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2395), 8,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2380), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26222] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(753), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1357), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [26353] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(754), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1410), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [26484] = 36,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1424), 1,
      anon_sym_QMARK,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(755), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1422), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26607] = 37,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    ACTIONS(2410), 1,
      sym_equality_operator,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(756), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1401), 4,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1399), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26732] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(757), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1410), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [26865] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2417), 1,
      anon_sym_Function,
    STATE(774), 1,
      aux_sym__function_type_tails,
    STATE(777), 1,
      sym__function_builtin_identifier,
    STATE(868), 1,
      sym__function_type_tail,
    STATE(758), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2415), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2413), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26940] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2421), 1,
      anon_sym_LPAREN,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2425), 1,
      anon_sym_LT,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(293), 1,
      sym__assignment_operator,
    STATE(781), 1,
      aux_sym_cascade_section_repeat1,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(999), 1,
      sym__cascade_assignment_section,
    STATE(1069), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(759), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    ACTIONS(1073), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [27043] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(760), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1406), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [27174] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(761), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1383), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1381), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [27307] = 38,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(762), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2431), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27434] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(763), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1353), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [27565] = 47,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(2433), 1,
      anon_sym_RBRACE,
    STATE(825), 1,
      sym__metadata,
    STATE(910), 1,
      sym__required,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2654), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3040), 1,
      sym__default_named_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(764), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [27710] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(765), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1395), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [27841] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2417), 1,
      anon_sym_Function,
    STATE(774), 1,
      aux_sym__function_type_tails,
    STATE(777), 1,
      sym__function_builtin_identifier,
    STATE(868), 1,
      sym__function_type_tail,
    STATE(766), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2437), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2435), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27916] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(767), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1420), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1418), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [28049] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(768), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1397), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1395), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [28182] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(769), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1418), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [28313] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(770), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1432), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [28444] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(771), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1414), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [28575] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(772), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1408), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1406), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [28708] = 37,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1401), 1,
      anon_sym_QMARK,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    ACTIONS(2439), 1,
      sym_equality_operator,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(773), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1399), 10,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28833] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2446), 1,
      anon_sym_Function,
    STATE(777), 1,
      sym__function_builtin_identifier,
    STATE(868), 1,
      sym__function_type_tail,
    STATE(774), 3,
      aux_sym__function_type_tails,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2444), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2442), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28906] = 40,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2398), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2400), 1,
      anon_sym_QMARK,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1554), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1592), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1661), 1,
      aux_sym__if_null_expression,
    STATE(1669), 1,
      sym_type_cast,
    STATE(1709), 1,
      sym_type_test,
    STATE(2058), 1,
      sym_is_operator,
    STATE(2077), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(775), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1381), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [29037] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(776), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1434), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [29170] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2451), 1,
      anon_sym_LPAREN,
    ACTIONS(2454), 1,
      anon_sym_QMARK,
    ACTIONS(2457), 1,
      anon_sym_LT,
    STATE(795), 1,
      sym_type_parameters,
    STATE(801), 1,
      sym_nullable_type,
    STATE(827), 1,
      sym_parameter_type_list,
    STATE(777), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2460), 8,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2449), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29249] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(778), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1355), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1353), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [29382] = 36,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1426), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1429), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(779), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1424), 4,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1422), 8,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29505] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(780), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1359), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1357), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [29638] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2421), 1,
      anon_sym_LPAREN,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2425), 1,
      anon_sym_LT,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(293), 1,
      sym__assignment_operator,
    STATE(874), 1,
      aux_sym_cascade_section_repeat1,
    STATE(980), 1,
      sym__cascade_assignment_section,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1074), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(781), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    ACTIONS(1065), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [29741] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2332), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2334), 1,
      anon_sym_QMARK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2338), 1,
      anon_sym_PIPE,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2342), 1,
      anon_sym_AMP,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(956), 1,
      sym_type_cast,
    STATE(957), 1,
      sym_type_test,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1570), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1574), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1662), 1,
      aux_sym__if_null_expression,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(2089), 1,
      sym_is_operator,
    STATE(2090), 1,
      sym_as_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(782), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1416), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1414), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [29874] = 46,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(825), 1,
      sym__metadata,
    STATE(910), 1,
      sym__required,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2654), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(2997), 1,
      sym__default_named_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(783), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [30016] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2465), 1,
      anon_sym_GT_GT,
    STATE(343), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    ACTIONS(2462), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(784), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_shift_expression_repeat1,
    ACTIONS(1359), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1357), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30090] = 43,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(914), 1,
      sym_cascade_section,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    STATE(2496), 1,
      aux_sym__expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2076), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(2231), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(785), 2,
      sym_comment,
      sym_documentation_comment,
  [30226] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(2151), 1,
      anon_sym_LPAREN,
    ACTIONS(2156), 1,
      anon_sym_GT,
    ACTIONS(2468), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2723), 1,
      sym__type,
    STATE(786), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2147), 12,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2149), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
  [30320] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(791), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(787), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2473), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2471), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30396] = 46,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(919), 1,
      sym__required,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1798), 1,
      sym__covariant,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2540), 1,
      sym__final_const_var_or_type,
    STATE(2625), 1,
      sym__simple_formal_parameter,
    STATE(2628), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2868), 1,
      sym__type,
    STATE(3069), 1,
      sym_typed_identifier,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(788), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2627), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [30538] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2481), 1,
      anon_sym_LPAREN,
    ACTIONS(2484), 1,
      anon_sym_QMARK,
    STATE(821), 1,
      sym_parameter_type_list,
    STATE(894), 1,
      sym_nullable_type,
    STATE(789), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2479), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30612] = 43,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1279), 1,
      anon_sym_is,
    ACTIONS(1281), 1,
      anon_sym_as,
    ACTIONS(1286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2064), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(2066), 1,
      anon_sym_QMARK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2070), 1,
      anon_sym_PIPE,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2074), 1,
      anon_sym_AMP,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(914), 1,
      sym_cascade_section,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1392), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1393), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1398), 1,
      aux_sym__if_null_expression,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1453), 1,
      sym_type_cast,
    STATE(1469), 1,
      sym_type_test,
    STATE(2096), 1,
      sym_as_operator,
    STATE(2097), 1,
      sym_is_operator,
    STATE(2502), 1,
      aux_sym__expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(2076), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(2196), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(790), 2,
      sym_comment,
      sym_documentation_comment,
  [30748] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(793), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(791), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2491), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2489), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30820] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(343), 1,
      sym_shift_operator,
    STATE(784), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(792), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2495), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2493), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30892] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2504), 1,
      anon_sym_SLASH,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    STATE(793), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(2499), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2497), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30966] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(794), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1985), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1987), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31032] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2509), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_QMARK,
    STATE(789), 1,
      sym_nullable_type,
    STATE(818), 1,
      sym_parameter_type_list,
    STATE(795), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2507), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31106] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(796), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1953), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1955), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31172] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2520), 1,
      anon_sym_LPAREN,
    ACTIONS(2524), 1,
      anon_sym_QMARK,
    STATE(818), 1,
      sym_parameter_type_list,
    STATE(897), 1,
      sym_nullable_type,
    STATE(797), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2528), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2517), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31246] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(798), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1965), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1967), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31312] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(799), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1961), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1963), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31378] = 46,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(825), 1,
      sym__metadata,
    STATE(910), 1,
      sym__required,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2654), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3040), 1,
      sym__default_named_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(800), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [31520] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2509), 1,
      anon_sym_LPAREN,
    ACTIONS(2512), 1,
      anon_sym_QMARK,
    STATE(818), 1,
      sym_parameter_type_list,
    STATE(897), 1,
      sym_nullable_type,
    STATE(801), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2507), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31594] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(802), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1921), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1923), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31660] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(803), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1969), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1971), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31726] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(804), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1925), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1927), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31792] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2533), 1,
      anon_sym_QMARK,
    ACTIONS(2536), 1,
      anon_sym_LT,
    STATE(817), 1,
      sym_type_arguments,
    STATE(872), 1,
      sym_nullable_type,
    STATE(805), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 8,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2531), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31866] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(806), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1929), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1931), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31932] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(807), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1945), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1947), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31998] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(808), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1949), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1951), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32064] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(809), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1973), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1975), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32130] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(810), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1981), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1983), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32196] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(811), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1917), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1919), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32262] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(812), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1889), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1891), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32328] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(813), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1989), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1991), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32394] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(814), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1957), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1959), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32460] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(815), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1977), 12,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1979), 30,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32526] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2543), 1,
      anon_sym_QMARK,
    ACTIONS(2548), 1,
      anon_sym_Function,
    STATE(888), 1,
      sym_nullable_type,
    STATE(816), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2541), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32597] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2552), 1,
      anon_sym_QMARK,
    STATE(892), 1,
      sym_nullable_type,
    STATE(817), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2550), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32666] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2484), 1,
      anon_sym_QMARK,
    STATE(894), 1,
      sym_nullable_type,
    STATE(818), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2479), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32735] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(829), 1,
      aux_sym__expression_repeat1,
    STATE(914), 1,
      sym_cascade_section,
    ACTIONS(2561), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(819), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2557), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32806] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2564), 1,
      anon_sym_PIPE_PIPE,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(820), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(1416), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1414), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
  [32875] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2569), 1,
      anon_sym_QMARK,
    STATE(847), 1,
      sym_nullable_type,
    STATE(821), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2567), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32944] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2574), 1,
      anon_sym_AMP_AMP,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(822), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(1434), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_PIPE_PIPE,
  [33013] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(1071), 1,
      anon_sym_async,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2421), 1,
      anon_sym_LPAREN,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2425), 1,
      anon_sym_LT,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(284), 1,
      sym__assignment_operator,
    STATE(874), 1,
      aux_sym_cascade_section_repeat1,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1198), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1965), 1,
      sym__cascade_assignment_section,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(823), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    ACTIONS(1065), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [33116] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2577), 1,
      sym__additive_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(824), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_additive_expression_repeat1,
    ACTIONS(1355), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1353), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33185] = 45,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(919), 1,
      sym__required,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1798), 1,
      sym__covariant,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2540), 1,
      sym__final_const_var_or_type,
    STATE(2625), 1,
      sym__simple_formal_parameter,
    STATE(2628), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(825), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2627), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [33324] = 45,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(2580), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(2982), 1,
      sym_formal_parameter,
    STATE(3048), 1,
      sym__default_formal_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(826), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [33463] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2512), 1,
      anon_sym_QMARK,
    STATE(897), 1,
      sym_nullable_type,
    STATE(827), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2507), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33532] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2582), 1,
      anon_sym_DOT,
    STATE(842), 1,
      sym__type_dot_identifier,
    STATE(828), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    ACTIONS(2015), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33601] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(914), 1,
      sym_cascade_section,
    ACTIONS(2589), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(829), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__expression_repeat1,
    ACTIONS(2587), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2585), 27,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33670] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(1075), 1,
      anon_sym_async,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2421), 1,
      anon_sym_LPAREN,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2425), 1,
      anon_sym_LT,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(284), 1,
      sym__assignment_operator,
    STATE(823), 1,
      aux_sym_cascade_section_repeat1,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1199), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1970), 1,
      sym__cascade_assignment_section,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(830), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    ACTIONS(1073), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [33773] = 45,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(2592), 1,
      anon_sym_RBRACK,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(2982), 1,
      sym_formal_parameter,
    STATE(3048), 1,
      sym__default_formal_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(831), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [33912] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1330), 1,
      sym_increment_operator,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(832), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 9,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    ACTIONS(1322), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33985] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(368), 1,
      sym_additive_operator,
    STATE(824), 1,
      aux_sym_additive_expression_repeat1,
    STATE(833), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2596), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2594), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34054] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(365), 1,
      sym_logical_or_operator,
    STATE(820), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(834), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2600), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2598), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34123] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(366), 1,
      sym_logical_and_operator,
    STATE(822), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(835), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2604), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2602), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34192] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(836), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1643), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34256] = 44,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(2982), 1,
      sym_formal_parameter,
    STATE(3048), 1,
      sym__default_formal_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(837), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [34392] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(838), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2608), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2606), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34456] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(887), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(839), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2612), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2610), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34522] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(886), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(840), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2616), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2614), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34588] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(885), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(841), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2620), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2618), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34654] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(842), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2624), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2622), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34718] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2626), 1,
      anon_sym_LPAREN,
    ACTIONS(2630), 1,
      anon_sym_QMARK,
    ACTIONS(2634), 1,
      anon_sym_LT,
    STATE(933), 1,
      sym_nullable_type,
    STATE(936), 1,
      sym_type_parameters,
    STATE(1014), 1,
      sym_parameter_type_list,
    STATE(843), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2395), 10,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2380), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34794] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(844), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2640), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2638), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34858] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(845), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2644), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2642), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34922] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2646), 1,
      anon_sym_Function,
    STATE(851), 1,
      sym__function_builtin_identifier,
    STATE(1071), 1,
      sym__function_type_tail,
    STATE(846), 3,
      aux_sym__function_type_tails,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2444), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2442), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34992] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(847), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2651), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2649), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35056] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(848), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2655), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2653), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35120] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2659), 1,
      anon_sym_EQ,
    STATE(849), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2661), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2657), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35186] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(850), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1695), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35250] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2663), 1,
      anon_sym_LPAREN,
    ACTIONS(2666), 1,
      anon_sym_QMARK,
    ACTIONS(2669), 1,
      anon_sym_LT,
    STATE(929), 1,
      sym_nullable_type,
    STATE(936), 1,
      sym_type_parameters,
    STATE(1014), 1,
      sym_parameter_type_list,
    STATE(851), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2460), 10,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2449), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35326] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2674), 1,
      anon_sym_EQ,
    STATE(852), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2676), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2672), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35392] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(853), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2680), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2678), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35456] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(854), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2684), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2682), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35520] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(855), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2688), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2686), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35584] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(856), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2692), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2690), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35648] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    STATE(857), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2541), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35714] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(858), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1668), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35778] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1684), 1,
      sym_increment_operator,
    STATE(859), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1680), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35844] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2696), 1,
      anon_sym_EQ,
    STATE(860), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2698), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2694), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35910] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(861), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2702), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2700), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35974] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    STATE(955), 1,
      sym_arguments,
    STATE(862), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2706), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2704), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36042] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(863), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2710), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2708), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36106] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(864), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2714), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2712), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36170] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(865), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2716), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36234] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(866), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2722), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2720), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36298] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2724), 1,
      anon_sym_Function,
    STATE(846), 1,
      aux_sym__function_type_tails,
    STATE(851), 1,
      sym__function_builtin_identifier,
    STATE(1071), 1,
      sym__function_type_tail,
    STATE(867), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2415), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2413), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36370] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(868), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2726), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36434] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    STATE(943), 1,
      sym_arguments,
    STATE(869), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1680), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36502] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(870), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1688), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1690), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36566] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1676), 1,
      sym_increment_operator,
    STATE(871), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1678), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1672), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36632] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(872), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2550), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36696] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1701), 1,
      sym_increment_operator,
    STATE(873), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1680), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36762] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1368), 1,
      anon_sym_LT,
    ACTIONS(2730), 1,
      anon_sym_LPAREN,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(874), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_cascade_section_repeat1,
    ACTIONS(1366), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1361), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [36836] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(875), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36900] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(876), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1657), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36964] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(877), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2735), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2733), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37028] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2724), 1,
      anon_sym_Function,
    STATE(846), 1,
      aux_sym__function_type_tails,
    STATE(851), 1,
      sym__function_builtin_identifier,
    STATE(1071), 1,
      sym__function_type_tail,
    STATE(878), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2437), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2435), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37100] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(879), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2739), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2737), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37164] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2543), 1,
      anon_sym_QMARK,
    STATE(959), 1,
      sym_nullable_type,
    STATE(880), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2541), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37232] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(881), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2743), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2741), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37296] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(882), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2747), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2745), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37360] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(982), 1,
      anon_sym_EQ,
    STATE(883), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(984), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(980), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37426] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(899), 1,
      aux_sym__if_null_expression,
    STATE(884), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2751), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2749), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37492] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2753), 1,
      anon_sym_AMP,
    STATE(885), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(1408), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1406), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37558] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2756), 1,
      anon_sym_CARET,
    STATE(886), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(1397), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1395), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37624] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2759), 1,
      anon_sym_PIPE,
    STATE(887), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(1420), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1418), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37690] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2766), 1,
      anon_sym_Function,
    STATE(888), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2762), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37756] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(889), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2770), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2768), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37820] = 44,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(2791), 1,
      sym__default_formal_parameter,
    STATE(2982), 1,
      sym_formal_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(890), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [37956] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(891), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2772), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38020] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(892), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2778), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2776), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38084] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(893), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2782), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2780), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38148] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(894), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2567), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38212] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2790), 1,
      anon_sym_LT,
    ACTIONS(2794), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(2784), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(895), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2787), 3,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    ACTIONS(1328), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1330), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38286] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(896), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2801), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2799), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38350] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(897), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2479), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38414] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(898), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2805), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2803), 30,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38478] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2809), 1,
      anon_sym_QMARK_QMARK,
    STATE(899), 3,
      aux_sym__if_null_expression,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2807), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38544] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(900), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2816), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2814), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38607] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(901), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2820), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2818), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38670] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(425), 1,
      sym_multiplicative_operator,
    STATE(930), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(902), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2473), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2471), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38743] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(903), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2824), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2822), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38806] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2826), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(904), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1699), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2829), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1701), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38873] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(905), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1410), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38936] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(906), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1643), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38999] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(907), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1668), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39062] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(908), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1277), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1257), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39125] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(909), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2676), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2672), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39188] = 43,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2628), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(910), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [39321] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(911), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2834), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2832), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39384] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(912), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2838), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2836), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39447] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(913), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2842), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2840), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39510] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(914), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2846), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2844), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39573] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(915), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2661), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2657), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39636] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(916), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2850), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2848), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39699] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(917), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2854), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2852), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39762] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(918), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1881), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1879), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39825] = 43,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2662), 1,
      sym_formal_parameter,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(919), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [39958] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2856), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(920), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1674), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2859), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1676), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40025] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(921), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2864), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2862), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40088] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2866), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(922), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1682), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2869), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1684), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40155] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(923), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1041), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1039), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40218] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(924), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2874), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2872), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40281] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(925), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2878), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2876), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40344] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(926), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2499), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2497), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40407] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(927), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2882), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2880), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40470] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2884), 1,
      anon_sym_LPAREN,
    ACTIONS(2887), 1,
      anon_sym_QMARK,
    STATE(1006), 1,
      sym_parameter_type_list,
    STATE(1073), 1,
      sym_nullable_type,
    STATE(928), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2479), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40541] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2890), 1,
      anon_sym_LPAREN,
    ACTIONS(2893), 1,
      anon_sym_QMARK,
    STATE(1022), 1,
      sym_parameter_type_list,
    STATE(1026), 1,
      sym_nullable_type,
    STATE(929), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2507), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40612] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(425), 1,
      sym_multiplicative_operator,
    STATE(972), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(930), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2491), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2489), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40681] = 43,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(1077), 1,
      sym__metadata,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1794), 1,
      sym__covariant,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2464), 1,
      sym__simple_formal_parameter,
    STATE(2466), 1,
      sym__normal_formal_parameter,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2557), 1,
      sym__final_const_var_or_type,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3190), 1,
      sym_formal_parameter,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(931), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2465), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [40814] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(2787), 1,
      anon_sym_QMARK,
    ACTIONS(2790), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1322), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(1332), 2,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    STATE(932), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1328), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1330), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40889] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2896), 1,
      anon_sym_LPAREN,
    ACTIONS(2900), 1,
      anon_sym_QMARK,
    STATE(1022), 1,
      sym_parameter_type_list,
    STATE(1026), 1,
      sym_nullable_type,
    STATE(933), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2528), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2517), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40960] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(934), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2906), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2904), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41023] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(935), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2910), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2908), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41086] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2890), 1,
      anon_sym_LPAREN,
    ACTIONS(2893), 1,
      anon_sym_QMARK,
    STATE(928), 1,
      sym_nullable_type,
    STATE(1022), 1,
      sym_parameter_type_list,
    STATE(936), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2507), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41157] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(937), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2914), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2912), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41220] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(938), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(984), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(980), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41283] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(939), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2918), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2916), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41346] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(940), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2698), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2694), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41409] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(941), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2922), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2920), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41472] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(942), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2130), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2128), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41535] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(943), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1733), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1731), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41598] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(944), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2926), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2924), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41661] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(945), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2930), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2928), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41724] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(946), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2934), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2932), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41787] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(947), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2938), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2936), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41850] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(948), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2942), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2940), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41913] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(949), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2946), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2944), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41976] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(950), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2950), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2948), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42039] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(951), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2954), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2952), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42102] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(952), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2958), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2956), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42165] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(953), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2962), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2960), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42228] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(954), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2966), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2964), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42291] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(955), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2970), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2968), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42354] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(956), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2974), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2972), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42417] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(957), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2978), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2976), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42480] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(958), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2982), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2980), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42543] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(959), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2762), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42606] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(960), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2986), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2984), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42669] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2465), 1,
      anon_sym_GT_GT,
    STATE(319), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    ACTIONS(2462), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(961), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_shift_expression_repeat1,
    ACTIONS(1359), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1357), 22,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42740] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(962), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1322), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42803] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(963), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2990), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2988), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42866] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(964), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2994), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2992), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42929] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_QMARK,
    ACTIONS(3002), 1,
      anon_sym_DOT,
    ACTIONS(3005), 1,
      anon_sym_QMARK_DOT,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    ACTIONS(1297), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(965), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_cascade_section_repeat2,
    ACTIONS(1292), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [43008] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(966), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3008), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43071] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(967), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3014), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3012), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43134] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(968), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3018), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3016), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43197] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(969), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3022), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3020), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43260] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(970), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1657), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43323] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(971), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1661), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43386] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2504), 1,
      anon_sym_SLASH,
    STATE(425), 1,
      sym_multiplicative_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    STATE(972), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(2499), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2497), 21,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43457] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(973), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3026), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3024), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43520] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(974), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3030), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3028), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43583] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(975), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1674), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1676), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43646] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(976), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3034), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3032), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43709] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(977), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(973), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(975), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43772] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3036), 1,
      anon_sym_QMARK,
    ACTIONS(3039), 1,
      anon_sym_LT,
    STATE(1013), 1,
      sym_type_arguments,
    STATE(1055), 1,
      sym_nullable_type,
    STATE(978), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 10,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2531), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43843] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(979), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3044), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3042), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43906] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(980), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1155), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1153), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43969] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(981), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3048), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3046), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44032] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(982), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3052), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3050), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44095] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2421), 1,
      anon_sym_LPAREN,
    ACTIONS(2425), 1,
      anon_sym_LT,
    STATE(874), 1,
      aux_sym_cascade_section_repeat1,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(983), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1376), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1371), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [44170] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(984), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1821), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1819), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44233] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(985), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3056), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3054), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44296] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(986), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3060), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3058), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44359] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(319), 1,
      sym_shift_operator,
    STATE(961), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(987), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2495), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2493), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44428] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(988), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3064), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3062), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44491] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(989), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3068), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3066), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44554] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(990), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3072), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3070), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44617] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(991), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3076), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3074), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44680] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(992), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1729), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1727), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44743] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(993), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2031), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2017), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44806] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(994), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3080), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3078), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44869] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(995), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1680), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44932] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(996), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2473), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2471), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44995] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2421), 1,
      anon_sym_LPAREN,
    ACTIONS(2425), 1,
      anon_sym_LT,
    STATE(983), 1,
      aux_sym_cascade_section_repeat1,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(997), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1390), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1385), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [45070] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(998), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1695), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45133] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(999), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1071), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1065), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45196] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1000), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3084), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3082), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45259] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1001), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3088), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3086), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45322] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1002), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3092), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3090), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45385] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1003), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3096), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3094), 29,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45448] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1330), 1,
      sym_increment_operator,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(1004), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 11,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1322), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45518] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(321), 1,
      sym_additive_operator,
    STATE(1016), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1005), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2596), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2594), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45584] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3098), 1,
      anon_sym_QMARK,
    STATE(1067), 1,
      sym_nullable_type,
    STATE(1006), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2567), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45650] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(829), 1,
      aux_sym__expression_repeat1,
    STATE(914), 1,
      sym_cascade_section,
    ACTIONS(1465), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(1007), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2557), 24,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45718] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(1021), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1008), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2604), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2602), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45784] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1680), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(2829), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1009), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1699), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1701), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45852] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(1019), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1010), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2600), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2598), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45918] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3101), 1,
      anon_sym_DOT,
    STATE(1038), 1,
      sym__type_dot_identifier,
    STATE(1011), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2015), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45984] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1017), 1,
      aux_sym__expression_repeat1,
    STATE(1133), 1,
      sym_cascade_section,
    ACTIONS(3104), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(1012), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2557), 22,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46052] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3107), 1,
      anon_sym_QMARK,
    STATE(1040), 1,
      sym_nullable_type,
    STATE(1013), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2550), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46118] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2893), 1,
      anon_sym_QMARK,
    STATE(1026), 1,
      sym_nullable_type,
    STATE(1014), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2507), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46184] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    ACTIONS(3110), 1,
      anon_sym_QMARK,
    STATE(1037), 1,
      sym_nullable_type,
    STATE(1015), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2541), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46252] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2577), 1,
      sym__additive_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(1016), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_additive_expression_repeat1,
    ACTIONS(1355), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1353), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46318] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1133), 1,
      sym_cascade_section,
    ACTIONS(3113), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(1017), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__expression_repeat1,
    ACTIONS(2587), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2585), 22,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46384] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1672), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(2859), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1018), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1678), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1674), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1676), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46452] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2564), 1,
      anon_sym_PIPE_PIPE,
    STATE(336), 1,
      sym_logical_or_operator,
    STATE(1019), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(1416), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1414), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
  [46518] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1680), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(2869), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1020), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1682), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1684), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46586] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2574), 1,
      anon_sym_AMP_AMP,
    STATE(334), 1,
      sym_logical_and_operator,
    STATE(1021), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(1434), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1432), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_PIPE_PIPE,
  [46652] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2887), 1,
      anon_sym_QMARK,
    STATE(1073), 1,
      sym_nullable_type,
    STATE(1022), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2479), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46718] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1023), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2608), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2606), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46779] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1024), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2680), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2678), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46840] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3116), 1,
      anon_sym_CARET,
    STATE(1025), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(1397), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1395), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46903] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1026), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2479), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46964] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1701), 1,
      sym_increment_operator,
    STATE(1027), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1680), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47027] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1676), 1,
      sym_increment_operator,
    STATE(1028), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1678), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1672), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47090] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1029), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2770), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2768), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47151] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1684), 1,
      sym_increment_operator,
    STATE(1030), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1680), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47214] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1031), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2743), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2741), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47275] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1032), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2805), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2803), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47336] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3119), 1,
      anon_sym_PIPE,
    STATE(1033), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(1420), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1418), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47399] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1034), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1643), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47460] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    STATE(1035), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2541), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47523] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1036), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1668), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47584] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2766), 1,
      anon_sym_Function,
    STATE(1037), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2762), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47647] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1038), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2624), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2622), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47708] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3110), 1,
      anon_sym_QMARK,
    STATE(1137), 1,
      sym_nullable_type,
    STATE(1039), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2541), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47773] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1040), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2778), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2776), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47834] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1041), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2716), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47895] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1042), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2772), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47956] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(982), 1,
      anon_sym_EQ,
    STATE(1043), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(984), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(980), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48019] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2790), 1,
      anon_sym_LT,
    ACTIONS(2794), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(2784), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(1044), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2787), 3,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    ACTIONS(1328), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1330), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48090] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2659), 1,
      anon_sym_EQ,
    STATE(1045), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2661), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2657), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48153] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2674), 1,
      anon_sym_EQ,
    STATE(1046), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2676), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2672), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48216] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3122), 1,
      anon_sym_QMARK_QMARK,
    STATE(1047), 3,
      aux_sym__if_null_expression,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2807), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48279] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1048), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2739), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2737), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48340] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1049), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2688), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2686), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48401] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3129), 1,
      anon_sym_AT,
    ACTIONS(3132), 1,
      anon_sym_export,
    ACTIONS(3135), 1,
      anon_sym_import,
    STATE(1454), 1,
      aux_sym__metadata_repeat1,
    STATE(1571), 1,
      sym_annotation,
    STATE(1572), 1,
      sym_import_or_export,
    STATE(1581), 1,
      sym_import_specification,
    STATE(1817), 1,
      sym__import,
    STATE(1869), 1,
      sym__export,
    STATE(2579), 1,
      sym__metadata,
    STATE(1577), 2,
      sym_library_import,
      sym_library_export,
    ACTIONS(3125), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_part_of_builtin,
    STATE(1050), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_program_repeat1,
    ACTIONS(3127), 21,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [48484] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1051), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2655), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2653), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48545] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1052), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1657), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48606] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1053), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2747), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2745), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48667] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1047), 1,
      aux_sym__if_null_expression,
    STATE(1054), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2751), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2749), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48730] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1055), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2550), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48791] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    STATE(1156), 1,
      sym_arguments,
    STATE(1056), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2706), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2704), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48856] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1057), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1661), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48917] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1058), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2782), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2780), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [48978] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(546), 1,
      sym_lambda_expression,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1722), 1,
      sym__metadata,
    STATE(1764), 1,
      sym_final_builtin,
    STATE(1771), 1,
      sym_inferred_type,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1799), 1,
      sym__covariant,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(2368), 1,
      sym_function_signature,
    STATE(2530), 1,
      sym__type,
    STATE(2667), 1,
      sym__declared_identifier,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(3419), 1,
      sym__final_const_var_or_type,
    STATE(1059), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2500), 2,
      sym__get,
      sym__set,
    STATE(3160), 2,
      sym_pattern_variable_declaration,
      sym_initialized_variable_definition,
  [49105] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1341), 1,
      anon_sym_DOT,
    ACTIONS(2787), 1,
      anon_sym_QMARK,
    ACTIONS(2790), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1322), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(1332), 2,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    STATE(1060), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1328), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1330), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49178] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1061), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2640), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2638), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49239] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3138), 1,
      anon_sym_AMP,
    STATE(1062), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(1408), 11,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1406), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49302] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1025), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1063), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2616), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2614), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49365] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(3141), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1722), 1,
      sym__metadata,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1798), 1,
      sym__covariant,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2478), 1,
      sym__simple_formal_parameter,
    STATE(2540), 1,
      sym__final_const_var_or_type,
    STATE(2581), 1,
      sym__type,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(1064), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2480), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [49492] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1065), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2710), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2708), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49553] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1066), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2644), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2642), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49614] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1067), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2651), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2649), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49675] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1068), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 13,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1695), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49736] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(293), 1,
      sym__assignment_operator,
    STATE(965), 1,
      aux_sym_cascade_section_repeat2,
    STATE(980), 1,
      sym__cascade_assignment_section,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1069), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    ACTIONS(1065), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [49821] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1070), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2722), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2720), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49882] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1071), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2726), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [49943] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1033), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1072), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2612), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2610), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50006] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1073), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2567), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50067] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(293), 1,
      sym__assignment_operator,
    STATE(939), 1,
      sym__cascade_assignment_section,
    STATE(965), 1,
      aux_sym_cascade_section_repeat2,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1074), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    ACTIONS(1153), 11,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [50152] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1075), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2735), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2733), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50213] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1076), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2801), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2799), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50274] = 41,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(2262), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      sym_const_builtin,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1722), 1,
      sym__metadata,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1798), 1,
      sym__covariant,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2468), 1,
      sym__declared_identifier,
    STATE(2478), 1,
      sym__simple_formal_parameter,
    STATE(2540), 1,
      sym__final_const_var_or_type,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2756), 1,
      sym__type,
    STATE(3283), 1,
      sym_this,
    STATE(3288), 1,
      sym_super,
    STATE(1077), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2480), 3,
      sym__function_formal_parameter,
      sym_super_formal_parameter,
      sym_constructor_param,
  [50401] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    STATE(1152), 1,
      sym_arguments,
    STATE(1078), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1680), 23,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50466] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1079), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2684), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2682), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50527] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1080), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2702), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2700), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50588] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2696), 1,
      anon_sym_EQ,
    STATE(1081), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2698), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2694), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50651] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1082), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2692), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2690), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50712] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1083), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2714), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2712), 25,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50773] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1062), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1084), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2620), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2618), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50836] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1085), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3008), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50896] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1330), 1,
      sym_increment_operator,
    ACTIONS(1334), 1,
      anon_sym_LT,
    ACTIONS(1993), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(1086), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 8,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1322), 24,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50964] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1087), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3096), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3094), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51024] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1088), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1717), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1715), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51084] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1089), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3044), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3042), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51144] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1090), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1643), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51204] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1091), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2910), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2908), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51264] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1092), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1819), 11,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(1821), 25,
      anon_sym_QMARK,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [51324] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1093), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3076), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3074), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51384] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1094), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2130), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2128), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51444] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1095), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2926), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2924), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51504] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1096), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1668), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51564] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1097), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3084), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3082), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51624] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1098), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2031), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2017), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51684] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2866), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(1099), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2869), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1682), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1684), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51748] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2856), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(1100), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2859), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1674), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1676), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51812] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1672), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(2859), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1101), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1678), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1674), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1676), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51878] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1102), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1725), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1723), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [51938] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1103), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2934), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
    ACTIONS(2932), 28,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51998] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1104), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2994), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2992), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52058] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1105), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1680), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52118] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1106), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2950), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2948), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52178] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1680), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(2869), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1107), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1682), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1684), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52244] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1108), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1821), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1819), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52304] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1109), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1729), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1727), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [52364] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1110), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1695), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52424] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1111), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2918), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2916), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52484] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1112), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1657), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52544] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1113), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1661), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52604] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1114), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3080), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3078), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52664] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1115), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3068), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3066), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52724] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2826), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(1116), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2829), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1699), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1701), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52788] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1117), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2473), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2471), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52848] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1118), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2974), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2972), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52908] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1119), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3030), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3028), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52968] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1120), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3088), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3086), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53028] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(1177), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1121), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2473), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2471), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53098] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1122), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1661), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [53158] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1123), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1155), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1153), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53218] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1124), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1657), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [53278] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1125), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2661), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2657), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53338] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1126), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1739), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1737), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [53398] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1127), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2676), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2672), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53458] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1128), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1688), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1690), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53518] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1129), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(984), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(980), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53578] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1130), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2698), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2694), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53638] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1131), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2954), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2952), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53698] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1132), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2958), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2956), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53758] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1133), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2846), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2844), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53818] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1134), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1881), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1879), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [53878] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1135), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1322), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [53938] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1136), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1733), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1731), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [53998] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1137), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2762), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54058] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1138), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1668), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [54118] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1139), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2922), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2920), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54178] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1680), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(2829), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1140), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 3,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1699), 7,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1701), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54244] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1141), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1721), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1719), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [54304] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1142), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2864), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2862), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54364] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1143), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2978), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2976), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54424] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1144), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2834), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2832), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54484] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1145), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1643), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [54544] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1146), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3072), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3070), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54604] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2504), 1,
      anon_sym_SLASH,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    STATE(1147), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(2499), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2497), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54672] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1148), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3026), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3024), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54732] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1149), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2824), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2822), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54792] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1150), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2942), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2940), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54852] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1151), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1041), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1039), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54912] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1152), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1733), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1731), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54972] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1153), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3018), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3016), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55032] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1154), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3022), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3020), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55092] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1155), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1695), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55152] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1156), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2970), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2968), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55212] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1157), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2966), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2964), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55272] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1158), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1729), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1727), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55332] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1159), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1410), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55392] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1160), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1821), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1819), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [55452] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1161), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2930), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2928), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55512] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1162), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2882), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2880), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55572] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1163), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1071), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1065), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55632] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1164), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2878), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2876), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55692] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1165), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2816), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2814), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55752] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1166), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2986), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2984), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55812] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1167), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2962), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2960), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55872] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1168), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3034), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3032), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55932] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1169), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3064), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3062), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [55992] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1170), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2938), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2936), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56052] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1171), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1674), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1676), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56112] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1172), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2946), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2944), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56172] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1173), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2906), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2904), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56232] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1174), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2850), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2848), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56292] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1175), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2854), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2852), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56352] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1176), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3092), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3090), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56412] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(1147), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1177), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2491), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2489), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56482] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1178), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1881), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1879), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56542] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1179), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2982), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2980), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56602] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1180), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3014), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3012), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56662] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1181), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2914), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2912), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56722] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1182), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2990), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2988), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56782] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1183), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2820), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2818), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56842] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1184), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2842), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2840), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56902] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1185), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1879), 11,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_SEMI,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(1881), 25,
      anon_sym_QMARK,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [56962] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1186), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1277), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1257), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57022] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1187), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2874), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2872), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57082] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1188), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3060), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3058), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57142] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1189), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2838), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2836), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57202] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1190), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2499), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2497), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57262] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1191), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2934), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2932), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57322] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1192), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3048), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3046), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57382] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1193), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3052), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3050), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57442] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1194), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3056), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3054), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57502] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1195), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(973), 12,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(975), 24,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57562] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1196), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1661), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57621] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1197), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1657), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57680] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(1155), 1,
      anon_sym_async,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(284), 1,
      sym__assignment_operator,
    STATE(965), 1,
      aux_sym_cascade_section_repeat2,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1963), 1,
      sym__cascade_assignment_section,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1198), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1153), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [57765] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1067), 1,
      anon_sym_EQ,
    ACTIONS(1071), 1,
      anon_sym_async,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(2423), 1,
      anon_sym_QMARK,
    ACTIONS(2427), 1,
      anon_sym_DOT,
    ACTIONS(2429), 1,
      anon_sym_QMARK_DOT,
    STATE(284), 1,
      sym__assignment_operator,
    STATE(965), 1,
      aux_sym_cascade_section_repeat2,
    STATE(997), 1,
      sym__assignable_selector,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1965), 1,
      sym__cascade_assignment_section,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1199), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1065), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(1069), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [57850] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(982), 1,
      anon_sym_EQ,
    ACTIONS(3146), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1200), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3143), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(984), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(980), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [57915] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    STATE(1287), 1,
      sym_arguments,
    STATE(1201), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2706), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2704), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57978] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    STATE(1228), 1,
      sym_arguments,
    STATE(1202), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1680), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58041] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    STATE(955), 1,
      sym_arguments,
    ACTIONS(3152), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1203), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3149), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2706), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2704), 16,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [58108] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(275), 1,
      sym__assignment_operator,
    STATE(874), 1,
      aux_sym_cascade_section_repeat1,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1365), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1593), 1,
      sym__assignable_selector,
    STATE(1965), 1,
      sym__cascade_assignment_section,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1204), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1071), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1065), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [58191] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1676), 1,
      sym_increment_operator,
    STATE(1205), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1678), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1672), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58252] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3163), 1,
      anon_sym_DOT,
    STATE(1372), 1,
      sym_arguments,
    STATE(3209), 1,
      sym_type_arguments,
    ACTIONS(3159), 2,
      anon_sym_QMARK,
      anon_sym_AT,
    STATE(1206), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3155), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [58321] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1332), 1,
      anon_sym_BANG,
    ACTIONS(1993), 1,
      anon_sym_DOT,
    ACTIONS(2787), 1,
      anon_sym_QMARK,
    ACTIONS(2790), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(1207), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
    ACTIONS(1328), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1330), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58392] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1701), 1,
      sym_increment_operator,
    STATE(1208), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1680), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58453] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1684), 1,
      sym_increment_operator,
    STATE(1209), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1680), 25,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58514] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1210), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1668), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58573] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1211), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1643), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58632] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2659), 1,
      anon_sym_EQ,
    ACTIONS(3168), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1212), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3165), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2661), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2657), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [58697] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2674), 1,
      anon_sym_EQ,
    ACTIONS(3174), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1213), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3171), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2676), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2672), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [58762] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2696), 1,
      anon_sym_EQ,
    ACTIONS(3180), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1214), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3177), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2698), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2694), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [58827] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(275), 1,
      sym__assignment_operator,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1204), 1,
      aux_sym_cascade_section_repeat1,
    STATE(1355), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1593), 1,
      sym__assignable_selector,
    STATE(1970), 1,
      sym__cascade_assignment_section,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1215), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1075), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1073), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [58910] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1216), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      sym__additive_operator,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1695), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      sym_increment_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58969] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1217), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3012), 14,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_QMARK_DOT,
    ACTIONS(3014), 21,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_QMARK,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_DOT,
      anon_sym_switch,
      sym_void_type,
      anon_sym_Function,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [59028] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1218), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(973), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(975), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59086] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1219), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3034), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3032), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59144] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1220), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3084), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3082), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59202] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1221), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2942), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2940), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59260] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1222), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2824), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2822), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59318] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1223), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3026), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3024), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59376] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1224), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2834), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2832), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59434] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1225), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2864), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2862), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59492] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1226), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2922), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2920), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59550] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1227), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1697), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1695), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59608] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1228), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1733), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1731), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59666] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1229), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1663), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1661), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59724] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1230), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1659), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1657), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59782] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1231), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1670), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1668), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59840] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1232), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1645), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1643), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59898] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1233), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(955), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(950), 21,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_default,
      anon_sym_case,
      sym_rethrow_builtin,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [59956] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1234), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2743), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2741), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60014] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2504), 1,
      anon_sym_SLASH,
    STATE(430), 1,
      sym_multiplicative_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    STATE(1235), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(2499), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2497), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60080] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1236), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2954), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2952), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60138] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1237), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2698), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2694), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60196] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3186), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1238), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3183), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(3026), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3024), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [60258] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1239), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(984), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(980), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60316] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1240), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1881), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1879), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60374] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3192), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1241), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3189), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2824), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2822), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [60436] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1242), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2716), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60494] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1243), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1688), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1690), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60552] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1244), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1041), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1039), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60610] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3198), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1245), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3195), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(3068), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(3066), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [60672] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1246), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2676), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2672), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60730] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1247), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2661), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2657), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60788] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1248), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3010), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3008), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60846] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1486), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1249), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1489), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1332), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1322), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [60908] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1250), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3030), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3028), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60966] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(430), 1,
      sym_multiplicative_operator,
    STATE(1235), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1251), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2491), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2489), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61034] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1252), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1821), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1819), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61092] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1253), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1729), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1727), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61150] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3201), 1,
      anon_sym_DOT,
    STATE(1254), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_QMARK_DOT,
    ACTIONS(1322), 24,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61210] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1255), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1686), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1680), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61268] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1256), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2994), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2992), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61326] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1257), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2688), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2686), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61384] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1686), 1,
      anon_sym_BANG,
    ACTIONS(2869), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1258), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1680), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1682), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1684), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61448] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1678), 1,
      anon_sym_BANG,
    ACTIONS(2859), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1259), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1672), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1674), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1676), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61512] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(430), 1,
      sym_multiplicative_operator,
    STATE(1251), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1260), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2473), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2471), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61580] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1261), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3044), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3042), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61638] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1262), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3096), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3094), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61696] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1263), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2990), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2988), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61754] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1264), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2820), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2818), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61812] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3207), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1265), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3204), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2850), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2848), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [61874] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3213), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1266), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3210), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2854), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2852), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [61936] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1267), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1277), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1257), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61994] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1268), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2874), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2872), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62052] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1686), 1,
      anon_sym_BANG,
    ACTIONS(2829), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(1269), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1680), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1699), 5,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1701), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62116] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1270), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2914), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2912), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62174] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1271), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2982), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2980), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62232] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1272), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3092), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3090), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62290] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1273), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2854), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2852), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62348] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1274), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2850), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2848), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62406] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1275), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2816), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2814), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62464] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1276), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2906), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2904), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62522] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1277), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2938), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2936), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62580] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1278), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1332), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(1322), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62638] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1279), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3068), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3066), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62696] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1280), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2962), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2960), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62754] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1281), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3088), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3086), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62812] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1282), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3064), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3062), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62870] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3219), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1283), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3216), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2986), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2984), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [62932] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3224), 1,
      anon_sym_QMARK,
    ACTIONS(3228), 1,
      anon_sym_LT,
    STATE(1305), 1,
      sym_type_parameters,
    STATE(1311), 1,
      sym_nullable_type,
    STATE(1369), 1,
      sym_parameter_type_list,
    STATE(1284), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2395), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2380), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63002] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1285), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3014), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3012), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63060] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1286), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2986), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2984), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63118] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1287), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2970), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2968), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63176] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1288), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3060), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3058), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63234] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1289), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2878), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2876), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63292] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1290), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3056), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3054), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63350] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1291), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2882), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2880), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63408] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1292), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2930), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2928), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63466] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3232), 1,
      anon_sym_QMARK,
    ACTIONS(3235), 1,
      anon_sym_LT,
    STATE(1305), 1,
      sym_type_parameters,
    STATE(1319), 1,
      sym_nullable_type,
    STATE(1369), 1,
      sym_parameter_type_list,
    STATE(1293), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2460), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2449), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63536] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1294), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3052), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3050), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63594] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1295), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3048), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(3046), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63652] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1296), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2958), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2956), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63710] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3241), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1297), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3238), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2878), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2876), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [63772] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1298), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2966), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
    ACTIONS(2964), 26,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [63830] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3247), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1299), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3244), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2914), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2912), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [63892] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3253), 2,
      anon_sym_QMARK,
      anon_sym_BANG,
    STATE(1300), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3250), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2982), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2980), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [63954] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1301), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2031), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64011] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1302), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3076), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3074), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64068] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1303), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3080), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3078), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64125] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(982), 1,
      anon_sym_EQ,
    ACTIONS(975), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(1304), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(984), 10,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(980), 20,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64186] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3256), 1,
      anon_sym_QMARK,
    STATE(1320), 1,
      sym_nullable_type,
    STATE(1375), 1,
      sym_parameter_type_list,
    STATE(1305), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2507), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64251] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3259), 1,
      anon_sym_Function,
    STATE(1293), 1,
      sym__function_builtin_identifier,
    STATE(1312), 1,
      aux_sym__function_type_tails,
    STATE(1449), 1,
      sym__function_type_tail,
    STATE(1306), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2415), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2413), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64316] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1307), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1674), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1676), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64373] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    STATE(1314), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    ACTIONS(3263), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    STATE(1308), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3261), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [64436] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1309), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3267), 5,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3265), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [64493] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3259), 1,
      anon_sym_Function,
    STATE(1293), 1,
      sym__function_builtin_identifier,
    STATE(1312), 1,
      aux_sym__function_type_tails,
    STATE(1449), 1,
      sym__function_type_tail,
    STATE(1310), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2437), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2435), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64558] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3269), 1,
      anon_sym_QMARK,
    STATE(1375), 1,
      sym_parameter_type_list,
    STATE(1430), 1,
      sym_nullable_type,
    STATE(1311), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2528), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2517), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64623] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3273), 1,
      anon_sym_Function,
    STATE(1293), 1,
      sym__function_builtin_identifier,
    STATE(1449), 1,
      sym__function_type_tail,
    STATE(1312), 3,
      aux_sym__function_type_tails,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2444), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2442), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64686] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1313), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2499), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2497), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64743] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3280), 1,
      anon_sym_AT,
    STATE(1361), 1,
      sym_annotation,
    ACTIONS(3278), 2,
      anon_sym_LPAREN,
      anon_sym_QMARK,
    STATE(1314), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__metadata_repeat1,
    ACTIONS(3276), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [64804] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1315), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3022), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3020), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64861] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1316), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3018), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3016), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64918] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1317), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2130), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2128), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64975] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1318), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2926), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2924), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65032] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3256), 1,
      anon_sym_QMARK,
    STATE(1375), 1,
      sym_parameter_type_list,
    STATE(1430), 1,
      sym_nullable_type,
    STATE(1319), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2507), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65097] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3222), 1,
      anon_sym_LPAREN,
    ACTIONS(3283), 1,
      anon_sym_QMARK,
    STATE(1368), 1,
      sym_parameter_type_list,
    STATE(1439), 1,
      sym_nullable_type,
    STATE(1320), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2479), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65162] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2504), 1,
      anon_sym_SLASH,
    STATE(420), 1,
      sym_multiplicative_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(2501), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    STATE(1321), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_multiplicative_expression_repeat1,
    ACTIONS(2499), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2497), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65226] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3286), 1,
      anon_sym_PIPE,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3290), 1,
      anon_sym_DOT,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(836), 1,
      sym_index_selector,
    STATE(871), 1,
      sym_unconditional_assignable_selector,
    STATE(1177), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1322), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [65332] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(1333), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1323), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2473), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2471), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65398] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3286), 1,
      anon_sym_PIPE,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3292), 1,
      anon_sym_DOT,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(552), 1,
      sym_index_selector,
    STATE(568), 1,
      sym_unconditional_assignable_selector,
    STATE(1177), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1324), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [65504] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3294), 1,
      anon_sym_QMARK,
    ACTIONS(3297), 1,
      anon_sym_LT,
    STATE(1349), 1,
      sym_type_arguments,
    STATE(1441), 1,
      sym_nullable_type,
    STATE(1325), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2531), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65568] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1326), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3302), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3300), 19,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_throw,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      sym_rethrow_builtin,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [65624] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(3311), 1,
      sym_hex_integer_literal,
    STATE(1315), 1,
      sym_super,
    STATE(2127), 1,
      sym__numeric_literal,
    ACTIONS(3308), 2,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
    STATE(1327), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3306), 12,
      anon_sym_POUND,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3304), 14,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [65690] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3286), 1,
      anon_sym_PIPE,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3314), 1,
      anon_sym_DOT,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(552), 1,
      sym_index_selector,
    STATE(568), 1,
      sym_unconditional_assignable_selector,
    STATE(1177), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1328), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [65796] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(420), 1,
      sym_multiplicative_operator,
    STATE(1332), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1329), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2473), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2471), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65862] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2465), 1,
      anon_sym_GT_GT,
    STATE(327), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    ACTIONS(2462), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1330), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_shift_expression_repeat1,
    ACTIONS(1359), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1357), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65926] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3316), 1,
      anon_sym_LPAREN,
    ACTIONS(3318), 1,
      anon_sym_QMARK,
    ACTIONS(3322), 1,
      anon_sym_LT,
    STATE(1353), 1,
      sym_nullable_type,
    STATE(1354), 1,
      sym_type_parameters,
    STATE(1494), 1,
      sym_parameter_type_list,
    STATE(1331), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2395), 6,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2380), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65994] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(420), 1,
      sym_multiplicative_operator,
    STATE(1321), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1332), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2491), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2489), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [66060] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(793), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1333), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(2491), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2489), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [66126] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(327), 1,
      sym_shift_operator,
    STATE(1330), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1334), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2495), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2493), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [66188] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2300), 1,
      anon_sym_LBRACK,
    ACTIONS(2312), 1,
      anon_sym_DOT,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3326), 1,
      anon_sym_PIPE,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(420), 1,
      sym_multiplicative_operator,
    STATE(662), 1,
      sym_unconditional_assignable_selector,
    STATE(676), 1,
      sym_index_selector,
    STATE(1332), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1335), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [66294] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3316), 1,
      anon_sym_LPAREN,
    ACTIONS(3330), 1,
      anon_sym_QMARK,
    ACTIONS(3333), 1,
      anon_sym_LT,
    STATE(1352), 1,
      sym_nullable_type,
    STATE(1354), 1,
      sym_type_parameters,
    STATE(1494), 1,
      sym_parameter_type_list,
    STATE(1336), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2460), 6,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2449), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [66362] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3286), 1,
      anon_sym_PIPE,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3336), 1,
      anon_sym_DOT,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(552), 1,
      sym_index_selector,
    STATE(568), 1,
      sym_unconditional_assignable_selector,
    STATE(1177), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1337), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [66468] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3336), 1,
      anon_sym_DOT,
    ACTIONS(3338), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_AMP,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(552), 1,
      sym_index_selector,
    STATE(568), 1,
      sym_unconditional_assignable_selector,
    STATE(791), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1338), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [66574] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3336), 1,
      anon_sym_DOT,
    ACTIONS(3342), 1,
      anon_sym_PIPE,
    ACTIONS(3344), 1,
      anon_sym_AMP,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(552), 1,
      sym_index_selector,
    STATE(568), 1,
      sym_unconditional_assignable_selector,
    STATE(1333), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1339), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [66680] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1263), 1,
      sym_equality_operator,
    ACTIONS(1267), 1,
      anon_sym_CARET,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_DOT,
    ACTIONS(3338), 1,
      anon_sym_PIPE,
    ACTIONS(3340), 1,
      anon_sym_AMP,
    STATE(329), 1,
      sym_relational_operator,
    STATE(343), 1,
      sym_shift_operator,
    STATE(368), 1,
      sym_additive_operator,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(791), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(792), 1,
      aux_sym_shift_expression_repeat1,
    STATE(833), 1,
      aux_sym_additive_expression_repeat1,
    STATE(836), 1,
      sym_index_selector,
    STATE(839), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(840), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(841), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(871), 1,
      sym_unconditional_assignable_selector,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1340), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [66786] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3346), 1,
      anon_sym_DOT,
    STATE(1442), 1,
      sym__type_dot_identifier,
    STATE(1341), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2015), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [66846] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3348), 1,
      anon_sym_PIPE,
    ACTIONS(3350), 1,
      anon_sym_AMP,
    ACTIONS(3352), 1,
      anon_sym_DOT,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(430), 1,
      sym_multiplicative_operator,
    STATE(1028), 1,
      sym_unconditional_assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1251), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1342), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [66952] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2336), 1,
      sym_equality_operator,
    ACTIONS(2340), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3290), 1,
      anon_sym_DOT,
    ACTIONS(3342), 1,
      anon_sym_PIPE,
    ACTIONS(3344), 1,
      anon_sym_AMP,
    STATE(335), 1,
      sym_additive_operator,
    STATE(339), 1,
      sym_shift_operator,
    STATE(351), 1,
      sym_relational_operator,
    STATE(427), 1,
      sym_multiplicative_operator,
    STATE(836), 1,
      sym_index_selector,
    STATE(871), 1,
      sym_unconditional_assignable_selector,
    STATE(1333), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1517), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1582), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1663), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1665), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1666), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1343), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [67058] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3354), 1,
      anon_sym_PIPE,
    ACTIONS(3356), 1,
      anon_sym_AMP,
    ACTIONS(3358), 1,
      anon_sym_DOT,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(425), 1,
      sym_multiplicative_operator,
    STATE(607), 1,
      sym_index_selector,
    STATE(620), 1,
      sym_unconditional_assignable_selector,
    STATE(930), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1344), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [67164] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2202), 1,
      sym_equality_operator,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3348), 1,
      anon_sym_PIPE,
    ACTIONS(3350), 1,
      anon_sym_AMP,
    ACTIONS(3358), 1,
      anon_sym_DOT,
    STATE(355), 1,
      sym_additive_operator,
    STATE(363), 1,
      sym_relational_operator,
    STATE(367), 1,
      sym_shift_operator,
    STATE(430), 1,
      sym_multiplicative_operator,
    STATE(607), 1,
      sym_index_selector,
    STATE(620), 1,
      sym_unconditional_assignable_selector,
    STATE(1251), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1418), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1461), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1513), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1514), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1516), 1,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1345), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [67270] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1440), 1,
      sym_equality_operator,
    ACTIONS(1444), 1,
      anon_sym_CARET,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3352), 1,
      anon_sym_DOT,
    ACTIONS(3354), 1,
      anon_sym_PIPE,
    ACTIONS(3356), 1,
      anon_sym_AMP,
    STATE(317), 1,
      sym_relational_operator,
    STATE(319), 1,
      sym_shift_operator,
    STATE(321), 1,
      sym_additive_operator,
    STATE(425), 1,
      sym_multiplicative_operator,
    STATE(930), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(987), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1005), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1028), 1,
      sym_unconditional_assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(1063), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1072), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1084), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1346), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [67376] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2320), 1,
      anon_sym_LBRACK,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    ACTIONS(2402), 1,
      sym_equality_operator,
    ACTIONS(2406), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3326), 1,
      anon_sym_PIPE,
    ACTIONS(3328), 1,
      anon_sym_AMP,
    STATE(349), 1,
      sym_relational_operator,
    STATE(356), 1,
      sym_shift_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(420), 1,
      sym_multiplicative_operator,
    STATE(1205), 1,
      sym_unconditional_assignable_selector,
    STATE(1211), 1,
      sym_index_selector,
    STATE(1332), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(1535), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1606), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1617), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1626), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1660), 1,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1347), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [67482] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    ACTIONS(2068), 1,
      sym_equality_operator,
    ACTIONS(2072), 1,
      anon_sym_CARET,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3286), 1,
      anon_sym_PIPE,
    ACTIONS(3288), 1,
      anon_sym_AMP,
    ACTIONS(3360), 1,
      anon_sym_DOT,
    STATE(320), 1,
      sym_relational_operator,
    STATE(327), 1,
      sym_shift_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(424), 1,
      sym_multiplicative_operator,
    STATE(552), 1,
      sym_index_selector,
    STATE(568), 1,
      sym_unconditional_assignable_selector,
    STATE(1177), 1,
      aux_sym_multiplicative_expression_repeat1,
    STATE(1334), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1386), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1405), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1408), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1409), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1416), 1,
      sym__multiplicative_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1348), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
  [67588] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3362), 1,
      anon_sym_QMARK,
    STATE(1427), 1,
      sym_nullable_type,
    STATE(1349), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2550), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67647] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1350), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2934), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2932), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67702] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3316), 1,
      anon_sym_LPAREN,
    ACTIONS(3365), 1,
      anon_sym_QMARK,
    STATE(1459), 1,
      sym_parameter_type_list,
    STATE(1528), 1,
      sym_nullable_type,
    STATE(1351), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2479), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67765] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3316), 1,
      anon_sym_LPAREN,
    ACTIONS(3368), 1,
      anon_sym_QMARK,
    STATE(1492), 1,
      sym_parameter_type_list,
    STATE(1541), 1,
      sym_nullable_type,
    STATE(1352), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2507), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67828] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3316), 1,
      anon_sym_LPAREN,
    ACTIONS(3371), 1,
      anon_sym_QMARK,
    STATE(1492), 1,
      sym_parameter_type_list,
    STATE(1541), 1,
      sym_nullable_type,
    STATE(1353), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2528), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2517), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67891] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3316), 1,
      anon_sym_LPAREN,
    ACTIONS(3368), 1,
      anon_sym_QMARK,
    STATE(1351), 1,
      sym_nullable_type,
    STATE(1492), 1,
      sym_parameter_type_list,
    STATE(1354), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2507), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67954] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(275), 1,
      sym__assignment_operator,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1478), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1593), 1,
      sym__assignable_selector,
    STATE(1965), 1,
      sym__cascade_assignment_section,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1355), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1071), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1065), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [68025] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1356), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2739), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2737), 25,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68080] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3375), 1,
      anon_sym_super,
    STATE(969), 1,
      sym_super,
    STATE(1357), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3306), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3304), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [68139] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    ACTIONS(3377), 1,
      anon_sym_QMARK,
    STATE(1423), 1,
      sym_nullable_type,
    STATE(1358), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2541), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68200] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3380), 1,
      anon_sym_super,
    STATE(1154), 1,
      sym_super,
    STATE(1359), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3306), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3304), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [68259] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1360), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2710), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2708), 25,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68314] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1361), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3384), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AT,
    ACTIONS(3382), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [68369] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3386), 1,
      anon_sym_Function,
    STATE(1336), 1,
      sym__function_builtin_identifier,
    STATE(1551), 1,
      sym__function_type_tail,
    STATE(1362), 3,
      aux_sym__function_type_tails,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2444), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2442), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68430] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3389), 1,
      anon_sym_Function,
    STATE(1336), 1,
      sym__function_builtin_identifier,
    STATE(1362), 1,
      aux_sym__function_type_tails,
    STATE(1551), 1,
      sym__function_type_tail,
    STATE(1363), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2437), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2435), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68493] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1364), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2747), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2745), 25,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68548] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(275), 1,
      sym__assignment_operator,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1478), 1,
      aux_sym_cascade_section_repeat2,
    STATE(1593), 1,
      sym__assignable_selector,
    STATE(1963), 1,
      sym__cascade_assignment_section,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1365), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1155), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1153), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [68619] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3389), 1,
      anon_sym_Function,
    STATE(1336), 1,
      sym__function_builtin_identifier,
    STATE(1362), 1,
      aux_sym__function_type_tails,
    STATE(1551), 1,
      sym__function_type_tail,
    STATE(1366), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2415), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2413), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68682] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1367), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2640), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2638), 25,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68737] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3391), 1,
      anon_sym_QMARK,
    STATE(1406), 1,
      sym_nullable_type,
    STATE(1368), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2567), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68796] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3256), 1,
      anon_sym_QMARK,
    STATE(1430), 1,
      sym_nullable_type,
    STATE(1369), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2507), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [68855] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1370), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3396), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AT,
    ACTIONS(3394), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [68910] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(3400), 1,
      anon_sym_DOT,
    STATE(1611), 1,
      sym_arguments,
    STATE(3145), 1,
      sym_type_arguments,
    ACTIONS(3159), 2,
      anon_sym_AT,
      sym_part_of_builtin,
    STATE(1371), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3155), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [68975] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1372), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3404), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AT,
    ACTIONS(3402), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [69030] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1373), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2499), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2497), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69085] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1374), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1819), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AT,
    ACTIONS(1821), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [69140] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3283), 1,
      anon_sym_QMARK,
    STATE(1439), 1,
      sym_nullable_type,
    STATE(1375), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2479), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69199] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1376), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1879), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_AT,
    ACTIONS(1881), 28,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_operator,
      anon_sym_mixin,
      anon_sym_required,
      anon_sym_set,
      anon_sym_static,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [69254] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2577), 1,
      sym__additive_operator,
    STATE(328), 1,
      sym_additive_operator,
    STATE(1377), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_additive_expression_repeat1,
    ACTIONS(1355), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1353), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69313] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1378), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2130), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2128), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69368] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1379), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2926), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2924), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69423] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1380), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1674), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1676), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69478] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1381), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3018), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(3016), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69533] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1382), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3022), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(3020), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69588] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2574), 1,
      anon_sym_AMP_AMP,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(1383), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(1434), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1432), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_PIPE_PIPE,
  [69647] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2564), 1,
      anon_sym_PIPE_PIPE,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1384), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(1416), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1414), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
  [69706] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(161), 1,
      anon_sym_super,
    STATE(1315), 1,
      sym_super,
    STATE(1385), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3306), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3304), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [69765] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(328), 1,
      sym_additive_operator,
    STATE(1377), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1386), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2596), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2594), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69824] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3406), 1,
      anon_sym_super,
    STATE(1487), 1,
      sym_super,
    STATE(1387), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3306), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3304), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [69883] = 36,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1722), 1,
      sym__metadata,
    STATE(1764), 1,
      sym_final_builtin,
    STATE(1771), 1,
      sym_inferred_type,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1799), 1,
      sym__covariant,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(2667), 1,
      sym__declared_identifier,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2943), 1,
      sym__type,
    STATE(3419), 1,
      sym__final_const_var_or_type,
    STATE(1388), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3160), 2,
      sym_pattern_variable_declaration,
      sym_initialized_variable_definition,
  [69994] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1389), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3076), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(3074), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70049] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1390), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2031), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2017), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70104] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1391), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3080), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(3078), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70159] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(330), 1,
      sym_logical_and_operator,
    STATE(1383), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1392), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2604), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2602), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70218] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(332), 1,
      sym_logical_or_operator,
    STATE(1384), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1393), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2600), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2598), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70277] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3410), 1,
      anon_sym_super,
    STATE(1382), 1,
      sym_super,
    STATE(1394), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3306), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3304), 16,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      sym_identifier,
  [70336] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1395), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3414), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3412), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [70390] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1396), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2688), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2686), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70444] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1397), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3418), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3416), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [70498] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1410), 1,
      aux_sym__if_null_expression,
    STATE(1398), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2751), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2749), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70554] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1399), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3422), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3420), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [70608] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1400), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2743), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2741), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70662] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1401), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3426), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3424), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [70716] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1402), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3430), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3428), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [70770] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1403), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2644), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2642), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70824] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1404), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3422), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_minus_operator,
    ACTIONS(3420), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      sym_const_builtin,
      sym_identifier,
  [70878] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1413), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1405), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2612), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2610), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70934] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1406), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2651), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2649), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70988] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1407), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2716), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71042] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1417), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1408), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2616), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2614), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71098] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1421), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1409), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2620), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2618), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71154] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3432), 1,
      anon_sym_QMARK_QMARK,
    STATE(1410), 3,
      aux_sym__if_null_expression,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2807), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71210] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1411), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2655), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2653), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71264] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1412), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3437), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3435), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [71318] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3439), 1,
      anon_sym_PIPE,
    STATE(1413), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(1420), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1418), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71374] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1414), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2680), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2678), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71428] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1415), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3444), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3442), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [71482] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1416), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3448), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3446), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [71536] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3450), 1,
      anon_sym_CARET,
    STATE(1417), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(1397), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1395), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71592] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1431), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1418), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2495), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2493), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71652] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1419), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2684), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2682), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71706] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3457), 1,
      anon_sym_AT,
    ACTIONS(3460), 1,
      anon_sym_part,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1671), 1,
      sym_part_directive,
    STATE(3508), 1,
      sym__metadata,
    ACTIONS(3453), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_part_of_builtin,
    STATE(1420), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_program_repeat2,
    ACTIONS(3455), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [71772] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3463), 1,
      anon_sym_AMP,
    STATE(1421), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(1408), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1406), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71828] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(3468), 1,
      anon_sym_QMARK,
    ACTIONS(3471), 1,
      anon_sym_LT,
    STATE(1468), 1,
      sym_nullable_type,
    STATE(1472), 1,
      sym_type_parameters,
    STATE(1603), 1,
      sym_parameter_type_list,
    STATE(1422), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2460), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2449), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71894] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2766), 1,
      anon_sym_Function,
    STATE(1423), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2762), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [71950] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1424), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2772), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72004] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1425), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2147), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(2149), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [72058] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(3474), 1,
      anon_sym_QMARK,
    ACTIONS(3478), 1,
      anon_sym_LT,
    STATE(1471), 1,
      sym_nullable_type,
    STATE(1472), 1,
      sym_type_parameters,
    STATE(1603), 1,
      sym_parameter_type_list,
    STATE(1426), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2395), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2380), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72124] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1427), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2778), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2776), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72178] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1428), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2782), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2780), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72232] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1429), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2692), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2690), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72286] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1430), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2479), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72340] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2465), 1,
      anon_sym_GT_GT,
    STATE(367), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    ACTIONS(2462), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1431), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_shift_expression_repeat1,
    ACTIONS(1359), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1357), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72402] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1432), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2805), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2803), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72456] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1433), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2702), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2700), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72510] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1434), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3484), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_minus_operator,
    ACTIONS(3482), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      sym_const_builtin,
      sym_identifier,
  [72564] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1435), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2714), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2712), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72618] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1436), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2770), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2768), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72672] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1437), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2735), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2733), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72726] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3486), 1,
      anon_sym_DOT,
    STATE(1545), 1,
      sym__type_dot_identifier,
    STATE(1438), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2015), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72784] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1439), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2567), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72838] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1440), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2801), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2799), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72892] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1441), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2550), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72946] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1442), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2624), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2622), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73000] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3488), 1,
      anon_sym_QMARK,
    ACTIONS(3491), 1,
      anon_sym_LT,
    STATE(1491), 1,
      sym_type_arguments,
    STATE(1539), 1,
      sym_nullable_type,
    STATE(1443), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 6,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2531), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73062] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1444), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3414), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      sym_minus_operator,
    ACTIONS(3412), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      sym_const_builtin,
      sym_identifier,
  [73116] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    STATE(1445), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2541), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73172] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1446), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2722), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2720), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73226] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1447), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2608), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2606), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73280] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3377), 1,
      anon_sym_QMARK,
    STATE(1500), 1,
      sym_nullable_type,
    STATE(1448), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2541), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73338] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1449), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2726), 24,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73392] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1450), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3306), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3304), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [73446] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1451), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3496), 13,
      anon_sym_POUND,
      sym_hex_integer_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_increment_operator,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(3494), 17,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_null,
      sym_minus_operator,
      anon_sym_await,
      anon_sym_switch,
      anon_sym_new,
      sym_const_builtin,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [73500] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1452), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2934), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2932), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73553] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1453), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2974), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2972), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73606] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(19), 1,
      anon_sym_AT,
    STATE(1473), 1,
      aux_sym__metadata_repeat1,
    STATE(1571), 1,
      sym_annotation,
    ACTIONS(3263), 2,
      anon_sym_LPAREN,
      sym_part_of_builtin,
    STATE(1454), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3261), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [73665] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3498), 1,
      anon_sym_Function,
    STATE(1422), 1,
      sym__function_builtin_identifier,
    STATE(1462), 1,
      aux_sym__function_type_tails,
    STATE(1615), 1,
      sym__function_type_tail,
    STATE(1455), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2415), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2413), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73726] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(1464), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1456), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2600), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2598), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73783] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(1465), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1457), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2604), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2602), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73840] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1458), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2747), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2745), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73893] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3500), 1,
      anon_sym_QMARK,
    STATE(1507), 1,
      sym_nullable_type,
    STATE(1459), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2567), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73950] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3498), 1,
      anon_sym_Function,
    STATE(1422), 1,
      sym__function_builtin_identifier,
    STATE(1462), 1,
      aux_sym__function_type_tails,
    STATE(1615), 1,
      sym__function_type_tail,
    STATE(1460), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2437), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2435), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74011] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(355), 1,
      sym_additive_operator,
    STATE(1466), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1461), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2596), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2594), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74068] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3503), 1,
      anon_sym_Function,
    STATE(1422), 1,
      sym__function_builtin_identifier,
    STATE(1615), 1,
      sym__function_type_tail,
    STATE(1462), 3,
      aux_sym__function_type_tails,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2444), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2442), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74127] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3506), 1,
      anon_sym_LPAREN,
    ACTIONS(3508), 1,
      anon_sym_QMARK,
    ACTIONS(3511), 1,
      anon_sym_LT,
    STATE(1557), 1,
      sym_type_parameters,
    STATE(1587), 1,
      sym_nullable_type,
    STATE(1667), 1,
      sym_parameter_type_list,
    STATE(1463), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2395), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2380), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74192] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2564), 1,
      anon_sym_PIPE_PIPE,
    STATE(352), 1,
      sym_logical_or_operator,
    STATE(1464), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(1416), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1414), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
  [74249] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2574), 1,
      anon_sym_AMP_AMP,
    STATE(354), 1,
      sym_logical_and_operator,
    STATE(1465), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(1434), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1432), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_PIPE_PIPE,
  [74306] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2577), 1,
      sym__additive_operator,
    STATE(355), 1,
      sym_additive_operator,
    STATE(1466), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_additive_expression_repeat1,
    ACTIONS(1355), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1353), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74363] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(3513), 1,
      anon_sym_QMARK,
    STATE(1599), 1,
      sym_parameter_type_list,
    STATE(1635), 1,
      sym_nullable_type,
    STATE(1467), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2479), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74424] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(3516), 1,
      anon_sym_QMARK,
    STATE(1589), 1,
      sym_parameter_type_list,
    STATE(1647), 1,
      sym_nullable_type,
    STATE(1468), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2507), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74485] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1469), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2978), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2976), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74538] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3519), 1,
      anon_sym_DQUOTE,
    ACTIONS(3522), 1,
      anon_sym_SQUOTE,
    ACTIONS(3525), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3528), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3531), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(3534), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(3537), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3540), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1470), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_string_literal_repeat1,
    STATE(1854), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
    ACTIONS(1181), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74607] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(3543), 1,
      anon_sym_QMARK,
    STATE(1589), 1,
      sym_parameter_type_list,
    STATE(1647), 1,
      sym_nullable_type,
    STATE(1471), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2528), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2517), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74668] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3466), 1,
      anon_sym_LPAREN,
    ACTIONS(3516), 1,
      anon_sym_QMARK,
    STATE(1467), 1,
      sym_nullable_type,
    STATE(1589), 1,
      sym_parameter_type_list,
    STATE(1472), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2507), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74729] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3547), 1,
      anon_sym_AT,
    STATE(1571), 1,
      sym_annotation,
    ACTIONS(3278), 2,
      anon_sym_LPAREN,
      sym_part_of_builtin,
    STATE(1473), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__metadata_repeat1,
    ACTIONS(3276), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [74786] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3554), 1,
      anon_sym_AT,
    ACTIONS(3557), 1,
      sym_part_of_builtin,
    STATE(1454), 1,
      aux_sym__metadata_repeat1,
    STATE(1571), 1,
      sym_annotation,
    STATE(1725), 1,
      sym_part_of_directive,
    STATE(3509), 1,
      sym__metadata,
    ACTIONS(3550), 2,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
    STATE(1474), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_program_repeat3,
    ACTIONS(3552), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [74851] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(860), 1,
      anon_sym_DQUOTE,
    ACTIONS(862), 1,
      anon_sym_SQUOTE,
    ACTIONS(864), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(866), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(868), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(870), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(872), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(874), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1470), 1,
      aux_sym_string_literal_repeat1,
    STATE(1475), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(1854), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
    ACTIONS(1185), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74922] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    ACTIONS(3560), 1,
      anon_sym_QMARK,
    STATE(1518), 1,
      sym_nullable_type,
    STATE(1476), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2541), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74981] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1477), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2473), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2471), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75034] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1297), 1,
      anon_sym_LT,
    ACTIONS(2996), 1,
      anon_sym_LBRACK,
    ACTIONS(2999), 1,
      anon_sym_QMARK,
    ACTIONS(3002), 1,
      anon_sym_DOT,
    ACTIONS(3005), 1,
      anon_sym_QMARK_DOT,
    STATE(1141), 1,
      sym__cascade_subsection,
    STATE(1145), 1,
      sym_index_selector,
    STATE(1593), 1,
      sym__assignable_selector,
    STATE(1138), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1478), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_cascade_section_repeat2,
    ACTIONS(1292), 18,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [75103] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1479), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3267), 5,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3265), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [75156] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1480), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3080), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3078), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75209] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1481), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2031), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2017), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75262] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1482), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2499), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2497), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75315] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1483), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3076), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3074), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75368] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1484), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2950), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2948), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75421] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1485), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2946), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2944), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75474] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1486), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2739), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2737), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75527] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1487), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3022), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3020), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75580] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1488), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3018), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(3016), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75633] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1489), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2710), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2708), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75686] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1490), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2640), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2638), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75739] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3563), 1,
      anon_sym_QMARK,
    STATE(1532), 1,
      sym_nullable_type,
    STATE(1491), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2550), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75796] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3365), 1,
      anon_sym_QMARK,
    STATE(1528), 1,
      sym_nullable_type,
    STATE(1492), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2479), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75853] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1493), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2910), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2908), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75906] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3368), 1,
      anon_sym_QMARK,
    STATE(1541), 1,
      sym_nullable_type,
    STATE(1494), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2507), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [75963] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1495), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2926), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2924), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76016] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1496), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2130), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(2128), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76069] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1497), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1410), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76122] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3506), 1,
      anon_sym_LPAREN,
    ACTIONS(3508), 1,
      anon_sym_QMARK,
    ACTIONS(3511), 1,
      anon_sym_LT,
    STATE(1557), 1,
      sym_type_parameters,
    STATE(1607), 1,
      sym_nullable_type,
    STATE(1667), 1,
      sym_parameter_type_list,
    STATE(1498), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2460), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2449), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76187] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1499), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1674), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_SLASH,
    ACTIONS(1676), 22,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76240] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1500), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2762), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76293] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1501), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2842), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2840), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76346] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1502), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2838), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2836), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76399] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1503), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2722), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2720), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76451] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1504), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2745), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2747), 14,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_when,
      anon_sym_on,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [76503] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1505), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2655), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2653), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76555] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1506), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2680), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2678), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76607] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1507), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2651), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2649), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76659] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1508), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2714), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2712), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76711] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3570), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3572), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(2936), 1,
      sym_binary_operator,
    STATE(3346), 1,
      sym__bitwise_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3568), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    STATE(1509), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3566), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(3345), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [76791] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1510), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2772), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76843] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3574), 1,
      anon_sym_QMARK,
    ACTIONS(3577), 1,
      anon_sym_LT,
    STATE(1600), 1,
      sym_type_arguments,
    STATE(1628), 1,
      sym_nullable_type,
    STATE(1511), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 4,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2531), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76903] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1512), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2692), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2690), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76955] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1525), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1513), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2612), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2610), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77009] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1526), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1514), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2616), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2614), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77063] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1515), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2737), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(2739), 14,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_when,
      anon_sym_on,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [77115] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1527), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1516), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2620), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2618), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77169] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(339), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1546), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1517), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2495), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2493), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77227] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2766), 1,
      anon_sym_Function,
    STATE(1518), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2762), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77281] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1519), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2770), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2768), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77333] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3580), 1,
      anon_sym_QMARK_QMARK,
    STATE(1520), 3,
      aux_sym__if_null_expression,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2807), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77387] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1521), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2644), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2642), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77439] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1522), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3583), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3585), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [77491] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1523), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2684), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2682), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77543] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3560), 1,
      anon_sym_QMARK,
    STATE(1583), 1,
      sym_nullable_type,
    STATE(1524), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2541), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77599] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3587), 1,
      anon_sym_PIPE,
    STATE(1525), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(1420), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1418), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77653] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3590), 1,
      anon_sym_CARET,
    STATE(1526), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(1397), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1395), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77707] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3593), 1,
      anon_sym_AMP,
    STATE(1527), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(1408), 7,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1406), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77761] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1528), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2567), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77813] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1520), 1,
      aux_sym__if_null_expression,
    STATE(1529), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2751), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2749), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77867] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(3161), 1,
      anon_sym_LT,
    STATE(1664), 1,
      sym_type_arguments,
    STATE(1718), 1,
      sym_nullable_type,
    STATE(1530), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2531), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77927] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1531), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2801), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2799), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [77979] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1532), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2778), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2776), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78031] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    STATE(1533), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2541), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78085] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1534), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2735), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2733), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78137] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(356), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1553), 1,
      aux_sym_shift_expression_repeat1,
    STATE(1535), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2495), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2493), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78195] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3596), 1,
      anon_sym_DOT,
    STATE(1645), 1,
      sym__type_dot_identifier,
    STATE(1536), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2015), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78251] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3570), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3600), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(2731), 1,
      sym_binary_operator,
    STATE(3346), 1,
      sym__bitwise_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3598), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    STATE(1537), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3566), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(3345), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [78331] = 33,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(3602), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1930), 1,
      sym__late_builtin,
    STATE(1987), 1,
      sym__final_or_const,
    STATE(2357), 1,
      sym__type,
    STATE(2377), 1,
      sym__set,
    STATE(2411), 1,
      sym__get,
    STATE(2568), 1,
      sym_setter_signature,
    STATE(2616), 1,
      sym_final_builtin,
    STATE(2799), 1,
      sym_inferred_type,
    STATE(1538), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2521), 2,
      sym_getter_signature,
      sym_function_signature,
  [78433] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1539), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2550), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78485] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1540), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2782), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2780), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78537] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1541), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2479), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78589] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3570), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3606), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(2807), 1,
      sym_binary_operator,
    STATE(3346), 1,
      sym__bitwise_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3604), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    STATE(1542), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3566), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(3345), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [78669] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1543), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2805), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2803), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78721] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1544), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2702), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2700), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78773] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1545), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2624), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2622), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78825] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2465), 1,
      anon_sym_GT_GT,
    STATE(339), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    ACTIONS(2462), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1546), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_shift_expression_repeat1,
    ACTIONS(1359), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1357), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78885] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1547), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2743), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2741), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78937] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1548), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2688), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2686), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [78989] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1549), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2608), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2606), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79041] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1550), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2716), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79093] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1551), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2726), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79145] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1273), 1,
      anon_sym_GT_GT,
    ACTIONS(1275), 1,
      sym__additive_operator,
    ACTIONS(2477), 1,
      anon_sym_SLASH,
    ACTIONS(3570), 1,
      anon_sym_EQ_EQ,
    ACTIONS(3610), 1,
      anon_sym_LBRACK_RBRACK_EQ,
    STATE(1397), 1,
      sym__shift_operator,
    STATE(1416), 1,
      sym__multiplicative_operator,
    STATE(2720), 1,
      sym_binary_operator,
    STATE(3346), 1,
      sym__bitwise_operator,
    ACTIONS(400), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(402), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1271), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(3608), 2,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    STATE(1552), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2475), 3,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
    ACTIONS(3566), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(3345), 5,
      sym_relational_operator,
      sym_bitwise_operator,
      sym_shift_operator,
      sym_additive_operator,
      sym_multiplicative_operator,
  [79225] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2465), 1,
      anon_sym_GT_GT,
    STATE(356), 1,
      sym_shift_operator,
    STATE(1397), 1,
      sym__shift_operator,
    ACTIONS(2462), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    STATE(1553), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_shift_expression_repeat1,
    ACTIONS(1359), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1357), 17,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79285] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(1568), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1554), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2604), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2602), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79340] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1555), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3612), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3614), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [79391] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1556), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2710), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2708), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79442] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3506), 1,
      anon_sym_LPAREN,
    ACTIONS(3616), 1,
      anon_sym_QMARK,
    STATE(1559), 1,
      sym_nullable_type,
    STATE(1616), 1,
      sym_parameter_type_list,
    STATE(1557), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2507), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79501] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1558), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3619), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3621), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [79552] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3506), 1,
      anon_sym_LPAREN,
    ACTIONS(3623), 1,
      anon_sym_QMARK,
    STATE(1639), 1,
      sym_parameter_type_list,
    STATE(1680), 1,
      sym_nullable_type,
    STATE(1559), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2479), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79611] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1560), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2978), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2976), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79662] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2564), 1,
      anon_sym_PIPE_PIPE,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(1561), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(1416), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1414), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
  [79717] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2574), 1,
      anon_sym_AMP_AMP,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(1562), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(1434), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1432), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_PIPE_PIPE,
  [79772] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1563), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2974), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2972), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79823] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1564), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3626), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3628), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [79874] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3630), 1,
      anon_sym_Function,
    STATE(1498), 1,
      sym__function_builtin_identifier,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1565), 3,
      aux_sym__function_type_tails,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2444), 10,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2442), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79931] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1566), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2640), 13,
      anon_sym_EQ,
      anon_sym_extends,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2638), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79982] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1567), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3633), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3635), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80033] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2574), 1,
      anon_sym_AMP_AMP,
    STATE(309), 1,
      sym_logical_and_operator,
    STATE(1568), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_and_expression_repeat1,
    ACTIONS(1434), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1432), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_PIPE_PIPE,
  [80088] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1569), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3637), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3639), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80139] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(322), 1,
      sym_logical_or_operator,
    STATE(1561), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1570), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2600), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2598), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80194] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1571), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3384), 3,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3382), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80245] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1572), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3641), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3643), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80296] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1573), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(1410), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80347] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(324), 1,
      sym_logical_and_operator,
    STATE(1562), 1,
      aux_sym_logical_and_expression_repeat1,
    STATE(1574), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2604), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2602), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80402] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2577), 1,
      sym__additive_operator,
    STATE(335), 1,
      sym_additive_operator,
    STATE(1575), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_additive_expression_repeat1,
    ACTIONS(1355), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1353), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80457] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1576), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3645), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3647), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80508] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1577), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3649), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3651), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80559] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1578), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2946), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2944), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80610] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1579), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3653), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3655), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80661] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2577), 1,
      sym__additive_operator,
    STATE(361), 1,
      sym_additive_operator,
    STATE(1580), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_additive_expression_repeat1,
    ACTIONS(1355), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1353), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80716] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1581), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3657), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3659), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80767] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(335), 1,
      sym_additive_operator,
    STATE(1575), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1582), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2596), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2594), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80822] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1583), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2762), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80873] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1584), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3661), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3663), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80924] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1585), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3396), 3,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3394), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [80975] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(45), 1,
      anon_sym_Function,
    STATE(1498), 1,
      sym__function_builtin_identifier,
    STATE(1565), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1586), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2437), 10,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2435), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81034] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3506), 1,
      anon_sym_LPAREN,
    ACTIONS(3616), 1,
      anon_sym_QMARK,
    STATE(1616), 1,
      sym_parameter_type_list,
    STATE(1684), 1,
      sym_nullable_type,
    STATE(1587), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2528), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2517), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81093] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1588), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2640), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2638), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81144] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3513), 1,
      anon_sym_QMARK,
    STATE(1635), 1,
      sym_nullable_type,
    STATE(1589), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2479), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81199] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    STATE(1631), 1,
      sym_nullable_type,
    STATE(1590), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2541), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81256] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1591), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2910), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2908), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81307] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1608), 1,
      aux_sym_logical_or_expression_repeat1,
    STATE(1592), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2600), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2598), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81362] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1392), 1,
      anon_sym_LT,
    ACTIONS(3668), 1,
      anon_sym_LPAREN,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(1597), 1,
      aux_sym_cascade_section_repeat1,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(1593), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1390), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1385), 18,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [81425] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1594), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2838), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2836), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81476] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1595), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2842), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2840), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81527] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1596), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2950), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2948), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81578] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1378), 1,
      anon_sym_LT,
    ACTIONS(3671), 1,
      anon_sym_LPAREN,
    STATE(874), 1,
      aux_sym_cascade_section_repeat1,
    STATE(1088), 1,
      sym_argument_part,
    STATE(1109), 1,
      sym_arguments,
    STATE(3052), 1,
      sym_type_arguments,
    STATE(1597), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1376), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1371), 18,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
  [81641] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1598), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3674), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3676), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [81692] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3678), 1,
      anon_sym_QMARK,
    STATE(1644), 1,
      sym_nullable_type,
    STATE(1599), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2567), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81747] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3681), 1,
      anon_sym_QMARK,
    STATE(1618), 1,
      sym_nullable_type,
    STATE(1600), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2550), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81802] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1601), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2747), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2745), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81853] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1602), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2739), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2737), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81904] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3516), 1,
      anon_sym_QMARK,
    STATE(1647), 1,
      sym_nullable_type,
    STATE(1603), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2507), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81959] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1604), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3684), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3686), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [82010] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(45), 1,
      anon_sym_Function,
    STATE(1498), 1,
      sym__function_builtin_identifier,
    STATE(1565), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1605), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2415), 10,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2413), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82069] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(361), 1,
      sym_additive_operator,
    STATE(1580), 1,
      aux_sym_additive_expression_repeat1,
    STATE(1606), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2596), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2594), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82124] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3506), 1,
      anon_sym_LPAREN,
    ACTIONS(3616), 1,
      anon_sym_QMARK,
    STATE(1616), 1,
      sym_parameter_type_list,
    STATE(1684), 1,
      sym_nullable_type,
    STATE(1607), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2507), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82183] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2564), 1,
      anon_sym_PIPE_PIPE,
    STATE(369), 1,
      sym_logical_or_operator,
    STATE(1608), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_logical_or_expression_repeat1,
    ACTIONS(1416), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1414), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
  [82238] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1609), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2473), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
      anon_sym_async,
    ACTIONS(2471), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82289] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1610), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1043), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(1045), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [82340] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1611), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3404), 3,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3402), 24,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_library,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [82391] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1612), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2624), 12,
      anon_sym_EQ,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2622), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82442] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1613), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3688), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3690), 23,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_export,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_import,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [82493] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(1614), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 10,
      anon_sym_EQ,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2015), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82547] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1615), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2726), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82597] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3623), 1,
      anon_sym_QMARK,
    STATE(1680), 1,
      sym_nullable_type,
    STATE(1616), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2479), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82651] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1653), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1617), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2620), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2618), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82703] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1618), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2778), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2776), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82753] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1619), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2722), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2720), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82803] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1620), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2782), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2780), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82853] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1621), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2801), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2799), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82903] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1622), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2716), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82953] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1623), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2735), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2733), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83003] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1624), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2714), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2712), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83053] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1625), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2710), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2708), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83103] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1654), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1626), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2616), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2614), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83155] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2548), 1,
      anon_sym_Function,
    STATE(1627), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2541), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83207] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1628), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2550), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83257] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1629), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2702), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2700), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83307] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3694), 1,
      anon_sym_QMARK_QMARK,
    STATE(1630), 3,
      aux_sym__if_null_expression,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2807), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83359] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2766), 1,
      anon_sym_Function,
    STATE(1631), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2762), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83411] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1632), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2770), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2768), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83461] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1633), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2692), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2690), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83511] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1634), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2743), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2741), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83561] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1635), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2567), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83611] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1636), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2718), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2716), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83661] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1637), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2684), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2682), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83711] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1638), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2680), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2678), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83761] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3697), 1,
      anon_sym_QMARK,
    STATE(1703), 1,
      sym_nullable_type,
    STATE(1639), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2567), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83815] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1640), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2688), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2686), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83865] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1641), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2772), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83915] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1642), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2688), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2686), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83965] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1643), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2655), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2653), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84015] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1644), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2651), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2649), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84065] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1645), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2624), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2622), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84115] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1646), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2743), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2741), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84165] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1647), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2479), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84215] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3665), 1,
      anon_sym_QMARK,
    STATE(1711), 1,
      sym_nullable_type,
    STATE(1648), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2541), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84269] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1649), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2805), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2803), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84319] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1650), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 11,
      anon_sym_EQ,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2772), 15,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84369] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1651), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2644), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2642), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84419] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1652), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2608), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2606), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84469] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3700), 1,
      anon_sym_AMP,
    STATE(1653), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(1408), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1406), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84521] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3703), 1,
      anon_sym_CARET,
    STATE(1654), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(1397), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1395), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84573] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3706), 1,
      anon_sym_PIPE,
    STATE(1655), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(1420), 5,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1418), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84625] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3709), 1,
      anon_sym_AMP,
    STATE(1656), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_and_expression_repeat1,
    ACTIONS(1408), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1406), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84677] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3712), 1,
      anon_sym_CARET,
    STATE(1657), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_xor_expression_repeat1,
    ACTIONS(1397), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1395), 15,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84729] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3715), 1,
      anon_sym_PIPE,
    STATE(1658), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_bitwise_or_expression_repeat1,
    ACTIONS(1420), 8,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(1418), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84781] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3718), 1,
      anon_sym_QMARK_QMARK,
    STATE(1659), 3,
      aux_sym__if_null_expression,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2812), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2807), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84833] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1655), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1660), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2612), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2610), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84885] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1659), 1,
      aux_sym__if_null_expression,
    STATE(1661), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2751), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2749), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84937] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1630), 1,
      aux_sym__if_null_expression,
    STATE(1662), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2751), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2749), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [84989] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1658), 1,
      aux_sym_bitwise_or_expression_repeat1,
    STATE(1663), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2612), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2610), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85041] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(1721), 1,
      sym_nullable_type,
    STATE(1664), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2550), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85095] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1657), 1,
      aux_sym_bitwise_xor_expression_repeat1,
    STATE(1665), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2616), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2614), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85147] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1656), 1,
      aux_sym_bitwise_and_expression_repeat1,
    STATE(1666), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2620), 9,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2618), 16,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85199] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3616), 1,
      anon_sym_QMARK,
    STATE(1684), 1,
      sym_nullable_type,
    STATE(1667), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2507), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85253] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(1711), 1,
      anon_sym_static,
    ACTIONS(3721), 1,
      sym_identifier,
    ACTIONS(3724), 1,
      anon_sym_LPAREN,
    ACTIONS(3727), 1,
      sym_void_type,
    ACTIONS(3730), 1,
      anon_sym_Function,
    ACTIONS(3735), 1,
      sym_const_builtin,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1552), 1,
      sym__operator,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2515), 1,
      sym__static,
    STATE(3229), 1,
      sym__type,
    STATE(3333), 1,
      sym__factory,
    ACTIONS(3733), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1668), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3314), 4,
      sym_operator_signature,
      sym_factory_constructor_signature,
      sym_constructor_signature,
      sym_constant_constructor_signature,
  [85343] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1669), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2974), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2972), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85392] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1670), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2702), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2700), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85441] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1671), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3737), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3739), 21,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [85490] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1672), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2770), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2768), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85539] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3745), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2730), 1,
      sym_normal_parameter_type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3292), 1,
      sym_optional_parameter_types,
    STATE(1673), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [85632] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1674), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3747), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3749), 21,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [85681] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1675), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2950), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2948), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85730] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1676), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2782), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2780), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85779] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1677), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2838), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2836), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85828] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1678), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2805), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2803), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85877] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1679), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2473), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2471), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85926] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1680), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2572), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2567), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85975] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1681), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2801), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2799), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86024] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1682), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2946), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2944), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86073] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1683), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2680), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2678), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86122] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1684), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2479), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86171] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1685), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2684), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2682), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86220] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3751), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3484), 1,
      sym_optional_parameter_types,
    STATE(1686), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [86313] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1687), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2735), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2733), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86362] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3753), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3307), 1,
      sym_optional_parameter_types,
    STATE(1688), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [86455] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3755), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3563), 1,
      sym_optional_parameter_types,
    STATE(1689), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [86548] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3757), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3506), 1,
      sym_optional_parameter_types,
    STATE(1690), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [86641] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3759), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3355), 1,
      sym_optional_parameter_types,
    STATE(1691), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [86734] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1692), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2608), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2606), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86783] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3761), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3328), 1,
      sym_optional_parameter_types,
    STATE(1693), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [86876] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1694), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2714), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2712), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [86925] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3763), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(2959), 1,
      sym_normal_parameter_type,
    STATE(3522), 1,
      sym_optional_parameter_types,
    STATE(1695), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [87018] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1696), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2910), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2908), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87067] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1697), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2692), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2690), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87116] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3765), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3316), 1,
      sym_optional_parameter_types,
    STATE(1698), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [87209] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3767), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3352), 1,
      sym_optional_parameter_types,
    STATE(1699), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [87302] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1700), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2655), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2653), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87351] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3769), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2701), 1,
      sym_normal_parameter_type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3336), 1,
      sym_optional_parameter_types,
    STATE(1701), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [87444] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1702), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2722), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2720), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87493] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1703), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2651), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2649), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87542] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1704), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2728), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2726), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87591] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3771), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3569), 1,
      sym_optional_parameter_types,
    STATE(1705), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [87684] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1706), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2644), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2642), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87733] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3773), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3320), 1,
      sym_optional_parameter_types,
    STATE(1707), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [87826] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1708), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2842), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2840), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87875] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1709), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2978), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2976), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87924] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1710), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1410), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [87973] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1711), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 6,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(2762), 19,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK_QMARK,
      sym_equality_operator,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_is,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88022] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3775), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3465), 1,
      sym_optional_parameter_types,
    STATE(1712), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [88115] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1713), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3777), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3779), 21,
      anon_sym_part,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [88164] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3781), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(2832), 1,
      sym_normal_parameter_type,
    STATE(3394), 1,
      sym_optional_parameter_types,
    STATE(1714), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [88257] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3783), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(3452), 1,
      sym_optional_parameter_types,
    STATE(1715), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [88350] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3785), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(2843), 1,
      sym_normal_parameter_type,
    STATE(3400), 1,
      sym_optional_parameter_types,
    STATE(1716), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [88443] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(3741), 1,
      anon_sym_LBRACE,
    ACTIONS(3743), 1,
      anon_sym_LBRACK,
    ACTIONS(3787), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2759), 1,
      sym_normal_parameter_type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3470), 1,
      sym_optional_parameter_types,
    STATE(1717), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3472), 2,
      sym_optional_positional_parameter_types,
      sym_named_parameter_types,
  [88536] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1718), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2550), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88584] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1183), 1,
      anon_sym_QMARK,
    ACTIONS(3789), 1,
      anon_sym_DQUOTE,
    ACTIONS(3792), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3798), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3801), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(3804), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(3807), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3810), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(1719), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_string_literal_repeat1,
    ACTIONS(1181), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1994), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [88650] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1089), 1,
      anon_sym_DQUOTE,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1095), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1097), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(1099), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(1101), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1103), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1187), 1,
      anon_sym_QMARK,
    STATE(1719), 1,
      aux_sym_string_literal_repeat1,
    STATE(1720), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1185), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(1994), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [88718] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1721), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2778), 11,
      anon_sym_when,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_implements,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2776), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88766] = 30,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(153), 1,
      anon_sym_covariant,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1802), 1,
      sym__covariant,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2943), 1,
      sym__type,
    STATE(3536), 1,
      sym__final_const_var_or_type,
    STATE(1722), 2,
      sym_comment,
      sym_documentation_comment,
  [88858] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1723), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3813), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3815), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [88906] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1724), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3817), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3819), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [88954] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1725), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3821), 4,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      sym_part_of_builtin,
    ACTIONS(3823), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89002] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(708), 1,
      anon_sym_DQUOTE,
    ACTIONS(710), 1,
      anon_sym_SQUOTE,
    ACTIONS(712), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(714), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(716), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(718), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(720), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(722), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3827), 1,
      anon_sym_async,
    STATE(595), 1,
      aux_sym_string_literal_repeat1,
    STATE(2458), 1,
      sym_string_literal,
    STATE(1726), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3825), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(729), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [89072] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(876), 1,
      anon_sym_LBRACE,
    ACTIONS(880), 1,
      anon_sym_LBRACK,
    ACTIONS(884), 1,
      anon_sym_LPAREN,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3829), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2421), 1,
      sym__type_name,
    STATE(2965), 1,
      sym__type,
    STATE(3136), 1,
      sym__outer_pattern,
    STATE(3171), 1,
      sym_type_arguments,
    STATE(1727), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3182), 5,
      sym__parenthesized_pattern,
      sym_list_pattern,
      sym_map_pattern,
      sym_record_pattern,
      sym_object_pattern,
  [89153] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1728), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3832), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3834), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89200] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1729), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3836), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3838), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89247] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1730), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3840), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3842), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89294] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1731), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3844), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3846), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89341] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1732), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3848), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3850), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89388] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1733), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3852), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3854), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89435] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1734), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3856), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3858), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89482] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1735), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3860), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3862), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89529] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1736), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3864), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3866), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89576] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1737), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3868), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3870), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89623] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1738), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3872), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3874), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89670] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1739), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3876), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3878), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89717] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1740), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3880), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3882), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89764] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1741), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3884), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3886), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89811] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1742), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3888), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3890), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89858] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1743), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3892), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3894), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89905] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1744), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3896), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3898), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89952] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1745), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3900), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3902), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [89999] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1746), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3904), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3906), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90046] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1747), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3908), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3910), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90093] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1748), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3912), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3914), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90140] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1749), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3916), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3918), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90187] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1750), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3920), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3922), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90234] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1751), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3924), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3926), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90281] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1752), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3928), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3930), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90328] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1753), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3932), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3934), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90375] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1754), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3936), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3938), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90422] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1755), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3940), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3942), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90469] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1756), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3944), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3946), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90516] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1757), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3948), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3950), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90563] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1758), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3952), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3954), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90610] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(876), 1,
      anon_sym_LBRACE,
    ACTIONS(880), 1,
      anon_sym_LBRACK,
    ACTIONS(884), 1,
      anon_sym_LPAREN,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3956), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2421), 1,
      sym__type_name,
    STATE(2987), 1,
      sym__type,
    STATE(3136), 1,
      sym__outer_pattern,
    STATE(3171), 1,
      sym_type_arguments,
    STATE(1759), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3182), 5,
      sym__parenthesized_pattern,
      sym_list_pattern,
      sym_map_pattern,
      sym_record_pattern,
      sym_object_pattern,
  [90691] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1760), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3959), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3961), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90738] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1761), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3963), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3965), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90785] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1762), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3967), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3969), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90832] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1763), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3971), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3973), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [90879] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(876), 1,
      anon_sym_LBRACE,
    ACTIONS(880), 1,
      anon_sym_LBRACK,
    ACTIONS(884), 1,
      anon_sym_LPAREN,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3956), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2421), 1,
      sym__type_name,
    STATE(2987), 1,
      sym__type,
    STATE(3171), 1,
      sym_type_arguments,
    STATE(3413), 1,
      sym__outer_pattern,
    STATE(1764), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3182), 5,
      sym__parenthesized_pattern,
      sym_list_pattern,
      sym_map_pattern,
      sym_record_pattern,
      sym_object_pattern,
  [90960] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1765), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3975), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3977), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91007] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1766), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3979), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3981), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91054] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1767), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3983), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3985), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91101] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1768), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3987), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3989), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91148] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1769), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3991), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3993), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91195] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1770), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3995), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3997), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91242] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(876), 1,
      anon_sym_LBRACE,
    ACTIONS(880), 1,
      anon_sym_LBRACK,
    ACTIONS(884), 1,
      anon_sym_LPAREN,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3829), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2421), 1,
      sym__type_name,
    STATE(2965), 1,
      sym__type,
    STATE(3171), 1,
      sym_type_arguments,
    STATE(3413), 1,
      sym__outer_pattern,
    STATE(1771), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3182), 5,
      sym__parenthesized_pattern,
      sym_list_pattern,
      sym_map_pattern,
      sym_record_pattern,
      sym_object_pattern,
  [91323] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1772), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3999), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4001), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91370] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1773), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4003), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4005), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91417] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1774), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4007), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4009), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91464] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1775), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4011), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4013), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91511] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1776), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4015), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4017), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91558] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1777), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4019), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4021), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91605] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1778), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4023), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4025), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91652] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1779), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4027), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4029), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91699] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1780), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4031), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4033), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91746] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1781), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4035), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4037), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91793] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1782), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4039), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4041), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91840] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1783), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4043), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4045), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91887] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1784), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4047), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4049), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91934] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1785), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4051), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4053), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [91981] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1786), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4055), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4057), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92028] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1787), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4059), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4061), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92075] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1788), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4063), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4065), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92122] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1789), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4067), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4069), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92169] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1790), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4071), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4073), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92216] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1791), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4075), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4077), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92263] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1792), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4079), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4081), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92310] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1793), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4083), 3,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4085), 20,
      anon_sym_enum,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_extension,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_abstract,
      anon_sym_sealed,
      anon_sym_mixin,
      anon_sym_set,
      anon_sym_typedef,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [92357] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(4087), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(3535), 1,
      sym__type,
    STATE(3536), 1,
      sym__final_const_var_or_type,
    STATE(1794), 2,
      sym_comment,
      sym_documentation_comment,
  [92443] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2943), 1,
      sym__type,
    STATE(3536), 1,
      sym__final_const_var_or_type,
    STATE(1795), 2,
      sym_comment,
      sym_documentation_comment,
  [92529] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(45), 1,
      anon_sym_Function,
    STATE(1498), 1,
      sym__function_builtin_identifier,
    STATE(1586), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4089), 7,
      anon_sym_when,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(4091), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [92583] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4093), 1,
      sym_identifier,
    ACTIONS(4096), 1,
      anon_sym_LPAREN,
    ACTIONS(4099), 1,
      sym_void_type,
    ACTIONS(4104), 1,
      anon_sym_Function,
    ACTIONS(4107), 1,
      anon_sym_get,
    ACTIONS(4110), 1,
      anon_sym_static,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1969), 1,
      sym__static,
    STATE(3221), 1,
      sym__type,
    STATE(3314), 1,
      sym_getter_signature,
    STATE(3369), 1,
      sym__get,
    STATE(1797), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4102), 4,
      anon_sym_factory,
      anon_sym_operator,
      anon_sym_set,
      sym_const_builtin,
  [92663] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(4087), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(3300), 1,
      sym__final_const_var_or_type,
    STATE(3535), 1,
      sym__type,
    STATE(1798), 2,
      sym_comment,
      sym_documentation_comment,
  [92749] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2943), 1,
      sym__type,
    STATE(3300), 1,
      sym__final_const_var_or_type,
    STATE(1799), 2,
      sym_comment,
      sym_documentation_comment,
  [92835] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4113), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1961), 1,
      sym__metadata,
    STATE(2007), 1,
      sym__required,
    STATE(3013), 1,
      sym__named_parameter_type,
    STATE(3172), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1800), 2,
      sym_comment,
      sym_documentation_comment,
  [92921] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4115), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1961), 1,
      sym__metadata,
    STATE(2007), 1,
      sym__required,
    STATE(3013), 1,
      sym__named_parameter_type,
    STATE(3172), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1801), 2,
      sym_comment,
      sym_documentation_comment,
  [93007] = 28,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(2268), 1,
      sym_const_builtin,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1915), 1,
      sym__late_builtin,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1984), 1,
      sym_final_builtin,
    STATE(2755), 1,
      sym__var_or_type,
    STATE(2943), 1,
      sym__type,
    STATE(3529), 1,
      sym__final_const_var_or_type,
    STATE(1802), 2,
      sym_comment,
      sym_documentation_comment,
  [93093] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1961), 1,
      sym__metadata,
    STATE(2007), 1,
      sym__required,
    STATE(3013), 1,
      sym__named_parameter_type,
    STATE(3172), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1803), 2,
      sym_comment,
      sym_documentation_comment,
  [93176] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(2156), 1,
      anon_sym_GT,
    ACTIONS(4117), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2723), 1,
      sym__type,
    STATE(2778), 1,
      sym_type_parameter,
    STATE(2779), 1,
      sym__metadata,
    STATE(1804), 2,
      sym_comment,
      sym_documentation_comment,
  [93259] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(1905), 1,
      sym_nullable_type,
    STATE(1805), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4119), 8,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2548), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [93308] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4121), 1,
      sym_identifier,
    ACTIONS(4124), 1,
      anon_sym_LBRACE,
    ACTIONS(4126), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 1,
      anon_sym_LPAREN,
    STATE(979), 1,
      sym__record_literal_no_const,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2407), 1,
      sym_function_type,
    STATE(2424), 1,
      sym__type_not_function,
    STATE(2657), 1,
      sym__type_not_void,
    STATE(2987), 1,
      sym__type,
    STATE(3135), 1,
      sym_type_arguments,
    ACTIONS(4130), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(1806), 2,
      sym_comment,
      sym_documentation_comment,
  [93389] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4121), 1,
      sym_identifier,
    ACTIONS(4132), 1,
      anon_sym_LBRACE,
    ACTIONS(4134), 1,
      anon_sym_LBRACK,
    ACTIONS(4136), 1,
      anon_sym_LPAREN,
    STATE(979), 1,
      sym__record_literal_no_const,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2407), 1,
      sym_function_type,
    STATE(2424), 1,
      sym__type_not_function,
    STATE(2657), 1,
      sym__type_not_void,
    STATE(2987), 1,
      sym__type,
    STATE(3163), 1,
      sym_type_arguments,
    ACTIONS(4130), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(1807), 2,
      sym_comment,
      sym_documentation_comment,
  [93470] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(4138), 1,
      sym_identifier,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2457), 1,
      sym_string_literal,
    STATE(1808), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3240), 2,
      sym_uri,
      sym_dotted_identifier_list,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [93537] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(4138), 1,
      sym_identifier,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2457), 1,
      sym_string_literal,
    STATE(1809), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3107), 2,
      sym_uri,
      sym_dotted_identifier_list,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [93604] = 27,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1961), 1,
      sym__metadata,
    STATE(2007), 1,
      sym__required,
    STATE(2719), 1,
      sym__named_parameter_type,
    STATE(3172), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1810), 2,
      sym_comment,
      sym_documentation_comment,
  [93687] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1811), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1949), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1951), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [93731] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1812), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1981), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1983), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [93775] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4140), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1813), 2,
      sym_comment,
      sym_documentation_comment,
  [93855] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4142), 1,
      anon_sym_RBRACK,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(1814), 2,
      sym_comment,
      sym_documentation_comment,
  [93935] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4144), 1,
      anon_sym_LBRACE,
    ACTIONS(4146), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2670), 1,
      sym_record_type_field,
    STATE(2822), 1,
      sym__type,
    STATE(1815), 2,
      sym_comment,
      sym_documentation_comment,
  [94015] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4148), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1816), 2,
      sym_comment,
      sym_documentation_comment,
  [94095] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2237), 1,
      sym_uri,
    STATE(2320), 1,
      sym_configurable_uri,
    STATE(2457), 1,
      sym_string_literal,
    STATE(1817), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [94161] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(4150), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2343), 1,
      sym__set,
    STATE(2344), 1,
      sym__get,
    STATE(2567), 1,
      sym__type,
    STATE(1818), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3104), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [94237] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4152), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1819), 2,
      sym_comment,
      sym_documentation_comment,
  [94317] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4154), 1,
      anon_sym_LBRACE,
    ACTIONS(4156), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1820), 2,
      sym_comment,
      sym_documentation_comment,
  [94397] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4158), 1,
      anon_sym_LBRACE,
    ACTIONS(4160), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1821), 2,
      sym_comment,
      sym_documentation_comment,
  [94477] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1822), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1977), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1979), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [94521] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4162), 1,
      anon_sym_LBRACE,
    ACTIONS(4164), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1823), 2,
      sym_comment,
      sym_documentation_comment,
  [94601] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4166), 1,
      anon_sym_LBRACE,
    ACTIONS(4168), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1824), 2,
      sym_comment,
      sym_documentation_comment,
  [94681] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1825), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1917), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1919), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [94725] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1826), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1985), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1987), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [94769] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1827), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1989), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1991), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [94813] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1828), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1973), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1975), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [94857] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1829), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1969), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1971), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [94901] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4170), 1,
      anon_sym_LBRACE,
    ACTIONS(4172), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1830), 2,
      sym_comment,
      sym_documentation_comment,
  [94981] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1831), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1965), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1967), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [95025] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1832), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1953), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1955), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [95069] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4174), 1,
      anon_sym_LBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(2827), 1,
      sym_record_type_field,
    STATE(1833), 2,
      sym_comment,
      sym_documentation_comment,
  [95149] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4176), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1834), 2,
      sym_comment,
      sym_documentation_comment,
  [95229] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4178), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1835), 2,
      sym_comment,
      sym_documentation_comment,
  [95309] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4180), 1,
      anon_sym_LBRACE,
    ACTIONS(4182), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(2985), 1,
      sym_record_type_field,
    STATE(1836), 2,
      sym_comment,
      sym_documentation_comment,
  [95389] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4184), 1,
      anon_sym_LBRACE,
    ACTIONS(4186), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1837), 2,
      sym_comment,
      sym_documentation_comment,
  [95469] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4188), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1838), 2,
      sym_comment,
      sym_documentation_comment,
  [95549] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4190), 1,
      anon_sym_LBRACE,
    ACTIONS(4192), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(2878), 1,
      sym_record_type_field,
    STATE(1839), 2,
      sym_comment,
      sym_documentation_comment,
  [95629] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2457), 1,
      sym_string_literal,
    STATE(2507), 1,
      sym_uri,
    STATE(2514), 1,
      sym_configurable_uri,
    STATE(1840), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [95695] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4194), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1841), 2,
      sym_comment,
      sym_documentation_comment,
  [95775] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4196), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1842), 2,
      sym_comment,
      sym_documentation_comment,
  [95855] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4198), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1843), 2,
      sym_comment,
      sym_documentation_comment,
  [95935] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4200), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1844), 2,
      sym_comment,
      sym_documentation_comment,
  [96015] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4202), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1845), 2,
      sym_comment,
      sym_documentation_comment,
  [96095] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4204), 1,
      anon_sym_LBRACE,
    ACTIONS(4206), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1846), 2,
      sym_comment,
      sym_documentation_comment,
  [96175] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4208), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1847), 2,
      sym_comment,
      sym_documentation_comment,
  [96255] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(1919), 1,
      sym_nullable_type,
    STATE(1848), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4089), 7,
      anon_sym_when,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(4091), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [96303] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4210), 1,
      anon_sym_LBRACE,
    ACTIONS(4212), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1849), 2,
      sym_comment,
      sym_documentation_comment,
  [96383] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1850), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1921), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1923), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [96427] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4214), 1,
      anon_sym_LBRACE,
    ACTIONS(4216), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1851), 2,
      sym_comment,
      sym_documentation_comment,
  [96507] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4218), 1,
      anon_sym_LBRACE,
    ACTIONS(4220), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1852), 2,
      sym_comment,
      sym_documentation_comment,
  [96587] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1853), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1925), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1927), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [96631] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1854), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1961), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1963), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [96675] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4222), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1855), 2,
      sym_comment,
      sym_documentation_comment,
  [96755] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4224), 1,
      anon_sym_LBRACE,
    ACTIONS(4226), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2708), 1,
      sym_record_type_field,
    STATE(2822), 1,
      sym__type,
    STATE(1856), 2,
      sym_comment,
      sym_documentation_comment,
  [96835] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4228), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1857), 2,
      sym_comment,
      sym_documentation_comment,
  [96915] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4230), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1858), 2,
      sym_comment,
      sym_documentation_comment,
  [96995] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4232), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1859), 2,
      sym_comment,
      sym_documentation_comment,
  [97075] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1860), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1929), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1931), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [97119] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4234), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1861), 2,
      sym_comment,
      sym_documentation_comment,
  [97199] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4236), 1,
      anon_sym_LBRACE,
    ACTIONS(4238), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1862), 2,
      sym_comment,
      sym_documentation_comment,
  [97279] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4240), 1,
      anon_sym_LBRACE,
    ACTIONS(4242), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2794), 1,
      sym_record_type_field,
    STATE(2822), 1,
      sym__type,
    STATE(1863), 2,
      sym_comment,
      sym_documentation_comment,
  [97359] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4244), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1864), 2,
      sym_comment,
      sym_documentation_comment,
  [97439] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1865), 2,
      sym_comment,
      sym_documentation_comment,
  [97519] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4248), 1,
      anon_sym_RBRACK,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(1866), 2,
      sym_comment,
      sym_documentation_comment,
  [97599] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4250), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1867), 2,
      sym_comment,
      sym_documentation_comment,
  [97679] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1868), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1945), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1947), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [97723] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2457), 1,
      sym_string_literal,
    STATE(2505), 1,
      sym_configurable_uri,
    STATE(2507), 1,
      sym_uri,
    STATE(1869), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [97789] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4252), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1870), 2,
      sym_comment,
      sym_documentation_comment,
  [97869] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4254), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1871), 2,
      sym_comment,
      sym_documentation_comment,
  [97949] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4256), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1872), 2,
      sym_comment,
      sym_documentation_comment,
  [98029] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4258), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1873), 2,
      sym_comment,
      sym_documentation_comment,
  [98109] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4260), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1874), 2,
      sym_comment,
      sym_documentation_comment,
  [98189] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4262), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1875), 2,
      sym_comment,
      sym_documentation_comment,
  [98269] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4264), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1876), 2,
      sym_comment,
      sym_documentation_comment,
  [98349] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4266), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1877), 2,
      sym_comment,
      sym_documentation_comment,
  [98429] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4268), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1878), 2,
      sym_comment,
      sym_documentation_comment,
  [98509] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1879), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1889), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1891), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [98553] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(4150), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2343), 1,
      sym__set,
    STATE(2344), 1,
      sym__get,
    STATE(2567), 1,
      sym__type,
    STATE(1880), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3264), 3,
      sym_getter_signature,
      sym_setter_signature,
      sym_function_signature,
  [98629] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4270), 1,
      anon_sym_LBRACE,
    ACTIONS(4272), 1,
      anon_sym_RPAREN,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1881), 2,
      sym_comment,
      sym_documentation_comment,
  [98709] = 26,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4274), 1,
      anon_sym_RBRACE,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1882), 2,
      sym_comment,
      sym_documentation_comment,
  [98789] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1883), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1957), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(1959), 16,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [98833] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2672), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1884), 2,
      sym_comment,
      sym_documentation_comment,
  [98910] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2457), 1,
      sym_string_literal,
    STATE(3139), 1,
      sym_uri,
    STATE(1885), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [98973] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2938), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1886), 2,
      sym_comment,
      sym_documentation_comment,
  [99050] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2722), 1,
      sym_normal_parameter_type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(1887), 2,
      sym_comment,
      sym_documentation_comment,
  [99127] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2933), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1888), 2,
      sym_comment,
      sym_documentation_comment,
  [99204] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2912), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1889), 2,
      sym_comment,
      sym_documentation_comment,
  [99281] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2961), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1890), 2,
      sym_comment,
      sym_documentation_comment,
  [99358] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2974), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1891), 2,
      sym_comment,
      sym_documentation_comment,
  [99435] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2844), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1892), 2,
      sym_comment,
      sym_documentation_comment,
  [99512] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2457), 1,
      sym_string_literal,
    STATE(3242), 1,
      sym_uri,
    STATE(1893), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [99575] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(4150), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2343), 1,
      sym__set,
    STATE(2463), 1,
      sym__get,
    STATE(2566), 1,
      sym__type,
    STATE(1894), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3314), 2,
      sym_setter_signature,
      sym_function_signature,
  [99650] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2856), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1895), 2,
      sym_comment,
      sym_documentation_comment,
  [99727] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1896), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4119), 8,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2548), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [99770] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2905), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1897), 2,
      sym_comment,
      sym_documentation_comment,
  [99847] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2033), 1,
      sym__metadata,
    STATE(2639), 1,
      sym__type,
    STATE(2770), 1,
      sym_typed_identifier,
    STATE(3005), 1,
      sym_normal_parameter_type,
    STATE(1898), 2,
      sym_comment,
      sym_documentation_comment,
  [99924] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2825), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1899), 2,
      sym_comment,
      sym_documentation_comment,
  [100001] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2816), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1900), 2,
      sym_comment,
      sym_documentation_comment,
  [100078] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3254), 1,
      sym_record_type_named_field,
    STATE(3495), 1,
      sym__type,
    STATE(1901), 2,
      sym_comment,
      sym_documentation_comment,
  [100155] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2735), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1902), 2,
      sym_comment,
      sym_documentation_comment,
  [100232] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2800), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1903), 2,
      sym_comment,
      sym_documentation_comment,
  [100309] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2015), 1,
      anon_sym_QMARK,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4280), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2275), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(1904), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(4276), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [100370] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1905), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4283), 8,
      anon_sym_when,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2766), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [100413] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2872), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1906), 2,
      sym_comment,
      sym_documentation_comment,
  [100490] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2804), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1907), 2,
      sym_comment,
      sym_documentation_comment,
  [100567] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(3825), 1,
      anon_sym_SEMI,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2458), 1,
      sym_string_literal,
    STATE(1908), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [100630] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(2457), 1,
      sym_string_literal,
    STATE(2537), 1,
      sym_uri,
    STATE(1909), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [100693] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2762), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1910), 2,
      sym_comment,
      sym_documentation_comment,
  [100770] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1911), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4285), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_TILDE,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(4287), 13,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      sym__additive_operator,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_TILDE_SLASH,
      anon_sym_EQ_EQ,
      anon_sym_LBRACK_RBRACK_EQ,
  [100813] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2725), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1912), 2,
      sym_comment,
      sym_documentation_comment,
  [100890] = 25,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2043), 1,
      sym__metadata,
    STATE(2718), 1,
      sym_record_type_named_field,
    STATE(3101), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1913), 2,
      sym_comment,
      sym_documentation_comment,
  [100967] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1986), 1,
      sym_final_builtin,
    STATE(2799), 1,
      sym__var_or_type,
    STATE(2943), 1,
      sym__type,
    STATE(1914), 2,
      sym_comment,
      sym_documentation_comment,
  [101041] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1976), 1,
      sym_inferred_type,
    STATE(1993), 1,
      sym_final_builtin,
    STATE(2943), 1,
      sym__type,
    STATE(2987), 1,
      sym__var_or_type,
    STATE(1915), 2,
      sym_comment,
      sym_documentation_comment,
  [101115] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4289), 1,
      sym_identifier,
    ACTIONS(4291), 1,
      anon_sym_LBRACE,
    ACTIONS(4293), 1,
      anon_sym_LBRACK,
    ACTIONS(4295), 1,
      anon_sym_LPAREN,
    STATE(1261), 1,
      sym__record_literal_no_const,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2623), 1,
      sym__type_not_void,
    STATE(3097), 1,
      sym_type_arguments,
    STATE(1916), 2,
      sym_comment,
      sym_documentation_comment,
  [101189] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4289), 1,
      sym_identifier,
    ACTIONS(4297), 1,
      anon_sym_LBRACE,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    ACTIONS(4301), 1,
      anon_sym_LPAREN,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2367), 1,
      sym__record_literal_no_const,
    STATE(2592), 1,
      sym__type_not_void,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(3141), 1,
      sym_type_arguments,
    STATE(1917), 2,
      sym_comment,
      sym_documentation_comment,
  [101263] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    ACTIONS(4305), 1,
      anon_sym_QMARK,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4309), 1,
      anon_sym_DOT,
    ACTIONS(4311), 1,
      anon_sym_QMARK_DOT,
    STATE(906), 1,
      sym_index_selector,
    STATE(922), 1,
      sym__assignable_selector,
    STATE(975), 1,
      sym__assignable_selector_part,
    STATE(1958), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(907), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1918), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [101333] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1919), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4313), 7,
      anon_sym_when,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(4315), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [101375] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    ACTIONS(4305), 1,
      anon_sym_QMARK,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4309), 1,
      anon_sym_DOT,
    ACTIONS(4311), 1,
      anon_sym_QMARK_DOT,
    STATE(906), 1,
      sym_index_selector,
    STATE(1020), 1,
      sym__assignable_selector,
    STATE(1307), 1,
      sym__assignable_selector_part,
    STATE(1941), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(907), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1920), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [101445] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4319), 1,
      anon_sym_QMARK,
    ACTIONS(4324), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2015), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(4322), 2,
      anon_sym_as,
      anon_sym_when,
    STATE(1921), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4317), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [101497] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(91), 1,
      anon_sym_r_DQUOTE,
    ACTIONS(93), 1,
      anon_sym_r_SQUOTE,
    ACTIONS(95), 1,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(97), 1,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
    STATE(474), 1,
      aux_sym_string_literal_repeat1,
    STATE(3360), 1,
      sym_string_literal,
    STATE(1922), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(627), 8,
      sym__string_literal_double_quotes,
      sym__string_literal_single_quotes,
      sym__string_literal_double_quotes_multiple,
      sym__string_literal_single_quotes_multiple,
      sym__raw_string_literal_double_quotes,
      sym__raw_string_literal_single_quotes,
      sym__raw_string_literal_double_quotes_multiple,
      sym__raw_string_literal_single_quotes_multiple,
  [101557] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4132), 1,
      anon_sym_LBRACE,
    ACTIONS(4134), 1,
      anon_sym_LBRACK,
    ACTIONS(4136), 1,
      anon_sym_LPAREN,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(979), 1,
      sym__record_literal_no_const,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2657), 1,
      sym__type_not_void,
    STATE(3163), 1,
      sym_type_arguments,
    STATE(1923), 2,
      sym_comment,
      sym_documentation_comment,
  [101631] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4289), 1,
      sym_identifier,
    ACTIONS(4327), 1,
      anon_sym_LBRACE,
    ACTIONS(4329), 1,
      anon_sym_LBRACK,
    ACTIONS(4331), 1,
      anon_sym_LPAREN,
    STATE(1089), 1,
      sym__record_literal_no_const,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2650), 1,
      sym__type_not_void,
    STATE(3079), 1,
      sym_type_arguments,
    STATE(1924), 2,
      sym_comment,
      sym_documentation_comment,
  [101705] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4333), 1,
      anon_sym_LBRACK,
    ACTIONS(4335), 1,
      anon_sym_QMARK,
    ACTIONS(4337), 1,
      anon_sym_DOT,
    ACTIONS(4339), 1,
      anon_sym_QMARK_DOT,
    STATE(1232), 1,
      sym_index_selector,
    STATE(1258), 1,
      sym__assignable_selector,
    STATE(1499), 1,
      sym__assignable_selector_part,
    STATE(1937), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(1231), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1925), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [101775] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4341), 1,
      anon_sym_LBRACK,
    ACTIONS(4343), 1,
      anon_sym_QMARK,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    ACTIONS(4347), 1,
      anon_sym_QMARK_DOT,
    STATE(1090), 1,
      sym_index_selector,
    STATE(1099), 1,
      sym__assignable_selector,
    STATE(1171), 1,
      sym__assignable_selector_part,
    STATE(1944), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(1096), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1926), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [101845] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4124), 1,
      anon_sym_LBRACE,
    ACTIONS(4126), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 1,
      anon_sym_LPAREN,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(979), 1,
      sym__record_literal_no_const,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2657), 1,
      sym__type_not_void,
    STATE(3135), 1,
      sym_type_arguments,
    STATE(1927), 2,
      sym_comment,
      sym_documentation_comment,
  [101919] = 24,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2088), 1,
      sym__metadata,
    STATE(2822), 1,
      sym__type,
    STATE(3056), 1,
      sym_record_type_field,
    STATE(1928), 2,
      sym_comment,
      sym_documentation_comment,
  [101993] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4341), 1,
      anon_sym_LBRACK,
    ACTIONS(4343), 1,
      anon_sym_QMARK,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    ACTIONS(4347), 1,
      anon_sym_QMARK_DOT,
    STATE(1090), 1,
      sym_index_selector,
    STATE(1107), 1,
      sym__assignable_selector,
    STATE(1380), 1,
      sym__assignable_selector_part,
    STATE(1942), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(1096), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1929), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [102063] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1988), 1,
      sym_final_builtin,
    STATE(1930), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2935), 2,
      sym__type,
      sym_inferred_type,
  [102132] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4349), 1,
      sym_increment_operator,
    STATE(292), 1,
      sym__assignment_operator,
    STATE(1496), 1,
      sym_postfix_operator,
    STATE(1931), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102177] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4351), 1,
      sym_increment_operator,
    STATE(210), 1,
      sym__assignment_operator,
    STATE(1094), 1,
      sym_postfix_operator,
    STATE(1932), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102222] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2015), 1,
      anon_sym_QMARK,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4280), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2288), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(1933), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4353), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [102281] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1981), 1,
      sym_final_builtin,
    STATE(1934), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2704), 2,
      sym__type,
      sym_inferred_type,
  [102350] = 23,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4289), 1,
      sym_identifier,
    ACTIONS(4355), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      anon_sym_LBRACK,
    ACTIONS(4359), 1,
      anon_sym_LPAREN,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2611), 1,
      sym__type_not_void,
    STATE(3262), 1,
      sym_type_arguments,
    STATE(1935), 2,
      sym_comment,
      sym_documentation_comment,
  [102421] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4361), 1,
      sym_increment_operator,
    STATE(308), 1,
      sym__assignment_operator,
    STATE(1317), 1,
      sym_postfix_operator,
    STATE(1936), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102466] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4333), 1,
      anon_sym_LBRACK,
    ACTIONS(4335), 1,
      anon_sym_QMARK,
    ACTIONS(4337), 1,
      anon_sym_DOT,
    ACTIONS(4339), 1,
      anon_sym_QMARK_DOT,
    STATE(1232), 1,
      sym_index_selector,
    STATE(1269), 1,
      sym__assignable_selector,
    STATE(1945), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(1231), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1937), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [102533] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4363), 1,
      sym_increment_operator,
    STATE(280), 1,
      sym__assignment_operator,
    STATE(942), 1,
      sym_postfix_operator,
    STATE(1938), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102578] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4365), 1,
      sym_increment_operator,
    STATE(299), 1,
      sym__assignment_operator,
    STATE(1378), 1,
      sym_postfix_operator,
    STATE(1939), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102623] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4361), 1,
      sym_increment_operator,
    STATE(230), 1,
      sym__assignment_operator,
    STATE(1317), 1,
      sym_postfix_operator,
    STATE(1940), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102668] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    ACTIONS(4305), 1,
      anon_sym_QMARK,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4309), 1,
      anon_sym_DOT,
    ACTIONS(4311), 1,
      anon_sym_QMARK_DOT,
    STATE(906), 1,
      sym_index_selector,
    STATE(1009), 1,
      sym__assignable_selector,
    STATE(1945), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(907), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1941), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [102735] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4341), 1,
      anon_sym_LBRACK,
    ACTIONS(4343), 1,
      anon_sym_QMARK,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    ACTIONS(4347), 1,
      anon_sym_QMARK_DOT,
    STATE(1090), 1,
      sym_index_selector,
    STATE(1140), 1,
      sym__assignable_selector,
    STATE(1945), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(1096), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1942), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [102802] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4363), 1,
      sym_increment_operator,
    STATE(285), 1,
      sym__assignment_operator,
    STATE(942), 1,
      sym_postfix_operator,
    STATE(1943), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102847] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4341), 1,
      anon_sym_LBRACK,
    ACTIONS(4343), 1,
      anon_sym_QMARK,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    ACTIONS(4347), 1,
      anon_sym_QMARK_DOT,
    STATE(1090), 1,
      sym_index_selector,
    STATE(1116), 1,
      sym__assignable_selector,
    STATE(1945), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(1096), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1944), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [102914] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4367), 1,
      anon_sym_LBRACK,
    ACTIONS(4370), 1,
      anon_sym_LPAREN,
    ACTIONS(4373), 1,
      anon_sym_QMARK,
    ACTIONS(4376), 1,
      anon_sym_LT,
    ACTIONS(4379), 1,
      anon_sym_BANG,
    ACTIONS(4382), 1,
      anon_sym_DOT,
    ACTIONS(4385), 1,
      anon_sym_QMARK_DOT,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(2409), 1,
      sym_index_selector,
    STATE(2414), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1945), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2385), 3,
      sym__exclamation_operator,
      sym_argument_part,
      sym__assignable_selector,
  [102977] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(67), 1,
      anon_sym_late,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1950), 1,
      sym__late_builtin,
    STATE(1946), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2799), 2,
      sym__type,
      sym_inferred_type,
  [103046] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1947), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4390), 3,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4388), 14,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [103087] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4365), 1,
      sym_increment_operator,
    STATE(297), 1,
      sym__assignment_operator,
    STATE(1378), 1,
      sym_postfix_operator,
    STATE(1948), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103132] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4363), 1,
      sym_increment_operator,
    STATE(287), 1,
      sym__assignment_operator,
    STATE(942), 1,
      sym_postfix_operator,
    STATE(1949), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103177] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2021), 1,
      sym_final_builtin,
    STATE(1950), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2935), 2,
      sym__type,
      sym_inferred_type,
  [103246] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4349), 1,
      sym_increment_operator,
    STATE(277), 1,
      sym__assignment_operator,
    STATE(1496), 1,
      sym_postfix_operator,
    STATE(1951), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103291] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4363), 1,
      sym_increment_operator,
    STATE(251), 1,
      sym__assignment_operator,
    STATE(942), 1,
      sym_postfix_operator,
    STATE(1952), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103336] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1953), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4394), 3,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4392), 14,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [103377] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1954), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1828), 3,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4396), 14,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [103418] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4363), 1,
      sym_increment_operator,
    STATE(270), 1,
      sym__assignment_operator,
    STATE(942), 1,
      sym_postfix_operator,
    STATE(1955), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103463] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4363), 1,
      sym_increment_operator,
    STATE(207), 1,
      sym__assignment_operator,
    STATE(942), 1,
      sym_postfix_operator,
    STATE(1956), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103508] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(35), 1,
      anon_sym_var,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(145), 1,
      anon_sym_final,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(1972), 1,
      sym_final_builtin,
    STATE(1957), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2970), 2,
      sym__type,
      sym_inferred_type,
  [103577] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    ACTIONS(4305), 1,
      anon_sym_QMARK,
    ACTIONS(4307), 1,
      anon_sym_LT,
    ACTIONS(4309), 1,
      anon_sym_DOT,
    ACTIONS(4311), 1,
      anon_sym_QMARK_DOT,
    STATE(904), 1,
      sym__assignable_selector,
    STATE(906), 1,
      sym_index_selector,
    STATE(1945), 1,
      aux_sym__assignable_selector_part_repeat1,
    STATE(2273), 1,
      sym_type_arguments,
    STATE(2338), 1,
      sym_selector,
    STATE(2401), 1,
      sym_arguments,
    STATE(907), 2,
      sym_unconditional_assignable_selector,
      sym_conditional_assignable_selector,
    STATE(1958), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2385), 2,
      sym__exclamation_operator,
      sym_argument_part,
  [103644] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1959), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1746), 3,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(4398), 14,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_external,
      sym_identifier,
  [103685] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4351), 1,
      sym_increment_operator,
    STATE(274), 1,
      sym__assignment_operator,
    STATE(1094), 1,
      sym_postfix_operator,
    STATE(1960), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1069), 14,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103730] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(446), 1,
      anon_sym_required,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2013), 1,
      sym__required,
    STATE(3024), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(1961), 2,
      sym_comment,
      sym_documentation_comment,
  [103798] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1962), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2846), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2844), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [103838] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1963), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2918), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2916), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [103878] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1964), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1412), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1410), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [103918] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1965), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1155), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1153), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [103958] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1966), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3072), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(3070), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [103998] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1967), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2910), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2908), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [104038] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1968), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2950), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(2948), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [104078] = 22,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3221), 1,
      sym__type,
    STATE(3369), 1,
      sym__get,
    STATE(3520), 1,
      sym_getter_signature,
    STATE(1969), 2,
      sym_comment,
      sym_documentation_comment,
  [104146] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1970), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1071), 4,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_async,
    ACTIONS(1065), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [104186] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4400), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2713), 1,
      sym__type,
    STATE(2916), 1,
      sym_static_final_declaration,
    STATE(3264), 1,
      sym_static_final_declaration_list,
    STATE(1971), 2,
      sym_comment,
      sym_documentation_comment,
  [104251] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4402), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2704), 1,
      sym__type,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3264), 1,
      sym_initialized_identifier_list,
    STATE(1972), 2,
      sym_comment,
      sym_documentation_comment,
  [104316] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1973), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1957), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1959), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104355] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1974), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1889), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1891), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104394] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1975), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1981), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1983), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104433] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3829), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2965), 1,
      sym__type,
    ACTIONS(4404), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(1976), 2,
      sym_comment,
      sym_documentation_comment,
  [104496] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1977), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1973), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1975), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104535] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1978), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1969), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1971), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104574] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1979), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1965), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1967), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104613] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1980), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1953), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1955), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104652] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4402), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2836), 1,
      sym__type,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3073), 1,
      sym_initialized_identifier_list,
    STATE(1981), 2,
      sym_comment,
      sym_documentation_comment,
  [104717] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1982), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1917), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1919), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [104756] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4402), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2799), 1,
      sym__type,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3314), 1,
      sym_initialized_identifier_list,
    STATE(1983), 2,
      sym_comment,
      sym_documentation_comment,
  [104821] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3956), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2987), 1,
      sym__type,
    ACTIONS(4130), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(1984), 2,
      sym_comment,
      sym_documentation_comment,
  [104884] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(2067), 1,
      sym_nullable_type,
    STATE(1985), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 3,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_implements,
    ACTIONS(4119), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2541), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [104929] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4402), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2935), 1,
      sym__type,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3520), 1,
      sym_initialized_identifier_list,
    STATE(1986), 2,
      sym_comment,
      sym_documentation_comment,
  [104994] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4400), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2908), 1,
      sym__type,
    STATE(2916), 1,
      sym_static_final_declaration,
    STATE(3520), 1,
      sym_static_final_declaration_list,
    STATE(1987), 2,
      sym_comment,
      sym_documentation_comment,
  [105059] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4402), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2962), 1,
      sym__type,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3546), 1,
      sym_initialized_identifier_list,
    STATE(1988), 2,
      sym_comment,
      sym_documentation_comment,
  [105124] = 21,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4400), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2916), 1,
      sym_static_final_declaration,
    STATE(2918), 1,
      sym__type,
    STATE(3104), 1,
      sym_static_final_declaration_list,
    STATE(1989), 2,
      sym_comment,
      sym_documentation_comment,
  [105189] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1990), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1676), 15,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_TILDE_SLASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      sym_increment_operator,
  [105226] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1991), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1921), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1923), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105265] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4406), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2898), 1,
      sym__type,
    ACTIONS(4130), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(1992), 2,
      sym_comment,
      sym_documentation_comment,
  [105328] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4410), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2789), 1,
      sym__type,
    ACTIONS(4413), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(1993), 2,
      sym_comment,
      sym_documentation_comment,
  [105391] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1994), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1961), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1963), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105430] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4415), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2965), 1,
      sym__type,
    ACTIONS(4404), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(1995), 2,
      sym_comment,
      sym_documentation_comment,
  [105493] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1996), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1925), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1927), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105532] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1997), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1985), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1987), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105571] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1998), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1929), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1931), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105610] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1999), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1945), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1947), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105649] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2015), 1,
      anon_sym_QMARK,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4280), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2275), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(4419), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2000), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [105706] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2001), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1977), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1979), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105745] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2002), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1949), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1951), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105784] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2003), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1989), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
      anon_sym_QMARK,
    ACTIONS(1991), 10,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [105823] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4422), 1,
      anon_sym_LPAREN,
    ACTIONS(4424), 1,
      anon_sym_DOT,
    STATE(1718), 1,
      sym_nullable_type,
    STATE(2117), 1,
      sym_type_arguments,
    ACTIONS(2531), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2004), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 6,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [105873] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2547), 1,
      sym__type_not_void_list,
    STATE(2554), 1,
      sym__type_not_void,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2005), 2,
      sym_comment,
      sym_documentation_comment,
  [105935] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(3057), 1,
      sym_mixin_application,
    STATE(3058), 1,
      sym__type_not_void,
    STATE(2006), 2,
      sym_comment,
      sym_documentation_comment,
  [105997] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3024), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(2007), 2,
      sym_comment,
      sym_documentation_comment,
  [106059] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4428), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(2008), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4426), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [106097] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4432), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(2009), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4430), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [106135] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4434), 1,
      anon_sym_GT,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2960), 1,
      sym__type,
    STATE(2010), 2,
      sym_comment,
      sym_documentation_comment,
  [106197] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4438), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(2011), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4436), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [106235] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4442), 1,
      anon_sym_EQ,
    STATE(2012), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4440), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106273] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3016), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(2013), 2,
      sym_comment,
      sym_documentation_comment,
  [106335] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4446), 1,
      anon_sym_EQ,
    STATE(2014), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4444), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106373] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4450), 1,
      anon_sym_EQ,
    STATE(2015), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4448), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106411] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4454), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(2016), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4452), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [106449] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4458), 1,
      anon_sym_EQ,
    STATE(2017), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4456), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106487] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4324), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2018), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4460), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106527] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4462), 1,
      anon_sym_GT,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2833), 1,
      sym__type,
    STATE(2019), 2,
      sym_comment,
      sym_documentation_comment,
  [106589] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4466), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(2020), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4464), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [106627] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4468), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3043), 1,
      sym__type,
    STATE(3546), 1,
      sym_identifier_list,
    STATE(2021), 2,
      sym_comment,
      sym_documentation_comment,
  [106689] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4472), 1,
      anon_sym_EQ,
    STATE(2022), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4470), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106727] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2554), 1,
      sym__type_not_void,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(3065), 1,
      sym__type_not_void_list,
    STATE(2023), 2,
      sym_comment,
      sym_documentation_comment,
  [106789] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4476), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(2024), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4474), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [106827] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2674), 1,
      anon_sym_EQ,
    STATE(2025), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4478), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106865] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4482), 1,
      anon_sym_EQ,
    STATE(2026), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4480), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106903] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2554), 1,
      sym__type_not_void,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2971), 1,
      sym__type_not_void_list,
    STATE(2027), 2,
      sym_comment,
      sym_documentation_comment,
  [106965] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2696), 1,
      anon_sym_EQ,
    STATE(2028), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4484), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107003] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(982), 1,
      anon_sym_EQ,
    STATE(2029), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4486), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107041] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(2156), 1,
      anon_sym_GT,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2723), 1,
      sym__type,
    STATE(2030), 2,
      sym_comment,
      sym_documentation_comment,
  [107103] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4490), 2,
      anon_sym_EQ,
      anon_sym_async,
    STATE(2031), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4488), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [107141] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4319), 1,
      anon_sym_QMARK,
    ACTIONS(4322), 1,
      anon_sym_as,
    ACTIONS(4324), 1,
      anon_sym_DOT,
    ACTIONS(4492), 1,
      anon_sym_COLON,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2015), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    STATE(2032), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4317), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_BANG,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107191] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2651), 1,
      sym__type,
    STATE(2727), 1,
      sym_typed_identifier,
    STATE(2033), 2,
      sym_comment,
      sym_documentation_comment,
  [107253] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4496), 1,
      anon_sym_EQ,
    STATE(2034), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4494), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107291] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4498), 1,
      anon_sym_GT,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2842), 1,
      sym__type,
    STATE(2035), 2,
      sym_comment,
      sym_documentation_comment,
  [107353] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2554), 1,
      sym__type_not_void,
    STATE(2564), 1,
      sym__type_not_void_list,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2036), 2,
      sym_comment,
      sym_documentation_comment,
  [107415] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4438), 1,
      anon_sym_async,
    STATE(2037), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2606), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
    ACTIONS(4436), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    ACTIONS(2608), 6,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [107457] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2015), 1,
      anon_sym_QMARK,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4280), 1,
      anon_sym_LT,
    ACTIONS(4500), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2276), 1,
      sym__formal_parameter_part,
    STATE(2296), 1,
      sym_formal_parameter_list,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2038), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 5,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      sym_identifier,
  [107511] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4322), 1,
      anon_sym_as,
    ACTIONS(4324), 1,
      anon_sym_DOT,
    ACTIONS(4492), 1,
      anon_sym_COLON,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2015), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    STATE(2039), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4317), 3,
      anon_sym_BANG,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(4319), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
  [107561] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2554), 1,
      sym__type_not_void,
    STATE(2582), 1,
      sym__type_not_void_list,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2040), 2,
      sym_comment,
      sym_documentation_comment,
  [107623] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1502), 1,
      anon_sym_COLON,
    ACTIONS(4319), 1,
      anon_sym_QMARK,
    ACTIONS(4324), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2015), 2,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(4322), 2,
      anon_sym_as,
      anon_sym_when,
    STATE(2041), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4317), 4,
      anon_sym_BANG,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107673] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4502), 1,
      anon_sym_GT,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2732), 1,
      sym__type,
    STATE(2042), 2,
      sym_comment,
      sym_documentation_comment,
  [107735] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3069), 1,
      sym_typed_identifier,
    STATE(3495), 1,
      sym__type,
    STATE(2043), 2,
      sym_comment,
      sym_documentation_comment,
  [107797] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4504), 1,
      anon_sym_GT,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2685), 1,
      sym__type,
    STATE(2044), 2,
      sym_comment,
      sym_documentation_comment,
  [107859] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4508), 1,
      anon_sym_EQ,
    STATE(2045), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4506), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107897] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2659), 1,
      anon_sym_EQ,
    STATE(2046), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4510), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107935] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4514), 1,
      anon_sym_EQ,
    STATE(2047), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4512), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107973] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4516), 1,
      anon_sym_GT,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2702), 1,
      sym__type,
    STATE(2048), 2,
      sym_comment,
      sym_documentation_comment,
  [108035] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4520), 1,
      anon_sym_EQ,
    STATE(2049), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4518), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [108073] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4524), 1,
      anon_sym_EQ,
    STATE(2050), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4522), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [108111] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(3058), 1,
      sym__type_not_void,
    STATE(3199), 1,
      sym_mixin_application,
    STATE(2051), 2,
      sym_comment,
      sym_documentation_comment,
  [108173] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4528), 1,
      anon_sym_EQ,
    STATE(2052), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4526), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [108211] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    ACTIONS(4530), 1,
      anon_sym_GT,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2692), 1,
      sym__type,
    STATE(2053), 2,
      sym_comment,
      sym_documentation_comment,
  [108273] = 20,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2554), 1,
      sym__type_not_void,
    STATE(2574), 1,
      sym__type_not_void_list,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2054), 2,
      sym_comment,
      sym_documentation_comment,
  [108335] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4534), 1,
      anon_sym_EQ,
    STATE(2055), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4532), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [108373] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4538), 1,
      anon_sym_EQ,
    STATE(2056), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4536), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [108411] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3251), 1,
      sym__type,
    STATE(2057), 2,
      sym_comment,
      sym_documentation_comment,
  [108470] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4540), 1,
      sym_identifier,
    ACTIONS(4542), 1,
      anon_sym_LPAREN,
    ACTIONS(4544), 1,
      anon_sym_Function,
    STATE(1426), 1,
      sym__function_builtin_identifier,
    STATE(1455), 1,
      aux_sym__function_type_tails,
    STATE(1511), 1,
      sym__type_name,
    STATE(1590), 1,
      sym_record_type,
    STATE(1615), 1,
      sym__function_type_tail,
    STATE(1627), 1,
      sym__type_not_void_not_function,
    STATE(1648), 1,
      sym_function_type,
    STATE(1677), 1,
      sym__type_not_void,
    STATE(2614), 1,
      sym__type_not_function,
    STATE(2058), 2,
      sym_comment,
      sym_documentation_comment,
  [108529] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(3263), 1,
      sym__type_not_void,
    STATE(2059), 2,
      sym_comment,
      sym_documentation_comment,
  [108588] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2015), 1,
      anon_sym_QMARK,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4280), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2680), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2060), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [108641] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2643), 1,
      sym__type_not_void,
    STATE(2061), 2,
      sym_comment,
      sym_documentation_comment,
  [108700] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(3198), 1,
      sym__type_not_void,
    STATE(2062), 2,
      sym_comment,
      sym_documentation_comment,
  [108759] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2015), 1,
      anon_sym_QMARK,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4280), 1,
      anon_sym_LT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2276), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2063), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [108812] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4546), 1,
      sym_identifier,
    ACTIONS(4548), 1,
      anon_sym_LPAREN,
    ACTIONS(4550), 1,
      anon_sym_Function,
    STATE(843), 1,
      sym__function_builtin_identifier,
    STATE(867), 1,
      aux_sym__function_type_tails,
    STATE(978), 1,
      sym__type_name,
    STATE(1015), 1,
      sym_record_type,
    STATE(1035), 1,
      sym__type_not_void_not_function,
    STATE(1039), 1,
      sym_function_type,
    STATE(1071), 1,
      sym__function_type_tail,
    STATE(1184), 1,
      sym__type_not_void,
    STATE(2664), 1,
      sym__type_not_function,
    STATE(2064), 2,
      sym_comment,
      sym_documentation_comment,
  [108871] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3415), 1,
      sym__type,
    STATE(2065), 2,
      sym_comment,
      sym_documentation_comment,
  [108930] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4546), 1,
      sym_identifier,
    ACTIONS(4548), 1,
      anon_sym_LPAREN,
    ACTIONS(4550), 1,
      anon_sym_Function,
    STATE(843), 1,
      sym__function_builtin_identifier,
    STATE(867), 1,
      aux_sym__function_type_tails,
    STATE(978), 1,
      sym__type_name,
    STATE(1015), 1,
      sym_record_type,
    STATE(1035), 1,
      sym__type_not_void_not_function,
    STATE(1039), 1,
      sym_function_type,
    STATE(1071), 1,
      sym__function_type_tail,
    STATE(1189), 1,
      sym__type_not_void,
    STATE(2664), 1,
      sym__type_not_function,
    STATE(2066), 2,
      sym_comment,
      sym_documentation_comment,
  [108989] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2067), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2764), 3,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_implements,
    ACTIONS(4283), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2762), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [109028] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(3252), 1,
      sym__type_not_void,
    STATE(2068), 2,
      sym_comment,
      sym_documentation_comment,
  [109087] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3259), 1,
      sym__type,
    STATE(2069), 2,
      sym_comment,
      sym_documentation_comment,
  [109146] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2593), 1,
      sym__type_not_void,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2070), 2,
      sym_comment,
      sym_documentation_comment,
  [109205] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3192), 1,
      sym__type,
    STATE(2071), 2,
      sym_comment,
      sym_documentation_comment,
  [109264] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3095), 1,
      sym__type,
    STATE(2072), 2,
      sym_comment,
      sym_documentation_comment,
  [109323] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2111), 1,
      sym__type_name,
    STATE(3224), 1,
      sym__type,
    STATE(2073), 2,
      sym_comment,
      sym_documentation_comment,
  [109382] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2613), 1,
      sym__type_not_void,
    STATE(2074), 2,
      sym_comment,
      sym_documentation_comment,
  [109441] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3018), 1,
      sym__type,
    STATE(2075), 2,
      sym_comment,
      sym_documentation_comment,
  [109500] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3151), 1,
      sym__type,
    STATE(2076), 2,
      sym_comment,
      sym_documentation_comment,
  [109559] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4540), 1,
      sym_identifier,
    ACTIONS(4542), 1,
      anon_sym_LPAREN,
    ACTIONS(4544), 1,
      anon_sym_Function,
    STATE(1426), 1,
      sym__function_builtin_identifier,
    STATE(1455), 1,
      aux_sym__function_type_tails,
    STATE(1511), 1,
      sym__type_name,
    STATE(1590), 1,
      sym_record_type,
    STATE(1615), 1,
      sym__function_type_tail,
    STATE(1627), 1,
      sym__type_not_void_not_function,
    STATE(1648), 1,
      sym_function_type,
    STATE(1708), 1,
      sym__type_not_void,
    STATE(2614), 1,
      sym__type_not_function,
    STATE(2077), 2,
      sym_comment,
      sym_documentation_comment,
  [109618] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2078), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4460), 13,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [109653] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2669), 1,
      sym__type_not_void,
    STATE(2079), 2,
      sym_comment,
      sym_documentation_comment,
  [109712] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3399), 1,
      sym__type,
    STATE(2080), 2,
      sym_comment,
      sym_documentation_comment,
  [109771] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3502), 1,
      sym__type,
    STATE(2081), 2,
      sym_comment,
      sym_documentation_comment,
  [109830] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2118), 1,
      sym__type_name,
    STATE(3072), 1,
      sym__type,
    STATE(2082), 2,
      sym_comment,
      sym_documentation_comment,
  [109889] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(2652), 1,
      sym__type_not_void,
    STATE(2083), 2,
      sym_comment,
      sym_documentation_comment,
  [109948] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3020), 1,
      sym__type,
    STATE(2084), 2,
      sym_comment,
      sym_documentation_comment,
  [110007] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3023), 1,
      sym__type,
    STATE(2085), 2,
      sym_comment,
      sym_documentation_comment,
  [110066] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4552), 1,
      sym_identifier,
    ACTIONS(4554), 1,
      anon_sym_LPAREN,
    ACTIONS(4556), 1,
      anon_sym_Function,
    STATE(1331), 1,
      sym__function_builtin_identifier,
    STATE(1366), 1,
      aux_sym__function_type_tails,
    STATE(1443), 1,
      sym__type_name,
    STATE(1476), 1,
      sym_record_type,
    STATE(1524), 1,
      sym_function_type,
    STATE(1533), 1,
      sym__type_not_void_not_function,
    STATE(1551), 1,
      sym__function_type_tail,
    STATE(1595), 1,
      sym__type_not_void,
    STATE(2649), 1,
      sym__type_not_function,
    STATE(2086), 2,
      sym_comment,
      sym_documentation_comment,
  [110125] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4552), 1,
      sym_identifier,
    ACTIONS(4554), 1,
      anon_sym_LPAREN,
    ACTIONS(4556), 1,
      anon_sym_Function,
    STATE(1331), 1,
      sym__function_builtin_identifier,
    STATE(1366), 1,
      aux_sym__function_type_tails,
    STATE(1443), 1,
      sym__type_name,
    STATE(1476), 1,
      sym_record_type,
    STATE(1524), 1,
      sym_function_type,
    STATE(1533), 1,
      sym__type_not_void_not_function,
    STATE(1551), 1,
      sym__function_type_tail,
    STATE(1594), 1,
      sym__type_not_void,
    STATE(2649), 1,
      sym__type_not_function,
    STATE(2087), 2,
      sym_comment,
      sym_documentation_comment,
  [110184] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2910), 1,
      sym__type,
    STATE(2088), 2,
      sym_comment,
      sym_documentation_comment,
  [110243] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4558), 1,
      sym_identifier,
    ACTIONS(4560), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_Function,
    STATE(752), 1,
      sym__function_builtin_identifier,
    STATE(758), 1,
      aux_sym__function_type_tails,
    STATE(805), 1,
      sym__type_name,
    STATE(816), 1,
      sym_record_type,
    STATE(857), 1,
      sym__type_not_void_not_function,
    STATE(868), 1,
      sym__function_type_tail,
    STATE(880), 1,
      sym_function_type,
    STATE(912), 1,
      sym__type_not_void,
    STATE(2638), 1,
      sym__type_not_function,
    STATE(2089), 2,
      sym_comment,
      sym_documentation_comment,
  [110302] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4558), 1,
      sym_identifier,
    ACTIONS(4560), 1,
      anon_sym_LPAREN,
    ACTIONS(4562), 1,
      anon_sym_Function,
    STATE(752), 1,
      sym__function_builtin_identifier,
    STATE(758), 1,
      aux_sym__function_type_tails,
    STATE(805), 1,
      sym__type_name,
    STATE(816), 1,
      sym_record_type,
    STATE(857), 1,
      sym__type_not_void_not_function,
    STATE(868), 1,
      sym__function_type_tail,
    STATE(880), 1,
      sym_function_type,
    STATE(913), 1,
      sym__type_not_void,
    STATE(2638), 1,
      sym__type_not_function,
    STATE(2090), 2,
      sym_comment,
      sym_documentation_comment,
  [110361] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2607), 1,
      sym__type_not_void,
    STATE(2091), 2,
      sym_comment,
      sym_documentation_comment,
  [110420] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3067), 1,
      sym__type,
    STATE(2092), 2,
      sym_comment,
      sym_documentation_comment,
  [110479] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(3408), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(2217), 1,
      sym__type,
    STATE(2093), 2,
      sym_comment,
      sym_documentation_comment,
  [110538] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2145), 1,
      sym_function_type,
    STATE(2633), 1,
      sym__type_not_function,
    STATE(3154), 1,
      sym__type_not_void,
    STATE(2094), 2,
      sym_comment,
      sym_documentation_comment,
  [110597] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(914), 1,
      sym_cascade_section,
    STATE(2101), 1,
      aux_sym__expression_repeat1,
    ACTIONS(2076), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(2095), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2557), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [110638] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4564), 1,
      sym_identifier,
    ACTIONS(4566), 1,
      anon_sym_LPAREN,
    ACTIONS(4568), 1,
      anon_sym_Function,
    STATE(1284), 1,
      sym__function_builtin_identifier,
    STATE(1306), 1,
      aux_sym__function_type_tails,
    STATE(1325), 1,
      sym__type_name,
    STATE(1358), 1,
      sym_record_type,
    STATE(1445), 1,
      sym__type_not_void_not_function,
    STATE(1448), 1,
      sym_function_type,
    STATE(1449), 1,
      sym__function_type_tail,
    STATE(1501), 1,
      sym__type_not_void,
    STATE(2608), 1,
      sym__type_not_function,
    STATE(2096), 2,
      sym_comment,
      sym_documentation_comment,
  [110697] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(4564), 1,
      sym_identifier,
    ACTIONS(4566), 1,
      anon_sym_LPAREN,
    ACTIONS(4568), 1,
      anon_sym_Function,
    STATE(1284), 1,
      sym__function_builtin_identifier,
    STATE(1306), 1,
      aux_sym__function_type_tails,
    STATE(1325), 1,
      sym__type_name,
    STATE(1358), 1,
      sym_record_type,
    STATE(1445), 1,
      sym__type_not_void_not_function,
    STATE(1448), 1,
      sym_function_type,
    STATE(1449), 1,
      sym__function_type_tail,
    STATE(1502), 1,
      sym__type_not_void,
    STATE(2608), 1,
      sym__type_not_function,
    STATE(2097), 2,
      sym_comment,
      sym_documentation_comment,
  [110756] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4289), 1,
      sym_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1985), 1,
      sym_record_type,
    STATE(2099), 1,
      sym__type_not_void_not_function,
    STATE(2144), 1,
      sym__function_builtin_identifier,
    STATE(2145), 1,
      sym_function_type,
    STATE(2161), 1,
      aux_sym__function_type_tails,
    STATE(2595), 1,
      sym__type_not_void,
    STATE(2596), 1,
      sym__type_not_function,
    STATE(2098), 2,
      sym_comment,
      sym_documentation_comment,
  [110815] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2099), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2546), 3,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_implements,
    ACTIONS(4119), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2541), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
  [110854] = 19,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(33), 1,
      sym_void_type,
    ACTIONS(45), 1,
      anon_sym_Function,
    ACTIONS(4570), 1,
      sym_identifier,
    STATE(1463), 1,
      sym__function_builtin_identifier,
    STATE(1530), 1,
      sym__type_name,
    STATE(1605), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(1796), 1,
      sym__type_not_function,
    STATE(1805), 1,
      sym_record_type,
    STATE(1848), 1,
      sym_function_type,
    STATE(1896), 1,
      sym__type_not_void_not_function,
    STATE(3421), 1,
      sym__type,
    STATE(2100), 2,
      sym_comment,
      sym_documentation_comment,
  [110913] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(914), 1,
      sym_cascade_section,
    ACTIONS(4573), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(2101), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__expression_repeat1,
    ACTIONS(2585), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_case,
      anon_sym_else,
  [110952] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2102), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4576), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [110986] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1763), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2148), 1,
      sym_type_parameters,
    STATE(2578), 1,
      sym_superclass,
    STATE(3074), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2103), 2,
      sym_comment,
      sym_documentation_comment,
  [111042] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2104), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3082), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111076] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2105), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4588), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111110] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2106), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2818), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111144] = 18,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4580), 1,
      anon_sym_EQ,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1784), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2171), 1,
      sym_type_parameters,
    STATE(2544), 1,
      sym_superclass,
    STATE(3245), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2107), 2,
      sym_comment,
      sym_documentation_comment,
  [111200] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2108), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4590), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111234] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2109), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1879), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111268] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2110), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4592), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111302] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(111), 1,
      anon_sym_LT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4594), 1,
      anon_sym_EQ,
    STATE(1664), 1,
      sym_type_arguments,
    STATE(1718), 1,
      sym_nullable_type,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2604), 1,
      sym_type_parameters,
    STATE(3502), 1,
      sym__formal_parameter_part,
    ACTIONS(2539), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(2111), 2,
      sym_comment,
      sym_documentation_comment,
  [111356] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2524), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2112), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4596), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [111402] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4600), 2,
      anon_sym_LPAREN,
      anon_sym_AT,
    STATE(2113), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4598), 10,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_covariant,
      anon_sym_Function,
      sym_const_builtin,
      anon_sym_late,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [111438] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2114), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2988), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111472] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2115), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4602), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111506] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2525), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2116), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4604), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [111552] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4608), 1,
      anon_sym_DOT,
    STATE(1721), 1,
      sym_nullable_type,
    ACTIONS(2550), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2117), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2555), 6,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [111596] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(111), 1,
      anon_sym_LT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4610), 1,
      anon_sym_EQ,
    STATE(1664), 1,
      sym_type_arguments,
    STATE(1718), 1,
      sym_nullable_type,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2602), 1,
      sym_type_parameters,
    STATE(3505), 1,
      sym__formal_parameter_part,
    ACTIONS(2539), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(2118), 2,
      sym_comment,
      sym_documentation_comment,
  [111650] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2119), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4612), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111684] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2120), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2814), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111718] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2121), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1819), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111752] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2122), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2960), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111786] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2123), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4614), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111820] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2124), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4317), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111854] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2125), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3058), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111888] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4422), 1,
      anon_sym_LPAREN,
    ACTIONS(4616), 1,
      anon_sym_DOT,
    STATE(1718), 1,
      sym_nullable_type,
    STATE(2117), 1,
      sym_type_arguments,
    ACTIONS(2531), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2126), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2539), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [111936] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2127), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4618), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [111970] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2128), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3054), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112004] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4622), 1,
      anon_sym_QMARK,
    ACTIONS(4624), 1,
      anon_sym_BANG,
    ACTIONS(4626), 1,
      anon_sym_as,
    STATE(2129), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4620), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112044] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2130), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4628), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112078] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2447), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2131), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4630), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [112124] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2454), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2132), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4632), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [112170] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2133), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3050), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112204] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2134), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3046), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112238] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1962), 1,
      sym_cascade_section,
    STATE(2140), 1,
      aux_sym__expression_repeat1,
    ACTIONS(2344), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(2135), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2559), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    ACTIONS(2557), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
  [112279] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4636), 1,
      anon_sym_AMP_AMP,
    STATE(437), 1,
      sym_logical_and_operator,
    STATE(2143), 1,
      aux_sym__logical_and_pattern_repeat1,
    STATE(2136), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4634), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_PIPE_PIPE,
  [112318] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4640), 1,
      anon_sym_async,
    STATE(1962), 1,
      sym_cascade_section,
    STATE(2142), 1,
      aux_sym__expression_repeat1,
    ACTIONS(2210), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(2137), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4638), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [112359] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4644), 1,
      anon_sym_async,
    STATE(1962), 1,
      sym_cascade_section,
    STATE(2142), 1,
      aux_sym__expression_repeat1,
    ACTIONS(2210), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(2138), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4642), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [112400] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1763), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2224), 1,
      sym_type_parameters,
    STATE(2578), 1,
      sym_superclass,
    STATE(3074), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2139), 2,
      sym_comment,
      sym_documentation_comment,
  [112453] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(1962), 1,
      sym_cascade_section,
    ACTIONS(4646), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(2587), 3,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
    STATE(2140), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__expression_repeat1,
    ACTIONS(2585), 4,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
  [112492] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2449), 1,
      anon_sym_DOT,
    ACTIONS(3508), 1,
      anon_sym_QMARK,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4649), 1,
      anon_sym_LPAREN,
    STATE(1667), 1,
      sym_parameter_type_list,
    STATE(2219), 1,
      sym_nullable_type,
    STATE(2262), 1,
      sym_type_parameters,
    STATE(2141), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2460), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [112539] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2587), 1,
      anon_sym_async,
    STATE(1962), 1,
      sym_cascade_section,
    ACTIONS(4652), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    STATE(2142), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__expression_repeat1,
    ACTIONS(2585), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [112578] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4657), 1,
      anon_sym_AMP_AMP,
    STATE(437), 1,
      sym_logical_and_operator,
    STATE(2143), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__logical_and_pattern_repeat1,
    ACTIONS(4655), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_PIPE_PIPE,
  [112615] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2380), 1,
      anon_sym_DOT,
    ACTIONS(3508), 1,
      anon_sym_QMARK,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4660), 1,
      anon_sym_LPAREN,
    STATE(1667), 1,
      sym_parameter_type_list,
    STATE(2259), 1,
      sym_nullable_type,
    STATE(2262), 1,
      sym_type_parameters,
    STATE(2144), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2395), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [112662] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(2204), 1,
      sym_nullable_type,
    STATE(2145), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2541), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_implements,
  [112699] = 17,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1784), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2234), 1,
      sym_type_parameters,
    STATE(2544), 1,
      sym_superclass,
    STATE(3245), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2146), 2,
      sym_comment,
      sym_documentation_comment,
  [112752] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4636), 1,
      anon_sym_AMP_AMP,
    STATE(437), 1,
      sym_logical_and_operator,
    STATE(2136), 1,
      aux_sym__logical_and_pattern_repeat1,
    STATE(2147), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4664), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_PIPE_PIPE,
  [112791] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4666), 1,
      anon_sym_EQ,
    STATE(1766), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2572), 1,
      sym_superclass,
    STATE(3187), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2148), 2,
      sym_comment,
      sym_documentation_comment,
  [112841] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4670), 1,
      anon_sym_LPAREN,
    STATE(2149), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4668), 9,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_const_builtin,
      anon_sym_late,
      sym_identifier,
  [112875] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4676), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    STATE(2176), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2150), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [112919] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4682), 1,
      anon_sym_DQUOTE,
    ACTIONS(4688), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4690), 1,
      anon_sym_DOLLAR,
    ACTIONS(4693), 1,
      sym__unused_escape_sequence,
    ACTIONS(4685), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2151), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [112961] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4698), 1,
      anon_sym_PIPE_PIPE,
    STATE(436), 1,
      sym_logical_or_operator,
    STATE(2163), 1,
      aux_sym__logical_or_pattern_repeat1,
    STATE(2152), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4696), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [112999] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4704), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    STATE(2179), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2153), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113043] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4710), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2172), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2154), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113087] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4714), 1,
      anon_sym_PIPE_PIPE,
    STATE(436), 1,
      sym_logical_or_operator,
    STATE(2155), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__logical_or_pattern_repeat1,
    ACTIONS(4712), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [113123] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4422), 1,
      anon_sym_LPAREN,
    ACTIONS(4717), 1,
      anon_sym_DOT,
    STATE(1718), 1,
      sym_nullable_type,
    STATE(2431), 1,
      sym_type_arguments,
    ACTIONS(2531), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2539), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(2156), 2,
      sym_comment,
      sym_documentation_comment,
  [113169] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4719), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2150), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2157), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113213] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4721), 1,
      anon_sym_EQ,
    STATE(2158), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4576), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [113247] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4725), 1,
      anon_sym_LPAREN,
    STATE(2159), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4723), 9,
      sym_void_type,
      anon_sym_factory,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      anon_sym_static,
      sym_const_builtin,
      sym_identifier,
  [113281] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4727), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2180), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2160), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113325] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(45), 1,
      anon_sym_Function,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(2141), 1,
      sym__function_builtin_identifier,
    STATE(2175), 1,
      aux_sym__function_type_tails,
    STATE(2161), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2413), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOT,
    ACTIONS(2415), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [113367] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4729), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2173), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2162), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113411] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4698), 1,
      anon_sym_PIPE_PIPE,
    STATE(436), 1,
      sym_logical_or_operator,
    STATE(2155), 1,
      aux_sym__logical_or_pattern_repeat1,
    STATE(2163), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4731), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [113449] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4736), 1,
      anon_sym_QMARK,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2647), 1,
      sym_nullable_type,
    STATE(3131), 1,
      sym_type_bound,
    ACTIONS(2015), 2,
      anon_sym_LT,
      anon_sym_Function,
    ACTIONS(4733), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2164), 2,
      sym_comment,
      sym_documentation_comment,
  [113495] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4741), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2151), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2165), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113539] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4743), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2165), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2166), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113583] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4324), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2167), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1320), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    ACTIONS(2015), 4,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_SEMI,
  [113621] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(890), 1,
      anon_sym_default,
    ACTIONS(892), 1,
      anon_sym_case,
    ACTIONS(4745), 1,
      sym_identifier,
    ACTIONS(4747), 1,
      anon_sym_RBRACE,
    STATE(409), 1,
      sym_case_builtin,
    STATE(2193), 1,
      aux_sym_switch_block_repeat1,
    STATE(2476), 1,
      aux_sym_switch_statement_case_repeat1,
    STATE(2665), 1,
      sym_switch_statement_case,
    STATE(2691), 1,
      sym_label,
    STATE(3463), 1,
      sym_switch_statement_default,
    STATE(2168), 2,
      sym_comment,
      sym_documentation_comment,
  [113671] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2169), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2962), 4,
      anon_sym_QMARK,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2960), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [113705] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4749), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2182), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2170), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113749] = 16,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4666), 1,
      anon_sym_EQ,
    STATE(1738), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2586), 1,
      sym_superclass,
    STATE(3062), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2171), 2,
      sym_comment,
      sym_documentation_comment,
  [113799] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4751), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2151), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2172), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113843] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4753), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2176), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2173), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [113887] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(45), 1,
      anon_sym_Function,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(2141), 1,
      sym__function_builtin_identifier,
    STATE(2175), 1,
      aux_sym__function_type_tails,
    STATE(2174), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2435), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOT,
    ACTIONS(2437), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [113929] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3630), 1,
      anon_sym_Function,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(2141), 1,
      sym__function_builtin_identifier,
    ACTIONS(2442), 3,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_DOT,
    ACTIONS(2444), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
    STATE(2175), 3,
      aux_sym__function_type_tails,
      sym_comment,
      sym_documentation_comment,
  [113969] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4758), 1,
      anon_sym_SQUOTE,
    ACTIONS(4761), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(4763), 1,
      anon_sym_DOLLAR,
    ACTIONS(4766), 1,
      sym__unused_escape_sequence,
    ACTIONS(4755), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2176), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114011] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4769), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2151), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2177), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114055] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4771), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2177), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2178), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114099] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4773), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2151), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2179), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114143] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4700), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DOLLAR,
    ACTIONS(4708), 1,
      sym__unused_escape_sequence,
    ACTIONS(4775), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2151), 1,
      aux_sym__string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4702), 2,
      sym__template_chars_double,
      anon_sym_SQUOTE,
    STATE(2180), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2495), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114187] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4777), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2185), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2181), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114231] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4779), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2176), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2182), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114275] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4781), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2184), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2183), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114319] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4783), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2176), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2184), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114363] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4674), 1,
      anon_sym_SQUOTE,
    ACTIONS(4678), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__unused_escape_sequence,
    ACTIONS(4785), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2176), 1,
      aux_sym__string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4672), 2,
      sym__template_chars_single,
      anon_sym_DQUOTE,
    STATE(2185), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2449), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114407] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2186), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4655), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [114438] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4789), 1,
      anon_sym_COLON,
    ACTIONS(4791), 1,
      anon_sym_SEMI,
    ACTIONS(4793), 1,
      anon_sym_async,
    STATE(2521), 1,
      sym_initializers,
    STATE(3314), 1,
      sym_redirection,
    STATE(2187), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4787), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [114479] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(149), 1,
      sym_assert_builtin,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(4795), 1,
      sym_identifier,
    STATE(2430), 1,
      sym_initializer_list_entry,
    STATE(2941), 1,
      sym_super,
    STATE(3319), 1,
      sym_this,
    STATE(2188), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2354), 2,
      sym_assertion,
      sym_field_initializer,
  [114524] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4797), 1,
      anon_sym_COMMA,
    ACTIONS(4799), 1,
      anon_sym_SEMI,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2714), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2015), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2189), 2,
      sym_comment,
      sym_documentation_comment,
  [114567] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2190), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4803), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(4801), 5,
      sym_void_type,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [114600] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4805), 1,
      anon_sym_DQUOTE,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    STATE(2206), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2191), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114641] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4815), 1,
      anon_sym_SQUOTE,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    STATE(2203), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2192), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114682] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4821), 1,
      sym_identifier,
    ACTIONS(4824), 1,
      anon_sym_RBRACE,
    ACTIONS(4826), 1,
      anon_sym_default,
    ACTIONS(4828), 1,
      anon_sym_case,
    STATE(409), 1,
      sym_case_builtin,
    STATE(2559), 1,
      aux_sym_switch_statement_case_repeat1,
    STATE(2665), 1,
      sym_switch_statement_case,
    STATE(2691), 1,
      sym_label,
    STATE(2193), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_switch_block_repeat1,
  [114727] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(149), 1,
      sym_assert_builtin,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(4831), 1,
      sym_identifier,
    STATE(2726), 1,
      sym_initializer_list_entry,
    STATE(2920), 1,
      sym_super,
    STATE(2994), 1,
      sym_this,
    STATE(2194), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2354), 2,
      sym_assertion,
      sym_field_initializer,
  [114772] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(4835), 1,
      anon_sym_EQ_GT,
    ACTIONS(4837), 1,
      anon_sym_async,
    STATE(446), 1,
      sym_block,
    ACTIONS(4839), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(1772), 2,
      sym_function_body,
      sym__semicolon,
    STATE(2195), 2,
      sym_comment,
      sym_documentation_comment,
  [114815] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(4841), 1,
      anon_sym_DQUOTE,
    STATE(2218), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2196), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114856] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2197), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4843), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [114887] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(4845), 1,
      anon_sym_SQUOTE,
    STATE(2220), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2198), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [114928] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2199), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4847), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [114959] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4851), 1,
      anon_sym_DOT,
    STATE(992), 1,
      sym_arguments,
    STATE(2742), 1,
      sym_argument_part,
    STATE(2743), 1,
      sym_type_arguments,
    STATE(2200), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4849), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115002] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4856), 1,
      anon_sym_SQUOTE,
    ACTIONS(4859), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(4861), 1,
      anon_sym_DOLLAR,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2201), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    ACTIONS(4853), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [115041] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4864), 1,
      anon_sym_DQUOTE,
    ACTIONS(4870), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4872), 1,
      anon_sym_DOLLAR,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2202), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    ACTIONS(4867), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [115080] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4878), 1,
      anon_sym_SQUOTE,
    ACTIONS(4880), 1,
      anon_sym_DOLLAR,
    ACTIONS(4883), 1,
      sym__unused_escape_sequence,
    ACTIONS(4875), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2203), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__string_literal_single_quotes_repeat1,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [115119] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2204), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2762), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_catch,
      anon_sym_with,
      anon_sym_implements,
  [115150] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(4888), 1,
      anon_sym_DOT,
    STATE(992), 1,
      sym_arguments,
    STATE(3003), 1,
      sym_argument_part,
    STATE(3006), 1,
      sym_type_arguments,
    STATE(2205), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4886), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115193] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4890), 1,
      anon_sym_DQUOTE,
    ACTIONS(4895), 1,
      anon_sym_DOLLAR,
    ACTIONS(4898), 1,
      sym__unused_escape_sequence,
    ACTIONS(4892), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2206), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__string_literal_double_quotes_repeat1,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [115232] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(4835), 1,
      anon_sym_EQ_GT,
    ACTIONS(4837), 1,
      anon_sym_async,
    STATE(446), 1,
      sym_block,
    ACTIONS(4839), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(1753), 2,
      sym_function_body,
      sym__semicolon,
    STATE(2207), 2,
      sym_comment,
      sym_documentation_comment,
  [115275] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4905), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    STATE(2201), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2208), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [115316] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4913), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    STATE(2202), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2209), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [115357] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(4917), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2210), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [115398] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4919), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2236), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2211), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [115439] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(4921), 1,
      anon_sym_DQUOTE,
    STATE(2206), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2212), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [115480] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(4923), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2208), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2213), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [115521] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4925), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2209), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2214), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [115562] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(4927), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2238), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2215), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [115603] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2479), 1,
      anon_sym_DOT,
    ACTIONS(3623), 1,
      anon_sym_QMARK,
    ACTIONS(4929), 1,
      anon_sym_LPAREN,
    STATE(1639), 1,
      sym_parameter_type_list,
    STATE(1680), 1,
      sym_nullable_type,
    STATE(2216), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2487), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [115644] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2217), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4932), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [115675] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(4934), 1,
      anon_sym_DQUOTE,
    STATE(2206), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2218), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [115716] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2507), 1,
      anon_sym_DOT,
    ACTIONS(3616), 1,
      anon_sym_QMARK,
    ACTIONS(4936), 1,
      anon_sym_LPAREN,
    STATE(1616), 1,
      sym_parameter_type_list,
    STATE(1684), 1,
      sym_nullable_type,
    STATE(2219), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [115757] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(4939), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2220), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [115798] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(149), 1,
      sym_assert_builtin,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(4831), 1,
      sym_identifier,
    STATE(2430), 1,
      sym_initializer_list_entry,
    STATE(2920), 1,
      sym_super,
    STATE(3458), 1,
      sym_this,
    STATE(2221), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2354), 2,
      sym_assertion,
      sym_field_initializer,
  [115843] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4941), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2202), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2222), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [115884] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(4943), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2201), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2223), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [115925] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1766), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2572), 1,
      sym_superclass,
    STATE(3187), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2224), 2,
      sym_comment,
      sym_documentation_comment,
  [115972] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(4947), 1,
      anon_sym_EQ,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2015), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(2225), 2,
      sym_comment,
      sym_documentation_comment,
  [116013] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(4949), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2226), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116054] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(4951), 1,
      anon_sym_DQUOTE,
    STATE(2212), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2227), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116095] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4955), 1,
      anon_sym_class,
    ACTIONS(4957), 1,
      anon_sym_interface,
    ACTIONS(4959), 1,
      anon_sym_base,
    ACTIONS(4961), 1,
      anon_sym_mixin,
    STATE(2957), 1,
      sym_base,
    STATE(3515), 1,
      sym_mixin,
    STATE(3525), 1,
      sym_interface,
    ACTIONS(4953), 2,
      anon_sym_final,
      anon_sym_inline,
    STATE(2228), 2,
      sym_comment,
      sym_documentation_comment,
  [116140] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4963), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2202), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2229), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [116181] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2230), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4965), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [116212] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2231), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4620), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [116243] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(4967), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2232), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116284] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(4969), 1,
      anon_sym_DQUOTE,
    STATE(2206), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2233), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116325] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4582), 1,
      anon_sym_extends,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1738), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2586), 1,
      sym_superclass,
    STATE(3062), 1,
      sym_interfaces,
    STATE(3248), 1,
      sym_mixins,
    STATE(2234), 2,
      sym_comment,
      sym_documentation_comment,
  [116372] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1757), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2410), 1,
      sym_type_parameters,
    STATE(2587), 1,
      sym_mixins,
    STATE(3092), 1,
      sym_interfaces,
    STATE(2235), 2,
      sym_comment,
      sym_documentation_comment,
  [116419] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4973), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2202), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2236), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [116460] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4977), 1,
      anon_sym_if,
    ACTIONS(4979), 1,
      anon_sym_deferred,
    STATE(2336), 1,
      aux_sym_configurable_uri_repeat1,
    STATE(2543), 1,
      sym_configuration_uri,
    STATE(3093), 1,
      sym__deferred,
    STATE(2237), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4975), 4,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [116501] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(4981), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2201), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2238), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [116542] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(4983), 1,
      anon_sym_DQUOTE,
    STATE(2191), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2239), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116583] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(4985), 1,
      anon_sym_SQUOTE,
    STATE(2192), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2240), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116624] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(4987), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2201), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2241), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [116665] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4989), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2202), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2242), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [116706] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(4991), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2223), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2243), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [116747] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4993), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2229), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2244), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [116788] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(4995), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2245), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116829] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(4997), 1,
      anon_sym_DQUOTE,
    STATE(2206), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2246), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [116870] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4500), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym__type_dot_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(3503), 1,
      sym_formal_parameter_list,
    STATE(2247), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2015), 4,
      anon_sym_QMARK,
      anon_sym_LT,
      anon_sym_Function,
      anon_sym_operator,
  [116911] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(4999), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2222), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2248), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [116952] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(5001), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2241), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2249), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [116993] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4909), 1,
      anon_sym_DQUOTE,
    ACTIONS(4915), 1,
      anon_sym_DOLLAR,
    ACTIONS(5003), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(2242), 1,
      aux_sym__raw_string_literal_double_quotes_multiple_repeat1,
    STATE(2402), 1,
      sym__sub_string_test,
    STATE(2250), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4911), 4,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [117034] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(5005), 1,
      anon_sym_SQUOTE,
    STATE(2245), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2251), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [117075] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(149), 1,
      sym_assert_builtin,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(4795), 1,
      sym_identifier,
    STATE(2303), 1,
      sym_initializer_list_entry,
    STATE(2941), 1,
      sym_super,
    STATE(2947), 1,
      sym_this,
    STATE(2252), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2354), 2,
      sym_assertion,
      sym_field_initializer,
  [117120] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(5007), 1,
      anon_sym_DQUOTE,
    STATE(2246), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2253), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [117161] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(5009), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2261), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2254), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [117202] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4817), 1,
      anon_sym_DOLLAR,
    ACTIONS(4819), 1,
      sym__unused_escape_sequence,
    ACTIONS(5011), 1,
      anon_sym_SQUOTE,
    STATE(2232), 1,
      aux_sym__string_literal_single_quotes_repeat1,
    ACTIONS(4813), 2,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
    STATE(2255), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2584), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [117243] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4809), 1,
      anon_sym_DOLLAR,
    ACTIONS(4811), 1,
      sym__unused_escape_sequence,
    ACTIONS(5013), 1,
      anon_sym_DQUOTE,
    STATE(2233), 1,
      aux_sym__string_literal_double_quotes_repeat1,
    ACTIONS(4807), 2,
      sym__template_chars_double_single,
      anon_sym_SQUOTE,
    STATE(2256), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(2583), 3,
      sym_template_substitution,
      sym__sub_string_test,
      sym_escape_sequence,
  [117284] = 15,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1750), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2436), 1,
      sym_type_parameters,
    STATE(2563), 1,
      sym_mixins,
    STATE(3243), 1,
      sym_interfaces,
    STATE(2257), 2,
      sym_comment,
      sym_documentation_comment,
  [117331] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2258), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5017), 4,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
    ACTIONS(5015), 5,
      sym_void_type,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [117364] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2517), 1,
      anon_sym_DOT,
    ACTIONS(3616), 1,
      anon_sym_QMARK,
    ACTIONS(5019), 1,
      anon_sym_LPAREN,
    STATE(1616), 1,
      sym_parameter_type_list,
    STATE(1684), 1,
      sym_nullable_type,
    STATE(2259), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2528), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [117405] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4947), 1,
      anon_sym_EQ,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2289), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(2260), 2,
      sym_comment,
      sym_documentation_comment,
  [117450] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4903), 1,
      anon_sym_SQUOTE,
    ACTIONS(4907), 1,
      anon_sym_DOLLAR,
    ACTIONS(5023), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(2201), 1,
      aux_sym__raw_string_literal_single_quotes_multiple_repeat1,
    STATE(2398), 1,
      sym__sub_string_test,
    STATE(2261), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4901), 4,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [117491] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2507), 1,
      anon_sym_DOT,
    ACTIONS(3616), 1,
      anon_sym_QMARK,
    ACTIONS(4936), 1,
      anon_sym_LPAREN,
    STATE(1616), 1,
      sym_parameter_type_list,
    STATE(2216), 1,
      sym_nullable_type,
    STATE(2262), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2515), 4,
      anon_sym_Function,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [117532] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5025), 1,
      anon_sym_DQUOTE,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    STATE(2281), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2263), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [117570] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5033), 1,
      anon_sym_COMMA,
    ACTIONS(5035), 1,
      anon_sym_async,
    STATE(2291), 1,
      aux_sym_initializers_repeat1,
    STATE(2264), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5031), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [117606] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5039), 1,
      anon_sym_async,
    ACTIONS(5041), 1,
      anon_sym_native,
    STATE(2446), 1,
      sym__native,
    STATE(2265), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5037), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [117642] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5043), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2779), 1,
      sym__metadata,
    STATE(3267), 1,
      sym_type_parameter,
    STATE(2266), 2,
      sym_comment,
      sym_documentation_comment,
  [117686] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5043), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2705), 1,
      sym_type_parameter,
    STATE(2779), 1,
      sym__metadata,
    STATE(2267), 2,
      sym_comment,
      sym_documentation_comment,
  [117730] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2268), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5045), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(5047), 4,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
  [117762] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5043), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2738), 1,
      sym_type_parameter,
    STATE(2779), 1,
      sym__metadata,
    STATE(2269), 2,
      sym_comment,
      sym_documentation_comment,
  [117806] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5051), 1,
      anon_sym_LPAREN,
    STATE(2270), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5049), 7,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      sym_const_builtin,
      anon_sym_late,
      sym_identifier,
  [117838] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2271), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5053), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(5055), 4,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
  [117870] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5043), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2779), 1,
      sym__metadata,
    STATE(2849), 1,
      sym_type_parameter,
    STATE(2272), 2,
      sym_comment,
      sym_documentation_comment,
  [117914] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1686), 1,
      anon_sym_QMARK,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2374), 1,
      sym_arguments,
    STATE(2273), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1680), 5,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [117950] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2274), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5057), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_r_DQUOTE,
      anon_sym_r_SQUOTE,
    ACTIONS(5059), 4,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_r_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_r_SQUOTE_SQUOTE_SQUOTE,
  [117982] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(2475), 1,
      sym_nullable_type,
    STATE(2275), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5061), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [118016] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5065), 1,
      anon_sym_async,
    STATE(2460), 1,
      sym__native,
    STATE(2276), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5063), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [118052] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5043), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2779), 1,
      sym__metadata,
    STATE(2966), 1,
      sym_type_parameter,
    STATE(2277), 2,
      sym_comment,
      sym_documentation_comment,
  [118096] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2278), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5067), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
  [118126] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2288), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(5069), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2279), 2,
      sym_comment,
      sym_documentation_comment,
  [118168] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5074), 1,
      anon_sym_SQUOTE,
    ACTIONS(5076), 1,
      anon_sym_DOLLAR,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2280), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    ACTIONS(5071), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [118204] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5079), 1,
      anon_sym_DQUOTE,
    ACTIONS(5084), 1,
      anon_sym_DOLLAR,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2281), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    ACTIONS(5081), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [118240] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5090), 1,
      anon_sym_in,
    STATE(2282), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5087), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
  [118272] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5043), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2779), 1,
      sym__metadata,
    STATE(2823), 1,
      sym_type_parameter,
    STATE(2283), 2,
      sym_comment,
      sym_documentation_comment,
  [118316] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2288), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(5092), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2284), 2,
      sym_comment,
      sym_documentation_comment,
  [118358] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5096), 1,
      anon_sym_async,
    STATE(2506), 1,
      sym__native,
    STATE(2285), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5094), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [118394] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(1741), 1,
      anon_sym_RBRACE,
    ACTIONS(5098), 1,
      sym_identifier,
    ACTIONS(5100), 1,
      anon_sym_SEMI,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2992), 1,
      sym_enum_constant,
    STATE(3537), 1,
      sym__metadata,
    STATE(2286), 2,
      sym_comment,
      sym_documentation_comment,
  [118438] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(1883), 1,
      anon_sym_RBRACE,
    ACTIONS(5098), 1,
      sym_identifier,
    ACTIONS(5102), 1,
      anon_sym_SEMI,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2992), 1,
      sym_enum_constant,
    STATE(3537), 1,
      sym__metadata,
    STATE(2287), 2,
      sym_comment,
      sym_documentation_comment,
  [118482] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(2445), 1,
      sym_nullable_type,
    STATE(2288), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5104), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [118516] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5108), 1,
      anon_sym_async,
    STATE(2526), 1,
      sym__native,
    STATE(2289), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5106), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [118552] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5110), 1,
      anon_sym_DQUOTE,
    STATE(2281), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2290), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [118590] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5114), 1,
      anon_sym_COMMA,
    ACTIONS(5117), 1,
      anon_sym_async,
    STATE(2291), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_initializers_repeat1,
    ACTIONS(5112), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [118624] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2292), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5090), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_in,
  [118654] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4460), 1,
      anon_sym_LPAREN,
    ACTIONS(2772), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2293), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2774), 5,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_operator,
      anon_sym_set,
      sym_identifier,
  [118688] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5119), 1,
      anon_sym_DQUOTE,
    STATE(2263), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2294), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [118726] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5123), 1,
      anon_sym_SQUOTE,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    STATE(2280), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2295), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [118764] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4464), 1,
      anon_sym_native,
    ACTIONS(5130), 1,
      anon_sym_COLON,
    ACTIONS(5132), 1,
      anon_sym_async,
    STATE(2296), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5127), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [118800] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5043), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2456), 1,
      sym_nullable_type,
    STATE(2778), 1,
      sym_type_parameter,
    STATE(2779), 1,
      sym__metadata,
    STATE(2297), 2,
      sym_comment,
      sym_documentation_comment,
  [118844] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5135), 1,
      anon_sym_DQUOTE,
    STATE(2281), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2298), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [118882] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2288), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    ACTIONS(5137), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2299), 2,
      sym_comment,
      sym_documentation_comment,
  [118924] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5139), 1,
      anon_sym_SQUOTE,
    STATE(2280), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2300), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [118962] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5141), 1,
      anon_sym_SQUOTE,
    STATE(2326), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2301), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [119000] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5145), 1,
      anon_sym_async,
    STATE(2520), 1,
      sym__native,
    STATE(2302), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5143), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [119036] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5033), 1,
      anon_sym_COMMA,
    ACTIONS(5149), 1,
      anon_sym_async,
    STATE(2264), 1,
      aux_sym_initializers_repeat1,
    STATE(2303), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5147), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [119072] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5151), 1,
      anon_sym_SQUOTE,
    STATE(2295), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2304), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [119110] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5155), 1,
      anon_sym_async,
    STATE(2516), 1,
      sym__native,
    STATE(2305), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5153), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [119146] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5157), 1,
      anon_sym_DQUOTE,
    STATE(2298), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2306), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [119184] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5161), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    STATE(2307), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5163), 3,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
    ACTIONS(5159), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
  [119218] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2308), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4712), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_PIPE_PIPE,
  [119248] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(5169), 1,
      anon_sym_on,
    STATE(1768), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2482), 1,
      sym_type_parameters,
    STATE(3075), 1,
      sym_interfaces,
    STATE(2309), 2,
      sym_comment,
      sym_documentation_comment,
  [119292] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(2523), 1,
      sym_nullable_type,
    STATE(2310), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5171), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [119326] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5175), 1,
      anon_sym_async,
    STATE(2492), 1,
      sym__native,
    STATE(2311), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5173), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [119362] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(5177), 1,
      anon_sym_on,
    STATE(1793), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2452), 1,
      sym_type_parameters,
    STATE(3185), 1,
      sym_interfaces,
    STATE(2312), 2,
      sym_comment,
      sym_documentation_comment,
  [119406] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5179), 1,
      anon_sym_DQUOTE,
    STATE(2281), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2313), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [119444] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5181), 1,
      anon_sym_SQUOTE,
    STATE(2280), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2314), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [119482] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2706), 1,
      anon_sym_QMARK,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2435), 1,
      sym_arguments,
    STATE(2315), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2704), 5,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [119518] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5183), 1,
      anon_sym_DQUOTE,
    STATE(2281), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2316), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [119556] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5185), 1,
      anon_sym_SQUOTE,
    STATE(2280), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2317), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [119594] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5187), 1,
      anon_sym_DQUOTE,
    STATE(2313), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2318), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [119632] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5189), 1,
      anon_sym_SQUOTE,
    STATE(2314), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2319), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [119670] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5191), 1,
      anon_sym_as,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1564), 1,
      sym__semicolon,
    STATE(2490), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    STATE(3486), 1,
      sym__as,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2320), 2,
      sym_comment,
      sym_documentation_comment,
  [119712] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5200), 1,
      anon_sym_in,
    STATE(2321), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5197), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
  [119744] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5202), 1,
      anon_sym_DQUOTE,
    STATE(2290), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2322), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [119782] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5206), 1,
      aux_sym__sub_string_test_token1,
    STATE(2323), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5208), 3,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
    ACTIONS(5204), 4,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
  [119816] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5029), 1,
      anon_sym_DOLLAR,
    ACTIONS(5210), 1,
      anon_sym_DQUOTE,
    STATE(2316), 1,
      aux_sym__raw_string_literal_double_quotes_repeat1,
    STATE(2448), 1,
      sym__sub_string_test,
    STATE(2324), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5027), 4,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      sym__unused_escape_sequence,
  [119854] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5214), 1,
      anon_sym_async,
    STATE(2459), 1,
      sym__native,
    STATE(2325), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5212), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [119890] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5216), 1,
      anon_sym_SQUOTE,
    STATE(2280), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2326), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [119928] = 14,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(5218), 1,
      anon_sym_on,
    STATE(1770), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2489), 1,
      sym_type_parameters,
    STATE(3078), 1,
      sym_interfaces,
    STATE(2327), 2,
      sym_comment,
      sym_documentation_comment,
  [119972] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5220), 1,
      anon_sym_SQUOTE,
    STATE(2317), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2328), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [120010] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5224), 1,
      anon_sym_async,
    STATE(2493), 1,
      sym__native,
    STATE(2329), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5222), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [120046] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5125), 1,
      anon_sym_DOLLAR,
    ACTIONS(5226), 1,
      anon_sym_SQUOTE,
    STATE(2300), 1,
      aux_sym__raw_string_literal_single_quotes_repeat1,
    STATE(2439), 1,
      sym__sub_string_test,
    STATE(2330), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5121), 4,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      sym__unused_escape_sequence,
  [120084] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5041), 1,
      anon_sym_native,
    ACTIONS(5230), 1,
      anon_sym_async,
    STATE(2508), 1,
      sym__native,
    STATE(2331), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5228), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [120120] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2864), 1,
      anon_sym_QMARK,
    STATE(2332), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2862), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120151] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5234), 1,
      anon_sym_async,
    STATE(2333), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5232), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [120182] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2334), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5200), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_SEMI,
  [120211] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2958), 1,
      anon_sym_QMARK,
    STATE(2335), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2956), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120242] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4977), 1,
      anon_sym_if,
    STATE(2361), 1,
      aux_sym_configurable_uri_repeat1,
    STATE(2543), 1,
      sym_configuration_uri,
    STATE(2336), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5236), 4,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [120277] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5240), 1,
      anon_sym_async,
    STATE(2337), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5238), 6,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [120308] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2994), 1,
      anon_sym_QMARK,
    STATE(2338), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2992), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120339] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5242), 1,
      anon_sym_LBRACE,
    ACTIONS(5244), 1,
      anon_sym_EQ_GT,
    ACTIONS(5246), 1,
      anon_sym_async,
    STATE(966), 1,
      sym_function_expression_body,
    STATE(974), 1,
      sym_block,
    ACTIONS(5248), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2339), 2,
      sym_comment,
      sym_documentation_comment,
  [120378] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2661), 1,
      anon_sym_QMARK,
    STATE(2340), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2657), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120409] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2676), 1,
      anon_sym_QMARK,
    STATE(2341), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2672), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120440] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    ACTIONS(5252), 1,
      anon_sym_EQ_GT,
    ACTIONS(5254), 1,
      anon_sym_async,
    STATE(1248), 1,
      sym_function_expression_body,
    STATE(1250), 1,
      sym_block,
    ACTIONS(5256), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2342), 2,
      sym_comment,
      sym_documentation_comment,
  [120479] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5258), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2675), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2343), 2,
      sym_comment,
      sym_documentation_comment,
  [120520] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5260), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2675), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2344), 2,
      sym_comment,
      sym_documentation_comment,
  [120561] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2850), 1,
      anon_sym_QMARK,
    STATE(2345), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2848), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120592] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2854), 1,
      anon_sym_QMARK,
    STATE(2346), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2852), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120623] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5264), 1,
      anon_sym_async,
    STATE(2347), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5262), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [120654] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3048), 1,
      anon_sym_QMARK,
    STATE(2348), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3046), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120685] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5268), 1,
      anon_sym_async,
    STATE(2349), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5266), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [120716] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3052), 1,
      anon_sym_QMARK,
    STATE(2350), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3050), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120747] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3056), 1,
      anon_sym_QMARK,
    STATE(2351), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3054), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120778] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5272), 1,
      anon_sym_EQ,
    ACTIONS(5274), 1,
      anon_sym_async,
    STATE(2352), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5270), 5,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [120811] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3092), 1,
      anon_sym_QMARK,
    STATE(2353), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3090), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120842] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5278), 1,
      anon_sym_async,
    STATE(2354), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5276), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [120873] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2982), 1,
      anon_sym_QMARK,
    STATE(2355), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2980), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120904] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2990), 1,
      anon_sym_QMARK,
    STATE(2356), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2988), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [120935] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(5280), 1,
      sym_identifier,
    STATE(2372), 1,
      sym__get,
    STATE(2378), 1,
      sym__set,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3520), 1,
      sym_initialized_identifier_list,
    STATE(2357), 2,
      sym_comment,
      sym_documentation_comment,
  [120976] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5282), 1,
      anon_sym_LBRACE,
    ACTIONS(5284), 1,
      anon_sym_EQ_GT,
    ACTIONS(5286), 1,
      anon_sym_async,
    STATE(1085), 1,
      sym_function_expression_body,
    STATE(1119), 1,
      sym_block,
    ACTIONS(5288), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2358), 2,
      sym_comment,
      sym_documentation_comment,
  [121015] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3060), 1,
      anon_sym_QMARK,
    STATE(2359), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3058), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121046] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5292), 1,
      anon_sym_async,
    STATE(2360), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5290), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [121077] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5296), 1,
      anon_sym_if,
    STATE(2543), 1,
      sym_configuration_uri,
    STATE(2361), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_configurable_uri_repeat1,
    ACTIONS(5294), 4,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [121110] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5299), 1,
      anon_sym_DQUOTE,
    STATE(2362), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 6,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [121141] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3088), 1,
      anon_sym_QMARK,
    STATE(2363), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3086), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121172] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3068), 1,
      anon_sym_QMARK,
    STATE(2364), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3066), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121203] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2954), 1,
      anon_sym_QMARK,
    STATE(2365), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2952), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121234] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2914), 1,
      anon_sym_QMARK,
    STATE(2366), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2912), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121265] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3044), 1,
      anon_sym_QMARK,
    STATE(2367), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3042), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121296] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(4835), 1,
      anon_sym_EQ_GT,
    ACTIONS(4837), 1,
      anon_sym_async,
    STATE(446), 1,
      sym_block,
    STATE(538), 1,
      sym_function_body,
    ACTIONS(4839), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2368), 2,
      sym_comment,
      sym_documentation_comment,
  [121335] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1332), 1,
      anon_sym_QMARK,
    STATE(2369), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1322), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121366] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(4835), 1,
      anon_sym_EQ_GT,
    ACTIONS(4837), 1,
      anon_sym_async,
    STATE(446), 1,
      sym_block,
    STATE(1959), 1,
      sym_function_body,
    ACTIONS(4839), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2370), 2,
      sym_comment,
      sym_documentation_comment,
  [121405] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2816), 1,
      anon_sym_QMARK,
    STATE(2371), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2814), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121436] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5303), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2305), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2372), 2,
      sym_comment,
      sym_documentation_comment,
  [121477] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2373), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5305), 7,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_when,
  [121506] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1733), 1,
      anon_sym_QMARK,
    STATE(2374), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1731), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121537] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5309), 1,
      anon_sym_async,
    STATE(2375), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5307), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [121568] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2698), 1,
      anon_sym_QMARK,
    STATE(2376), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2694), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121599] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2311), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2377), 2,
      sym_comment,
      sym_documentation_comment,
  [121640] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2305), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2378), 2,
      sym_comment,
      sym_documentation_comment,
  [121681] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2938), 1,
      anon_sym_QMARK,
    STATE(2379), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2936), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121712] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3064), 1,
      anon_sym_QMARK,
    STATE(2380), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3062), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121743] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2718), 1,
      anon_sym_QMARK,
    STATE(2381), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2716), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121774] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2922), 1,
      anon_sym_QMARK,
    STATE(2382), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2920), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121805] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3034), 1,
      anon_sym_QMARK,
    STATE(2383), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3032), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121836] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3030), 1,
      anon_sym_QMARK,
    STATE(2384), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3028), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121867] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1686), 1,
      anon_sym_QMARK,
    STATE(2385), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1680), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121898] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2688), 1,
      anon_sym_QMARK,
    STATE(2386), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2686), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121929] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2820), 1,
      anon_sym_QMARK,
    STATE(2387), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2818), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121960] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2874), 1,
      anon_sym_QMARK,
    STATE(2388), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2872), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [121991] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2986), 1,
      anon_sym_QMARK,
    STATE(2389), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2984), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122022] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2906), 1,
      anon_sym_QMARK,
    STATE(2390), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2904), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122053] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2878), 1,
      anon_sym_QMARK,
    STATE(2391), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2876), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122084] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5317), 1,
      anon_sym_async,
    STATE(2392), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5315), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [122115] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1277), 1,
      anon_sym_QMARK,
    STATE(2393), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1257), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122146] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2743), 1,
      anon_sym_QMARK,
    STATE(2394), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2741), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122177] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5319), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2841), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2395), 2,
      sym_comment,
      sym_documentation_comment,
  [122218] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1697), 1,
      anon_sym_QMARK,
    STATE(2396), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1695), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122249] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2834), 1,
      anon_sym_QMARK,
    STATE(2397), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2832), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122280] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5204), 1,
      anon_sym_SQUOTE,
    STATE(2398), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5208), 6,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [122311] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3096), 1,
      anon_sym_QMARK,
    STATE(2399), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3094), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122342] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5321), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2841), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2400), 2,
      sym_comment,
      sym_documentation_comment,
  [122383] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1729), 1,
      anon_sym_QMARK,
    STATE(2401), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1727), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122414] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5159), 1,
      anon_sym_DQUOTE,
    STATE(2402), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5163), 6,
      sym__template_chars_double,
      sym__template_chars_raw_slash,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [122445] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(4835), 1,
      anon_sym_EQ_GT,
    ACTIONS(4837), 1,
      anon_sym_async,
    STATE(446), 1,
      sym_block,
    STATE(1953), 1,
      sym_function_body,
    ACTIONS(4839), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2403), 2,
      sym_comment,
      sym_documentation_comment,
  [122484] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3026), 1,
      anon_sym_QMARK,
    STATE(2404), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3024), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122515] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2824), 1,
      anon_sym_QMARK,
    STATE(2405), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2822), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122546] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5325), 1,
      anon_sym_EQ,
    ACTIONS(5327), 1,
      anon_sym_async,
    STATE(2406), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5323), 5,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
      anon_sym_native,
  [122579] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    STATE(2556), 1,
      sym_nullable_type,
    ACTIONS(2541), 2,
      anon_sym_LPAREN,
      anon_sym_DOT,
    STATE(2407), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4089), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [122614] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5299), 1,
      anon_sym_SQUOTE,
    STATE(2408), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 6,
      sym__template_chars_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [122645] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1645), 1,
      anon_sym_QMARK,
    STATE(2409), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1643), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122676] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1752), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2571), 1,
      sym_mixins,
    STATE(3193), 1,
      sym_interfaces,
    STATE(2410), 2,
      sym_comment,
      sym_documentation_comment,
  [122717] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5329), 1,
      sym_identifier,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2311), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2411), 2,
      sym_comment,
      sym_documentation_comment,
  [122758] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2942), 1,
      anon_sym_QMARK,
    STATE(2412), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2940), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122789] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2882), 1,
      anon_sym_QMARK,
    STATE(2413), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2880), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122820] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1670), 1,
      anon_sym_QMARK,
    STATE(2414), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1668), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122851] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2930), 1,
      anon_sym_QMARK,
    STATE(2415), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2928), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122882] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3084), 1,
      anon_sym_QMARK,
    STATE(2416), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3082), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [122913] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(4835), 1,
      anon_sym_EQ_GT,
    ACTIONS(4837), 1,
      anon_sym_async,
    STATE(446), 1,
      sym_block,
    STATE(1954), 1,
      sym_function_body,
    ACTIONS(4839), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2417), 2,
      sym_comment,
      sym_documentation_comment,
  [122952] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4793), 1,
      anon_sym_async,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(3314), 1,
      sym__native,
    STATE(2418), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4787), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [122987] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(5280), 1,
      sym_identifier,
    STATE(2372), 1,
      sym__get,
    STATE(2378), 1,
      sym__set,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3264), 1,
      sym_initialized_identifier_list,
    STATE(2419), 2,
      sym_comment,
      sym_documentation_comment,
  [123028] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3692), 1,
      anon_sym_DOT,
    ACTIONS(5333), 1,
      anon_sym_EQ,
    STATE(1612), 1,
      sym__type_dot_identifier,
    ACTIONS(1320), 2,
      anon_sym_Function,
      sym_identifier,
    ACTIONS(2015), 2,
      anon_sym_QMARK,
      anon_sym_LT,
    STATE(2420), 2,
      sym_comment,
      sym_documentation_comment,
  [123065] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4422), 1,
      anon_sym_LPAREN,
    STATE(1718), 1,
      sym_nullable_type,
    STATE(2431), 1,
      sym_type_arguments,
    ACTIONS(2539), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(2421), 2,
      sym_comment,
      sym_documentation_comment,
  [123104] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(4835), 1,
      anon_sym_EQ_GT,
    ACTIONS(4837), 1,
      anon_sym_async,
    STATE(446), 1,
      sym_block,
    STATE(1947), 1,
      sym_function_body,
    ACTIONS(4839), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2422), 2,
      sym_comment,
      sym_documentation_comment,
  [123143] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1659), 1,
      anon_sym_QMARK,
    STATE(2423), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1657), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [123174] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(45), 1,
      anon_sym_Function,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(2141), 1,
      sym__function_builtin_identifier,
    STATE(2174), 1,
      aux_sym__function_type_tails,
    STATE(2424), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4089), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [123211] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5337), 1,
      aux_sym__sub_string_test_token1,
    STATE(2425), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5335), 3,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(5339), 3,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
  [123244] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(5341), 1,
      anon_sym_EQ_GT,
    ACTIONS(5343), 1,
      anon_sym_async,
    STATE(2384), 1,
      sym_block,
    STATE(2427), 1,
      sym_function_expression_body,
    ACTIONS(5345), 2,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
    STATE(2426), 2,
      sym_comment,
      sym_documentation_comment,
  [123283] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3010), 1,
      anon_sym_QMARK,
    STATE(2427), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(3008), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [123314] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2966), 1,
      anon_sym_QMARK,
    STATE(2428), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2964), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [123345] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5349), 1,
      anon_sym_async,
    STATE(2429), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5347), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [123376] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5117), 1,
      anon_sym_async,
    STATE(2430), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5112), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [123407] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    STATE(1721), 1,
      sym_nullable_type,
    ACTIONS(2550), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2555), 2,
      anon_sym_Function,
      sym_identifier,
    STATE(2431), 2,
      sym_comment,
      sym_documentation_comment,
  [123444] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(984), 1,
      anon_sym_QMARK,
    STATE(2432), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(980), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [123475] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(5280), 1,
      sym_identifier,
    STATE(2372), 1,
      sym__get,
    STATE(2378), 1,
      sym__set,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3104), 1,
      sym_initialized_identifier_list,
    STATE(2433), 2,
      sym_comment,
      sym_documentation_comment,
  [123516] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(5353), 1,
      aux_sym__sub_string_test_token1,
    STATE(2434), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5351), 3,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
    ACTIONS(5355), 3,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      sym__unused_escape_sequence,
  [123549] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2970), 1,
      anon_sym_QMARK,
    STATE(2435), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(2968), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [123580] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4584), 1,
      anon_sym_with,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1775), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(2550), 1,
      sym_mixins,
    STATE(3042), 1,
      sym_interfaces,
    STATE(2436), 2,
      sym_comment,
      sym_documentation_comment,
  [123621] = 13,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(1709), 1,
      anon_sym_operator,
    ACTIONS(5357), 1,
      sym_identifier,
    STATE(1509), 1,
      sym__operator,
    STATE(2372), 1,
      sym__get,
    STATE(2378), 1,
      sym__set,
    STATE(2437), 2,
      sym_comment,
      sym_documentation_comment,
  [123662] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1663), 1,
      anon_sym_QMARK,
    STATE(2438), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(1661), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
  [123693] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2439), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5339), 6,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [123721] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(5098), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2631), 1,
      sym_enum_constant,
    STATE(3537), 1,
      sym__metadata,
    STATE(2440), 2,
      sym_comment,
      sym_documentation_comment,
  [123759] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5362), 1,
      anon_sym_SQUOTE,
    STATE(2441), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5360), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [123789] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2289), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2442), 2,
      sym_comment,
      sym_documentation_comment,
  [123827] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1598), 1,
      sym__semicolon,
    STATE(2535), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2443), 2,
      sym_comment,
      sym_documentation_comment,
  [123863] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(2647), 1,
      sym_nullable_type,
    STATE(3131), 1,
      sym_type_bound,
    ACTIONS(5364), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2444), 2,
      sym_comment,
      sym_documentation_comment,
  [123899] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2445), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5171), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [123927] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5368), 1,
      anon_sym_async,
    STATE(2446), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5366), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [123957] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2447), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4596), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [123985] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2448), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5355), 6,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [124013] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5372), 1,
      anon_sym_SQUOTE,
    STATE(2449), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5370), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [124043] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(5374), 1,
      sym_identifier,
    ACTIONS(5376), 1,
      anon_sym_QMARK,
    STATE(759), 1,
      sym_cascade_selector,
    STATE(1126), 1,
      sym_index_selector,
    STATE(3009), 1,
      sym_nullable_selector,
    STATE(2450), 2,
      sym_comment,
      sym_documentation_comment,
  [124081] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4791), 1,
      anon_sym_SEMI,
    ACTIONS(4793), 1,
      anon_sym_async,
    STATE(2451), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4787), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [124113] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(5378), 1,
      anon_sym_on,
    STATE(1761), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3166), 1,
      sym_interfaces,
    STATE(2452), 2,
      sym_comment,
      sym_documentation_comment,
  [124151] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5380), 1,
      anon_sym_DQUOTE,
    STATE(2453), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5382), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [124181] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2454), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4604), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [124209] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(119), 1,
      anon_sym_BANG,
    ACTIONS(5386), 1,
      anon_sym_LPAREN,
    STATE(2640), 1,
      sym__exclamation_operator,
    STATE(2455), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5384), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [124243] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(2653), 1,
      sym_nullable_type,
    STATE(3028), 1,
      sym_type_bound,
    ACTIONS(5388), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2456), 2,
      sym_comment,
      sym_documentation_comment,
  [124279] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2457), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5390), 6,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_show,
      anon_sym_hide,
      anon_sym_deferred,
  [124307] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5394), 1,
      anon_sym_async,
    STATE(2458), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5392), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [124337] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5398), 1,
      anon_sym_async,
    STATE(2459), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5396), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [124367] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5402), 1,
      anon_sym_async,
    STATE(2460), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5400), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [124397] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2305), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2461), 2,
      sym_comment,
      sym_documentation_comment,
  [124435] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2845), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2462), 2,
      sym_comment,
      sym_documentation_comment,
  [124473] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2675), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2463), 2,
      sym_comment,
      sym_documentation_comment,
  [124511] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2464), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5404), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [124539] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2465), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5406), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [124567] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2466), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5408), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [124595] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5380), 1,
      anon_sym_SQUOTE,
    STATE(2467), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5382), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [124625] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2468), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5410), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [124653] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2841), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2469), 2,
      sym_comment,
      sym_documentation_comment,
  [124691] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2264), 1,
      anon_sym_LBRACE,
    ACTIONS(2266), 1,
      anon_sym_LBRACK,
    ACTIONS(5412), 1,
      anon_sym_RPAREN,
    STATE(3311), 1,
      sym_optional_formal_parameters,
    STATE(2470), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3424), 2,
      sym__optional_postional_formal_parameters,
      sym__named_formal_parameters,
  [124727] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2671), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2471), 2,
      sym_comment,
      sym_documentation_comment,
  [124765] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2288), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2472), 2,
      sym_comment,
      sym_documentation_comment,
  [124803] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2884), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2473), 2,
      sym_comment,
      sym_documentation_comment,
  [124841] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2331), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2474), 2,
      sym_comment,
      sym_documentation_comment,
  [124879] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2475), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5104), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [124907] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(892), 1,
      anon_sym_case,
    ACTIONS(4745), 1,
      sym_identifier,
    ACTIONS(5414), 1,
      anon_sym_default,
    STATE(416), 1,
      sym_case_builtin,
    STATE(2529), 1,
      aux_sym_switch_statement_case_repeat1,
    STATE(2691), 1,
      sym_label,
    STATE(2476), 2,
      sym_comment,
      sym_documentation_comment,
  [124945] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1613), 1,
      sym__semicolon,
    STATE(2535), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2477), 2,
      sym_comment,
      sym_documentation_comment,
  [124981] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2478), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5416), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [125009] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(5374), 1,
      sym_identifier,
    ACTIONS(5376), 1,
      anon_sym_QMARK,
    STATE(830), 1,
      sym_cascade_selector,
    STATE(1126), 1,
      sym_index_selector,
    STATE(3009), 1,
      sym_nullable_selector,
    STATE(2479), 2,
      sym_comment,
      sym_documentation_comment,
  [125047] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2480), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5418), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [125075] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5422), 1,
      anon_sym_LPAREN,
    STATE(2481), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5420), 5,
      anon_sym_final,
      sym_void_type,
      anon_sym_var,
      anon_sym_Function,
      sym_identifier,
  [125105] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(5177), 1,
      anon_sym_on,
    STATE(1793), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3185), 1,
      sym_interfaces,
    STATE(2482), 2,
      sym_comment,
      sym_documentation_comment,
  [125143] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(3399), 1,
      sym__formal_parameter_part,
    STATE(2483), 2,
      sym_comment,
      sym_documentation_comment,
  [125181] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1555), 1,
      sym__semicolon,
    STATE(2535), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2484), 2,
      sym_comment,
      sym_documentation_comment,
  [125217] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(3502), 1,
      sym__formal_parameter_part,
    STATE(2485), 2,
      sym_comment,
      sym_documentation_comment,
  [125255] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    ACTIONS(5374), 1,
      sym_identifier,
    ACTIONS(5376), 1,
      anon_sym_QMARK,
    STATE(1126), 1,
      sym_index_selector,
    STATE(1215), 1,
      sym_cascade_selector,
    STATE(3009), 1,
      sym_nullable_selector,
    STATE(2486), 2,
      sym_comment,
      sym_documentation_comment,
  [125293] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5362), 1,
      anon_sym_DQUOTE,
    STATE(2487), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5360), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [125323] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2488), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5424), 6,
      anon_sym_final,
      anon_sym_inline,
      anon_sym_class,
      anon_sym_interface,
      anon_sym_base,
      anon_sym_mixin,
  [125351] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(5169), 1,
      anon_sym_on,
    STATE(1768), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3075), 1,
      sym_interfaces,
    STATE(2489), 2,
      sym_comment,
      sym_documentation_comment,
  [125389] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1584), 1,
      sym__semicolon,
    STATE(2535), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2490), 2,
      sym_comment,
      sym_documentation_comment,
  [125425] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1567), 1,
      sym__semicolon,
    STATE(2484), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2491), 2,
      sym_comment,
      sym_documentation_comment,
  [125461] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5428), 1,
      anon_sym_async,
    STATE(2492), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5426), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [125491] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5432), 1,
      anon_sym_async,
    STATE(2493), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5430), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [125521] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2325), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2494), 2,
      sym_comment,
      sym_documentation_comment,
  [125559] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5434), 1,
      anon_sym_DQUOTE,
    STATE(2495), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5436), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [125589] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(914), 1,
      sym_cascade_section,
    STATE(2101), 1,
      aux_sym__expression_repeat1,
    ACTIONS(2076), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(4638), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(2496), 2,
      sym_comment,
      sym_documentation_comment,
  [125623] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2497), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 6,
      sym__template_chars_single_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [125651] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5299), 1,
      anon_sym_DQUOTE,
    STATE(2498), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [125681] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5438), 1,
      anon_sym_DQUOTE,
    STATE(2499), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5440), 5,
      sym__template_chars_double,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [125711] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2311), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2500), 2,
      sym_comment,
      sym_documentation_comment,
  [125749] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5376), 1,
      anon_sym_QMARK,
    ACTIONS(5442), 1,
      sym_identifier,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(466), 1,
      sym_cascade_selector,
    STATE(639), 1,
      sym_index_selector,
    STATE(3110), 1,
      sym_nullable_selector,
    STATE(2501), 2,
      sym_comment,
      sym_documentation_comment,
  [125787] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(914), 1,
      sym_cascade_section,
    STATE(2101), 1,
      aux_sym__expression_repeat1,
    ACTIONS(2076), 2,
      anon_sym_DOT_DOT,
      anon_sym_QMARK_DOT_DOT,
    ACTIONS(4642), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(2502), 2,
      sym_comment,
      sym_documentation_comment,
  [125821] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5448), 1,
      anon_sym_COLON,
    STATE(519), 1,
      sym__semicolon,
    STATE(2503), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5446), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_else,
  [125855] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5452), 1,
      anon_sym_DOT,
    STATE(2504), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_factory_constructor_signature_repeat1,
    ACTIONS(5450), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [125885] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1604), 1,
      sym__semicolon,
    STATE(2522), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2505), 2,
      sym_comment,
      sym_documentation_comment,
  [125921] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5039), 1,
      anon_sym_async,
    STATE(2506), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5037), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [125951] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4977), 1,
      anon_sym_if,
    STATE(2336), 1,
      aux_sym_configurable_uri_repeat1,
    STATE(2543), 1,
      sym_configuration_uri,
    STATE(2507), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4975), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [125985] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5457), 1,
      anon_sym_async,
    STATE(2508), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5455), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [126015] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(2632), 1,
      sym_nullable_type,
    STATE(3270), 1,
      sym_type_bound,
    ACTIONS(5459), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2509), 2,
      sym_comment,
      sym_documentation_comment,
  [126051] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(2634), 1,
      sym_nullable_type,
    STATE(3272), 1,
      sym_type_bound,
    ACTIONS(5461), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2510), 2,
      sym_comment,
      sym_documentation_comment,
  [126087] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5376), 1,
      anon_sym_QMARK,
    ACTIONS(5463), 1,
      sym_identifier,
    ACTIONS(5465), 1,
      anon_sym_LBRACK,
    STATE(455), 1,
      sym_cascade_selector,
    STATE(587), 1,
      sym_index_selector,
    STATE(3102), 1,
      sym_nullable_selector,
    STATE(2511), 2,
      sym_comment,
      sym_documentation_comment,
  [126125] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1555), 1,
      sym__semicolon,
    STATE(2443), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2512), 2,
      sym_comment,
      sym_documentation_comment,
  [126161] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2020), 1,
      sym_formal_parameter_list,
    STATE(2310), 1,
      sym__formal_parameter_part,
    STATE(2932), 1,
      sym_type_parameters,
    STATE(2513), 2,
      sym_comment,
      sym_documentation_comment,
  [126199] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1569), 1,
      sym__semicolon,
    STATE(2477), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2514), 2,
      sym_comment,
      sym_documentation_comment,
  [126235] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5469), 1,
      anon_sym_LPAREN,
    STATE(2515), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5467), 5,
      sym_void_type,
      anon_sym_Function,
      anon_sym_get,
      anon_sym_set,
      sym_identifier,
  [126265] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5473), 1,
      anon_sym_async,
    STATE(2516), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5471), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [126295] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2517), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 6,
      sym__template_chars_double_single,
      sym__template_chars_raw_slash,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [126323] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5438), 1,
      anon_sym_SQUOTE,
    STATE(2518), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5440), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [126353] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5299), 1,
      anon_sym_SQUOTE,
    STATE(2519), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 5,
      sym__template_chars_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [126383] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5477), 1,
      anon_sym_async,
    STATE(2520), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5475), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [126413] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5481), 1,
      anon_sym_SEMI,
    ACTIONS(5483), 1,
      anon_sym_async,
    STATE(2521), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5479), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [126445] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1569), 1,
      sym__semicolon,
    STATE(2535), 1,
      aux_sym_library_export_repeat1,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5195), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2522), 2,
      sym_comment,
      sym_documentation_comment,
  [126481] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2523), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5485), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [126509] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2524), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5487), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [126537] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2525), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5489), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [126565] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5493), 1,
      anon_sym_async,
    STATE(2526), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5491), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [126595] = 12,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(143), 1,
      anon_sym_AT,
    ACTIONS(5098), 1,
      sym_identifier,
    STATE(1308), 1,
      aux_sym__metadata_repeat1,
    STATE(1361), 1,
      sym_annotation,
    STATE(2992), 1,
      sym_enum_constant,
    STATE(3537), 1,
      sym__metadata,
    STATE(2527), 2,
      sym_comment,
      sym_documentation_comment,
  [126633] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2528), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5450), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [126660] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5495), 1,
      sym_identifier,
    STATE(2691), 1,
      sym_label,
    ACTIONS(5498), 2,
      anon_sym_default,
      anon_sym_case,
    STATE(2529), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_switch_statement_case_repeat1,
  [126691] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(5357), 1,
      sym_identifier,
    STATE(2461), 2,
      sym__get,
      sym__set,
    STATE(2530), 2,
      sym_comment,
      sym_documentation_comment,
  [126724] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2531), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [126751] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4797), 1,
      anon_sym_COMMA,
    STATE(2575), 1,
      aux_sym_inferred_parameters_repeat1,
    STATE(2532), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5500), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [126782] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2533), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5440), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [126809] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4797), 1,
      anon_sym_COMMA,
    STATE(2532), 1,
      aux_sym_inferred_parameters_repeat1,
    STATE(2534), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5502), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [126840] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5504), 1,
      anon_sym_SEMI,
    STATE(2733), 1,
      sym_combinator,
    ACTIONS(5506), 2,
      anon_sym_show,
      anon_sym_hide,
    STATE(2535), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_library_export_repeat1,
  [126871] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5511), 1,
      anon_sym_RPAREN,
    STATE(197), 1,
      sym__semicolon,
    STATE(2763), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2536), 2,
      sym_comment,
      sym_documentation_comment,
  [126906] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2537), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5513), 5,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_show,
      anon_sym_hide,
  [126933] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2538), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5360), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [126960] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2546), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(3039), 1,
      sym_formal_parameter_list,
    STATE(2539), 2,
      sym_comment,
      sym_documentation_comment,
  [126995] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(5517), 1,
      sym_identifier,
    STATE(3538), 1,
      sym_super,
    STATE(3551), 1,
      sym_this,
    STATE(2540), 2,
      sym_comment,
      sym_documentation_comment,
  [127030] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5521), 1,
      anon_sym_COMMA,
    ACTIONS(5519), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
    STATE(2541), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__type_not_void_list_repeat1,
  [127059] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2406), 1,
      sym_formal_parameter_list,
    STATE(2577), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(2542), 2,
      sym_comment,
      sym_documentation_comment,
  [127094] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2543), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5524), 5,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_show,
      anon_sym_hide,
  [127121] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1741), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3063), 1,
      sym_interfaces,
    STATE(2544), 2,
      sym_comment,
      sym_documentation_comment,
  [127156] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5526), 1,
      sym_identifier,
    ACTIONS(5528), 1,
      anon_sym_new,
    STATE(1203), 1,
      sym__new_builtin,
    STATE(2110), 1,
      sym__identifier_or_new,
    STATE(3276), 1,
      sym__type_name,
    STATE(2545), 2,
      sym_comment,
      sym_documentation_comment,
  [127191] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2504), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(3232), 1,
      sym_formal_parameter_list,
    STATE(2546), 2,
      sym_comment,
      sym_documentation_comment,
  [127226] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1793), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3185), 1,
      sym_interfaces,
    STATE(2547), 2,
      sym_comment,
      sym_documentation_comment,
  [127261] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5526), 1,
      sym_identifier,
    ACTIONS(5530), 1,
      anon_sym_new,
    STATE(2078), 1,
      sym__new_builtin,
    STATE(2110), 1,
      sym__identifier_or_new,
    STATE(3276), 1,
      sym__type_name,
    STATE(2548), 2,
      sym_comment,
      sym_documentation_comment,
  [127296] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5532), 1,
      anon_sym_RPAREN,
    STATE(196), 1,
      sym__semicolon,
    STATE(2677), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2549), 2,
      sym_comment,
      sym_documentation_comment,
  [127331] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1786), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3255), 1,
      sym_interfaces,
    STATE(2550), 2,
      sym_comment,
      sym_documentation_comment,
  [127366] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5017), 1,
      anon_sym_LPAREN,
    ACTIONS(5534), 1,
      anon_sym_class,
    STATE(2551), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5015), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [127397] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2504), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(3301), 1,
      sym_formal_parameter_list,
    STATE(2552), 2,
      sym_comment,
      sym_documentation_comment,
  [127432] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5536), 1,
      sym_identifier,
    ACTIONS(4404), 2,
      anon_sym_this,
      anon_sym_super,
    ACTIONS(5540), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2553), 2,
      sym_comment,
      sym_documentation_comment,
  [127463] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5544), 1,
      anon_sym_COMMA,
    STATE(2555), 1,
      aux_sym__type_not_void_list_repeat1,
    STATE(2554), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5542), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
  [127494] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5544), 1,
      anon_sym_COMMA,
    STATE(2541), 1,
      aux_sym__type_not_void_list_repeat1,
    STATE(2555), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5546), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
  [127525] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2762), 2,
      anon_sym_LPAREN,
      anon_sym_DOT,
    STATE(2556), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4313), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [127554] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(159), 1,
      anon_sym_this,
    ACTIONS(161), 1,
      anon_sym_super,
    ACTIONS(5548), 1,
      sym_identifier,
    STATE(3538), 1,
      sym_super,
    STATE(3551), 1,
      sym_this,
    STATE(2557), 2,
      sym_comment,
      sym_documentation_comment,
  [127589] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2558), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5382), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [127616] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(892), 1,
      anon_sym_case,
    ACTIONS(4745), 1,
      sym_identifier,
    STATE(416), 1,
      sym_case_builtin,
    STATE(2529), 1,
      aux_sym_switch_statement_case_repeat1,
    STATE(2691), 1,
      sym_label,
    STATE(2559), 2,
      sym_comment,
      sym_documentation_comment,
  [127651] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2504), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(2560), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5550), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [127682] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(5554), 1,
      anon_sym_EQ,
    ACTIONS(5556), 1,
      anon_sym_SEMI,
    ACTIONS(5558), 1,
      anon_sym_in,
    STATE(2673), 1,
      aux_sym_initialized_identifier_list_repeat1,
    STATE(2561), 2,
      sym_comment,
      sym_documentation_comment,
  [127717] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5448), 1,
      anon_sym_COLON,
    STATE(2562), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5446), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [127746] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1775), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3042), 1,
      sym_interfaces,
    STATE(2563), 2,
      sym_comment,
      sym_documentation_comment,
  [127781] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1731), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3253), 1,
      sym_interfaces,
    STATE(2564), 2,
      sym_comment,
      sym_documentation_comment,
  [127816] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5560), 1,
      anon_sym_COLON,
    STATE(519), 1,
      sym__semicolon,
    ACTIONS(5446), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2565), 2,
      sym_comment,
      sym_documentation_comment,
  [127849] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(5562), 1,
      sym_identifier,
    STATE(2395), 1,
      sym__set,
    STATE(2469), 1,
      sym__get,
    STATE(2566), 2,
      sym_comment,
      sym_documentation_comment,
  [127884] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(47), 1,
      anon_sym_get,
    ACTIONS(61), 1,
      anon_sym_set,
    ACTIONS(5562), 1,
      sym_identifier,
    STATE(2395), 1,
      sym__set,
    STATE(2400), 1,
      sym__get,
    STATE(2567), 2,
      sym_comment,
      sym_documentation_comment,
  [127919] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5483), 1,
      anon_sym_async,
    STATE(2568), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5479), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_async_STAR,
      anon_sym_sync_STAR,
  [127948] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2569), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5440), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [127975] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2570), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5301), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [128002] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1735), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3147), 1,
      sym_interfaces,
    STATE(2571), 2,
      sym_comment,
      sym_documentation_comment,
  [128037] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1749), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3157), 1,
      sym_interfaces,
    STATE(2572), 2,
      sym_comment,
      sym_documentation_comment,
  [128072] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2573), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5360), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [128099] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1761), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3166), 1,
      sym_interfaces,
    STATE(2574), 2,
      sym_comment,
      sym_documentation_comment,
  [128134] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5564), 1,
      anon_sym_COMMA,
    ACTIONS(5567), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
    STATE(2575), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_inferred_parameters_repeat1,
  [128163] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2552), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(3542), 1,
      sym_formal_parameter_list,
    STATE(2576), 2,
      sym_comment,
      sym_documentation_comment,
  [128198] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2352), 1,
      sym_formal_parameter_list,
    STATE(2504), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(2577), 2,
      sym_comment,
      sym_documentation_comment,
  [128233] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1773), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3186), 1,
      sym_interfaces,
    STATE(2578), 2,
      sym_comment,
      sym_documentation_comment,
  [128268] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5569), 1,
      anon_sym_export,
    ACTIONS(5571), 1,
      anon_sym_import,
    STATE(1576), 1,
      sym_import_specification,
    STATE(1817), 1,
      sym__import,
    STATE(1840), 1,
      sym__export,
    STATE(2579), 2,
      sym_comment,
      sym_documentation_comment,
  [128303] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5515), 1,
      anon_sym_DOT,
    STATE(2560), 1,
      aux_sym_factory_constructor_signature_repeat1,
    STATE(2580), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5573), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
  [128334] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5575), 1,
      sym_identifier,
    ACTIONS(4404), 2,
      anon_sym_this,
      anon_sym_super,
    ACTIONS(5069), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2581), 2,
      sym_comment,
      sym_documentation_comment,
  [128365] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1742), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3047), 1,
      sym_interfaces,
    STATE(2582), 2,
      sym_comment,
      sym_documentation_comment,
  [128400] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2583), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5578), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [128427] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2584), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5580), 5,
      sym__template_chars_single_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [128454] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2585), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5382), 5,
      sym__template_chars_double_single,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR,
      sym__unused_escape_sequence,
  [128481] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    ACTIONS(4586), 1,
      anon_sym_implements,
    STATE(1746), 1,
      sym_class_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3197), 1,
      sym_interfaces,
    STATE(2586), 2,
      sym_comment,
      sym_documentation_comment,
  [128516] = 11,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1752), 1,
      sym_enum_body,
    STATE(2023), 1,
      sym__implements,
    STATE(3193), 1,
      sym_interfaces,
    STATE(2587), 2,
      sym_comment,
      sym_documentation_comment,
  [128551] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2588), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5582), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [128577] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5586), 1,
      anon_sym_else,
    STATE(2589), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5584), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [128605] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2590), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5137), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [128631] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(854), 1,
      sym_hex_integer_literal,
    STATE(2127), 1,
      sym__numeric_literal,
    ACTIONS(852), 2,
      sym_decimal_integer_literal,
      sym_decimal_floating_point_literal,
    STATE(2591), 2,
      sym_comment,
      sym_documentation_comment,
  [128661] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(2356), 1,
      sym_arguments,
    STATE(3118), 1,
      sym__dot_identifier,
    STATE(2592), 2,
      sym_comment,
      sym_documentation_comment,
  [128693] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4584), 1,
      anon_sym_with,
    STATE(3204), 1,
      sym_mixins,
    ACTIONS(5590), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(2593), 2,
      sym_comment,
      sym_documentation_comment,
  [128723] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(3290), 1,
      anon_sym_DOT,
    STATE(836), 1,
      sym_index_selector,
    STATE(871), 1,
      sym_unconditional_assignable_selector,
    STATE(2594), 2,
      sym_comment,
      sym_documentation_comment,
  [128755] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(2397), 1,
      sym_arguments,
    STATE(3061), 1,
      sym__dot_identifier,
    STATE(2595), 2,
      sym_comment,
      sym_documentation_comment,
  [128787] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5592), 1,
      anon_sym_Function,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(2141), 1,
      sym__function_builtin_identifier,
    STATE(2174), 1,
      aux_sym__function_type_tails,
    STATE(2596), 2,
      sym_comment,
      sym_documentation_comment,
  [128819] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2597), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5594), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [128845] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2598), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5596), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [128871] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2599), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5567), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [128897] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2600), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5598), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [128923] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2601), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5600), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [128949] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(4594), 1,
      anon_sym_EQ,
    STATE(2009), 1,
      sym_formal_parameter_list,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2602), 2,
      sym_comment,
      sym_documentation_comment,
  [128981] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5530), 1,
      anon_sym_new,
    ACTIONS(5602), 1,
      sym_identifier,
    STATE(2078), 1,
      sym__new_builtin,
    STATE(2108), 1,
      sym__identifier_or_new,
    STATE(2603), 2,
      sym_comment,
      sym_documentation_comment,
  [129013] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5604), 1,
      anon_sym_EQ,
    STATE(2009), 1,
      sym_formal_parameter_list,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2604), 2,
      sym_comment,
      sym_documentation_comment,
  [129045] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5608), 1,
      anon_sym_COMMA,
    ACTIONS(5606), 2,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(2605), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_list_literal_repeat1,
  [129073] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2606), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5611), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [129099] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(1224), 1,
      sym_arguments,
    STATE(3113), 1,
      sym__dot_identifier,
    STATE(2607), 2,
      sym_comment,
      sym_documentation_comment,
  [129131] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3259), 1,
      anon_sym_Function,
    STATE(1293), 1,
      sym__function_builtin_identifier,
    STATE(1310), 1,
      aux_sym__function_type_tails,
    STATE(1449), 1,
      sym__function_type_tail,
    STATE(2608), 2,
      sym_comment,
      sym_documentation_comment,
  [129163] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2320), 1,
      anon_sym_LBRACK,
    ACTIONS(2325), 1,
      anon_sym_DOT,
    STATE(1205), 1,
      sym_unconditional_assignable_selector,
    STATE(1211), 1,
      sym_index_selector,
    STATE(2609), 2,
      sym_comment,
      sym_documentation_comment,
  [129195] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4791), 1,
      anon_sym_SEMI,
    ACTIONS(5613), 1,
      anon_sym_COLON,
    STATE(2610), 2,
      sym_comment,
      sym_documentation_comment,
    STATE(3314), 2,
      sym_initializers,
      sym_redirection,
  [129225] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    ACTIONS(5615), 1,
      anon_sym_LPAREN,
    STATE(2114), 1,
      sym_arguments,
    STATE(3226), 1,
      sym__dot_identifier,
    STATE(2611), 2,
      sym_comment,
      sym_documentation_comment,
  [129257] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4586), 1,
      anon_sym_implements,
    ACTIONS(5617), 1,
      anon_sym_SEMI,
    STATE(2023), 1,
      sym__implements,
    STATE(3432), 1,
      sym_interfaces,
    STATE(2612), 2,
      sym_comment,
      sym_documentation_comment,
  [129289] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(1144), 1,
      sym_arguments,
    STATE(3231), 1,
      sym__dot_identifier,
    STATE(2613), 2,
      sym_comment,
      sym_documentation_comment,
  [129321] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3498), 1,
      anon_sym_Function,
    STATE(1422), 1,
      sym__function_builtin_identifier,
    STATE(1460), 1,
      aux_sym__function_type_tails,
    STATE(1615), 1,
      sym__function_type_tail,
    STATE(2614), 2,
      sym_comment,
      sym_documentation_comment,
  [129353] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2615), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5619), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [129379] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5623), 1,
      anon_sym_LPAREN,
    STATE(2616), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5621), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [129407] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(5625), 1,
      sym_identifier,
    STATE(3333), 1,
      sym__factory,
    STATE(3520), 1,
      sym_factory_constructor_signature,
    STATE(2617), 2,
      sym_comment,
      sym_documentation_comment,
  [129439] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1707), 1,
      anon_sym_factory,
    ACTIONS(5625), 1,
      sym_identifier,
    STATE(3239), 1,
      sym_factory_constructor_signature,
    STATE(3312), 1,
      sym__factory,
    STATE(2618), 2,
      sym_comment,
      sym_documentation_comment,
  [129471] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(5627), 1,
      sym_identifier,
    ACTIONS(5629), 1,
      anon_sym_on,
    STATE(3453), 1,
      sym_type_parameters,
    STATE(2619), 2,
      sym_comment,
      sym_documentation_comment,
  [129503] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(5631), 1,
      sym_identifier,
    STATE(2078), 1,
      sym__new_builtin,
    STATE(2951), 1,
      sym__identifier_or_new,
    STATE(2620), 2,
      sym_comment,
      sym_documentation_comment,
  [129535] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    ACTIONS(5633), 1,
      anon_sym_DOT,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(3054), 1,
      sym_formal_parameter_list,
    STATE(2621), 2,
      sym_comment,
      sym_documentation_comment,
  [129567] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5637), 1,
      anon_sym_LPAREN,
    STATE(2622), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5635), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [129595] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(1263), 1,
      sym_arguments,
    STATE(3106), 1,
      sym__dot_identifier,
    STATE(2623), 2,
      sym_comment,
      sym_documentation_comment,
  [129627] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5639), 1,
      anon_sym_COMMA,
    STATE(184), 1,
      sym__semicolon,
    STATE(2658), 1,
      aux_sym__for_loop_parts_repeat1,
    STATE(2624), 2,
      sym_comment,
      sym_documentation_comment,
  [129659] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2625), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5641), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [129685] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4333), 1,
      anon_sym_LBRACK,
    ACTIONS(4337), 1,
      anon_sym_DOT,
    STATE(1232), 1,
      sym_index_selector,
    STATE(1259), 1,
      sym_unconditional_assignable_selector,
    STATE(2626), 2,
      sym_comment,
      sym_documentation_comment,
  [129717] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2627), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5644), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [129743] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5647), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(5649), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(2628), 2,
      sym_comment,
      sym_documentation_comment,
  [129771] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5653), 1,
      anon_sym_LPAREN,
    STATE(2629), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5651), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [129799] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5655), 1,
      anon_sym_COMMA,
    ACTIONS(5658), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(2630), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_parameter_type_list_repeat1,
  [129827] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5660), 1,
      anon_sym_RBRACE,
    ACTIONS(5662), 1,
      anon_sym_COMMA,
    ACTIONS(5664), 1,
      anon_sym_SEMI,
    STATE(2641), 1,
      aux_sym_enum_body_repeat1,
    STATE(2631), 2,
      sym_comment,
      sym_documentation_comment,
  [129859] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(3036), 1,
      sym_type_bound,
    ACTIONS(5666), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2632), 2,
      sym_comment,
      sym_documentation_comment,
  [129889] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5592), 1,
      anon_sym_Function,
    STATE(1498), 1,
      sym__function_builtin_identifier,
    STATE(1586), 1,
      aux_sym__function_type_tails,
    STATE(1704), 1,
      sym__function_type_tail,
    STATE(2633), 2,
      sym_comment,
      sym_documentation_comment,
  [129921] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(3035), 1,
      sym_type_bound,
    ACTIONS(5668), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2634), 2,
      sym_comment,
      sym_documentation_comment,
  [129951] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    ACTIONS(3352), 1,
      anon_sym_DOT,
    STATE(1028), 1,
      sym_unconditional_assignable_selector,
    STATE(1034), 1,
      sym_index_selector,
    STATE(2635), 2,
      sym_comment,
      sym_documentation_comment,
  [129983] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(5602), 1,
      sym_identifier,
    STATE(2078), 1,
      sym__new_builtin,
    STATE(2973), 1,
      sym__identifier_or_new,
    STATE(2636), 2,
      sym_comment,
      sym_documentation_comment,
  [130015] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(5670), 1,
      sym_identifier,
    ACTIONS(5672), 1,
      anon_sym_on,
    STATE(3308), 1,
      sym_type_parameters,
    STATE(2637), 2,
      sym_comment,
      sym_documentation_comment,
  [130047] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2417), 1,
      anon_sym_Function,
    STATE(766), 1,
      aux_sym__function_type_tails,
    STATE(777), 1,
      sym__function_builtin_identifier,
    STATE(868), 1,
      sym__function_type_tail,
    STATE(2638), 2,
      sym_comment,
      sym_documentation_comment,
  [130079] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5674), 1,
      sym_identifier,
    STATE(2639), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5676), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [130107] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5680), 1,
      anon_sym_LPAREN,
    STATE(2640), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5678), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [130135] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1883), 1,
      anon_sym_RBRACE,
    ACTIONS(5102), 1,
      anon_sym_SEMI,
    ACTIONS(5682), 1,
      anon_sym_COMMA,
    STATE(2655), 1,
      aux_sym_enum_body_repeat1,
    STATE(2641), 2,
      sym_comment,
      sym_documentation_comment,
  [130167] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    ACTIONS(4309), 1,
      anon_sym_DOT,
    STATE(906), 1,
      sym_index_selector,
    STATE(1018), 1,
      sym_unconditional_assignable_selector,
    STATE(2642), 2,
      sym_comment,
      sym_documentation_comment,
  [130199] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2643), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5519), 4,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_implements,
  [130225] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(5684), 1,
      sym_identifier,
    STATE(2078), 1,
      sym__new_builtin,
    STATE(3235), 1,
      sym__identifier_or_new,
    STATE(2644), 2,
      sym_comment,
      sym_documentation_comment,
  [130257] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5688), 1,
      anon_sym_else,
    STATE(2645), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5686), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [130285] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(5690), 1,
      sym_identifier,
    STATE(2078), 1,
      sym__new_builtin,
    STATE(3235), 1,
      sym__identifier_or_new,
    STATE(2646), 2,
      sym_comment,
      sym_documentation_comment,
  [130317] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(3008), 1,
      sym_type_bound,
    ACTIONS(5692), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2647), 2,
      sym_comment,
      sym_documentation_comment,
  [130347] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    ACTIONS(4309), 1,
      anon_sym_DOT,
    STATE(906), 1,
      sym_index_selector,
    STATE(920), 1,
      sym_unconditional_assignable_selector,
    STATE(2648), 2,
      sym_comment,
      sym_documentation_comment,
  [130379] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3389), 1,
      anon_sym_Function,
    STATE(1336), 1,
      sym__function_builtin_identifier,
    STATE(1363), 1,
      aux_sym__function_type_tails,
    STATE(1551), 1,
      sym__function_type_tail,
    STATE(2649), 2,
      sym_comment,
      sym_documentation_comment,
  [130411] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(1182), 1,
      sym_arguments,
    STATE(3238), 1,
      sym__dot_identifier,
    STATE(2650), 2,
      sym_comment,
      sym_documentation_comment,
  [130443] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5674), 1,
      sym_identifier,
    STATE(2651), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5694), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [130471] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5696), 1,
      anon_sym_LBRACE,
    ACTIONS(5698), 1,
      anon_sym_catch,
    STATE(484), 1,
      sym_block,
    STATE(3090), 1,
      sym_catch_clause,
    STATE(2652), 2,
      sym_comment,
      sym_documentation_comment,
  [130503] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4739), 1,
      anon_sym_extends,
    STATE(3270), 1,
      sym_type_bound,
    ACTIONS(5459), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(2653), 2,
      sym_comment,
      sym_documentation_comment,
  [130533] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5700), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(5702), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(2654), 2,
      sym_comment,
      sym_documentation_comment,
  [130561] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5706), 1,
      anon_sym_COMMA,
    ACTIONS(5704), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    STATE(2655), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_enum_body_repeat1,
  [130589] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACK,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    STATE(1090), 1,
      sym_index_selector,
    STATE(1101), 1,
      sym_unconditional_assignable_selector,
    STATE(2656), 2,
      sym_comment,
      sym_documentation_comment,
  [130621] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(963), 1,
      sym_arguments,
    STATE(3050), 1,
      sym__dot_identifier,
    STATE(2657), 2,
      sym_comment,
      sym_documentation_comment,
  [130653] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5639), 1,
      anon_sym_COMMA,
    STATE(188), 1,
      sym__semicolon,
    STATE(2711), 1,
      aux_sym__for_loop_parts_repeat1,
    STATE(2658), 2,
      sym_comment,
      sym_documentation_comment,
  [130685] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5711), 1,
      anon_sym_LPAREN,
    STATE(2659), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5709), 3,
      sym_void_type,
      anon_sym_Function,
      sym_identifier,
  [130713] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2660), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5446), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_else,
  [130739] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4422), 1,
      anon_sym_LPAREN,
    ACTIONS(4424), 1,
      anon_sym_DOT,
    STATE(3211), 1,
      sym_type_arguments,
    STATE(2661), 2,
      sym_comment,
      sym_documentation_comment,
  [130771] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5713), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(5715), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    STATE(2662), 2,
      sym_comment,
      sym_documentation_comment,
  [130799] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4422), 1,
      anon_sym_LPAREN,
    ACTIONS(5717), 1,
      anon_sym_DOT,
    STATE(3137), 1,
      sym_type_arguments,
    STATE(2663), 2,
      sym_comment,
      sym_documentation_comment,
  [130831] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2724), 1,
      anon_sym_Function,
    STATE(851), 1,
      sym__function_builtin_identifier,
    STATE(878), 1,
      aux_sym__function_type_tails,
    STATE(1071), 1,
      sym__function_type_tail,
    STATE(2664), 2,
      sym_comment,
      sym_documentation_comment,
  [130863] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5721), 1,
      anon_sym_RBRACE,
    STATE(2665), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5719), 3,
      anon_sym_default,
      anon_sym_case,
      sym_identifier,
  [130891] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5725), 1,
      anon_sym_when,
    STATE(2666), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5723), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
  [130919] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(5554), 1,
      anon_sym_EQ,
    ACTIONS(5556), 1,
      anon_sym_SEMI,
    STATE(2673), 1,
      aux_sym_initialized_identifier_list_repeat1,
    STATE(2667), 2,
      sym_comment,
      sym_documentation_comment,
  [130951] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACK,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    STATE(1090), 1,
      sym_index_selector,
    STATE(1100), 1,
      sym_unconditional_assignable_selector,
    STATE(2668), 2,
      sym_comment,
      sym_documentation_comment,
  [130983] = 10,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_DOT,
    STATE(911), 1,
      sym_arguments,
    STATE(3017), 1,
      sym__dot_identifier,
    STATE(2669), 2,
      sym_comment,
      sym_documentation_comment,
  [131015] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5727), 1,
      anon_sym_COMMA,
    ACTIONS(5729), 1,
      anon_sym_RPAREN,
    STATE(2751), 1,
      aux_sym_record_type_repeat1,
    STATE(2670), 2,
      sym_comment,
      sym_documentation_comment,
  [131044] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5106), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2526), 1,
      sym__native,
    STATE(2671), 2,
      sym_comment,
      sym_documentation_comment,
  [131073] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5731), 1,
      anon_sym_RBRACE,
    ACTIONS(5733), 1,
      anon_sym_COMMA,
    STATE(2678), 1,
      aux_sym_record_type_repeat2,
    STATE(2672), 2,
      sym_comment,
      sym_documentation_comment,
  [131102] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(5735), 1,
      anon_sym_SEMI,
    STATE(2707), 1,
      aux_sym_initialized_identifier_list_repeat1,
    STATE(2673), 2,
      sym_comment,
      sym_documentation_comment,
  [131131] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(590), 1,
      anon_sym_RBRACK,
    ACTIONS(5737), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2674), 2,
      sym_comment,
      sym_documentation_comment,
  [131160] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5173), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2492), 1,
      sym__native,
    STATE(2675), 2,
      sym_comment,
      sym_documentation_comment,
  [131189] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5222), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2493), 1,
      sym__native,
    STATE(2676), 2,
      sym_comment,
      sym_documentation_comment,
  [131218] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5739), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2677), 2,
      sym_comment,
      sym_documentation_comment,
  [131247] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4202), 1,
      anon_sym_RBRACE,
    ACTIONS(5741), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2678), 2,
      sym_comment,
      sym_documentation_comment,
  [131276] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5743), 1,
      anon_sym_RPAREN,
    STATE(2796), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2679), 2,
      sym_comment,
      sym_documentation_comment,
  [131305] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5063), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2460), 1,
      sym__native,
    STATE(2680), 2,
      sym_comment,
      sym_documentation_comment,
  [131334] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5745), 1,
      anon_sym_RBRACE,
    ACTIONS(5747), 1,
      anon_sym_COMMA,
    STATE(2811), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2681), 2,
      sym_comment,
      sym_documentation_comment,
  [131363] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5749), 1,
      anon_sym_COMMA,
    ACTIONS(5752), 1,
      anon_sym_RPAREN,
    STATE(2682), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_record_pattern_repeat1,
  [131390] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5756), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2683), 2,
      sym_comment,
      sym_documentation_comment,
  [131419] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(5758), 1,
      anon_sym_SEMI,
    STATE(2707), 1,
      aux_sym_initialized_identifier_list_repeat1,
    STATE(2684), 2,
      sym_comment,
      sym_documentation_comment,
  [131448] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5760), 1,
      anon_sym_GT,
    STATE(2683), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2685), 2,
      sym_comment,
      sym_documentation_comment,
  [131477] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1021), 1,
      anon_sym_RPAREN,
    ACTIONS(5762), 1,
      anon_sym_COMMA,
    STATE(2682), 1,
      aux_sym_record_pattern_repeat1,
    STATE(2686), 2,
      sym_comment,
      sym_documentation_comment,
  [131506] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5764), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2687), 2,
      sym_comment,
      sym_documentation_comment,
  [131535] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5560), 1,
      anon_sym_COLON,
    ACTIONS(5446), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(2688), 2,
      sym_comment,
      sym_documentation_comment,
  [131562] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5766), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2689), 2,
      sym_comment,
      sym_documentation_comment,
  [131591] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5768), 1,
      sym_identifier,
    ACTIONS(4404), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(2690), 2,
      sym_comment,
      sym_documentation_comment,
  [131618] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2691), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5772), 3,
      anon_sym_default,
      anon_sym_case,
      sym_identifier,
  [131643] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5774), 1,
      anon_sym_GT,
    STATE(2689), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2692), 2,
      sym_comment,
      sym_documentation_comment,
  [131672] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5776), 1,
      sym_identifier,
    STATE(526), 1,
      sym__semicolon,
    STATE(2693), 2,
      sym_comment,
      sym_documentation_comment,
  [131701] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5778), 1,
      anon_sym_COMMA,
    ACTIONS(5781), 1,
      anon_sym_RPAREN,
    STATE(2694), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__record_literal_no_const_repeat1,
  [131728] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3767), 1,
      anon_sym_RPAREN,
    ACTIONS(5783), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2695), 2,
      sym_comment,
      sym_documentation_comment,
  [131757] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2696), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5785), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131782] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5787), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2697), 2,
      sym_comment,
      sym_documentation_comment,
  [131811] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    ACTIONS(5789), 1,
      sym_identifier,
    STATE(544), 1,
      sym__semicolon,
    STATE(2698), 2,
      sym_comment,
      sym_documentation_comment,
  [131840] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(5791), 1,
      anon_sym_DOT,
    STATE(3473), 1,
      sym_type_arguments,
    STATE(2699), 2,
      sym_comment,
      sym_documentation_comment,
  [131869] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(5795), 1,
      anon_sym_GT,
    STATE(2761), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2700), 2,
      sym_comment,
      sym_documentation_comment,
  [131898] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5797), 1,
      anon_sym_COMMA,
    ACTIONS(5799), 1,
      anon_sym_RPAREN,
    STATE(2695), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2701), 2,
      sym_comment,
      sym_documentation_comment,
  [131927] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5801), 1,
      anon_sym_GT,
    STATE(2697), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2702), 2,
      sym_comment,
      sym_documentation_comment,
  [131956] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2703), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5803), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131981] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3073), 1,
      sym_initialized_identifier_list,
    STATE(2704), 2,
      sym_comment,
      sym_documentation_comment,
  [132010] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(5807), 1,
      anon_sym_GT,
    STATE(2700), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2705), 2,
      sym_comment,
      sym_documentation_comment,
  [132039] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4212), 1,
      anon_sym_RPAREN,
    ACTIONS(5809), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_record_type_repeat1,
    STATE(2706), 2,
      sym_comment,
      sym_documentation_comment,
  [132068] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5811), 1,
      anon_sym_COMMA,
    ACTIONS(5814), 1,
      anon_sym_SEMI,
    STATE(2707), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_initialized_identifier_list_repeat1,
  [132095] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5816), 1,
      anon_sym_COMMA,
    ACTIONS(5818), 1,
      anon_sym_RPAREN,
    STATE(2706), 1,
      aux_sym_record_type_repeat1,
    STATE(2708), 2,
      sym_comment,
      sym_documentation_comment,
  [132124] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5820), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2709), 2,
      sym_comment,
      sym_documentation_comment,
  [132153] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5822), 1,
      sym_identifier,
    STATE(3021), 1,
      sym_dotted_identifier_list,
    STATE(3571), 1,
      sym_uri_test,
    STATE(2710), 2,
      sym_comment,
      sym_documentation_comment,
  [132182] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5824), 1,
      anon_sym_COMMA,
    ACTIONS(5827), 1,
      anon_sym_SEMI,
    STATE(2711), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__for_loop_parts_repeat1,
  [132209] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2712), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5829), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [132234] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5831), 1,
      sym_identifier,
    STATE(2916), 1,
      sym_static_final_declaration,
    STATE(3073), 1,
      sym_static_final_declaration_list,
    STATE(2713), 2,
      sym_comment,
      sym_documentation_comment,
  [132263] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4797), 1,
      anon_sym_COMMA,
    ACTIONS(5833), 1,
      anon_sym_SEMI,
    STATE(2575), 1,
      aux_sym_inferred_parameters_repeat1,
    STATE(2714), 2,
      sym_comment,
      sym_documentation_comment,
  [132292] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3765), 1,
      anon_sym_RPAREN,
    ACTIONS(5835), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2715), 2,
      sym_comment,
      sym_documentation_comment,
  [132321] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4797), 1,
      anon_sym_COMMA,
    ACTIONS(4799), 1,
      anon_sym_SEMI,
    STATE(2714), 1,
      aux_sym_inferred_parameters_repeat1,
    STATE(2716), 2,
      sym_comment,
      sym_documentation_comment,
  [132350] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(5837), 1,
      anon_sym_on,
    STATE(3511), 1,
      sym_type_parameters,
    STATE(2717), 2,
      sym_comment,
      sym_documentation_comment,
  [132379] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4222), 1,
      anon_sym_RBRACE,
    ACTIONS(5839), 1,
      anon_sym_COMMA,
    STATE(2724), 1,
      aux_sym_record_type_repeat2,
    STATE(2718), 2,
      sym_comment,
      sym_documentation_comment,
  [132408] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5841), 1,
      anon_sym_RBRACE,
    ACTIONS(5843), 1,
      anon_sym_COMMA,
    STATE(3002), 1,
      aux_sym_named_parameter_types_repeat1,
    STATE(2719), 2,
      sym_comment,
      sym_documentation_comment,
  [132437] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2921), 1,
      sym_formal_parameter_list,
    STATE(2720), 2,
      sym_comment,
      sym_documentation_comment,
  [132466] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5845), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2721), 2,
      sym_comment,
      sym_documentation_comment,
  [132495] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5847), 1,
      anon_sym_COMMA,
    ACTIONS(5849), 1,
      anon_sym_RBRACK,
    STATE(3004), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2722), 2,
      sym_comment,
      sym_documentation_comment,
  [132524] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5851), 1,
      anon_sym_GT,
    STATE(2709), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2723), 2,
      sym_comment,
      sym_documentation_comment,
  [132553] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4232), 1,
      anon_sym_RBRACE,
    ACTIONS(5853), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2724), 2,
      sym_comment,
      sym_documentation_comment,
  [132582] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4232), 1,
      anon_sym_RBRACE,
    ACTIONS(5853), 1,
      anon_sym_COMMA,
    STATE(2739), 1,
      aux_sym_record_type_repeat2,
    STATE(2725), 2,
      sym_comment,
      sym_documentation_comment,
  [132611] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5147), 1,
      anon_sym_SEMI,
    ACTIONS(5855), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      aux_sym_initializers_repeat1,
    STATE(2726), 2,
      sym_comment,
      sym_documentation_comment,
  [132640] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2727), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5694), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [132665] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3755), 1,
      anon_sym_RPAREN,
    ACTIONS(5857), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2728), 2,
      sym_comment,
      sym_documentation_comment,
  [132694] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(5859), 1,
      anon_sym_GT,
    STATE(2761), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2729), 2,
      sym_comment,
      sym_documentation_comment,
  [132723] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5861), 1,
      anon_sym_COMMA,
    ACTIONS(5863), 1,
      anon_sym_RPAREN,
    STATE(2715), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2730), 2,
      sym_comment,
      sym_documentation_comment,
  [132752] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2940), 1,
      sym_formal_parameter_list,
    STATE(2731), 2,
      sym_comment,
      sym_documentation_comment,
  [132781] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(5865), 1,
      anon_sym_GT,
    STATE(2721), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2732), 2,
      sym_comment,
      sym_documentation_comment,
  [132810] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2733), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5867), 3,
      anon_sym_SEMI,
      anon_sym_show,
      anon_sym_hide,
  [132835] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5869), 1,
      anon_sym_RBRACE,
    ACTIONS(5871), 1,
      anon_sym_COMMA,
    STATE(2734), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_record_type_repeat2,
  [132862] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4148), 1,
      anon_sym_RBRACE,
    ACTIONS(5874), 1,
      anon_sym_COMMA,
    STATE(2969), 1,
      aux_sym_record_type_repeat2,
    STATE(2735), 2,
      sym_comment,
      sym_documentation_comment,
  [132891] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(642), 1,
      anon_sym_RPAREN,
    ACTIONS(5876), 1,
      anon_sym_COMMA,
    STATE(2983), 1,
      aux_sym__argument_list_repeat1,
    STATE(2736), 2,
      sym_comment,
      sym_documentation_comment,
  [132920] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3104), 1,
      sym_initialized_identifier_list,
    STATE(2737), 2,
      sym_comment,
      sym_documentation_comment,
  [132949] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(5878), 1,
      anon_sym_GT,
    STATE(2729), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2738), 2,
      sym_comment,
      sym_documentation_comment,
  [132978] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4234), 1,
      anon_sym_RBRACE,
    ACTIONS(5880), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2739), 2,
      sym_comment,
      sym_documentation_comment,
  [133007] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(614), 1,
      anon_sym_RBRACE,
    ACTIONS(5882), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2740), 2,
      sym_comment,
      sym_documentation_comment,
  [133036] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(5884), 1,
      sym_identifier,
    STATE(3033), 1,
      sym__new_builtin,
    STATE(2741), 2,
      sym_comment,
      sym_documentation_comment,
  [133065] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2742), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5886), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [133090] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(5888), 1,
      anon_sym_DOT,
    STATE(943), 1,
      sym_arguments,
    STATE(2743), 2,
      sym_comment,
      sym_documentation_comment,
  [133119] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(5890), 1,
      sym_identifier,
    STATE(3066), 1,
      sym__new_builtin,
    STATE(2744), 2,
      sym_comment,
      sym_documentation_comment,
  [133148] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1009), 1,
      anon_sym_RPAREN,
    ACTIONS(5892), 1,
      anon_sym_COMMA,
    STATE(2682), 1,
      aux_sym_record_pattern_repeat1,
    STATE(2745), 2,
      sym_comment,
      sym_documentation_comment,
  [133177] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(558), 1,
      anon_sym_RBRACK,
    ACTIONS(5894), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2746), 2,
      sym_comment,
      sym_documentation_comment,
  [133206] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(612), 1,
      anon_sym_RBRACE,
    ACTIONS(5896), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2747), 2,
      sym_comment,
      sym_documentation_comment,
  [133235] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(612), 1,
      anon_sym_RBRACK,
    ACTIONS(5898), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2748), 2,
      sym_comment,
      sym_documentation_comment,
  [133264] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(612), 1,
      anon_sym_RBRACE,
    ACTIONS(5896), 1,
      anon_sym_COMMA,
    STATE(2854), 1,
      aux_sym_list_literal_repeat1,
    STATE(2749), 2,
      sym_comment,
      sym_documentation_comment,
  [133293] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5900), 1,
      anon_sym_COMMA,
    ACTIONS(5903), 1,
      anon_sym_RPAREN,
    STATE(2963), 1,
      aux_sym__normal_formal_parameters_repeat1,
    STATE(2750), 2,
      sym_comment,
      sym_documentation_comment,
  [133322] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4272), 1,
      anon_sym_RPAREN,
    ACTIONS(5905), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_record_type_repeat1,
    STATE(2751), 2,
      sym_comment,
      sym_documentation_comment,
  [133351] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(612), 1,
      anon_sym_RBRACK,
    ACTIONS(5898), 1,
      anon_sym_COMMA,
    STATE(2855), 1,
      aux_sym_list_literal_repeat1,
    STATE(2752), 2,
      sym_comment,
      sym_documentation_comment,
  [133380] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5907), 1,
      anon_sym_COMMA,
    ACTIONS(5910), 1,
      anon_sym_RBRACK,
    STATE(2753), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_list_pattern_repeat1,
  [133407] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5912), 1,
      anon_sym_COMMA,
    ACTIONS(5914), 1,
      anon_sym_RPAREN,
    STATE(2886), 1,
      aux_sym_record_pattern_repeat1,
    STATE(2754), 2,
      sym_comment,
      sym_documentation_comment,
  [133436] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2755), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4130), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [133461] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5916), 1,
      sym_identifier,
    ACTIONS(4404), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(2756), 2,
      sym_comment,
      sym_documentation_comment,
  [133488] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(594), 1,
      anon_sym_RBRACE,
    ACTIONS(5919), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2757), 2,
      sym_comment,
      sym_documentation_comment,
  [133517] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5921), 1,
      anon_sym_RBRACE,
    ACTIONS(5923), 1,
      anon_sym_COMMA,
    STATE(2758), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_switch_expression_repeat1,
  [133544] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5926), 1,
      anon_sym_COMMA,
    ACTIONS(5928), 1,
      anon_sym_RPAREN,
    STATE(2728), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2759), 2,
      sym_comment,
      sym_documentation_comment,
  [133573] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2760), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5930), 3,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
  [133598] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    ACTIONS(5935), 1,
      anon_sym_GT,
    STATE(2761), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_type_parameters_repeat1,
  [133625] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5937), 1,
      anon_sym_RBRACE,
    ACTIONS(5939), 1,
      anon_sym_COMMA,
    STATE(2768), 1,
      aux_sym_record_type_repeat2,
    STATE(2762), 2,
      sym_comment,
      sym_documentation_comment,
  [133654] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5941), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2763), 2,
      sym_comment,
      sym_documentation_comment,
  [133683] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5943), 1,
      anon_sym_RPAREN,
    STATE(2857), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2764), 2,
      sym_comment,
      sym_documentation_comment,
  [133712] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5945), 1,
      anon_sym_COMMA,
    ACTIONS(5947), 1,
      anon_sym_SEMI,
    STATE(2976), 1,
      aux_sym_static_final_declaration_list_repeat1,
    STATE(2765), 2,
      sym_comment,
      sym_documentation_comment,
  [133741] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(608), 1,
      anon_sym_RBRACK,
    ACTIONS(5949), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2766), 2,
      sym_comment,
      sym_documentation_comment,
  [133770] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4955), 1,
      anon_sym_class,
    ACTIONS(4961), 1,
      anon_sym_mixin,
    STATE(3053), 1,
      sym_mixin,
    STATE(2767), 2,
      sym_comment,
      sym_documentation_comment,
  [133799] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4254), 1,
      anon_sym_RBRACE,
    ACTIONS(5951), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2768), 2,
      sym_comment,
      sym_documentation_comment,
  [133828] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5242), 1,
      anon_sym_LBRACE,
    ACTIONS(5953), 1,
      anon_sym_EQ_GT,
    STATE(921), 1,
      sym_block,
    STATE(2769), 2,
      sym_comment,
      sym_documentation_comment,
  [133857] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2770), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5676), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [133882] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(989), 1,
      anon_sym_RBRACK,
    ACTIONS(5955), 1,
      anon_sym_COMMA,
    STATE(2863), 1,
      aux_sym_list_pattern_repeat1,
    STATE(2771), 2,
      sym_comment,
      sym_documentation_comment,
  [133911] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5957), 1,
      anon_sym_RPAREN,
    STATE(2861), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2772), 2,
      sym_comment,
      sym_documentation_comment,
  [133940] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2378), 1,
      anon_sym_RBRACE,
    ACTIONS(5959), 1,
      anon_sym_COMMA,
    STATE(2979), 1,
      aux_sym__named_formal_parameters_repeat1,
    STATE(2773), 2,
      sym_comment,
      sym_documentation_comment,
  [133969] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(588), 1,
      anon_sym_RBRACK,
    ACTIONS(5961), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2774), 2,
      sym_comment,
      sym_documentation_comment,
  [133998] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(578), 1,
      anon_sym_RBRACE,
    ACTIONS(5963), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2775), 2,
      sym_comment,
      sym_documentation_comment,
  [134027] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5965), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2776), 2,
      sym_comment,
      sym_documentation_comment,
  [134056] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2580), 1,
      anon_sym_RBRACK,
    ACTIONS(5967), 1,
      anon_sym_COMMA,
    STATE(2964), 1,
      aux_sym_positional_parameters_repeat1,
    STATE(2777), 2,
      sym_comment,
      sym_documentation_comment,
  [134085] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(5969), 1,
      anon_sym_GT,
    STATE(2993), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2778), 2,
      sym_comment,
      sym_documentation_comment,
  [134114] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2154), 1,
      anon_sym_QMARK,
    ACTIONS(5971), 1,
      sym_identifier,
    STATE(2509), 1,
      sym_nullable_type,
    STATE(2779), 2,
      sym_comment,
      sym_documentation_comment,
  [134143] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1017), 1,
      anon_sym_RBRACE,
    ACTIONS(5973), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2780), 2,
      sym_comment,
      sym_documentation_comment,
  [134172] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(5975), 1,
      anon_sym_RPAREN,
    STATE(2866), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2781), 2,
      sym_comment,
      sym_documentation_comment,
  [134201] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(572), 1,
      anon_sym_RBRACK,
    ACTIONS(5977), 1,
      anon_sym_COMMA,
    STATE(2774), 1,
      aux_sym_list_literal_repeat1,
    STATE(2782), 2,
      sym_comment,
      sym_documentation_comment,
  [134230] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2783), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5979), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_identifier,
  [134255] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(562), 1,
      anon_sym_RBRACE,
    ACTIONS(5981), 1,
      anon_sym_COMMA,
    STATE(2775), 1,
      aux_sym_list_literal_repeat1,
    STATE(2784), 2,
      sym_comment,
      sym_documentation_comment,
  [134284] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(572), 1,
      anon_sym_RBRACK,
    ACTIONS(5977), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2785), 2,
      sym_comment,
      sym_documentation_comment,
  [134313] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(526), 1,
      anon_sym_RBRACK,
    ACTIONS(5983), 1,
      anon_sym_COMMA,
    STATE(2862), 1,
      aux_sym_list_literal_repeat1,
    STATE(2786), 2,
      sym_comment,
      sym_documentation_comment,
  [134342] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(562), 1,
      anon_sym_RBRACE,
    ACTIONS(5981), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2787), 2,
      sym_comment,
      sym_documentation_comment,
  [134371] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5985), 1,
      anon_sym_COMMA,
    ACTIONS(5988), 1,
      anon_sym_RPAREN,
    STATE(2788), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__normal_formal_parameters_repeat1,
  [134398] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2789), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5990), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [134423] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(594), 1,
      anon_sym_RBRACE,
    ACTIONS(5919), 1,
      anon_sym_COMMA,
    STATE(2839), 1,
      aux_sym_list_literal_repeat1,
    STATE(2790), 2,
      sym_comment,
      sym_documentation_comment,
  [134452] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5992), 1,
      anon_sym_COMMA,
    ACTIONS(5994), 1,
      anon_sym_RBRACK,
    STATE(2777), 1,
      aux_sym_positional_parameters_repeat1,
    STATE(2791), 2,
      sym_comment,
      sym_documentation_comment,
  [134481] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5996), 1,
      anon_sym_RBRACE,
    ACTIONS(5998), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2792), 2,
      sym_comment,
      sym_documentation_comment,
  [134510] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6000), 1,
      anon_sym_COMMA,
    ACTIONS(6003), 1,
      anon_sym_RPAREN,
    STATE(2793), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__for_loop_parts_repeat2,
  [134537] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6005), 1,
      anon_sym_COMMA,
    ACTIONS(6007), 1,
      anon_sym_RPAREN,
    STATE(2810), 1,
      aux_sym_record_type_repeat1,
    STATE(2794), 2,
      sym_comment,
      sym_documentation_comment,
  [134566] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(608), 1,
      anon_sym_RBRACK,
    ACTIONS(5949), 1,
      anon_sym_COMMA,
    STATE(2674), 1,
      aux_sym_list_literal_repeat1,
    STATE(2795), 2,
      sym_comment,
      sym_documentation_comment,
  [134595] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6009), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2796), 2,
      sym_comment,
      sym_documentation_comment,
  [134624] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6011), 1,
      anon_sym_COMMA,
    ACTIONS(6013), 1,
      anon_sym_RBRACK,
    STATE(2869), 1,
      aux_sym_list_literal_repeat1,
    STATE(2797), 2,
      sym_comment,
      sym_documentation_comment,
  [134653] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(654), 1,
      anon_sym_RBRACE,
    ACTIONS(6015), 1,
      anon_sym_COMMA,
    STATE(2848), 1,
      aux_sym_map_pattern_repeat1,
    STATE(2798), 2,
      sym_comment,
      sym_documentation_comment,
  [134682] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3520), 1,
      sym_initialized_identifier_list,
    STATE(2799), 2,
      sym_comment,
      sym_documentation_comment,
  [134711] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4256), 1,
      anon_sym_RBRACE,
    ACTIONS(6017), 1,
      anon_sym_COMMA,
    STATE(2815), 1,
      aux_sym_record_type_repeat2,
    STATE(2800), 2,
      sym_comment,
      sym_documentation_comment,
  [134740] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6019), 1,
      anon_sym_RBRACE,
    ACTIONS(6021), 1,
      anon_sym_COMMA,
    STATE(2890), 1,
      aux_sym_list_literal_repeat1,
    STATE(2801), 2,
      sym_comment,
      sym_documentation_comment,
  [134769] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(512), 1,
      anon_sym_RBRACK,
    ACTIONS(6023), 1,
      anon_sym_COMMA,
    STATE(2785), 1,
      aux_sym_list_literal_repeat1,
    STATE(2802), 2,
      sym_comment,
      sym_documentation_comment,
  [134798] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(510), 1,
      anon_sym_RBRACE,
    ACTIONS(6025), 1,
      anon_sym_COMMA,
    STATE(2787), 1,
      aux_sym_list_literal_repeat1,
    STATE(2803), 2,
      sym_comment,
      sym_documentation_comment,
  [134827] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6027), 1,
      anon_sym_RBRACE,
    ACTIONS(6029), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_record_type_repeat2,
    STATE(2804), 2,
      sym_comment,
      sym_documentation_comment,
  [134856] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6031), 1,
      anon_sym_COMMA,
    ACTIONS(6033), 1,
      anon_sym_RPAREN,
    STATE(2694), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(2805), 2,
      sym_comment,
      sym_documentation_comment,
  [134885] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(512), 1,
      anon_sym_RBRACK,
    ACTIONS(6023), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2806), 2,
      sym_comment,
      sym_documentation_comment,
  [134914] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2285), 1,
      sym_formal_parameter_list,
    STATE(2807), 2,
      sym_comment,
      sym_documentation_comment,
  [134943] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6035), 1,
      anon_sym_RBRACE,
    ACTIONS(6037), 1,
      anon_sym_COMMA,
    STATE(2808), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_map_pattern_repeat1,
  [134970] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(510), 1,
      anon_sym_RBRACE,
    ACTIONS(6025), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2809), 2,
      sym_comment,
      sym_documentation_comment,
  [134999] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4220), 1,
      anon_sym_RPAREN,
    ACTIONS(6040), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_record_type_repeat1,
    STATE(2810), 2,
      sym_comment,
      sym_documentation_comment,
  [135028] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1015), 1,
      anon_sym_RBRACE,
    ACTIONS(6042), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2811), 2,
      sym_comment,
      sym_documentation_comment,
  [135057] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3761), 1,
      anon_sym_RPAREN,
    ACTIONS(6044), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2812), 2,
      sym_comment,
      sym_documentation_comment,
  [135086] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(6046), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2813), 2,
      sym_comment,
      sym_documentation_comment,
  [135115] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6048), 1,
      anon_sym_LBRACE,
    ACTIONS(6050), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(6052), 1,
      sym_identifier_dollar_escaped,
    STATE(2814), 2,
      sym_comment,
      sym_documentation_comment,
  [135144] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4258), 1,
      anon_sym_RBRACE,
    ACTIONS(6054), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2815), 2,
      sym_comment,
      sym_documentation_comment,
  [135173] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4258), 1,
      anon_sym_RBRACE,
    ACTIONS(6054), 1,
      anon_sym_COMMA,
    STATE(2821), 1,
      aux_sym_record_type_repeat2,
    STATE(2816), 2,
      sym_comment,
      sym_documentation_comment,
  [135202] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(528), 1,
      anon_sym_RBRACE,
    ACTIONS(6056), 1,
      anon_sym_COMMA,
    STATE(2846), 1,
      aux_sym_list_literal_repeat1,
    STATE(2817), 2,
      sym_comment,
      sym_documentation_comment,
  [135231] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5282), 1,
      anon_sym_LBRACE,
    ACTIONS(6058), 1,
      anon_sym_EQ_GT,
    STATE(1142), 1,
      sym_block,
    STATE(2818), 2,
      sym_comment,
      sym_documentation_comment,
  [135260] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(644), 1,
      anon_sym_RBRACE,
    ACTIONS(6060), 1,
      anon_sym_COMMA,
    STATE(2808), 1,
      aux_sym_map_pattern_repeat1,
    STATE(2819), 2,
      sym_comment,
      sym_documentation_comment,
  [135289] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2820), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(6062), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [135314] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4140), 1,
      anon_sym_RBRACE,
    ACTIONS(6064), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2821), 2,
      sym_comment,
      sym_documentation_comment,
  [135343] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6066), 1,
      sym_identifier,
    ACTIONS(5540), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2822), 2,
      sym_comment,
      sym_documentation_comment,
  [135370] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(6068), 1,
      anon_sym_GT,
    STATE(2851), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2823), 2,
      sym_comment,
      sym_documentation_comment,
  [135399] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(969), 1,
      anon_sym_RBRACK,
    ACTIONS(6070), 1,
      anon_sym_COMMA,
    STATE(2753), 1,
      aux_sym_list_pattern_repeat1,
    STATE(2824), 2,
      sym_comment,
      sym_documentation_comment,
  [135428] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6072), 1,
      anon_sym_RBRACE,
    ACTIONS(6074), 1,
      anon_sym_COMMA,
    STATE(2829), 1,
      aux_sym_record_type_repeat2,
    STATE(2825), 2,
      sym_comment,
      sym_documentation_comment,
  [135457] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(5717), 1,
      anon_sym_DOT,
    STATE(3340), 1,
      sym_type_arguments,
    STATE(2826), 2,
      sym_comment,
      sym_documentation_comment,
  [135486] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6076), 1,
      anon_sym_COMMA,
    ACTIONS(6078), 1,
      anon_sym_RPAREN,
    STATE(2900), 1,
      aux_sym_record_type_repeat1,
    STATE(2827), 2,
      sym_comment,
      sym_documentation_comment,
  [135515] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(514), 1,
      anon_sym_RBRACK,
    ACTIONS(6080), 1,
      anon_sym_COMMA,
    STATE(2806), 1,
      aux_sym_list_literal_repeat1,
    STATE(2828), 2,
      sym_comment,
      sym_documentation_comment,
  [135544] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4268), 1,
      anon_sym_RBRACE,
    ACTIONS(6082), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2829), 2,
      sym_comment,
      sym_documentation_comment,
  [135573] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(516), 1,
      anon_sym_RBRACE,
    ACTIONS(6084), 1,
      anon_sym_COMMA,
    STATE(2809), 1,
      aux_sym_list_literal_repeat1,
    STATE(2830), 2,
      sym_comment,
      sym_documentation_comment,
  [135602] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(6086), 1,
      anon_sym_GT,
    STATE(2761), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2831), 2,
      sym_comment,
      sym_documentation_comment,
  [135631] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6088), 1,
      anon_sym_COMMA,
    ACTIONS(6090), 1,
      anon_sym_RPAREN,
    STATE(2812), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2832), 2,
      sym_comment,
      sym_documentation_comment,
  [135660] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(6092), 1,
      anon_sym_GT,
    STATE(2813), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2833), 2,
      sym_comment,
      sym_documentation_comment,
  [135689] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2834), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(6094), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      sym_identifier,
  [135714] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6096), 1,
      anon_sym_COMMA,
    ACTIONS(6098), 1,
      anon_sym_RBRACK,
    STATE(2748), 1,
      aux_sym_list_literal_repeat1,
    STATE(2835), 2,
      sym_comment,
      sym_documentation_comment,
  [135743] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3178), 1,
      sym_initialized_identifier_list,
    STATE(2836), 2,
      sym_comment,
      sym_documentation_comment,
  [135772] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6098), 1,
      anon_sym_RBRACE,
    ACTIONS(6100), 1,
      anon_sym_COMMA,
    STATE(2747), 1,
      aux_sym_list_literal_repeat1,
    STATE(2837), 2,
      sym_comment,
      sym_documentation_comment,
  [135801] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2838), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5606), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [135826] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(596), 1,
      anon_sym_RBRACE,
    ACTIONS(6102), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2839), 2,
      sym_comment,
      sym_documentation_comment,
  [135855] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5143), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2520), 1,
      sym__native,
    STATE(2840), 2,
      sym_comment,
      sym_documentation_comment,
  [135884] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5153), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2516), 1,
      sym__native,
    STATE(2841), 2,
      sym_comment,
      sym_documentation_comment,
  [135913] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(6104), 1,
      anon_sym_GT,
    STATE(2885), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2842), 2,
      sym_comment,
      sym_documentation_comment,
  [135942] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6106), 1,
      anon_sym_COMMA,
    ACTIONS(6108), 1,
      anon_sym_RPAREN,
    STATE(2887), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2843), 2,
      sym_comment,
      sym_documentation_comment,
  [135971] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4274), 1,
      anon_sym_RBRACE,
    ACTIONS(6110), 1,
      anon_sym_COMMA,
    STATE(2850), 1,
      aux_sym_record_type_repeat2,
    STATE(2844), 2,
      sym_comment,
      sym_documentation_comment,
  [136000] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5212), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2459), 1,
      sym__native,
    STATE(2845), 2,
      sym_comment,
      sym_documentation_comment,
  [136029] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(552), 1,
      anon_sym_RBRACE,
    ACTIONS(6112), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2846), 2,
      sym_comment,
      sym_documentation_comment,
  [136058] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(6114), 1,
      anon_sym_SEMI,
    STATE(2707), 1,
      aux_sym_initialized_identifier_list_repeat1,
    STATE(2847), 2,
      sym_comment,
      sym_documentation_comment,
  [136087] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(646), 1,
      anon_sym_RBRACE,
    ACTIONS(6116), 1,
      anon_sym_COMMA,
    STATE(2808), 1,
      aux_sym_map_pattern_repeat1,
    STATE(2848), 2,
      sym_comment,
      sym_documentation_comment,
  [136116] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(6118), 1,
      anon_sym_GT,
    STATE(2831), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2849), 2,
      sym_comment,
      sym_documentation_comment,
  [136145] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4266), 1,
      anon_sym_RBRACE,
    ACTIONS(6120), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2850), 2,
      sym_comment,
      sym_documentation_comment,
  [136174] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(6122), 1,
      anon_sym_GT,
    STATE(2761), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2851), 2,
      sym_comment,
      sym_documentation_comment,
  [136203] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(618), 1,
      anon_sym_RBRACE,
    ACTIONS(6124), 1,
      anon_sym_COMMA,
    STATE(2891), 1,
      aux_sym_list_literal_repeat1,
    STATE(2852), 2,
      sym_comment,
      sym_documentation_comment,
  [136232] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(616), 1,
      anon_sym_RBRACK,
    ACTIONS(6126), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      aux_sym_list_literal_repeat1,
    STATE(2853), 2,
      sym_comment,
      sym_documentation_comment,
  [136261] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(508), 1,
      anon_sym_RBRACE,
    ACTIONS(6128), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2854), 2,
      sym_comment,
      sym_documentation_comment,
  [136290] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(508), 1,
      anon_sym_RBRACK,
    ACTIONS(6130), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2855), 2,
      sym_comment,
      sym_documentation_comment,
  [136319] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4266), 1,
      anon_sym_RBRACE,
    ACTIONS(6120), 1,
      anon_sym_COMMA,
    STATE(2865), 1,
      aux_sym_record_type_repeat2,
    STATE(2856), 2,
      sym_comment,
      sym_documentation_comment,
  [136348] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6132), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2857), 2,
      sym_comment,
      sym_documentation_comment,
  [136377] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6134), 1,
      anon_sym_RPAREN,
    STATE(2880), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2858), 2,
      sym_comment,
      sym_documentation_comment,
  [136406] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(4424), 1,
      anon_sym_DOT,
    STATE(3454), 1,
      sym_type_arguments,
    STATE(2859), 2,
      sym_comment,
      sym_documentation_comment,
  [136435] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(524), 1,
      anon_sym_RBRACK,
    ACTIONS(6136), 1,
      anon_sym_COMMA,
    STATE(2746), 1,
      aux_sym_list_literal_repeat1,
    STATE(2860), 2,
      sym_comment,
      sym_documentation_comment,
  [136464] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6138), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2861), 2,
      sym_comment,
      sym_documentation_comment,
  [136493] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(556), 1,
      anon_sym_RBRACK,
    ACTIONS(6140), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2862), 2,
      sym_comment,
      sym_documentation_comment,
  [136522] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(991), 1,
      anon_sym_RBRACK,
    ACTIONS(6142), 1,
      anon_sym_COMMA,
    STATE(2753), 1,
      aux_sym_list_pattern_repeat1,
    STATE(2863), 2,
      sym_comment,
      sym_documentation_comment,
  [136551] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6144), 1,
      anon_sym_LBRACE,
    ACTIONS(6146), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(6148), 1,
      sym_identifier_dollar_escaped,
    STATE(2864), 2,
      sym_comment,
      sym_documentation_comment,
  [136580] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4264), 1,
      anon_sym_RBRACE,
    ACTIONS(6150), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2865), 2,
      sym_comment,
      sym_documentation_comment,
  [136609] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6152), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2866), 2,
      sym_comment,
      sym_documentation_comment,
  [136638] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(522), 1,
      anon_sym_RBRACE,
    ACTIONS(6154), 1,
      anon_sym_COMMA,
    STATE(2740), 1,
      aux_sym_list_literal_repeat1,
    STATE(2867), 2,
      sym_comment,
      sym_documentation_comment,
  [136667] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6156), 1,
      sym_identifier,
    ACTIONS(4404), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(2868), 2,
      sym_comment,
      sym_documentation_comment,
  [136694] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(524), 1,
      anon_sym_RBRACK,
    ACTIONS(6136), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2869), 2,
      sym_comment,
      sym_documentation_comment,
  [136723] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4172), 1,
      anon_sym_RPAREN,
    ACTIONS(6159), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_record_type_repeat1,
    STATE(2870), 2,
      sym_comment,
      sym_documentation_comment,
  [136752] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6161), 1,
      anon_sym_COMMA,
    ACTIONS(6163), 1,
      anon_sym_RPAREN,
    STATE(2694), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(2871), 2,
      sym_comment,
      sym_documentation_comment,
  [136781] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6165), 1,
      anon_sym_RBRACE,
    ACTIONS(6167), 1,
      anon_sym_COMMA,
    STATE(2875), 1,
      aux_sym_record_type_repeat2,
    STATE(2872), 2,
      sym_comment,
      sym_documentation_comment,
  [136810] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6169), 1,
      anon_sym_RBRACE,
    ACTIONS(6171), 1,
      anon_sym_COMMA,
    STATE(2873), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_named_parameter_types_repeat1,
  [136837] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6174), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2874), 2,
      sym_comment,
      sym_documentation_comment,
  [136866] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4252), 1,
      anon_sym_RBRACE,
    ACTIONS(6176), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2875), 2,
      sym_comment,
      sym_documentation_comment,
  [136895] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6178), 1,
      anon_sym_LBRACE,
    ACTIONS(6180), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(6182), 1,
      sym_identifier_dollar_escaped,
    STATE(2876), 2,
      sym_comment,
      sym_documentation_comment,
  [136924] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1009), 1,
      anon_sym_RPAREN,
    ACTIONS(5892), 1,
      anon_sym_COMMA,
    STATE(2686), 1,
      aux_sym_record_pattern_repeat1,
    STATE(2877), 2,
      sym_comment,
      sym_documentation_comment,
  [136953] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6184), 1,
      anon_sym_COMMA,
    ACTIONS(6186), 1,
      anon_sym_RPAREN,
    STATE(2870), 1,
      aux_sym_record_type_repeat1,
    STATE(2878), 2,
      sym_comment,
      sym_documentation_comment,
  [136982] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6188), 1,
      anon_sym_RPAREN,
    STATE(2889), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2879), 2,
      sym_comment,
      sym_documentation_comment,
  [137011] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6190), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2880), 2,
      sym_comment,
      sym_documentation_comment,
  [137040] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(6192), 1,
      anon_sym_EQ_GT,
    STATE(2332), 1,
      sym_block,
    STATE(2881), 2,
      sym_comment,
      sym_documentation_comment,
  [137069] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(542), 1,
      anon_sym_RBRACK,
    ACTIONS(6194), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2882), 2,
      sym_comment,
      sym_documentation_comment,
  [137098] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4194), 1,
      anon_sym_RBRACE,
    ACTIONS(6196), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2883), 2,
      sym_comment,
      sym_documentation_comment,
  [137127] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5228), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2508), 1,
      sym__native,
    STATE(2884), 2,
      sym_comment,
      sym_documentation_comment,
  [137156] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(6198), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2885), 2,
      sym_comment,
      sym_documentation_comment,
  [137185] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(999), 1,
      anon_sym_RPAREN,
    ACTIONS(6200), 1,
      anon_sym_COMMA,
    STATE(2682), 1,
      aux_sym_record_pattern_repeat1,
    STATE(2886), 2,
      sym_comment,
      sym_documentation_comment,
  [137214] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3751), 1,
      anon_sym_RPAREN,
    ACTIONS(6202), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2887), 2,
      sym_comment,
      sym_documentation_comment,
  [137243] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(544), 1,
      anon_sym_RBRACE,
    ACTIONS(6204), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2888), 2,
      sym_comment,
      sym_documentation_comment,
  [137272] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6206), 1,
      anon_sym_RPAREN,
    STATE(2793), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2889), 2,
      sym_comment,
      sym_documentation_comment,
  [137301] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(522), 1,
      anon_sym_RBRACE,
    ACTIONS(6154), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2890), 2,
      sym_comment,
      sym_documentation_comment,
  [137330] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(610), 1,
      anon_sym_RBRACE,
    ACTIONS(6208), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2891), 2,
      sym_comment,
      sym_documentation_comment,
  [137359] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1005), 1,
      anon_sym_RBRACE,
    ACTIONS(6210), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2892), 2,
      sym_comment,
      sym_documentation_comment,
  [137388] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(606), 1,
      anon_sym_RBRACK,
    ACTIONS(6212), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2893), 2,
      sym_comment,
      sym_documentation_comment,
  [137417] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6214), 1,
      anon_sym_COMMA,
    ACTIONS(6216), 1,
      anon_sym_RPAREN,
    STATE(2694), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(2894), 2,
      sym_comment,
      sym_documentation_comment,
  [137446] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3511), 1,
      anon_sym_LT,
    ACTIONS(6218), 1,
      anon_sym_on,
    STATE(3294), 1,
      sym_type_parameters,
    STATE(2895), 2,
      sym_comment,
      sym_documentation_comment,
  [137475] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(548), 1,
      anon_sym_RBRACK,
    ACTIONS(6220), 1,
      anon_sym_COMMA,
    STATE(2882), 1,
      aux_sym_list_literal_repeat1,
    STATE(2896), 2,
      sym_comment,
      sym_documentation_comment,
  [137504] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_COMMA,
    STATE(2888), 1,
      aux_sym_list_literal_repeat1,
    STATE(2897), 2,
      sym_comment,
      sym_documentation_comment,
  [137533] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6224), 1,
      sym_identifier,
    ACTIONS(4413), 2,
      anon_sym_this,
      anon_sym_super,
    STATE(2898), 2,
      sym_comment,
      sym_documentation_comment,
  [137560] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(548), 1,
      anon_sym_RBRACK,
    ACTIONS(6220), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2899), 2,
      sym_comment,
      sym_documentation_comment,
  [137589] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4164), 1,
      anon_sym_RPAREN,
    ACTIONS(6227), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_record_type_repeat1,
    STATE(2900), 2,
      sym_comment,
      sym_documentation_comment,
  [137618] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(610), 1,
      anon_sym_RBRACE,
    ACTIONS(6208), 1,
      anon_sym_COMMA,
    STATE(2927), 1,
      aux_sym_list_literal_repeat1,
    STATE(2901), 2,
      sym_comment,
      sym_documentation_comment,
  [137647] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(606), 1,
      anon_sym_RBRACK,
    ACTIONS(6212), 1,
      anon_sym_COMMA,
    STATE(2928), 1,
      aux_sym_list_literal_repeat1,
    STATE(2902), 2,
      sym_comment,
      sym_documentation_comment,
  [137676] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(550), 1,
      anon_sym_RBRACE,
    ACTIONS(6222), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2903), 2,
      sym_comment,
      sym_documentation_comment,
  [137705] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6229), 1,
      anon_sym_RBRACE,
    ACTIONS(6231), 1,
      anon_sym_COMMA,
    STATE(2892), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2904), 2,
      sym_comment,
      sym_documentation_comment,
  [137734] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4246), 1,
      anon_sym_RBRACE,
    ACTIONS(6233), 1,
      anon_sym_COMMA,
    STATE(2907), 1,
      aux_sym_record_type_repeat2,
    STATE(2905), 2,
      sym_comment,
      sym_documentation_comment,
  [137763] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6235), 1,
      sym_identifier,
    ACTIONS(6237), 1,
      anon_sym_new,
    STATE(1157), 1,
      sym__new_builtin,
    STATE(2906), 2,
      sym_comment,
      sym_documentation_comment,
  [137792] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4244), 1,
      anon_sym_RBRACE,
    ACTIONS(6239), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2907), 2,
      sym_comment,
      sym_documentation_comment,
  [137821] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5831), 1,
      sym_identifier,
    STATE(2916), 1,
      sym_static_final_declaration,
    STATE(3546), 1,
      sym_static_final_declaration_list,
    STATE(2908), 2,
      sym_comment,
      sym_documentation_comment,
  [137850] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(506), 1,
      anon_sym_RBRACK,
    ACTIONS(6241), 1,
      anon_sym_COMMA,
    STATE(2899), 1,
      aux_sym_list_literal_repeat1,
    STATE(2909), 2,
      sym_comment,
      sym_documentation_comment,
  [137879] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6243), 1,
      sym_identifier,
    ACTIONS(5069), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2910), 2,
      sym_comment,
      sym_documentation_comment,
  [137906] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(554), 1,
      anon_sym_RBRACE,
    ACTIONS(6245), 1,
      anon_sym_COMMA,
    STATE(2903), 1,
      aux_sym_list_literal_repeat1,
    STATE(2911), 2,
      sym_comment,
      sym_documentation_comment,
  [137935] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4244), 1,
      anon_sym_RBRACE,
    ACTIONS(6239), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      aux_sym_record_type_repeat2,
    STATE(2912), 2,
      sym_comment,
      sym_documentation_comment,
  [137964] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6247), 1,
      anon_sym_COMMA,
    ACTIONS(6249), 1,
      anon_sym_RPAREN,
    STATE(2694), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(2913), 2,
      sym_comment,
      sym_documentation_comment,
  [137993] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6251), 1,
      sym_identifier,
    ACTIONS(6253), 1,
      anon_sym_new,
    STATE(1298), 1,
      sym__new_builtin,
    STATE(2914), 2,
      sym_comment,
      sym_documentation_comment,
  [138022] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(506), 1,
      anon_sym_RBRACK,
    ACTIONS(6241), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2915), 2,
      sym_comment,
      sym_documentation_comment,
  [138051] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5945), 1,
      anon_sym_COMMA,
    ACTIONS(6255), 1,
      anon_sym_SEMI,
    STATE(2765), 1,
      aux_sym_static_final_declaration_list_repeat1,
    STATE(2916), 2,
      sym_comment,
      sym_documentation_comment,
  [138080] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(554), 1,
      anon_sym_RBRACE,
    ACTIONS(6245), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2917), 2,
      sym_comment,
      sym_documentation_comment,
  [138109] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5831), 1,
      sym_identifier,
    STATE(2916), 1,
      sym_static_final_declaration,
    STATE(3264), 1,
      sym_static_final_declaration_list,
    STATE(2918), 2,
      sym_comment,
      sym_documentation_comment,
  [138138] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3775), 1,
      anon_sym_RPAREN,
    ACTIONS(6257), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2919), 2,
      sym_comment,
      sym_documentation_comment,
  [138167] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(6259), 1,
      anon_sym_DOT,
    STATE(2349), 1,
      sym_arguments,
    STATE(2920), 2,
      sym_comment,
      sym_documentation_comment,
  [138196] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5094), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2506), 1,
      sym__native,
    STATE(2921), 2,
      sym_comment,
      sym_documentation_comment,
  [138225] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6261), 1,
      anon_sym_COMMA,
    ACTIONS(6264), 1,
      anon_sym_RPAREN,
    STATE(2922), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_record_type_repeat1,
  [138252] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(6266), 1,
      anon_sym_GT,
    STATE(2989), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2923), 2,
      sym_comment,
      sym_documentation_comment,
  [138281] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4230), 1,
      anon_sym_RBRACE,
    ACTIONS(6268), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2924), 2,
      sym_comment,
      sym_documentation_comment,
  [138310] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6270), 1,
      anon_sym_RBRACE,
    ACTIONS(6272), 1,
      anon_sym_COMMA,
    STATE(2942), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2925), 2,
      sym_comment,
      sym_documentation_comment,
  [138339] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    ACTIONS(6274), 1,
      anon_sym_EQ_GT,
    STATE(1225), 1,
      sym_block,
    STATE(2926), 2,
      sym_comment,
      sym_documentation_comment,
  [138368] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(560), 1,
      anon_sym_RBRACE,
    ACTIONS(6276), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2927), 2,
      sym_comment,
      sym_documentation_comment,
  [138397] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(536), 1,
      anon_sym_RBRACK,
    ACTIONS(6278), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2928), 2,
      sym_comment,
      sym_documentation_comment,
  [138426] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(560), 1,
      anon_sym_RBRACE,
    ACTIONS(6276), 1,
      anon_sym_COMMA,
    STATE(2945), 1,
      aux_sym_list_literal_repeat1,
    STATE(2929), 2,
      sym_comment,
      sym_documentation_comment,
  [138455] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(536), 1,
      anon_sym_RBRACK,
    ACTIONS(6278), 1,
      anon_sym_COMMA,
    STATE(2946), 1,
      aux_sym_list_literal_repeat1,
    STATE(2930), 2,
      sym_comment,
      sym_documentation_comment,
  [138484] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6280), 1,
      anon_sym_COMMA,
    ACTIONS(6282), 1,
      anon_sym_RPAREN,
    STATE(2736), 1,
      aux_sym__argument_list_repeat1,
    STATE(2931), 2,
      sym_comment,
      sym_documentation_comment,
  [138513] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2009), 1,
      sym_formal_parameter_list,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2932), 2,
      sym_comment,
      sym_documentation_comment,
  [138542] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6284), 1,
      anon_sym_RBRACE,
    ACTIONS(6286), 1,
      anon_sym_COMMA,
    STATE(2937), 1,
      aux_sym_record_type_repeat2,
    STATE(2933), 2,
      sym_comment,
      sym_documentation_comment,
  [138571] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3314), 1,
      sym_initialized_identifier_list,
    STATE(2934), 2,
      sym_comment,
      sym_documentation_comment,
  [138600] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3546), 1,
      sym_initialized_identifier_list,
    STATE(2935), 2,
      sym_comment,
      sym_documentation_comment,
  [138629] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2265), 1,
      sym_formal_parameter_list,
    STATE(2936), 2,
      sym_comment,
      sym_documentation_comment,
  [138658] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4208), 1,
      anon_sym_RBRACE,
    ACTIONS(6288), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2937), 2,
      sym_comment,
      sym_documentation_comment,
  [138687] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4200), 1,
      anon_sym_RBRACE,
    ACTIONS(6290), 1,
      anon_sym_COMMA,
    STATE(2948), 1,
      aux_sym_record_type_repeat2,
    STATE(2938), 2,
      sym_comment,
      sym_documentation_comment,
  [138716] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5031), 1,
      anon_sym_SEMI,
    ACTIONS(5855), 1,
      anon_sym_COMMA,
    STATE(2950), 1,
      aux_sym_initializers_repeat1,
    STATE(2939), 2,
      sym_comment,
      sym_documentation_comment,
  [138745] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5037), 1,
      anon_sym_SEMI,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(2446), 1,
      sym__native,
    STATE(2940), 2,
      sym_comment,
      sym_documentation_comment,
  [138774] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(6292), 1,
      anon_sym_DOT,
    STATE(2349), 1,
      sym_arguments,
    STATE(2941), 2,
      sym_comment,
      sym_documentation_comment,
  [138803] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1003), 1,
      anon_sym_RBRACE,
    ACTIONS(6294), 1,
      anon_sym_COMMA,
    STATE(2758), 1,
      aux_sym_switch_expression_repeat1,
    STATE(2942), 2,
      sym_comment,
      sym_documentation_comment,
  [138832] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2943), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4404), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [138857] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(6296), 1,
      sym_identifier,
    STATE(2428), 1,
      sym__new_builtin,
    STATE(2944), 2,
      sym_comment,
      sym_documentation_comment,
  [138886] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(592), 1,
      anon_sym_RBRACE,
    ACTIONS(6298), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2945), 2,
      sym_comment,
      sym_documentation_comment,
  [138915] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(576), 1,
      anon_sym_RBRACK,
    ACTIONS(6300), 1,
      anon_sym_COMMA,
    STATE(2605), 1,
      aux_sym_list_literal_repeat1,
    STATE(2946), 2,
      sym_comment,
      sym_documentation_comment,
  [138944] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(6302), 1,
      anon_sym_DOT,
    STATE(3548), 1,
      sym_arguments,
    STATE(2947), 2,
      sym_comment,
      sym_documentation_comment,
  [138973] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4188), 1,
      anon_sym_RBRACE,
    ACTIONS(6304), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2948), 2,
      sym_comment,
      sym_documentation_comment,
  [139002] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3161), 1,
      anon_sym_LT,
    ACTIONS(6306), 1,
      anon_sym_DOT,
    STATE(3476), 1,
      sym_type_arguments,
    STATE(2949), 2,
      sym_comment,
      sym_documentation_comment,
  [139031] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5112), 1,
      anon_sym_SEMI,
    ACTIONS(6308), 1,
      anon_sym_COMMA,
    STATE(2950), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_initializers_repeat1,
  [139058] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(2337), 1,
      sym_formal_parameter_list,
    STATE(2951), 2,
      sym_comment,
      sym_documentation_comment,
  [139087] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5509), 1,
      anon_sym_COMMA,
    ACTIONS(6311), 1,
      anon_sym_RPAREN,
    STATE(2874), 1,
      aux_sym__for_loop_parts_repeat2,
    STATE(2952), 2,
      sym_comment,
      sym_documentation_comment,
  [139116] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(552), 1,
      anon_sym_RBRACE,
    ACTIONS(6112), 1,
      anon_sym_COMMA,
    STATE(2757), 1,
      aux_sym_list_literal_repeat1,
    STATE(2953), 2,
      sym_comment,
      sym_documentation_comment,
  [139145] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(556), 1,
      anon_sym_RBRACK,
    ACTIONS(6140), 1,
      anon_sym_COMMA,
    STATE(2766), 1,
      aux_sym_list_literal_repeat1,
    STATE(2954), 2,
      sym_comment,
      sym_documentation_comment,
  [139174] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(564), 1,
      anon_sym_RBRACK,
    ACTIONS(6313), 1,
      anon_sym_COMMA,
    STATE(2915), 1,
      aux_sym_list_literal_repeat1,
    STATE(2955), 2,
      sym_comment,
      sym_documentation_comment,
  [139203] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(566), 1,
      anon_sym_RBRACE,
    ACTIONS(6315), 1,
      anon_sym_COMMA,
    STATE(2917), 1,
      aux_sym_list_literal_repeat1,
    STATE(2956), 2,
      sym_comment,
      sym_documentation_comment,
  [139232] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4961), 1,
      anon_sym_mixin,
    ACTIONS(6317), 1,
      anon_sym_class,
    STATE(3493), 1,
      sym_mixin,
    STATE(2957), 2,
      sym_comment,
      sym_documentation_comment,
  [139261] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(6319), 1,
      anon_sym_GT,
    STATE(2761), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2958), 2,
      sym_comment,
      sym_documentation_comment,
  [139290] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6321), 1,
      anon_sym_COMMA,
    ACTIONS(6323), 1,
      anon_sym_RPAREN,
    STATE(2919), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(2959), 2,
      sym_comment,
      sym_documentation_comment,
  [139319] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5754), 1,
      anon_sym_COMMA,
    ACTIONS(6325), 1,
      anon_sym_GT,
    STATE(2923), 1,
      aux_sym_type_arguments_repeat1,
    STATE(2960), 2,
      sym_comment,
      sym_documentation_comment,
  [139348] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4188), 1,
      anon_sym_RBRACE,
    ACTIONS(6304), 1,
      anon_sym_COMMA,
    STATE(2967), 1,
      aux_sym_record_type_repeat2,
    STATE(2961), 2,
      sym_comment,
      sym_documentation_comment,
  [139377] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3302), 1,
      sym_initialized_identifier_list,
    STATE(2962), 2,
      sym_comment,
      sym_documentation_comment,
  [139406] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6327), 1,
      anon_sym_COMMA,
    ACTIONS(6330), 1,
      anon_sym_RPAREN,
    STATE(2788), 1,
      aux_sym__normal_formal_parameters_repeat1,
    STATE(2963), 2,
      sym_comment,
      sym_documentation_comment,
  [139435] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6332), 1,
      anon_sym_COMMA,
    ACTIONS(6335), 1,
      anon_sym_RBRACK,
    STATE(2964), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_positional_parameters_repeat1,
  [139462] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2965), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(6337), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [139487] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(6339), 1,
      anon_sym_GT,
    STATE(2958), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2966), 2,
      sym_comment,
      sym_documentation_comment,
  [139516] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4178), 1,
      anon_sym_RBRACE,
    ACTIONS(6341), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2967), 2,
      sym_comment,
      sym_documentation_comment,
  [139545] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(6343), 1,
      sym_identifier,
    STATE(3236), 1,
      sym__new_builtin,
    STATE(2968), 2,
      sym_comment,
      sym_documentation_comment,
  [139574] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4196), 1,
      anon_sym_RBRACE,
    ACTIONS(6345), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(2969), 2,
      sym_comment,
      sym_documentation_comment,
  [139603] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(2991), 1,
      sym_initialized_identifier,
    STATE(3264), 1,
      sym_initialized_identifier_list,
    STATE(2970), 2,
      sym_comment,
      sym_documentation_comment,
  [139632] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2971), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(6347), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
  [139657] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(991), 1,
      anon_sym_RBRACK,
    ACTIONS(6142), 1,
      anon_sym_COMMA,
    STATE(2824), 1,
      aux_sym_list_pattern_repeat1,
    STATE(2972), 2,
      sym_comment,
      sym_documentation_comment,
  [139686] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4278), 1,
      anon_sym_LPAREN,
    STATE(2016), 1,
      sym__strict_formal_parameter_list,
    STATE(3230), 1,
      sym_formal_parameter_list,
    STATE(2973), 2,
      sym_comment,
      sym_documentation_comment,
  [139715] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4196), 1,
      anon_sym_RBRACE,
    ACTIONS(6345), 1,
      anon_sym_COMMA,
    STATE(3000), 1,
      aux_sym_record_type_repeat2,
    STATE(2974), 2,
      sym_comment,
      sym_documentation_comment,
  [139744] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4947), 1,
      anon_sym_EQ,
    ACTIONS(4945), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(2975), 2,
      sym_comment,
      sym_documentation_comment,
  [139771] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6349), 1,
      anon_sym_COMMA,
    ACTIONS(6352), 1,
      anon_sym_SEMI,
    STATE(2976), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_static_final_declaration_list_repeat1,
  [139798] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4156), 1,
      anon_sym_RPAREN,
    ACTIONS(6354), 1,
      anon_sym_COMMA,
    STATE(2922), 1,
      aux_sym_record_type_repeat1,
    STATE(2977), 2,
      sym_comment,
      sym_documentation_comment,
  [139827] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(6356), 1,
      anon_sym_SEMI,
    STATE(2847), 1,
      aux_sym_initialized_identifier_list_repeat1,
    STATE(2978), 2,
      sym_comment,
      sym_documentation_comment,
  [139856] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6358), 1,
      anon_sym_RBRACE,
    ACTIONS(6360), 1,
      anon_sym_COMMA,
    STATE(2979), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__named_formal_parameters_repeat1,
  [139883] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6363), 1,
      anon_sym_COMMA,
    ACTIONS(6365), 1,
      anon_sym_RPAREN,
    STATE(2745), 1,
      aux_sym_record_pattern_repeat1,
    STATE(2980), 2,
      sym_comment,
      sym_documentation_comment,
  [139912] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5528), 1,
      anon_sym_new,
    ACTIONS(6367), 1,
      sym_identifier,
    STATE(954), 1,
      sym__new_builtin,
    STATE(2981), 2,
      sym_comment,
      sym_documentation_comment,
  [139941] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6371), 1,
      anon_sym_EQ,
    ACTIONS(6369), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(2982), 2,
      sym_comment,
      sym_documentation_comment,
  [139968] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6373), 1,
      anon_sym_COMMA,
    ACTIONS(6376), 1,
      anon_sym_RPAREN,
    STATE(2983), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym__argument_list_repeat1,
  [139995] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6378), 1,
      sym_identifier,
    ACTIONS(5540), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(2984), 2,
      sym_comment,
      sym_documentation_comment,
  [140022] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6381), 1,
      anon_sym_COMMA,
    ACTIONS(6383), 1,
      anon_sym_RPAREN,
    STATE(2977), 1,
      aux_sym_record_type_repeat1,
    STATE(2985), 2,
      sym_comment,
      sym_documentation_comment,
  [140051] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(646), 1,
      anon_sym_RBRACE,
    ACTIONS(6116), 1,
      anon_sym_COMMA,
    STATE(2819), 1,
      aux_sym_map_pattern_repeat1,
    STATE(2986), 2,
      sym_comment,
      sym_documentation_comment,
  [140080] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2987), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(4413), 3,
      anon_sym_this,
      anon_sym_super,
      sym_identifier,
  [140105] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6385), 1,
      anon_sym_LBRACE,
    ACTIONS(6387), 1,
      aux_sym__sub_string_test_token1,
    ACTIONS(6389), 1,
      sym_identifier_dollar_escaped,
    STATE(2988), 2,
      sym_comment,
      sym_documentation_comment,
  [140134] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6391), 1,
      anon_sym_COMMA,
    ACTIONS(6394), 1,
      anon_sym_GT,
    STATE(2989), 3,
      sym_comment,
      sym_documentation_comment,
      aux_sym_type_arguments_repeat1,
  [140161] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(6396), 1,
      sym_identifier,
    STATE(3025), 1,
      sym__new_builtin,
    STATE(2990), 2,
      sym_comment,
      sym_documentation_comment,
  [140190] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    ACTIONS(6398), 1,
      anon_sym_SEMI,
    STATE(2684), 1,
      aux_sym_initialized_identifier_list_repeat1,
    STATE(2991), 2,
      sym_comment,
      sym_documentation_comment,
  [140219] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2992), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5704), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [140244] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5793), 1,
      anon_sym_COMMA,
    ACTIONS(6400), 1,
      anon_sym_GT,
    STATE(2761), 1,
      aux_sym_type_parameters_repeat1,
    STATE(2993), 2,
      sym_comment,
      sym_documentation_comment,
  [140273] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(6402), 1,
      anon_sym_DOT,
    STATE(3548), 1,
      sym_arguments,
    STATE(2994), 2,
      sym_comment,
      sym_documentation_comment,
  [140302] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    ACTIONS(6404), 1,
      anon_sym_EQ_GT,
    STATE(448), 1,
      sym_block,
    STATE(2995), 2,
      sym_comment,
      sym_documentation_comment,
  [140331] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(6406), 1,
      sym_identifier,
    STATE(3225), 1,
      sym__new_builtin,
    STATE(2996), 2,
      sym_comment,
      sym_documentation_comment,
  [140360] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6408), 1,
      anon_sym_RBRACE,
    ACTIONS(6410), 1,
      anon_sym_COMMA,
    STATE(2773), 1,
      aux_sym__named_formal_parameters_repeat1,
    STATE(2997), 2,
      sym_comment,
      sym_documentation_comment,
  [140389] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(2998), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(6412), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [140414] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(155), 1,
      anon_sym_new,
    ACTIONS(6414), 1,
      sym_identifier,
    STATE(3027), 1,
      sym__new_builtin,
    STATE(2999), 2,
      sym_comment,
      sym_documentation_comment,
  [140443] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4152), 1,
      anon_sym_RBRACE,
    ACTIONS(6416), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_record_type_repeat2,
    STATE(3000), 2,
      sym_comment,
      sym_documentation_comment,
  [140472] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4955), 1,
      anon_sym_class,
    ACTIONS(4961), 1,
      anon_sym_mixin,
    STATE(3227), 1,
      sym_mixin,
    STATE(3001), 2,
      sym_comment,
      sym_documentation_comment,
  [140501] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4113), 1,
      anon_sym_RBRACE,
    ACTIONS(6418), 1,
      anon_sym_COMMA,
    STATE(2873), 1,
      aux_sym_named_parameter_types_repeat1,
    STATE(3002), 2,
      sym_comment,
      sym_documentation_comment,
  [140530] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(3003), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(6420), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [140555] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4248), 1,
      anon_sym_RBRACK,
    ACTIONS(6422), 1,
      anon_sym_COMMA,
    STATE(2630), 1,
      aux_sym_parameter_type_list_repeat1,
    STATE(3004), 2,
      sym_comment,
      sym_documentation_comment,
  [140584] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    STATE(3005), 2,
      sym_comment,
      sym_documentation_comment,
    ACTIONS(5658), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [140609] = 9,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    ACTIONS(6424), 1,
      anon_sym_DOT,
    STATE(943), 1,
      sym_arguments,
    STATE(3006), 2,
      sym_comment,
      sym_documentation_comment,
  [140638] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6426), 1,
      sym_identifier,
    STATE(1206), 1,
      sym_scoped_identifier,
    STATE(3007), 2,
      sym_comment,
      sym_documentation_comment,
  [140664] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6428), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3008), 2,
      sym_comment,
      sym_documentation_comment,
  [140688] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    STATE(1102), 1,
      sym_index_selector,
    STATE(3009), 2,
      sym_comment,
      sym_documentation_comment,
  [140714] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6430), 1,
      anon_sym_LPAREN,
    STATE(3565), 1,
      sym_parenthesized_expression,
    STATE(3010), 2,
      sym_comment,
      sym_documentation_comment,
  [140740] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6430), 1,
      anon_sym_LPAREN,
    STATE(3561), 1,
      sym_parenthesized_expression,
    STATE(3011), 2,
      sym_comment,
      sym_documentation_comment,
  [140766] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6430), 1,
      anon_sym_LPAREN,
    STATE(3554), 1,
      sym_parenthesized_expression,
    STATE(3012), 2,
      sym_comment,
      sym_documentation_comment,
  [140792] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6169), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3013), 2,
      sym_comment,
      sym_documentation_comment,
  [140816] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6432), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3014), 2,
      sym_comment,
      sym_documentation_comment,
  [140840] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(648), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3015), 2,
      sym_comment,
      sym_documentation_comment,
  [140864] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6434), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3016), 2,
      sym_comment,
      sym_documentation_comment,
  [140888] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    STATE(927), 1,
      sym_arguments,
    STATE(3017), 2,
      sym_comment,
      sym_documentation_comment,
  [140914] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6394), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3018), 2,
      sym_comment,
      sym_documentation_comment,
  [140938] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6436), 1,
      anon_sym_new,
    STATE(2315), 1,
      sym__new_builtin,
    STATE(3019), 2,
      sym_comment,
      sym_documentation_comment,
  [140964] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1776), 1,
      sym_extension_body,
    STATE(3020), 2,
      sym_comment,
      sym_documentation_comment,
  [140990] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6440), 1,
      anon_sym_RPAREN,
    ACTIONS(6442), 1,
      anon_sym_EQ_EQ,
    STATE(3021), 2,
      sym_comment,
      sym_documentation_comment,
  [141016] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    STATE(448), 1,
      sym_block,
    STATE(3022), 2,
      sym_comment,
      sym_documentation_comment,
  [141042] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1778), 1,
      sym_extension_body,
    STATE(3023), 2,
      sym_comment,
      sym_documentation_comment,
  [141068] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6444), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3024), 2,
      sym_comment,
      sym_documentation_comment,
  [141092] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2696), 1,
      sym_arguments,
    STATE(3025), 2,
      sym_comment,
      sym_documentation_comment,
  [141118] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6446), 1,
      sym_identifier,
    ACTIONS(6448), 1,
      anon_sym_class,
    STATE(3026), 2,
      sym_comment,
      sym_documentation_comment,
  [141144] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2703), 1,
      sym_arguments,
    STATE(3027), 2,
      sym_comment,
      sym_documentation_comment,
  [141170] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5459), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3028), 2,
      sym_comment,
      sym_documentation_comment,
  [141194] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6450), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3029), 2,
      sym_comment,
      sym_documentation_comment,
  [141218] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6376), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3030), 2,
      sym_comment,
      sym_documentation_comment,
  [141242] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6352), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3031), 2,
      sym_comment,
      sym_documentation_comment,
  [141266] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6452), 1,
      sym_identifier,
    STATE(1791), 1,
      sym_mixin_application_class,
    STATE(3032), 2,
      sym_comment,
      sym_documentation_comment,
  [141292] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2998), 1,
      sym_arguments,
    STATE(3033), 2,
      sym_comment,
      sym_documentation_comment,
  [141318] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6454), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3034), 2,
      sym_comment,
      sym_documentation_comment,
  [141342] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6456), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3035), 2,
      sym_comment,
      sym_documentation_comment,
  [141366] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6458), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3036), 2,
      sym_comment,
      sym_documentation_comment,
  [141390] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1953), 1,
      sym__semicolon,
    STATE(3037), 2,
      sym_comment,
      sym_documentation_comment,
  [141416] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5713), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3038), 2,
      sym_comment,
      sym_documentation_comment,
  [141440] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5323), 1,
      anon_sym_native,
    ACTIONS(6460), 1,
      anon_sym_EQ,
    STATE(3039), 2,
      sym_comment,
      sym_documentation_comment,
  [141466] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6358), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3040), 2,
      sym_comment,
      sym_documentation_comment,
  [141490] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6462), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(3041), 2,
      sym_comment,
      sym_documentation_comment,
  [141514] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1786), 1,
      sym_enum_body,
    STATE(3042), 2,
      sym_comment,
      sym_documentation_comment,
  [141540] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6464), 1,
      sym_identifier,
    STATE(3302), 1,
      sym_identifier_list,
    STATE(3043), 2,
      sym_comment,
      sym_documentation_comment,
  [141566] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5822), 1,
      sym_identifier,
    STATE(3241), 1,
      sym_dotted_identifier_list,
    STATE(3044), 2,
      sym_comment,
      sym_documentation_comment,
  [141592] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6466), 1,
      sym_identifier,
    STATE(1371), 1,
      sym_scoped_identifier,
    STATE(3045), 2,
      sym_comment,
      sym_documentation_comment,
  [141618] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(447), 1,
      sym__semicolon,
    STATE(3046), 2,
      sym_comment,
      sym_documentation_comment,
  [141644] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1731), 1,
      sym_class_body,
    STATE(3047), 2,
      sym_comment,
      sym_documentation_comment,
  [141670] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6335), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(3048), 2,
      sym_comment,
      sym_documentation_comment,
  [141694] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1954), 1,
      sym__semicolon,
    STATE(3049), 2,
      sym_comment,
      sym_documentation_comment,
  [141720] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    STATE(1000), 1,
      sym_arguments,
    STATE(3050), 2,
      sym_comment,
      sym_documentation_comment,
  [141746] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6468), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3051), 2,
      sym_comment,
      sym_documentation_comment,
  [141770] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2421), 1,
      anon_sym_LPAREN,
    STATE(1136), 1,
      sym_arguments,
    STATE(3052), 2,
      sym_comment,
      sym_documentation_comment,
  [141796] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6446), 1,
      sym_identifier,
    ACTIONS(6470), 1,
      anon_sym_class,
    STATE(3053), 2,
      sym_comment,
      sym_documentation_comment,
  [141822] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6472), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3054), 2,
      sym_comment,
      sym_documentation_comment,
  [141846] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6474), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3055), 2,
      sym_comment,
      sym_documentation_comment,
  [141870] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6264), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3056), 2,
      sym_comment,
      sym_documentation_comment,
  [141894] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1744), 1,
      sym__semicolon,
    STATE(3057), 2,
      sym_comment,
      sym_documentation_comment,
  [141920] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4584), 1,
      anon_sym_with,
    STATE(2612), 1,
      sym_mixins,
    STATE(3058), 2,
      sym_comment,
      sym_documentation_comment,
  [141946] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5092), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3059), 2,
      sym_comment,
      sym_documentation_comment,
  [141970] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2001), 1,
      anon_sym_LPAREN,
    STATE(947), 1,
      sym_arguments,
    STATE(3060), 2,
      sym_comment,
      sym_documentation_comment,
  [141996] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2413), 1,
      sym_arguments,
    STATE(3061), 2,
      sym_comment,
      sym_documentation_comment,
  [142022] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1747), 1,
      sym_class_body,
    STATE(3062), 2,
      sym_comment,
      sym_documentation_comment,
  [142048] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1748), 1,
      sym_class_body,
    STATE(3063), 2,
      sym_comment,
      sym_documentation_comment,
  [142074] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6476), 1,
      anon_sym_COMMA,
    ACTIONS(6479), 1,
      anon_sym_RPAREN,
    STATE(3064), 2,
      sym_comment,
      sym_documentation_comment,
  [142100] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6481), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    STATE(3065), 2,
      sym_comment,
      sym_documentation_comment,
  [142124] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2360), 1,
      sym_arguments,
    STATE(3066), 2,
      sym_comment,
      sym_documentation_comment,
  [142150] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1754), 1,
      sym_extension_body,
    STATE(3067), 2,
      sym_comment,
      sym_documentation_comment,
  [142176] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4460), 1,
      anon_sym_LPAREN,
    ACTIONS(6483), 1,
      anon_sym_EQ,
    STATE(3068), 2,
      sym_comment,
      sym_documentation_comment,
  [142202] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6485), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3069), 2,
      sym_comment,
      sym_documentation_comment,
  [142226] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4363), 1,
      sym_increment_operator,
    STATE(942), 1,
      sym_postfix_operator,
    STATE(3070), 2,
      sym_comment,
      sym_documentation_comment,
  [142252] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6487), 1,
      anon_sym_COMMA,
    ACTIONS(6489), 1,
      anon_sym_RPAREN,
    STATE(3071), 2,
      sym_comment,
      sym_documentation_comment,
  [142278] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6491), 1,
      sym_identifier,
    STATE(2485), 1,
      sym__type_name,
    STATE(3072), 2,
      sym_comment,
      sym_documentation_comment,
  [142304] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1760), 1,
      sym__semicolon,
    STATE(3073), 2,
      sym_comment,
      sym_documentation_comment,
  [142330] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1728), 1,
      sym_class_body,
    STATE(3074), 2,
      sym_comment,
      sym_documentation_comment,
  [142356] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1793), 1,
      sym_class_body,
    STATE(3075), 2,
      sym_comment,
      sym_documentation_comment,
  [142382] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5822), 1,
      sym_identifier,
    STATE(3117), 1,
      sym_dotted_identifier_list,
    STATE(3076), 2,
      sym_comment,
      sym_documentation_comment,
  [142408] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(876), 1,
      sym_index_selector,
    STATE(3077), 2,
      sym_comment,
      sym_documentation_comment,
  [142434] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1768), 1,
      sym_class_body,
    STATE(3078), 2,
      sym_comment,
      sym_documentation_comment,
  [142460] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6493), 1,
      anon_sym_LBRACE,
    ACTIONS(6495), 1,
      anon_sym_LBRACK,
    STATE(3079), 2,
      sym_comment,
      sym_documentation_comment,
  [142486] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2379), 1,
      sym_arguments,
    STATE(3080), 2,
      sym_comment,
      sym_documentation_comment,
  [142512] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4327), 1,
      anon_sym_LBRACE,
    ACTIONS(4329), 1,
      anon_sym_LBRACK,
    STATE(3081), 2,
      sym_comment,
      sym_documentation_comment,
  [142538] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6497), 1,
      anon_sym_new,
    STATE(1056), 1,
      sym__new_builtin,
    STATE(3082), 2,
      sym_comment,
      sym_documentation_comment,
  [142564] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6499), 1,
      anon_sym_LPAREN,
    STATE(585), 1,
      sym_arguments,
    STATE(3083), 2,
      sym_comment,
      sym_documentation_comment,
  [142590] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5250), 1,
      anon_sym_LBRACE,
    STATE(1225), 1,
      sym_block,
    STATE(3084), 2,
      sym_comment,
      sym_documentation_comment,
  [142616] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6501), 1,
      anon_sym_COMMA,
    STATE(2805), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(3085), 2,
      sym_comment,
      sym_documentation_comment,
  [142642] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(549), 1,
      sym__semicolon,
    STATE(3086), 2,
      sym_comment,
      sym_documentation_comment,
  [142668] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(6), 1,
      sym_for_loop_parts,
    STATE(3087), 2,
      sym_comment,
      sym_documentation_comment,
  [142694] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6430), 1,
      anon_sym_LPAREN,
    STATE(3148), 1,
      sym_parenthesized_expression,
    STATE(3088), 2,
      sym_comment,
      sym_documentation_comment,
  [142720] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6505), 1,
      anon_sym_COMMA,
    ACTIONS(6507), 1,
      anon_sym_RPAREN,
    STATE(3089), 2,
      sym_comment,
      sym_documentation_comment,
  [142746] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5696), 1,
      anon_sym_LBRACE,
    STATE(488), 1,
      sym_block,
    STATE(3090), 2,
      sym_comment,
      sym_documentation_comment,
  [142772] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6509), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3091), 2,
      sym_comment,
      sym_documentation_comment,
  [142796] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1752), 1,
      sym_enum_body,
    STATE(3092), 2,
      sym_comment,
      sym_documentation_comment,
  [142822] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5191), 1,
      anon_sym_as,
    STATE(3298), 1,
      sym__as,
    STATE(3093), 2,
      sym_comment,
      sym_documentation_comment,
  [142848] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(160), 1,
      sym_for_loop_parts,
    STATE(3094), 2,
      sym_comment,
      sym_documentation_comment,
  [142874] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1743), 1,
      sym_extension_body,
    STATE(3095), 2,
      sym_comment,
      sym_documentation_comment,
  [142900] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6511), 2,
      anon_sym_class,
      anon_sym_mixin,
    STATE(3096), 2,
      sym_comment,
      sym_documentation_comment,
  [142924] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6513), 1,
      anon_sym_LBRACE,
    ACTIONS(6515), 1,
      anon_sym_LBRACK,
    STATE(3097), 2,
      sym_comment,
      sym_documentation_comment,
  [142950] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6249), 1,
      anon_sym_RPAREN,
    ACTIONS(6509), 1,
      anon_sym_COMMA,
    STATE(3098), 2,
      sym_comment,
      sym_documentation_comment,
  [142976] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6517), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(3099), 2,
      sym_comment,
      sym_documentation_comment,
  [143000] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4291), 1,
      anon_sym_LBRACE,
    ACTIONS(4293), 1,
      anon_sym_LBRACK,
    STATE(3100), 2,
      sym_comment,
      sym_documentation_comment,
  [143026] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6519), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3101), 2,
      sym_comment,
      sym_documentation_comment,
  [143050] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5465), 1,
      anon_sym_LBRACK,
    STATE(582), 1,
      sym_index_selector,
    STATE(3102), 2,
      sym_comment,
      sym_documentation_comment,
  [143076] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6521), 2,
      anon_sym_class,
      sym_identifier,
    STATE(3103), 2,
      sym_comment,
      sym_documentation_comment,
  [143100] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1772), 1,
      sym__semicolon,
    STATE(3104), 2,
      sym_comment,
      sym_documentation_comment,
  [143126] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6501), 1,
      anon_sym_COMMA,
    STATE(2913), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(3105), 2,
      sym_comment,
      sym_documentation_comment,
  [143152] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    STATE(1220), 1,
      sym_arguments,
    STATE(3106), 2,
      sym_comment,
      sym_documentation_comment,
  [143178] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1723), 1,
      sym__semicolon,
    STATE(3107), 2,
      sym_comment,
      sym_documentation_comment,
  [143204] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6501), 1,
      anon_sym_COMMA,
    STATE(2871), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(3108), 2,
      sym_comment,
      sym_documentation_comment,
  [143230] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6523), 1,
      anon_sym_LBRACE,
    ACTIONS(6525), 1,
      anon_sym_LBRACK,
    STATE(3109), 2,
      sym_comment,
      sym_documentation_comment,
  [143256] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(637), 1,
      sym_index_selector,
    STATE(3110), 2,
      sym_comment,
      sym_documentation_comment,
  [143282] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6527), 1,
      anon_sym_COMMA,
    ACTIONS(6530), 1,
      anon_sym_RPAREN,
    STATE(3111), 2,
      sym_comment,
      sym_documentation_comment,
  [143308] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5069), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3112), 2,
      sym_comment,
      sym_documentation_comment,
  [143332] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    STATE(1291), 1,
      sym_arguments,
    STATE(3113), 2,
      sym_comment,
      sym_documentation_comment,
  [143358] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6432), 1,
      anon_sym_COMMA,
    ACTIONS(6532), 1,
      anon_sym_RPAREN,
    STATE(3114), 2,
      sym_comment,
      sym_documentation_comment,
  [143384] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4297), 1,
      anon_sym_LBRACE,
    ACTIONS(4299), 1,
      anon_sym_LBRACK,
    STATE(3115), 2,
      sym_comment,
      sym_documentation_comment,
  [143410] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1557), 1,
      anon_sym_while,
    ACTIONS(6535), 1,
      anon_sym_else,
    STATE(3116), 2,
      sym_comment,
      sym_documentation_comment,
  [143436] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1558), 1,
      sym__semicolon,
    STATE(3117), 2,
      sym_comment,
      sym_documentation_comment,
  [143462] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2416), 1,
      sym_arguments,
    STATE(3118), 2,
      sym_comment,
      sym_documentation_comment,
  [143488] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_for_loop_parts,
    STATE(3119), 2,
      sym_comment,
      sym_documentation_comment,
  [143514] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6163), 1,
      anon_sym_RPAREN,
    ACTIONS(6509), 1,
      anon_sym_COMMA,
    STATE(3120), 2,
      sym_comment,
      sym_documentation_comment,
  [143540] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1619), 1,
      anon_sym_while,
    ACTIONS(6537), 1,
      anon_sym_else,
    STATE(3121), 2,
      sym_comment,
      sym_documentation_comment,
  [143566] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4361), 1,
      sym_increment_operator,
    STATE(1317), 1,
      sym_postfix_operator,
    STATE(3122), 2,
      sym_comment,
      sym_documentation_comment,
  [143592] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6539), 1,
      anon_sym_LBRACE,
    STATE(524), 1,
      sym_switch_block,
    STATE(3123), 2,
      sym_comment,
      sym_documentation_comment,
  [143618] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6216), 1,
      anon_sym_RPAREN,
    ACTIONS(6509), 1,
      anon_sym_COMMA,
    STATE(3124), 2,
      sym_comment,
      sym_documentation_comment,
  [143644] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6541), 1,
      sym_identifier,
    STATE(2712), 1,
      sym__identifier_list,
    STATE(3125), 2,
      sym_comment,
      sym_documentation_comment,
  [143670] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6543), 1,
      anon_sym_LPAREN,
    STATE(647), 1,
      sym_arguments,
    STATE(3126), 2,
      sym_comment,
      sym_documentation_comment,
  [143696] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2302), 1,
      anon_sym_LPAREN,
    STATE(1277), 1,
      sym_arguments,
    STATE(3127), 2,
      sym_comment,
      sym_documentation_comment,
  [143722] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6545), 1,
      anon_sym_LPAREN,
    STATE(1909), 1,
      sym_configuration_uri_condition,
    STATE(3128), 2,
      sym_comment,
      sym_documentation_comment,
  [143748] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(522), 1,
      sym__semicolon,
    STATE(3129), 2,
      sym_comment,
      sym_documentation_comment,
  [143774] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(530), 1,
      sym__semicolon,
    STATE(3130), 2,
      sym_comment,
      sym_documentation_comment,
  [143800] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5692), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3131), 2,
      sym_comment,
      sym_documentation_comment,
  [143824] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6547), 1,
      anon_sym_RPAREN,
    ACTIONS(6549), 1,
      anon_sym_case,
    STATE(3132), 2,
      sym_comment,
      sym_documentation_comment,
  [143850] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(541), 1,
      sym__semicolon,
    STATE(3133), 2,
      sym_comment,
      sym_documentation_comment,
  [143876] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(200), 1,
      sym__semicolon,
    STATE(3134), 2,
      sym_comment,
      sym_documentation_comment,
  [143902] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6551), 1,
      anon_sym_LBRACE,
    ACTIONS(6553), 1,
      anon_sym_LBRACK,
    STATE(3135), 2,
      sym_comment,
      sym_documentation_comment,
  [143928] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6555), 1,
      anon_sym_EQ,
    ACTIONS(6557), 1,
      anon_sym_in,
    STATE(3136), 2,
      sym_comment,
      sym_documentation_comment,
  [143954] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(6559), 1,
      anon_sym_DOT,
    STATE(3137), 2,
      sym_comment,
      sym_documentation_comment,
  [143980] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(518), 1,
      sym__semicolon,
    STATE(3138), 2,
      sym_comment,
      sym_documentation_comment,
  [144006] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1713), 1,
      sym__semicolon,
    STATE(3139), 2,
      sym_comment,
      sym_documentation_comment,
  [144032] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACK,
    STATE(563), 1,
      sym_index_selector,
    STATE(3140), 2,
      sym_comment,
      sym_documentation_comment,
  [144058] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6561), 1,
      anon_sym_LBRACE,
    ACTIONS(6563), 1,
      anon_sym_LBRACK,
    STATE(3141), 2,
      sym_comment,
      sym_documentation_comment,
  [144084] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    STATE(2332), 1,
      sym_block,
    STATE(3142), 2,
      sym_comment,
      sym_documentation_comment,
  [144110] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6565), 1,
      anon_sym_new,
    STATE(1201), 1,
      sym__new_builtin,
    STATE(3143), 2,
      sym_comment,
      sym_documentation_comment,
  [144136] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_for_loop_parts,
    STATE(3144), 2,
      sym_comment,
      sym_documentation_comment,
  [144162] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(1585), 1,
      sym_arguments,
    STATE(3145), 2,
      sym_comment,
      sym_documentation_comment,
  [144188] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4124), 1,
      anon_sym_LBRACE,
    ACTIONS(4126), 1,
      anon_sym_LBRACK,
    STATE(3146), 2,
      sym_comment,
      sym_documentation_comment,
  [144214] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1734), 1,
      sym_enum_body,
    STATE(3147), 2,
      sym_comment,
      sym_documentation_comment,
  [144240] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(551), 1,
      sym__semicolon,
    STATE(3148), 2,
      sym_comment,
      sym_documentation_comment,
  [144266] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6430), 1,
      anon_sym_LPAREN,
    STATE(3368), 1,
      sym_parenthesized_expression,
    STATE(3149), 2,
      sym_comment,
      sym_documentation_comment,
  [144292] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6501), 1,
      anon_sym_COMMA,
    STATE(2894), 1,
      aux_sym__record_literal_no_const_repeat1,
    STATE(3150), 2,
      sym_comment,
      sym_documentation_comment,
  [144318] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1739), 1,
      sym_extension_body,
    STATE(3151), 2,
      sym_comment,
      sym_documentation_comment,
  [144344] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6567), 1,
      anon_sym_LPAREN,
    STATE(3433), 1,
      sym_catch_parameters,
    STATE(3152), 2,
      sym_comment,
      sym_documentation_comment,
  [144370] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4833), 1,
      anon_sym_LBRACE,
    STATE(528), 1,
      sym_block,
    STATE(3153), 2,
      sym_comment,
      sym_documentation_comment,
  [144396] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6569), 1,
      anon_sym_DOT,
    ACTIONS(6571), 1,
      anon_sym_SEMI,
    STATE(3154), 2,
      sym_comment,
      sym_documentation_comment,
  [144422] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6573), 1,
      anon_sym_COMMA,
    ACTIONS(6575), 1,
      anon_sym_RPAREN,
    STATE(3155), 2,
      sym_comment,
      sym_documentation_comment,
  [144448] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5696), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_block,
    STATE(3156), 2,
      sym_comment,
      sym_documentation_comment,
  [144474] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1740), 1,
      sym_class_body,
    STATE(3157), 2,
      sym_comment,
      sym_documentation_comment,
  [144500] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4303), 1,
      anon_sym_LBRACK,
    STATE(970), 1,
      sym_index_selector,
    STATE(3158), 2,
      sym_comment,
      sym_documentation_comment,
  [144526] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6577), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3159), 2,
      sym_comment,
      sym_documentation_comment,
  [144550] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(512), 1,
      sym__semicolon,
    STATE(3160), 2,
      sym_comment,
      sym_documentation_comment,
  [144576] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6579), 1,
      anon_sym_LBRACE,
    ACTIONS(6581), 1,
      anon_sym_LBRACK,
    STATE(3161), 2,
      sym_comment,
      sym_documentation_comment,
  [144602] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4349), 1,
      sym_increment_operator,
    STATE(1496), 1,
      sym_postfix_operator,
    STATE(3162), 2,
      sym_comment,
      sym_documentation_comment,
  [144628] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6583), 1,
      anon_sym_LBRACE,
    ACTIONS(6585), 1,
      anon_sym_LBRACK,
    STATE(3163), 2,
      sym_comment,
      sym_documentation_comment,
  [144654] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_for_loop_parts,
    STATE(3164), 2,
      sym_comment,
      sym_documentation_comment,
  [144680] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(150), 1,
      sym_for_loop_parts,
    STATE(3165), 2,
      sym_comment,
      sym_documentation_comment,
  [144706] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1742), 1,
      sym_class_body,
    STATE(3166), 2,
      sym_comment,
      sym_documentation_comment,
  [144732] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6587), 1,
      anon_sym_LPAREN,
    STATE(30), 1,
      sym_parenthesized_expression,
    STATE(3167), 2,
      sym_comment,
      sym_documentation_comment,
  [144758] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6589), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(3168), 2,
      sym_comment,
      sym_documentation_comment,
  [144782] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6591), 1,
      anon_sym_COMMA,
    ACTIONS(6594), 1,
      anon_sym_RPAREN,
    STATE(3169), 2,
      sym_comment,
      sym_documentation_comment,
  [144808] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6596), 1,
      anon_sym_new,
    STATE(862), 1,
      sym__new_builtin,
    STATE(3170), 2,
      sym_comment,
      sym_documentation_comment,
  [144834] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6598), 1,
      anon_sym_LBRACE,
    ACTIONS(6600), 1,
      anon_sym_LBRACK,
    STATE(3171), 2,
      sym_comment,
      sym_documentation_comment,
  [144860] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6602), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3172), 2,
      sym_comment,
      sym_documentation_comment,
  [144884] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6604), 1,
      anon_sym_RPAREN,
    ACTIONS(6606), 1,
      anon_sym_case,
    STATE(3173), 2,
      sym_comment,
      sym_documentation_comment,
  [144910] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5444), 1,
      anon_sym_LBRACK,
    STATE(638), 1,
      sym_index_selector,
    STATE(3174), 2,
      sym_comment,
      sym_documentation_comment,
  [144936] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2214), 1,
      anon_sym_LBRACK,
    STATE(614), 1,
      sym_index_selector,
    STATE(3175), 2,
      sym_comment,
      sym_documentation_comment,
  [144962] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(511), 1,
      sym__semicolon,
    STATE(3176), 2,
      sym_comment,
      sym_documentation_comment,
  [144988] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(8), 1,
      sym_for_loop_parts,
    STATE(3177), 2,
      sym_comment,
      sym_documentation_comment,
  [145014] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1767), 1,
      sym__semicolon,
    STATE(3178), 2,
      sym_comment,
      sym_documentation_comment,
  [145040] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACK,
    STATE(1112), 1,
      sym_index_selector,
    STATE(3179), 2,
      sym_comment,
      sym_documentation_comment,
  [145066] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6608), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3180), 2,
      sym_comment,
      sym_documentation_comment,
  [145090] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2158), 1,
      anon_sym_LBRACK,
    STATE(1052), 1,
      sym_index_selector,
    STATE(3181), 2,
      sym_comment,
      sym_documentation_comment,
  [145116] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4721), 2,
      anon_sym_EQ,
      anon_sym_in,
    STATE(3182), 2,
      sym_comment,
      sym_documentation_comment,
  [145140] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5465), 1,
      anon_sym_LBRACK,
    STATE(584), 1,
      sym_index_selector,
    STATE(3183), 2,
      sym_comment,
      sym_documentation_comment,
  [145166] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5752), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3184), 2,
      sym_comment,
      sym_documentation_comment,
  [145190] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1761), 1,
      sym_class_body,
    STATE(3185), 2,
      sym_comment,
      sym_documentation_comment,
  [145216] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1758), 1,
      sym_class_body,
    STATE(3186), 2,
      sym_comment,
      sym_documentation_comment,
  [145242] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1756), 1,
      sym_class_body,
    STATE(3187), 2,
      sym_comment,
      sym_documentation_comment,
  [145268] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6610), 1,
      anon_sym_COMMA,
    ACTIONS(6613), 1,
      anon_sym_RPAREN,
    STATE(3188), 2,
      sym_comment,
      sym_documentation_comment,
  [145294] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4460), 1,
      anon_sym_LPAREN,
    ACTIONS(6615), 1,
      anon_sym_EQ,
    STATE(3189), 2,
      sym_comment,
      sym_documentation_comment,
  [145320] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5988), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3190), 2,
      sym_comment,
      sym_documentation_comment,
  [145344] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6617), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3191), 2,
      sym_comment,
      sym_documentation_comment,
  [145368] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1733), 1,
      sym_extension_body,
    STATE(3192), 2,
      sym_comment,
      sym_documentation_comment,
  [145394] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1735), 1,
      sym_enum_body,
    STATE(3193), 2,
      sym_comment,
      sym_documentation_comment,
  [145420] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4365), 1,
      sym_increment_operator,
    STATE(1378), 1,
      sym_postfix_operator,
    STATE(3194), 2,
      sym_comment,
      sym_documentation_comment,
  [145446] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6619), 1,
      sym_identifier,
    STATE(1777), 1,
      sym_mixin_application_class,
    STATE(3195), 2,
      sym_comment,
      sym_documentation_comment,
  [145472] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6621), 1,
      anon_sym_LBRACK,
    STATE(2423), 1,
      sym_index_selector,
    STATE(3196), 2,
      sym_comment,
      sym_documentation_comment,
  [145498] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1736), 1,
      sym_class_body,
    STATE(3197), 2,
      sym_comment,
      sym_documentation_comment,
  [145524] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6623), 1,
      anon_sym_DOT,
    ACTIONS(6625), 1,
      anon_sym_SEMI,
    STATE(3198), 2,
      sym_comment,
      sym_documentation_comment,
  [145550] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1737), 1,
      sym__semicolon,
    STATE(3199), 2,
      sym_comment,
      sym_documentation_comment,
  [145576] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6627), 1,
      anon_sym_LBRACE,
    ACTIONS(6629), 1,
      anon_sym_LBRACK,
    STATE(3200), 2,
      sym_comment,
      sym_documentation_comment,
  [145602] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2320), 1,
      anon_sym_LBRACK,
    STATE(1197), 1,
      sym_index_selector,
    STATE(3201), 2,
      sym_comment,
      sym_documentation_comment,
  [145628] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5242), 1,
      anon_sym_LBRACE,
    STATE(921), 1,
      sym_block,
    STATE(3202), 2,
      sym_comment,
      sym_documentation_comment,
  [145654] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(519), 1,
      sym__semicolon,
    STATE(3203), 2,
      sym_comment,
      sym_documentation_comment,
  [145680] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6631), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(3204), 2,
      sym_comment,
      sym_documentation_comment,
  [145704] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5282), 1,
      anon_sym_LBRACE,
    STATE(1142), 1,
      sym_block,
    STATE(3205), 2,
      sym_comment,
      sym_documentation_comment,
  [145730] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4333), 1,
      anon_sym_LBRACK,
    STATE(1230), 1,
      sym_index_selector,
    STATE(3206), 2,
      sym_comment,
      sym_documentation_comment,
  [145756] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6633), 1,
      anon_sym_RPAREN,
    ACTIONS(6635), 1,
      anon_sym_case,
    STATE(3207), 2,
      sym_comment,
      sym_documentation_comment,
  [145782] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6637), 1,
      anon_sym_LPAREN,
    STATE(2429), 1,
      sym_assertion_arguments,
    STATE(3208), 2,
      sym_comment,
      sym_documentation_comment,
  [145808] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    STATE(1370), 1,
      sym_arguments,
    STATE(3209), 2,
      sym_comment,
      sym_documentation_comment,
  [145834] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6503), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym_for_loop_parts,
    STATE(3210), 2,
      sym_comment,
      sym_documentation_comment,
  [145860] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4606), 1,
      anon_sym_LPAREN,
    ACTIONS(4608), 1,
      anon_sym_DOT,
    STATE(3211), 2,
      sym_comment,
      sym_documentation_comment,
  [145886] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6035), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3212), 2,
      sym_comment,
      sym_documentation_comment,
  [145910] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5696), 1,
      anon_sym_LBRACE,
    STATE(486), 1,
      sym_block,
    STATE(3213), 2,
      sym_comment,
      sym_documentation_comment,
  [145936] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6587), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
    STATE(3214), 2,
      sym_comment,
      sym_documentation_comment,
  [145962] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2419), 1,
      anon_sym_LBRACK,
    STATE(1124), 1,
      sym_index_selector,
    STATE(3215), 2,
      sym_comment,
      sym_documentation_comment,
  [145988] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6430), 1,
      anon_sym_LPAREN,
    STATE(3123), 1,
      sym_parenthesized_expression,
    STATE(3216), 2,
      sym_comment,
      sym_documentation_comment,
  [146014] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(449), 1,
      sym__semicolon,
    STATE(3217), 2,
      sym_comment,
      sym_documentation_comment,
  [146040] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6033), 1,
      anon_sym_RPAREN,
    ACTIONS(6509), 1,
      anon_sym_COMMA,
    STATE(3218), 2,
      sym_comment,
      sym_documentation_comment,
  [146066] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6639), 1,
      anon_sym_RPAREN,
    ACTIONS(6641), 1,
      anon_sym_case,
    STATE(3219), 2,
      sym_comment,
      sym_documentation_comment,
  [146092] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6643), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3220), 2,
      sym_comment,
      sym_documentation_comment,
  [146116] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6645), 1,
      anon_sym_get,
    STATE(3443), 1,
      sym__get,
    STATE(3221), 2,
      sym_comment,
      sym_documentation_comment,
  [146142] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6647), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3222), 2,
      sym_comment,
      sym_documentation_comment,
  [146166] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5814), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3223), 2,
      sym_comment,
      sym_documentation_comment,
  [146190] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6491), 1,
      sym_identifier,
    STATE(2483), 1,
      sym__type_name,
    STATE(3224), 2,
      sym_comment,
      sym_documentation_comment,
  [146216] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(2820), 1,
      sym_arguments,
    STATE(3225), 2,
      sym_comment,
      sym_documentation_comment,
  [146242] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5615), 1,
      anon_sym_LPAREN,
    STATE(2104), 1,
      sym_arguments,
    STATE(3226), 2,
      sym_comment,
      sym_documentation_comment,
  [146268] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6470), 1,
      anon_sym_class,
    ACTIONS(6649), 1,
      sym_identifier,
    STATE(3227), 2,
      sym_comment,
      sym_documentation_comment,
  [146294] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6651), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3228), 2,
      sym_comment,
      sym_documentation_comment,
  [146318] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6653), 1,
      anon_sym_operator,
    STATE(1537), 1,
      sym__operator,
    STATE(3229), 2,
      sym_comment,
      sym_documentation_comment,
  [146344] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6655), 2,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3230), 2,
      sym_comment,
      sym_documentation_comment,
  [146368] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    STATE(1162), 1,
      sym_arguments,
    STATE(3231), 2,
      sym_comment,
      sym_documentation_comment,
  [146394] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5270), 1,
      anon_sym_native,
    ACTIONS(6657), 1,
      anon_sym_EQ,
    STATE(3232), 2,
      sym_comment,
      sym_documentation_comment,
  [146420] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5805), 1,
      sym_identifier,
    STATE(3223), 1,
      sym_initialized_identifier,
    STATE(3233), 2,
      sym_comment,
      sym_documentation_comment,
  [146446] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5781), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3234), 2,
      sym_comment,
      sym_documentation_comment,
  [146470] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3398), 1,
      anon_sym_LPAREN,
    STATE(3418), 1,
      sym_arguments,
    STATE(3235), 2,
      sym_comment,
      sym_documentation_comment,
  [146496] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    STATE(2360), 1,
      sym_arguments,
    STATE(3236), 2,
      sym_comment,
      sym_documentation_comment,
  [146522] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1947), 1,
      sym__semicolon,
    STATE(3237), 2,
      sym_comment,
      sym_documentation_comment,
  [146548] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    STATE(1097), 1,
      sym_arguments,
    STATE(3238), 2,
      sym_comment,
      sym_documentation_comment,
  [146574] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5331), 1,
      anon_sym_native,
    STATE(3520), 1,
      sym__native,
    STATE(3239), 2,
      sym_comment,
      sym_documentation_comment,
  [146600] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1724), 1,
      sym__semicolon,
    STATE(3240), 2,
      sym_comment,
      sym_documentation_comment,
  [146626] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1579), 1,
      sym__semicolon,
    STATE(3241), 2,
      sym_comment,
      sym_documentation_comment,
  [146652] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5193), 1,
      anon_sym_SEMI,
    STATE(1674), 1,
      sym__semicolon,
    STATE(3242), 2,
      sym_comment,
      sym_documentation_comment,
  [146678] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1775), 1,
      sym_enum_body,
    STATE(3243), 2,
      sym_comment,
      sym_documentation_comment,
  [146704] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    STATE(1170), 1,
      sym_arguments,
    STATE(3244), 2,
      sym_comment,
      sym_documentation_comment,
  [146730] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_class_body,
    STATE(3245), 2,
      sym_comment,
      sym_documentation_comment,
  [146756] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(2300), 1,
      anon_sym_LBRACK,
    STATE(666), 1,
      sym_index_selector,
    STATE(3246), 2,
      sym_comment,
      sym_documentation_comment,
  [146782] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6659), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3247), 2,
      sym_comment,
      sym_documentation_comment,
  [146806] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6661), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(3248), 2,
      sym_comment,
      sym_documentation_comment,
  [146830] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4351), 1,
      sym_increment_operator,
    STATE(1094), 1,
      sym_postfix_operator,
    STATE(3249), 2,
      sym_comment,
      sym_documentation_comment,
  [146856] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6448), 1,
      anon_sym_class,
    ACTIONS(6663), 1,
      sym_identifier,
    STATE(3250), 2,
      sym_comment,
      sym_documentation_comment,
  [146882] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1729), 1,
      sym_extension_body,
    STATE(3251), 2,
      sym_comment,
      sym_documentation_comment,
  [146908] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6665), 1,
      anon_sym_DOT,
    ACTIONS(6667), 1,
      anon_sym_SEMI,
    STATE(3252), 2,
      sym_comment,
      sym_documentation_comment,
  [146934] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4578), 1,
      anon_sym_LBRACE,
    STATE(1787), 1,
      sym_class_body,
    STATE(3253), 2,
      sym_comment,
      sym_documentation_comment,
  [146960] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5869), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3254), 2,
      sym_comment,
      sym_documentation_comment,
  [146984] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4971), 1,
      anon_sym_LBRACE,
    STATE(1788), 1,
      sym_enum_body,
    STATE(3255), 2,
      sym_comment,
      sym_documentation_comment,
  [147010] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6669), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3256), 2,
      sym_comment,
      sym_documentation_comment,
  [147034] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6671), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(3257), 2,
      sym_comment,
      sym_documentation_comment,
  [147058] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6098), 1,
      anon_sym_RPAREN,
    ACTIONS(6527), 1,
      anon_sym_COMMA,
    STATE(3258), 2,
      sym_comment,
      sym_documentation_comment,
  [147084] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6438), 1,
      anon_sym_LBRACE,
    STATE(1751), 1,
      sym_extension_body,
    STATE(3259), 2,
      sym_comment,
      sym_documentation_comment,
  [147110] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(190), 1,
      sym__semicolon,
    STATE(3260), 2,
      sym_comment,
      sym_documentation_comment,
  [147136] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5831), 1,
      sym_identifier,
    STATE(3031), 1,
      sym_static_final_declaration,
    STATE(3261), 2,
      sym_comment,
      sym_documentation_comment,
  [147162] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6673), 1,
      anon_sym_LBRACE,
    ACTIONS(6675), 1,
      anon_sym_LBRACK,
    STATE(3262), 2,
      sym_comment,
      sym_documentation_comment,
  [147188] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6677), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3263), 2,
      sym_comment,
      sym_documentation_comment,
  [147212] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1732), 1,
      sym__semicolon,
    STATE(3264), 2,
      sym_comment,
      sym_documentation_comment,
  [147238] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(474), 1,
      anon_sym_SEMI,
    STATE(1959), 1,
      sym__semicolon,
    STATE(3265), 2,
      sym_comment,
      sym_documentation_comment,
  [147264] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6679), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3266), 2,
      sym_comment,
      sym_documentation_comment,
  [147288] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5935), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3267), 2,
      sym_comment,
      sym_documentation_comment,
  [147312] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5910), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(3268), 2,
      sym_comment,
      sym_documentation_comment,
  [147336] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5921), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(3269), 2,
      sym_comment,
      sym_documentation_comment,
  [147360] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5666), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3270), 2,
      sym_comment,
      sym_documentation_comment,
  [147384] = 8,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6681), 1,
      anon_sym_COMMA,
    ACTIONS(6683), 1,
      anon_sym_RPAREN,
    STATE(3271), 2,
      sym_comment,
      sym_documentation_comment,
  [147410] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5668), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(3272), 2,
      sym_comment,
      sym_documentation_comment,
  [147434] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6685), 1,
      sym_identifier,
    STATE(3273), 2,
      sym_comment,
      sym_documentation_comment,
  [147457] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6687), 1,
      sym_identifier,
    STATE(3274), 2,
      sym_comment,
      sym_documentation_comment,
  [147480] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6689), 1,
      sym_identifier,
    STATE(3275), 2,
      sym_comment,
      sym_documentation_comment,
  [147503] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6691), 1,
      anon_sym_DOT,
    STATE(3276), 2,
      sym_comment,
      sym_documentation_comment,
  [147526] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6683), 1,
      anon_sym_RPAREN,
    STATE(3277), 2,
      sym_comment,
      sym_documentation_comment,
  [147549] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6594), 1,
      anon_sym_RPAREN,
    STATE(3278), 2,
      sym_comment,
      sym_documentation_comment,
  [147572] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6693), 1,
      sym_identifier,
    STATE(3279), 2,
      sym_comment,
      sym_documentation_comment,
  [147595] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6695), 1,
      anon_sym_COLON,
    STATE(3280), 2,
      sym_comment,
      sym_documentation_comment,
  [147618] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6697), 1,
      anon_sym_RBRACE,
    STATE(3281), 2,
      sym_comment,
      sym_documentation_comment,
  [147641] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5333), 1,
      anon_sym_EQ,
    STATE(3282), 2,
      sym_comment,
      sym_documentation_comment,
  [147664] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6699), 1,
      anon_sym_DOT,
    STATE(3283), 2,
      sym_comment,
      sym_documentation_comment,
  [147687] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6701), 1,
      sym_identifier,
    STATE(3284), 2,
      sym_comment,
      sym_documentation_comment,
  [147710] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6703), 1,
      anon_sym_RPAREN,
    STATE(3285), 2,
      sym_comment,
      sym_documentation_comment,
  [147733] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6705), 1,
      anon_sym_RPAREN,
    STATE(3286), 2,
      sym_comment,
      sym_documentation_comment,
  [147756] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6707), 1,
      anon_sym_EQ,
    STATE(3287), 2,
      sym_comment,
      sym_documentation_comment,
  [147779] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6709), 1,
      anon_sym_DOT,
    STATE(3288), 2,
      sym_comment,
      sym_documentation_comment,
  [147802] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6711), 1,
      anon_sym_RPAREN,
    STATE(3289), 2,
      sym_comment,
      sym_documentation_comment,
  [147825] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6713), 1,
      anon_sym_RPAREN,
    STATE(3290), 2,
      sym_comment,
      sym_documentation_comment,
  [147848] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6715), 1,
      anon_sym_RPAREN,
    STATE(3291), 2,
      sym_comment,
      sym_documentation_comment,
  [147871] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5863), 1,
      anon_sym_RPAREN,
    STATE(3292), 2,
      sym_comment,
      sym_documentation_comment,
  [147894] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4186), 1,
      anon_sym_RPAREN,
    STATE(3293), 2,
      sym_comment,
      sym_documentation_comment,
  [147917] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6717), 1,
      anon_sym_on,
    STATE(3294), 2,
      sym_comment,
      sym_documentation_comment,
  [147940] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6719), 1,
      anon_sym_RPAREN,
    STATE(3295), 2,
      sym_comment,
      sym_documentation_comment,
  [147963] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6721), 1,
      sym_identifier,
    STATE(3296), 2,
      sym_comment,
      sym_documentation_comment,
  [147986] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6723), 1,
      anon_sym_RPAREN,
    STATE(3297), 2,
      sym_comment,
      sym_documentation_comment,
  [148009] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6725), 1,
      sym_identifier,
    STATE(3298), 2,
      sym_comment,
      sym_documentation_comment,
  [148032] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6727), 1,
      anon_sym_RPAREN,
    STATE(3299), 2,
      sym_comment,
      sym_documentation_comment,
  [148055] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6729), 1,
      sym_identifier,
    STATE(3300), 2,
      sym_comment,
      sym_documentation_comment,
  [148078] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5270), 1,
      anon_sym_SEMI,
    STATE(3301), 2,
      sym_comment,
      sym_documentation_comment,
  [148101] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6731), 1,
      anon_sym_SEMI,
    STATE(3302), 2,
      sym_comment,
      sym_documentation_comment,
  [148124] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6733), 1,
      sym_identifier,
    STATE(3303), 2,
      sym_comment,
      sym_documentation_comment,
  [148147] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6735), 1,
      sym_identifier,
    STATE(3304), 2,
      sym_comment,
      sym_documentation_comment,
  [148170] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6737), 1,
      sym_identifier,
    STATE(3305), 2,
      sym_comment,
      sym_documentation_comment,
  [148193] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6739), 1,
      anon_sym_RPAREN,
    STATE(3306), 2,
      sym_comment,
      sym_documentation_comment,
  [148216] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6741), 1,
      anon_sym_RPAREN,
    STATE(3307), 2,
      sym_comment,
      sym_documentation_comment,
  [148239] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6743), 1,
      anon_sym_on,
    STATE(3308), 2,
      sym_comment,
      sym_documentation_comment,
  [148262] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6745), 1,
      anon_sym_RPAREN,
    STATE(3309), 2,
      sym_comment,
      sym_documentation_comment,
  [148285] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6747), 1,
      sym_identifier,
    STATE(3310), 2,
      sym_comment,
      sym_documentation_comment,
  [148308] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6749), 1,
      anon_sym_RPAREN,
    STATE(3311), 2,
      sym_comment,
      sym_documentation_comment,
  [148331] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6751), 1,
      sym_identifier,
    STATE(3312), 2,
      sym_comment,
      sym_documentation_comment,
  [148354] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6753), 1,
      anon_sym_COLON,
    STATE(3313), 2,
      sym_comment,
      sym_documentation_comment,
  [148377] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5481), 1,
      anon_sym_SEMI,
    STATE(3314), 2,
      sym_comment,
      sym_documentation_comment,
  [148400] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6755), 1,
      anon_sym_RBRACK,
    STATE(3315), 2,
      sym_comment,
      sym_documentation_comment,
  [148423] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3773), 1,
      anon_sym_RPAREN,
    STATE(3316), 2,
      sym_comment,
      sym_documentation_comment,
  [148446] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6757), 1,
      anon_sym_COLON,
    STATE(3317), 2,
      sym_comment,
      sym_documentation_comment,
  [148469] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6759), 1,
      anon_sym_RPAREN,
    STATE(3318), 2,
      sym_comment,
      sym_documentation_comment,
  [148492] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6761), 1,
      anon_sym_DOT,
    STATE(3319), 2,
      sym_comment,
      sym_documentation_comment,
  [148515] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6763), 1,
      anon_sym_RPAREN,
    STATE(3320), 2,
      sym_comment,
      sym_documentation_comment,
  [148538] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6765), 1,
      anon_sym_RPAREN,
    STATE(3321), 2,
      sym_comment,
      sym_documentation_comment,
  [148561] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6767), 1,
      anon_sym_RPAREN,
    STATE(3322), 2,
      sym_comment,
      sym_documentation_comment,
  [148584] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6769), 1,
      anon_sym_RPAREN,
    STATE(3323), 2,
      sym_comment,
      sym_documentation_comment,
  [148607] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6771), 1,
      sym_identifier,
    STATE(3324), 2,
      sym_comment,
      sym_documentation_comment,
  [148630] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6773), 1,
      anon_sym_RPAREN,
    STATE(3325), 2,
      sym_comment,
      sym_documentation_comment,
  [148653] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6775), 1,
      sym_identifier,
    STATE(3326), 2,
      sym_comment,
      sym_documentation_comment,
  [148676] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6777), 1,
      anon_sym_RPAREN,
    STATE(3327), 2,
      sym_comment,
      sym_documentation_comment,
  [148699] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3753), 1,
      anon_sym_RPAREN,
    STATE(3328), 2,
      sym_comment,
      sym_documentation_comment,
  [148722] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6779), 1,
      anon_sym_RBRACK,
    STATE(3329), 2,
      sym_comment,
      sym_documentation_comment,
  [148745] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6781), 1,
      anon_sym_COLON,
    STATE(3330), 2,
      sym_comment,
      sym_documentation_comment,
  [148768] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6783), 1,
      anon_sym_SLASH,
    STATE(3331), 2,
      sym_comment,
      sym_documentation_comment,
  [148791] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6785), 1,
      sym_identifier,
    STATE(3332), 2,
      sym_comment,
      sym_documentation_comment,
  [148814] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6787), 1,
      sym_identifier,
    STATE(3333), 2,
      sym_comment,
      sym_documentation_comment,
  [148837] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6610), 1,
      anon_sym_COMMA,
    STATE(3334), 2,
      sym_comment,
      sym_documentation_comment,
  [148860] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6789), 1,
      sym_identifier,
    STATE(3335), 2,
      sym_comment,
      sym_documentation_comment,
  [148883] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5799), 1,
      anon_sym_RPAREN,
    STATE(3336), 2,
      sym_comment,
      sym_documentation_comment,
  [148906] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4206), 1,
      anon_sym_RPAREN,
    STATE(3337), 2,
      sym_comment,
      sym_documentation_comment,
  [148929] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6791), 1,
      sym_identifier,
    STATE(3338), 2,
      sym_comment,
      sym_documentation_comment,
  [148952] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6793), 1,
      anon_sym_RPAREN,
    STATE(3339), 2,
      sym_comment,
      sym_documentation_comment,
  [148975] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6559), 1,
      anon_sym_DOT,
    STATE(3340), 2,
      sym_comment,
      sym_documentation_comment,
  [148998] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6033), 1,
      anon_sym_RPAREN,
    STATE(3341), 2,
      sym_comment,
      sym_documentation_comment,
  [149021] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6795), 1,
      anon_sym_LPAREN,
    STATE(3342), 2,
      sym_comment,
      sym_documentation_comment,
  [149044] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6797), 1,
      sym_identifier,
    STATE(3343), 2,
      sym_comment,
      sym_documentation_comment,
  [149067] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6799), 1,
      sym_identifier,
    STATE(3344), 2,
      sym_comment,
      sym_documentation_comment,
  [149090] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6801), 1,
      anon_sym_LPAREN,
    STATE(3345), 2,
      sym_comment,
      sym_documentation_comment,
  [149113] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6803), 1,
      anon_sym_LPAREN,
    STATE(3346), 2,
      sym_comment,
      sym_documentation_comment,
  [149136] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6805), 1,
      anon_sym_LPAREN,
    STATE(3347), 2,
      sym_comment,
      sym_documentation_comment,
  [149159] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6807), 1,
      anon_sym_RPAREN,
    STATE(3348), 2,
      sym_comment,
      sym_documentation_comment,
  [149182] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6809), 1,
      anon_sym_COLON,
    STATE(3349), 2,
      sym_comment,
      sym_documentation_comment,
  [149205] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6811), 1,
      anon_sym_RPAREN,
    STATE(3350), 2,
      sym_comment,
      sym_documentation_comment,
  [149228] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6813), 1,
      anon_sym_RBRACK,
    STATE(3351), 2,
      sym_comment,
      sym_documentation_comment,
  [149251] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3759), 1,
      anon_sym_RPAREN,
    STATE(3352), 2,
      sym_comment,
      sym_documentation_comment,
  [149274] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6815), 1,
      anon_sym_RPAREN,
    STATE(3353), 2,
      sym_comment,
      sym_documentation_comment,
  [149297] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6817), 1,
      anon_sym_RPAREN,
    STATE(3354), 2,
      sym_comment,
      sym_documentation_comment,
  [149320] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6819), 1,
      anon_sym_RPAREN,
    STATE(3355), 2,
      sym_comment,
      sym_documentation_comment,
  [149343] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6821), 1,
      anon_sym_RPAREN,
    STATE(3356), 2,
      sym_comment,
      sym_documentation_comment,
  [149366] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6823), 1,
      anon_sym_RPAREN,
    STATE(3357), 2,
      sym_comment,
      sym_documentation_comment,
  [149389] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6825), 1,
      anon_sym_RPAREN,
    STATE(3358), 2,
      sym_comment,
      sym_documentation_comment,
  [149412] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6827), 1,
      anon_sym_RPAREN,
    STATE(3359), 2,
      sym_comment,
      sym_documentation_comment,
  [149435] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6829), 1,
      anon_sym_RPAREN,
    STATE(3360), 2,
      sym_comment,
      sym_documentation_comment,
  [149458] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6831), 1,
      sym_identifier,
    STATE(3361), 2,
      sym_comment,
      sym_documentation_comment,
  [149481] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6833), 1,
      anon_sym_RBRACE,
    STATE(3362), 2,
      sym_comment,
      sym_documentation_comment,
  [149504] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6835), 1,
      anon_sym_RPAREN,
    STATE(3363), 2,
      sym_comment,
      sym_documentation_comment,
  [149527] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6837), 1,
      anon_sym_RPAREN,
    STATE(3364), 2,
      sym_comment,
      sym_documentation_comment,
  [149550] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6839), 1,
      anon_sym_RPAREN,
    STATE(3365), 2,
      sym_comment,
      sym_documentation_comment,
  [149573] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6841), 1,
      sym_identifier,
    STATE(3366), 2,
      sym_comment,
      sym_documentation_comment,
  [149596] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6843), 1,
      sym_identifier,
    STATE(3367), 2,
      sym_comment,
      sym_documentation_comment,
  [149619] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6845), 1,
      anon_sym_LBRACE,
    STATE(3368), 2,
      sym_comment,
      sym_documentation_comment,
  [149642] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5260), 1,
      sym_identifier,
    STATE(3369), 2,
      sym_comment,
      sym_documentation_comment,
  [149665] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6847), 1,
      anon_sym_RBRACK,
    STATE(3370), 2,
      sym_comment,
      sym_documentation_comment,
  [149688] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6849), 1,
      anon_sym_LBRACE,
    STATE(3371), 2,
      sym_comment,
      sym_documentation_comment,
  [149711] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6851), 1,
      sym_identifier,
    STATE(3372), 2,
      sym_comment,
      sym_documentation_comment,
  [149734] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6853), 1,
      sym_identifier,
    STATE(3373), 2,
      sym_comment,
      sym_documentation_comment,
  [149757] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6855), 1,
      sym_identifier,
    STATE(3374), 2,
      sym_comment,
      sym_documentation_comment,
  [149780] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6857), 1,
      anon_sym_RPAREN,
    STATE(3375), 2,
      sym_comment,
      sym_documentation_comment,
  [149803] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6859), 1,
      sym_identifier,
    STATE(3376), 2,
      sym_comment,
      sym_documentation_comment,
  [149826] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6861), 1,
      anon_sym_RPAREN,
    STATE(3377), 2,
      sym_comment,
      sym_documentation_comment,
  [149849] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6863), 1,
      sym_identifier,
    STATE(3378), 2,
      sym_comment,
      sym_documentation_comment,
  [149872] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6865), 1,
      sym_identifier,
    STATE(3379), 2,
      sym_comment,
      sym_documentation_comment,
  [149895] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6867), 1,
      anon_sym_SEMI,
    STATE(3380), 2,
      sym_comment,
      sym_documentation_comment,
  [149918] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6869), 1,
      anon_sym_RBRACK,
    STATE(3381), 2,
      sym_comment,
      sym_documentation_comment,
  [149941] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6871), 1,
      sym_identifier,
    STATE(3382), 2,
      sym_comment,
      sym_documentation_comment,
  [149964] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6873), 1,
      sym_identifier,
    STATE(3383), 2,
      sym_comment,
      sym_documentation_comment,
  [149987] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6875), 1,
      anon_sym_RPAREN,
    STATE(3384), 2,
      sym_comment,
      sym_documentation_comment,
  [150010] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6877), 1,
      anon_sym_RPAREN,
    STATE(3385), 2,
      sym_comment,
      sym_documentation_comment,
  [150033] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6879), 1,
      sym_identifier,
    STATE(3386), 2,
      sym_comment,
      sym_documentation_comment,
  [150056] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6881), 1,
      sym_identifier,
    STATE(3387), 2,
      sym_comment,
      sym_documentation_comment,
  [150079] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6883), 1,
      anon_sym_RBRACK,
    STATE(3388), 2,
      sym_comment,
      sym_documentation_comment,
  [150102] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6885), 1,
      sym_identifier,
    STATE(3389), 2,
      sym_comment,
      sym_documentation_comment,
  [150125] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4168), 1,
      anon_sym_RPAREN,
    STATE(3390), 2,
      sym_comment,
      sym_documentation_comment,
  [150148] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6887), 1,
      sym_identifier,
    STATE(3391), 2,
      sym_comment,
      sym_documentation_comment,
  [150171] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6889), 1,
      sym_identifier,
    STATE(3392), 2,
      sym_comment,
      sym_documentation_comment,
  [150194] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6891), 1,
      anon_sym_RBRACK,
    STATE(3393), 2,
      sym_comment,
      sym_documentation_comment,
  [150217] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6090), 1,
      anon_sym_RPAREN,
    STATE(3394), 2,
      sym_comment,
      sym_documentation_comment,
  [150240] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6893), 1,
      anon_sym_EQ,
    STATE(3395), 2,
      sym_comment,
      sym_documentation_comment,
  [150263] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6895), 1,
      sym_identifier,
    STATE(3396), 2,
      sym_comment,
      sym_documentation_comment,
  [150286] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6897), 1,
      sym_identifier,
    STATE(3397), 2,
      sym_comment,
      sym_documentation_comment,
  [150309] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6899), 1,
      anon_sym_RBRACK,
    STATE(3398), 2,
      sym_comment,
      sym_documentation_comment,
  [150332] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6901), 1,
      anon_sym_SEMI,
    STATE(3399), 2,
      sym_comment,
      sym_documentation_comment,
  [150355] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6108), 1,
      anon_sym_RPAREN,
    STATE(3400), 2,
      sym_comment,
      sym_documentation_comment,
  [150378] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6903), 1,
      sym_identifier,
    STATE(3401), 2,
      sym_comment,
      sym_documentation_comment,
  [150401] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6905), 1,
      sym_identifier,
    STATE(3402), 2,
      sym_comment,
      sym_documentation_comment,
  [150424] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6907), 1,
      anon_sym_RBRACK,
    STATE(3403), 2,
      sym_comment,
      sym_documentation_comment,
  [150447] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4160), 1,
      anon_sym_RPAREN,
    STATE(3404), 2,
      sym_comment,
      sym_documentation_comment,
  [150470] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6909), 1,
      sym_identifier,
    STATE(3405), 2,
      sym_comment,
      sym_documentation_comment,
  [150493] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6911), 1,
      sym_identifier,
    STATE(3406), 2,
      sym_comment,
      sym_documentation_comment,
  [150516] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6913), 1,
      anon_sym_RBRACK,
    STATE(3407), 2,
      sym_comment,
      sym_documentation_comment,
  [150539] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6915), 1,
      anon_sym_EQ_GT,
    STATE(3408), 2,
      sym_comment,
      sym_documentation_comment,
  [150562] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6917), 1,
      anon_sym_EQ,
    STATE(3409), 2,
      sym_comment,
      sym_documentation_comment,
  [150585] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6919), 1,
      anon_sym_EQ,
    STATE(3410), 2,
      sym_comment,
      sym_documentation_comment,
  [150608] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6921), 1,
      sym_identifier,
    STATE(3411), 2,
      sym_comment,
      sym_documentation_comment,
  [150631] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6923), 1,
      sym_identifier,
    STATE(3412), 2,
      sym_comment,
      sym_documentation_comment,
  [150654] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6555), 1,
      anon_sym_EQ,
    STATE(3413), 2,
      sym_comment,
      sym_documentation_comment,
  [150677] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6925), 1,
      anon_sym_RPAREN,
    STATE(3414), 2,
      sym_comment,
      sym_documentation_comment,
  [150700] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6927), 1,
      anon_sym_SEMI,
    STATE(3415), 2,
      sym_comment,
      sym_documentation_comment,
  [150723] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6929), 1,
      sym_identifier,
    STATE(3416), 2,
      sym_comment,
      sym_documentation_comment,
  [150746] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6931), 1,
      anon_sym_RPAREN,
    STATE(3417), 2,
      sym_comment,
      sym_documentation_comment,
  [150769] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6933), 1,
      anon_sym_SEMI,
    STATE(3418), 2,
      sym_comment,
      sym_documentation_comment,
  [150792] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6935), 1,
      sym_identifier,
    STATE(3419), 2,
      sym_comment,
      sym_documentation_comment,
  [150815] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4747), 1,
      anon_sym_RBRACE,
    STATE(3420), 2,
      sym_comment,
      sym_documentation_comment,
  [150838] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6937), 1,
      sym_identifier,
    STATE(3421), 2,
      sym_comment,
      sym_documentation_comment,
  [150861] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6483), 1,
      anon_sym_EQ,
    STATE(3422), 2,
      sym_comment,
      sym_documentation_comment,
  [150884] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6939), 1,
      anon_sym_LBRACE,
    STATE(3423), 2,
      sym_comment,
      sym_documentation_comment,
  [150907] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6941), 1,
      anon_sym_RPAREN,
    STATE(3424), 2,
      sym_comment,
      sym_documentation_comment,
  [150930] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6943), 1,
      sym_identifier,
    STATE(3425), 2,
      sym_comment,
      sym_documentation_comment,
  [150953] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6945), 1,
      sym_identifier,
    STATE(3426), 2,
      sym_comment,
      sym_documentation_comment,
  [150976] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6615), 1,
      anon_sym_EQ,
    STATE(3427), 2,
      sym_comment,
      sym_documentation_comment,
  [150999] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6571), 1,
      anon_sym_SEMI,
    STATE(3428), 2,
      sym_comment,
      sym_documentation_comment,
  [151022] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6947), 1,
      anon_sym_LBRACK,
    STATE(3429), 2,
      sym_comment,
      sym_documentation_comment,
  [151045] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6949), 1,
      ts_builtin_sym_end,
    STATE(3430), 2,
      sym_comment,
      sym_documentation_comment,
  [151068] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6951), 1,
      sym_identifier,
    STATE(3431), 2,
      sym_comment,
      sym_documentation_comment,
  [151091] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6953), 1,
      anon_sym_SEMI,
    STATE(3432), 2,
      sym_comment,
      sym_documentation_comment,
  [151114] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6955), 1,
      anon_sym_LBRACE,
    STATE(3433), 2,
      sym_comment,
      sym_documentation_comment,
  [151137] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6163), 1,
      anon_sym_RPAREN,
    STATE(3434), 2,
      sym_comment,
      sym_documentation_comment,
  [151160] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6957), 1,
      anon_sym_SEMI,
    STATE(3435), 2,
      sym_comment,
      sym_documentation_comment,
  [151183] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6959), 1,
      anon_sym_RPAREN,
    STATE(3436), 2,
      sym_comment,
      sym_documentation_comment,
  [151206] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6961), 1,
      anon_sym_RPAREN,
    STATE(3437), 2,
      sym_comment,
      sym_documentation_comment,
  [151229] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6963), 1,
      anon_sym_RPAREN,
    STATE(3438), 2,
      sym_comment,
      sym_documentation_comment,
  [151252] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6965), 1,
      sym_identifier,
    STATE(3439), 2,
      sym_comment,
      sym_documentation_comment,
  [151275] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6967), 1,
      anon_sym_RPAREN,
    STATE(3440), 2,
      sym_comment,
      sym_documentation_comment,
  [151298] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6969), 1,
      anon_sym_RPAREN,
    STATE(3441), 2,
      sym_comment,
      sym_documentation_comment,
  [151321] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6971), 1,
      anon_sym_RBRACE,
    STATE(3442), 2,
      sym_comment,
      sym_documentation_comment,
  [151344] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5321), 1,
      sym_identifier,
    STATE(3443), 2,
      sym_comment,
      sym_documentation_comment,
  [151367] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6973), 1,
      sym_identifier,
    STATE(3444), 2,
      sym_comment,
      sym_documentation_comment,
  [151390] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6975), 1,
      anon_sym_RPAREN,
    STATE(3445), 2,
      sym_comment,
      sym_documentation_comment,
  [151413] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6977), 1,
      anon_sym_RPAREN,
    STATE(3446), 2,
      sym_comment,
      sym_documentation_comment,
  [151436] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6216), 1,
      anon_sym_RPAREN,
    STATE(3447), 2,
      sym_comment,
      sym_documentation_comment,
  [151459] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6979), 1,
      sym_identifier,
    STATE(3448), 2,
      sym_comment,
      sym_documentation_comment,
  [151482] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6981), 1,
      anon_sym_RBRACK,
    STATE(3449), 2,
      sym_comment,
      sym_documentation_comment,
  [151505] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6983), 1,
      anon_sym_while,
    STATE(3450), 2,
      sym_comment,
      sym_documentation_comment,
  [151528] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6985), 1,
      anon_sym_RPAREN,
    STATE(3451), 2,
      sym_comment,
      sym_documentation_comment,
  [151551] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6987), 1,
      anon_sym_RPAREN,
    STATE(3452), 2,
      sym_comment,
      sym_documentation_comment,
  [151574] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6989), 1,
      anon_sym_on,
    STATE(3453), 2,
      sym_comment,
      sym_documentation_comment,
  [151597] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4608), 1,
      anon_sym_DOT,
    STATE(3454), 2,
      sym_comment,
      sym_documentation_comment,
  [151620] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6591), 1,
      anon_sym_COMMA,
    STATE(3455), 2,
      sym_comment,
      sym_documentation_comment,
  [151643] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6991), 1,
      anon_sym_RPAREN,
    STATE(3456), 2,
      sym_comment,
      sym_documentation_comment,
  [151666] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6993), 1,
      sym_identifier,
    STATE(3457), 2,
      sym_comment,
      sym_documentation_comment,
  [151689] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6995), 1,
      anon_sym_DOT,
    STATE(3458), 2,
      sym_comment,
      sym_documentation_comment,
  [151712] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(6997), 1,
      anon_sym_LF,
    STATE(3459), 2,
      sym_comment,
      sym_documentation_comment,
  [151735] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6999), 1,
      anon_sym_RPAREN,
    STATE(3460), 2,
      sym_comment,
      sym_documentation_comment,
  [151758] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7001), 1,
      anon_sym_SEMI,
    STATE(3461), 2,
      sym_comment,
      sym_documentation_comment,
  [151781] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7003), 1,
      anon_sym_COLON,
    STATE(3462), 2,
      sym_comment,
      sym_documentation_comment,
  [151804] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7005), 1,
      anon_sym_RBRACE,
    STATE(3463), 2,
      sym_comment,
      sym_documentation_comment,
  [151827] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1502), 1,
      anon_sym_COLON,
    STATE(3464), 2,
      sym_comment,
      sym_documentation_comment,
  [151850] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3783), 1,
      anon_sym_RPAREN,
    STATE(3465), 2,
      sym_comment,
      sym_documentation_comment,
  [151873] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7007), 1,
      anon_sym_RBRACK,
    STATE(3466), 2,
      sym_comment,
      sym_documentation_comment,
  [151896] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7009), 1,
      anon_sym_COLON,
    STATE(3467), 2,
      sym_comment,
      sym_documentation_comment,
  [151919] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7011), 1,
      anon_sym_COLON,
    STATE(3468), 2,
      sym_comment,
      sym_documentation_comment,
  [151942] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7013), 1,
      sym_identifier,
    STATE(3469), 2,
      sym_comment,
      sym_documentation_comment,
  [151965] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5928), 1,
      anon_sym_RPAREN,
    STATE(3470), 2,
      sym_comment,
      sym_documentation_comment,
  [151988] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7015), 1,
      anon_sym_COLON,
    STATE(3471), 2,
      sym_comment,
      sym_documentation_comment,
  [152011] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7017), 1,
      anon_sym_RPAREN,
    STATE(3472), 2,
      sym_comment,
      sym_documentation_comment,
  [152034] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7019), 1,
      anon_sym_DOT,
    STATE(3473), 2,
      sym_comment,
      sym_documentation_comment,
  [152057] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7021), 1,
      anon_sym_class,
    STATE(3474), 2,
      sym_comment,
      sym_documentation_comment,
  [152080] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6476), 1,
      anon_sym_COMMA,
    STATE(3475), 2,
      sym_comment,
      sym_documentation_comment,
  [152103] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7023), 1,
      anon_sym_DOT,
    STATE(3476), 2,
      sym_comment,
      sym_documentation_comment,
  [152126] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7025), 1,
      anon_sym_RBRACK,
    STATE(3477), 2,
      sym_comment,
      sym_documentation_comment,
  [152149] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7027), 1,
      sym_identifier,
    STATE(3478), 2,
      sym_comment,
      sym_documentation_comment,
  [152172] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7029), 1,
      anon_sym_class,
    STATE(3479), 2,
      sym_comment,
      sym_documentation_comment,
  [152195] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6249), 1,
      anon_sym_RPAREN,
    STATE(3480), 2,
      sym_comment,
      sym_documentation_comment,
  [152218] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7031), 1,
      anon_sym_LPAREN,
    STATE(3481), 2,
      sym_comment,
      sym_documentation_comment,
  [152241] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7033), 1,
      anon_sym_as,
    STATE(3482), 2,
      sym_comment,
      sym_documentation_comment,
  [152264] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7035), 1,
      anon_sym_LPAREN,
    STATE(3483), 2,
      sym_comment,
      sym_documentation_comment,
  [152287] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3757), 1,
      anon_sym_RPAREN,
    STATE(3484), 2,
      sym_comment,
      sym_documentation_comment,
  [152310] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7037), 1,
      sym_identifier,
    STATE(3485), 2,
      sym_comment,
      sym_documentation_comment,
  [152333] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7039), 1,
      sym_identifier,
    STATE(3486), 2,
      sym_comment,
      sym_documentation_comment,
  [152356] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6530), 1,
      anon_sym_RPAREN,
    STATE(3487), 2,
      sym_comment,
      sym_documentation_comment,
  [152379] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7041), 1,
      sym_identifier,
    STATE(3488), 2,
      sym_comment,
      sym_documentation_comment,
  [152402] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7043), 1,
      anon_sym_RPAREN,
    STATE(3489), 2,
      sym_comment,
      sym_documentation_comment,
  [152425] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7045), 1,
      sym_identifier,
    STATE(3490), 2,
      sym_comment,
      sym_documentation_comment,
  [152448] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7047), 1,
      anon_sym_EQ,
    STATE(3491), 2,
      sym_comment,
      sym_documentation_comment,
  [152471] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7049), 1,
      anon_sym_RBRACE,
    STATE(3492), 2,
      sym_comment,
      sym_documentation_comment,
  [152494] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7051), 1,
      anon_sym_class,
    STATE(3493), 2,
      sym_comment,
      sym_documentation_comment,
  [152517] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7053), 1,
      anon_sym_RPAREN,
    STATE(3494), 2,
      sym_comment,
      sym_documentation_comment,
  [152540] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5674), 1,
      sym_identifier,
    STATE(3495), 2,
      sym_comment,
      sym_documentation_comment,
  [152563] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6098), 1,
      anon_sym_RPAREN,
    STATE(3496), 2,
      sym_comment,
      sym_documentation_comment,
  [152586] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7055), 1,
      anon_sym_LPAREN,
    STATE(3497), 2,
      sym_comment,
      sym_documentation_comment,
  [152609] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7057), 1,
      anon_sym_LPAREN,
    STATE(3498), 2,
      sym_comment,
      sym_documentation_comment,
  [152632] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7059), 1,
      sym_identifier,
    STATE(3499), 2,
      sym_comment,
      sym_documentation_comment,
  [152655] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7061), 1,
      sym_identifier,
    STATE(3500), 2,
      sym_comment,
      sym_documentation_comment,
  [152678] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7063), 1,
      sym_identifier,
    STATE(3501), 2,
      sym_comment,
      sym_documentation_comment,
  [152701] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7065), 1,
      anon_sym_SEMI,
    STATE(3502), 2,
      sym_comment,
      sym_documentation_comment,
  [152724] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5130), 1,
      anon_sym_SEMI,
    STATE(3503), 2,
      sym_comment,
      sym_documentation_comment,
  [152747] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(7067), 1,
      aux_sym_script_tag_token1,
    STATE(3504), 2,
      sym_comment,
      sym_documentation_comment,
  [152770] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7069), 1,
      anon_sym_SEMI,
    STATE(3505), 2,
      sym_comment,
      sym_documentation_comment,
  [152793] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7071), 1,
      anon_sym_RPAREN,
    STATE(3506), 2,
      sym_comment,
      sym_documentation_comment,
  [152816] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7073), 1,
      anon_sym_RPAREN,
    STATE(3507), 2,
      sym_comment,
      sym_documentation_comment,
  [152839] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7075), 1,
      anon_sym_part,
    STATE(3508), 2,
      sym_comment,
      sym_documentation_comment,
  [152862] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(1635), 1,
      sym_part_of_builtin,
    STATE(3509), 2,
      sym_comment,
      sym_documentation_comment,
  [152885] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7077), 1,
      anon_sym_RPAREN,
    STATE(3510), 2,
      sym_comment,
      sym_documentation_comment,
  [152908] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7079), 1,
      anon_sym_on,
    STATE(3511), 2,
      sym_comment,
      sym_documentation_comment,
  [152931] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7081), 1,
      anon_sym_RPAREN,
    STATE(3512), 2,
      sym_comment,
      sym_documentation_comment,
  [152954] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7083), 1,
      anon_sym_EQ,
    STATE(3513), 2,
      sym_comment,
      sym_documentation_comment,
  [152977] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7085), 1,
      sym_identifier,
    STATE(3514), 2,
      sym_comment,
      sym_documentation_comment,
  [153000] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7087), 1,
      anon_sym_class,
    STATE(3515), 2,
      sym_comment,
      sym_documentation_comment,
  [153023] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4238), 1,
      anon_sym_RPAREN,
    STATE(3516), 2,
      sym_comment,
      sym_documentation_comment,
  [153046] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7089), 1,
      anon_sym_RPAREN,
    STATE(3517), 2,
      sym_comment,
      sym_documentation_comment,
  [153069] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7091), 1,
      anon_sym_RPAREN,
    STATE(3518), 2,
      sym_comment,
      sym_documentation_comment,
  [153092] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7093), 1,
      anon_sym_SEMI,
    STATE(3519), 2,
      sym_comment,
      sym_documentation_comment,
  [153115] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7095), 1,
      anon_sym_SEMI,
    STATE(3520), 2,
      sym_comment,
      sym_documentation_comment,
  [153138] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4216), 1,
      anon_sym_RPAREN,
    STATE(3521), 2,
      sym_comment,
      sym_documentation_comment,
  [153161] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6323), 1,
      anon_sym_RPAREN,
    STATE(3522), 2,
      sym_comment,
      sym_documentation_comment,
  [153184] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7097), 1,
      sym_identifier,
    STATE(3523), 2,
      sym_comment,
      sym_documentation_comment,
  [153207] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7099), 1,
      sym_identifier,
    STATE(3524), 2,
      sym_comment,
      sym_documentation_comment,
  [153230] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6317), 1,
      anon_sym_class,
    STATE(3525), 2,
      sym_comment,
      sym_documentation_comment,
  [153253] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7101), 1,
      anon_sym_RPAREN,
    STATE(3526), 2,
      sym_comment,
      sym_documentation_comment,
  [153276] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7103), 1,
      sym_identifier,
    STATE(3527), 2,
      sym_comment,
      sym_documentation_comment,
  [153299] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4791), 1,
      anon_sym_SEMI,
    STATE(3528), 2,
      sym_comment,
      sym_documentation_comment,
  [153322] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7105), 1,
      sym_identifier,
    STATE(3529), 2,
      sym_comment,
      sym_documentation_comment,
  [153345] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7107), 1,
      sym_identifier,
    STATE(3530), 2,
      sym_comment,
      sym_documentation_comment,
  [153368] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7109), 1,
      sym_identifier,
    STATE(3531), 2,
      sym_comment,
      sym_documentation_comment,
  [153391] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7111), 1,
      sym_identifier,
    STATE(3532), 2,
      sym_comment,
      sym_documentation_comment,
  [153414] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7113), 1,
      anon_sym_EQ,
    STATE(3533), 2,
      sym_comment,
      sym_documentation_comment,
  [153437] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7115), 1,
      sym_identifier,
    STATE(3534), 2,
      sym_comment,
      sym_documentation_comment,
  [153460] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7117), 1,
      sym_identifier,
    STATE(3535), 2,
      sym_comment,
      sym_documentation_comment,
  [153483] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7120), 1,
      sym_identifier,
    STATE(3536), 2,
      sym_comment,
      sym_documentation_comment,
  [153506] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7122), 1,
      sym_identifier,
    STATE(3537), 2,
      sym_comment,
      sym_documentation_comment,
  [153529] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7124), 1,
      anon_sym_DOT,
    STATE(3538), 2,
      sym_comment,
      sym_documentation_comment,
  [153552] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(4955), 1,
      anon_sym_class,
    STATE(3539), 2,
      sym_comment,
      sym_documentation_comment,
  [153575] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7126), 1,
      anon_sym_RPAREN,
    STATE(3540), 2,
      sym_comment,
      sym_documentation_comment,
  [153598] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7128), 1,
      sym_identifier,
    STATE(3541), 2,
      sym_comment,
      sym_documentation_comment,
  [153621] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5323), 1,
      anon_sym_SEMI,
    STATE(3542), 2,
      sym_comment,
      sym_documentation_comment,
  [153644] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7130), 1,
      sym_identifier,
    STATE(3543), 2,
      sym_comment,
      sym_documentation_comment,
  [153667] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7132), 1,
      anon_sym_COLON,
    STATE(3544), 2,
      sym_comment,
      sym_documentation_comment,
  [153690] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(7134), 1,
      aux_sym_documentation_comment_token1,
    STATE(3545), 2,
      sym_comment,
      sym_documentation_comment,
  [153713] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7136), 1,
      anon_sym_SEMI,
    STATE(3546), 2,
      sym_comment,
      sym_documentation_comment,
  [153736] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7138), 1,
      sym_identifier,
    STATE(3547), 2,
      sym_comment,
      sym_documentation_comment,
  [153759] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7140), 1,
      anon_sym_SEMI,
    STATE(3548), 2,
      sym_comment,
      sym_documentation_comment,
  [153782] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7142), 1,
      sym_identifier,
    STATE(3549), 2,
      sym_comment,
      sym_documentation_comment,
  [153805] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(7144), 1,
      aux_sym_comment_token2,
    STATE(3550), 2,
      sym_comment,
      sym_documentation_comment,
  [153828] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7146), 1,
      anon_sym_DOT,
    STATE(3551), 2,
      sym_comment,
      sym_documentation_comment,
  [153851] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(6527), 1,
      anon_sym_COMMA,
    STATE(3552), 2,
      sym_comment,
      sym_documentation_comment,
  [153874] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(5165), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(5167), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(7148), 1,
      aux_sym_comment_token1,
    STATE(3553), 2,
      sym_comment,
      sym_documentation_comment,
  [153897] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7150), 1,
      anon_sym_LBRACE,
    STATE(3554), 2,
      sym_comment,
      sym_documentation_comment,
  [153920] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7152), 1,
      anon_sym_RPAREN,
    STATE(3555), 2,
      sym_comment,
      sym_documentation_comment,
  [153943] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7154), 1,
      anon_sym_RPAREN,
    STATE(3556), 2,
      sym_comment,
      sym_documentation_comment,
  [153966] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7156), 1,
      sym_identifier,
    STATE(3557), 2,
      sym_comment,
      sym_documentation_comment,
  [153989] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7158), 1,
      anon_sym_COLON,
    STATE(3558), 2,
      sym_comment,
      sym_documentation_comment,
  [154012] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7160), 1,
      anon_sym_RPAREN,
    STATE(3559), 2,
      sym_comment,
      sym_documentation_comment,
  [154035] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7162), 1,
      sym_identifier,
    STATE(3560), 2,
      sym_comment,
      sym_documentation_comment,
  [154058] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7164), 1,
      anon_sym_LBRACE,
    STATE(3561), 2,
      sym_comment,
      sym_documentation_comment,
  [154081] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7166), 1,
      anon_sym_RPAREN,
    STATE(3562), 2,
      sym_comment,
      sym_documentation_comment,
  [154104] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(3771), 1,
      anon_sym_RPAREN,
    STATE(3563), 2,
      sym_comment,
      sym_documentation_comment,
  [154127] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7168), 1,
      anon_sym_RPAREN,
    STATE(3564), 2,
      sym_comment,
      sym_documentation_comment,
  [154150] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7170), 1,
      anon_sym_LBRACE,
    STATE(3565), 2,
      sym_comment,
      sym_documentation_comment,
  [154173] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7172), 1,
      anon_sym_RPAREN,
    STATE(3566), 2,
      sym_comment,
      sym_documentation_comment,
  [154196] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7174), 1,
      sym_identifier,
    STATE(3567), 2,
      sym_comment,
      sym_documentation_comment,
  [154219] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7176), 1,
      anon_sym_RPAREN,
    STATE(3568), 2,
      sym_comment,
      sym_documentation_comment,
  [154242] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7178), 1,
      anon_sym_RPAREN,
    STATE(3569), 2,
      sym_comment,
      sym_documentation_comment,
  [154265] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7180), 1,
      anon_sym_RPAREN,
    STATE(3570), 2,
      sym_comment,
      sym_documentation_comment,
  [154288] = 7,
    ACTIONS(3), 1,
      anon_sym_SLASH_SLASH,
    ACTIONS(5), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(7), 1,
      anon_sym_SLASH_SLASH_SLASH,
    ACTIONS(9), 1,
      sym__block_comment,
    ACTIONS(11), 1,
      sym__documentation_block_comment,
    ACTIONS(7182), 1,
      anon_sym_RPAREN,
    STATE(3571), 2,
      sym_comment,
      sym_documentation_comment,
  [154311] = 1,
    ACTIONS(7184), 1,
      ts_builtin_sym_end,
  [154315] = 1,
    ACTIONS(7186), 1,
      ts_builtin_sym_end,
  [154319] = 1,
    ACTIONS(7188), 1,
      ts_builtin_sym_end,
  [154323] = 1,
    ACTIONS(7190), 1,
      ts_builtin_sym_end,
  [154327] = 1,
    ACTIONS(7192), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(494)] = 0,
  [SMALL_STATE(495)] = 147,
  [SMALL_STATE(496)] = 294,
  [SMALL_STATE(497)] = 385,
  [SMALL_STATE(498)] = 478,
  [SMALL_STATE(499)] = 625,
  [SMALL_STATE(500)] = 718,
  [SMALL_STATE(501)] = 865,
  [SMALL_STATE(502)] = 1004,
  [SMALL_STATE(503)] = 1151,
  [SMALL_STATE(504)] = 1298,
  [SMALL_STATE(505)] = 1445,
  [SMALL_STATE(506)] = 1592,
  [SMALL_STATE(507)] = 1729,
  [SMALL_STATE(508)] = 1876,
  [SMALL_STATE(509)] = 2028,
  [SMALL_STATE(510)] = 2124,
  [SMALL_STATE(511)] = 2276,
  [SMALL_STATE(512)] = 2356,
  [SMALL_STATE(513)] = 2436,
  [SMALL_STATE(514)] = 2548,
  [SMALL_STATE(515)] = 2660,
  [SMALL_STATE(516)] = 2770,
  [SMALL_STATE(517)] = 2876,
  [SMALL_STATE(518)] = 2984,
  [SMALL_STATE(519)] = 3063,
  [SMALL_STATE(520)] = 3142,
  [SMALL_STATE(521)] = 3221,
  [SMALL_STATE(522)] = 3312,
  [SMALL_STATE(523)] = 3391,
  [SMALL_STATE(524)] = 3470,
  [SMALL_STATE(525)] = 3549,
  [SMALL_STATE(526)] = 3628,
  [SMALL_STATE(527)] = 3707,
  [SMALL_STATE(528)] = 3786,
  [SMALL_STATE(529)] = 3865,
  [SMALL_STATE(530)] = 3944,
  [SMALL_STATE(531)] = 4023,
  [SMALL_STATE(532)] = 4104,
  [SMALL_STATE(533)] = 4193,
  [SMALL_STATE(534)] = 4272,
  [SMALL_STATE(535)] = 4351,
  [SMALL_STATE(536)] = 4430,
  [SMALL_STATE(537)] = 4509,
  [SMALL_STATE(538)] = 4588,
  [SMALL_STATE(539)] = 4667,
  [SMALL_STATE(540)] = 4746,
  [SMALL_STATE(541)] = 4825,
  [SMALL_STATE(542)] = 4904,
  [SMALL_STATE(543)] = 4983,
  [SMALL_STATE(544)] = 5062,
  [SMALL_STATE(545)] = 5141,
  [SMALL_STATE(546)] = 5220,
  [SMALL_STATE(547)] = 5299,
  [SMALL_STATE(548)] = 5380,
  [SMALL_STATE(549)] = 5459,
  [SMALL_STATE(550)] = 5538,
  [SMALL_STATE(551)] = 5717,
  [SMALL_STATE(552)] = 5796,
  [SMALL_STATE(553)] = 5874,
  [SMALL_STATE(554)] = 6018,
  [SMALL_STATE(555)] = 6162,
  [SMALL_STATE(556)] = 6298,
  [SMALL_STATE(557)] = 6376,
  [SMALL_STATE(558)] = 6520,
  [SMALL_STATE(559)] = 6664,
  [SMALL_STATE(560)] = 6808,
  [SMALL_STATE(561)] = 6984,
  [SMALL_STATE(562)] = 7074,
  [SMALL_STATE(563)] = 7218,
  [SMALL_STATE(564)] = 7296,
  [SMALL_STATE(565)] = 7440,
  [SMALL_STATE(566)] = 7518,
  [SMALL_STATE(567)] = 7606,
  [SMALL_STATE(568)] = 7684,
  [SMALL_STATE(569)] = 7766,
  [SMALL_STATE(570)] = 7910,
  [SMALL_STATE(571)] = 7992,
  [SMALL_STATE(572)] = 8070,
  [SMALL_STATE(573)] = 8204,
  [SMALL_STATE(574)] = 8294,
  [SMALL_STATE(575)] = 8438,
  [SMALL_STATE(576)] = 8516,
  [SMALL_STATE(577)] = 8598,
  [SMALL_STATE(578)] = 8771,
  [SMALL_STATE(579)] = 8848,
  [SMALL_STATE(580)] = 8925,
  [SMALL_STATE(581)] = 9002,
  [SMALL_STATE(582)] = 9079,
  [SMALL_STATE(583)] = 9156,
  [SMALL_STATE(584)] = 9233,
  [SMALL_STATE(585)] = 9310,
  [SMALL_STATE(586)] = 9387,
  [SMALL_STATE(587)] = 9560,
  [SMALL_STATE(588)] = 9637,
  [SMALL_STATE(589)] = 9810,
  [SMALL_STATE(590)] = 9981,
  [SMALL_STATE(591)] = 10154,
  [SMALL_STATE(592)] = 10231,
  [SMALL_STATE(593)] = 10326,
  [SMALL_STATE(594)] = 10499,
  [SMALL_STATE(595)] = 10576,
  [SMALL_STATE(596)] = 10673,
  [SMALL_STATE(597)] = 10846,
  [SMALL_STATE(598)] = 11017,
  [SMALL_STATE(599)] = 11190,
  [SMALL_STATE(600)] = 11363,
  [SMALL_STATE(601)] = 11440,
  [SMALL_STATE(602)] = 11613,
  [SMALL_STATE(603)] = 11690,
  [SMALL_STATE(604)] = 11863,
  [SMALL_STATE(605)] = 11951,
  [SMALL_STATE(606)] = 12037,
  [SMALL_STATE(607)] = 12113,
  [SMALL_STATE(608)] = 12188,
  [SMALL_STATE(609)] = 12263,
  [SMALL_STATE(610)] = 12358,
  [SMALL_STATE(611)] = 12451,
  [SMALL_STATE(612)] = 12526,
  [SMALL_STATE(613)] = 12601,
  [SMALL_STATE(614)] = 12676,
  [SMALL_STATE(615)] = 12751,
  [SMALL_STATE(616)] = 12826,
  [SMALL_STATE(617)] = 12901,
  [SMALL_STATE(618)] = 12976,
  [SMALL_STATE(619)] = 13067,
  [SMALL_STATE(620)] = 13142,
  [SMALL_STATE(621)] = 13221,
  [SMALL_STATE(622)] = 13300,
  [SMALL_STATE(623)] = 13375,
  [SMALL_STATE(624)] = 13454,
  [SMALL_STATE(625)] = 13529,
  [SMALL_STATE(626)] = 13604,
  [SMALL_STATE(627)] = 13679,
  [SMALL_STATE(628)] = 13754,
  [SMALL_STATE(629)] = 13829,
  [SMALL_STATE(630)] = 13920,
  [SMALL_STATE(631)] = 14015,
  [SMALL_STATE(632)] = 14090,
  [SMALL_STATE(633)] = 14165,
  [SMALL_STATE(634)] = 14240,
  [SMALL_STATE(635)] = 14315,
  [SMALL_STATE(636)] = 14390,
  [SMALL_STATE(637)] = 14465,
  [SMALL_STATE(638)] = 14539,
  [SMALL_STATE(639)] = 14613,
  [SMALL_STATE(640)] = 14687,
  [SMALL_STATE(641)] = 14771,
  [SMALL_STATE(642)] = 14845,
  [SMALL_STATE(643)] = 14935,
  [SMALL_STATE(644)] = 15041,
  [SMALL_STATE(645)] = 15115,
  [SMALL_STATE(646)] = 15207,
  [SMALL_STATE(647)] = 15281,
  [SMALL_STATE(648)] = 15355,
  [SMALL_STATE(649)] = 15461,
  [SMALL_STATE(650)] = 15535,
  [SMALL_STATE(651)] = 15609,
  [SMALL_STATE(652)] = 15683,
  [SMALL_STATE(653)] = 15757,
  [SMALL_STATE(654)] = 15831,
  [SMALL_STATE(655)] = 15937,
  [SMALL_STATE(656)] = 16027,
  [SMALL_STATE(657)] = 16115,
  [SMALL_STATE(658)] = 16189,
  [SMALL_STATE(659)] = 16277,
  [SMALL_STATE(660)] = 16383,
  [SMALL_STATE(661)] = 16526,
  [SMALL_STATE(662)] = 16599,
  [SMALL_STATE(663)] = 16676,
  [SMALL_STATE(664)] = 16775,
  [SMALL_STATE(665)] = 16878,
  [SMALL_STATE(666)] = 16951,
  [SMALL_STATE(667)] = 17024,
  [SMALL_STATE(668)] = 17185,
  [SMALL_STATE(669)] = 17290,
  [SMALL_STATE(670)] = 17393,
  [SMALL_STATE(671)] = 17496,
  [SMALL_STATE(672)] = 17569,
  [SMALL_STATE(673)] = 17672,
  [SMALL_STATE(674)] = 17749,
  [SMALL_STATE(675)] = 17854,
  [SMALL_STATE(676)] = 17931,
  [SMALL_STATE(677)] = 18004,
  [SMALL_STATE(678)] = 18119,
  [SMALL_STATE(679)] = 18208,
  [SMALL_STATE(680)] = 18310,
  [SMALL_STATE(681)] = 18468,
  [SMALL_STATE(682)] = 18554,
  [SMALL_STATE(683)] = 18656,
  [SMALL_STATE(684)] = 18791,
  [SMALL_STATE(685)] = 18894,
  [SMALL_STATE(686)] = 19049,
  [SMALL_STATE(687)] = 19184,
  [SMALL_STATE(688)] = 19339,
  [SMALL_STATE(689)] = 19474,
  [SMALL_STATE(690)] = 19609,
  [SMALL_STATE(691)] = 19712,
  [SMALL_STATE(692)] = 19815,
  [SMALL_STATE(693)] = 19950,
  [SMALL_STATE(694)] = 20093,
  [SMALL_STATE(695)] = 20228,
  [SMALL_STATE(696)] = 20363,
  [SMALL_STATE(697)] = 20518,
  [SMALL_STATE(698)] = 20645,
  [SMALL_STATE(699)] = 20780,
  [SMALL_STATE(700)] = 20883,
  [SMALL_STATE(701)] = 21018,
  [SMALL_STATE(702)] = 21121,
  [SMALL_STATE(703)] = 21264,
  [SMALL_STATE(704)] = 21367,
  [SMALL_STATE(705)] = 21496,
  [SMALL_STATE(706)] = 21596,
  [SMALL_STATE(707)] = 21696,
  [SMALL_STATE(708)] = 21796,
  [SMALL_STATE(709)] = 21896,
  [SMALL_STATE(710)] = 22048,
  [SMALL_STATE(711)] = 22144,
  [SMALL_STATE(712)] = 22244,
  [SMALL_STATE(713)] = 22344,
  [SMALL_STATE(714)] = 22479,
  [SMALL_STATE(715)] = 22604,
  [SMALL_STATE(716)] = 22739,
  [SMALL_STATE(717)] = 22840,
  [SMALL_STATE(718)] = 22941,
  [SMALL_STATE(719)] = 23076,
  [SMALL_STATE(720)] = 23177,
  [SMALL_STATE(721)] = 23312,
  [SMALL_STATE(722)] = 23439,
  [SMALL_STATE(723)] = 23580,
  [SMALL_STATE(724)] = 23715,
  [SMALL_STATE(725)] = 23850,
  [SMALL_STATE(726)] = 23985,
  [SMALL_STATE(727)] = 24120,
  [SMALL_STATE(728)] = 24255,
  [SMALL_STATE(729)] = 24356,
  [SMALL_STATE(730)] = 24424,
  [SMALL_STATE(731)] = 24492,
  [SMALL_STATE(732)] = 24560,
  [SMALL_STATE(733)] = 24628,
  [SMALL_STATE(734)] = 24696,
  [SMALL_STATE(735)] = 24764,
  [SMALL_STATE(736)] = 24832,
  [SMALL_STATE(737)] = 24900,
  [SMALL_STATE(738)] = 24968,
  [SMALL_STATE(739)] = 25036,
  [SMALL_STATE(740)] = 25104,
  [SMALL_STATE(741)] = 25172,
  [SMALL_STATE(742)] = 25270,
  [SMALL_STATE(743)] = 25368,
  [SMALL_STATE(744)] = 25436,
  [SMALL_STATE(745)] = 25530,
  [SMALL_STATE(746)] = 25598,
  [SMALL_STATE(747)] = 25666,
  [SMALL_STATE(748)] = 25734,
  [SMALL_STATE(749)] = 25832,
  [SMALL_STATE(750)] = 25930,
  [SMALL_STATE(751)] = 25998,
  [SMALL_STATE(752)] = 26143,
  [SMALL_STATE(753)] = 26222,
  [SMALL_STATE(754)] = 26353,
  [SMALL_STATE(755)] = 26484,
  [SMALL_STATE(756)] = 26607,
  [SMALL_STATE(757)] = 26732,
  [SMALL_STATE(758)] = 26865,
  [SMALL_STATE(759)] = 26940,
  [SMALL_STATE(760)] = 27043,
  [SMALL_STATE(761)] = 27174,
  [SMALL_STATE(762)] = 27307,
  [SMALL_STATE(763)] = 27434,
  [SMALL_STATE(764)] = 27565,
  [SMALL_STATE(765)] = 27710,
  [SMALL_STATE(766)] = 27841,
  [SMALL_STATE(767)] = 27916,
  [SMALL_STATE(768)] = 28049,
  [SMALL_STATE(769)] = 28182,
  [SMALL_STATE(770)] = 28313,
  [SMALL_STATE(771)] = 28444,
  [SMALL_STATE(772)] = 28575,
  [SMALL_STATE(773)] = 28708,
  [SMALL_STATE(774)] = 28833,
  [SMALL_STATE(775)] = 28906,
  [SMALL_STATE(776)] = 29037,
  [SMALL_STATE(777)] = 29170,
  [SMALL_STATE(778)] = 29249,
  [SMALL_STATE(779)] = 29382,
  [SMALL_STATE(780)] = 29505,
  [SMALL_STATE(781)] = 29638,
  [SMALL_STATE(782)] = 29741,
  [SMALL_STATE(783)] = 29874,
  [SMALL_STATE(784)] = 30016,
  [SMALL_STATE(785)] = 30090,
  [SMALL_STATE(786)] = 30226,
  [SMALL_STATE(787)] = 30320,
  [SMALL_STATE(788)] = 30396,
  [SMALL_STATE(789)] = 30538,
  [SMALL_STATE(790)] = 30612,
  [SMALL_STATE(791)] = 30748,
  [SMALL_STATE(792)] = 30820,
  [SMALL_STATE(793)] = 30892,
  [SMALL_STATE(794)] = 30966,
  [SMALL_STATE(795)] = 31032,
  [SMALL_STATE(796)] = 31106,
  [SMALL_STATE(797)] = 31172,
  [SMALL_STATE(798)] = 31246,
  [SMALL_STATE(799)] = 31312,
  [SMALL_STATE(800)] = 31378,
  [SMALL_STATE(801)] = 31520,
  [SMALL_STATE(802)] = 31594,
  [SMALL_STATE(803)] = 31660,
  [SMALL_STATE(804)] = 31726,
  [SMALL_STATE(805)] = 31792,
  [SMALL_STATE(806)] = 31866,
  [SMALL_STATE(807)] = 31932,
  [SMALL_STATE(808)] = 31998,
  [SMALL_STATE(809)] = 32064,
  [SMALL_STATE(810)] = 32130,
  [SMALL_STATE(811)] = 32196,
  [SMALL_STATE(812)] = 32262,
  [SMALL_STATE(813)] = 32328,
  [SMALL_STATE(814)] = 32394,
  [SMALL_STATE(815)] = 32460,
  [SMALL_STATE(816)] = 32526,
  [SMALL_STATE(817)] = 32597,
  [SMALL_STATE(818)] = 32666,
  [SMALL_STATE(819)] = 32735,
  [SMALL_STATE(820)] = 32806,
  [SMALL_STATE(821)] = 32875,
  [SMALL_STATE(822)] = 32944,
  [SMALL_STATE(823)] = 33013,
  [SMALL_STATE(824)] = 33116,
  [SMALL_STATE(825)] = 33185,
  [SMALL_STATE(826)] = 33324,
  [SMALL_STATE(827)] = 33463,
  [SMALL_STATE(828)] = 33532,
  [SMALL_STATE(829)] = 33601,
  [SMALL_STATE(830)] = 33670,
  [SMALL_STATE(831)] = 33773,
  [SMALL_STATE(832)] = 33912,
  [SMALL_STATE(833)] = 33985,
  [SMALL_STATE(834)] = 34054,
  [SMALL_STATE(835)] = 34123,
  [SMALL_STATE(836)] = 34192,
  [SMALL_STATE(837)] = 34256,
  [SMALL_STATE(838)] = 34392,
  [SMALL_STATE(839)] = 34456,
  [SMALL_STATE(840)] = 34522,
  [SMALL_STATE(841)] = 34588,
  [SMALL_STATE(842)] = 34654,
  [SMALL_STATE(843)] = 34718,
  [SMALL_STATE(844)] = 34794,
  [SMALL_STATE(845)] = 34858,
  [SMALL_STATE(846)] = 34922,
  [SMALL_STATE(847)] = 34992,
  [SMALL_STATE(848)] = 35056,
  [SMALL_STATE(849)] = 35120,
  [SMALL_STATE(850)] = 35186,
  [SMALL_STATE(851)] = 35250,
  [SMALL_STATE(852)] = 35326,
  [SMALL_STATE(853)] = 35392,
  [SMALL_STATE(854)] = 35456,
  [SMALL_STATE(855)] = 35520,
  [SMALL_STATE(856)] = 35584,
  [SMALL_STATE(857)] = 35648,
  [SMALL_STATE(858)] = 35714,
  [SMALL_STATE(859)] = 35778,
  [SMALL_STATE(860)] = 35844,
  [SMALL_STATE(861)] = 35910,
  [SMALL_STATE(862)] = 35974,
  [SMALL_STATE(863)] = 36042,
  [SMALL_STATE(864)] = 36106,
  [SMALL_STATE(865)] = 36170,
  [SMALL_STATE(866)] = 36234,
  [SMALL_STATE(867)] = 36298,
  [SMALL_STATE(868)] = 36370,
  [SMALL_STATE(869)] = 36434,
  [SMALL_STATE(870)] = 36502,
  [SMALL_STATE(871)] = 36566,
  [SMALL_STATE(872)] = 36632,
  [SMALL_STATE(873)] = 36696,
  [SMALL_STATE(874)] = 36762,
  [SMALL_STATE(875)] = 36836,
  [SMALL_STATE(876)] = 36900,
  [SMALL_STATE(877)] = 36964,
  [SMALL_STATE(878)] = 37028,
  [SMALL_STATE(879)] = 37100,
  [SMALL_STATE(880)] = 37164,
  [SMALL_STATE(881)] = 37232,
  [SMALL_STATE(882)] = 37296,
  [SMALL_STATE(883)] = 37360,
  [SMALL_STATE(884)] = 37426,
  [SMALL_STATE(885)] = 37492,
  [SMALL_STATE(886)] = 37558,
  [SMALL_STATE(887)] = 37624,
  [SMALL_STATE(888)] = 37690,
  [SMALL_STATE(889)] = 37756,
  [SMALL_STATE(890)] = 37820,
  [SMALL_STATE(891)] = 37956,
  [SMALL_STATE(892)] = 38020,
  [SMALL_STATE(893)] = 38084,
  [SMALL_STATE(894)] = 38148,
  [SMALL_STATE(895)] = 38212,
  [SMALL_STATE(896)] = 38286,
  [SMALL_STATE(897)] = 38350,
  [SMALL_STATE(898)] = 38414,
  [SMALL_STATE(899)] = 38478,
  [SMALL_STATE(900)] = 38544,
  [SMALL_STATE(901)] = 38607,
  [SMALL_STATE(902)] = 38670,
  [SMALL_STATE(903)] = 38743,
  [SMALL_STATE(904)] = 38806,
  [SMALL_STATE(905)] = 38873,
  [SMALL_STATE(906)] = 38936,
  [SMALL_STATE(907)] = 38999,
  [SMALL_STATE(908)] = 39062,
  [SMALL_STATE(909)] = 39125,
  [SMALL_STATE(910)] = 39188,
  [SMALL_STATE(911)] = 39321,
  [SMALL_STATE(912)] = 39384,
  [SMALL_STATE(913)] = 39447,
  [SMALL_STATE(914)] = 39510,
  [SMALL_STATE(915)] = 39573,
  [SMALL_STATE(916)] = 39636,
  [SMALL_STATE(917)] = 39699,
  [SMALL_STATE(918)] = 39762,
  [SMALL_STATE(919)] = 39825,
  [SMALL_STATE(920)] = 39958,
  [SMALL_STATE(921)] = 40025,
  [SMALL_STATE(922)] = 40088,
  [SMALL_STATE(923)] = 40155,
  [SMALL_STATE(924)] = 40218,
  [SMALL_STATE(925)] = 40281,
  [SMALL_STATE(926)] = 40344,
  [SMALL_STATE(927)] = 40407,
  [SMALL_STATE(928)] = 40470,
  [SMALL_STATE(929)] = 40541,
  [SMALL_STATE(930)] = 40612,
  [SMALL_STATE(931)] = 40681,
  [SMALL_STATE(932)] = 40814,
  [SMALL_STATE(933)] = 40889,
  [SMALL_STATE(934)] = 40960,
  [SMALL_STATE(935)] = 41023,
  [SMALL_STATE(936)] = 41086,
  [SMALL_STATE(937)] = 41157,
  [SMALL_STATE(938)] = 41220,
  [SMALL_STATE(939)] = 41283,
  [SMALL_STATE(940)] = 41346,
  [SMALL_STATE(941)] = 41409,
  [SMALL_STATE(942)] = 41472,
  [SMALL_STATE(943)] = 41535,
  [SMALL_STATE(944)] = 41598,
  [SMALL_STATE(945)] = 41661,
  [SMALL_STATE(946)] = 41724,
  [SMALL_STATE(947)] = 41787,
  [SMALL_STATE(948)] = 41850,
  [SMALL_STATE(949)] = 41913,
  [SMALL_STATE(950)] = 41976,
  [SMALL_STATE(951)] = 42039,
  [SMALL_STATE(952)] = 42102,
  [SMALL_STATE(953)] = 42165,
  [SMALL_STATE(954)] = 42228,
  [SMALL_STATE(955)] = 42291,
  [SMALL_STATE(956)] = 42354,
  [SMALL_STATE(957)] = 42417,
  [SMALL_STATE(958)] = 42480,
  [SMALL_STATE(959)] = 42543,
  [SMALL_STATE(960)] = 42606,
  [SMALL_STATE(961)] = 42669,
  [SMALL_STATE(962)] = 42740,
  [SMALL_STATE(963)] = 42803,
  [SMALL_STATE(964)] = 42866,
  [SMALL_STATE(965)] = 42929,
  [SMALL_STATE(966)] = 43008,
  [SMALL_STATE(967)] = 43071,
  [SMALL_STATE(968)] = 43134,
  [SMALL_STATE(969)] = 43197,
  [SMALL_STATE(970)] = 43260,
  [SMALL_STATE(971)] = 43323,
  [SMALL_STATE(972)] = 43386,
  [SMALL_STATE(973)] = 43457,
  [SMALL_STATE(974)] = 43520,
  [SMALL_STATE(975)] = 43583,
  [SMALL_STATE(976)] = 43646,
  [SMALL_STATE(977)] = 43709,
  [SMALL_STATE(978)] = 43772,
  [SMALL_STATE(979)] = 43843,
  [SMALL_STATE(980)] = 43906,
  [SMALL_STATE(981)] = 43969,
  [SMALL_STATE(982)] = 44032,
  [SMALL_STATE(983)] = 44095,
  [SMALL_STATE(984)] = 44170,
  [SMALL_STATE(985)] = 44233,
  [SMALL_STATE(986)] = 44296,
  [SMALL_STATE(987)] = 44359,
  [SMALL_STATE(988)] = 44428,
  [SMALL_STATE(989)] = 44491,
  [SMALL_STATE(990)] = 44554,
  [SMALL_STATE(991)] = 44617,
  [SMALL_STATE(992)] = 44680,
  [SMALL_STATE(993)] = 44743,
  [SMALL_STATE(994)] = 44806,
  [SMALL_STATE(995)] = 44869,
  [SMALL_STATE(996)] = 44932,
  [SMALL_STATE(997)] = 44995,
  [SMALL_STATE(998)] = 45070,
  [SMALL_STATE(999)] = 45133,
  [SMALL_STATE(1000)] = 45196,
  [SMALL_STATE(1001)] = 45259,
  [SMALL_STATE(1002)] = 45322,
  [SMALL_STATE(1003)] = 45385,
  [SMALL_STATE(1004)] = 45448,
  [SMALL_STATE(1005)] = 45518,
  [SMALL_STATE(1006)] = 45584,
  [SMALL_STATE(1007)] = 45650,
  [SMALL_STATE(1008)] = 45718,
  [SMALL_STATE(1009)] = 45784,
  [SMALL_STATE(1010)] = 45852,
  [SMALL_STATE(1011)] = 45918,
  [SMALL_STATE(1012)] = 45984,
  [SMALL_STATE(1013)] = 46052,
  [SMALL_STATE(1014)] = 46118,
  [SMALL_STATE(1015)] = 46184,
  [SMALL_STATE(1016)] = 46252,
  [SMALL_STATE(1017)] = 46318,
  [SMALL_STATE(1018)] = 46384,
  [SMALL_STATE(1019)] = 46452,
  [SMALL_STATE(1020)] = 46518,
  [SMALL_STATE(1021)] = 46586,
  [SMALL_STATE(1022)] = 46652,
  [SMALL_STATE(1023)] = 46718,
  [SMALL_STATE(1024)] = 46779,
  [SMALL_STATE(1025)] = 46840,
  [SMALL_STATE(1026)] = 46903,
  [SMALL_STATE(1027)] = 46964,
  [SMALL_STATE(1028)] = 47027,
  [SMALL_STATE(1029)] = 47090,
  [SMALL_STATE(1030)] = 47151,
  [SMALL_STATE(1031)] = 47214,
  [SMALL_STATE(1032)] = 47275,
  [SMALL_STATE(1033)] = 47336,
  [SMALL_STATE(1034)] = 47399,
  [SMALL_STATE(1035)] = 47460,
  [SMALL_STATE(1036)] = 47523,
  [SMALL_STATE(1037)] = 47584,
  [SMALL_STATE(1038)] = 47647,
  [SMALL_STATE(1039)] = 47708,
  [SMALL_STATE(1040)] = 47773,
  [SMALL_STATE(1041)] = 47834,
  [SMALL_STATE(1042)] = 47895,
  [SMALL_STATE(1043)] = 47956,
  [SMALL_STATE(1044)] = 48019,
  [SMALL_STATE(1045)] = 48090,
  [SMALL_STATE(1046)] = 48153,
  [SMALL_STATE(1047)] = 48216,
  [SMALL_STATE(1048)] = 48279,
  [SMALL_STATE(1049)] = 48340,
  [SMALL_STATE(1050)] = 48401,
  [SMALL_STATE(1051)] = 48484,
  [SMALL_STATE(1052)] = 48545,
  [SMALL_STATE(1053)] = 48606,
  [SMALL_STATE(1054)] = 48667,
  [SMALL_STATE(1055)] = 48730,
  [SMALL_STATE(1056)] = 48791,
  [SMALL_STATE(1057)] = 48856,
  [SMALL_STATE(1058)] = 48917,
  [SMALL_STATE(1059)] = 48978,
  [SMALL_STATE(1060)] = 49105,
  [SMALL_STATE(1061)] = 49178,
  [SMALL_STATE(1062)] = 49239,
  [SMALL_STATE(1063)] = 49302,
  [SMALL_STATE(1064)] = 49365,
  [SMALL_STATE(1065)] = 49492,
  [SMALL_STATE(1066)] = 49553,
  [SMALL_STATE(1067)] = 49614,
  [SMALL_STATE(1068)] = 49675,
  [SMALL_STATE(1069)] = 49736,
  [SMALL_STATE(1070)] = 49821,
  [SMALL_STATE(1071)] = 49882,
  [SMALL_STATE(1072)] = 49943,
  [SMALL_STATE(1073)] = 50006,
  [SMALL_STATE(1074)] = 50067,
  [SMALL_STATE(1075)] = 50152,
  [SMALL_STATE(1076)] = 50213,
  [SMALL_STATE(1077)] = 50274,
  [SMALL_STATE(1078)] = 50401,
  [SMALL_STATE(1079)] = 50466,
  [SMALL_STATE(1080)] = 50527,
  [SMALL_STATE(1081)] = 50588,
  [SMALL_STATE(1082)] = 50651,
  [SMALL_STATE(1083)] = 50712,
  [SMALL_STATE(1084)] = 50773,
  [SMALL_STATE(1085)] = 50836,
  [SMALL_STATE(1086)] = 50896,
  [SMALL_STATE(1087)] = 50964,
  [SMALL_STATE(1088)] = 51024,
  [SMALL_STATE(1089)] = 51084,
  [SMALL_STATE(1090)] = 51144,
  [SMALL_STATE(1091)] = 51204,
  [SMALL_STATE(1092)] = 51264,
  [SMALL_STATE(1093)] = 51324,
  [SMALL_STATE(1094)] = 51384,
  [SMALL_STATE(1095)] = 51444,
  [SMALL_STATE(1096)] = 51504,
  [SMALL_STATE(1097)] = 51564,
  [SMALL_STATE(1098)] = 51624,
  [SMALL_STATE(1099)] = 51684,
  [SMALL_STATE(1100)] = 51748,
  [SMALL_STATE(1101)] = 51812,
  [SMALL_STATE(1102)] = 51878,
  [SMALL_STATE(1103)] = 51938,
  [SMALL_STATE(1104)] = 51998,
  [SMALL_STATE(1105)] = 52058,
  [SMALL_STATE(1106)] = 52118,
  [SMALL_STATE(1107)] = 52178,
  [SMALL_STATE(1108)] = 52244,
  [SMALL_STATE(1109)] = 52304,
  [SMALL_STATE(1110)] = 52364,
  [SMALL_STATE(1111)] = 52424,
  [SMALL_STATE(1112)] = 52484,
  [SMALL_STATE(1113)] = 52544,
  [SMALL_STATE(1114)] = 52604,
  [SMALL_STATE(1115)] = 52664,
  [SMALL_STATE(1116)] = 52724,
  [SMALL_STATE(1117)] = 52788,
  [SMALL_STATE(1118)] = 52848,
  [SMALL_STATE(1119)] = 52908,
  [SMALL_STATE(1120)] = 52968,
  [SMALL_STATE(1121)] = 53028,
  [SMALL_STATE(1122)] = 53098,
  [SMALL_STATE(1123)] = 53158,
  [SMALL_STATE(1124)] = 53218,
  [SMALL_STATE(1125)] = 53278,
  [SMALL_STATE(1126)] = 53338,
  [SMALL_STATE(1127)] = 53398,
  [SMALL_STATE(1128)] = 53458,
  [SMALL_STATE(1129)] = 53518,
  [SMALL_STATE(1130)] = 53578,
  [SMALL_STATE(1131)] = 53638,
  [SMALL_STATE(1132)] = 53698,
  [SMALL_STATE(1133)] = 53758,
  [SMALL_STATE(1134)] = 53818,
  [SMALL_STATE(1135)] = 53878,
  [SMALL_STATE(1136)] = 53938,
  [SMALL_STATE(1137)] = 53998,
  [SMALL_STATE(1138)] = 54058,
  [SMALL_STATE(1139)] = 54118,
  [SMALL_STATE(1140)] = 54178,
  [SMALL_STATE(1141)] = 54244,
  [SMALL_STATE(1142)] = 54304,
  [SMALL_STATE(1143)] = 54364,
  [SMALL_STATE(1144)] = 54424,
  [SMALL_STATE(1145)] = 54484,
  [SMALL_STATE(1146)] = 54544,
  [SMALL_STATE(1147)] = 54604,
  [SMALL_STATE(1148)] = 54672,
  [SMALL_STATE(1149)] = 54732,
  [SMALL_STATE(1150)] = 54792,
  [SMALL_STATE(1151)] = 54852,
  [SMALL_STATE(1152)] = 54912,
  [SMALL_STATE(1153)] = 54972,
  [SMALL_STATE(1154)] = 55032,
  [SMALL_STATE(1155)] = 55092,
  [SMALL_STATE(1156)] = 55152,
  [SMALL_STATE(1157)] = 55212,
  [SMALL_STATE(1158)] = 55272,
  [SMALL_STATE(1159)] = 55332,
  [SMALL_STATE(1160)] = 55392,
  [SMALL_STATE(1161)] = 55452,
  [SMALL_STATE(1162)] = 55512,
  [SMALL_STATE(1163)] = 55572,
  [SMALL_STATE(1164)] = 55632,
  [SMALL_STATE(1165)] = 55692,
  [SMALL_STATE(1166)] = 55752,
  [SMALL_STATE(1167)] = 55812,
  [SMALL_STATE(1168)] = 55872,
  [SMALL_STATE(1169)] = 55932,
  [SMALL_STATE(1170)] = 55992,
  [SMALL_STATE(1171)] = 56052,
  [SMALL_STATE(1172)] = 56112,
  [SMALL_STATE(1173)] = 56172,
  [SMALL_STATE(1174)] = 56232,
  [SMALL_STATE(1175)] = 56292,
  [SMALL_STATE(1176)] = 56352,
  [SMALL_STATE(1177)] = 56412,
  [SMALL_STATE(1178)] = 56482,
  [SMALL_STATE(1179)] = 56542,
  [SMALL_STATE(1180)] = 56602,
  [SMALL_STATE(1181)] = 56662,
  [SMALL_STATE(1182)] = 56722,
  [SMALL_STATE(1183)] = 56782,
  [SMALL_STATE(1184)] = 56842,
  [SMALL_STATE(1185)] = 56902,
  [SMALL_STATE(1186)] = 56962,
  [SMALL_STATE(1187)] = 57022,
  [SMALL_STATE(1188)] = 57082,
  [SMALL_STATE(1189)] = 57142,
  [SMALL_STATE(1190)] = 57202,
  [SMALL_STATE(1191)] = 57262,
  [SMALL_STATE(1192)] = 57322,
  [SMALL_STATE(1193)] = 57382,
  [SMALL_STATE(1194)] = 57442,
  [SMALL_STATE(1195)] = 57502,
  [SMALL_STATE(1196)] = 57562,
  [SMALL_STATE(1197)] = 57621,
  [SMALL_STATE(1198)] = 57680,
  [SMALL_STATE(1199)] = 57765,
  [SMALL_STATE(1200)] = 57850,
  [SMALL_STATE(1201)] = 57915,
  [SMALL_STATE(1202)] = 57978,
  [SMALL_STATE(1203)] = 58041,
  [SMALL_STATE(1204)] = 58108,
  [SMALL_STATE(1205)] = 58191,
  [SMALL_STATE(1206)] = 58252,
  [SMALL_STATE(1207)] = 58321,
  [SMALL_STATE(1208)] = 58392,
  [SMALL_STATE(1209)] = 58453,
  [SMALL_STATE(1210)] = 58514,
  [SMALL_STATE(1211)] = 58573,
  [SMALL_STATE(1212)] = 58632,
  [SMALL_STATE(1213)] = 58697,
  [SMALL_STATE(1214)] = 58762,
  [SMALL_STATE(1215)] = 58827,
  [SMALL_STATE(1216)] = 58910,
  [SMALL_STATE(1217)] = 58969,
  [SMALL_STATE(1218)] = 59028,
  [SMALL_STATE(1219)] = 59086,
  [SMALL_STATE(1220)] = 59144,
  [SMALL_STATE(1221)] = 59202,
  [SMALL_STATE(1222)] = 59260,
  [SMALL_STATE(1223)] = 59318,
  [SMALL_STATE(1224)] = 59376,
  [SMALL_STATE(1225)] = 59434,
  [SMALL_STATE(1226)] = 59492,
  [SMALL_STATE(1227)] = 59550,
  [SMALL_STATE(1228)] = 59608,
  [SMALL_STATE(1229)] = 59666,
  [SMALL_STATE(1230)] = 59724,
  [SMALL_STATE(1231)] = 59782,
  [SMALL_STATE(1232)] = 59840,
  [SMALL_STATE(1233)] = 59898,
  [SMALL_STATE(1234)] = 59956,
  [SMALL_STATE(1235)] = 60014,
  [SMALL_STATE(1236)] = 60080,
  [SMALL_STATE(1237)] = 60138,
  [SMALL_STATE(1238)] = 60196,
  [SMALL_STATE(1239)] = 60258,
  [SMALL_STATE(1240)] = 60316,
  [SMALL_STATE(1241)] = 60374,
  [SMALL_STATE(1242)] = 60436,
  [SMALL_STATE(1243)] = 60494,
  [SMALL_STATE(1244)] = 60552,
  [SMALL_STATE(1245)] = 60610,
  [SMALL_STATE(1246)] = 60672,
  [SMALL_STATE(1247)] = 60730,
  [SMALL_STATE(1248)] = 60788,
  [SMALL_STATE(1249)] = 60846,
  [SMALL_STATE(1250)] = 60908,
  [SMALL_STATE(1251)] = 60966,
  [SMALL_STATE(1252)] = 61034,
  [SMALL_STATE(1253)] = 61092,
  [SMALL_STATE(1254)] = 61150,
  [SMALL_STATE(1255)] = 61210,
  [SMALL_STATE(1256)] = 61268,
  [SMALL_STATE(1257)] = 61326,
  [SMALL_STATE(1258)] = 61384,
  [SMALL_STATE(1259)] = 61448,
  [SMALL_STATE(1260)] = 61512,
  [SMALL_STATE(1261)] = 61580,
  [SMALL_STATE(1262)] = 61638,
  [SMALL_STATE(1263)] = 61696,
  [SMALL_STATE(1264)] = 61754,
  [SMALL_STATE(1265)] = 61812,
  [SMALL_STATE(1266)] = 61874,
  [SMALL_STATE(1267)] = 61936,
  [SMALL_STATE(1268)] = 61994,
  [SMALL_STATE(1269)] = 62052,
  [SMALL_STATE(1270)] = 62116,
  [SMALL_STATE(1271)] = 62174,
  [SMALL_STATE(1272)] = 62232,
  [SMALL_STATE(1273)] = 62290,
  [SMALL_STATE(1274)] = 62348,
  [SMALL_STATE(1275)] = 62406,
  [SMALL_STATE(1276)] = 62464,
  [SMALL_STATE(1277)] = 62522,
  [SMALL_STATE(1278)] = 62580,
  [SMALL_STATE(1279)] = 62638,
  [SMALL_STATE(1280)] = 62696,
  [SMALL_STATE(1281)] = 62754,
  [SMALL_STATE(1282)] = 62812,
  [SMALL_STATE(1283)] = 62870,
  [SMALL_STATE(1284)] = 62932,
  [SMALL_STATE(1285)] = 63002,
  [SMALL_STATE(1286)] = 63060,
  [SMALL_STATE(1287)] = 63118,
  [SMALL_STATE(1288)] = 63176,
  [SMALL_STATE(1289)] = 63234,
  [SMALL_STATE(1290)] = 63292,
  [SMALL_STATE(1291)] = 63350,
  [SMALL_STATE(1292)] = 63408,
  [SMALL_STATE(1293)] = 63466,
  [SMALL_STATE(1294)] = 63536,
  [SMALL_STATE(1295)] = 63594,
  [SMALL_STATE(1296)] = 63652,
  [SMALL_STATE(1297)] = 63710,
  [SMALL_STATE(1298)] = 63772,
  [SMALL_STATE(1299)] = 63830,
  [SMALL_STATE(1300)] = 63892,
  [SMALL_STATE(1301)] = 63954,
  [SMALL_STATE(1302)] = 64011,
  [SMALL_STATE(1303)] = 64068,
  [SMALL_STATE(1304)] = 64125,
  [SMALL_STATE(1305)] = 64186,
  [SMALL_STATE(1306)] = 64251,
  [SMALL_STATE(1307)] = 64316,
  [SMALL_STATE(1308)] = 64373,
  [SMALL_STATE(1309)] = 64436,
  [SMALL_STATE(1310)] = 64493,
  [SMALL_STATE(1311)] = 64558,
  [SMALL_STATE(1312)] = 64623,
  [SMALL_STATE(1313)] = 64686,
  [SMALL_STATE(1314)] = 64743,
  [SMALL_STATE(1315)] = 64804,
  [SMALL_STATE(1316)] = 64861,
  [SMALL_STATE(1317)] = 64918,
  [SMALL_STATE(1318)] = 64975,
  [SMALL_STATE(1319)] = 65032,
  [SMALL_STATE(1320)] = 65097,
  [SMALL_STATE(1321)] = 65162,
  [SMALL_STATE(1322)] = 65226,
  [SMALL_STATE(1323)] = 65332,
  [SMALL_STATE(1324)] = 65398,
  [SMALL_STATE(1325)] = 65504,
  [SMALL_STATE(1326)] = 65568,
  [SMALL_STATE(1327)] = 65624,
  [SMALL_STATE(1328)] = 65690,
  [SMALL_STATE(1329)] = 65796,
  [SMALL_STATE(1330)] = 65862,
  [SMALL_STATE(1331)] = 65926,
  [SMALL_STATE(1332)] = 65994,
  [SMALL_STATE(1333)] = 66060,
  [SMALL_STATE(1334)] = 66126,
  [SMALL_STATE(1335)] = 66188,
  [SMALL_STATE(1336)] = 66294,
  [SMALL_STATE(1337)] = 66362,
  [SMALL_STATE(1338)] = 66468,
  [SMALL_STATE(1339)] = 66574,
  [SMALL_STATE(1340)] = 66680,
  [SMALL_STATE(1341)] = 66786,
  [SMALL_STATE(1342)] = 66846,
  [SMALL_STATE(1343)] = 66952,
  [SMALL_STATE(1344)] = 67058,
  [SMALL_STATE(1345)] = 67164,
  [SMALL_STATE(1346)] = 67270,
  [SMALL_STATE(1347)] = 67376,
  [SMALL_STATE(1348)] = 67482,
  [SMALL_STATE(1349)] = 67588,
  [SMALL_STATE(1350)] = 67647,
  [SMALL_STATE(1351)] = 67702,
  [SMALL_STATE(1352)] = 67765,
  [SMALL_STATE(1353)] = 67828,
  [SMALL_STATE(1354)] = 67891,
  [SMALL_STATE(1355)] = 67954,
  [SMALL_STATE(1356)] = 68025,
  [SMALL_STATE(1357)] = 68080,
  [SMALL_STATE(1358)] = 68139,
  [SMALL_STATE(1359)] = 68200,
  [SMALL_STATE(1360)] = 68259,
  [SMALL_STATE(1361)] = 68314,
  [SMALL_STATE(1362)] = 68369,
  [SMALL_STATE(1363)] = 68430,
  [SMALL_STATE(1364)] = 68493,
  [SMALL_STATE(1365)] = 68548,
  [SMALL_STATE(1366)] = 68619,
  [SMALL_STATE(1367)] = 68682,
  [SMALL_STATE(1368)] = 68737,
  [SMALL_STATE(1369)] = 68796,
  [SMALL_STATE(1370)] = 68855,
  [SMALL_STATE(1371)] = 68910,
  [SMALL_STATE(1372)] = 68975,
  [SMALL_STATE(1373)] = 69030,
  [SMALL_STATE(1374)] = 69085,
  [SMALL_STATE(1375)] = 69140,
  [SMALL_STATE(1376)] = 69199,
  [SMALL_STATE(1377)] = 69254,
  [SMALL_STATE(1378)] = 69313,
  [SMALL_STATE(1379)] = 69368,
  [SMALL_STATE(1380)] = 69423,
  [SMALL_STATE(1381)] = 69478,
  [SMALL_STATE(1382)] = 69533,
  [SMALL_STATE(1383)] = 69588,
  [SMALL_STATE(1384)] = 69647,
  [SMALL_STATE(1385)] = 69706,
  [SMALL_STATE(1386)] = 69765,
  [SMALL_STATE(1387)] = 69824,
  [SMALL_STATE(1388)] = 69883,
  [SMALL_STATE(1389)] = 69994,
  [SMALL_STATE(1390)] = 70049,
  [SMALL_STATE(1391)] = 70104,
  [SMALL_STATE(1392)] = 70159,
  [SMALL_STATE(1393)] = 70218,
  [SMALL_STATE(1394)] = 70277,
  [SMALL_STATE(1395)] = 70336,
  [SMALL_STATE(1396)] = 70390,
  [SMALL_STATE(1397)] = 70444,
  [SMALL_STATE(1398)] = 70498,
  [SMALL_STATE(1399)] = 70554,
  [SMALL_STATE(1400)] = 70608,
  [SMALL_STATE(1401)] = 70662,
  [SMALL_STATE(1402)] = 70716,
  [SMALL_STATE(1403)] = 70770,
  [SMALL_STATE(1404)] = 70824,
  [SMALL_STATE(1405)] = 70878,
  [SMALL_STATE(1406)] = 70934,
  [SMALL_STATE(1407)] = 70988,
  [SMALL_STATE(1408)] = 71042,
  [SMALL_STATE(1409)] = 71098,
  [SMALL_STATE(1410)] = 71154,
  [SMALL_STATE(1411)] = 71210,
  [SMALL_STATE(1412)] = 71264,
  [SMALL_STATE(1413)] = 71318,
  [SMALL_STATE(1414)] = 71374,
  [SMALL_STATE(1415)] = 71428,
  [SMALL_STATE(1416)] = 71482,
  [SMALL_STATE(1417)] = 71536,
  [SMALL_STATE(1418)] = 71592,
  [SMALL_STATE(1419)] = 71652,
  [SMALL_STATE(1420)] = 71706,
  [SMALL_STATE(1421)] = 71772,
  [SMALL_STATE(1422)] = 71828,
  [SMALL_STATE(1423)] = 71894,
  [SMALL_STATE(1424)] = 71950,
  [SMALL_STATE(1425)] = 72004,
  [SMALL_STATE(1426)] = 72058,
  [SMALL_STATE(1427)] = 72124,
  [SMALL_STATE(1428)] = 72178,
  [SMALL_STATE(1429)] = 72232,
  [SMALL_STATE(1430)] = 72286,
  [SMALL_STATE(1431)] = 72340,
  [SMALL_STATE(1432)] = 72402,
  [SMALL_STATE(1433)] = 72456,
  [SMALL_STATE(1434)] = 72510,
  [SMALL_STATE(1435)] = 72564,
  [SMALL_STATE(1436)] = 72618,
  [SMALL_STATE(1437)] = 72672,
  [SMALL_STATE(1438)] = 72726,
  [SMALL_STATE(1439)] = 72784,
  [SMALL_STATE(1440)] = 72838,
  [SMALL_STATE(1441)] = 72892,
  [SMALL_STATE(1442)] = 72946,
  [SMALL_STATE(1443)] = 73000,
  [SMALL_STATE(1444)] = 73062,
  [SMALL_STATE(1445)] = 73116,
  [SMALL_STATE(1446)] = 73172,
  [SMALL_STATE(1447)] = 73226,
  [SMALL_STATE(1448)] = 73280,
  [SMALL_STATE(1449)] = 73338,
  [SMALL_STATE(1450)] = 73392,
  [SMALL_STATE(1451)] = 73446,
  [SMALL_STATE(1452)] = 73500,
  [SMALL_STATE(1453)] = 73553,
  [SMALL_STATE(1454)] = 73606,
  [SMALL_STATE(1455)] = 73665,
  [SMALL_STATE(1456)] = 73726,
  [SMALL_STATE(1457)] = 73783,
  [SMALL_STATE(1458)] = 73840,
  [SMALL_STATE(1459)] = 73893,
  [SMALL_STATE(1460)] = 73950,
  [SMALL_STATE(1461)] = 74011,
  [SMALL_STATE(1462)] = 74068,
  [SMALL_STATE(1463)] = 74127,
  [SMALL_STATE(1464)] = 74192,
  [SMALL_STATE(1465)] = 74249,
  [SMALL_STATE(1466)] = 74306,
  [SMALL_STATE(1467)] = 74363,
  [SMALL_STATE(1468)] = 74424,
  [SMALL_STATE(1469)] = 74485,
  [SMALL_STATE(1470)] = 74538,
  [SMALL_STATE(1471)] = 74607,
  [SMALL_STATE(1472)] = 74668,
  [SMALL_STATE(1473)] = 74729,
  [SMALL_STATE(1474)] = 74786,
  [SMALL_STATE(1475)] = 74851,
  [SMALL_STATE(1476)] = 74922,
  [SMALL_STATE(1477)] = 74981,
  [SMALL_STATE(1478)] = 75034,
  [SMALL_STATE(1479)] = 75103,
  [SMALL_STATE(1480)] = 75156,
  [SMALL_STATE(1481)] = 75209,
  [SMALL_STATE(1482)] = 75262,
  [SMALL_STATE(1483)] = 75315,
  [SMALL_STATE(1484)] = 75368,
  [SMALL_STATE(1485)] = 75421,
  [SMALL_STATE(1486)] = 75474,
  [SMALL_STATE(1487)] = 75527,
  [SMALL_STATE(1488)] = 75580,
  [SMALL_STATE(1489)] = 75633,
  [SMALL_STATE(1490)] = 75686,
  [SMALL_STATE(1491)] = 75739,
  [SMALL_STATE(1492)] = 75796,
  [SMALL_STATE(1493)] = 75853,
  [SMALL_STATE(1494)] = 75906,
  [SMALL_STATE(1495)] = 75963,
  [SMALL_STATE(1496)] = 76016,
  [SMALL_STATE(1497)] = 76069,
  [SMALL_STATE(1498)] = 76122,
  [SMALL_STATE(1499)] = 76187,
  [SMALL_STATE(1500)] = 76240,
  [SMALL_STATE(1501)] = 76293,
  [SMALL_STATE(1502)] = 76346,
  [SMALL_STATE(1503)] = 76399,
  [SMALL_STATE(1504)] = 76451,
  [SMALL_STATE(1505)] = 76503,
  [SMALL_STATE(1506)] = 76555,
  [SMALL_STATE(1507)] = 76607,
  [SMALL_STATE(1508)] = 76659,
  [SMALL_STATE(1509)] = 76711,
  [SMALL_STATE(1510)] = 76791,
  [SMALL_STATE(1511)] = 76843,
  [SMALL_STATE(1512)] = 76903,
  [SMALL_STATE(1513)] = 76955,
  [SMALL_STATE(1514)] = 77009,
  [SMALL_STATE(1515)] = 77063,
  [SMALL_STATE(1516)] = 77115,
  [SMALL_STATE(1517)] = 77169,
  [SMALL_STATE(1518)] = 77227,
  [SMALL_STATE(1519)] = 77281,
  [SMALL_STATE(1520)] = 77333,
  [SMALL_STATE(1521)] = 77387,
  [SMALL_STATE(1522)] = 77439,
  [SMALL_STATE(1523)] = 77491,
  [SMALL_STATE(1524)] = 77543,
  [SMALL_STATE(1525)] = 77599,
  [SMALL_STATE(1526)] = 77653,
  [SMALL_STATE(1527)] = 77707,
  [SMALL_STATE(1528)] = 77761,
  [SMALL_STATE(1529)] = 77813,
  [SMALL_STATE(1530)] = 77867,
  [SMALL_STATE(1531)] = 77927,
  [SMALL_STATE(1532)] = 77979,
  [SMALL_STATE(1533)] = 78031,
  [SMALL_STATE(1534)] = 78085,
  [SMALL_STATE(1535)] = 78137,
  [SMALL_STATE(1536)] = 78195,
  [SMALL_STATE(1537)] = 78251,
  [SMALL_STATE(1538)] = 78331,
  [SMALL_STATE(1539)] = 78433,
  [SMALL_STATE(1540)] = 78485,
  [SMALL_STATE(1541)] = 78537,
  [SMALL_STATE(1542)] = 78589,
  [SMALL_STATE(1543)] = 78669,
  [SMALL_STATE(1544)] = 78721,
  [SMALL_STATE(1545)] = 78773,
  [SMALL_STATE(1546)] = 78825,
  [SMALL_STATE(1547)] = 78885,
  [SMALL_STATE(1548)] = 78937,
  [SMALL_STATE(1549)] = 78989,
  [SMALL_STATE(1550)] = 79041,
  [SMALL_STATE(1551)] = 79093,
  [SMALL_STATE(1552)] = 79145,
  [SMALL_STATE(1553)] = 79225,
  [SMALL_STATE(1554)] = 79285,
  [SMALL_STATE(1555)] = 79340,
  [SMALL_STATE(1556)] = 79391,
  [SMALL_STATE(1557)] = 79442,
  [SMALL_STATE(1558)] = 79501,
  [SMALL_STATE(1559)] = 79552,
  [SMALL_STATE(1560)] = 79611,
  [SMALL_STATE(1561)] = 79662,
  [SMALL_STATE(1562)] = 79717,
  [SMALL_STATE(1563)] = 79772,
  [SMALL_STATE(1564)] = 79823,
  [SMALL_STATE(1565)] = 79874,
  [SMALL_STATE(1566)] = 79931,
  [SMALL_STATE(1567)] = 79982,
  [SMALL_STATE(1568)] = 80033,
  [SMALL_STATE(1569)] = 80088,
  [SMALL_STATE(1570)] = 80139,
  [SMALL_STATE(1571)] = 80194,
  [SMALL_STATE(1572)] = 80245,
  [SMALL_STATE(1573)] = 80296,
  [SMALL_STATE(1574)] = 80347,
  [SMALL_STATE(1575)] = 80402,
  [SMALL_STATE(1576)] = 80457,
  [SMALL_STATE(1577)] = 80508,
  [SMALL_STATE(1578)] = 80559,
  [SMALL_STATE(1579)] = 80610,
  [SMALL_STATE(1580)] = 80661,
  [SMALL_STATE(1581)] = 80716,
  [SMALL_STATE(1582)] = 80767,
  [SMALL_STATE(1583)] = 80822,
  [SMALL_STATE(1584)] = 80873,
  [SMALL_STATE(1585)] = 80924,
  [SMALL_STATE(1586)] = 80975,
  [SMALL_STATE(1587)] = 81034,
  [SMALL_STATE(1588)] = 81093,
  [SMALL_STATE(1589)] = 81144,
  [SMALL_STATE(1590)] = 81199,
  [SMALL_STATE(1591)] = 81256,
  [SMALL_STATE(1592)] = 81307,
  [SMALL_STATE(1593)] = 81362,
  [SMALL_STATE(1594)] = 81425,
  [SMALL_STATE(1595)] = 81476,
  [SMALL_STATE(1596)] = 81527,
  [SMALL_STATE(1597)] = 81578,
  [SMALL_STATE(1598)] = 81641,
  [SMALL_STATE(1599)] = 81692,
  [SMALL_STATE(1600)] = 81747,
  [SMALL_STATE(1601)] = 81802,
  [SMALL_STATE(1602)] = 81853,
  [SMALL_STATE(1603)] = 81904,
  [SMALL_STATE(1604)] = 81959,
  [SMALL_STATE(1605)] = 82010,
  [SMALL_STATE(1606)] = 82069,
  [SMALL_STATE(1607)] = 82124,
  [SMALL_STATE(1608)] = 82183,
  [SMALL_STATE(1609)] = 82238,
  [SMALL_STATE(1610)] = 82289,
  [SMALL_STATE(1611)] = 82340,
  [SMALL_STATE(1612)] = 82391,
  [SMALL_STATE(1613)] = 82442,
  [SMALL_STATE(1614)] = 82493,
  [SMALL_STATE(1615)] = 82547,
  [SMALL_STATE(1616)] = 82597,
  [SMALL_STATE(1617)] = 82651,
  [SMALL_STATE(1618)] = 82703,
  [SMALL_STATE(1619)] = 82753,
  [SMALL_STATE(1620)] = 82803,
  [SMALL_STATE(1621)] = 82853,
  [SMALL_STATE(1622)] = 82903,
  [SMALL_STATE(1623)] = 82953,
  [SMALL_STATE(1624)] = 83003,
  [SMALL_STATE(1625)] = 83053,
  [SMALL_STATE(1626)] = 83103,
  [SMALL_STATE(1627)] = 83155,
  [SMALL_STATE(1628)] = 83207,
  [SMALL_STATE(1629)] = 83257,
  [SMALL_STATE(1630)] = 83307,
  [SMALL_STATE(1631)] = 83359,
  [SMALL_STATE(1632)] = 83411,
  [SMALL_STATE(1633)] = 83461,
  [SMALL_STATE(1634)] = 83511,
  [SMALL_STATE(1635)] = 83561,
  [SMALL_STATE(1636)] = 83611,
  [SMALL_STATE(1637)] = 83661,
  [SMALL_STATE(1638)] = 83711,
  [SMALL_STATE(1639)] = 83761,
  [SMALL_STATE(1640)] = 83815,
  [SMALL_STATE(1641)] = 83865,
  [SMALL_STATE(1642)] = 83915,
  [SMALL_STATE(1643)] = 83965,
  [SMALL_STATE(1644)] = 84015,
  [SMALL_STATE(1645)] = 84065,
  [SMALL_STATE(1646)] = 84115,
  [SMALL_STATE(1647)] = 84165,
  [SMALL_STATE(1648)] = 84215,
  [SMALL_STATE(1649)] = 84269,
  [SMALL_STATE(1650)] = 84319,
  [SMALL_STATE(1651)] = 84369,
  [SMALL_STATE(1652)] = 84419,
  [SMALL_STATE(1653)] = 84469,
  [SMALL_STATE(1654)] = 84521,
  [SMALL_STATE(1655)] = 84573,
  [SMALL_STATE(1656)] = 84625,
  [SMALL_STATE(1657)] = 84677,
  [SMALL_STATE(1658)] = 84729,
  [SMALL_STATE(1659)] = 84781,
  [SMALL_STATE(1660)] = 84833,
  [SMALL_STATE(1661)] = 84885,
  [SMALL_STATE(1662)] = 84937,
  [SMALL_STATE(1663)] = 84989,
  [SMALL_STATE(1664)] = 85041,
  [SMALL_STATE(1665)] = 85095,
  [SMALL_STATE(1666)] = 85147,
  [SMALL_STATE(1667)] = 85199,
  [SMALL_STATE(1668)] = 85253,
  [SMALL_STATE(1669)] = 85343,
  [SMALL_STATE(1670)] = 85392,
  [SMALL_STATE(1671)] = 85441,
  [SMALL_STATE(1672)] = 85490,
  [SMALL_STATE(1673)] = 85539,
  [SMALL_STATE(1674)] = 85632,
  [SMALL_STATE(1675)] = 85681,
  [SMALL_STATE(1676)] = 85730,
  [SMALL_STATE(1677)] = 85779,
  [SMALL_STATE(1678)] = 85828,
  [SMALL_STATE(1679)] = 85877,
  [SMALL_STATE(1680)] = 85926,
  [SMALL_STATE(1681)] = 85975,
  [SMALL_STATE(1682)] = 86024,
  [SMALL_STATE(1683)] = 86073,
  [SMALL_STATE(1684)] = 86122,
  [SMALL_STATE(1685)] = 86171,
  [SMALL_STATE(1686)] = 86220,
  [SMALL_STATE(1687)] = 86313,
  [SMALL_STATE(1688)] = 86362,
  [SMALL_STATE(1689)] = 86455,
  [SMALL_STATE(1690)] = 86548,
  [SMALL_STATE(1691)] = 86641,
  [SMALL_STATE(1692)] = 86734,
  [SMALL_STATE(1693)] = 86783,
  [SMALL_STATE(1694)] = 86876,
  [SMALL_STATE(1695)] = 86925,
  [SMALL_STATE(1696)] = 87018,
  [SMALL_STATE(1697)] = 87067,
  [SMALL_STATE(1698)] = 87116,
  [SMALL_STATE(1699)] = 87209,
  [SMALL_STATE(1700)] = 87302,
  [SMALL_STATE(1701)] = 87351,
  [SMALL_STATE(1702)] = 87444,
  [SMALL_STATE(1703)] = 87493,
  [SMALL_STATE(1704)] = 87542,
  [SMALL_STATE(1705)] = 87591,
  [SMALL_STATE(1706)] = 87684,
  [SMALL_STATE(1707)] = 87733,
  [SMALL_STATE(1708)] = 87826,
  [SMALL_STATE(1709)] = 87875,
  [SMALL_STATE(1710)] = 87924,
  [SMALL_STATE(1711)] = 87973,
  [SMALL_STATE(1712)] = 88022,
  [SMALL_STATE(1713)] = 88115,
  [SMALL_STATE(1714)] = 88164,
  [SMALL_STATE(1715)] = 88257,
  [SMALL_STATE(1716)] = 88350,
  [SMALL_STATE(1717)] = 88443,
  [SMALL_STATE(1718)] = 88536,
  [SMALL_STATE(1719)] = 88584,
  [SMALL_STATE(1720)] = 88650,
  [SMALL_STATE(1721)] = 88718,
  [SMALL_STATE(1722)] = 88766,
  [SMALL_STATE(1723)] = 88858,
  [SMALL_STATE(1724)] = 88906,
  [SMALL_STATE(1725)] = 88954,
  [SMALL_STATE(1726)] = 89002,
  [SMALL_STATE(1727)] = 89072,
  [SMALL_STATE(1728)] = 89153,
  [SMALL_STATE(1729)] = 89200,
  [SMALL_STATE(1730)] = 89247,
  [SMALL_STATE(1731)] = 89294,
  [SMALL_STATE(1732)] = 89341,
  [SMALL_STATE(1733)] = 89388,
  [SMALL_STATE(1734)] = 89435,
  [SMALL_STATE(1735)] = 89482,
  [SMALL_STATE(1736)] = 89529,
  [SMALL_STATE(1737)] = 89576,
  [SMALL_STATE(1738)] = 89623,
  [SMALL_STATE(1739)] = 89670,
  [SMALL_STATE(1740)] = 89717,
  [SMALL_STATE(1741)] = 89764,
  [SMALL_STATE(1742)] = 89811,
  [SMALL_STATE(1743)] = 89858,
  [SMALL_STATE(1744)] = 89905,
  [SMALL_STATE(1745)] = 89952,
  [SMALL_STATE(1746)] = 89999,
  [SMALL_STATE(1747)] = 90046,
  [SMALL_STATE(1748)] = 90093,
  [SMALL_STATE(1749)] = 90140,
  [SMALL_STATE(1750)] = 90187,
  [SMALL_STATE(1751)] = 90234,
  [SMALL_STATE(1752)] = 90281,
  [SMALL_STATE(1753)] = 90328,
  [SMALL_STATE(1754)] = 90375,
  [SMALL_STATE(1755)] = 90422,
  [SMALL_STATE(1756)] = 90469,
  [SMALL_STATE(1757)] = 90516,
  [SMALL_STATE(1758)] = 90563,
  [SMALL_STATE(1759)] = 90610,
  [SMALL_STATE(1760)] = 90691,
  [SMALL_STATE(1761)] = 90738,
  [SMALL_STATE(1762)] = 90785,
  [SMALL_STATE(1763)] = 90832,
  [SMALL_STATE(1764)] = 90879,
  [SMALL_STATE(1765)] = 90960,
  [SMALL_STATE(1766)] = 91007,
  [SMALL_STATE(1767)] = 91054,
  [SMALL_STATE(1768)] = 91101,
  [SMALL_STATE(1769)] = 91148,
  [SMALL_STATE(1770)] = 91195,
  [SMALL_STATE(1771)] = 91242,
  [SMALL_STATE(1772)] = 91323,
  [SMALL_STATE(1773)] = 91370,
  [SMALL_STATE(1774)] = 91417,
  [SMALL_STATE(1775)] = 91464,
  [SMALL_STATE(1776)] = 91511,
  [SMALL_STATE(1777)] = 91558,
  [SMALL_STATE(1778)] = 91605,
  [SMALL_STATE(1779)] = 91652,
  [SMALL_STATE(1780)] = 91699,
  [SMALL_STATE(1781)] = 91746,
  [SMALL_STATE(1782)] = 91793,
  [SMALL_STATE(1783)] = 91840,
  [SMALL_STATE(1784)] = 91887,
  [SMALL_STATE(1785)] = 91934,
  [SMALL_STATE(1786)] = 91981,
  [SMALL_STATE(1787)] = 92028,
  [SMALL_STATE(1788)] = 92075,
  [SMALL_STATE(1789)] = 92122,
  [SMALL_STATE(1790)] = 92169,
  [SMALL_STATE(1791)] = 92216,
  [SMALL_STATE(1792)] = 92263,
  [SMALL_STATE(1793)] = 92310,
  [SMALL_STATE(1794)] = 92357,
  [SMALL_STATE(1795)] = 92443,
  [SMALL_STATE(1796)] = 92529,
  [SMALL_STATE(1797)] = 92583,
  [SMALL_STATE(1798)] = 92663,
  [SMALL_STATE(1799)] = 92749,
  [SMALL_STATE(1800)] = 92835,
  [SMALL_STATE(1801)] = 92921,
  [SMALL_STATE(1802)] = 93007,
  [SMALL_STATE(1803)] = 93093,
  [SMALL_STATE(1804)] = 93176,
  [SMALL_STATE(1805)] = 93259,
  [SMALL_STATE(1806)] = 93308,
  [SMALL_STATE(1807)] = 93389,
  [SMALL_STATE(1808)] = 93470,
  [SMALL_STATE(1809)] = 93537,
  [SMALL_STATE(1810)] = 93604,
  [SMALL_STATE(1811)] = 93687,
  [SMALL_STATE(1812)] = 93731,
  [SMALL_STATE(1813)] = 93775,
  [SMALL_STATE(1814)] = 93855,
  [SMALL_STATE(1815)] = 93935,
  [SMALL_STATE(1816)] = 94015,
  [SMALL_STATE(1817)] = 94095,
  [SMALL_STATE(1818)] = 94161,
  [SMALL_STATE(1819)] = 94237,
  [SMALL_STATE(1820)] = 94317,
  [SMALL_STATE(1821)] = 94397,
  [SMALL_STATE(1822)] = 94477,
  [SMALL_STATE(1823)] = 94521,
  [SMALL_STATE(1824)] = 94601,
  [SMALL_STATE(1825)] = 94681,
  [SMALL_STATE(1826)] = 94725,
  [SMALL_STATE(1827)] = 94769,
  [SMALL_STATE(1828)] = 94813,
  [SMALL_STATE(1829)] = 94857,
  [SMALL_STATE(1830)] = 94901,
  [SMALL_STATE(1831)] = 94981,
  [SMALL_STATE(1832)] = 95025,
  [SMALL_STATE(1833)] = 95069,
  [SMALL_STATE(1834)] = 95149,
  [SMALL_STATE(1835)] = 95229,
  [SMALL_STATE(1836)] = 95309,
  [SMALL_STATE(1837)] = 95389,
  [SMALL_STATE(1838)] = 95469,
  [SMALL_STATE(1839)] = 95549,
  [SMALL_STATE(1840)] = 95629,
  [SMALL_STATE(1841)] = 95695,
  [SMALL_STATE(1842)] = 95775,
  [SMALL_STATE(1843)] = 95855,
  [SMALL_STATE(1844)] = 95935,
  [SMALL_STATE(1845)] = 96015,
  [SMALL_STATE(1846)] = 96095,
  [SMALL_STATE(1847)] = 96175,
  [SMALL_STATE(1848)] = 96255,
  [SMALL_STATE(1849)] = 96303,
  [SMALL_STATE(1850)] = 96383,
  [SMALL_STATE(1851)] = 96427,
  [SMALL_STATE(1852)] = 96507,
  [SMALL_STATE(1853)] = 96587,
  [SMALL_STATE(1854)] = 96631,
  [SMALL_STATE(1855)] = 96675,
  [SMALL_STATE(1856)] = 96755,
  [SMALL_STATE(1857)] = 96835,
  [SMALL_STATE(1858)] = 96915,
  [SMALL_STATE(1859)] = 96995,
  [SMALL_STATE(1860)] = 97075,
  [SMALL_STATE(1861)] = 97119,
  [SMALL_STATE(1862)] = 97199,
  [SMALL_STATE(1863)] = 97279,
  [SMALL_STATE(1864)] = 97359,
  [SMALL_STATE(1865)] = 97439,
  [SMALL_STATE(1866)] = 97519,
  [SMALL_STATE(1867)] = 97599,
  [SMALL_STATE(1868)] = 97679,
  [SMALL_STATE(1869)] = 97723,
  [SMALL_STATE(1870)] = 97789,
  [SMALL_STATE(1871)] = 97869,
  [SMALL_STATE(1872)] = 97949,
  [SMALL_STATE(1873)] = 98029,
  [SMALL_STATE(1874)] = 98109,
  [SMALL_STATE(1875)] = 98189,
  [SMALL_STATE(1876)] = 98269,
  [SMALL_STATE(1877)] = 98349,
  [SMALL_STATE(1878)] = 98429,
  [SMALL_STATE(1879)] = 98509,
  [SMALL_STATE(1880)] = 98553,
  [SMALL_STATE(1881)] = 98629,
  [SMALL_STATE(1882)] = 98709,
  [SMALL_STATE(1883)] = 98789,
  [SMALL_STATE(1884)] = 98833,
  [SMALL_STATE(1885)] = 98910,
  [SMALL_STATE(1886)] = 98973,
  [SMALL_STATE(1887)] = 99050,
  [SMALL_STATE(1888)] = 99127,
  [SMALL_STATE(1889)] = 99204,
  [SMALL_STATE(1890)] = 99281,
  [SMALL_STATE(1891)] = 99358,
  [SMALL_STATE(1892)] = 99435,
  [SMALL_STATE(1893)] = 99512,
  [SMALL_STATE(1894)] = 99575,
  [SMALL_STATE(1895)] = 99650,
  [SMALL_STATE(1896)] = 99727,
  [SMALL_STATE(1897)] = 99770,
  [SMALL_STATE(1898)] = 99847,
  [SMALL_STATE(1899)] = 99924,
  [SMALL_STATE(1900)] = 100001,
  [SMALL_STATE(1901)] = 100078,
  [SMALL_STATE(1902)] = 100155,
  [SMALL_STATE(1903)] = 100232,
  [SMALL_STATE(1904)] = 100309,
  [SMALL_STATE(1905)] = 100370,
  [SMALL_STATE(1906)] = 100413,
  [SMALL_STATE(1907)] = 100490,
  [SMALL_STATE(1908)] = 100567,
  [SMALL_STATE(1909)] = 100630,
  [SMALL_STATE(1910)] = 100693,
  [SMALL_STATE(1911)] = 100770,
  [SMALL_STATE(1912)] = 100813,
  [SMALL_STATE(1913)] = 100890,
  [SMALL_STATE(1914)] = 100967,
  [SMALL_STATE(1915)] = 101041,
  [SMALL_STATE(1916)] = 101115,
  [SMALL_STATE(1917)] = 101189,
  [SMALL_STATE(1918)] = 101263,
  [SMALL_STATE(1919)] = 101333,
  [SMALL_STATE(1920)] = 101375,
  [SMALL_STATE(1921)] = 101445,
  [SMALL_STATE(1922)] = 101497,
  [SMALL_STATE(1923)] = 101557,
  [SMALL_STATE(1924)] = 101631,
  [SMALL_STATE(1925)] = 101705,
  [SMALL_STATE(1926)] = 101775,
  [SMALL_STATE(1927)] = 101845,
  [SMALL_STATE(1928)] = 101919,
  [SMALL_STATE(1929)] = 101993,
  [SMALL_STATE(1930)] = 102063,
  [SMALL_STATE(1931)] = 102132,
  [SMALL_STATE(1932)] = 102177,
  [SMALL_STATE(1933)] = 102222,
  [SMALL_STATE(1934)] = 102281,
  [SMALL_STATE(1935)] = 102350,
  [SMALL_STATE(1936)] = 102421,
  [SMALL_STATE(1937)] = 102466,
  [SMALL_STATE(1938)] = 102533,
  [SMALL_STATE(1939)] = 102578,
  [SMALL_STATE(1940)] = 102623,
  [SMALL_STATE(1941)] = 102668,
  [SMALL_STATE(1942)] = 102735,
  [SMALL_STATE(1943)] = 102802,
  [SMALL_STATE(1944)] = 102847,
  [SMALL_STATE(1945)] = 102914,
  [SMALL_STATE(1946)] = 102977,
  [SMALL_STATE(1947)] = 103046,
  [SMALL_STATE(1948)] = 103087,
  [SMALL_STATE(1949)] = 103132,
  [SMALL_STATE(1950)] = 103177,
  [SMALL_STATE(1951)] = 103246,
  [SMALL_STATE(1952)] = 103291,
  [SMALL_STATE(1953)] = 103336,
  [SMALL_STATE(1954)] = 103377,
  [SMALL_STATE(1955)] = 103418,
  [SMALL_STATE(1956)] = 103463,
  [SMALL_STATE(1957)] = 103508,
  [SMALL_STATE(1958)] = 103577,
  [SMALL_STATE(1959)] = 103644,
  [SMALL_STATE(1960)] = 103685,
  [SMALL_STATE(1961)] = 103730,
  [SMALL_STATE(1962)] = 103798,
  [SMALL_STATE(1963)] = 103838,
  [SMALL_STATE(1964)] = 103878,
  [SMALL_STATE(1965)] = 103918,
  [SMALL_STATE(1966)] = 103958,
  [SMALL_STATE(1967)] = 103998,
  [SMALL_STATE(1968)] = 104038,
  [SMALL_STATE(1969)] = 104078,
  [SMALL_STATE(1970)] = 104146,
  [SMALL_STATE(1971)] = 104186,
  [SMALL_STATE(1972)] = 104251,
  [SMALL_STATE(1973)] = 104316,
  [SMALL_STATE(1974)] = 104355,
  [SMALL_STATE(1975)] = 104394,
  [SMALL_STATE(1976)] = 104433,
  [SMALL_STATE(1977)] = 104496,
  [SMALL_STATE(1978)] = 104535,
  [SMALL_STATE(1979)] = 104574,
  [SMALL_STATE(1980)] = 104613,
  [SMALL_STATE(1981)] = 104652,
  [SMALL_STATE(1982)] = 104717,
  [SMALL_STATE(1983)] = 104756,
  [SMALL_STATE(1984)] = 104821,
  [SMALL_STATE(1985)] = 104884,
  [SMALL_STATE(1986)] = 104929,
  [SMALL_STATE(1987)] = 104994,
  [SMALL_STATE(1988)] = 105059,
  [SMALL_STATE(1989)] = 105124,
  [SMALL_STATE(1990)] = 105189,
  [SMALL_STATE(1991)] = 105226,
  [SMALL_STATE(1992)] = 105265,
  [SMALL_STATE(1993)] = 105328,
  [SMALL_STATE(1994)] = 105391,
  [SMALL_STATE(1995)] = 105430,
  [SMALL_STATE(1996)] = 105493,
  [SMALL_STATE(1997)] = 105532,
  [SMALL_STATE(1998)] = 105571,
  [SMALL_STATE(1999)] = 105610,
  [SMALL_STATE(2000)] = 105649,
  [SMALL_STATE(2001)] = 105706,
  [SMALL_STATE(2002)] = 105745,
  [SMALL_STATE(2003)] = 105784,
  [SMALL_STATE(2004)] = 105823,
  [SMALL_STATE(2005)] = 105873,
  [SMALL_STATE(2006)] = 105935,
  [SMALL_STATE(2007)] = 105997,
  [SMALL_STATE(2008)] = 106059,
  [SMALL_STATE(2009)] = 106097,
  [SMALL_STATE(2010)] = 106135,
  [SMALL_STATE(2011)] = 106197,
  [SMALL_STATE(2012)] = 106235,
  [SMALL_STATE(2013)] = 106273,
  [SMALL_STATE(2014)] = 106335,
  [SMALL_STATE(2015)] = 106373,
  [SMALL_STATE(2016)] = 106411,
  [SMALL_STATE(2017)] = 106449,
  [SMALL_STATE(2018)] = 106487,
  [SMALL_STATE(2019)] = 106527,
  [SMALL_STATE(2020)] = 106589,
  [SMALL_STATE(2021)] = 106627,
  [SMALL_STATE(2022)] = 106689,
  [SMALL_STATE(2023)] = 106727,
  [SMALL_STATE(2024)] = 106789,
  [SMALL_STATE(2025)] = 106827,
  [SMALL_STATE(2026)] = 106865,
  [SMALL_STATE(2027)] = 106903,
  [SMALL_STATE(2028)] = 106965,
  [SMALL_STATE(2029)] = 107003,
  [SMALL_STATE(2030)] = 107041,
  [SMALL_STATE(2031)] = 107103,
  [SMALL_STATE(2032)] = 107141,
  [SMALL_STATE(2033)] = 107191,
  [SMALL_STATE(2034)] = 107253,
  [SMALL_STATE(2035)] = 107291,
  [SMALL_STATE(2036)] = 107353,
  [SMALL_STATE(2037)] = 107415,
  [SMALL_STATE(2038)] = 107457,
  [SMALL_STATE(2039)] = 107511,
  [SMALL_STATE(2040)] = 107561,
  [SMALL_STATE(2041)] = 107623,
  [SMALL_STATE(2042)] = 107673,
  [SMALL_STATE(2043)] = 107735,
  [SMALL_STATE(2044)] = 107797,
  [SMALL_STATE(2045)] = 107859,
  [SMALL_STATE(2046)] = 107897,
  [SMALL_STATE(2047)] = 107935,
  [SMALL_STATE(2048)] = 107973,
  [SMALL_STATE(2049)] = 108035,
  [SMALL_STATE(2050)] = 108073,
  [SMALL_STATE(2051)] = 108111,
  [SMALL_STATE(2052)] = 108173,
  [SMALL_STATE(2053)] = 108211,
  [SMALL_STATE(2054)] = 108273,
  [SMALL_STATE(2055)] = 108335,
  [SMALL_STATE(2056)] = 108373,
  [SMALL_STATE(2057)] = 108411,
  [SMALL_STATE(2058)] = 108470,
  [SMALL_STATE(2059)] = 108529,
  [SMALL_STATE(2060)] = 108588,
  [SMALL_STATE(2061)] = 108641,
  [SMALL_STATE(2062)] = 108700,
  [SMALL_STATE(2063)] = 108759,
  [SMALL_STATE(2064)] = 108812,
  [SMALL_STATE(2065)] = 108871,
  [SMALL_STATE(2066)] = 108930,
  [SMALL_STATE(2067)] = 108989,
  [SMALL_STATE(2068)] = 109028,
  [SMALL_STATE(2069)] = 109087,
  [SMALL_STATE(2070)] = 109146,
  [SMALL_STATE(2071)] = 109205,
  [SMALL_STATE(2072)] = 109264,
  [SMALL_STATE(2073)] = 109323,
  [SMALL_STATE(2074)] = 109382,
  [SMALL_STATE(2075)] = 109441,
  [SMALL_STATE(2076)] = 109500,
  [SMALL_STATE(2077)] = 109559,
  [SMALL_STATE(2078)] = 109618,
  [SMALL_STATE(2079)] = 109653,
  [SMALL_STATE(2080)] = 109712,
  [SMALL_STATE(2081)] = 109771,
  [SMALL_STATE(2082)] = 109830,
  [SMALL_STATE(2083)] = 109889,
  [SMALL_STATE(2084)] = 109948,
  [SMALL_STATE(2085)] = 110007,
  [SMALL_STATE(2086)] = 110066,
  [SMALL_STATE(2087)] = 110125,
  [SMALL_STATE(2088)] = 110184,
  [SMALL_STATE(2089)] = 110243,
  [SMALL_STATE(2090)] = 110302,
  [SMALL_STATE(2091)] = 110361,
  [SMALL_STATE(2092)] = 110420,
  [SMALL_STATE(2093)] = 110479,
  [SMALL_STATE(2094)] = 110538,
  [SMALL_STATE(2095)] = 110597,
  [SMALL_STATE(2096)] = 110638,
  [SMALL_STATE(2097)] = 110697,
  [SMALL_STATE(2098)] = 110756,
  [SMALL_STATE(2099)] = 110815,
  [SMALL_STATE(2100)] = 110854,
  [SMALL_STATE(2101)] = 110913,
  [SMALL_STATE(2102)] = 110952,
  [SMALL_STATE(2103)] = 110986,
  [SMALL_STATE(2104)] = 111042,
  [SMALL_STATE(2105)] = 111076,
  [SMALL_STATE(2106)] = 111110,
  [SMALL_STATE(2107)] = 111144,
  [SMALL_STATE(2108)] = 111200,
  [SMALL_STATE(2109)] = 111234,
  [SMALL_STATE(2110)] = 111268,
  [SMALL_STATE(2111)] = 111302,
  [SMALL_STATE(2112)] = 111356,
  [SMALL_STATE(2113)] = 111402,
  [SMALL_STATE(2114)] = 111438,
  [SMALL_STATE(2115)] = 111472,
  [SMALL_STATE(2116)] = 111506,
  [SMALL_STATE(2117)] = 111552,
  [SMALL_STATE(2118)] = 111596,
  [SMALL_STATE(2119)] = 111650,
  [SMALL_STATE(2120)] = 111684,
  [SMALL_STATE(2121)] = 111718,
  [SMALL_STATE(2122)] = 111752,
  [SMALL_STATE(2123)] = 111786,
  [SMALL_STATE(2124)] = 111820,
  [SMALL_STATE(2125)] = 111854,
  [SMALL_STATE(2126)] = 111888,
  [SMALL_STATE(2127)] = 111936,
  [SMALL_STATE(2128)] = 111970,
  [SMALL_STATE(2129)] = 112004,
  [SMALL_STATE(2130)] = 112044,
  [SMALL_STATE(2131)] = 112078,
  [SMALL_STATE(2132)] = 112124,
  [SMALL_STATE(2133)] = 112170,
  [SMALL_STATE(2134)] = 112204,
  [SMALL_STATE(2135)] = 112238,
  [SMALL_STATE(2136)] = 112279,
  [SMALL_STATE(2137)] = 112318,
  [SMALL_STATE(2138)] = 112359,
  [SMALL_STATE(2139)] = 112400,
  [SMALL_STATE(2140)] = 112453,
  [SMALL_STATE(2141)] = 112492,
  [SMALL_STATE(2142)] = 112539,
  [SMALL_STATE(2143)] = 112578,
  [SMALL_STATE(2144)] = 112615,
  [SMALL_STATE(2145)] = 112662,
  [SMALL_STATE(2146)] = 112699,
  [SMALL_STATE(2147)] = 112752,
  [SMALL_STATE(2148)] = 112791,
  [SMALL_STATE(2149)] = 112841,
  [SMALL_STATE(2150)] = 112875,
  [SMALL_STATE(2151)] = 112919,
  [SMALL_STATE(2152)] = 112961,
  [SMALL_STATE(2153)] = 112999,
  [SMALL_STATE(2154)] = 113043,
  [SMALL_STATE(2155)] = 113087,
  [SMALL_STATE(2156)] = 113123,
  [SMALL_STATE(2157)] = 113169,
  [SMALL_STATE(2158)] = 113213,
  [SMALL_STATE(2159)] = 113247,
  [SMALL_STATE(2160)] = 113281,
  [SMALL_STATE(2161)] = 113325,
  [SMALL_STATE(2162)] = 113367,
  [SMALL_STATE(2163)] = 113411,
  [SMALL_STATE(2164)] = 113449,
  [SMALL_STATE(2165)] = 113495,
  [SMALL_STATE(2166)] = 113539,
  [SMALL_STATE(2167)] = 113583,
  [SMALL_STATE(2168)] = 113621,
  [SMALL_STATE(2169)] = 113671,
  [SMALL_STATE(2170)] = 113705,
  [SMALL_STATE(2171)] = 113749,
  [SMALL_STATE(2172)] = 113799,
  [SMALL_STATE(2173)] = 113843,
  [SMALL_STATE(2174)] = 113887,
  [SMALL_STATE(2175)] = 113929,
  [SMALL_STATE(2176)] = 113969,
  [SMALL_STATE(2177)] = 114011,
  [SMALL_STATE(2178)] = 114055,
  [SMALL_STATE(2179)] = 114099,
  [SMALL_STATE(2180)] = 114143,
  [SMALL_STATE(2181)] = 114187,
  [SMALL_STATE(2182)] = 114231,
  [SMALL_STATE(2183)] = 114275,
  [SMALL_STATE(2184)] = 114319,
  [SMALL_STATE(2185)] = 114363,
  [SMALL_STATE(2186)] = 114407,
  [SMALL_STATE(2187)] = 114438,
  [SMALL_STATE(2188)] = 114479,
  [SMALL_STATE(2189)] = 114524,
  [SMALL_STATE(2190)] = 114567,
  [SMALL_STATE(2191)] = 114600,
  [SMALL_STATE(2192)] = 114641,
  [SMALL_STATE(2193)] = 114682,
  [SMALL_STATE(2194)] = 114727,
  [SMALL_STATE(2195)] = 114772,
  [SMALL_STATE(2196)] = 114815,
  [SMALL_STATE(2197)] = 114856,
  [SMALL_STATE(2198)] = 114887,
  [SMALL_STATE(2199)] = 114928,
  [SMALL_STATE(2200)] = 114959,
  [SMALL_STATE(2201)] = 115002,
  [SMALL_STATE(2202)] = 115041,
  [SMALL_STATE(2203)] = 115080,
  [SMALL_STATE(2204)] = 115119,
  [SMALL_STATE(2205)] = 115150,
  [SMALL_STATE(2206)] = 115193,
  [SMALL_STATE(2207)] = 115232,
  [SMALL_STATE(2208)] = 115275,
  [SMALL_STATE(2209)] = 115316,
  [SMALL_STATE(2210)] = 115357,
  [SMALL_STATE(2211)] = 115398,
  [SMALL_STATE(2212)] = 115439,
  [SMALL_STATE(2213)] = 115480,
  [SMALL_STATE(2214)] = 115521,
  [SMALL_STATE(2215)] = 115562,
  [SMALL_STATE(2216)] = 115603,
  [SMALL_STATE(2217)] = 115644,
  [SMALL_STATE(2218)] = 115675,
  [SMALL_STATE(2219)] = 115716,
  [SMALL_STATE(2220)] = 115757,
  [SMALL_STATE(2221)] = 115798,
  [SMALL_STATE(2222)] = 115843,
  [SMALL_STATE(2223)] = 115884,
  [SMALL_STATE(2224)] = 115925,
  [SMALL_STATE(2225)] = 115972,
  [SMALL_STATE(2226)] = 116013,
  [SMALL_STATE(2227)] = 116054,
  [SMALL_STATE(2228)] = 116095,
  [SMALL_STATE(2229)] = 116140,
  [SMALL_STATE(2230)] = 116181,
  [SMALL_STATE(2231)] = 116212,
  [SMALL_STATE(2232)] = 116243,
  [SMALL_STATE(2233)] = 116284,
  [SMALL_STATE(2234)] = 116325,
  [SMALL_STATE(2235)] = 116372,
  [SMALL_STATE(2236)] = 116419,
  [SMALL_STATE(2237)] = 116460,
  [SMALL_STATE(2238)] = 116501,
  [SMALL_STATE(2239)] = 116542,
  [SMALL_STATE(2240)] = 116583,
  [SMALL_STATE(2241)] = 116624,
  [SMALL_STATE(2242)] = 116665,
  [SMALL_STATE(2243)] = 116706,
  [SMALL_STATE(2244)] = 116747,
  [SMALL_STATE(2245)] = 116788,
  [SMALL_STATE(2246)] = 116829,
  [SMALL_STATE(2247)] = 116870,
  [SMALL_STATE(2248)] = 116911,
  [SMALL_STATE(2249)] = 116952,
  [SMALL_STATE(2250)] = 116993,
  [SMALL_STATE(2251)] = 117034,
  [SMALL_STATE(2252)] = 117075,
  [SMALL_STATE(2253)] = 117120,
  [SMALL_STATE(2254)] = 117161,
  [SMALL_STATE(2255)] = 117202,
  [SMALL_STATE(2256)] = 117243,
  [SMALL_STATE(2257)] = 117284,
  [SMALL_STATE(2258)] = 117331,
  [SMALL_STATE(2259)] = 117364,
  [SMALL_STATE(2260)] = 117405,
  [SMALL_STATE(2261)] = 117450,
  [SMALL_STATE(2262)] = 117491,
  [SMALL_STATE(2263)] = 117532,
  [SMALL_STATE(2264)] = 117570,
  [SMALL_STATE(2265)] = 117606,
  [SMALL_STATE(2266)] = 117642,
  [SMALL_STATE(2267)] = 117686,
  [SMALL_STATE(2268)] = 117730,
  [SMALL_STATE(2269)] = 117762,
  [SMALL_STATE(2270)] = 117806,
  [SMALL_STATE(2271)] = 117838,
  [SMALL_STATE(2272)] = 117870,
  [SMALL_STATE(2273)] = 117914,
  [SMALL_STATE(2274)] = 117950,
  [SMALL_STATE(2275)] = 117982,
  [SMALL_STATE(2276)] = 118016,
  [SMALL_STATE(2277)] = 118052,
  [SMALL_STATE(2278)] = 118096,
  [SMALL_STATE(2279)] = 118126,
  [SMALL_STATE(2280)] = 118168,
  [SMALL_STATE(2281)] = 118204,
  [SMALL_STATE(2282)] = 118240,
  [SMALL_STATE(2283)] = 118272,
  [SMALL_STATE(2284)] = 118316,
  [SMALL_STATE(2285)] = 118358,
  [SMALL_STATE(2286)] = 118394,
  [SMALL_STATE(2287)] = 118438,
  [SMALL_STATE(2288)] = 118482,
  [SMALL_STATE(2289)] = 118516,
  [SMALL_STATE(2290)] = 118552,
  [SMALL_STATE(2291)] = 118590,
  [SMALL_STATE(2292)] = 118624,
  [SMALL_STATE(2293)] = 118654,
  [SMALL_STATE(2294)] = 118688,
  [SMALL_STATE(2295)] = 118726,
  [SMALL_STATE(2296)] = 118764,
  [SMALL_STATE(2297)] = 118800,
  [SMALL_STATE(2298)] = 118844,
  [SMALL_STATE(2299)] = 118882,
  [SMALL_STATE(2300)] = 118924,
  [SMALL_STATE(2301)] = 118962,
  [SMALL_STATE(2302)] = 119000,
  [SMALL_STATE(2303)] = 119036,
  [SMALL_STATE(2304)] = 119072,
  [SMALL_STATE(2305)] = 119110,
  [SMALL_STATE(2306)] = 119146,
  [SMALL_STATE(2307)] = 119184,
  [SMALL_STATE(2308)] = 119218,
  [SMALL_STATE(2309)] = 119248,
  [SMALL_STATE(2310)] = 119292,
  [SMALL_STATE(2311)] = 119326,
  [SMALL_STATE(2312)] = 119362,
  [SMALL_STATE(2313)] = 119406,
  [SMALL_STATE(2314)] = 119444,
  [SMALL_STATE(2315)] = 119482,
  [SMALL_STATE(2316)] = 119518,
  [SMALL_STATE(2317)] = 119556,
  [SMALL_STATE(2318)] = 119594,
  [SMALL_STATE(2319)] = 119632,
  [SMALL_STATE(2320)] = 119670,
  [SMALL_STATE(2321)] = 119712,
  [SMALL_STATE(2322)] = 119744,
  [SMALL_STATE(2323)] = 119782,
  [SMALL_STATE(2324)] = 119816,
  [SMALL_STATE(2325)] = 119854,
  [SMALL_STATE(2326)] = 119890,
  [SMALL_STATE(2327)] = 119928,
  [SMALL_STATE(2328)] = 119972,
  [SMALL_STATE(2329)] = 120010,
  [SMALL_STATE(2330)] = 120046,
  [SMALL_STATE(2331)] = 120084,
  [SMALL_STATE(2332)] = 120120,
  [SMALL_STATE(2333)] = 120151,
  [SMALL_STATE(2334)] = 120182,
  [SMALL_STATE(2335)] = 120211,
  [SMALL_STATE(2336)] = 120242,
  [SMALL_STATE(2337)] = 120277,
  [SMALL_STATE(2338)] = 120308,
  [SMALL_STATE(2339)] = 120339,
  [SMALL_STATE(2340)] = 120378,
  [SMALL_STATE(2341)] = 120409,
  [SMALL_STATE(2342)] = 120440,
  [SMALL_STATE(2343)] = 120479,
  [SMALL_STATE(2344)] = 120520,
  [SMALL_STATE(2345)] = 120561,
  [SMALL_STATE(2346)] = 120592,
  [SMALL_STATE(2347)] = 120623,
  [SMALL_STATE(2348)] = 120654,
  [SMALL_STATE(2349)] = 120685,
  [SMALL_STATE(2350)] = 120716,
  [SMALL_STATE(2351)] = 120747,
  [SMALL_STATE(2352)] = 120778,
  [SMALL_STATE(2353)] = 120811,
  [SMALL_STATE(2354)] = 120842,
  [SMALL_STATE(2355)] = 120873,
  [SMALL_STATE(2356)] = 120904,
  [SMALL_STATE(2357)] = 120935,
  [SMALL_STATE(2358)] = 120976,
  [SMALL_STATE(2359)] = 121015,
  [SMALL_STATE(2360)] = 121046,
  [SMALL_STATE(2361)] = 121077,
  [SMALL_STATE(2362)] = 121110,
  [SMALL_STATE(2363)] = 121141,
  [SMALL_STATE(2364)] = 121172,
  [SMALL_STATE(2365)] = 121203,
  [SMALL_STATE(2366)] = 121234,
  [SMALL_STATE(2367)] = 121265,
  [SMALL_STATE(2368)] = 121296,
  [SMALL_STATE(2369)] = 121335,
  [SMALL_STATE(2370)] = 121366,
  [SMALL_STATE(2371)] = 121405,
  [SMALL_STATE(2372)] = 121436,
  [SMALL_STATE(2373)] = 121477,
  [SMALL_STATE(2374)] = 121506,
  [SMALL_STATE(2375)] = 121537,
  [SMALL_STATE(2376)] = 121568,
  [SMALL_STATE(2377)] = 121599,
  [SMALL_STATE(2378)] = 121640,
  [SMALL_STATE(2379)] = 121681,
  [SMALL_STATE(2380)] = 121712,
  [SMALL_STATE(2381)] = 121743,
  [SMALL_STATE(2382)] = 121774,
  [SMALL_STATE(2383)] = 121805,
  [SMALL_STATE(2384)] = 121836,
  [SMALL_STATE(2385)] = 121867,
  [SMALL_STATE(2386)] = 121898,
  [SMALL_STATE(2387)] = 121929,
  [SMALL_STATE(2388)] = 121960,
  [SMALL_STATE(2389)] = 121991,
  [SMALL_STATE(2390)] = 122022,
  [SMALL_STATE(2391)] = 122053,
  [SMALL_STATE(2392)] = 122084,
  [SMALL_STATE(2393)] = 122115,
  [SMALL_STATE(2394)] = 122146,
  [SMALL_STATE(2395)] = 122177,
  [SMALL_STATE(2396)] = 122218,
  [SMALL_STATE(2397)] = 122249,
  [SMALL_STATE(2398)] = 122280,
  [SMALL_STATE(2399)] = 122311,
  [SMALL_STATE(2400)] = 122342,
  [SMALL_STATE(2401)] = 122383,
  [SMALL_STATE(2402)] = 122414,
  [SMALL_STATE(2403)] = 122445,
  [SMALL_STATE(2404)] = 122484,
  [SMALL_STATE(2405)] = 122515,
  [SMALL_STATE(2406)] = 122546,
  [SMALL_STATE(2407)] = 122579,
  [SMALL_STATE(2408)] = 122614,
  [SMALL_STATE(2409)] = 122645,
  [SMALL_STATE(2410)] = 122676,
  [SMALL_STATE(2411)] = 122717,
  [SMALL_STATE(2412)] = 122758,
  [SMALL_STATE(2413)] = 122789,
  [SMALL_STATE(2414)] = 122820,
  [SMALL_STATE(2415)] = 122851,
  [SMALL_STATE(2416)] = 122882,
  [SMALL_STATE(2417)] = 122913,
  [SMALL_STATE(2418)] = 122952,
  [SMALL_STATE(2419)] = 122987,
  [SMALL_STATE(2420)] = 123028,
  [SMALL_STATE(2421)] = 123065,
  [SMALL_STATE(2422)] = 123104,
  [SMALL_STATE(2423)] = 123143,
  [SMALL_STATE(2424)] = 123174,
  [SMALL_STATE(2425)] = 123211,
  [SMALL_STATE(2426)] = 123244,
  [SMALL_STATE(2427)] = 123283,
  [SMALL_STATE(2428)] = 123314,
  [SMALL_STATE(2429)] = 123345,
  [SMALL_STATE(2430)] = 123376,
  [SMALL_STATE(2431)] = 123407,
  [SMALL_STATE(2432)] = 123444,
  [SMALL_STATE(2433)] = 123475,
  [SMALL_STATE(2434)] = 123516,
  [SMALL_STATE(2435)] = 123549,
  [SMALL_STATE(2436)] = 123580,
  [SMALL_STATE(2437)] = 123621,
  [SMALL_STATE(2438)] = 123662,
  [SMALL_STATE(2439)] = 123693,
  [SMALL_STATE(2440)] = 123721,
  [SMALL_STATE(2441)] = 123759,
  [SMALL_STATE(2442)] = 123789,
  [SMALL_STATE(2443)] = 123827,
  [SMALL_STATE(2444)] = 123863,
  [SMALL_STATE(2445)] = 123899,
  [SMALL_STATE(2446)] = 123927,
  [SMALL_STATE(2447)] = 123957,
  [SMALL_STATE(2448)] = 123985,
  [SMALL_STATE(2449)] = 124013,
  [SMALL_STATE(2450)] = 124043,
  [SMALL_STATE(2451)] = 124081,
  [SMALL_STATE(2452)] = 124113,
  [SMALL_STATE(2453)] = 124151,
  [SMALL_STATE(2454)] = 124181,
  [SMALL_STATE(2455)] = 124209,
  [SMALL_STATE(2456)] = 124243,
  [SMALL_STATE(2457)] = 124279,
  [SMALL_STATE(2458)] = 124307,
  [SMALL_STATE(2459)] = 124337,
  [SMALL_STATE(2460)] = 124367,
  [SMALL_STATE(2461)] = 124397,
  [SMALL_STATE(2462)] = 124435,
  [SMALL_STATE(2463)] = 124473,
  [SMALL_STATE(2464)] = 124511,
  [SMALL_STATE(2465)] = 124539,
  [SMALL_STATE(2466)] = 124567,
  [SMALL_STATE(2467)] = 124595,
  [SMALL_STATE(2468)] = 124625,
  [SMALL_STATE(2469)] = 124653,
  [SMALL_STATE(2470)] = 124691,
  [SMALL_STATE(2471)] = 124727,
  [SMALL_STATE(2472)] = 124765,
  [SMALL_STATE(2473)] = 124803,
  [SMALL_STATE(2474)] = 124841,
  [SMALL_STATE(2475)] = 124879,
  [SMALL_STATE(2476)] = 124907,
  [SMALL_STATE(2477)] = 124945,
  [SMALL_STATE(2478)] = 124981,
  [SMALL_STATE(2479)] = 125009,
  [SMALL_STATE(2480)] = 125047,
  [SMALL_STATE(2481)] = 125075,
  [SMALL_STATE(2482)] = 125105,
  [SMALL_STATE(2483)] = 125143,
  [SMALL_STATE(2484)] = 125181,
  [SMALL_STATE(2485)] = 125217,
  [SMALL_STATE(2486)] = 125255,
  [SMALL_STATE(2487)] = 125293,
  [SMALL_STATE(2488)] = 125323,
  [SMALL_STATE(2489)] = 125351,
  [SMALL_STATE(2490)] = 125389,
  [SMALL_STATE(2491)] = 125425,
  [SMALL_STATE(2492)] = 125461,
  [SMALL_STATE(2493)] = 125491,
  [SMALL_STATE(2494)] = 125521,
  [SMALL_STATE(2495)] = 125559,
  [SMALL_STATE(2496)] = 125589,
  [SMALL_STATE(2497)] = 125623,
  [SMALL_STATE(2498)] = 125651,
  [SMALL_STATE(2499)] = 125681,
  [SMALL_STATE(2500)] = 125711,
  [SMALL_STATE(2501)] = 125749,
  [SMALL_STATE(2502)] = 125787,
  [SMALL_STATE(2503)] = 125821,
  [SMALL_STATE(2504)] = 125855,
  [SMALL_STATE(2505)] = 125885,
  [SMALL_STATE(2506)] = 125921,
  [SMALL_STATE(2507)] = 125951,
  [SMALL_STATE(2508)] = 125985,
  [SMALL_STATE(2509)] = 126015,
  [SMALL_STATE(2510)] = 126051,
  [SMALL_STATE(2511)] = 126087,
  [SMALL_STATE(2512)] = 126125,
  [SMALL_STATE(2513)] = 126161,
  [SMALL_STATE(2514)] = 126199,
  [SMALL_STATE(2515)] = 126235,
  [SMALL_STATE(2516)] = 126265,
  [SMALL_STATE(2517)] = 126295,
  [SMALL_STATE(2518)] = 126323,
  [SMALL_STATE(2519)] = 126353,
  [SMALL_STATE(2520)] = 126383,
  [SMALL_STATE(2521)] = 126413,
  [SMALL_STATE(2522)] = 126445,
  [SMALL_STATE(2523)] = 126481,
  [SMALL_STATE(2524)] = 126509,
  [SMALL_STATE(2525)] = 126537,
  [SMALL_STATE(2526)] = 126565,
  [SMALL_STATE(2527)] = 126595,
  [SMALL_STATE(2528)] = 126633,
  [SMALL_STATE(2529)] = 126660,
  [SMALL_STATE(2530)] = 126691,
  [SMALL_STATE(2531)] = 126724,
  [SMALL_STATE(2532)] = 126751,
  [SMALL_STATE(2533)] = 126782,
  [SMALL_STATE(2534)] = 126809,
  [SMALL_STATE(2535)] = 126840,
  [SMALL_STATE(2536)] = 126871,
  [SMALL_STATE(2537)] = 126906,
  [SMALL_STATE(2538)] = 126933,
  [SMALL_STATE(2539)] = 126960,
  [SMALL_STATE(2540)] = 126995,
  [SMALL_STATE(2541)] = 127030,
  [SMALL_STATE(2542)] = 127059,
  [SMALL_STATE(2543)] = 127094,
  [SMALL_STATE(2544)] = 127121,
  [SMALL_STATE(2545)] = 127156,
  [SMALL_STATE(2546)] = 127191,
  [SMALL_STATE(2547)] = 127226,
  [SMALL_STATE(2548)] = 127261,
  [SMALL_STATE(2549)] = 127296,
  [SMALL_STATE(2550)] = 127331,
  [SMALL_STATE(2551)] = 127366,
  [SMALL_STATE(2552)] = 127397,
  [SMALL_STATE(2553)] = 127432,
  [SMALL_STATE(2554)] = 127463,
  [SMALL_STATE(2555)] = 127494,
  [SMALL_STATE(2556)] = 127525,
  [SMALL_STATE(2557)] = 127554,
  [SMALL_STATE(2558)] = 127589,
  [SMALL_STATE(2559)] = 127616,
  [SMALL_STATE(2560)] = 127651,
  [SMALL_STATE(2561)] = 127682,
  [SMALL_STATE(2562)] = 127717,
  [SMALL_STATE(2563)] = 127746,
  [SMALL_STATE(2564)] = 127781,
  [SMALL_STATE(2565)] = 127816,
  [SMALL_STATE(2566)] = 127849,
  [SMALL_STATE(2567)] = 127884,
  [SMALL_STATE(2568)] = 127919,
  [SMALL_STATE(2569)] = 127948,
  [SMALL_STATE(2570)] = 127975,
  [SMALL_STATE(2571)] = 128002,
  [SMALL_STATE(2572)] = 128037,
  [SMALL_STATE(2573)] = 128072,
  [SMALL_STATE(2574)] = 128099,
  [SMALL_STATE(2575)] = 128134,
  [SMALL_STATE(2576)] = 128163,
  [SMALL_STATE(2577)] = 128198,
  [SMALL_STATE(2578)] = 128233,
  [SMALL_STATE(2579)] = 128268,
  [SMALL_STATE(2580)] = 128303,
  [SMALL_STATE(2581)] = 128334,
  [SMALL_STATE(2582)] = 128365,
  [SMALL_STATE(2583)] = 128400,
  [SMALL_STATE(2584)] = 128427,
  [SMALL_STATE(2585)] = 128454,
  [SMALL_STATE(2586)] = 128481,
  [SMALL_STATE(2587)] = 128516,
  [SMALL_STATE(2588)] = 128551,
  [SMALL_STATE(2589)] = 128577,
  [SMALL_STATE(2590)] = 128605,
  [SMALL_STATE(2591)] = 128631,
  [SMALL_STATE(2592)] = 128661,
  [SMALL_STATE(2593)] = 128693,
  [SMALL_STATE(2594)] = 128723,
  [SMALL_STATE(2595)] = 128755,
  [SMALL_STATE(2596)] = 128787,
  [SMALL_STATE(2597)] = 128819,
  [SMALL_STATE(2598)] = 128845,
  [SMALL_STATE(2599)] = 128871,
  [SMALL_STATE(2600)] = 128897,
  [SMALL_STATE(2601)] = 128923,
  [SMALL_STATE(2602)] = 128949,
  [SMALL_STATE(2603)] = 128981,
  [SMALL_STATE(2604)] = 129013,
  [SMALL_STATE(2605)] = 129045,
  [SMALL_STATE(2606)] = 129073,
  [SMALL_STATE(2607)] = 129099,
  [SMALL_STATE(2608)] = 129131,
  [SMALL_STATE(2609)] = 129163,
  [SMALL_STATE(2610)] = 129195,
  [SMALL_STATE(2611)] = 129225,
  [SMALL_STATE(2612)] = 129257,
  [SMALL_STATE(2613)] = 129289,
  [SMALL_STATE(2614)] = 129321,
  [SMALL_STATE(2615)] = 129353,
  [SMALL_STATE(2616)] = 129379,
  [SMALL_STATE(2617)] = 129407,
  [SMALL_STATE(2618)] = 129439,
  [SMALL_STATE(2619)] = 129471,
  [SMALL_STATE(2620)] = 129503,
  [SMALL_STATE(2621)] = 129535,
  [SMALL_STATE(2622)] = 129567,
  [SMALL_STATE(2623)] = 129595,
  [SMALL_STATE(2624)] = 129627,
  [SMALL_STATE(2625)] = 129659,
  [SMALL_STATE(2626)] = 129685,
  [SMALL_STATE(2627)] = 129717,
  [SMALL_STATE(2628)] = 129743,
  [SMALL_STATE(2629)] = 129771,
  [SMALL_STATE(2630)] = 129799,
  [SMALL_STATE(2631)] = 129827,
  [SMALL_STATE(2632)] = 129859,
  [SMALL_STATE(2633)] = 129889,
  [SMALL_STATE(2634)] = 129921,
  [SMALL_STATE(2635)] = 129951,
  [SMALL_STATE(2636)] = 129983,
  [SMALL_STATE(2637)] = 130015,
  [SMALL_STATE(2638)] = 130047,
  [SMALL_STATE(2639)] = 130079,
  [SMALL_STATE(2640)] = 130107,
  [SMALL_STATE(2641)] = 130135,
  [SMALL_STATE(2642)] = 130167,
  [SMALL_STATE(2643)] = 130199,
  [SMALL_STATE(2644)] = 130225,
  [SMALL_STATE(2645)] = 130257,
  [SMALL_STATE(2646)] = 130285,
  [SMALL_STATE(2647)] = 130317,
  [SMALL_STATE(2648)] = 130347,
  [SMALL_STATE(2649)] = 130379,
  [SMALL_STATE(2650)] = 130411,
  [SMALL_STATE(2651)] = 130443,
  [SMALL_STATE(2652)] = 130471,
  [SMALL_STATE(2653)] = 130503,
  [SMALL_STATE(2654)] = 130533,
  [SMALL_STATE(2655)] = 130561,
  [SMALL_STATE(2656)] = 130589,
  [SMALL_STATE(2657)] = 130621,
  [SMALL_STATE(2658)] = 130653,
  [SMALL_STATE(2659)] = 130685,
  [SMALL_STATE(2660)] = 130713,
  [SMALL_STATE(2661)] = 130739,
  [SMALL_STATE(2662)] = 130771,
  [SMALL_STATE(2663)] = 130799,
  [SMALL_STATE(2664)] = 130831,
  [SMALL_STATE(2665)] = 130863,
  [SMALL_STATE(2666)] = 130891,
  [SMALL_STATE(2667)] = 130919,
  [SMALL_STATE(2668)] = 130951,
  [SMALL_STATE(2669)] = 130983,
  [SMALL_STATE(2670)] = 131015,
  [SMALL_STATE(2671)] = 131044,
  [SMALL_STATE(2672)] = 131073,
  [SMALL_STATE(2673)] = 131102,
  [SMALL_STATE(2674)] = 131131,
  [SMALL_STATE(2675)] = 131160,
  [SMALL_STATE(2676)] = 131189,
  [SMALL_STATE(2677)] = 131218,
  [SMALL_STATE(2678)] = 131247,
  [SMALL_STATE(2679)] = 131276,
  [SMALL_STATE(2680)] = 131305,
  [SMALL_STATE(2681)] = 131334,
  [SMALL_STATE(2682)] = 131363,
  [SMALL_STATE(2683)] = 131390,
  [SMALL_STATE(2684)] = 131419,
  [SMALL_STATE(2685)] = 131448,
  [SMALL_STATE(2686)] = 131477,
  [SMALL_STATE(2687)] = 131506,
  [SMALL_STATE(2688)] = 131535,
  [SMALL_STATE(2689)] = 131562,
  [SMALL_STATE(2690)] = 131591,
  [SMALL_STATE(2691)] = 131618,
  [SMALL_STATE(2692)] = 131643,
  [SMALL_STATE(2693)] = 131672,
  [SMALL_STATE(2694)] = 131701,
  [SMALL_STATE(2695)] = 131728,
  [SMALL_STATE(2696)] = 131757,
  [SMALL_STATE(2697)] = 131782,
  [SMALL_STATE(2698)] = 131811,
  [SMALL_STATE(2699)] = 131840,
  [SMALL_STATE(2700)] = 131869,
  [SMALL_STATE(2701)] = 131898,
  [SMALL_STATE(2702)] = 131927,
  [SMALL_STATE(2703)] = 131956,
  [SMALL_STATE(2704)] = 131981,
  [SMALL_STATE(2705)] = 132010,
  [SMALL_STATE(2706)] = 132039,
  [SMALL_STATE(2707)] = 132068,
  [SMALL_STATE(2708)] = 132095,
  [SMALL_STATE(2709)] = 132124,
  [SMALL_STATE(2710)] = 132153,
  [SMALL_STATE(2711)] = 132182,
  [SMALL_STATE(2712)] = 132209,
  [SMALL_STATE(2713)] = 132234,
  [SMALL_STATE(2714)] = 132263,
  [SMALL_STATE(2715)] = 132292,
  [SMALL_STATE(2716)] = 132321,
  [SMALL_STATE(2717)] = 132350,
  [SMALL_STATE(2718)] = 132379,
  [SMALL_STATE(2719)] = 132408,
  [SMALL_STATE(2720)] = 132437,
  [SMALL_STATE(2721)] = 132466,
  [SMALL_STATE(2722)] = 132495,
  [SMALL_STATE(2723)] = 132524,
  [SMALL_STATE(2724)] = 132553,
  [SMALL_STATE(2725)] = 132582,
  [SMALL_STATE(2726)] = 132611,
  [SMALL_STATE(2727)] = 132640,
  [SMALL_STATE(2728)] = 132665,
  [SMALL_STATE(2729)] = 132694,
  [SMALL_STATE(2730)] = 132723,
  [SMALL_STATE(2731)] = 132752,
  [SMALL_STATE(2732)] = 132781,
  [SMALL_STATE(2733)] = 132810,
  [SMALL_STATE(2734)] = 132835,
  [SMALL_STATE(2735)] = 132862,
  [SMALL_STATE(2736)] = 132891,
  [SMALL_STATE(2737)] = 132920,
  [SMALL_STATE(2738)] = 132949,
  [SMALL_STATE(2739)] = 132978,
  [SMALL_STATE(2740)] = 133007,
  [SMALL_STATE(2741)] = 133036,
  [SMALL_STATE(2742)] = 133065,
  [SMALL_STATE(2743)] = 133090,
  [SMALL_STATE(2744)] = 133119,
  [SMALL_STATE(2745)] = 133148,
  [SMALL_STATE(2746)] = 133177,
  [SMALL_STATE(2747)] = 133206,
  [SMALL_STATE(2748)] = 133235,
  [SMALL_STATE(2749)] = 133264,
  [SMALL_STATE(2750)] = 133293,
  [SMALL_STATE(2751)] = 133322,
  [SMALL_STATE(2752)] = 133351,
  [SMALL_STATE(2753)] = 133380,
  [SMALL_STATE(2754)] = 133407,
  [SMALL_STATE(2755)] = 133436,
  [SMALL_STATE(2756)] = 133461,
  [SMALL_STATE(2757)] = 133488,
  [SMALL_STATE(2758)] = 133517,
  [SMALL_STATE(2759)] = 133544,
  [SMALL_STATE(2760)] = 133573,
  [SMALL_STATE(2761)] = 133598,
  [SMALL_STATE(2762)] = 133625,
  [SMALL_STATE(2763)] = 133654,
  [SMALL_STATE(2764)] = 133683,
  [SMALL_STATE(2765)] = 133712,
  [SMALL_STATE(2766)] = 133741,
  [SMALL_STATE(2767)] = 133770,
  [SMALL_STATE(2768)] = 133799,
  [SMALL_STATE(2769)] = 133828,
  [SMALL_STATE(2770)] = 133857,
  [SMALL_STATE(2771)] = 133882,
  [SMALL_STATE(2772)] = 133911,
  [SMALL_STATE(2773)] = 133940,
  [SMALL_STATE(2774)] = 133969,
  [SMALL_STATE(2775)] = 133998,
  [SMALL_STATE(2776)] = 134027,
  [SMALL_STATE(2777)] = 134056,
  [SMALL_STATE(2778)] = 134085,
  [SMALL_STATE(2779)] = 134114,
  [SMALL_STATE(2780)] = 134143,
  [SMALL_STATE(2781)] = 134172,
  [SMALL_STATE(2782)] = 134201,
  [SMALL_STATE(2783)] = 134230,
  [SMALL_STATE(2784)] = 134255,
  [SMALL_STATE(2785)] = 134284,
  [SMALL_STATE(2786)] = 134313,
  [SMALL_STATE(2787)] = 134342,
  [SMALL_STATE(2788)] = 134371,
  [SMALL_STATE(2789)] = 134398,
  [SMALL_STATE(2790)] = 134423,
  [SMALL_STATE(2791)] = 134452,
  [SMALL_STATE(2792)] = 134481,
  [SMALL_STATE(2793)] = 134510,
  [SMALL_STATE(2794)] = 134537,
  [SMALL_STATE(2795)] = 134566,
  [SMALL_STATE(2796)] = 134595,
  [SMALL_STATE(2797)] = 134624,
  [SMALL_STATE(2798)] = 134653,
  [SMALL_STATE(2799)] = 134682,
  [SMALL_STATE(2800)] = 134711,
  [SMALL_STATE(2801)] = 134740,
  [SMALL_STATE(2802)] = 134769,
  [SMALL_STATE(2803)] = 134798,
  [SMALL_STATE(2804)] = 134827,
  [SMALL_STATE(2805)] = 134856,
  [SMALL_STATE(2806)] = 134885,
  [SMALL_STATE(2807)] = 134914,
  [SMALL_STATE(2808)] = 134943,
  [SMALL_STATE(2809)] = 134970,
  [SMALL_STATE(2810)] = 134999,
  [SMALL_STATE(2811)] = 135028,
  [SMALL_STATE(2812)] = 135057,
  [SMALL_STATE(2813)] = 135086,
  [SMALL_STATE(2814)] = 135115,
  [SMALL_STATE(2815)] = 135144,
  [SMALL_STATE(2816)] = 135173,
  [SMALL_STATE(2817)] = 135202,
  [SMALL_STATE(2818)] = 135231,
  [SMALL_STATE(2819)] = 135260,
  [SMALL_STATE(2820)] = 135289,
  [SMALL_STATE(2821)] = 135314,
  [SMALL_STATE(2822)] = 135343,
  [SMALL_STATE(2823)] = 135370,
  [SMALL_STATE(2824)] = 135399,
  [SMALL_STATE(2825)] = 135428,
  [SMALL_STATE(2826)] = 135457,
  [SMALL_STATE(2827)] = 135486,
  [SMALL_STATE(2828)] = 135515,
  [SMALL_STATE(2829)] = 135544,
  [SMALL_STATE(2830)] = 135573,
  [SMALL_STATE(2831)] = 135602,
  [SMALL_STATE(2832)] = 135631,
  [SMALL_STATE(2833)] = 135660,
  [SMALL_STATE(2834)] = 135689,
  [SMALL_STATE(2835)] = 135714,
  [SMALL_STATE(2836)] = 135743,
  [SMALL_STATE(2837)] = 135772,
  [SMALL_STATE(2838)] = 135801,
  [SMALL_STATE(2839)] = 135826,
  [SMALL_STATE(2840)] = 135855,
  [SMALL_STATE(2841)] = 135884,
  [SMALL_STATE(2842)] = 135913,
  [SMALL_STATE(2843)] = 135942,
  [SMALL_STATE(2844)] = 135971,
  [SMALL_STATE(2845)] = 136000,
  [SMALL_STATE(2846)] = 136029,
  [SMALL_STATE(2847)] = 136058,
  [SMALL_STATE(2848)] = 136087,
  [SMALL_STATE(2849)] = 136116,
  [SMALL_STATE(2850)] = 136145,
  [SMALL_STATE(2851)] = 136174,
  [SMALL_STATE(2852)] = 136203,
  [SMALL_STATE(2853)] = 136232,
  [SMALL_STATE(2854)] = 136261,
  [SMALL_STATE(2855)] = 136290,
  [SMALL_STATE(2856)] = 136319,
  [SMALL_STATE(2857)] = 136348,
  [SMALL_STATE(2858)] = 136377,
  [SMALL_STATE(2859)] = 136406,
  [SMALL_STATE(2860)] = 136435,
  [SMALL_STATE(2861)] = 136464,
  [SMALL_STATE(2862)] = 136493,
  [SMALL_STATE(2863)] = 136522,
  [SMALL_STATE(2864)] = 136551,
  [SMALL_STATE(2865)] = 136580,
  [SMALL_STATE(2866)] = 136609,
  [SMALL_STATE(2867)] = 136638,
  [SMALL_STATE(2868)] = 136667,
  [SMALL_STATE(2869)] = 136694,
  [SMALL_STATE(2870)] = 136723,
  [SMALL_STATE(2871)] = 136752,
  [SMALL_STATE(2872)] = 136781,
  [SMALL_STATE(2873)] = 136810,
  [SMALL_STATE(2874)] = 136837,
  [SMALL_STATE(2875)] = 136866,
  [SMALL_STATE(2876)] = 136895,
  [SMALL_STATE(2877)] = 136924,
  [SMALL_STATE(2878)] = 136953,
  [SMALL_STATE(2879)] = 136982,
  [SMALL_STATE(2880)] = 137011,
  [SMALL_STATE(2881)] = 137040,
  [SMALL_STATE(2882)] = 137069,
  [SMALL_STATE(2883)] = 137098,
  [SMALL_STATE(2884)] = 137127,
  [SMALL_STATE(2885)] = 137156,
  [SMALL_STATE(2886)] = 137185,
  [SMALL_STATE(2887)] = 137214,
  [SMALL_STATE(2888)] = 137243,
  [SMALL_STATE(2889)] = 137272,
  [SMALL_STATE(2890)] = 137301,
  [SMALL_STATE(2891)] = 137330,
  [SMALL_STATE(2892)] = 137359,
  [SMALL_STATE(2893)] = 137388,
  [SMALL_STATE(2894)] = 137417,
  [SMALL_STATE(2895)] = 137446,
  [SMALL_STATE(2896)] = 137475,
  [SMALL_STATE(2897)] = 137504,
  [SMALL_STATE(2898)] = 137533,
  [SMALL_STATE(2899)] = 137560,
  [SMALL_STATE(2900)] = 137589,
  [SMALL_STATE(2901)] = 137618,
  [SMALL_STATE(2902)] = 137647,
  [SMALL_STATE(2903)] = 137676,
  [SMALL_STATE(2904)] = 137705,
  [SMALL_STATE(2905)] = 137734,
  [SMALL_STATE(2906)] = 137763,
  [SMALL_STATE(2907)] = 137792,
  [SMALL_STATE(2908)] = 137821,
  [SMALL_STATE(2909)] = 137850,
  [SMALL_STATE(2910)] = 137879,
  [SMALL_STATE(2911)] = 137906,
  [SMALL_STATE(2912)] = 137935,
  [SMALL_STATE(2913)] = 137964,
  [SMALL_STATE(2914)] = 137993,
  [SMALL_STATE(2915)] = 138022,
  [SMALL_STATE(2916)] = 138051,
  [SMALL_STATE(2917)] = 138080,
  [SMALL_STATE(2918)] = 138109,
  [SMALL_STATE(2919)] = 138138,
  [SMALL_STATE(2920)] = 138167,
  [SMALL_STATE(2921)] = 138196,
  [SMALL_STATE(2922)] = 138225,
  [SMALL_STATE(2923)] = 138252,
  [SMALL_STATE(2924)] = 138281,
  [SMALL_STATE(2925)] = 138310,
  [SMALL_STATE(2926)] = 138339,
  [SMALL_STATE(2927)] = 138368,
  [SMALL_STATE(2928)] = 138397,
  [SMALL_STATE(2929)] = 138426,
  [SMALL_STATE(2930)] = 138455,
  [SMALL_STATE(2931)] = 138484,
  [SMALL_STATE(2932)] = 138513,
  [SMALL_STATE(2933)] = 138542,
  [SMALL_STATE(2934)] = 138571,
  [SMALL_STATE(2935)] = 138600,
  [SMALL_STATE(2936)] = 138629,
  [SMALL_STATE(2937)] = 138658,
  [SMALL_STATE(2938)] = 138687,
  [SMALL_STATE(2939)] = 138716,
  [SMALL_STATE(2940)] = 138745,
  [SMALL_STATE(2941)] = 138774,
  [SMALL_STATE(2942)] = 138803,
  [SMALL_STATE(2943)] = 138832,
  [SMALL_STATE(2944)] = 138857,
  [SMALL_STATE(2945)] = 138886,
  [SMALL_STATE(2946)] = 138915,
  [SMALL_STATE(2947)] = 138944,
  [SMALL_STATE(2948)] = 138973,
  [SMALL_STATE(2949)] = 139002,
  [SMALL_STATE(2950)] = 139031,
  [SMALL_STATE(2951)] = 139058,
  [SMALL_STATE(2952)] = 139087,
  [SMALL_STATE(2953)] = 139116,
  [SMALL_STATE(2954)] = 139145,
  [SMALL_STATE(2955)] = 139174,
  [SMALL_STATE(2956)] = 139203,
  [SMALL_STATE(2957)] = 139232,
  [SMALL_STATE(2958)] = 139261,
  [SMALL_STATE(2959)] = 139290,
  [SMALL_STATE(2960)] = 139319,
  [SMALL_STATE(2961)] = 139348,
  [SMALL_STATE(2962)] = 139377,
  [SMALL_STATE(2963)] = 139406,
  [SMALL_STATE(2964)] = 139435,
  [SMALL_STATE(2965)] = 139462,
  [SMALL_STATE(2966)] = 139487,
  [SMALL_STATE(2967)] = 139516,
  [SMALL_STATE(2968)] = 139545,
  [SMALL_STATE(2969)] = 139574,
  [SMALL_STATE(2970)] = 139603,
  [SMALL_STATE(2971)] = 139632,
  [SMALL_STATE(2972)] = 139657,
  [SMALL_STATE(2973)] = 139686,
  [SMALL_STATE(2974)] = 139715,
  [SMALL_STATE(2975)] = 139744,
  [SMALL_STATE(2976)] = 139771,
  [SMALL_STATE(2977)] = 139798,
  [SMALL_STATE(2978)] = 139827,
  [SMALL_STATE(2979)] = 139856,
  [SMALL_STATE(2980)] = 139883,
  [SMALL_STATE(2981)] = 139912,
  [SMALL_STATE(2982)] = 139941,
  [SMALL_STATE(2983)] = 139968,
  [SMALL_STATE(2984)] = 139995,
  [SMALL_STATE(2985)] = 140022,
  [SMALL_STATE(2986)] = 140051,
  [SMALL_STATE(2987)] = 140080,
  [SMALL_STATE(2988)] = 140105,
  [SMALL_STATE(2989)] = 140134,
  [SMALL_STATE(2990)] = 140161,
  [SMALL_STATE(2991)] = 140190,
  [SMALL_STATE(2992)] = 140219,
  [SMALL_STATE(2993)] = 140244,
  [SMALL_STATE(2994)] = 140273,
  [SMALL_STATE(2995)] = 140302,
  [SMALL_STATE(2996)] = 140331,
  [SMALL_STATE(2997)] = 140360,
  [SMALL_STATE(2998)] = 140389,
  [SMALL_STATE(2999)] = 140414,
  [SMALL_STATE(3000)] = 140443,
  [SMALL_STATE(3001)] = 140472,
  [SMALL_STATE(3002)] = 140501,
  [SMALL_STATE(3003)] = 140530,
  [SMALL_STATE(3004)] = 140555,
  [SMALL_STATE(3005)] = 140584,
  [SMALL_STATE(3006)] = 140609,
  [SMALL_STATE(3007)] = 140638,
  [SMALL_STATE(3008)] = 140664,
  [SMALL_STATE(3009)] = 140688,
  [SMALL_STATE(3010)] = 140714,
  [SMALL_STATE(3011)] = 140740,
  [SMALL_STATE(3012)] = 140766,
  [SMALL_STATE(3013)] = 140792,
  [SMALL_STATE(3014)] = 140816,
  [SMALL_STATE(3015)] = 140840,
  [SMALL_STATE(3016)] = 140864,
  [SMALL_STATE(3017)] = 140888,
  [SMALL_STATE(3018)] = 140914,
  [SMALL_STATE(3019)] = 140938,
  [SMALL_STATE(3020)] = 140964,
  [SMALL_STATE(3021)] = 140990,
  [SMALL_STATE(3022)] = 141016,
  [SMALL_STATE(3023)] = 141042,
  [SMALL_STATE(3024)] = 141068,
  [SMALL_STATE(3025)] = 141092,
  [SMALL_STATE(3026)] = 141118,
  [SMALL_STATE(3027)] = 141144,
  [SMALL_STATE(3028)] = 141170,
  [SMALL_STATE(3029)] = 141194,
  [SMALL_STATE(3030)] = 141218,
  [SMALL_STATE(3031)] = 141242,
  [SMALL_STATE(3032)] = 141266,
  [SMALL_STATE(3033)] = 141292,
  [SMALL_STATE(3034)] = 141318,
  [SMALL_STATE(3035)] = 141342,
  [SMALL_STATE(3036)] = 141366,
  [SMALL_STATE(3037)] = 141390,
  [SMALL_STATE(3038)] = 141416,
  [SMALL_STATE(3039)] = 141440,
  [SMALL_STATE(3040)] = 141466,
  [SMALL_STATE(3041)] = 141490,
  [SMALL_STATE(3042)] = 141514,
  [SMALL_STATE(3043)] = 141540,
  [SMALL_STATE(3044)] = 141566,
  [SMALL_STATE(3045)] = 141592,
  [SMALL_STATE(3046)] = 141618,
  [SMALL_STATE(3047)] = 141644,
  [SMALL_STATE(3048)] = 141670,
  [SMALL_STATE(3049)] = 141694,
  [SMALL_STATE(3050)] = 141720,
  [SMALL_STATE(3051)] = 141746,
  [SMALL_STATE(3052)] = 141770,
  [SMALL_STATE(3053)] = 141796,
  [SMALL_STATE(3054)] = 141822,
  [SMALL_STATE(3055)] = 141846,
  [SMALL_STATE(3056)] = 141870,
  [SMALL_STATE(3057)] = 141894,
  [SMALL_STATE(3058)] = 141920,
  [SMALL_STATE(3059)] = 141946,
  [SMALL_STATE(3060)] = 141970,
  [SMALL_STATE(3061)] = 141996,
  [SMALL_STATE(3062)] = 142022,
  [SMALL_STATE(3063)] = 142048,
  [SMALL_STATE(3064)] = 142074,
  [SMALL_STATE(3065)] = 142100,
  [SMALL_STATE(3066)] = 142124,
  [SMALL_STATE(3067)] = 142150,
  [SMALL_STATE(3068)] = 142176,
  [SMALL_STATE(3069)] = 142202,
  [SMALL_STATE(3070)] = 142226,
  [SMALL_STATE(3071)] = 142252,
  [SMALL_STATE(3072)] = 142278,
  [SMALL_STATE(3073)] = 142304,
  [SMALL_STATE(3074)] = 142330,
  [SMALL_STATE(3075)] = 142356,
  [SMALL_STATE(3076)] = 142382,
  [SMALL_STATE(3077)] = 142408,
  [SMALL_STATE(3078)] = 142434,
  [SMALL_STATE(3079)] = 142460,
  [SMALL_STATE(3080)] = 142486,
  [SMALL_STATE(3081)] = 142512,
  [SMALL_STATE(3082)] = 142538,
  [SMALL_STATE(3083)] = 142564,
  [SMALL_STATE(3084)] = 142590,
  [SMALL_STATE(3085)] = 142616,
  [SMALL_STATE(3086)] = 142642,
  [SMALL_STATE(3087)] = 142668,
  [SMALL_STATE(3088)] = 142694,
  [SMALL_STATE(3089)] = 142720,
  [SMALL_STATE(3090)] = 142746,
  [SMALL_STATE(3091)] = 142772,
  [SMALL_STATE(3092)] = 142796,
  [SMALL_STATE(3093)] = 142822,
  [SMALL_STATE(3094)] = 142848,
  [SMALL_STATE(3095)] = 142874,
  [SMALL_STATE(3096)] = 142900,
  [SMALL_STATE(3097)] = 142924,
  [SMALL_STATE(3098)] = 142950,
  [SMALL_STATE(3099)] = 142976,
  [SMALL_STATE(3100)] = 143000,
  [SMALL_STATE(3101)] = 143026,
  [SMALL_STATE(3102)] = 143050,
  [SMALL_STATE(3103)] = 143076,
  [SMALL_STATE(3104)] = 143100,
  [SMALL_STATE(3105)] = 143126,
  [SMALL_STATE(3106)] = 143152,
  [SMALL_STATE(3107)] = 143178,
  [SMALL_STATE(3108)] = 143204,
  [SMALL_STATE(3109)] = 143230,
  [SMALL_STATE(3110)] = 143256,
  [SMALL_STATE(3111)] = 143282,
  [SMALL_STATE(3112)] = 143308,
  [SMALL_STATE(3113)] = 143332,
  [SMALL_STATE(3114)] = 143358,
  [SMALL_STATE(3115)] = 143384,
  [SMALL_STATE(3116)] = 143410,
  [SMALL_STATE(3117)] = 143436,
  [SMALL_STATE(3118)] = 143462,
  [SMALL_STATE(3119)] = 143488,
  [SMALL_STATE(3120)] = 143514,
  [SMALL_STATE(3121)] = 143540,
  [SMALL_STATE(3122)] = 143566,
  [SMALL_STATE(3123)] = 143592,
  [SMALL_STATE(3124)] = 143618,
  [SMALL_STATE(3125)] = 143644,
  [SMALL_STATE(3126)] = 143670,
  [SMALL_STATE(3127)] = 143696,
  [SMALL_STATE(3128)] = 143722,
  [SMALL_STATE(3129)] = 143748,
  [SMALL_STATE(3130)] = 143774,
  [SMALL_STATE(3131)] = 143800,
  [SMALL_STATE(3132)] = 143824,
  [SMALL_STATE(3133)] = 143850,
  [SMALL_STATE(3134)] = 143876,
  [SMALL_STATE(3135)] = 143902,
  [SMALL_STATE(3136)] = 143928,
  [SMALL_STATE(3137)] = 143954,
  [SMALL_STATE(3138)] = 143980,
  [SMALL_STATE(3139)] = 144006,
  [SMALL_STATE(3140)] = 144032,
  [SMALL_STATE(3141)] = 144058,
  [SMALL_STATE(3142)] = 144084,
  [SMALL_STATE(3143)] = 144110,
  [SMALL_STATE(3144)] = 144136,
  [SMALL_STATE(3145)] = 144162,
  [SMALL_STATE(3146)] = 144188,
  [SMALL_STATE(3147)] = 144214,
  [SMALL_STATE(3148)] = 144240,
  [SMALL_STATE(3149)] = 144266,
  [SMALL_STATE(3150)] = 144292,
  [SMALL_STATE(3151)] = 144318,
  [SMALL_STATE(3152)] = 144344,
  [SMALL_STATE(3153)] = 144370,
  [SMALL_STATE(3154)] = 144396,
  [SMALL_STATE(3155)] = 144422,
  [SMALL_STATE(3156)] = 144448,
  [SMALL_STATE(3157)] = 144474,
  [SMALL_STATE(3158)] = 144500,
  [SMALL_STATE(3159)] = 144526,
  [SMALL_STATE(3160)] = 144550,
  [SMALL_STATE(3161)] = 144576,
  [SMALL_STATE(3162)] = 144602,
  [SMALL_STATE(3163)] = 144628,
  [SMALL_STATE(3164)] = 144654,
  [SMALL_STATE(3165)] = 144680,
  [SMALL_STATE(3166)] = 144706,
  [SMALL_STATE(3167)] = 144732,
  [SMALL_STATE(3168)] = 144758,
  [SMALL_STATE(3169)] = 144782,
  [SMALL_STATE(3170)] = 144808,
  [SMALL_STATE(3171)] = 144834,
  [SMALL_STATE(3172)] = 144860,
  [SMALL_STATE(3173)] = 144884,
  [SMALL_STATE(3174)] = 144910,
  [SMALL_STATE(3175)] = 144936,
  [SMALL_STATE(3176)] = 144962,
  [SMALL_STATE(3177)] = 144988,
  [SMALL_STATE(3178)] = 145014,
  [SMALL_STATE(3179)] = 145040,
  [SMALL_STATE(3180)] = 145066,
  [SMALL_STATE(3181)] = 145090,
  [SMALL_STATE(3182)] = 145116,
  [SMALL_STATE(3183)] = 145140,
  [SMALL_STATE(3184)] = 145166,
  [SMALL_STATE(3185)] = 145190,
  [SMALL_STATE(3186)] = 145216,
  [SMALL_STATE(3187)] = 145242,
  [SMALL_STATE(3188)] = 145268,
  [SMALL_STATE(3189)] = 145294,
  [SMALL_STATE(3190)] = 145320,
  [SMALL_STATE(3191)] = 145344,
  [SMALL_STATE(3192)] = 145368,
  [SMALL_STATE(3193)] = 145394,
  [SMALL_STATE(3194)] = 145420,
  [SMALL_STATE(3195)] = 145446,
  [SMALL_STATE(3196)] = 145472,
  [SMALL_STATE(3197)] = 145498,
  [SMALL_STATE(3198)] = 145524,
  [SMALL_STATE(3199)] = 145550,
  [SMALL_STATE(3200)] = 145576,
  [SMALL_STATE(3201)] = 145602,
  [SMALL_STATE(3202)] = 145628,
  [SMALL_STATE(3203)] = 145654,
  [SMALL_STATE(3204)] = 145680,
  [SMALL_STATE(3205)] = 145704,
  [SMALL_STATE(3206)] = 145730,
  [SMALL_STATE(3207)] = 145756,
  [SMALL_STATE(3208)] = 145782,
  [SMALL_STATE(3209)] = 145808,
  [SMALL_STATE(3210)] = 145834,
  [SMALL_STATE(3211)] = 145860,
  [SMALL_STATE(3212)] = 145886,
  [SMALL_STATE(3213)] = 145910,
  [SMALL_STATE(3214)] = 145936,
  [SMALL_STATE(3215)] = 145962,
  [SMALL_STATE(3216)] = 145988,
  [SMALL_STATE(3217)] = 146014,
  [SMALL_STATE(3218)] = 146040,
  [SMALL_STATE(3219)] = 146066,
  [SMALL_STATE(3220)] = 146092,
  [SMALL_STATE(3221)] = 146116,
  [SMALL_STATE(3222)] = 146142,
  [SMALL_STATE(3223)] = 146166,
  [SMALL_STATE(3224)] = 146190,
  [SMALL_STATE(3225)] = 146216,
  [SMALL_STATE(3226)] = 146242,
  [SMALL_STATE(3227)] = 146268,
  [SMALL_STATE(3228)] = 146294,
  [SMALL_STATE(3229)] = 146318,
  [SMALL_STATE(3230)] = 146344,
  [SMALL_STATE(3231)] = 146368,
  [SMALL_STATE(3232)] = 146394,
  [SMALL_STATE(3233)] = 146420,
  [SMALL_STATE(3234)] = 146446,
  [SMALL_STATE(3235)] = 146470,
  [SMALL_STATE(3236)] = 146496,
  [SMALL_STATE(3237)] = 146522,
  [SMALL_STATE(3238)] = 146548,
  [SMALL_STATE(3239)] = 146574,
  [SMALL_STATE(3240)] = 146600,
  [SMALL_STATE(3241)] = 146626,
  [SMALL_STATE(3242)] = 146652,
  [SMALL_STATE(3243)] = 146678,
  [SMALL_STATE(3244)] = 146704,
  [SMALL_STATE(3245)] = 146730,
  [SMALL_STATE(3246)] = 146756,
  [SMALL_STATE(3247)] = 146782,
  [SMALL_STATE(3248)] = 146806,
  [SMALL_STATE(3249)] = 146830,
  [SMALL_STATE(3250)] = 146856,
  [SMALL_STATE(3251)] = 146882,
  [SMALL_STATE(3252)] = 146908,
  [SMALL_STATE(3253)] = 146934,
  [SMALL_STATE(3254)] = 146960,
  [SMALL_STATE(3255)] = 146984,
  [SMALL_STATE(3256)] = 147010,
  [SMALL_STATE(3257)] = 147034,
  [SMALL_STATE(3258)] = 147058,
  [SMALL_STATE(3259)] = 147084,
  [SMALL_STATE(3260)] = 147110,
  [SMALL_STATE(3261)] = 147136,
  [SMALL_STATE(3262)] = 147162,
  [SMALL_STATE(3263)] = 147188,
  [SMALL_STATE(3264)] = 147212,
  [SMALL_STATE(3265)] = 147238,
  [SMALL_STATE(3266)] = 147264,
  [SMALL_STATE(3267)] = 147288,
  [SMALL_STATE(3268)] = 147312,
  [SMALL_STATE(3269)] = 147336,
  [SMALL_STATE(3270)] = 147360,
  [SMALL_STATE(3271)] = 147384,
  [SMALL_STATE(3272)] = 147410,
  [SMALL_STATE(3273)] = 147434,
  [SMALL_STATE(3274)] = 147457,
  [SMALL_STATE(3275)] = 147480,
  [SMALL_STATE(3276)] = 147503,
  [SMALL_STATE(3277)] = 147526,
  [SMALL_STATE(3278)] = 147549,
  [SMALL_STATE(3279)] = 147572,
  [SMALL_STATE(3280)] = 147595,
  [SMALL_STATE(3281)] = 147618,
  [SMALL_STATE(3282)] = 147641,
  [SMALL_STATE(3283)] = 147664,
  [SMALL_STATE(3284)] = 147687,
  [SMALL_STATE(3285)] = 147710,
  [SMALL_STATE(3286)] = 147733,
  [SMALL_STATE(3287)] = 147756,
  [SMALL_STATE(3288)] = 147779,
  [SMALL_STATE(3289)] = 147802,
  [SMALL_STATE(3290)] = 147825,
  [SMALL_STATE(3291)] = 147848,
  [SMALL_STATE(3292)] = 147871,
  [SMALL_STATE(3293)] = 147894,
  [SMALL_STATE(3294)] = 147917,
  [SMALL_STATE(3295)] = 147940,
  [SMALL_STATE(3296)] = 147963,
  [SMALL_STATE(3297)] = 147986,
  [SMALL_STATE(3298)] = 148009,
  [SMALL_STATE(3299)] = 148032,
  [SMALL_STATE(3300)] = 148055,
  [SMALL_STATE(3301)] = 148078,
  [SMALL_STATE(3302)] = 148101,
  [SMALL_STATE(3303)] = 148124,
  [SMALL_STATE(3304)] = 148147,
  [SMALL_STATE(3305)] = 148170,
  [SMALL_STATE(3306)] = 148193,
  [SMALL_STATE(3307)] = 148216,
  [SMALL_STATE(3308)] = 148239,
  [SMALL_STATE(3309)] = 148262,
  [SMALL_STATE(3310)] = 148285,
  [SMALL_STATE(3311)] = 148308,
  [SMALL_STATE(3312)] = 148331,
  [SMALL_STATE(3313)] = 148354,
  [SMALL_STATE(3314)] = 148377,
  [SMALL_STATE(3315)] = 148400,
  [SMALL_STATE(3316)] = 148423,
  [SMALL_STATE(3317)] = 148446,
  [SMALL_STATE(3318)] = 148469,
  [SMALL_STATE(3319)] = 148492,
  [SMALL_STATE(3320)] = 148515,
  [SMALL_STATE(3321)] = 148538,
  [SMALL_STATE(3322)] = 148561,
  [SMALL_STATE(3323)] = 148584,
  [SMALL_STATE(3324)] = 148607,
  [SMALL_STATE(3325)] = 148630,
  [SMALL_STATE(3326)] = 148653,
  [SMALL_STATE(3327)] = 148676,
  [SMALL_STATE(3328)] = 148699,
  [SMALL_STATE(3329)] = 148722,
  [SMALL_STATE(3330)] = 148745,
  [SMALL_STATE(3331)] = 148768,
  [SMALL_STATE(3332)] = 148791,
  [SMALL_STATE(3333)] = 148814,
  [SMALL_STATE(3334)] = 148837,
  [SMALL_STATE(3335)] = 148860,
  [SMALL_STATE(3336)] = 148883,
  [SMALL_STATE(3337)] = 148906,
  [SMALL_STATE(3338)] = 148929,
  [SMALL_STATE(3339)] = 148952,
  [SMALL_STATE(3340)] = 148975,
  [SMALL_STATE(3341)] = 148998,
  [SMALL_STATE(3342)] = 149021,
  [SMALL_STATE(3343)] = 149044,
  [SMALL_STATE(3344)] = 149067,
  [SMALL_STATE(3345)] = 149090,
  [SMALL_STATE(3346)] = 149113,
  [SMALL_STATE(3347)] = 149136,
  [SMALL_STATE(3348)] = 149159,
  [SMALL_STATE(3349)] = 149182,
  [SMALL_STATE(3350)] = 149205,
  [SMALL_STATE(3351)] = 149228,
  [SMALL_STATE(3352)] = 149251,
  [SMALL_STATE(3353)] = 149274,
  [SMALL_STATE(3354)] = 149297,
  [SMALL_STATE(3355)] = 149320,
  [SMALL_STATE(3356)] = 149343,
  [SMALL_STATE(3357)] = 149366,
  [SMALL_STATE(3358)] = 149389,
  [SMALL_STATE(3359)] = 149412,
  [SMALL_STATE(3360)] = 149435,
  [SMALL_STATE(3361)] = 149458,
  [SMALL_STATE(3362)] = 149481,
  [SMALL_STATE(3363)] = 149504,
  [SMALL_STATE(3364)] = 149527,
  [SMALL_STATE(3365)] = 149550,
  [SMALL_STATE(3366)] = 149573,
  [SMALL_STATE(3367)] = 149596,
  [SMALL_STATE(3368)] = 149619,
  [SMALL_STATE(3369)] = 149642,
  [SMALL_STATE(3370)] = 149665,
  [SMALL_STATE(3371)] = 149688,
  [SMALL_STATE(3372)] = 149711,
  [SMALL_STATE(3373)] = 149734,
  [SMALL_STATE(3374)] = 149757,
  [SMALL_STATE(3375)] = 149780,
  [SMALL_STATE(3376)] = 149803,
  [SMALL_STATE(3377)] = 149826,
  [SMALL_STATE(3378)] = 149849,
  [SMALL_STATE(3379)] = 149872,
  [SMALL_STATE(3380)] = 149895,
  [SMALL_STATE(3381)] = 149918,
  [SMALL_STATE(3382)] = 149941,
  [SMALL_STATE(3383)] = 149964,
  [SMALL_STATE(3384)] = 149987,
  [SMALL_STATE(3385)] = 150010,
  [SMALL_STATE(3386)] = 150033,
  [SMALL_STATE(3387)] = 150056,
  [SMALL_STATE(3388)] = 150079,
  [SMALL_STATE(3389)] = 150102,
  [SMALL_STATE(3390)] = 150125,
  [SMALL_STATE(3391)] = 150148,
  [SMALL_STATE(3392)] = 150171,
  [SMALL_STATE(3393)] = 150194,
  [SMALL_STATE(3394)] = 150217,
  [SMALL_STATE(3395)] = 150240,
  [SMALL_STATE(3396)] = 150263,
  [SMALL_STATE(3397)] = 150286,
  [SMALL_STATE(3398)] = 150309,
  [SMALL_STATE(3399)] = 150332,
  [SMALL_STATE(3400)] = 150355,
  [SMALL_STATE(3401)] = 150378,
  [SMALL_STATE(3402)] = 150401,
  [SMALL_STATE(3403)] = 150424,
  [SMALL_STATE(3404)] = 150447,
  [SMALL_STATE(3405)] = 150470,
  [SMALL_STATE(3406)] = 150493,
  [SMALL_STATE(3407)] = 150516,
  [SMALL_STATE(3408)] = 150539,
  [SMALL_STATE(3409)] = 150562,
  [SMALL_STATE(3410)] = 150585,
  [SMALL_STATE(3411)] = 150608,
  [SMALL_STATE(3412)] = 150631,
  [SMALL_STATE(3413)] = 150654,
  [SMALL_STATE(3414)] = 150677,
  [SMALL_STATE(3415)] = 150700,
  [SMALL_STATE(3416)] = 150723,
  [SMALL_STATE(3417)] = 150746,
  [SMALL_STATE(3418)] = 150769,
  [SMALL_STATE(3419)] = 150792,
  [SMALL_STATE(3420)] = 150815,
  [SMALL_STATE(3421)] = 150838,
  [SMALL_STATE(3422)] = 150861,
  [SMALL_STATE(3423)] = 150884,
  [SMALL_STATE(3424)] = 150907,
  [SMALL_STATE(3425)] = 150930,
  [SMALL_STATE(3426)] = 150953,
  [SMALL_STATE(3427)] = 150976,
  [SMALL_STATE(3428)] = 150999,
  [SMALL_STATE(3429)] = 151022,
  [SMALL_STATE(3430)] = 151045,
  [SMALL_STATE(3431)] = 151068,
  [SMALL_STATE(3432)] = 151091,
  [SMALL_STATE(3433)] = 151114,
  [SMALL_STATE(3434)] = 151137,
  [SMALL_STATE(3435)] = 151160,
  [SMALL_STATE(3436)] = 151183,
  [SMALL_STATE(3437)] = 151206,
  [SMALL_STATE(3438)] = 151229,
  [SMALL_STATE(3439)] = 151252,
  [SMALL_STATE(3440)] = 151275,
  [SMALL_STATE(3441)] = 151298,
  [SMALL_STATE(3442)] = 151321,
  [SMALL_STATE(3443)] = 151344,
  [SMALL_STATE(3444)] = 151367,
  [SMALL_STATE(3445)] = 151390,
  [SMALL_STATE(3446)] = 151413,
  [SMALL_STATE(3447)] = 151436,
  [SMALL_STATE(3448)] = 151459,
  [SMALL_STATE(3449)] = 151482,
  [SMALL_STATE(3450)] = 151505,
  [SMALL_STATE(3451)] = 151528,
  [SMALL_STATE(3452)] = 151551,
  [SMALL_STATE(3453)] = 151574,
  [SMALL_STATE(3454)] = 151597,
  [SMALL_STATE(3455)] = 151620,
  [SMALL_STATE(3456)] = 151643,
  [SMALL_STATE(3457)] = 151666,
  [SMALL_STATE(3458)] = 151689,
  [SMALL_STATE(3459)] = 151712,
  [SMALL_STATE(3460)] = 151735,
  [SMALL_STATE(3461)] = 151758,
  [SMALL_STATE(3462)] = 151781,
  [SMALL_STATE(3463)] = 151804,
  [SMALL_STATE(3464)] = 151827,
  [SMALL_STATE(3465)] = 151850,
  [SMALL_STATE(3466)] = 151873,
  [SMALL_STATE(3467)] = 151896,
  [SMALL_STATE(3468)] = 151919,
  [SMALL_STATE(3469)] = 151942,
  [SMALL_STATE(3470)] = 151965,
  [SMALL_STATE(3471)] = 151988,
  [SMALL_STATE(3472)] = 152011,
  [SMALL_STATE(3473)] = 152034,
  [SMALL_STATE(3474)] = 152057,
  [SMALL_STATE(3475)] = 152080,
  [SMALL_STATE(3476)] = 152103,
  [SMALL_STATE(3477)] = 152126,
  [SMALL_STATE(3478)] = 152149,
  [SMALL_STATE(3479)] = 152172,
  [SMALL_STATE(3480)] = 152195,
  [SMALL_STATE(3481)] = 152218,
  [SMALL_STATE(3482)] = 152241,
  [SMALL_STATE(3483)] = 152264,
  [SMALL_STATE(3484)] = 152287,
  [SMALL_STATE(3485)] = 152310,
  [SMALL_STATE(3486)] = 152333,
  [SMALL_STATE(3487)] = 152356,
  [SMALL_STATE(3488)] = 152379,
  [SMALL_STATE(3489)] = 152402,
  [SMALL_STATE(3490)] = 152425,
  [SMALL_STATE(3491)] = 152448,
  [SMALL_STATE(3492)] = 152471,
  [SMALL_STATE(3493)] = 152494,
  [SMALL_STATE(3494)] = 152517,
  [SMALL_STATE(3495)] = 152540,
  [SMALL_STATE(3496)] = 152563,
  [SMALL_STATE(3497)] = 152586,
  [SMALL_STATE(3498)] = 152609,
  [SMALL_STATE(3499)] = 152632,
  [SMALL_STATE(3500)] = 152655,
  [SMALL_STATE(3501)] = 152678,
  [SMALL_STATE(3502)] = 152701,
  [SMALL_STATE(3503)] = 152724,
  [SMALL_STATE(3504)] = 152747,
  [SMALL_STATE(3505)] = 152770,
  [SMALL_STATE(3506)] = 152793,
  [SMALL_STATE(3507)] = 152816,
  [SMALL_STATE(3508)] = 152839,
  [SMALL_STATE(3509)] = 152862,
  [SMALL_STATE(3510)] = 152885,
  [SMALL_STATE(3511)] = 152908,
  [SMALL_STATE(3512)] = 152931,
  [SMALL_STATE(3513)] = 152954,
  [SMALL_STATE(3514)] = 152977,
  [SMALL_STATE(3515)] = 153000,
  [SMALL_STATE(3516)] = 153023,
  [SMALL_STATE(3517)] = 153046,
  [SMALL_STATE(3518)] = 153069,
  [SMALL_STATE(3519)] = 153092,
  [SMALL_STATE(3520)] = 153115,
  [SMALL_STATE(3521)] = 153138,
  [SMALL_STATE(3522)] = 153161,
  [SMALL_STATE(3523)] = 153184,
  [SMALL_STATE(3524)] = 153207,
  [SMALL_STATE(3525)] = 153230,
  [SMALL_STATE(3526)] = 153253,
  [SMALL_STATE(3527)] = 153276,
  [SMALL_STATE(3528)] = 153299,
  [SMALL_STATE(3529)] = 153322,
  [SMALL_STATE(3530)] = 153345,
  [SMALL_STATE(3531)] = 153368,
  [SMALL_STATE(3532)] = 153391,
  [SMALL_STATE(3533)] = 153414,
  [SMALL_STATE(3534)] = 153437,
  [SMALL_STATE(3535)] = 153460,
  [SMALL_STATE(3536)] = 153483,
  [SMALL_STATE(3537)] = 153506,
  [SMALL_STATE(3538)] = 153529,
  [SMALL_STATE(3539)] = 153552,
  [SMALL_STATE(3540)] = 153575,
  [SMALL_STATE(3541)] = 153598,
  [SMALL_STATE(3542)] = 153621,
  [SMALL_STATE(3543)] = 153644,
  [SMALL_STATE(3544)] = 153667,
  [SMALL_STATE(3545)] = 153690,
  [SMALL_STATE(3546)] = 153713,
  [SMALL_STATE(3547)] = 153736,
  [SMALL_STATE(3548)] = 153759,
  [SMALL_STATE(3549)] = 153782,
  [SMALL_STATE(3550)] = 153805,
  [SMALL_STATE(3551)] = 153828,
  [SMALL_STATE(3552)] = 153851,
  [SMALL_STATE(3553)] = 153874,
  [SMALL_STATE(3554)] = 153897,
  [SMALL_STATE(3555)] = 153920,
  [SMALL_STATE(3556)] = 153943,
  [SMALL_STATE(3557)] = 153966,
  [SMALL_STATE(3558)] = 153989,
  [SMALL_STATE(3559)] = 154012,
  [SMALL_STATE(3560)] = 154035,
  [SMALL_STATE(3561)] = 154058,
  [SMALL_STATE(3562)] = 154081,
  [SMALL_STATE(3563)] = 154104,
  [SMALL_STATE(3564)] = 154127,
  [SMALL_STATE(3565)] = 154150,
  [SMALL_STATE(3566)] = 154173,
  [SMALL_STATE(3567)] = 154196,
  [SMALL_STATE(3568)] = 154219,
  [SMALL_STATE(3569)] = 154242,
  [SMALL_STATE(3570)] = 154265,
  [SMALL_STATE(3571)] = 154288,
  [SMALL_STATE(3572)] = 154311,
  [SMALL_STATE(3573)] = 154315,
  [SMALL_STATE(3574)] = 154319,
  [SMALL_STATE(3575)] = 154323,
  [SMALL_STATE(3576)] = 154327,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3553),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [13] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0, 0, 0),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3087),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_switch_statement_case, 5, 0, 0), SHIFT(489),
  [172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement_case, 5, 0, 0),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement_case, 5, 0, 0),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3347),
  [182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3210),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_switch_statement_case, 3, 0, 0), SHIFT(489),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement_case, 3, 0, 0),
  [189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement_case, 3, 0, 0),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_switch_statement_case, 4, 0, 0), SHIFT(489),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement_case, 4, 0, 0),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement_case, 4, 0, 0),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(489),
  [201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3335),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(981),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(981),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(982),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(985),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2240),
  [222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2166),
  [225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2322),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2330),
  [234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2254),
  [240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(53),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(986),
  [251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(45),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(264),
  [257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1804),
  [260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(456),
  [263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1385),
  [266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1217),
  [269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1412),
  [272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(413),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3216),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3214),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2698),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(191),
  [292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(189),
  [295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3213),
  [298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3347),
  [301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3210),
  [304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3007),
  [307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1896),
  [313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2190),
  [316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2693),
  [319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3208),
  [322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1001),
  [325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2270),
  [328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1625),
  [331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2834),
  [334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2783),
  [337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2169),
  [340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1806),
  [343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2481),
  [346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1103),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement_default, 3, 0, 0),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement_default, 2, 0, 0),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement_default, 4, 0, 0),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3149),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 1, 0, 0),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 3, 0, 0),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 2, 0, 0),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__map_pattern_entry, 1, 0, 0),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 1, 0, 0),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2, 0, 52),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, 0, 89),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2, 0, 54),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2, 0, 0),
  [676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 69),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 74),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 77),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 54),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 67),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(1921),
  [899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(3416),
  [902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2134),
  [905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2134),
  [908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2133),
  [911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2128),
  [914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2227),
  [917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2226),
  [920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2160),
  [923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2170),
  [926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2306),
  [929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2304),
  [932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2214),
  [935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2213),
  [938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(174),
  [941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(383),
  [944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2125),
  [947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2, 0, 0), SHIFT(376),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2, 0, 0),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(786),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2, 0, 0),
  [957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(2591),
  [960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2, 0, 0), SHIFT(1935),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 2, 0, 0), REDUCE(sym_block, 2, 0, 0),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 2, 0, 0),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_pattern, 2, 0, 0),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 2, 0, 0),
  [986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 2, 0, 0), REDUCE(sym_block, 2, 0, 0),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3144),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [1033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, 0, 0),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3, 0, 0),
  [1037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, 0, 0),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [1041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [1043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__semicolon, 1, 0, 0),
  [1045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__semicolon, 1, 0, 0),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 1, 0, 0),
  [1049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 1, 0, 0),
  [1051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3, 0, 0),
  [1053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3, 0, 0),
  [1055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 0),
  [1057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2, 0, 0),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 4, 0, 0),
  [1061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 4, 0, 0),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 4, 0, 0),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 3, 0, 0),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [1071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 3, 0, 0),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 2, 0, 0),
  [1075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 2, 0, 0),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 8),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 8),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 1, 0, 8),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 1, 0, 8),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 5, 0, 0),
  [1143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [1147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2083),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3152),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 4, 0, 0),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 4, 0, 0),
  [1157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [1160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2240),
  [1163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2166),
  [1166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [1169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2322),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2330),
  [1175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [1178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2254),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1, 0, 0),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1, 0, 0),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0),
  [1191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2063),
  [1194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(1833),
  [1197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3007),
  [1200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3541),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2551),
  [1206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3539),
  [1209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3530),
  [1212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2619),
  [1215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(1896),
  [1218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2190),
  [1221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(1625),
  [1224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2834),
  [1227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3479),
  [1230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3096),
  [1233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2488),
  [1236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3474),
  [1239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(3103),
  [1242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2783),
  [1245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2629),
  [1248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(1989),
  [1251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2481),
  [1254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 2, 0, 0), SHIFT_REPEAT(2159),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [1277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [1283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(2511),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 6, 0, 0),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0),
  [1294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(217),
  [1297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0),
  [1299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3183),
  [1302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3386),
  [1305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3387),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__on_part, 3, 0, 0),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__on_part, 3, 0, 0),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__try_head, 2, 0, 19),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__try_head, 2, 0, 19),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__on_part, 4, 0, 0),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__on_part, 4, 0, 0),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_name, 1, 0, 1),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0),
  [1324] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1), SHIFT(709),
  [1328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignable_expression, 1, 0, 0),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignable_expression, 1, 0, 0),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0),
  [1334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1),
  [1337] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1), SHIFT(2297),
  [1341] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1), SHIFT(3499),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__on_part, 2, 0, 0),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__on_part, 2, 0, 0),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [1351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_additive_expression_repeat1, 2, 0, 0),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_additive_expression_repeat1, 2, 0, 0),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_shift_expression_repeat1, 2, 0, 0),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_shift_expression_repeat1, 2, 0, 0),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2, 0, 0),
  [1363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2, 0, 0), SHIFT_REPEAT(164),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat1, 2, 0, 0),
  [1368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat1, 2, 0, 0), SHIFT_REPEAT(2030),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cascade_subsection, 2, 0, 0),
  [1373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 2, 0, 0), SHIFT(164),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cascade_subsection, 2, 0, 0),
  [1378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cascade_subsection, 2, 0, 0), SHIFT(2030),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 36),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__if_null_expression, 2, 0, 36),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cascade_subsection, 1, 0, 0),
  [1387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 1, 0, 0), SHIFT(164),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cascade_subsection, 1, 0, 0),
  [1392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__cascade_subsection, 1, 0, 0), SHIFT(2030),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 0),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equality_expression, 3, 0, 0),
  [1403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 0), SHIFT(372),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_without_cascade, 1, 0, 0),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_without_cascade, 1, 0, 0),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2, 0, 0),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2, 0, 0),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_expression, 3, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_expression, 3, 0, 0),
  [1426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_relational_expression, 3, 0, 0), SHIFT(1425),
  [1429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_relational_expression, 3, 0, 0), SHIFT(1425),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2, 0, 0),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [1450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(2501),
  [1453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(211),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3174),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3405),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3406),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [1467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 2, 0, 0),
  [1469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 2, 0, 0),
  [1471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 3, 0, 0),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 3, 0, 0),
  [1475] = {.entry = {.count = 4, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1), REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1482] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1),
  [1486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [1489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [1492] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [1496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_assignable_expression, 1, 0, 0), REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [1499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 9, 0, 96),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, 0, 96),
  [1516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, 0, 0),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, 0, 0),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 34),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 34),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 34),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 34),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3, 0, 0),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3, 0, 0),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [1543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [1547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 8),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 8),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [1555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 86),
  [1557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 86),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 1, 0),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 1, 0),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_declaration, 1, 0, 0),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_declaration, 1, 0, 0),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, 0, 51),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 51),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 21),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 21),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, 0, 35),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 35),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2, 0, 0),
  [1591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2, 0, 0),
  [1593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, 0, 0),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, 0, 0),
  [1597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 2, 0),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 2, 0),
  [1601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 4, 0, 0),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 4, 0, 0),
  [1605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [1609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 85),
  [1611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 85),
  [1613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_declaration, 2, 0, 0),
  [1615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_declaration, 2, 0, 0),
  [1617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 62),
  [1619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 62),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [1623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_each_statement, 4, 0, 0),
  [1625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_each_statement, 4, 0, 0),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [1639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 61),
  [1641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 61),
  [1643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unconditional_assignable_selector, 1, 0, 0),
  [1645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unconditional_assignable_selector, 1, 0, 0),
  [1647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 0), SHIFT(337),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [1654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 1, 0, 0), SHIFT(163),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_assignable_selector, 2, 0, 0),
  [1659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_assignable_selector, 2, 0, 0),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unconditional_assignable_selector, 2, 0, 0),
  [1663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unconditional_assignable_selector, 2, 0, 0),
  [1665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2, 0, 0), SHIFT_REPEAT(163),
  [1668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignable_selector, 1, 0, 0),
  [1670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignable_selector, 1, 0, 0),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary, 2, 0, 0),
  [1674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignable_expression, 2, 0, 0),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignable_expression, 2, 0, 0),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary, 2, 0, 0),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector, 1, 0, 0),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignable_selector_part, 1, 0, 0),
  [1684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignable_selector_part, 1, 0, 0),
  [1686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector, 1, 0, 0),
  [1688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 2, 0, 0), SHIFT(163),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_selector, 3, 0, 0),
  [1697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_selector, 3, 0, 0),
  [1699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignable_selector_part, 2, 0, 0),
  [1701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignable_selector_part, 2, 0, 0),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [1711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2618),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 1, 0, 0),
  [1717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat1, 1, 0, 0),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 1, 0, 0),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 1, 0, 0),
  [1723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_selector, 2, 0, 0),
  [1725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_selector, 2, 0, 0),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_part, 1, 0, 0),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_part, 1, 0, 0),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_part, 2, 0, 0),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_part, 2, 0, 0),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_selector, 1, 0, 0),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_selector, 1, 0, 0),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [1743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2038),
  [1746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0),
  [1748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1833),
  [1751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(3007),
  [1754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [1757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1896),
  [1760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2190),
  [1763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2270),
  [1766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(3531),
  [1769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1625),
  [1772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2834),
  [1775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1911),
  [1778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2783),
  [1781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2149),
  [1784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2618),
  [1787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2481),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2159),
  [1793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2256),
  [1796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2255),
  [1799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2153),
  [1802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2157),
  [1805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2324),
  [1808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [1811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2244),
  [1814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2243),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [1825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2038),
  [1828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0),
  [1830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(1833),
  [1833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(3007),
  [1836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2258),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(1896),
  [1842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2190),
  [1845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2270),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(3531),
  [1851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(1625),
  [1854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2834),
  [1857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(1911),
  [1860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2783),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2149),
  [1866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2618),
  [1869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2481),
  [1872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0), SHIFT_REPEAT(2159),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_loop_parts, 3, 0, 53),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_loop_parts, 3, 0, 53),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes_multiple, 2, 0, 0),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes_multiple, 2, 0, 0),
  [1893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2253),
  [1896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2251),
  [1899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2154),
  [1902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2162),
  [1905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2318),
  [1908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2319),
  [1911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2250),
  [1914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2249),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 3, 0, 0),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 3, 0, 0),
  [1921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 2, 0, 0),
  [1923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes_multiple, 2, 0, 0),
  [1925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 2, 0, 0),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 2, 0, 0),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes, 2, 0, 0),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes, 2, 0, 0),
  [1933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_unconditional_assignable_selector, 2, 0, 0), REDUCE(sym_super_formal_parameter, 3, 0, 0),
  [1936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_unconditional_assignable_selector, 2, 0, 0), SHIFT(709),
  [1939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unconditional_assignable_selector, 2, 0, 0), REDUCE(sym_super_formal_parameter, 3, 0, 0),
  [1942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unconditional_assignable_selector, 2, 0, 0), SHIFT(2297),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes, 2, 0, 0),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes, 2, 0, 0),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes_multiple, 2, 0, 0),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes_multiple, 2, 0, 0),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes, 3, 0, 0),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes, 3, 0, 0),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes, 2, 0, 0),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes, 2, 0, 0),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes, 3, 0, 0),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes, 3, 0, 0),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes_multiple, 3, 0, 0),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes_multiple, 3, 0, 0),
  [1973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_single_quotes_multiple, 3, 0, 0),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_single_quotes_multiple, 3, 0, 0),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal_double_quotes, 2, 0, 0),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal_double_quotes, 2, 0, 0),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes, 3, 0, 0),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes, 3, 0, 0),
  [1985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 3, 0, 0),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_double_quotes_multiple, 3, 0, 0),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal_single_quotes, 3, 0, 0),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal_single_quotes, 3, 0, 0),
  [1993] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1), SHIFT(3499),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 1, 0, 0),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_expression, 1, 0, 0),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_name, 1, 0, 1),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expression, 1, 0, 0),
  [2019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(202),
  [2022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(167),
  [2025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3140),
  [2028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(2035),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0),
  [2033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(967),
  [2036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3279),
  [2039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3426),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3500),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [2052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(244),
  [2055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3077),
  [2058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3501),
  [2061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3500),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0),
  [2080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [2083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(167),
  [2086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3158),
  [2089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2035),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0),
  [2094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(967),
  [2097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3273),
  [2100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3431),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expression, 2, 0, 0),
  [2105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(244),
  [2108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(167),
  [2111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3077),
  [2114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(2035),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0),
  [2119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(967),
  [2122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3501),
  [2125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3500),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 2, 0, 0),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_expression, 2, 0, 0),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(202),
  [2135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3140),
  [2138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3279),
  [2141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3426),
  [2144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_relational_operator, 1, 0, 0), SHIFT(2164),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_operator, 1, 0, 0),
  [2149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_operator, 1, 0, 0),
  [2151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_relational_operator, 1, 0, 0), SHIFT(1833),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3181),
  [2165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(2053),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [2174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(212),
  [2177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(161),
  [2180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3175),
  [2183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(1180),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3401),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3402),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 5, 0, 0),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 5, 0, 0),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3402),
  [2222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(216),
  [2225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3391),
  [2228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3392),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [2233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [2235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 0), SHIFT(313),
  [2238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(212),
  [2241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(161),
  [2244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3175),
  [2247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(2053),
  [2250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(1180),
  [2253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3401),
  [2256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3402),
  [2259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3181),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1904),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [2270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(215),
  [2273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(161),
  [2276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3179),
  [2279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2053),
  [2282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1180),
  [2285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3396),
  [2288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3397),
  [2291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(216),
  [2294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3391),
  [2297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3392),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3246),
  [2307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(2019),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 1, 0, 0), SHIFT(3201),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [2329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 0), SHIFT(323),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [2348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3201),
  [2351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(2019),
  [2354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(226),
  [2357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(169),
  [2360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3206),
  [2363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2019),
  [2366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1285),
  [2369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3366),
  [2372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3367),
  [2375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__postfix_expression, 2, 0, 0), SHIFT(3246),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [2380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0),
  [2383] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1714),
  [2387] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(844),
  [2391] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2272),
  [2395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 0), SHIFT(331),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 1, 0, 0),
  [2415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 1, 0, 0),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__relational_pattern, 2, 0, 0),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, 0, 0),
  [2437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, 0, 0),
  [2439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_equality_expression, 3, 0, 0), SHIFT(344),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0),
  [2444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0),
  [2446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0), SHIFT_REPEAT(863),
  [2449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 1, 0, 0),
  [2451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1714),
  [2454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(844),
  [2457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2272),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0),
  [2462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_shift_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1402),
  [2465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_shift_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1402),
  [2468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_relational_operator, 1, 0, 0), SHIFT(1614),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__real_expression, 1, 0, 0),
  [2473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__real_expression, 1, 0, 0),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 3, 0, 0),
  [2481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1714),
  [2484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(844),
  [2487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 3, 0, 0),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_expression, 2, 0, 0),
  [2491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_expression, 2, 0, 0),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shift_expression, 2, 0, 0),
  [2495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shift_expression, 2, 0, 0),
  [2497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2, 0, 0),
  [2499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2, 0, 0),
  [2501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1415),
  [2504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multiplicative_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1415),
  [2507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 2, 0, 0),
  [2509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1714),
  [2512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(844),
  [2515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 2, 0, 0),
  [2517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0),
  [2520] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1714),
  [2524] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(844),
  [2528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0),
  [2531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0),
  [2533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(844),
  [2536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(2035),
  [2539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0),
  [2541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void, 1, 0, 0),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1, 0, 0), SHIFT(844),
  [2546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void, 1, 0, 0),
  [2548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_function, 1, 0, 0),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0),
  [2552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), SHIFT(844),
  [2555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0),
  [2557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 2, 0, 0),
  [2559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 2, 0, 0),
  [2561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 2, 0, 0), SHIFT(2511),
  [2564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_or_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1399),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 4, 0, 0),
  [2569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4, 0, 0), SHIFT(844),
  [2572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 4, 0, 0),
  [2574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_logical_and_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1395),
  [2577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_additive_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1401),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [2582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_name, 1, 0, 1), SHIFT(3425),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2, 0, 0),
  [2587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_repeat1, 2, 0, 0),
  [2589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2511),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_expression, 2, 0, 0),
  [2596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_expression, 2, 0, 0),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_or_expression, 2, 0, 0),
  [2600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_or_expression, 2, 0, 0),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_and_expression, 2, 0, 0),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_and_expression, 2, 0, 0),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 2, 0, 0),
  [2608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 2, 0, 0),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_or_expression, 2, 0, 0),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_or_expression, 2, 0, 0),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_xor_expression, 2, 0, 0),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_xor_expression, 2, 0, 0),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_and_expression, 2, 0, 0),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitwise_and_expression, 2, 0, 0),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_name, 2, 0, 1),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_name, 2, 0, 1),
  [2626] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1701),
  [2630] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1061),
  [2634] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2267),
  [2638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_type, 1, 0, 0),
  [2640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullable_type, 1, 0, 0),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 4, 0, 0),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 4, 0, 0),
  [2646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0), SHIFT_REPEAT(1065),
  [2649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type_tail, 5, 0, 0),
  [2651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type_tail, 5, 0, 0),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 6, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 6, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 3, 0, 0),
  [2659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_pattern, 3, 0, 0),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 3, 0, 0),
  [2663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1701),
  [2666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1061),
  [2669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2267),
  [2672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 3, 0, 0),
  [2674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [2676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 3, 0, 0),
  [2678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 5, 0, 0),
  [2680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 5, 0, 0),
  [2682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 7, 0, 0),
  [2684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 7, 0, 0),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2, 0, 0),
  [2688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2, 0, 0),
  [2690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 6, 0, 0),
  [2692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 6, 0, 0),
  [2694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 2, 0, 0),
  [2696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 2, 0, 0),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 8, 0, 0),
  [2702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 8, 0, 0),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_tearoff, 3, 0, 0),
  [2706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_tearoff, 3, 0, 0),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_builtin_identifier, 1, 0, 0),
  [2710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_builtin_identifier, 1, 0, 0),
  [2712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 9, 0, 0),
  [2714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 9, 0, 0),
  [2716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [2718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, 0, 0),
  [2720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 10, 0, 0),
  [2722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 10, 0, 0),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 1, 0, 0),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_tails, 1, 0, 0),
  [2730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat1, 2, 0, 0), SHIFT_REPEAT(168),
  [2733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 3, 0, 0),
  [2735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 3, 0, 0),
  [2737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [2739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, 0, 0),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [2743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, 0, 0),
  [2745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, 0, 0),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_null_expression, 2, 0, 20),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_null_expression, 2, 0, 20),
  [2753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(341),
  [2756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(350),
  [2759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(373),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void, 2, 0, 0),
  [2764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void, 2, 0, 0),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_function, 2, 0, 0),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 5, 0, 0),
  [2770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 5, 0, 0),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_dot_identifier, 2, 0, 7),
  [2774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_dot_identifier, 2, 0, 7),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 3, 0, 0),
  [2778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 3, 0, 0),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 2, 0, 0),
  [2782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 2, 0, 0),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignable_expression, 1, 0, 0), REDUCE(sym__primary, 1, 0, 0),
  [2787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_assignable_expression, 1, 0, 0), REDUCE(sym__primary, 1, 0, 0),
  [2790] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_assignable_expression, 1, 0, 0), REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1),
  [2794] = {.entry = {.count = 4, .reusable = false}}, REDUCE(sym_assignable_expression, 1, 0, 0), REDUCE(sym__primary, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1), SHIFT(3499),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_type_list, 3, 0, 0),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_type_list, 3, 0, 0),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type, 4, 0, 0),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type, 4, 0, 0),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37),
  [2809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37), SHIFT_REPEAT(371),
  [2812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bool_literal, 1, 0, 0),
  [2816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__bool_literal, 1, 0, 0),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_symbol_literal, 2, 0, 0),
  [2820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_symbol_literal, 2, 0, 0),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 4, 0, 0),
  [2824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 4, 0, 0),
  [2826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_selector, 1, 0, 0), REDUCE(sym__assignable_selector_part, 2, 0, 0),
  [2829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_selector, 1, 0, 0), REDUCE(sym__assignable_selector_part, 2, 0, 0),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 0),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 0),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_test, 2, 0, 0),
  [2838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_test, 2, 0, 0),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast, 2, 0, 0),
  [2842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast, 2, 0, 0),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 1, 0, 0),
  [2846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_repeat1, 1, 0, 0),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 6, 0, 0),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 6, 0, 0),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 6, 0, 0),
  [2854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 6, 0, 0),
  [2856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignable_expression, 2, 0, 0), REDUCE(sym__primary, 2, 0, 0),
  [2859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_assignable_expression, 2, 0, 0), REDUCE(sym__primary, 2, 0, 0),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression_body, 2, 0, 0),
  [2864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression_body, 2, 0, 0),
  [2866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__assignable_selector_part, 1, 0, 0), REDUCE(sym_selector, 1, 0, 0),
  [2869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__assignable_selector_part, 1, 0, 0), REDUCE(sym_selector, 1, 0, 0),
  [2872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_literal, 1, 0, 0),
  [2874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_literal, 1, 0, 0),
  [2876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 5, 0, 0),
  [2878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 5, 0, 0),
  [2880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 0),
  [2882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 0),
  [2884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1701),
  [2887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1061),
  [2890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1701),
  [2893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1061),
  [2896] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1701),
  [2900] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1061),
  [2904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 6, 0, 73),
  [2906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 6, 0, 73),
  [2908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression_without_cascade, 2, 0, 0),
  [2910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression_without_cascade, 2, 0, 0),
  [2912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 7, 0, 0),
  [2914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 7, 0, 0),
  [2916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cascade_section, 5, 0, 0),
  [2918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cascade_section, 5, 0, 0),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_assignment, 3, 0, 0),
  [2922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_assignment, 3, 0, 0),
  [2924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_operator, 1, 0, 0),
  [2926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_operator, 1, 0, 0),
  [2928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression_body, 3, 0, 0),
  [2930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression_body, 3, 0, 0),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super, 1, 0, 0),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_super, 1, 0, 0),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_invocation, 5, 0, 0),
  [2938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_invocation, 5, 0, 0),
  [2940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_literal_no_const, 4, 0, 0),
  [2942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__record_literal_no_const, 4, 0, 0),
  [2944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 72),
  [2946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 72),
  [2948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression_without_cascade, 3, 0, 38),
  [2950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression_without_cascade, 3, 0, 38),
  [2952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 38),
  [2954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 38),
  [2956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_this, 1, 0, 0),
  [2958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_this, 1, 0, 0),
  [2960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__new_builtin, 1, 0, 0),
  [2962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__new_builtin, 1, 0, 0),
  [2964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_tearoff, 4, 0, 0),
  [2966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_tearoff, 4, 0, 0),
  [2968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_invocation, 4, 0, 0),
  [2970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_invocation, 4, 0, 0),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 2, 0, 0),
  [2974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 2, 0, 0),
  [2976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_test_expression, 2, 0, 0),
  [2978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_test_expression, 2, 0, 0),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 7, 0, 0),
  [2982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 7, 0, 0),
  [2984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 5, 0, 0),
  [2986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_literal, 5, 0, 0),
  [2988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_object_expression, 3, 0, 0),
  [2990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_object_expression, 3, 0, 0),
  [2992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 1, 0, 0),
  [2994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 1, 0, 0),
  [2996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(232),
  [2999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3215),
  [3002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3343),
  [3005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cascade_section_repeat2, 2, 0, 0), SHIFT_REPEAT(3344),
  [3008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 2, 0, 21),
  [3010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 2, 0, 21),
  [3012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exclamation_operator, 1, 0, 0),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exclamation_operator, 1, 0, 0),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [3018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [3022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [3024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_or_map_literal, 4, 0, 0),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_or_map_literal, 4, 0, 0),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression_body, 1, 0, 0),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression_body, 1, 0, 0),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_literal_no_const, 5, 0, 0),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__record_literal_no_const, 5, 0, 0),
  [3036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(1061),
  [3039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(2053),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_literal, 2, 0, 0),
  [3044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_literal, 2, 0, 0),
  [3046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__numeric_literal, 1, 0, 0),
  [3048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__numeric_literal, 1, 0, 0),
  [3050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_true, 1, 0, 0),
  [3052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_true, 1, 0, 0),
  [3054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_false, 1, 0, 0),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_false, 1, 0, 0),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null_literal, 1, 0, 0),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null_literal, 1, 0, 0),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 5, 0, 60),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 5, 0, 60),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cascade_assignment_section, 2, 0, 0),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cascade_assignment_section, 2, 0, 0),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 1, 0, 0),
  [3076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 1, 0, 0),
  [3078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_expression, 1, 0, 0),
  [3080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_expression, 1, 0, 0),
  [3082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_object_expression, 4, 0, 0),
  [3084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_object_expression, 4, 0, 0),
  [3086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rethrow_expression, 1, 0, 0),
  [3088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rethrow_expression, 1, 0, 0),
  [3090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 7, 0, 84),
  [3092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 7, 0, 84),
  [3094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [3096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [3098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4, 0, 0), SHIFT(1061),
  [3101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_name, 1, 0, 1), SHIFT(3326),
  [3104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 2, 0, 0), SHIFT(2501),
  [3107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), SHIFT(1061),
  [3110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1, 0, 0), SHIFT(1061),
  [3113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2501),
  [3116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(342),
  [3119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(364),
  [3122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37), SHIFT_REPEAT(333),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0),
  [3129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [3132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2271),
  [3135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2, 0, 0), SHIFT_REPEAT(2274),
  [3138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(314),
  [3141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [3143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 2, 0, 0), REDUCE(sym_map_pattern, 2, 0, 0),
  [3146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 2, 0, 0), REDUCE(sym_map_pattern, 2, 0, 0),
  [3149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__identifier_or_new, 1, 0, 0), REDUCE(sym_constructor_tearoff, 3, 0, 0),
  [3152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__identifier_or_new, 1, 0, 0), REDUCE(sym_constructor_tearoff, 3, 0, 0),
  [3155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 2, 0, 2),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 2, 0, 2),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [3165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 3, 0, 0), REDUCE(sym_map_pattern, 3, 0, 0),
  [3168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 3, 0, 0), REDUCE(sym_map_pattern, 3, 0, 0),
  [3171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_literal, 3, 0, 0), REDUCE(sym_list_pattern, 3, 0, 0),
  [3174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_list_literal, 3, 0, 0), REDUCE(sym_list_pattern, 3, 0, 0),
  [3177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_literal, 2, 0, 0), REDUCE(sym_list_pattern, 2, 0, 0),
  [3180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_list_literal, 2, 0, 0), REDUCE(sym_list_pattern, 2, 0, 0),
  [3183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 4, 0, 0), REDUCE(sym_constant_pattern, 4, 0, 0),
  [3186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 4, 0, 0), REDUCE(sym_constant_pattern, 4, 0, 0),
  [3189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_literal, 4, 0, 0), REDUCE(sym_constant_pattern, 4, 0, 0),
  [3192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_list_literal, 4, 0, 0), REDUCE(sym_constant_pattern, 4, 0, 0),
  [3195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__literal, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [3198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__literal, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [3201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary, 1, 0, 0), SHIFT(3534),
  [3204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 6, 0, 0), REDUCE(sym_constant_pattern, 6, 0, 0),
  [3207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 6, 0, 0), REDUCE(sym_constant_pattern, 6, 0, 0),
  [3210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_literal, 6, 0, 0), REDUCE(sym_constant_pattern, 6, 0, 0),
  [3213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_list_literal, 6, 0, 0), REDUCE(sym_constant_pattern, 6, 0, 0),
  [3216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_literal, 5, 0, 0), REDUCE(sym_constant_pattern, 5, 0, 0),
  [3219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_list_literal, 5, 0, 0), REDUCE(sym_constant_pattern, 5, 0, 0),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [3224] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1367),
  [3228] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2283),
  [3232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1367),
  [3235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2283),
  [3238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 5, 0, 0), REDUCE(sym_constant_pattern, 5, 0, 0),
  [3241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 5, 0, 0), REDUCE(sym_constant_pattern, 5, 0, 0),
  [3244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_literal, 7, 0, 0), REDUCE(sym_constant_pattern, 7, 0, 0),
  [3247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_list_literal, 7, 0, 0), REDUCE(sym_constant_pattern, 7, 0, 0),
  [3250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_set_or_map_literal, 7, 0, 0), REDUCE(sym_constant_pattern, 7, 0, 0),
  [3253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_set_or_map_literal, 7, 0, 0), REDUCE(sym_constant_pattern, 7, 0, 0),
  [3256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1367),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__metadata, 1, 0, 0),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__metadata, 1, 0, 0),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 11),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 11),
  [3269] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1367),
  [3273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0), SHIFT_REPEAT(1360),
  [3276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__metadata_repeat1, 2, 0, 0),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__metadata_repeat1, 2, 0, 0),
  [3280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__metadata_repeat1, 2, 0, 0), SHIFT_REPEAT(3007),
  [3283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1367),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [3294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(1367),
  [3297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(2042),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment_operator, 1, 0, 0),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_operator, 1, 0, 0),
  [3304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_operator, 1, 0, 0),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_operator, 1, 0, 0),
  [3308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_prefix_operator, 1, 0, 0), SHIFT(2134),
  [3311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_prefix_operator, 1, 0, 0), SHIFT(2134),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [3318] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1490),
  [3322] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2269),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [3330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1490),
  [3333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2269),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [3362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), SHIFT(1367),
  [3365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1490),
  [3368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1490),
  [3371] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1490),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [3377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1, 0, 0), SHIFT(1367),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [3382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__metadata_repeat1, 1, 0, 0),
  [3384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__metadata_repeat1, 1, 0, 0),
  [3386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0), SHIFT_REPEAT(1489),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [3391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4, 0, 0), SHIFT(1367),
  [3394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 4, 0, 2),
  [3396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 4, 0, 2),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [3402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, 0, 2),
  [3404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, 0, 2),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [3410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [3412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_and_operator, 1, 0, 0),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_and_operator, 1, 0, 0),
  [3416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shift_operator, 1, 0, 0),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shift_operator, 1, 0, 0),
  [3420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_or_operator, 1, 0, 0),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_or_operator, 1, 0, 0),
  [3424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_additive_operator, 1, 0, 0),
  [3426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_additive_operator, 1, 0, 0),
  [3428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__shift_operator, 1, 0, 0),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__shift_operator, 1, 0, 0),
  [3432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37), SHIFT_REPEAT(311),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tilde_operator, 1, 0, 0),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tilde_operator, 1, 0, 0),
  [3439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(315),
  [3442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiplicative_operator, 1, 0, 0),
  [3444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiplicative_operator, 1, 0, 0),
  [3446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multiplicative_operator, 1, 0, 0),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_multiplicative_operator, 1, 0, 0),
  [3450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0),
  [3457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(3007),
  [3460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 2, 0, 0), SHIFT_REPEAT(1885),
  [3463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(318),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [3468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1588),
  [3471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2277),
  [3474] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1588),
  [3478] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(2277),
  [3482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_builtin, 1, 0, 0),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_builtin, 1, 0, 0),
  [3486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [3488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(1490),
  [3491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(2044),
  [3494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negation_operator, 1, 0, 0),
  [3496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negation_operator, 1, 0, 0),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [3500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4, 0, 0), SHIFT(1490),
  [3503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0), SHIFT_REPEAT(1556),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [3508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1566),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [3513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1588),
  [3516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1588),
  [3519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2227),
  [3522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2226),
  [3525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2160),
  [3528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2170),
  [3531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2306),
  [3534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2304),
  [3537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2214),
  [3540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2213),
  [3543] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1588),
  [3547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__metadata_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [3550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat3, 2, 0, 0),
  [3552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat3, 2, 0, 0),
  [3554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat3, 2, 0, 0), SHIFT_REPEAT(3045),
  [3557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat3, 2, 0, 0), SHIFT_REPEAT(1809),
  [3560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1, 0, 0), SHIFT(1490),
  [3563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), SHIFT(1490),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [3574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(1588),
  [3577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), SHIFT(2048),
  [3580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37), SHIFT_REPEAT(325),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_tag, 3, 0, 0),
  [3585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_tag, 3, 0, 0),
  [3587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(312),
  [3590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(326),
  [3593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(357),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2731),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 6, 0, 0),
  [3614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 6, 0, 0),
  [3616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1566),
  [3619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_name, 3, 0, 0),
  [3621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_name, 3, 0, 0),
  [3623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1566),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 3, 0, 0),
  [3628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 3, 0, 0),
  [3630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_tails, 2, 0, 0), SHIFT_REPEAT(1625),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 5, 0, 0),
  [3635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 5, 0, 0),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_export, 4, 0, 0),
  [3639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_export, 4, 0, 0),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [3643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1, 0, 0),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_import, 2, 0, 0),
  [3647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_import, 2, 0, 0),
  [3649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_or_export, 1, 0, 0),
  [3651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_or_export, 1, 0, 0),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_name, 4, 0, 0),
  [3655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_name, 4, 0, 0),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_import, 1, 0, 0),
  [3659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_import, 1, 0, 0),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 4, 0, 0),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 4, 0, 0),
  [3665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void, 1, 0, 0), SHIFT(1588),
  [3668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 1, 0, 0), SHIFT(168),
  [3671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__cascade_subsection, 2, 0, 0), SHIFT(168),
  [3674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_specification, 7, 0, 0),
  [3676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_specification, 7, 0, 0),
  [3678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_type_tail, 4, 0, 0), SHIFT(1588),
  [3681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), SHIFT(1588),
  [3684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_export, 3, 0, 0),
  [3686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_export, 3, 0, 0),
  [3688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_export, 5, 0, 0),
  [3690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_export, 5, 0, 0),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [3694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37), SHIFT_REPEAT(340),
  [3697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 4, 0, 0), SHIFT(1566),
  [3700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(348),
  [3703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(347),
  [3706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(346),
  [3709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_and_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(359),
  [3712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bitwise_xor_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(360),
  [3715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bitwise_or_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(358),
  [3718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__if_null_expression, 2, 0, 37), SHIFT_REPEAT(338),
  [3721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external_and_static, 1, 0, 0), SHIFT(2247),
  [3724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__external_and_static, 1, 0, 0), SHIFT(1833),
  [3727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external_and_static, 1, 0, 0), SHIFT(1896),
  [3730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external_and_static, 1, 0, 0), SHIFT(1625),
  [3733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external_and_static, 1, 0, 0),
  [3735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat2, 1, 0, 0),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat2, 1, 0, 0),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [3747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_directive, 4, 0, 0),
  [3749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_directive, 4, 0, 0),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_directive, 3, 0, 0),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_directive, 3, 0, 0),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [3789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2196),
  [3792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2198),
  [3795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2178),
  [3798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2181),
  [3801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2294),
  [3804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2301),
  [3807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2211),
  [3810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(2215),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_of_directive, 3, 0, 0),
  [3815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_of_directive, 3, 0, 0),
  [3817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part_of_directive, 4, 0, 0),
  [3819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part_of_directive, 4, 0, 0),
  [3821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat3, 1, 0, 0),
  [3823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat3, 1, 0, 0),
  [3825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__native, 1, 0, 0),
  [3827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__native, 1, 0, 0),
  [3829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), SHIFT(1614),
  [3832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 33),
  [3834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 33),
  [3836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 4, 0, 13),
  [3838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 4, 0, 13),
  [3840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_body, 3, 0, 0),
  [3842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_body, 3, 0, 0),
  [3844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 8, 0, 0),
  [3846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 8, 0, 0),
  [3848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 4, 0, 0),
  [3850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 4, 0, 0),
  [3852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 6, 0, 45),
  [3854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 6, 0, 45),
  [3856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, 0, 57),
  [3858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, 0, 57),
  [3860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 44),
  [3862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, 0, 44),
  [3864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 43),
  [3866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, 0, 43),
  [3868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application_class, 5, 0, 0),
  [3870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_application_class, 5, 0, 0),
  [3872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, 0, 15),
  [3874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, 0, 15),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 7, 0, 58),
  [3878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 7, 0, 58),
  [3880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 7, 0, 59),
  [3882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 7, 0, 59),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, 0, 16),
  [3886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, 0, 16),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 7, 0, 0),
  [3890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 7, 0, 0),
  [3892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 6, 0, 46),
  [3894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 6, 0, 46),
  [3896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application_class, 4, 0, 0),
  [3898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_application_class, 4, 0, 0),
  [3900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 7, 0, 0),
  [3902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 7, 0, 0),
  [3904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 26),
  [3906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 26),
  [3908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 27),
  [3910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 27),
  [3912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 28),
  [3914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 28),
  [3916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 47),
  [3918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, 0, 47),
  [3920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 5),
  [3922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 5),
  [3924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 6, 0, 41),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 6, 0, 41),
  [3928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 29),
  [3930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 29),
  [3932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 2, 0, 0),
  [3934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 2, 0, 0),
  [3936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 5, 0, 30),
  [3938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 5, 0, 30),
  [3940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, 0, 17),
  [3942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, 0, 17),
  [3944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 48),
  [3946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, 0, 48),
  [3948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 18),
  [3950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 18),
  [3952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, 0, 49),
  [3954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, 0, 49),
  [3956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1, 0, 0), SHIFT(1614),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 5, 0, 0),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 5, 0, 0),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 6, 0, 0),
  [3965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 6, 0, 0),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 6, 0, 0),
  [3969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 6, 0, 0),
  [3971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, 0, 18),
  [3973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, 0, 18),
  [3975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 4, 0, 0),
  [3977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 4, 0, 0),
  [3979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 31),
  [3981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 31),
  [3983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 6, 0, 0),
  [3985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 6, 0, 0),
  [3987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 4, 0, 0),
  [3989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 4, 0, 0),
  [3991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 1, 0, 0),
  [3993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 1, 0, 0),
  [3995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 3, 0, 0),
  [3997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 3, 0, 0),
  [3999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_definition, 3, 0, 0),
  [4001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_definition, 3, 0, 0),
  [4003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, 0, 32),
  [4005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, 0, 32),
  [4007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat4, 1, 0, 0),
  [4009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat4, 1, 0, 0),
  [4011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 12),
  [4013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 12),
  [4015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 5, 0, 24),
  [4017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 5, 0, 24),
  [4019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 2, 0, 0),
  [4021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 2, 0, 0),
  [4023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_declaration, 5, 0, 23),
  [4025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_declaration, 5, 0, 23),
  [4027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 6, 0, 0),
  [4029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 6, 0, 0),
  [4031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 0),
  [4033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 0),
  [4035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 5, 0, 0),
  [4037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 5, 0, 0),
  [4039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_body, 2, 0, 0),
  [4041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_body, 2, 0, 0),
  [4043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [4045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 0),
  [4047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 3, 0, 5),
  [4049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 3, 0, 5),
  [4051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 7, 0, 0),
  [4053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 7, 0, 0),
  [4055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 22),
  [4057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 22),
  [4059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 9, 0, 0),
  [4061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 9, 0, 0),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 40),
  [4065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, 0, 40),
  [4067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3, 0, 0),
  [4069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3, 0, 0),
  [4071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [4073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 0),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 3, 0, 0),
  [4077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 3, 0, 0),
  [4079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2, 0, 0),
  [4081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2, 0, 0),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 5, 0, 0),
  [4085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 5, 0, 0),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [4089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, 0, 0),
  [4091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, 0, 0),
  [4093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1, 0, 0), SHIFT(1614),
  [4096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__external, 1, 0, 0), SHIFT(1833),
  [4099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1, 0, 0), SHIFT(1896),
  [4102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external, 1, 0, 0),
  [4104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1, 0, 0), SHIFT(1625),
  [4107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1, 0, 0), SHIFT(2834),
  [4110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__external, 1, 0, 0), SHIFT(2149),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [4119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_function, 1, 0, 0),
  [4121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1, 0, 0), SHIFT(2167),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [4126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [4130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1, 0, 0),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [4134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [4142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [4158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [4258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [4276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_name, 1, 0, 1), SHIFT(2297),
  [4283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_not_function, 2, 0, 0),
  [4285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__operator, 1, 0, 0),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__operator, 1, 0, 0),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [4313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 2, 0, 0),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 2, 0, 0),
  [4317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__type_name, 1, 0, 1),
  [4322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_name, 1, 0, 1), SHIFT(3499),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [4343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [4353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 2, 0, 0),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [4367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(221),
  [4370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(165),
  [4373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3196),
  [4376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2010),
  [4379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1217),
  [4382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3378),
  [4385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__assignable_selector_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3379),
  [4388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 3, 0, 0),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat2, 3, 0, 0),
  [4392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 3, 0, 0),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extension_body_repeat1, 3, 0, 0),
  [4396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_body_repeat2, 2, 0, 0),
  [4398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extension_body_repeat1, 2, 0, 0),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [4404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0),
  [4406] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 1, 0, 0), REDUCE(sym__final_var_or_type, 1, 0, 0), SHIFT(1614),
  [4410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 2, 0, 0), SHIFT(1614),
  [4413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 2, 0, 0),
  [4415] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), REDUCE(sym__final_var_or_type, 1, 0, 0), SHIFT(1614),
  [4419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_name, 1, 0, 1), REDUCE(sym__simple_formal_parameter, 1, 0, 0),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 5, 0, 0),
  [4428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 5, 0, 0),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter_part, 2, 0, 0),
  [4432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__formal_parameter_part, 2, 0, 0),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [4436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 2, 0, 0),
  [4438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 2, 0, 0),
  [4440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_pattern, 5, 0, 0),
  [4442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_pattern, 5, 0, 0),
  [4444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, 0, 0),
  [4446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 4, 0, 0),
  [4448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [4450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [4452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter_list, 1, 0, 0),
  [4454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formal_parameter_list, 1, 0, 0),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 5, 0, 0),
  [4458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 5, 0, 0),
  [4460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_or_new, 1, 0, 0),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [4464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter_part, 1, 0, 0),
  [4466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__formal_parameter_part, 1, 0, 0),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [4470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parenthesized_pattern, 3, 0, 0),
  [4472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parenthesized_pattern, 3, 0, 0),
  [4474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 4, 0, 0),
  [4476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 4, 0, 0),
  [4478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [4480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 3, 0, 0),
  [4482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 3, 0, 0),
  [4484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_pattern, 2, 0, 0),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strict_formal_parameter_list, 3, 0, 0),
  [4490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strict_formal_parameter_list, 3, 0, 0),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 7, 0, 0),
  [4496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 7, 0, 0),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [4506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 5, 0, 0),
  [4508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 5, 0, 0),
  [4510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_pattern, 3, 0, 0),
  [4512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_pattern, 4, 0, 0),
  [4514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_pattern, 4, 0, 0),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_pattern, 4, 0, 0),
  [4520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_pattern, 4, 0, 0),
  [4522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [4524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [4526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 6, 0, 0),
  [4528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 6, 0, 0),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_pattern, 6, 0, 0),
  [4534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_pattern, 6, 0, 0),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 6, 0, 0),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 6, 0, 0),
  [4540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [4552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [4570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_var_or_type, 1, 0, 0), SHIFT(1614),
  [4573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2450),
  [4576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_pattern, 1, 0, 0),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [4588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 5, 0, 0),
  [4590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified, 5, 0, 0),
  [4592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified, 3, 0, 0),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [4596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_formal_parameter, 4, 0, 0),
  [4598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__required, 1, 0, 0),
  [4600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__required, 1, 0, 0),
  [4602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 4, 0, 0),
  [4604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_param, 4, 0, 0),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [4612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 6, 0, 0),
  [4614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_pattern, 2, 0, 0),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [4618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 2, 0, 0),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_pattern, 1, 0, 0),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 7, 0, 0),
  [4630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_formal_parameter, 3, 0, 0),
  [4632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_param, 3, 0, 0),
  [4634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_and_pattern, 2, 0, 0),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [4638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, 0, 0),
  [4640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 4, 0, 0),
  [4642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 6, 0, 0),
  [4644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer, 6, 0, 0),
  [4646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2486),
  [4649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1717),
  [4652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2479),
  [4655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__logical_and_pattern_repeat1, 2, 0, 0),
  [4657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__logical_and_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1444),
  [4660] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 1, 0, 0), REDUCE(sym__function_type_tail, 1, 0, 0), SHIFT(1717),
  [4664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_and_pattern, 1, 0, 0),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__static, 1, 0, 0),
  [4670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__static, 1, 0, 0),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [4682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2495),
  [4685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2495),
  [4688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2, 0, 0),
  [4690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2988),
  [4693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2453),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_or_pattern, 1, 0, 0),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [4700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__logical_or_pattern_repeat1, 2, 0, 0),
  [4714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__logical_or_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1404),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__outer_pattern, 1, 0, 0),
  [4723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external_builtin, 1, 0, 0),
  [4725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__external_builtin, 1, 0, 0),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_or_pattern, 2, 0, 0),
  [4733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 1), REDUCE(sym__type_name, 1, 0, 1),
  [4736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_name, 1, 0, 1), SHIFT(1566),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [4755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2449),
  [4758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2449),
  [4761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2, 0, 0),
  [4763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2864),
  [4766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2467),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [4787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 1, 0, 0),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [4791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [4793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_signature, 1, 0, 0),
  [4795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_list, 1, 0, 0),
  [4801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inferred_type, 1, 0, 0),
  [4803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_type, 1, 0, 0),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [4821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3464),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2, 0, 0),
  [4826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2, 0, 0),
  [4828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1434),
  [4831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [4843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null_assert_pattern, 2, 0, 0),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [4847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null_check_pattern, 2, 0, 0),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 1, 0, 3),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [4853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2398),
  [4856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2398),
  [4859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2, 0, 0),
  [4861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2323),
  [4864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2402),
  [4867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2402),
  [4870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2, 0, 0),
  [4872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 2, 0, 0), SHIFT_REPEAT(2307),
  [4875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2584),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2, 0, 0),
  [4880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2814),
  [4883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2558),
  [4886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, 0, 2),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [4890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2, 0, 0),
  [4892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2583),
  [4895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2876),
  [4898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2585),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [4903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [4909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [4929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 3, 0, 0), SHIFT(1717),
  [4932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_pattern, 3, 0, 0),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [4936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1717),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [4945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier, 1, 0, 0),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__relational_pattern, 1, 0, 0),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_configurable_uri, 1, 0, 0),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [5015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_final_builtin, 1, 0, 0),
  [5017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_final_builtin, 1, 0, 0),
  [5019] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type_not_void_not_function, 2, 0, 0), REDUCE(sym__function_type_tail, 2, 0, 0), SHIFT(1717),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [5031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializers, 3, 0, 0),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [5035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializers, 3, 0, 0),
  [5037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_signature, 4, 0, 0),
  [5039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_signature, 4, 0, 0),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [5045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_configuration_uri_condition, 3, 0, 0),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_configuration_uri_condition, 3, 0, 0),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__covariant, 1, 0, 0),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__covariant, 1, 0, 0),
  [5053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__export, 1, 0, 0),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__export, 1, 0, 0),
  [5057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import, 1, 0, 0),
  [5059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import, 1, 0, 0),
  [5061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 2, 0, 0),
  [5063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 2, 0, 3),
  [5065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 2, 0, 3),
  [5067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declared_identifier, 2, 0, 2),
  [5069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_field, 2, 0, 0),
  [5071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2439),
  [5074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 2, 0, 0),
  [5076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2425),
  [5079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 2, 0, 0),
  [5081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2448),
  [5084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 2, 0, 0), SHIFT_REPEAT(2434),
  [5087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declared_identifier, 2, 0, 2), REDUCE(sym__declared_identifier, 3, 0, 9),
  [5090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declared_identifier, 3, 0, 9),
  [5092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_field, 3, 0, 0),
  [5094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_signature, 3, 0, 0),
  [5096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_signature, 3, 0, 0),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 3, 0, 0),
  [5106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, 0, 2),
  [5108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, 0, 2),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [5112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializers_repeat1, 2, 0, 0),
  [5114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializers_repeat1, 2, 0, 0), SHIFT_REPEAT(2188),
  [5117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_initializers_repeat1, 2, 0, 0),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [5127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__formal_parameter_part, 1, 0, 0), REDUCE(sym_constructor_signature, 2, 0, 25),
  [5130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_signature, 2, 0, 25),
  [5132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__formal_parameter_part, 1, 0, 0), REDUCE(sym_constructor_signature, 2, 0, 25),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [5137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_identifier, 2, 0, 0),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [5143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 3, 0, 9),
  [5145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 3, 0, 9),
  [5147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializers, 2, 0, 0),
  [5149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializers, 2, 0, 0),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, 0, 10),
  [5155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, 0, 10),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [5159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 1, 0, 0),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [5163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_multiple_repeat1, 1, 0, 0),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [5169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [5171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 4, 0, 0),
  [5173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 2, 0, 4),
  [5175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 2, 0, 4),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [5197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declared_identifier, 3, 0, 9), REDUCE(sym__declared_identifier, 4, 0, 42),
  [5200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declared_identifier, 4, 0, 42),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [5204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 1, 0, 0),
  [5206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [5208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_multiple_repeat1, 1, 0, 0),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [5212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 3, 0, 2),
  [5214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 3, 0, 2),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [5222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 2, 0, 2),
  [5224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 2, 0, 2),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [5228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 4, 0, 9),
  [5230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 4, 0, 9),
  [5232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion_arguments, 3, 0, 0),
  [5234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion_arguments, 3, 0, 0),
  [5236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_configurable_uri, 2, 0, 0),
  [5238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_signature, 4, 0, 56),
  [5240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_signature, 4, 0, 56),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [5262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion_arguments, 6, 0, 0),
  [5264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion_arguments, 6, 0, 0),
  [5266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list_entry, 2, 0, 0),
  [5268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list_entry, 2, 0, 0),
  [5270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_factory_constructor_signature, 4, 0, 0),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [5274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_factory_constructor_signature, 4, 0, 0),
  [5276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list_entry, 1, 0, 0),
  [5278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list_entry, 1, 0, 0),
  [5280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [5286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [5290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list_entry, 4, 0, 0),
  [5292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list_entry, 4, 0, 0),
  [5294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_configurable_uri_repeat1, 2, 0, 0),
  [5296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_configurable_uri_repeat1, 2, 0, 0), SHIFT_REPEAT(3128),
  [5299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sub_string_test, 2, 0, 0),
  [5301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sub_string_test, 2, 0, 0),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [5305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0),
  [5307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion_arguments, 5, 0, 0),
  [5309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion_arguments, 5, 0, 0),
  [5311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [5315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion_arguments, 4, 0, 0),
  [5317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion_arguments, 4, 0, 0),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [5323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_factory_constructor_signature, 3, 0, 0),
  [5325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [5327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_factory_constructor_signature, 3, 0, 0),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [5335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 1, 0, 0),
  [5337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [5339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_single_quotes_repeat1, 1, 0, 0),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [5343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [5347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion, 2, 0, 0),
  [5349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion, 2, 0, 0),
  [5351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 1, 0, 0),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_double_quotes_repeat1, 1, 0, 0),
  [5357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), SHIFT(2442),
  [5360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 4, 0, 0),
  [5362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_substitution, 4, 0, 0),
  [5364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 1),
  [5366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_signature, 5, 0, 0),
  [5368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_signature, 5, 0, 0),
  [5370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 1, 0, 0),
  [5372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_single_quotes_multiple_repeat1, 1, 0, 0),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [5380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_escape_sequence, 1, 0, 0),
  [5382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape_sequence, 1, 0, 0),
  [5384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_operator, 1, 0, 0),
  [5386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_operator, 1, 0, 0),
  [5388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 0),
  [5390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uri, 1, 0, 0),
  [5392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__native, 2, 0, 0),
  [5394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__native, 2, 0, 0),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 4, 0, 2),
  [5398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 4, 0, 2),
  [5400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, 0, 3),
  [5402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, 0, 3),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 1, 0, 6),
  [5406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 1, 0, 0),
  [5408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 1, 0, 6),
  [5410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_formal_parameter, 1, 0, 6),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 2, 0, 14),
  [5418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 2, 0, 0),
  [5420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__late_builtin, 1, 0, 0),
  [5422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__late_builtin, 1, 0, 0),
  [5424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract, 1, 0, 0),
  [5426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 3, 0, 4),
  [5428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 3, 0, 4),
  [5430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 3, 0, 2),
  [5432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 3, 0, 2),
  [5434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 1, 0, 0),
  [5436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_multiple_repeat1, 1, 0, 0),
  [5438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_substitution, 2, 0, 0),
  [5440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 2, 0, 0),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [5446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__element, 1, 0, 0),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [5450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_factory_constructor_signature_repeat1, 2, 0, 0),
  [5452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_factory_constructor_signature_repeat1, 2, 0, 0), SHIFT_REPEAT(3412),
  [5455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_setter_signature, 5, 0, 9),
  [5457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_setter_signature, 5, 0, 9),
  [5459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 0),
  [5461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 7),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [5467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__external_and_static, 2, 0, 0),
  [5469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__external_and_static, 2, 0, 0),
  [5471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, 0, 10),
  [5473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, 0, 10),
  [5475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_getter_signature, 4, 0, 9),
  [5477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_getter_signature, 4, 0, 9),
  [5479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, 0, 0),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 2, 0, 0),
  [5483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_signature, 2, 0, 0),
  [5485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_formal_parameter, 5, 0, 0),
  [5487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_formal_parameter, 5, 0, 0),
  [5489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_param, 5, 0, 0),
  [5491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, 0, 2),
  [5493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, 0, 2),
  [5495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_statement_case_repeat1, 2, 0, 0), SHIFT_REPEAT(3464),
  [5498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_statement_case_repeat1, 2, 0, 0),
  [5500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_list, 2, 0, 0),
  [5502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_list, 1, 0, 0),
  [5504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_library_export_repeat1, 2, 0, 0),
  [5506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_library_export_repeat1, 2, 0, 0), SHIFT_REPEAT(3125),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [5511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 65),
  [5513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_configuration_uri, 3, 0, 0),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [5517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [5519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_not_void_list_repeat1, 2, 0, 0),
  [5521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_not_void_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2061),
  [5524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_configurable_uri_repeat1, 1, 0, 0),
  [5526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [5530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [5532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 2, 0, 55),
  [5534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [5536] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), REDUCE(sym__final_var_or_type, 1, 0, 0), SHIFT(2279),
  [5540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_field, 1, 0, 0),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_list, 1, 0, 0),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [5546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_not_void_list, 2, 0, 0),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [5550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_identifier_list, 2, 0, 0),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [5556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 1, 0, 6),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [5564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(3567),
  [5567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2, 0, 0),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [5573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_identifier_list, 1, 0, 0),
  [5575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), SHIFT(2284),
  [5578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_double_quotes_repeat1, 1, 0, 0),
  [5580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__string_literal_single_quotes_repeat1, 1, 0, 0),
  [5582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_element, 7, 0, 85),
  [5584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_element, 7, 0, 86),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [5590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2, 0, 0),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 3, 0, 0),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_element, 9, 0, 96),
  [5598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_element, 3, 0, 35),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2, 0, 0),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 2, 0, 0),
  [5608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(159),
  [5611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 50),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [5617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application, 2, 0, 0),
  [5619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_element, 4, 0, 51),
  [5621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__final_or_const, 1, 0, 0),
  [5623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__final_or_const, 1, 0, 0),
  [5625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [5627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [5629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [5631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [5635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__implements, 1, 0, 0),
  [5637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__implements, 1, 0, 0),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [5641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 1, 0, 6), REDUCE(sym__normal_formal_parameter, 2, 0, 14),
  [5644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__normal_formal_parameter, 1, 0, 0), REDUCE(sym__normal_formal_parameter, 2, 0, 0),
  [5647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 2, 0, 0),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [5651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__typedef, 1, 0, 0),
  [5653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typedef, 1, 0, 0),
  [5655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_type_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1898),
  [5658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_type_list_repeat1, 2, 0, 0),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 0),
  [5668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 7),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [5676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_parameter_type, 1, 0, 0),
  [5678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_operator, 2, 0, 0),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_operator, 2, 0, 0),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [5686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_element, 5, 0, 62),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [5690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [5692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 1),
  [5694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_parameter_type, 2, 0, 0),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [5700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 1, 0, 0),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [5704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [5706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(2527),
  [5709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_operator, 1, 0, 0),
  [5711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_operator, 1, 0, 0),
  [5713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 3, 0, 0),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [5719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_block_repeat1, 1, 0, 0),
  [5721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 1, 0, 0),
  [5723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__guarded_pattern, 1, 0, 0),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 2, 0, 6),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [5739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 70),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [5743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 71),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [5749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(405),
  [5752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_pattern_repeat1, 2, 0, 0),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [5758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier_list, 2, 0, 0),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 68),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [5768] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), REDUCE(sym__final_var_or_type, 1, 0, 0), SHIFT(2472),
  [5772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_statement_case_repeat1, 1, 0, 0),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [5778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_literal_no_const_repeat1, 2, 0, 0), SHIFT_REPEAT(186),
  [5781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_literal_no_const_repeat1, 2, 0, 0),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [5785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 5, 0, 3),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [5793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [5803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 5, 0, 2),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [5811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initialized_identifier_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3233),
  [5814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initialized_identifier_list_repeat1, 2, 0, 0),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [5824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat1, 2, 0, 66), SHIFT_REPEAT(218),
  [5827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat1, 2, 0, 66),
  [5829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_combinator, 2, 0, 0),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_list, 2, 0, 0),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [5857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [5861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [5863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [5865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_library_export_repeat1, 1, 0, 0),
  [5869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_type_repeat2, 2, 0, 0),
  [5871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_type_repeat2, 2, 0, 0), SHIFT_REPEAT(1901),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [5886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, 0, 3),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [5890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [5900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 1, 0, 0), SHIFT(931),
  [5903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 1, 0, 0),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [5907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(394),
  [5910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [5916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), SHIFT(2472),
  [5919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [5921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0),
  [5923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(406),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [5930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__guarded_pattern, 3, 0, 0),
  [5932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(2266),
  [5935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, 0, 0),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [5939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 75),
  [5943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 76),
  [5945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [5947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_final_declaration_list, 2, 0, 0),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [5957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 79),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [5963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [5965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 80),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [5975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 81),
  [5977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [5979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__set, 1, 0, 0),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [5985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__normal_formal_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(931),
  [5988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__normal_formal_parameters_repeat1, 2, 0, 0),
  [5990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 3, 0, 0),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [6000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat2, 2, 0, 82), SHIFT_REPEAT(225),
  [6003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat2, 2, 0, 82),
  [6005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [6007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [6009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 83),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [6035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_pattern_repeat1, 2, 0, 0),
  [6037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(185),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [6050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [6052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [6062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 6, 0, 2),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [6094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__get, 1, 0, 0),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [6114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 4, 0, 39),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [6132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, 0, 88),
  [6134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, 0, 90),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [6138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, 0, 91),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [6152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, 0, 92),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [6156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__var_or_type, 1, 0, 0), SHIFT(2299),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [6169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_parameter_types_repeat1, 2, 0, 0),
  [6171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_parameter_types_repeat1, 2, 0, 0), SHIFT_REPEAT(1803),
  [6174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 6, 0, 93),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [6180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [6182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [6188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 6, 0, 94),
  [6190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 6, 0, 95),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [6206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 7, 0, 97),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [6224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__final_const_var_or_type, 2, 0, 0), REDUCE(sym__final_var_or_type, 2, 0, 0),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [6235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [6237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [6253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [6255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_final_declaration_list, 1, 0, 0),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [6261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1928),
  [6264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_type_repeat1, 2, 0, 0),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [6282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 1, 0, 0),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [6308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializers_repeat1, 2, 0, 0), SHIFT_REPEAT(2221),
  [6311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 5, 0, 87),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [6315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [6317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [6321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [6327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 2, 0, 0), SHIFT(931),
  [6330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__normal_formal_parameters, 2, 0, 0),
  [6332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [6335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_positional_parameters_repeat1, 2, 0, 0),
  [6337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__var_or_type, 2, 0, 0),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [6343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [6347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixins, 2, 0, 0),
  [6349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_static_final_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3261),
  [6352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_static_final_declaration_list_repeat1, 2, 0, 0),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [6356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_variable_definition, 3, 0, 39),
  [6358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__named_formal_parameters_repeat1, 2, 0, 0),
  [6360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__named_formal_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [6367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [6369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_formal_parameter, 1, 0, 0),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [6373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(172),
  [6376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat1, 2, 0, 0),
  [6378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__final_var_or_type, 1, 0, 0), SHIFT(3112),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [6385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [6387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [6389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [6391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(2075),
  [6394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2, 0, 0),
  [6396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [6398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier_list, 1, 0, 0),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [6406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [6412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 4, 0, 3),
  [6414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [6420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, 0, 2),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 1),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_field, 1, 0, 0),
  [6434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_parameter_type, 3, 0, 0),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [6440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uri_test, 1, 0, 0),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [6444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_parameter_type, 2, 0, 0),
  [6446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [6448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [6450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 4, 0, 0),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [6454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_final_declaration, 3, 0, 0),
  [6456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 7),
  [6458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 0),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [6462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_formal_parameter, 3, 0, 0),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [6468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__any_argument, 1, 0, 0),
  [6470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [6472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_constructor_signature, 3, 0, 0),
  [6474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 0),
  [6476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_record_field, 1, 0, 0), SHIFT(3480),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [6481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interfaces, 2, 0, 0),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [6485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_named_field, 2, 0, 0),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [6491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [6503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [6509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 2, 0, 0),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base, 1, 0, 0),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [6515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [6517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern_element, 1, 0, 0),
  [6519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_named_field, 1, 0, 0),
  [6521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin, 1, 0, 0),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [6527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_record_field, 1, 0, 0), SHIFT(3434),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [6532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern_field, 1, 0, 0), SHIFT(2022),
  [6535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [6571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 7, 0, 0),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [6577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_field, 2, 0, 0),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [6589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, 0, 0),
  [6591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_record_field, 1, 0, 0), SHIFT(3447),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [6602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_parameter_type, 1, 0, 0),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [6608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat1, 2, 0, 64),
  [6610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_record_field, 1, 0, 0), SHIFT(3341),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [6615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [6617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__map_pattern_entry, 3, 0, 0),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [6625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 6, 0, 0),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [6631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 3, 0, 0),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [6643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 1, 0, 0),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [6647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initialized_identifier, 3, 0, 0),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [6651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_named_parameter, 5, 0, 0),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [6655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_constructor_signature, 5, 0, 0),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [6659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__for_loop_parts_repeat2, 2, 0, 55),
  [6661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 1, 0, 0),
  [6663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [6667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 5, 0, 0),
  [6669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_argument, 2, 0, 0),
  [6671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_field, 3, 0, 0),
  [6673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [6677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 2, 0, 0),
  [6679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_case, 3, 0, 0),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [6691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [6713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 4, 0, 78),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [6721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mixin_class_modifiers, 4, 0, 0),
  [6723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [6727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optional_postional_formal_parameters, 3, 0, 0),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [6731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 0),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [6783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [6789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [6795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__bitwise_operator, 1, 0, 0),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [6801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 1, 0, 0),
  [6803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitwise_operator, 1, 0, 0),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [6807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [6815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_positional_parameter_types, 5, 0, 0),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [6827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_parameter_types, 5, 0, 0),
  [6829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uri_test, 3, 0, 0),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [6839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [6841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_parameters, 3, 0, 0),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [6853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [6855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [6857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [6863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [6869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [6871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [6873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [6875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [6877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [6887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [6891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [6931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_formal_parameters, 3, 0, 0),
  [6933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirection, 5, 0, 0),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [6937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__final_var_or_type, 2, 0, 0),
  [6939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_parameters, 5, 0, 0),
  [6941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_formal_parameters, 1, 0, 0),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [6947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_selector, 1, 0, 0),
  [6949] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [6953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_application, 3, 0, 0),
  [6955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 0),
  [6957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 8, 0, 0),
  [6959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 39),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [6965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_modifiers, 2, 0, 0),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [6975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_parameter_types, 4, 0, 0),
  [6977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_loop_parts, 3, 0, 63),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [6995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [7001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirecting_factory_constructor_signature, 9, 0, 0),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [7017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_types, 1, 0, 0),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sealed, 1, 0, 0),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [7029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface, 1, 0, 0),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [7033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__deferred, 1, 0, 0),
  [7035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dot_identifier, 2, 19, 0),
  [7037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__as, 1, 0, 0),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [7041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mixin_class_modifiers, 3, 0, 0),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [7045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_modifiers, 3, 0, 0),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [7067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [7085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mixin_class_modifiers, 2, 0, 0),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [7089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [7091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [7093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_variable_declaration, 4, 0, 0),
  [7095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 0),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [7107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_modifiers, 1, 0, 0),
  [7109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__factory, 1, 0, 0),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [7117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__var_or_type, 1, 0, 0), SHIFT(2513),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [7126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optional_postional_formal_parameters, 4, 0, 0),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [7134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [7136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 0),
  [7138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__final_var_or_type, 1, 0, 0),
  [7140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirection, 3, 0, 0),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [7144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [7148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [7152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_formal_parameters, 4, 0, 0),
  [7154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__optional_postional_formal_parameters, 5, 0, 0),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [7160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_formal_parameters, 5, 0, 0),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [7168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_positional_parameter_types, 3, 0, 0),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [7172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_parameter_types, 3, 0, 0),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [7180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_positional_parameter_types, 4, 0, 0),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [7184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_documentation_comment, 1, 0, 0),
  [7186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 3, 0, 0),
  [7188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 1, 0, 0),
  [7190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_documentation_comment, 2, 0, 0),
  [7192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__template_chars_double = 0,
  ts_external_token__template_chars_single = 1,
  ts_external_token__template_chars_double_single = 2,
  ts_external_token__template_chars_single_single = 3,
  ts_external_token__template_chars_raw_slash = 4,
  ts_external_token__block_comment = 5,
  ts_external_token__documentation_block_comment = 6,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__template_chars_double] = sym__template_chars_double,
  [ts_external_token__template_chars_single] = sym__template_chars_single,
  [ts_external_token__template_chars_double_single] = sym__template_chars_double_single,
  [ts_external_token__template_chars_single_single] = sym__template_chars_single_single,
  [ts_external_token__template_chars_raw_slash] = sym__template_chars_raw_slash,
  [ts_external_token__block_comment] = sym__block_comment,
  [ts_external_token__documentation_block_comment] = sym__documentation_block_comment,
};

static const bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__template_chars_double] = true,
    [ts_external_token__template_chars_single] = true,
    [ts_external_token__template_chars_double_single] = true,
    [ts_external_token__template_chars_single_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [2] = {
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [3] = {
    [ts_external_token__template_chars_single] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [4] = {
    [ts_external_token__template_chars_double] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [5] = {
    [ts_external_token__template_chars_double_single] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [6] = {
    [ts_external_token__template_chars_single_single] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [7] = {
    [ts_external_token__template_chars_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [8] = {
    [ts_external_token__template_chars_double] = true,
    [ts_external_token__template_chars_raw_slash] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [9] = {
    [ts_external_token__template_chars_double_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
  [10] = {
    [ts_external_token__template_chars_single_single] = true,
    [ts_external_token__template_chars_raw_slash] = true,
    [ts_external_token__block_comment] = true,
    [ts_external_token__documentation_block_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_dart_external_scanner_create(void);
void tree_sitter_dart_external_scanner_destroy(void *);
bool tree_sitter_dart_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_dart_external_scanner_serialize(void *, char *);
void tree_sitter_dart_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_dart(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_dart_external_scanner_create,
      tree_sitter_dart_external_scanner_destroy,
      tree_sitter_dart_external_scanner_scan,
      tree_sitter_dart_external_scanner_serialize,
      tree_sitter_dart_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
